       IDENTIFICATION DIVISION.
       PROGRAM-ID. DSV-P-BCT.
      *
      * DATA SERVICE: bolle clienti
      *
      **** rel 7.1
      * nuovo
      ************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gribctsl'.
           COPY 'grifatsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'gribct'.
           COPY 'grifat'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parcdt'.
      *
           COPY 'dsv-idbct.cpy' REPLACING ==(BCT)== BY ==IDBCT==.
           COPY 'dsv-idfat.cpy'.
           COPY 'dsv-odbcl'.
      *
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
      **** rel 7.2
      *01  ID-FAT PIC X(15) VALUE 'fattur'.
       01  ID-FAT.
           05 FILLER PIC X(6) VALUE 'fattur'.
           05 FATTIV PIC X    VALUE SPACE.
           05 FILLER PIC X(8) VALUE SPACE.
      ************
       01  COMODI.
           05 SF-BCT  PIC XX.
           05 SF-FAT  PIC XX.
           05 MESS    PIC X(40) VALUE SPACE.
           05 SWOPE   PIC 9     VALUE ZERO.
      *
       LINKAGE SECTION.
           COPY 'dsv-bct.cpy'.
       PROCEDURE DIVISION USING D-BCT-P-IN.
           COPY 'declxer1'.
           COPY 'dclbct'.
           COPY 'dclfat'.
           COPY 'declxer2'.
       INIZIO.
           IF D-BCT-FUN = 'C'
              PERFORM CL-FILE
              GO TO FINE.
      *
           COPY 'strsub'.
      *
           IF D-BCT-FUN = 'O'
              PERFORM OP-FILE
              GO TO FINE.

           INITIALIZE D-BCT-CAMPI.
           INITIALIZE D-BCT-IN-FLD.

           MOVE D-BCT-AZI TO KBC-AZI.
           MOVE D-BCT-BOL TO KBC-BOL.
           MOVE D-BCT-NUM TO KBC-NUM.
           READ BOLCTE INVALID GO TO FINE.
      *
      *    Lettura Bolla Cliente
      *
           MOVE KBC-AZI TO D-IDBCT-AZI.
           MOVE KBC-BOL TO D-IDBCT-BOL.
           MOVE KBC-NUM TO D-IDBCT-NUM.
      *
           MOVE BCT-DATA TO AAGGG.
           MOVE 2        TO TIPOP1.
           CALL 'rdata'  USING PARCDT.
           MOVE AA4      TO D-IDBCT-SERIE.
      *
           MOVE 'RD' TO D-IDBCT-FUN.  *> read
           PERFORM CALL-ODBC-BCT.
           MOVE D-IDBCT-IDFAT  TO D-BCT-IDFAT.
      *
           IF BCT-NUFAT = ZERO GO TO NO-FAT-ID.
      *
      **** rel 7.2
           MOVE BCT-CATT TO FATTIV.
           IF BCT-CATT = '0' MOVE SPACE TO FATTIV.
           OPEN INPUT FATTUR.
      ************
           MOVE ZERO      TO D-FAT-ID.
           MOVE D-BCT-AZI TO KFT-AZI.
           MOVE BCT-NUDOC TO KFT-TDOC.
           MOVE BCT-NUFAT TO KFT-NUM.
      **** rel 7.2
      *    READ FATTUR INVALID GO TO NO-FAT-ID.
           READ FATTUR INVALID CLOSE FATTUR GO TO NO-FAT-ID.
           CLOSE FATTUR.
      ************
      *
      **** rel 7.2
      *    IF FAT-CDCLI = BCT-CLI GO TO NO-FAT-ID.
           IF FAT-CDCLI NOT = BCT-CLI GO TO NO-FAT-ID.
      ************
      *
           MOVE FAT-DATA  TO AAGGG.
           MOVE 2         TO TIPOP1.
           CALL 'rdata'   USING PARCDT.
           MOVE KFT-AZI   TO D-FAT-AZI.
           MOVE AA4       TO D-FAT-SERIE.
      **** rel 7.2
           IF AA4 NOT = D-IDBCT-SERIE GO TO NO-FAT-ID.
      ************
           MOVE FAT-CATT  TO D-FAT-ATT
           MOVE KFT-TDOC  TO D-FAT-TDOC
           MOVE KFT-NUM   TO D-FAT-NUM
      *
           MOVE 'RD' TO D-FAT-FUN.  *> read
           PERFORM CALL-ODBC-FAT.
           IF D-FAT-ID > ZERO 
              MOVE D-FAT-ID   TO D-BCT-IDFAT.
      *
       NO-FAT-ID.
           MOVE BCT-DATA   TO AAGGG D-BCT-DATA.
           MOVE 2          TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4        TO D-BCT-SERIE.
      *
           MOVE 'C' TO D-BCT-CF.
           IF BCT-TDOC = 6 OR 7 MOVE 'F' TO D-BCT-CF.
      *
           MOVE BCT-CLI    TO D-BCT-CLI
           MOVE BCT-TDOC   TO D-BCT-TDOC
           MOVE BCT-FLGFT  TO D-BCT-FLGFT
           MOVE BCT-RAGGR  TO D-BCT-RAGGR
           MOVE BCT-CDEP   TO D-BCT-CDEP
           MOVE BCT-CSPE   TO D-BCT-CSPE
           MOVE BCT-CPOR   TO D-BCT-CPOR
           MOVE BCT-CPAG   TO D-BCT-CPAG
           MOVE BCT-SCBAS  TO D-BCT-SCBAS
           MOVE BCT-CBAN   TO D-BCT-CBAN
           MOVE BCT-ESIVA  TO D-BCT-ESIVA
           MOVE BCT-VALUT  TO D-BCT-VALUT
           MOVE BCT-CAMGG  TO D-BCT-CAMGG
           MOVE BCT-DTORD  TO D-BCT-DTORD
           MOVE BCT-DSORD  TO D-BCT-DSORD
           MOVE BCT-DSFAT  TO D-BCT-DSFAT
           MOVE BCT-ZONA   TO D-BCT-ZONA
           MOVE BCT-CAGE   TO D-BCT-CAGE
           MOVE BCT-PROVV  TO D-BCT-PROVV
           MOVE BCT-CAUS   TO D-BCT-CAUS
           MOVE BCT-CDEP2  TO D-BCT-CDEP2
           MOVE BCT-CAUC   TO D-BCT-CAUC
      **** rel 7.2
           MOVE BCT-CATT   TO D-BCT-CATT.
      ************
           MOVE BCT-FLGIS  TO D-BCT-FLGIS
           MOVE BCT-ACCON  TO D-BCT-ACCON
           MOVE BCT-FLACC  TO D-BCT-FLACC
      *
           MOVE BCT-TMODU  TO D-BCT-TMODU
           MOVE BCT-LISRF  TO D-BCT-LISRF
           MOVE BCT-GGESC  TO D-BCT-GGESC
           MOVE BCT-LCONS  TO D-BCT-LCONS
           MOVE BCT-DRAG   TO D-BCT-DRAG
           MOVE BCT-DRAG2  TO D-BCT-DRAG2
           MOVE BCT-DIND   TO D-BCT-DIND
           MOVE BCT-DIND2  TO D-BCT-DIND2
           MOVE BCT-DCAP   TO D-BCT-DCAP
           MOVE BCT-DCIT   TO D-BCT-DCIT
           MOVE BCT-VCOD1  TO D-BCT-VCOD1
           MOVE BCT-VRAG1  TO D-BCT-VRAG1
           MOVE BCT-VIND1  TO D-BCT-VIND1
           MOVE BCT-VCOD2  TO D-BCT-VCOD2
           MOVE BCT-VRAG2  TO D-BCT-VRAG2
           MOVE BCT-VIND2  TO D-BCT-VIND2
           MOVE BCT-DEST   TO D-BCT-DEST
           MOVE BCT-ASPE   TO D-BCT-ASPE
           MOVE BCT-NCOL   TO D-BCT-NCOL
           MOVE BCT-PLOR   TO D-BCT-PLOR
           MOVE BCT-PNET   TO D-BCT-PNET
           MOVE BCT-CAUT   TO D-BCT-CAUT
           MOVE BCT-DTRA   TO D-BCT-DTRA
           MOVE BCT-OTRA   TO D-BCT-OTRA
           MOVE BCT-NOTE   TO D-BCT-NOTE
           MOVE BCT-FLGXAB TO D-BCT-FLGXAB
           MOVE BCT-IMB    TO D-BCT-IMB
           MOVE BCT-ESCFAT TO D-BCT-ESCFAT
           MOVE BCT-STAMP  TO D-BCT-STAMP
           MOVE BCT-PBASE  TO D-BCT-PBASE
           MOVE BCT-PRACC  TO D-BCT-PRACC
           MOVE BCT-IFAT   TO D-BCT-IFAT
      *
           PERFORM IBISCO-MIMOSA.
      *
           GO TO FINE.

       ERRIO.
           COPY 'errsub'.
       CHIUDI.
           IF ERRIO-ST NOT = ZERO OR
              D-BCT-FUN NOT = 'R'
                 PERFORM CL-FILE.
       FINE.
           EXIT PROGRAM.
      *-------------*
       OP-FILE.
           IF SWOPE = ZERO
              OPEN INPUT BOLCTE
      **** rel 7.2
      *       OPEN INPUT FATTUR
      ************
      *
              PERFORM IBISCO-MIMOSA
      *
              MOVE 1 TO SWOPE.
      *-------------*
       CL-FILE.
           IF SWOPE = 1
              CLOSE BOLCTE
      **** rel 7.2
      *       CLOSE FATTUR
      ************
      *
              PERFORM IBISCO-MIMOSA
      *
              MOVE ZERO TO SWOPE.
      *-------------*
       IBISCO-MIMOSA.
      * dati di Ibisco
           CALL 'dsv-i-bct' USING D-BCT-P-IN
                ON EXCEPTION NEXT SENTENCE.
           IF ERRIO-ST > ZERO GO TO ERRIO.

      * dati di Mimosa
           CALL 'dsv-m-bct' USING D-BCT-P-IN
                ON EXCEPTION NEXT SENTENCE.
           IF ERRIO-ST > ZERO GO TO ERRIO.

      * dati PERSONALIZZATI
           CALL 'dsv-c-bct' USING D-BCT-P-IN
                ON EXCEPTION NEXT SENTENCE.
           IF ERRIO-ST > ZERO GO TO ERRIO.
      *-------------*
       CALL-ODBC-BCT.
           MOVE 1 TO D-ODBC-FUN.
           MOVE 'dsv-idbct' TO D-ODBC-PROC.
           CALL 'dsv-odbc' USING D-ODBC-CTR D-BCT-PAR.
      *
           IF D-ODBC-ST > ZERO PERFORM ERRIO-ODBC.
      *-------------*
       CALL-ODBC-FAT.
           MOVE 1 TO D-ODBC-FUN.
           MOVE 'dsv-idfat' TO D-ODBC-PROC.
           CALL 'dsv-odbc' USING D-ODBC-CTR D-FAT-PAR.
      *
           IF D-ODBC-ST > ZERO PERFORM ERRIO-ODBC.
      *-------------*
       ERRIO-ODBC.
           MOVE D-ODBC-MSG TO F-MES1.
           MOVE 1 TO F-NMES.
           IF D-ODBC-SQLERRMC NOT = SPACE
              MOVE D-ODBC-SQLERRMC TO F-MES2
              MOVE 2 TO F-NMES.
           GO TO ERRIO.
      *-------------*
