       IDENTIFICATION DIVISION.
       PROGRAM-ID. DSV-P-OBF.
      *
      * DATA SERVICE: righi Bolle Fornitori
      *
      **** rel 7.1
      * nuovo
      ************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gribftsl'.
           COPY 'griobfsl'.
           COPY 'griorfsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'gribft'.
           COPY 'griobf'.
           COPY 'griorf'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griorfrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parer'.
      *
           COPY 'dsv-idbft.cpy'.
           COPY 'dsv-idbfr.cpy'.
           COPY 'dsv-idorf.cpy'.
           COPY 'dsv-idrif.cpy'.
           COPY 'dsv-idobf.cpy' REPLACING ==(OBF)== BY ==IDOBF==.
           COPY 'dsv-odbcl'.
      *
       01  ID-BFT PIC X(15) VALUE 'bolfte'.
       01  ID-OBF PIC X(15) VALUE 'bolorf'.
       01  ID-ORF PIC X(15) VALUE 'ordfor'.
       01  COMODI.
           05 SF-BFT   PIC XX.
           05 SF-OBF   PIC XX.
           05 SF-ORF   PIC XX.
           05 MESS    PIC X(40) VALUE SPACE.
           05 SWOPE   PIC 9     VALUE ZERO.
      *
       LINKAGE SECTION.
           COPY 'dsv-obf.cpy'.
       PROCEDURE DIVISION USING D-OBF-P-IN.
           COPY 'declxer1'.
           COPY 'dclbft'.
           COPY 'dclobf'.
           COPY 'dclorf'.
           COPY 'declxer2'.
       INIZIO.
           IF D-OBF-FUN = 'C'
              PERFORM CL-FILE
              GO TO FINE.
      *
           COPY 'strsub'.
      *
           IF D-OBF-FUN = 'O'
              PERFORM OP-FILE
              GO TO FINE.

           INITIALIZE D-OBF-CAMPI.
           INITIALIZE D-OBF-IN-FLD.

           MOVE D-OBF-AZI TO KBF-AZI.
           MOVE D-OBF-PRT TO KBF-PRT.
      **** rel 7.2
      *    READ BOLFTE INITIALIZE BFT.
           READ BOLFTE INVALID INITIALIZE BFT.
      ************
      *
           MOVE KBF-AZI TO D-BFT-AZI.
           MOVE KBF-PRT TO D-BFT-PRT.
      *
           IF D-OBF-SERIE = ZERO
              MOVE BFT-DTBO TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE AA4 TO D-BFT-SERIE
           ELSE
              MOVE D-OBF-SERIE TO D-BFT-SERIE.
      *
           MOVE 'RD' TO D-BFT-FUN.  *> read
           PERFORM CALL-ODBC-BFT.
           IF D-BFT-ID = ZERO GO TO FINE.
      *
           MOVE KBF-AZI   TO D-BFR-AZI.
           MOVE D-BFT-ID  TO D-BFR-IDBFT.
           MOVE D-OBF-PRG TO D-BFR-PRG.
      *
           MOVE 'RD' TO D-BFR-FUN.  *> read
           PERFORM CALL-ODBC-BFR.
           IF D-BFR-ID = ZERO GO TO FINE.
      *
           MOVE D-BFR-ID TO D-OBF-IDBFR.
      *
           MOVE KBF-AZI    TO KOB-AZI.
           MOVE KBF-PRT    TO KOB-PRT.
           MOVE D-OBF-PRG  TO KOB-PRB.
           MOVE D-OBF-PPRG TO KOB-PRG.
           READ BOLORF INVALID GO TO FINE.
      *
           MOVE KOB-AZI     TO D-IDOBF-AZI.
           MOVE D-OBF-IDBFR TO D-IDOBF-IDBFR.
           MOVE KOB-PRG     TO D-IDOBF-PRG.
      *
           MOVE 'RD' TO D-IDOBF-FUN.  *> read
           PERFORM CALL-ODBC-OBF.
           MOVE D-IDOBF-IDRIF TO D-OBF-IDRIF.
      *
           IF OBF-FORD NOT = ZERO GO TO NO-ORF.

           MOVE KOB-AZI  TO KOF-AZI.
           MOVE OBF-NORD TO KOF-NUM.
           READ ORDFOR INTO REKORF INVALID INITIALIZE REKORF.
           IF SF-ORF = '9D' OR '9A' OR '35' MOVE RF-ORF TO REKORF.
      *
           MOVE KOF-AZI TO D-ORF-AZI.
           MOVE KOF-NUM TO D-ORF-NUM.
      *
           MOVE ORF-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO D-ORF-SERIE.
      *
           MOVE 'RD' TO D-ORF-FUN.  *> read
           PERFORM CALL-ODBC-ORF.
           IF D-ORF-ID NOT = ZERO
      *
              MOVE D-ORF-AZI TO D-RIF-AZI
              MOVE D-ORF-ID  TO D-RIF-IDORD
              MOVE OBF-RGOR  TO D-RIF-PRG
      *
              MOVE 'RD' TO D-RIF-FUN      *> read
              PERFORM CALL-ODBC-RIF
              MOVE D-RIF-ID TO D-OBF-IDRIF.
       NO-ORF.
      *
           MOVE OBF-QUANT  TO D-OBF-QUANT
      *
           PERFORM IBISCO-MIMOSA.
      *
           GO TO FINE.

       ERRIO.
           COPY 'errsub'.
       CHIUDI.
           IF ERRIO-ST NOT = ZERO OR
              D-OBF-FUN NOT = 'R'
                 PERFORM CL-FILE.
       FINE.
           EXIT PROGRAM.
      *-------------*
       OP-FILE.
           IF SWOPE = ZERO
              OPEN INPUT BOLFTE
              OPEN INPUT BOLORF
              OPEN INPUT ORDFOR
      *
              PERFORM IBISCO-MIMOSA
      *
              MOVE 1 TO SWOPE.
      *-------------*
       CL-FILE.
           IF SWOPE = 1
              CLOSE BOLFTE
              CLOSE BOLORF
              CLOSE ORDFOR
      *
              PERFORM IBISCO-MIMOSA
      *
              MOVE ZERO TO SWOPE.
      *-------------*
       IBISCO-MIMOSA.
      * dati di Ibisco
           CALL 'dsv-i-obf' USING D-OBF-P-IN
                ON EXCEPTION NEXT SENTENCE.
           IF ERRIO-ST > ZERO GO TO ERRIO.

      * dati di Mimosa
           CALL 'dsv-m-obf' USING D-OBF-P-IN
                ON EXCEPTION NEXT SENTENCE.
           IF ERRIO-ST > ZERO GO TO ERRIO.

      * dati PERSONALIZZATI
           CALL 'dsv-c-obf' USING D-OBF-P-IN
                ON EXCEPTION NEXT SENTENCE.
           IF ERRIO-ST > ZERO GO TO ERRIO.
      *-------------*
       CALL-ODBC-BFT.
           MOVE 1 TO D-ODBC-FUN.
           MOVE 'dsv-idbft' TO D-ODBC-PROC.
           CALL 'dsv-odbc' USING D-ODBC-CTR D-BFT-PAR.
      *
           IF D-ODBC-ST > ZERO PERFORM ERRIO-ODBC.
      *-------------*
       CALL-ODBC-BFR.
           MOVE 1 TO D-ODBC-FUN.
           MOVE 'dsv-idbfr' TO D-ODBC-PROC.
           CALL 'dsv-odbc' USING D-ODBC-CTR D-BFR-PAR.
      *
           IF D-ODBC-ST > ZERO PERFORM ERRIO-ODBC.
      *-------------*
       CALL-ODBC-ORF.
           MOVE 1 TO D-ODBC-FUN.
           MOVE 'dsv-idorf' TO D-ODBC-PROC.
           CALL 'dsv-odbc' USING D-ODBC-CTR D-ORF-PAR.
      *
           IF D-ODBC-ST > ZERO PERFORM ERRIO-ODBC.
      *-------------*
       CALL-ODBC-RIF.
           MOVE 1 TO D-ODBC-FUN.
           MOVE 'dsv-idrif' TO D-ODBC-PROC.
           CALL 'dsv-odbc' USING D-ODBC-CTR D-RIF-PAR.
      *
           IF D-ODBC-ST > ZERO PERFORM ERRIO-ODBC.
      *-------------*
       CALL-ODBC-OBF.
           MOVE 1 TO D-ODBC-FUN.
           MOVE 'dsv-idobf' TO D-ODBC-PROC.
           CALL 'dsv-odbc' USING D-ODBC-CTR D-OBF-PAR.
      *
           IF D-ODBC-ST > ZERO PERFORM ERRIO-ODBC.
      *-------------*
       ERRIO-ODBC.
           MOVE D-ODBC-MSG TO F-MES1.
           MOVE 1 TO F-NMES.
           IF D-ODBC-SQLERRMC NOT = SPACE
              MOVE D-ODBC-SQLERRMC TO F-MES2
              MOVE 2 TO F-NMES.
           GO TO ERRIO.
      *-------------*
