       IDENTIFICATION DIVISION.
       PROGRAM-ID. DSV-TAB.
      *
      * OGGETTO: Programma accodamento tabella su tutta le aziende
      *          abilitate in DSV
      **** rel 7.1
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
      *
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
      *
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parppar'.
      *    COPY 'partras'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  COMODI.
           05 SF-AZI     PIC XX.
           05 MESS       PIC X(40) VALUE SPACE.
           05 SWOPE      PIC 9     VALUE ZERO.
           05 SWINI      PIC 9     VALUE ZERO.
           05 W-DATA     PIC 9(6)  VALUE ZERO.
           05 SAVE-AZI   PIC 9(3)  VALUE ZERO.
      *
       LINKAGE SECTION.
           COPY 'pardsvt'.
       PROCEDURE DIVISION USING PARDSVT.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'declxer2'.
       INIZIO.
      *
           OPEN INPUT ANAAZI.
      *
           MOVE LOW-VALUE TO KEYAZ.
           START ANAAZI KEY NOT < KEYAZ INVALID GO TO END-AZI-1.
       LOOP-AZI-1.
           READ ANAAZI NEXT AT END GO TO END-AZI-1.
           IF SF-AZI = '9D' OR '9A' OR '35' GO TO LOOP-AZI-1.

           PERFORM CALL-VSRV133.

           GO TO LOOP-AZI-1.
       END-AZI-1.
      *
           GO TO CHIUDI.
      *---------------------*
       ERRIO.
           COPY 'errsub'.
       CHIUDI.
           CLOSE ANAAZI.
      *
       FINE.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'grixxxer'.
      *-------------------------------
       CALL-VSRV133.
           MOVE DSVT-FUN  TO PPAR-FUN.
           MOVE DSVT-TARC TO PPAR-TARC.
      *
           MOVE SPACE     TO PPAR-KEY.
           STRING KAZ-COD  DELIMITED BY SIZE
                  DSVT-KEY DELIMITED BY SIZE
                           INTO PPAR-KEY
           END-STRING.
      *
      **** rel 7.2
           MOVE EX-AZI  TO SAVE-AZI.
      ************
           IF KAZ-COD NOT = EX-AZI
      **** rel 7.2
      *       MOVE EX-AZI  TO SAVE-AZI
      ************
              MOVE KAZ-COD TO EX-AZI
           END-IF.
           MOVE DSVT-TOPE TO PPAR-TOPE.
           MOVE DSVT-CATT TO PPAR-CATT.
           MOVE DSVT-OPZ  TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
      *
           MOVE SAVE-AZI  TO EX-AZI.
      *
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 ' DSVT-TARC ' ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *-------------------------------
