       IDENTIFICATION DIVISION.
       PROGRAM-ID. LIN130.
      *
      * OGGETTO   :   STAMPA LIBRO INVENTARI
      *
      **** rel 4.8
      * ricompilato per variazione parcdt (date)
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gribilsl'.
           COPY 'griallsl'.
           COPY 'gricolsl'.
           COPY 'gricfxsl'.
           COPY 'grimvxsl'.
           COPY 'grimolsl'.
           COPY 'grimslsl'.
           COPY 'griartsl'.
           COPY 'grilifsl'.
           COPY 'grimsxsl'.
           SELECT WDSLAV ASSIGN TO DISK 
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           SELECT WDSLA2 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL2 STATUS SF-LA2.
           COPY 'gritabsl'.
           COPY 'griprtsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gribil'.
           COPY 'griall'.
           COPY 'gricol'.
           COPY 'gricfx'.
           COPY 'grimvx'.                                         
           COPY 'grimol'.                                         
           COPY 'grimsl'.                                         
           COPY 'griart'.
           COPY 'grilif'.
           COPY 'grimsx'.                                         
           COPY 'gritab'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
      **** rel 4.0
      *    RECORD 21 DATA RECORD RF-LAV.
           RECORD 23 DATA RECORD RF-LAV.
      ************
       01  RF-LAV.
           05 KEYLV.
              10 KLV-TIP PIC 99.
              10 KLV-CAT PIC 9.
              10 KLV-COD.
                 15 KLV-MS PIC 9(2).
                 15 KLV-CD PIC 9(5).
      **** rel 4.0
      *    05 LAV-IMP PIC S9(11).
           05 LAV-IMP PIC S9(11)V99.
      ************
       FD  WDSLA2 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA2
      **** rel 4.8
      *    RECORD 48 DATA RECORD RF-LA2.
      **** rel 4.9
      *    RECORD 50 DATA RECORD RF-LA2.
      **** rel 4.0
      *    RECORD 56 DATA RECORD RF-LA2.
      **** rel 7.2
      *    RECORD 62 DATA RECORD RF-LA2.
           RECORD 68 DATA RECORD RF-LA2.
      ************
      ************
      ************
      ************
       01  RF-LA2.
           05 KEYL2.
              10 KL2-CAT PIC 9.
      **** rel 7.2
      *       10 KL2-ART PIC X(12).
              10 KL2-ART PIC X(18).
      ************
      **** rel 4.8
      *       10 KL2-ANN PIC 99.
              10 KL2-ANN PIC 9(4).
      ************
      **** rel 4.9
      *    05 LA2-QTA PIC S9(11).
      *    05 LA2-PRZ PIC S9(11).
           05 LA2-QTA PIC S9(11)V999.
      **** rel 4.0
      *    05 LA2-PRZ PIC S9(11)V999.
           05 LA2-PRZ PIC S9(11)V9(6).
           05 LA2-FSC PIC 9.
      ************
      ************
      **** rel 4.0
      *    05 LA2-IMP PIC S9(11).
           05 LA2-IMP PIC S9(11)V99.
      ************
      **** rel 4.1
      *FD  STAMPA LABEL RECORD OMITTED LINAGE NRGF DATA RECORD RF-ST.
       FD  STAMPA LABEL RECORD OMITTED DATA RECORD RF-ST.
      ************
       01  RF-ST.
           05 ST-STT PIC X(58).
           05 FILLER PIC X(74).
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
      **** rel 4.5
      **** rel 4.1
      *    COPY 'parps'.
           COPY 'parpsb'.
      ************
      ************
           COPY 'griazirk'.
           COPY 'griconrk'.
           COPY 'griclfrk'.
           COPY 'grimovrk'.                                       
           COPY 'grimolrk'.                                       
           COPY 'gritabrk'.
           COPY 'grit20rk'.
           COPY 'griartrk'.
           COPY 'parcdt'.
      **** rel 3.0
      *    COPY 'parx'.
      *    COPY 'parzf'.
      *    COPY 'wconf'.
           COPY '_parx'.
           COPY '_parzf'.
           COPY '_wconf'.
           COPY 'parpv'.
      ************
      **** rel 4.9
           COPY 'parrd'.
      ************
      **** rel 4.0
           COPY 'parop'.
      ************
       01 ID-LAV PIC X(15) VALUE 'wdslav'.
       01 ID-LA2 PIC X(15) VALUE 'wdsla2'.
       01  COMODI.
           05 ID-AZI PIC X(15) VALUE 'anazol'.
           05 ID-BIL PIC X(15) VALUE 'anabil'.
           05 ID-ALL PIC X(15) VALUE 'analle'.
           05 ID-COL PIC X(15) VALUE 'anacol'.
           05 ID-CFX PIC X(15) VALUE 'anacfx'.
           05 ID-MVX PIC X(15) VALUE 'movoxx'.
           05 ID-MOL PIC X(15) VALUE 'movmol'.
           05 ID-MSX PIC X(15) VALUE 'mosoxx'.
           05 ID-MSL PIC X(15) VALUE 'movsol'.
           05 ID-TAB PIC X(15) VALUE 'tabell'.
           05 ID-ART PIC X(15) VALUE 'magart'.
           05 ID-LIF PIC X(15) VALUE 'maglif'.
           05 SF-AZI PIC XX.
           05 SF-BIL PIC XX.
           05 SF-ALL PIC XX.
           05 SF-COL PIC XX.
           05 SF-CFX PIC XX.
           05 SF-MVX PIC XX.
           05 SF-MOL PIC XX.
           05 SF-MSX PIC XX.
           05 SF-MSL PIC XX.
           05 SF-TAB PIC XX.
           05 SF-ART PIC XX.
           05 SF-LIF PIC XX.
           05 SF-LAV PIC XX.
           05 SF-LA2 PIC XX.
      **** rel 4.1a                                                     
           05 TEST0  PIC 9 VALUE ZERO.                                 
           05 TESTA  PIC 9 VALUE ZERO.                                 
      ************                                                     
           05 MESS   PIC X(20) VALUE SPACE.
           05 RISP   PIC 9 VALUE ZERO.
           05 FUNZ   PIC 9 VALUE ZERO.
           05 FLDE   PIC 9 VALUE ZERO.
           05 DATEL  PIC 9(6) VALUE ZERO.
           05 INIES  PIC 9(6) VALUE ZERO.
           05 FINES  PIC 9(6) VALUE ZERO.
           05 INIESK PIC 9(5) COMP-3 VALUE ZERO.
           05 FINESK PIC 9(5) COMP-3 VALUE ZERO.
           05 DGRU   PIC X(28) VALUE SPACE.
      **** rel 4.9
      *    05 COMODO PIC S9(13) VALUE ZERO.
      ************
      **** rel 4.0
      *    05 TOTVL  PIC S9(13) VALUE ZERO.
           05 TOTVL  PIC S9(11)V99 VALUE ZERO.
      ************
      **** rel 4.9
      *    05 TOTQT  PIC S9(13) VALUE ZERO.
      *    05 TOTQ1  REDEFINES TOTQT PIC S9(12)V9.
      *    05 TOTQ2  REDEFINES TOTQT PIC S9(11)V99.
           05 TOTQT  PIC S9(13)V999 VALUE ZERO.
      ************
           05 TCON   PIC 9 VALUE ZERO.
           05 MCLI   PIC 99 VALUE ZERO.
           05 MFOR   PIC 99 VALUE ZERO.
           05 K      PIC 999 VALUE ZERO.
           05 N      PIC 999 VALUE ZERO.
           05 PART   PIC 9(7) VALUE ZERO.
           05 PR REDEFINES PART.
              10 MPAR PIC 99.
              10 MCLF PIC 9(5).
      **** rel 4.7
      *    05 CTRIG   PIC 999  VALUE ZERO.
      *    05 ALA1.
      *       10 ELX OCCURS 36 PIC X.
      *    05 J      PIC 999 VALUE ZERO.
      *    05 WDESK  PIC X(140).
      *    05 WDSK1  REDEFINES WDESK PIC X OCCURS 140.
      *    05 WDSK2  REDEFINES WDESK.
      *       10 WDSK21 PIC X(70).
      *       10 WDSK22 PIC X(70).
      *    05 WDSK3  REDEFINES WDESK.
           05 KONCA   PIC 999.
           05 POSIZ   PIC 999.
           05 CONCAIN PIC X(36).
           05 CONCOUT.
      ************
              10 WDSK31 PIC X(54).
              10 WDSK32 PIC X(54).
      **** rel 4.7
      *       10 WDSK33 PIC X(32).
              10 WDSK33 PIC X(54).
           05 COMCOUT.
              10 FILLER PIC X(54).
              10 FILLER PIC X(54).
              10 FILLER PIC X(54).
      ************
      **** rel 7.2
      *    05 ART1   PIC X(12) VALUE SPACE.
           05 ART1   PIC X(18) VALUE SPACE.
      ************
      **** rel 4.9
      *    05 CLAV   PIC S9(11) VALUE ZERO.
      *    05 CLV8   REDEFINES CLAV PIC S9(10)V9.
      *    05 CLV7   REDEFINES CLAV PIC S9(9)V99.
      *    05 QTAL   PIC S9(13) VALUE ZERO.
           05 QTAL   PIC S9(13)V999 VALUE ZERO.
      ************
      **** rel 4.0
      *    05 TOT    PIC S9(13) VALUE ZERO.
           05 TOT    PIC S9(13)V999 VALUE ZERO.
      ************
      **** rel 4.9
      *    05 COMA   PIC S9(13) VALUE ZERO.
      *    05 COMAV1 REDEFINES COMA PIC S9(12)V9.
      *    05 COMAV2 REDEFINES COMA PIC S9(11)V99.
      *    05 COMAV3 REDEFINES COMA PIC S9(10)V999.
      *    05 COMAV4 REDEFINES COMA PIC S9(9)V9999.
      ************
           05 PARSH  PIC X(120) VALUE SPACE.
           05 CICLO  PIC 9   VALUE ZERO.
           05 CDCLC  PIC 999 VALUE ZERO.
           05 CACLC  PIC 999 VALUE ZERO.
           05 CDFOC  PIC 999 VALUE ZERO.
           05 CAFOC  PIC 999 VALUE ZERO.
           05 CDSOC  PIC 999 VALUE ZERO.
           05 CASOC  PIC 999 VALUE ZERO.
           05 CDSOA  PIC 999 VALUE ZERO.
           05 CASOA  PIC 999 VALUE ZERO.
           05 FLAPE  PIC 9   VALUE ZERO.
           05 COUTI  PIC 9(7) VALUE ZERO.
           05 COPER  PIC 9(7) VALUE ZERO.
      **** rel 4.0
      *    05 DFPAT  PIC S9(13) VALUE ZERO.
      *    05 DFECO  PIC S9(13) VALUE ZERO.
      *    05 SALDO  PIC S9(13) VALUE ZERO.
      *    05 WSALDO PIC ZZ.ZZZ.ZZZ.ZZ9-. 
      *    05 TTGRUP PIC S9(13) VALUE ZERO.
           05 DFPAT  PIC S9(11)V99 VALUE ZERO.
           05 DFECO  PIC S9(11)V99 VALUE ZERO.
           05 SALDO  PIC S9(11)V99 VALUE ZERO.
           05 WSALDO PIC ZZZ.ZZZ.ZZ9,99-. 
           05 TTGRUP PIC S9(11)V99 VALUE ZERO.
      ************
           05 IDE-DES PIC X(20) VALUE SPACE.
      **** rel 4.0
      *    05 TOTGRU PIC S9(13) OCCURS 6.
           05 TOTGRU PIC S9(11)V99 OCCURS 6.
      ************
           05 COLONN PIC 9 VALUE ZERO.
      **** rel 4.0
      *    05 TOTCOL PIC S9(13) VALUE ZERO.
           05 TOTCOL PIC S9(11)V99 VALUE ZERO.
      ************
           05 DATSTA PIC ZZ/ZZ/ZZ.
           05 DESAX.
              10 FILLER PIC X(28) VALUE 'A T T I V I T A'' '.
              10 FILLER PIC X(28) VALUE 'CONTI D'' ORDINE'.
              10 FILLER PIC X(28) VALUE 'P A S S I V I T A'' '.
              10 FILLER PIC X(28) VALUE 'CONTI D'' ORDINE'.
              10 FILLER PIC X(28) VALUE 'PROFITTI E RENDITE'.
              10 FILLER PIC X(28) VALUE 'PERDITE E SPESE'.
           05 DESAT REDEFINES DESAX PIC X(28) OCCURS 6.
           05 SOTTX.
              10 FILLER PIC X(28) VALUE '----------------'.
              10 FILLER PIC X(28) VALUE '---------------'.
              10 FILLER PIC X(28) VALUE '------------------'.
              10 FILLER PIC X(28) VALUE '---------------'.
              10 FILLER PIC X(28) VALUE '------------------'.
              10 FILLER PIC X(28) VALUE '---------------'.
           05 SOTTY REDEFINES SOTTX PIC X(28) OCCURS 6.
           05 DESTX.
              10 FILLER PIC X(28) VALUE 'TOTALE ATTIVITA'' '.
              10 FILLER PIC X(28) VALUE 'TOTALE CONTI D''ORDINE'.
              10 FILLER PIC X(28) VALUE 'TOTALE PASSIVITA'' '.
              10 FILLER PIC X(28) VALUE 'TOTALE CONTI D''ORDINE'.
              10 FILLER PIC X(28) VALUE 'TOTALE PROFITTI E RENDITE'.
              10 FILLER PIC X(28) VALUE 'TOTALE PERDITE E SPESE'.
           05 DESTO REDEFINES DESTX PIC X(28) OCCURS 6.
           05 SOTOX.
              10 FILLER PIC X(28) VALUE '================'.
              10 FILLER PIC X(28) VALUE '====================='.
              10 FILLER PIC X(28) VALUE '================='.
              10 FILLER PIC X(28) VALUE '====================='.
              10 FILLER PIC X(28) VALUE '========================='.
              10 FILLER PIC X(28) VALUE '======================'.
           05 SOTOY REDEFINES SOTOX PIC X(28) OCCURS 6.
      **** rel 4.1
           05 APAGE  PIC 999.
           05 KRIG   PIC 999. 
       01  RX-91      PIC 99 COMP-X.
       01  FX-91      PIC 99 COMP-X VALUE 47.
      ************
       01  PARST.
           05 XCRR PIC 9 VALUE ZERO.
           05 RIGA PIC X(132) VALUE SPACE.
           05 RIG0 REDEFINES RIGA.
              10 RGRUPP PIC X(28).
              10 FILLER PIC X(104).
           05 RIG1 REDEFINES RIGA.
              10 FILLER PIC X(3).
              10 RVOCE  PIC X(36).
              10 FILLER  PIC X(93).
           05 RIG2 REDEFINES RIGA.
              10 FILLER PIC X(6).
              10 RDETT  PIC X(74).
              10 CLFMAG REDEFINES RDETT.
                 15 FILLER PIC X(3).
                 15 RDECFM PIC X(36).
                 15 FILLER PIC X.
                 15 RCITTA.
                    20 RANN   PIC 99.
                    20 FILLER PIC X.
                    20 RUNM   PIC XXX.
                    20 RQUA0  PIC ZZZZ.ZZZ.ZZZ-.
                    20 RQUA1 REDEFINES RQUA0 PIC ZZ.ZZZ.ZZZ,Z-.
                    20 RQUA2 REDEFINES RQUA0 PIC Z.ZZZ.ZZZ,ZZ-.
                    20 RSEGN PIC XX.
                    20 RPREZ PIC ZZZZ.ZZZ.ZZZ-.
      **** rel 7.2
      *             20 RPRE2 REDEFINES RPREZ PIC ZZ.ZZZ.ZZ,ZZ-.
      *             20 RPRE3 REDEFINES RPREZ PIC Z.ZZZ.ZZ,ZZZ-.
                    20 RPRE2 REDEFINES RPREZ PIC Z.ZZZ.ZZZ,ZZ-.
                    20 RPRE3 REDEFINES RPREZ PIC ZZZZ.ZZZ,ZZZ-.
      ************
      **** rel 5.0
                    20 RPRE4 REDEFINES RPREZ PIC ZZZ.ZZZ,ZZZZ-.
                    20 RPRE5 REDEFINES RPREZ PIC ZZ.ZZZ,ZZZZZ-.
                    20 RPRE6 REDEFINES RPREZ PIC Z.ZZZ,ZZZZZZ-.
      ************
              10 DTSOT  REDEFINES RDETT.
                 15 FILLER PIC X(3).
                 15 DSCAUS.
                    20 ERG PIC X(57).
                    20 ERG11 REDEFINES ERG PIC X OCCURS 57.
                    20 FILLER PIC X.
                    20 RSDOC.
                       25 RNDOC  PIC ZZZZZ-.
                       25 RDATA  PIC X(7).
      **** rel 4.0
      *       10 RIMPO1 PIC ZZ.ZZZ.ZZZ.ZZZ-.
              10 RIMPO1 PIC ZZZ.ZZZ.ZZZ,ZZ-.
      ************
              10 RSOTT1 REDEFINES RIMPO1 PIC X(15). 
      **** rel 4.0
      *       10 RIMPO2 PIC ZZZ.ZZZ.ZZZ.ZZZ-.
              10 RIMPO2 PIC ZZZZ.ZZZ.ZZZ,ZZ-.
      ************
              10 RSOTT2 REDEFINES RIMPO2 PIC X(16). 
      **** rel 4.0
      *       10 RIMPO3 PIC ZZZZ.ZZZ.ZZZ.ZZ9-.                         
              10 RIMPO3 PIC Z.ZZZ.ZZZ.ZZ9,99-.                         
      ************
              10 RSOTT3 REDEFINES RIMPO3 PIC X(17). 
              10 FILLER PIC X(4).
           05 RIG4 REDEFINES RIGA.
              10 FILLER   PIC X(40).
              10 RGAG.
                 15 RX OCCURS 50 PIC X.
                 15 FILLER   PIC X(42).
           05 RIG5 REDEFINES RIGA.
              10 FILLER   PIC X(41).
              10 RY OCCURS 50 PIC X.
              10 FILLER   PIC X(41).
           05 NRGF   PIC 99 VALUE 66.
           05 NRGL   PIC 99 VALUE 60.
           05 NRIG   PIC 99 VALUE ZERO.
           05 RTTS.
              10 TAZI   PIC X(51).
              10 FILLER PIC X(30) VALUE
                'L I B R O    I N V E N T A R I'.
              10 FILLER PIC X(51) VALUE SPACE.
           05 TINT1.
              10 FILLER PIC X(28) VALUE 
              'I N V E N T A R I O   A L  '.
              10 RDTIN  PIC ZZ/ZZ/ZZ.
           05 TINT2.
              10 FILLER PIC X(36) VALUE ALL '='.
           05 TINT3.
              10 FILLER PIC X(48) VALUE 
              'B I L A N C I O   D I   C H I U S U R A   A L'.
              10 RDCHI  PIC ZZ/ZZ/ZZ.
           05 TINT4.
              10 FILLER PIC X(56) VALUE ALL '='.
           05 TINT5.
              10 FILLER PIC X(35) VALUE 
              'P R O F I T T I   E   P E R D I T E'.
           05 TINT6.
              10 FILLER PIC X(35) VALUE ALL '='.
       01  W-LINEE PIC X(80) VALUE ALL '-'.
       01  WSTAMPA.
           05 FILLER PIC X(28) VALUE SPACE.
           05 FILLER PIC 99    VALUE 2.
           05 FILLER PIC 99    VALUE 2.
           05 FILLER PIC X(30) VALUE '9 INIZIO STAMPA'.
           05 FILLER PIC X(30) VALUE '0 ABBANDONA'.
       01  WSMESS1.
           05 WSS1   PIC X(28) VALUE SPACE.
           05 FILLER PIC 99    VALUE 2.
           05 FILLER PIC 99    VALUE 2.
           05 FILLER PIC X(30) VALUE '0 CONTINUA'.
           05 FILLER PIC X(30) VALUE '1 ABBANDONA'.
       SCREEN SECTION.
      **** rel 3.0
      *    COPY 'scrlog'.
           COPY '_scrlog'.
      ************
       01  SCRAZI.
           05 LINE 1  COLUMN 23 VALUE
           'STAMPA  LIBRO  INVENTARI'.
           05 LINE 2  COLUMN 1 PIC X(80) FROM W-LINEE.
           05 LINE 11 COLUMN 1  VALUE
              'Codice azienda (0=Fine) ...........:'.
           05 SCAZI  LINE 11 COLUMN 38 PIC ZZ9 USING KAZ-COD.
           05 SDAZI  LINE 11 COLUMN 42 PIC X(36) FROM AZRGSOC.
       01  SCRSTA.
           05 LINE 1  COLUMN 10 VALUE
           'STAMPA LIBRO INVENTARI'.
           05 LINE 1  COLUMN 33 PIC X(36) FROM AZRGSOC.
           05 LINE 2  COLUMN 1 PIC X(80) FROM W-LINEE.
           05 LINE  9 COLUMN 1 VALUE 'Esercizio dal .:'.
           05 SINIES LINE  9 COLUMN 18 PIC 99/99/99 USING INIES.
           05 LINE  9 COLUMN 27 VALUE 'Al .:'.
           05 SFINES LINE  9 COLUMN 33 PIC 99/99/99 USING FINES.
           05 LINE 11 COLUMN 1  VALUE
              'Data di stampa (0=Fine) ......:'.
           05 SDATEL LINE 11 COLUMN 33 PIC 99/99/99 USING DATEL.
           05 LINE 13 COLUMN 1  VALUE
              'Scelta  stampa ...............:'.
           05 SFUNZ  LINE 13 COLUMN 40 PIC 9        USING FUNZ .
           05 LINE 13 COLUMN 42 VALUE
      **** rel 4.3
      *       '(0=Inventario 1=Solo bilancio)'.
              '(0=Inventario 1=Bilancio 2=Entrambi)'.
      ************
           05 LINE 15 COLUMN 1  VALUE
              'Dettaglio profitti e perdite .:'.
           05 SFLDE  LINE 15 COLUMN 40 PIC 9        USING FLDE .
           05 LINE 15 COLUMN 42 VALUE
              '(0=No 1=Si)'.
       01  SCRCAL.
           05 LINE 1  COLUMN 1 VALUE
           '    LIBRO INVENTARI - CALCOLO - '.
           05 LINE 1  COLUMN 33 PIC X(36) FROM AZRGSOC.
           05 LINE 2  COLUMN 1 PIC X(80) FROM W-LINEE.
           05 LINE 9  COLUMN 10 VALUE 'Gruppo ..........:'.
           05 STCON LINE 9 COLUMN 30 PIC ZZ9 FROM KBL-TCON.
           05 SDGRU LINE 9 COLUMN 34 PIC X(28) FROM DGRU.
           05 LINE 10 COLUMN 10 VALUE 'Voce ............:'.
           05 STVOC LINE 10 COLUMN 30 PIC ZZ9 FROM KBL-NRIGA. 
           05 SDVOC LINE 10 COLUMN 34 PIC X(36) FROM BIL-DESCR. 
           05 LINE 11 COLUMN 10 VALUE 'Dettaglio .......:'.
           05 STDET LINE 11 COLUMN 30 PIC ZZ9 FROM KAL-PRG.
           05 SDDET LINE 11 COLUMN 34 PIC X(36) FROM ALL-DESCR.
       01  SCRCON.
           05 LINE 13 COLUMN 10 VALUE 'Conto ...........:'.
           05 SCDCON LINE 13 COLUMN 30 PIC 9(7) FROM KCL-COD.
           05 LINE 13 COLUMN 37 VALUE '     '.
       01  SCRCLI.
           05 LINE 13 COLUMN 10 VALUE 'Clienti .........:'.
           05 SCDCLI LINE 13 COLUMN 30 PIC 9(7) FROM CLF-COD.
           05 LINE 13 COLUMN 37 VALUE '     '.
       01  SCRFOR.
           05 LINE 13 COLUMN 10 VALUE 'Fornitori .......:'.
           05 SCDFOR LINE 13 COLUMN 30 PIC 9(7) FROM CLF-COD.
           05 LINE 13 COLUMN 37 VALUE '     '.
       01  SCRMAG.
           05 LINE 13 COLUMN 10 VALUE 'Articoli ........:'.
           05 SCDMAG LINE 13 COLUMN 30 PIC X(12) FROM KMA-ART.
       01  SCRBLL LINE 13 COLUMN 1 VALUE ' ' BLANK LINE.
       PROCEDURE DIVISION.
           COPY 'declxer1'.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==AZI==
                                   ==NFILE== BY ==ANAAZI==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==BIL==
                                   ==NFILE== BY ==ANABIL==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==ALL==
                                   ==NFILE== BY ==ANALLE==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==COL==
                                   ==NFILE== BY ==ANACOL==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==CFX==
                                   ==NFILE== BY ==ANACFX==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==MVX==
                                   ==NFILE== BY ==MOVMXX==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==MOL==
                                   ==NFILE== BY ==MOVMOL==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==MSL==
                                   ==NFILE== BY ==MOVSOL==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==ART==
                                   ==NFILE== BY ==MAGART==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==LIF==
                                   ==NFILE== BY ==MAGLIF==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==MSX==
                                   ==NFILE== BY ==MOVSXX==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==TAB==
                                   ==NFILE== BY ==TABELL==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==LAV==
                                   ==NFILE== BY ==WDSLAV==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==LA2==
                                   ==NFILE== BY ==WDSLA2==.
      **** rel 3.0
      *    COPY 'declxer2'.
           COPY '_dclxer2'.
      ************
       INIZIO.                                    
           ACCEPT PARSH FROM COMMAND-LINE.
           IF PARSH NOT = SPACE
                UNSTRING PARSH DELIMITED ALL SPACE 
                INTO ID-LAV ID-LA2.
           OPEN I-O ANABIL ANALLE.
           OPEN INPUT ANACOL MOVMOL MOVMXX.
           OPEN INPUT TABELL.
      **** rel 4.5
           OPEN INPUT ANAAZI.
      ************
           MOVE 'lin130' TO X-NOT F-NOT.
           MOVE 'LIBRO INVEN.' TO STK-LAB.
      **** rel 3.0
      *    COPY 'readide'.
           COPY '_readide'.
      ************
      **** rel 4.5
      **** rel 3.0
      *    COPY 'readazi'.
           COPY '_readazi'.
      ************
           IF KAZ-COD = ZERO GO TO FINE.
           MOVE RF-AZI TO REKAZI.
      ************
           MOVE 1 TO X-MOD.
           MOVE ZERO TO TIPOP1 GGMMAA.
           CALL 'rdata' USING PARCDT. 
           MOVE 1 TO KTB-TIP KTB-COD.
      **** rel 4.5
      *    READ TABELL INTO REKTAB INVALID KEY CLOSE TABELL
      *                MOVE 'RD TAB01' TO MESS GO TO ERRIO.
           READ TABELL INTO REKTAB INVALID KEY 
                       PERFORM INVK-TAB
                       CLOSE TABELL
                       GO TO ERRIO.
      ************
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
           MOVE 20 TO KTB-TIP.
           MOVE 1  TO KTB-COD.
      **** rel 4.5
      *    READ TABELL INTO RKTB20 INVALID KEY CLOSE TABELL
      *                MOVE 'RD TAB20' TO MESS GO TO ERRIO.
           READ TABELL INTO RKTB20 INVALID KEY 
                       PERFORM INVK-TAB
                       CLOSE TABELL
                       GO TO ERRIO.
      ************
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.
           MOVE T20-CDCLC TO CDCLC.
           MOVE T20-CACLC TO CACLC.
           MOVE T20-CDFOC TO CDFOC.
           MOVE T20-CAFOC TO CAFOC.
           MOVE T20-CDSOC TO CDSOC.
           MOVE T20-CASOC TO CASOC.
           MOVE T20-COUTI TO COUTI.
           MOVE T20-COPER TO COPER.
           MOVE T20-CDSOA TO CDSOA.
           MOVE T20-CASOA TO CASOA.
           CLOSE TABELL.
       LPINIZ.
      **** rel 4.5
           MOVE ZERO TO FUNZ FLDE.
      *    OPEN INPUT ANAAZI.
      *    MOVE ZERO TO KAZ-COD FUNZ FLDE.
      *    MOVE SPACE TO AZRGSOC.
      *    DISPLAY SCRLOG.
      *    DISPLAY SCRAZI.
      *LPAZI.
      *    ACCEPT SCAZI.
      *    DISPLAY SCAZI.
      *    IF KAZ-COD = ZERO CLOSE ANAAZI GO TO FINE.
      *    READ ANAAZI INTO REKAZI INVALID
      *         MOVE SPACE TO AZRGSOC DISPLAY SDAZI 
      *         PERFORM ERR-CINE GO TO LPAZI.
      *    DISPLAY SDAZI.
      *CNAZI.
      *    CALL 'rxcnf'  USING PARX CNF1.
      *    MOVE X-COD TO RISP.
      *    IF RISP > 1 GO TO CNAZI.
      *    IF RISP = 1 GO TO LPAZI.
      *    CLOSE ANAAZI.
      ************
           MOVE AZRGSOC TO TAZI.
           MOVE AZI-DTAPE TO AAGGG INIESK.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO INIES.
           MOVE 1 TO TIPOP1.
           ADD 11 TO MM9.
           IF MM9 > 12 ADD 1 TO AA9
                       SUBTRACT 12 FROM MM9.
           MOVE 31 TO GG9.
       LDAT.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 NOT = ZERO SUBTRACT 1 FROM GG9
                                         GO TO LDAT.
           IF GG9 < 28 MOVE ZERO TO GGMMAA.
           MOVE GGMMAA TO FINES.
           MOVE AAGGG TO FINESK.
           MOVE ZERO TO DATEL FUNZ FLDE.
           DISPLAY SCRLOG.
           DISPLAY SCRSTA.
       LPFUNZ.
           ACCEPT  SINIES.
           DISPLAY SINIES.
           IF INIES = ZERO GO TO LPFUNZ.
           MOVE 1 TO TIPOP1.
           MOVE INIES TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 NOT = ZERO PERFORM ERR-DATA GO TO LPFUNZ.
           MOVE AAGGG TO INIESK.
       LPFU10.
           ACCEPT  SFINES.
           DISPLAY SFINES.
           MOVE FINES TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 NOT = ZERO PERFORM ERR-DATA GO TO LPFU10.
           IF AAGGG NOT > INIESK GO TO LPFU10.
           MOVE AAGGG TO FINESK.
       LPFU20.
           ACCEPT  SDATEL.
           DISPLAY SDATEL.
      **** rel 4.5
           IF DATEL = ZERO GO TO FINE.
      *    IF DATEL = ZERO GO TO LPINIZ.
      ************
           MOVE DATEL TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 NOT = ZERO PERFORM ERR-DATA GO TO LPFU20.
           IF AAGGG < FINESK GO TO LPFU20.
           MOVE FINES TO RDTIN RDCHI.
       LPFU30.
           ACCEPT SFUNZ.
           DISPLAY SFUNZ.
      **** rel 4.3
      *    IF FUNZ > 1 GO TO LPFU30.
           IF FUNZ > 2 GO TO LPFU30.
      ************
       LPFU35.
      **** rel 4.3
           IF FUNZ = ZERO MOVE ZERO TO FLDE
                          DISPLAY SFLDE GO TO LPFU40.
      ************
           ACCEPT  SFLDE.
           DISPLAY SFLDE.
           IF FLDE > 1 GO TO LPFU35.
       LPFU40.
           CALL 'rxcnf'  USING PARX CNF1.
           MOVE X-COD TO RISP.
           IF RISP > 1 GO TO LPFU40.
           IF RISP NOT = ZERO GO TO LPFUNZ.
      * INIZIO PREPARAZIONE INVENTARIO E BILANCIO *
           MOVE ZERO TO KBL-TCON KBL-NRIGA KAL-PRG.
           MOVE SPACE TO DGRU BIL-DESCR ALL-DESCR.
           DISPLAY SCRLOG.
           DISPLAY SCRCAL.
           OPEN I-O WDSLAV.
       LDEL.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO LD20.
       LD10. 
           READ WDSLAV NEXT AT END GO TO LD20.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO LD10.
           DELETE WDSLAV.
           GO TO LD10.
       LD20.
           CLOSE WDSLAV.
           OPEN I-O WDSLA2.
           MOVE LOW-VALUE TO KEYL2.
           START WDSLA2 KEY NOT < KEYL2 INVALID GO TO LD40.
       LD30. 
           READ WDSLA2 NEXT AT END GO TO LD40.
           IF SF-LA2 = '9D' OR '9A' OR '35' GO TO LD30.
           DELETE WDSLA2.
           GO TO LD30.
       LD40. 
           CLOSE WDSLA2.
           MOVE ZERO TO DFPAT DFECO TCON.
           MOVE LOW-VALUE TO KEYBL.
           MOVE KAZ-COD TO KBL-AZI.
           START ANABIL KEY NOT < KEYBL INVALID GO TO ENDA.
       LPBIL.
           READ ANABIL NEXT AT END GO TO ENDA.
           IF SF-BIL = '9D' OR '9A' OR '35' GO TO LPBIL.
           IF KBL-AZI NOT = KAZ-COD GO TO ENDA.
           IF BIL-TRIGA = 'D' GO TO LPBIL.
           IF KBL-TCON NOT = TCON MOVE KBL-TCON TO TCON
                                  MOVE ZERO TO TOTGRU (TCON).
           MOVE ZERO TO BIL-IMPOR.
      **** rel 4.1a                                                     
           MOVE ZERO TO BIL-TEST TEST0.                                
      ************                                                     
           MOVE LOW-VALUE TO KEYAL.
           MOVE KBL-AZI TO KAL-AZI.
           MOVE KBL-TCON TO KAL-TCON.
           MOVE KBL-NRIGA TO KAL-NRIGA.
           MOVE DESAT (KBL-TCON) TO DGRU.
           DISPLAY STCON SDGRU STVOC SDVOC.
           START ANALLE KEY NOT < KEYAL INVALID GO TO ENDALL.
       LPALL.
           READ ANALLE NEXT AT END GO TO ENDALL.
           IF SF-ALL = '9D' OR '9A' OR '35' GO TO LPALL.
           IF KAL-AZI NOT = KBL-AZI OR
              KAL-TCON NOT = KBL-TCON OR
              KAL-NRIGA NOT = KBL-NRIGA GO TO ENDALL.
           MOVE ZERO TO ALL-TOTIM.
      **** rel 4.1a                                                     
           MOVE ZERO TO ALL-TEST TESTA.                                
      ************                                                     
           DISPLAY STDET SDDET.
           IF ALL-TALL = 'R' MOVE ALL-IMPOR TO ALL-TOTIM
      **** rel 4.1a                                                     
      *                                   DISPLAY SCRBLL.             
                          DISPLAY SCRBLL                             
                          IF ALL-IMPOR NOT = ZERO MOVE 1 TO TESTA.  
      ************                                                 
           IF ALL-TALL = 'S' PERFORM Z00-CONTI THRU Z99.
           IF ALL-TALL = 'C' OR 'F' PERFORM V00-CLIFO THRU V99.
           IF ALL-TALL = 'M' PERFORM U00-LIFO THRU U99.
           ADD  ALL-TOTIM TO BIL-IMPOR TOTGRU (TCON).
      **** rel 4.5
      *    REWRITE RF-BIL INVALID MOVE 'RWR BIL' TO MESS GO TO ERRIO.
      *    READ ANABIL INVALID MOVE 'RD.BIL' TO MESS GO TO ERRIO.
           REWRITE RF-BIL INVALID PERFORM INVK-BIL GO TO ERRIO.
           READ ANABIL INVALID PERFORM INVK-BIL GO TO ERRIO.
      ************
           IF KAL-TCON < 3 ADD ALL-TOTIM TO DFPAT.
           IF KAL-TCON = 6 ADD ALL-TOTIM TO DFECO.
           IF KAL-TCON = 5 SUBTRACT ALL-TOTIM FROM DFECO.
           IF KAL-TCON > 2 AND < 5 SUBTRACT ALL-TOTIM FROM DFPAT.
      **** rel 4.1a                                                     
           MOVE TESTA TO ALL-TEST.                                     
           IF TESTA = 1 MOVE TESTA TO TEST0.                           
           MOVE ZERO TO TESTA.                                         
      ************                                                     
      **** rel 4.5
      *    REWRITE RF-ALL INVALID MOVE 'RWR.ALL' TO MESS
           REWRITE RF-ALL INVALID PERFORM INVK-ALL
      ************
                                             GO TO ERRIO.
           GO TO LPALL.
       ENDALL.
      **** rel 4.1a                                                     
           MOVE TEST0 TO BIL-TEST.                                     
           MOVE ZERO TO TEST0.                                         
      ************                                                     
      **** rel 4.5
      *    REWRITE RF-BIL INVALID MOVE 'RW BIL' TO MESS
           REWRITE RF-BIL INVALID PERFORM INVK-BIL
      ************
                   GO TO ERRIO.
           GO TO LPBIL.
       ENDA.
           COMPUTE SALDO = DFPAT + DFECO.
           IF SALDO = ZERO GO TO STAMP.
           MOVE HIGH-VALUE TO WSS1
           MOVE SALDO TO WSALDO
           STRING 'DIFFERENZA : ' WSALDO 
                  DELIMITED HIGH-VALUE INTO WSS1.
           CALL 'rxcnf'  USING PARX WSMESS1.
           MOVE X-COD TO RISP.
           IF RISP = 1 GO TO LPINIZ.
      *
       STAMP.
           DISPLAY SCRLOG.
           DISPLAY SCRSTA.
           CALL 'rxcnf' USING PARX WSTAMPA.
           MOVE X-COD TO RISP.
           IF RISP NOT = 9 GO TO LPINIZ.
           MOVE 'STAMPA IN CORSO' TO F-MES1.
           MOVE 10 TO F-FUN.
           CALL 'rzfunz' USING PARF.
      **** rel 3.0
           MOVE 1 TO PV-FUN.
           CALL 'vrpview' USING PARPV.
      ************
           OPEN OUTPUT STAMPA.
      **** rel 4.1
           CALL X'91' USING RX-91 FX-91 STAMPA.
      ************
      **** rel 4.5
      **** rel 4.1
      *    CALL 'rpset' USING PARPS ON EXCEPTION
      *          MOVE SPACE TO PS-SET PS-RES.
      *    CANCEL 'rpset'.
           CALL 'rpsetb' USING PARPS ON EXCEPTION
                 MOVE SPACE TO PS-SET PS-RES
                 MOVE ZERO  TO PS-FF  PS-NRGL.
           CANCEL 'rpsetb'.
           IF PS-FF = 1
              MOVE 57 TO NRGL
              MOVE 66 TO NRGF
              IF PS-NRGL > ZERO
                 COMPUTE NRGL  = PS-NRGL - 3.
           MOVE ZERO TO KRIG.
      ************
           WRITE RF-ST FROM PS-SET AFTER ZERO.
      ************
           MOVE ZERO TO XCRR CICLO.
           IF FUNZ = 1 MOVE 1 TO CICLO.
       STAM.
           MOVE ZERO TO TCON.
           MOVE LOW-VALUE TO KEYBL.
           MOVE KAZ-COD TO KBL-AZI.
       S000.
           START ANABIL KEY NOT < KEYBL INVALID GO TO S050.
       S010.
           READ ANABIL NEXT AT END GO TO S050.
           IF SF-BIL = '9D' OR '9A' OR '35' GO TO S010.
           IF KBL-AZI NOT = KAZ-COD GO TO S050.
           IF ( KBL-TCON = 2 OR 4 ) AND TOTGRU ( KBL-TCON ) = ZERO
                                        ADD 1 TO KBL-TCON
                                        MOVE ZERO TO KBL-NRIGA
                                        GO TO S000.
           IF CICLO < 1 AND KBL-TCON > 4 GO TO S050.
           IF TCON > ZERO GO TO S011.
           MOVE KBL-TCON TO TCON.
           PERFORM B00-STA-INT THRU B99.
           IF CICLO = ZERO
                      WRITE RF-ST FROM TINT1 AFTER XCRR
      **** rel 4.1
                      ADD XCRR TO KRIG
      ************
                      ADD XCRR TO NRIG
                      WRITE RF-ST FROM TINT2 AFTER XCRR
      **** rel 4.1
                      ADD XCRR TO KRIG
      ************
                      ADD XCRR TO NRIG.
           IF CICLO = 1
                      WRITE RF-ST FROM TINT3 AFTER XCRR
      **** rel 4.1
                      ADD XCRR TO KRIG
      ************
                      ADD XCRR TO NRIG
                      WRITE RF-ST FROM TINT4 AFTER XCRR
      **** rel 4.1
                      ADD XCRR TO KRIG
      ************
                      ADD XCRR TO NRIG.
           PERFORM C00-STA-GRU THRU C99.
           MOVE ZERO TO TTGRUP.
       S011.
           IF KBL-TCON = TCON GO TO S012.
           PERFORM D00-STA-TOT THRU D99.
           IF CICLO = 1 AND KBL-TCON > 4
                      MOVE 2 TO CICLO
                      WRITE RF-ST FROM TINT5 AFTER XCRR
      **** rel 4.1
                      ADD XCRR TO KRIG
      ************
                      ADD XCRR TO NRIG
                      WRITE RF-ST FROM TINT6 AFTER XCRR
      **** rel 4.1
                      ADD XCRR TO KRIG
      ************
                      ADD XCRR TO NRIG.
           MOVE KBL-TCON TO TCON.
           PERFORM C00-STA-GRU THRU C99.
       S012.
           IF BIL-TRIGA = 'D' AND TOTGRU (TCON) = ZERO 
                                            GO TO S010.
           IF BIL-TRIGA = 'D' MOVE BIL-DESCR TO RVOCE
                     PERFORM A00-STA-RIGA THRU A99 
                     GO TO S010.
      **** rel 4.1a                                                     
      *    IF BIL-IMPOR = ZERO GO TO S010.                             
           IF BIL-IMPOR = ZERO AND BIL-TEST = ZERO GO TO S010.         
      ************                                                     
           MOVE BIL-DESCR TO RVOCE.
           IF CICLO = ZERO AND (TCON = 2 OR 4)
                      MOVE BIL-IMPOR TO RIMPO2
                      ADD BIL-IMPOR TO TTGRUP
                      PERFORM A00-STA-RIGA THRU A99
                      GO TO S010.
           IF CICLO = 1 OR ( CICLO = 2 AND FLDE = ZERO )
                        IF TCON = 2 OR 4
                                MOVE BIL-IMPOR TO RIMPO2
                                ADD BIL-IMPOR TO TTGRUP
                        ELSE       
                                MOVE BIL-IMPOR TO RIMPO3
                                ADD BIL-IMPOR  TO TTGRUP.
           PERFORM A00-STA-RIGA THRU A99.
           IF CICLO = 1 OR ( CICLO = 2 AND FLDE = ZERO ) GO TO S010.
           MOVE KBL-AZI TO KAL-AZI.
           MOVE KBL-TCON TO KAL-TCON.
           MOVE KBL-NRIGA TO KAL-NRIGA.
           MOVE ZERO TO KAL-PRG COLONN.
           START ANALLE KEY NOT < KEYAL INVALID GO TO S030.
       S020.
           READ ANALLE NEXT AT END GO TO S030.
           IF SF-ALL = '9D' OR '9A' OR '35' GO TO S020.
           IF KAL-AZI   > KBL-AZI   OR
              KAL-TCON  > KBL-TCON  OR
              KAL-NRIGA > KBL-NRIGA GO TO S030.
           IF ALL-TALL NOT = 'R' GO TO S025.
           IF ALL-CATEG = 1 MOVE ALL-DESCR TO RDECFM
                            MOVE ALL-TOTIM TO RIMPO1
                            PERFORM A00-STA-RIGA THRU A99
                            IF COLONN = ZERO MOVE ALL-CATEG TO COLONN
                                             MOVE ALL-TOTIM TO TOTCOL
                                             GO TO S020
                                        ELSE 
                                             ADD ALL-TOTIM TO TOTCOL
                                             GO TO S020.
           IF COLONN NOT = ZERO MOVE ALL '=' TO RSOTT1
                                MOVE TOTCOL TO RIMPO2
                                PERFORM A00-STA-RIGA THRU A99
                                MOVE ZERO TO COLONN TOTCOL.
           MOVE ALL-DESCR TO RDETT.
           MOVE ALL-TOTIM TO RIMPO2.
           PERFORM A00-STA-RIGA THRU A99.
           GO TO S020.
       S025.
           IF COLONN NOT = ZERO MOVE ALL '=' TO RSOTT1
                                MOVE TOTCOL TO RIMPO2
                                PERFORM A00-STA-RIGA THRU A99
                                MOVE ZERO TO COLONN TOTCOL.
      **** rel 4.1a                                                     
      *    IF ALL-TOTIM = ZERO GO TO S020.                             
           IF ALL-TOTIM = ZERO AND ALL-TEST = ZERO GO TO S020.         
      ************                                                     
           MOVE ALL-DESCR TO RDETT.
           IF ALL-TALL = 'S'
              IF ALL-FLAG = 'N'
                 MOVE ALL-TOTIM TO RIMPO2
                 PERFORM A00-STA-RIGA THRU A99
                 GO TO S020
                 ELSE MOVE '- DOCUMENTO -' TO RSDOC
                 PERFORM A00-STA-RIGA THRU A99
                 GO TO S026.
           IF ALL-DESCR NOT = SPACE
              PERFORM A00-STA-RIGA THRU A99.
       S026.
           IF ALL-TALL = 'C' OR 'F' PERFORM E00-STA-CLF THRU E99.
           IF ALL-TALL = 'M' PERFORM F00-STA-MAG THRU F99.
           IF ALL-TALL = 'S' PERFORM G00-STA-CON THRU G99.
           MOVE ALL '=' TO RSOTT1.
           MOVE ALL-TOTIM TO RIMPO2.
           PERFORM A00-STA-RIGA THRU A99.
           GO TO S020.
       S030.
           IF COLONN NOT = ZERO MOVE ALL '=' TO RSOTT1
                                MOVE TOTCOL TO RIMPO2
                                PERFORM A00-STA-RIGA THRU A99
                                MOVE ZERO TO COLONN TOTCOL.
           IF TCON = 2 OR 4 GO TO S040.
           MOVE ALL '=' TO RSOTT2.
           MOVE BIL-IMPOR TO RIMPO3.
           PERFORM A00-STA-RIGA THRU A99.
       S040.
           ADD BIL-IMPOR TO TTGRUP.
           GO TO S010.
       S050.
           PERFORM D00-STA-TOT THRU D99.
           IF CICLO = ZERO PERFORM I00-STA-BAR THRU I99
                      MOVE SPACE TO RF-ST RIGA
      **** rel 4.1
      *               WRITE RF-ST AFTER PAGE
      **** rel 4.1-1
      *               COMPUTE APAGE = NRGF - KRIG + 1
                      COMPUTE APAGE = NRGF - KRIG
      ************
                      MOVE ZERO TO KRIG
                      IF PS-FF = 1
                         WRITE RF-ST AFTER PAGE
                      ELSE
                         WRITE RF-ST AFTER APAGE
                      END-IF
      ************
      **** rel 4.3
      *               MOVE 1 TO CICLO
      *               GO TO STAM.
                      IF FUNZ = 2 MOVE 1 TO CICLO GO TO STAM
                      ELSE GO TO S090.
      ************
           IF CICLO = 1 MOVE 'MANCA PROF. E PERD.' TO MESS
                                               GO TO ERRIO.
      **** rel 4.1
           IF (NRIG + 7) > NRGL
              PERFORM I00-STA-BAR THRU I99
              MOVE SPACE TO RF-ST RIGA
      **** rel 4.1-1
      *       COMPUTE APAGE = NRGF - KRIG + 1
              COMPUTE APAGE = NRGF - KRIG
      ************
              MOVE ZERO TO KRIG
              IF PS-FF = 1
                 WRITE RF-ST AFTER PAGE
              ELSE
                 WRITE RF-ST AFTER APAGE
              END-IF
              PERFORM B00-STA-INT THRU B99
              MOVE 1 TO XCRR.
      ************
           MOVE 'IL PRESENTE BILANCIO RISPONDE A VERITA'' ' TO RIGA.
           WRITE RF-ST FROM RIGA AFTER XCRR.
      **** rel 4.1
           ADD XCRR TO KRIG.
      ************
           MOVE SPACE TO RIGA RF-ST.
           ADD XCRR TO NRIG.
           MOVE DATEL TO DATSTA.
           MOVE DATSTA TO RIGA.
           WRITE RF-ST FROM RIGA AFTER XCRR.
      **** rel 4.1
           ADD XCRR TO KRIG.
      ************
           MOVE SPACE TO RIGA RF-ST.
           ADD XCRR TO NRIG.
           IF NRIG NOT < NRGL GO TO S090.
           MOVE 5 TO XCRR.
           WRITE RF-ST AFTER XCRR.
      **** rel 4.1
           ADD XCRR TO KRIG.
      ************
           ADD XCRR TO NRIG.
           PERFORM I00-STA-BAR THRU I99.
           MOVE SPACE TO RF-ST RIGA.
      **** rel 4.1a                                                     
      **** rel 4.1
      *    WRITE RF-ST AFTER PAGE.                                     
      **** rel 4.1-1
      *    COMPUTE APAGE = NRGF - KRIG + 1.
           COMPUTE APAGE = NRGF - KRIG.
      ************
           MOVE ZERO TO KRIG.
           IF PS-FF = 1
              WRITE RF-ST AFTER PAGE
           ELSE
              WRITE RF-ST AFTER APAGE.
      ************
      ************                                                     
       S090.
      **** rel 4.5
           WRITE RF-ST FROM PS-RES AFTER ZERO.
      ************
           CLOSE STAMPA.
      **** rel 3.0
           MOVE ZERO TO PV-FUN.
           CALL 'vrpview' USING PARPV.
      ************
           GO TO LPINIZ.
      *--------------------------*
       ERRIO.
      **** rel 3.0
      *    COPY 'errio'.
           COPY '_errio'.
      ************
       FINE.
           CLOSE ANABIL ANALLE TABELL.
      **** rel 4.5
           CLOSE ANAAZI.
      ************
      **** rel 3.0
      *    COPY 'rfstack'.
           COPY '_rfstack'.
      ************
           DISPLAY SCRLOG.
           EXIT PROGRAM.
           STOP RUN.
      *--------------------------*
       A00-STA-RIGA.
      **** rel 4.1
      *    IF NRIG > NRGL WRITE RF-ST AFTER PAGE
      **** rel 4.1-1
      *    IF NRIG > NRGL COMPUTE APAGE = NRGF - KRIG + 1
           IF NRIG > NRGL COMPUTE APAGE = NRGF - KRIG
      ************
                          MOVE ZERO TO KRIG
                          IF PS-FF = 1
                             WRITE RF-ST AFTER PAGE
                          ELSE
                             WRITE RF-ST AFTER APAGE
                          END-IF
      ************
                          PERFORM B00-STA-INT THRU B99
                          MOVE 1 TO XCRR.
       A05.
           EXIT.
       A10.
           WRITE RF-ST FROM RIGA AFTER XCRR.
      **** rel 4.1
           ADD XCRR TO KRIG.
      ************
           ADD XCRR TO NRIG.
           MOVE SPACE TO RIGA RF-ST.
       A99.
           EXIT.
      *--------------------------*
       B00-STA-INT.
           MOVE ALL '-' TO RF-ST.
           WRITE RF-ST AFTER ZERO.
           MOVE 1 TO NRIG XCRR.
           MOVE SPACE TO RF-ST.
           WRITE RF-ST FROM RTTS AFTER XCRR.
      **** rel 4.1
           ADD XCRR TO KRIG.
      ************
           ADD XCRR TO NRIG.
           MOVE ALL '-' TO RF-ST.
           WRITE RF-ST AFTER XCRR.
      **** rel 4.1
           ADD XCRR TO KRIG.
      ************
           MOVE SPACE TO RF-ST.
       B99.
           EXIT.
      *-----------------------------*
       C00-STA-GRU.
           PERFORM A00-STA-RIGA THRU A05.
           MOVE DESAT (TCON) TO RGRUPP.
           WRITE RF-ST FROM RIGA AFTER XCRR.
      **** rel 4.1
           ADD XCRR TO KRIG.
      ************
           ADD XCRR TO NRIG.
           MOVE SPACE TO RF-ST RIGA.
           MOVE SOTTY (TCON) TO RGRUPP.
           WRITE RF-ST FROM RIGA AFTER XCRR.
      **** rel 4.1
           ADD XCRR TO KRIG.
      ************
           MOVE SPACE TO RF-ST RIGA
           ADD XCRR TO NRIG.
       C99.
           EXIT.
      *-----------------------------*
       D00-STA-TOT.
           IF TCON = 2 OR 4 MOVE ALL '=' TO RSOTT2
           ELSE
           MOVE ALL '-' TO RSOTT3.
           PERFORM A10 THRU A99.
           MOVE DESTO (TCON) TO RGRUPP.
           MOVE TTGRUP TO RIMPO3.
           PERFORM A00-STA-RIGA THRU A99.
           IF TCON > 1 GO TO D20.
           MOVE TTGRUP TO SALDO.
           IF DFPAT NOT < ZERO GO TO D10.
           MOVE 'PERDITA D'' ESERCIZIO' TO RGRUPP.
           MULTIPLY -1 BY DFPAT GIVING RIMPO3.
           PERFORM A00-STA-RIGA THRU A99.
           COMPUTE SALDO = SALDO - DFPAT.
           MOVE ALL '-' TO RSOTT3.
           PERFORM A10 THRU A99.
           MOVE SALDO TO RIMPO3.
           IF KBL-TCON = 2 AND TOTGRU (KBL-TCON) > ZERO
                          PERFORM A00-STA-RIGA THRU A99
                          GO TO D90
                      ELSE MOVE 'T O T A L E' TO RGRUPP
                          PERFORM A00-STA-RIGA THRU A99
                          MOVE ALL '=' TO RSOTT3
                          MOVE '===========' TO RGRUPP
                          PERFORM A10 THRU A99
                          MOVE ZERO TO SALDO GO TO D90.
       D10.
           IF KBL-TCON = 2 AND TOTGRU (KBL-TCON) > ZERO GO TO D90
                                    ELSE MOVE ALL '=' TO RSOTT3
                                         MOVE SOTOY (TCON) TO RGRUPP
                                    PERFORM A10 THRU A99
                                    GO TO D90.
       D20.
           IF TCON > 2 GO TO D30.
           COMPUTE SALDO = SALDO + TTGRUP.
           MOVE ALL '-' TO RSOTT3.
           PERFORM A10 THRU A99.
           MOVE SALDO TO RIMPO3.
           MOVE 'T O T A L E ' TO RGRUPP.
           PERFORM A00-STA-RIGA THRU A99.
           MOVE ALL '=' TO RSOTT3.
           MOVE '===========' TO RGRUPP.
           PERFORM A10 THRU A99.
           MOVE ZERO TO SALDO.
           GO TO D90.
       D30.
           IF TCON > 3 GO TO D60.
           MOVE TTGRUP TO SALDO.
           IF DFPAT < ZERO GO TO D40.
           MOVE 'UTILE D'' ESERCIZIO' TO RGRUPP.
           MOVE DFPAT TO RIMPO3.
           PERFORM A00-STA-RIGA THRU A99.
           COMPUTE SALDO = SALDO + DFPAT.
           MOVE ALL '-' TO RSOTT3.
           PERFORM A10 THRU A99.
           MOVE SALDO TO RIMPO3.
           IF KBL-TCON = 4 AND TOTGRU (KBL-TCON) > ZERO
                          PERFORM A00-STA-RIGA THRU A99
                          GO TO D90
                      ELSE MOVE 'T O T A L E' TO RGRUPP
                          PERFORM A00-STA-RIGA THRU A99
                          MOVE ALL '=' TO RSOTT3
                          MOVE '===========' TO RGRUPP
                          PERFORM A10 THRU A99
                          MOVE ZERO TO SALDO GO TO D90.
       D40.
           IF KBL-TCON = 4 AND TOTGRU (KBL-TCON) > ZERO GO TO D90
                                    ELSE MOVE ALL '=' TO RSOTT3
                                         MOVE SOTOY (TCON) TO RGRUPP
                                    PERFORM A10 THRU A99
                                    GO TO D90.
       D60.
           IF TCON > 4 GO TO D70.
           COMPUTE SALDO = SALDO + TTGRUP.
           MOVE ALL '-' TO RSOTT3.
           PERFORM A10 THRU A99.
           MOVE SALDO TO RIMPO3.
           MOVE 'T O T A L E ' TO RGRUPP.
           PERFORM A00-STA-RIGA THRU A99.
           MOVE ALL '=' TO RSOTT3.
           MOVE '===========' TO RGRUPP.
           PERFORM A10 THRU A99.
           MOVE ZERO TO SALDO.
           GO TO D90.
       D70.
           IF TCON > 5 GO TO D80.
           MOVE TTGRUP TO SALDO.
           IF DFECO NOT > ZERO MOVE SOTOY (TCON) TO RGRUPP
                                                 GO TO D75.
           MOVE 'PERDITA D'' ESERCIZIO' TO RGRUPP.
           MOVE DFECO TO RIMPO3.
           PERFORM A00-STA-RIGA THRU A99.
           COMPUTE SALDO = SALDO + DFECO.
           MOVE ALL '-' TO RSOTT3.
           PERFORM A10 THRU A99.
           MOVE SALDO TO RIMPO3.
           MOVE 'T O T A L E ' TO RGRUPP.
           PERFORM A00-STA-RIGA THRU A99.
           MOVE  '===========' TO RGRUPP.
       D75.
           MOVE ALL '=' TO RSOTT3. 
           PERFORM A10 THRU A99.
           GO TO D90.
       D80.
           MOVE TTGRUP TO SALDO.
           IF DFECO > ZERO MOVE SOTOY (TCON) TO RGRUPP GO TO D85.
           MOVE 'UTILE D'' ESERCIZIO' TO RGRUPP.
           MULTIPLY -1 BY DFECO GIVING RIMPO3.
           PERFORM A00-STA-RIGA THRU A99.
           COMPUTE SALDO = SALDO - DFECO.
           MOVE ALL '-' TO RSOTT3.
           PERFORM A10 THRU A99.
           MOVE SALDO TO RIMPO3.
           MOVE 'T O T A L E ' TO RGRUPP.
           PERFORM A00-STA-RIGA THRU A99.
           MOVE '===========' TO RGRUPP.
       D85.
           MOVE ALL '=' TO RSOTT3.
           PERFORM A10 THRU A99.
       D90.
           MOVE ZERO TO TTGRUP.
       D99.
           EXIT.
      *-----------------------------*
       E00-STA-CLF.
           CLOSE ANACOL MOVMOL MOVMXX.
           OPEN INPUT ANACFX WDSLAV.
           IF ALL-TALL = 'C' MOVE MCLI TO KLV-TIP
                        ELSE MOVE MFOR TO KLV-TIP.
           MOVE ALL-CATEG TO KLV-CAT.
           MOVE ZERO TO KLV-COD.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO E90.
       E10.
           READ WDSLAV NEXT AT END GO TO E90.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO E10.
           IF ALL-TALL = 'C' AND KLV-TIP NOT = MCLI GO TO E90.
           IF ALL-TALL = 'F' AND KLV-TIP NOT = MFOR GO TO E90.
           IF KLV-CAT NOT = ALL-CATEG GO TO E90.
           MOVE KAL-AZI TO KCX-AZI.
           MOVE KLV-COD TO KCX-COD.
           READ ANACFX INTO REKCLF INVALID
                       MOVE ALL '*' TO CLF-RGSOC CLF-CITTA.
           IF SF-CFX = '9D' OR '9A' OR '35' MOVE RF-CFX TO REKCLF.
           MOVE CLF-RGSOC TO RDECFM.
      **** rel 4.7
           IF CLF-RGSOC2 NOT = SPACE
              PERFORM A00-STA-RIGA THRU A99
              MOVE CLF-RGSOC2 TO RDECFM.
      ************
           MOVE CLF-CITTA TO RCITTA.
           MOVE LAV-IMP TO RIMPO1.
           PERFORM A00-STA-RIGA THRU A99.
           GO TO E10.
       E90.
           CLOSE ANACFX WDSLAV.
           OPEN INPUT ANACOL MOVMOL MOVMXX.
       E99.
           EXIT.
      *-----------------------------*
       F00-STA-MAG.
           CLOSE ANACOL MOVMOL MOVMXX.
           OPEN INPUT MAGART WDSLA2.
           MOVE ALL-CATEG TO KL2-CAT.
           MOVE SPACE TO KL2-ART.
           MOVE ZERO TO KL2-ANN.
           MOVE SPACE TO ART1.
           START WDSLA2 KEY NOT < KEYL2 INVALID GO TO F90.
       F10.
           READ WDSLA2 NEXT AT END GO TO F90.
           IF SF-LA2 = '9D' OR '9A' OR '35' GO TO F10.
           IF KL2-CAT NOT = ALL-CATEG GO TO F90.
           IF KL2-ART = ART1 GO TO F20.
           MOVE KL2-ART TO ART1.
           MOVE KAZ-COD TO KMA-AZI.
           MOVE KL2-ART TO KMA-ART.
           READ MAGART INTO REKART INVALID
                            MOVE ALL '*' TO ART-DESCR ART-UNMIS
      **** rel 4.0
      *                     MOVE ZERO TO ART-TPRZ
                            MOVE ZERO TO ART-FSC
      ************
                            MOVE ZERO TO ART-TQUAN.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           MOVE ART-DESCR TO RDECFM.
           MOVE ART-UNMIS TO RUNM.
       F20.
      **** rel 4.9
      *    MOVE LA2-QTA TO CLAV RQUA0.
      *    IF ART-TQUAN = 1 MOVE CLV8 TO RQUA1.
      *    IF ART-TQUAN = 2 MOVE CLV7 TO RQUA2.
           MOVE LA2-QTA TO RQUA0.
           IF ART-TQUAN = 1 MOVE LA2-QTA TO RQUA1.
           IF ART-TQUAN = 2 MOVE LA2-QTA TO RQUA2.
      ************
           MOVE LA2-IMP TO RIMPO1.
           IF ALL-TIPS NOT = 'D' GO TO F30.
           MOVE KL2-ANN TO RANN.
           MOVE 'x' TO RSEGN.
      **** rel 4.0
      *    MOVE LA2-PRZ TO RPREZ.
      *    IF ART-TPRZ = 1 MOVE LA2-PRZ TO RPRE2.
           MOVE ART-AZI  TO OP-AZI.
           MOVE ZERO     TO OP-VALUT.
           MOVE LA2-PRZ  TO OP-PREZZO.
           MOVE LA2-FSC  TO OP-FSC.
           CALL 'routprz' USING PAROP OP-GUN.
           MOVE OP-PREZZO  TO RPREZ.
           IF OP-NDEC = 2 MOVE OP-PREZZO  TO RPRE2.
           IF OP-NDEC = 3 MOVE OP-PREZZO  TO RPRE3.
      **** rel 5.0
           IF OP-NDEC = 4 MOVE OP-PREZZO  TO RPRE4.
           IF OP-NDEC = 5 MOVE OP-PREZZO  TO RPRE5.
           IF OP-NDEC = 6 MOVE OP-PREZZO  TO RPRE6.
      ************
      ************
       F30.
           PERFORM A00-STA-RIGA THRU A99.
           GO TO F10.
       F90.
           CLOSE MAGART WDSLA2.
           OPEN INPUT ANACOL MOVMOL MOVMXX.
       F99.
           EXIT.
      *----------------------------*
       G00-STA-CON.
           MOVE ZERO TO FLAPE.
       G05.
           OPEN INPUT TABELL.
           OPEN INPUT ANACFX.
           CLOSE MOVMOL.
           MOVE LOW-VALUE TO KEYMX KEYML.
           MOVE KAL-AZI TO KMX-AZI KML-AZI.
           MOVE ALL-CONTO TO KMX-CON KML-CON.
           MOVE INIESK TO KMX-DAT.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO G20.
       G10.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO G20.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO G10.
           IF KMX-AZI NOT = KAL-AZI OR
              KMX-CON NOT = ALL-CONTO GO TO G20.
           PERFORM H00-STA-MOV THRU H99.
           GO TO G10.
       G20.
           CLOSE MOVMXX.
           OPEN INPUT MOVMOL.
           START MOVMOL KEY NOT < KEYML INVALID GO TO G90.
       G30.
           READ MOVMOL NEXT INTO REKMOV AT END GO TO G90.
           IF SF-MOL = '9D' OR '9A' OR '35' GO TO G30.
           IF KML-AZI NOT = KAL-AZI OR
              KML-CON NOT = ALL-CONTO GO TO G90.
           PERFORM H00-STA-MOV THRU H99.
           GO TO G30.
       G90.
           CLOSE TABELL.
           CLOSE ANACFX.
           OPEN INPUT MOVMXX.
           IF FLAPE = ZERO MOVE 1 TO FLAPE GO TO G05.
       G99.
           EXIT.
      *--------------------------*
       H00-STA-MOV.
           IF MOV-CAUS = CDSOC OR
              MOV-CAUS = CASOC GO TO H99.
           IF FLAPE = 1 AND ( MOV-CAUS = CDSOA OR CASOA )
                                               GO TO H99.
           IF FLAPE = ZERO AND NOT ( MOV-CAUS = CDSOA OR CASOA )
                                                      GO TO H99.
           MOVE ZERO TO K.
           MOVE 2 TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ALL '*' TO TAB-DESCR. 
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 4.7
           IF TAB-DESCR = SPACE GO TO EX0.
           MOVE TAB-DESCR TO CONCOUT.
      *    MOVE TAB-DESCR TO WDESK.
      *    IF WDESK = SPACE MOVE ZERO TO K
      *                          GO TO EX0.
      *    MOVE 140 TO K.
      *LK0.
      *    SUBTRACT 1 FROM K.
      *    IF K < 1 GO TO EX0.
      *    IF WDSK1 (K) = SPACE GO TO LK0.
      *    ADD 1 TO K.
      ************
           IF T02-TIPRG NOT > 1 GO TO EX1.
       EX0.
           IF MOV-PART = ZERO OR
              MOV-PART = MOV-CON OR
              MOV-PART = 9999999 GO TO EX1.
           MOVE KAL-AZI TO KCX-AZI.
           MOVE MOV-PART TO KCX-COD.
           READ ANACFX INTO REKCLF INVALID MOVE '*****' TO CLF-RGSOC.
           IF SF-CFX = '9D' OR '9A' OR '35' MOVE RF-CFX TO REKCLF.
      **** rel 4.7
           MOVE CLF-RGSOC TO CONCAIN.
           PERFORM CONCATENA.
           MOVE CLF-RGSOC2 TO CONCAIN.
           PERFORM CONCATENA.
      *    MOVE CLF-RGSOC TO ALA1.
      *    MOVE 37 TO J.
      *LK1.
      *    SUBTRACT 1 FROM J.
      *    IF J < 1 GO TO EX1.
      *    IF ELX (J) = SPACE GO TO LK1.
      *    MOVE ZERO TO CTRIG.  
      *    COMPUTE CTRIG = K + J.
      *    IF CTRIG > 53 MOVE J TO N GO TO LK1-10.
      *    MOVE ZERO TO N.
      *LK1-00.
      *    ADD 1 TO K N.
      *    IF N > J GO TO EX1.
      *    IF CTRIG NOT > 53 GO TO LK1-20.
      *LK1-10.
      *    SUBTRACT 1 FROM N.
      *    IF N < 1 MOVE 54 TO K MOVE ZERO TO N CTRIG
      *                                  GO TO LK1-00.
      *    IF ELX (N) NOT = SPACE GO TO LK1-10.
      *    COMPUTE CTRIG = K + N.
      *    IF CTRIG > 53 GO TO LK1-10.
      *    MOVE N TO CTRIG.
      *    MOVE ZERO TO N.
      *LK1-15.
      *    ADD 1 TO K N.
      *    IF N NOT > CTRIG MOVE ELX (N) TO WDSK1 (K)
      *                                  GO TO LK1-15.
      *    MOVE ZERO TO CTRIG.
      *    MOVE 55 TO K.
      *LK1-20.
      *    MOVE ELX (N) TO WDSK1 (K).
      *    GO TO LK1-00.
      ************
       EX1.
      **** rel 4.7
           IF MOV-FLAG NOT = ZERO
              MOVE MOV-DSAGG TO CONCAIN
              PERFORM CONCATENA.
           PERFORM ALLINEA.
      *    IF MOV-FLAG = ZERO OR MOV-DSAGG = SPACE
      *                                  GO TO EX3.
      *    MOVE MOV-DSAGG TO ALA1.
      *    MOVE 37 TO J.
      *LK2.
      *    SUBTRACT 1 FROM J.
      *    IF J < 1 GO TO EX3.
      *    IF ELX (J) = SPACE GO TO LK2.
      *    MOVE ZERO TO CTRIG.  
      *    IF K > 54 MOVE ZERO TO N GO TO LK2-00.
      *    COMPUTE CTRIG = K + J.
      *    IF CTRIG > 53 MOVE J TO N GO TO LK2-10.
      *    MOVE ZERO TO N.
      *LK2-00.
      *    ADD 1 TO K N.
      *    IF K > 108 GO TO EX3.
      *    IF N > J GO TO EX3.
      *    IF CTRIG NOT > 53 GO TO LK2-20.
      *LK2-10.
      *    SUBTRACT 1 FROM N.
      *    IF N < 1 MOVE 54 TO K
      *             MOVE ZERO TO N CTRIG
      *             GO TO LK2-00.
      *    IF ELX (N) NOT = SPACE GO TO LK2-10.
      *    COMPUTE CTRIG = K + N.
      *    IF CTRIG > 53 GO TO LK2-10.
      *    MOVE N TO CTRIG.
      *    MOVE ZERO TO N.
      *LK2-15.
      *    ADD 1 TO K N.
      *    IF N NOT > CTRIG MOVE ELX (N) TO WDSK1 (K)
      *                                  GO TO LK2-15.
      *    MOVE ZERO TO CTRIG.
      *    MOVE 55 TO K.
      *LK2-20.
      *    MOVE ELX (N) TO WDSK1 (K).
      *    GO TO LK2-00.
      *EX3.
      ************
           MOVE WDSK31 TO ERG.
           IF WDSK32 = SPACE GO TO EX4.
           PERFORM A00-STA-RIGA THRU A99.
           MOVE WDSK32 TO ERG.
           IF WDSK33 = SPACE GO TO EX4.
           PERFORM A00-STA-RIGA THRU A99.
           MOVE WDSK33 TO ERG.
       EX4.
           IF MOV-DTDOC > ZERO
              MOVE MOV-DTDOC TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GMMMA TO RDATA.           
           IF MOV-NPRGI > ZERO
              MOVE MOV-NPRGI TO RNDOC
              ELSE
              IF MOV-NDOC > ZERO
                 MOVE MOV-NDOC TO RNDOC.
           IF KAL-TCON < 3 AND MOV-D-A = 'A'
                           MULTIPLY -1 BY MOV-IMPO.
           IF KAL-TCON > 2 AND MOV-D-A = 'D'
                           MULTIPLY -1 BY MOV-IMPO.
           MOVE MOV-IMPO TO RIMPO1.
           PERFORM A00-STA-RIGA THRU A99.
       H99.
           EXIT.
      *-------------------------*
       I00-STA-BAR.
           IF NRIG NOT < NRGF GO TO I99.
           MOVE ALL '=' TO RIGA.
           WRITE RF-ST FROM RIGA AFTER XCRR.
      **** rel 4.1
           ADD XCRR TO KRIG.
      ************
           MOVE SPACE TO RF-ST RIGA.
           ADD XCRR TO NRIG.
           IF NRIG NOT < NRGL GO TO I99.
           COMPUTE N = NRGL - NRIG.
           IF N > 50 MOVE 50 TO N.
           COMPUTE N = N / 2.
           COMPUTE K = 26 - N.
           COMPUTE N = N + 25.
       I10.
           SUBTRACT 1 FROM N.
           IF K > N GO TO I20.
           MOVE '/' TO RX (N) RY (N).
           WRITE RF-ST FROM RIGA AFTER 1.
      **** rel 4.1
           ADD 1 TO KRIG.
      ************
           MOVE SPACE TO RIGA RF-ST.
           GO TO I10.
       I20.
           MOVE ALL '=' TO RIGA.
           WRITE RF-ST FROM RIGA AFTER 1.
      **** rel 4.1
           ADD 1 TO KRIG.
      ************
           MOVE SPACE TO RIGA RF-ST.
       I99.
           EXIT.
      *-------------------------*
       U00-LIFO.
           MOVE SPACE TO KMA-ART.
           DISPLAY SCRMAG.
           MOVE ZERO TO TOTQT TOTVL.
           MOVE ZERO TO ALL-TOTIM.
           CLOSE ANACOL MOVMOL MOVMXX.
           OPEN I-O WDSLA2.
           OPEN INPUT MAGLIF MAGART.
           MOVE LOW-VALUE TO KEYLF.
           MOVE KAL-AZI TO KLF-AZI.
           MOVE SPACE TO ART1.
           START MAGLIF KEY NOT < KEYLF INVALID GO TO U90.
       U10.
           READ MAGLIF NEXT AT END GO TO U90.
           IF SF-LIF = '9D' OR '9A' OR '35' GO TO U10.
           IF KLF-AZI NOT = KAZ-COD GO TO U90.
           IF KLF-ART = ART1 AND ALL-TIPS NOT = 'D'
                                         GO TO U30.
           MOVE KLF-AZI TO KMA-AZI.
           MOVE KLF-ART TO KMA-ART.
           READ MAGART INTO REKART INVALID GO TO U10.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           IF ALL-CATEG = ZERO GO TO U15.
           IF ALL-CATEG = 1 AND ART-TPART < 2 GO TO U15.
           IF ART-TPART NOT = ALL-CATEG GO TO U10.
       U15.
           IF ALL-TIPS = 'D' GO TO U20.
           IF ART1 = SPACE GO TO U20.
           MOVE TOTQT TO LA2-QTA.
           MOVE TOTVL TO LA2-IMP.
           WRITE RF-LA2 INVALID GO TO U20.
           ADD  TOTVL TO ALL-TOTIM.
       U20.
           DISPLAY SCDMAG.
           MOVE ZERO TO TOTQT TOTVL.
           MOVE ALL-CATEG TO KL2-CAT.
           MOVE KLF-ART TO ART1 KL2-ART.
           MOVE ZERO TO KL2-ANN.
           IF ALL-TIPS = 'D' MOVE KLF-ANN TO KL2-ANN.
       U30.
      **** rel 4.9
      *    MOVE LIF-VAL TO CLAV.
      *    MOVE LIF-QTA TO QTAL.
      *    COMPUTE COMA = QTAL * CLAV.
      *    MOVE COMA TO TOT.
      *    IF ART-TPRZ = 0 AND ART-TQUAN = 1 MOVE COMAV1 TO TOT.
      *    IF ART-TPRZ = 0 AND ART-TQUAN = 2 MOVE COMAV2 TO TOT.
      *    IF ART-TPRZ = 1 AND ART-TQUAN = 0 MOVE COMAV2 TO TOT.
      *    IF ART-TPRZ = 1 AND ART-TQUAN = 1 MOVE COMAV3 TO TOT.
      *    IF ART-TPRZ = 1 AND ART-TQUAN = 2 MOVE COMAV4 TO TOT.
           COMPUTE RD-NUM = LIF-VAL * LIF-QTA.
      **** rel 4.0
      *    CALL 'rround' USING NNN-S PARRD DEC-0.
           CALL 'vrround' USING NNN-S PARRD DEC-2.
      ************
           MOVE RD-NUM TO TOT.
           MOVE LIF-QTA TO QTAL.
      ************
           MOVE LIF-VAL TO LA2-PRZ.
      **** rel 4.0
           MOVE LIF-FSC TO LA2-FSC.
      ************
           IF ALL-TIPS NOT = 'D' GO TO U40.
           MOVE QTAL  TO LA2-QTA.
           MOVE TOT   TO LA2-IMP.
           WRITE RF-LA2 INVALID MOVE 'WR LA2' TO MESS
                                          GO TO ERRIO.
           ADD  TOT TO ALL-TOTIM.
           GO TO U10.
       U40.
           COMPUTE TOTQT = TOTQT + QTAL.
           COMPUTE TOTVL = TOTVL + TOT.
           GO TO U10.
       U90.
           IF ALL-TIPS = 'D' GO TO U95.
           IF TOTQT = ZERO GO TO U95.
           MOVE TOTQT TO LA2-QTA.
           MOVE TOTVL TO LA2-IMP.
           WRITE RF-LA2 INVALID GO TO U95.
           ADD  TOTVL TO ALL-TOTIM.
       U95.
           CLOSE WDSLA2 MAGLIF MAGART.
           OPEN INPUT ANACOL MOVMOL MOVMXX.
       U99.
           EXIT. 
      *-------------------------*
       V00-CLIFO.
           MOVE ZERO TO CLF-COD.
           MOVE ZERO TO ALL-TOTIM.
           CLOSE ANACOL MOVMOL MOVMXX.
           OPEN I-O WDSLAV.
           OPEN INPUT ANACFX MOVSOL MOVSXX.
           MOVE KAZ-COD TO CLF-AZI.
           IF ALL-TALL = 'C' MOVE MCLI TO CLF-MS
                             DISPLAY SCRCLI
                        ELSE MOVE MFOR TO CLF-MS
                             DISPLAY SCRFOR.
           MOVE ZERO TO CLF-CD.
           MOVE CLF-KEYID TO KEYCX.
           START ANACFX KEY NOT < KEYCX INVALID GO TO V90.
       V10.
           READ ANACFX NEXT INTO REKCLF AT END GO TO V90.
           IF SF-CFX = '9D' OR '9A' OR '35' GO TO V10.
           IF KCX-AZI > KAL-AZI GO TO V90.
           IF ALL-TALL = 'C' AND
              CLF-MS > MCLI GO TO V90.
           IF ALL-TALL = 'F' AND
              CLF-MS > MFOR GO TO V90.
           IF ALL-CATEG = ZERO GO TO V15.
           IF ALL-CATEG = 1 AND CLF-CATCON < 2 GO TO V15.
           IF CLF-CATCON NOT = ALL-CATEG GO TO V10.
       V15.
           IF ALL-TALL = 'C' DISPLAY SCDCLI
                        ELSE DISPLAY SCDFOR.
           COMPUTE SALDO = CLF-SESP + CLF-SE-D - CLF-SE-A.
           MOVE LOW-VALUE TO KEYSL KEYSX.
           MOVE KAZ-COD TO KSL-AZI KSX-AZI.
           MOVE KCX-COD TO KSL-CON KSX-CON.
           MOVE INIESK  TO KSL-DAT KSX-DAT.
           START MOVSXX KEY NOT < KEYSX INVALID GO TO V50.
       V20.
           READ MOVSXX NEXT INTO REKMOV AT END GO TO V50.
           IF SF-MSX = '9D' OR '9A' OR '35' GO TO V20.
           IF KSX-AZI > KAZ-COD OR
              KSX-CON > KCX-COD GO TO V50.
           IF NOT ( MOV-CAUS = CDCLC OR
                    MOV-CAUS = CACLC OR
                    MOV-CAUS = CDFOC OR
                    MOV-CAUS = CAFOC ) GO TO V20.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO SALDO
           ELSE IF MOV-D-A = 'D' SUBTRACT MOV-IMPO FROM SALDO.
           GO TO V20.
       V50.
           START MOVSOL KEY NOT < KEYSL INVALID GO TO V80.
       V60.
           READ MOVSOL NEXT INTO REKMOV AT END GO TO V80.
           IF SF-MSL = '9D' OR '9A' OR '35' GO TO V60.
           IF KSL-AZI > KAZ-COD OR
              KSL-CON > KCX-COD GO TO V80.
           IF NOT ( MOV-CAUS = CDCLC OR
                    MOV-CAUS = CACLC OR
                    MOV-CAUS = CDFOC OR
                    MOV-CAUS = CAFOC ) GO TO V60.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO SALDO
           ELSE IF MOV-D-A = 'D' SUBTRACT MOV-IMPO FROM SALDO.
           GO TO V60.
       V80.
           MOVE CLF-MS TO KLV-TIP.
           MOVE ALL-CATEG TO KLV-CAT.
           MOVE KCX-COD TO KLV-COD.
           IF CLF-MS = MFOR MULTIPLY -1 BY SALDO.
           MOVE SALDO TO LAV-IMP.
           IF LAV-IMP = ZERO GO TO V10.
           WRITE RF-LAV INVALID GO TO V10.
           ADD SALDO TO ALL-TOTIM.
           GO TO V10.
       V90.
           CLOSE ANACFX MOVSOL MOVSXX WDSLAV.
           OPEN INPUT ANACOL MOVMOL MOVMXX.
       V99.
           EXIT.
      *-------------------------*
       Z00-CONTI.
           IF ALL-CONTO = COUTI OR COPER GO TO Z99.
           MOVE KAZ-COD TO KCL-AZI.
           MOVE ALL-CONTO TO KCL-COD.
           DISPLAY SCRCON.
           READ ANACOL INTO REKCON INVALID
      **** rel 4.5
      *                MOVE 'RD ANACOL' TO MESS GO TO ERRIO.
                       PERFORM INVK-COL GO TO ERRIO.
      ************
           IF SF-COL = '9D' OR '9A' OR '35' MOVE RF-COL TO REKCON.
           IF ALL-FLAG = 'S' GO TO Z10.
           COMPUTE ALL-TOTIM = CON-SESP + CON-SE-D - CON-SE-A.
       Z10.
           MOVE LOW-VALUE TO KEYML.
           MOVE KCL-AZI   TO KML-AZI.
           MOVE KCL-COD   TO KML-CON.
           MOVE INIESK    TO KML-DAT.
           START MOVMOL KEY NOT < KEYML INVALID GO TO Z30.
       Z20.
           READ MOVMOL NEXT INTO REKMOV AT END GO TO Z30.
           IF SF-MOL = '9D' OR '9A' OR '35' GO TO Z20.
           IF KML-AZI > KCL-AZI GO TO Z30.
           IF KML-CON > KCL-COD GO TO Z30.
           IF ALL-FLAG = 'S'
      **** rel 4.1a                                                     
              MOVE 1 TO TESTA                                          
      ************                                                     
              IF ( MOV-CAUS = T20-CDSOC OR 
                   MOV-CAUS = T20-CASOC ) GO TO Z20
              ELSE GO TO Z25.
           IF NOT ( MOV-CAUS = T20-CDSOC OR 
                    MOV-CAUS = T20-CASOC ) GO TO Z20.
       Z25.
           IF ALL-FLAG = 'N'
              IF MOV-D-A = 'A' ADD MOV-IMPO TO ALL-TOTIM 
                   ELSE SUBTRACT MOV-IMPO FROM ALL-TOTIM.
           IF ALL-FLAG = 'S'
              IF MOV-D-A = 'D' ADD MOV-IMPO TO ALL-TOTIM 
                   ELSE SUBTRACT MOV-IMPO FROM ALL-TOTIM.
           GO TO Z20.
       Z30.
           MOVE LOW-VALUE TO KEYMX.
           MOVE KCL-AZI   TO KMX-AZI.
           MOVE KCL-COD   TO KMX-CON.
           MOVE INIESK    TO KMX-DAT.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO Z90.
       Z40.
           READ  MOVMXX NEXT INTO REKMOV AT END GO TO Z90.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO Z40.
           IF KMX-AZI > KCL-AZI GO TO Z90.
           IF KMX-CON > KCL-COD GO TO Z90.
           IF ALL-FLAG = 'S'
      **** rel 4.1a                                                     
              MOVE 1 TO TESTA                                          
      ************                                                     
              IF ( MOV-CAUS = T20-CDSOC OR 
                   MOV-CAUS = T20-CASOC ) GO TO Z40
              ELSE GO TO Z45.
           IF NOT ( MOV-CAUS = T20-CDSOC OR 
                    MOV-CAUS = T20-CASOC ) GO TO Z40.
       Z45.
           IF ALL-FLAG = 'N'
              IF MOV-D-A = 'A' ADD MOV-IMPO TO ALL-TOTIM 
                   ELSE SUBTRACT MOV-IMPO FROM ALL-TOTIM.
           IF ALL-FLAG = 'S'
              IF MOV-D-A = 'D' ADD MOV-IMPO TO ALL-TOTIM 
                   ELSE SUBTRACT MOV-IMPO FROM ALL-TOTIM.
           GO TO Z40.
       Z90.
           IF KAL-TCON < 3 AND ALL-TOTIM < ZERO
                           MOVE ZERO TO ALL-TOTIM
      **** rel 4.1a                                                     
                           MOVE ZERO TO TESTA                          
      ************                                                     
                           GO TO Z99.
           IF KAL-TCON < 3 AND > 5 GO TO Z99.
           IF KAL-TCON > 2 AND < 5 AND ALL-TOTIM > ZERO
                                 MOVE ZERO TO ALL-TOTIM
      **** rel 4.1a                                                     
                           MOVE ZERO TO TESTA                          
      ************                                                     
                                 GO TO Z99.
           IF KAL-TCON > 2 AND < 6 MULTIPLY -1 BY ALL-TOTIM.
       Z99.      
            EXIT.
      **** rel 4.7
      * ---------------- *
       CONCATENA.
      **** rel 5.0
      *    PERFORM VARYING KONCA FROM 186 BY -1
           PERFORM VARYING KONCA FROM 162 BY -1
      ************
                   UNTIL CONCOUT(KONCA:1) NOT = SPACE OR KONCA = ZERO
                   CONTINUE.
           IF KONCA > ZERO ADD 1 TO KONCA.
           ADD 1 TO KONCA.
      **** rel 5.0
      *    IF KONCA NOT > 186 MOVE CONCAIN TO CONCOUT(KONCA:).
           IF KONCA NOT > 162 MOVE CONCAIN TO CONCOUT(KONCA:).
      ************
      * ---------------- *
       ALLINEA.
           MOVE 54 TO POSIZ.
           PERFORM SPEZZA THRU EX-SPEZZA.

           MOVE 108 TO POSIZ.
           PERFORM SPEZZA THRU EX-SPEZZA.
      * ---------------- *
       SPEZZA.
           IF CONCOUT(POSIZ + 1:) = SPACE GO TO EX-SPEZZA.
           IF CONCOUT(POSIZ + 1:1) NOT = SPACE GO TO SPEZZA-10.
           ADD 1 TO POSIZ.
           PERFORM VARYING KONCA FROM POSIZ BY 1
                   UNTIL CONCOUT(KONCA:1) NOT = SPACE
                   CONTINUE.
           SUBTRACT 1 FROM POSIZ.
           MOVE CONCOUT(1:POSIZ) TO COMCOUT.
           MOVE CONCOUT(KONCA:) TO COMCOUT(POSIZ + 1:).
           MOVE COMCOUT TO CONCOUT.
           GO TO EX-SPEZZA.
       SPEZZA-10.
           IF CONCOUT(POSIZ:1) = SPACE GO TO EX-SPEZZA.
           PERFORM VARYING KONCA FROM POSIZ BY -1
                   UNTIL CONCOUT(KONCA:1) = SPACE OR KONCA = ZERO
                   CONTINUE.
           IF KONCA = ZERO GO TO EX-SPEZZA.
           MOVE CONCOUT(1:KONCA) TO COMCOUT.
           MOVE CONCOUT(KONCA + 1:) TO COMCOUT(POSIZ + 1:).
           MOVE COMCOUT TO CONCOUT.
       EX-SPEZZA.
           EXIT.
      * ---------------- *
      ************
      **** rel 3.0
      *    COPY 'errmes'.
           COPY '_errmes'.
      ************
      **** rel 4.5
           COPY 'griazier'.
           COPY 'gribiler'.
           COPY 'grialler'.
           COPY 'gricoler'.
           COPY 'gricfxer'.
           COPY 'grimvxer'.
           COPY 'grimoler'.
           COPY 'grimsler'.
           COPY 'griarter'.
           COPY 'grilifer'.
           COPY 'grimsxer'.
           COPY 'gritaber'.
           COPY '_grixxxer'.
      **** rel 3.0
      *    COPY 'nocall'.
           COPY '_nocall'.
      ************
      ************
