      * Area parametri parcon1 usata da vcon110 e vcon350
      *
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-REC-KEY.
              10 IF-PROGR     PIC 999.
           05 IF-REC-WDS.
      * data
              10 IF-DATREG    PIC 9(6).
              10 IF-CAUS      PIC 999.
              10 IF-CAUS-D    PIC X(24).
              10 IF-LEGAME    PIC 999.
              10 IF-DESAG     PIC X(30).
              10 IF-PART      PIC 9(7).
              10 IF-PART-D    PIC X(36).
              10 IF-CLIFOR    PIC 9(5).
              10 IF-CLIFOR-D  PIC X(36).
      * IF-FLCOSZ: flag zoom di chiamata x centro di costo
      *            0=nessun zoom
      *            1=nessun zoom
      *            2=lancia vcdcx10 (centro di costo)
      *            3=lancia vcdcx20 (tabella ripartizioni)
              10 IF-FLCOSZ    PIC 9.
              10 IF-CCOST.
                 15 IF-TRIP   PIC X(3).
                 15 IF-FILL   PIC X.
      **** rel 5.0
      * IF-FLRIPO: indica se visualizzare il saldo del conto
      *            generale/clienti/fornitori includendo o
      *            meno il saldo esercizio precedente
      *            0=non include saldo es. precedente
      *            1= include saldo es. precedente
              10 IF-FLRIPO    PIC 9.
      ************
      **** rel 4.0
      *       10 IF-SALD      PIC S9(11).
              10 IF-SALD      PIC S9(11)V99.
      ************
              10 IF-CATT      PIC X.
              10 IF-NPRGI     PIC 9(5).
              10 IF-DOCUM     PIC 9(5).
      * data
              10 IF-DTDOC     PIC 9(6).
      * data
              10 IF-DTSCD     PIC 9(6).
      **** rel 4.0
      *       10 IF-IMPOR     PIC S9(11).
              10 IF-IMPOR     PIC S9(11)V99.
      ************
              10 IF-D-A       PIC X.
              10 IF-SEGNI     PIC X.
              10 IF-VALUT     PIC 999.
              10 IF-VALUT-D   PIC X(4).
      **** rel 4.0
      *       10 IF-CAMGG     PIC 9999V999.
              10 IF-CAMGG     PIC 9(5)V9(6).
      ************
              10 IF-IMVAL     PIC S9(11)V99.
              10 IF-CPART     PIC 9(7).
              10 IF-CPART-D   PIC X(36).
              10 IF-DESAG2    PIC X(30).
      * IF-FLCOS2Z: flag zoom di chiamata x centro di costo c/p
      *             0=nessun zoom
      *             1=nessun zoom
      *             2=lancia vcdcx10 (centro di costo)
      *             3=lancia vcdcx20 (tabella ripartizioni)
              10 IF-FLCOS2Z   PIC 9.
              10 IF-CCOST2.
                 15 IF-TRIP2  PIC X(3).
                 15 IF-FILL2  PIC X.
      **** rel 4.0
      *       10 IF-SALD2     PIC S9(11).
              10 IF-SALD2     PIC S9(11)V99.
      ************
      **** rel 7.2
              10 IF-CEE       PIC 9.
      ************
      *--- dati scadenzario carico
              10 IF-CDPAG     PIC 999.
              10 IF-DESPAG    PIC X(24).
              10 IF-CDBAN     PIC 9(5).
              10 IF-DESBAN    PIC X(36).
      * data
              10 IF-1SCAD     PIC 9(6).
      *--- dati per calcolo differenze cambio e differenze valutarie
      *       (per documento derivanti da partitario)
      **** rel 4.0
      *       10 IF-PAR-SALDO PIC S9(11).
              10 IF-PAR-SALDO PIC S9(11)V99.
      ************
              10 IF-PAR-VSALD PIC S9(11)V99.
              10 IF-PAR-VALUT PIC 999.
      **** rel 4.0
      *       10 IF-PAR-CADOC PIC 9999V999.
              10 IF-PAR-CADOC PIC 9(5)V9(6).
      ************
      * importo differenza cambio
      * (calcolata da partitario o da scadenzario)
      **** rel 4.0
      *       10 IF-DIFCAM    PIC S9(11).
              10 IF-DIFCAM    PIC S9(11)V99.
      ************
      * importo differenza valutaria
      * (calcolata da partitario o da scadenzario)
              10 IF-DIFVAL    PIC S9(11)V99.
      *--- dati relativi alla causale contabile come da tabella
              10 IF-TAB-CAUS.
                 15 IF-T02-TIPRG  PIC 9.
                 15 IF-T02-TIPOP  PIC 99.
                 15 IF-T02-SEGNO  PIC 9.
                 15 IF-T02-ATTRN  PIC 9.
                 15 IF-T02-DTSCO  PIC 9.
                 15 IF-T02-FLVEN  PIC 9.
                 15 IF-T02-FLGEC  PIC 9.
                 15 IF-T02-FLGSC  PIC 9.
                 15 IF-T02-FLGIS  PIC 9.
      *--- dati relativi alla causale contabile per movimento
      *    acquisto CEE come da tabella
              10 IF-ACEE-TAB-CAUS.
                 15 IF-ACEE-T02-TIPRG  PIC 9.
                 15 IF-ACEE-T02-D-A    PIC X.
                 15 IF-ACEE-T02-TIPOP  PIC 99.
                 15 IF-ACEE-T02-SEGNO  PIC 9.
                 15 IF-ACEE-T02-ATTRN  PIC 9.
                 15 IF-ACEE-T02-DTSCO  PIC 9.
                 15 IF-ACEE-T02-FLVEN  PIC 9.
                 15 IF-ACEE-T02-FLGEC  PIC 9.
                 15 IF-ACEE-T02-FLGSC  PIC 9.
                 15 IF-ACEE-T02-FLGIS  PIC 9.
      *--- dati relativi a movimento acquisto CEE
      * - per la parte IVA viene utilizzato il vettore IF-IVA
      * - per la contropartita dell'IVA indeducibile viene utilizzato
      *   il primo elemento del vettore IF-CPAR.
              10 IF-ACEE-CAUS     PIC 999.
              10 IF-ACEE-CAUS-D   PIC X(24).
              10 IF-ACEE-CATTA    PIC X.
              10 IF-ACEE-NPRGIA   PIC 9(5).
              10 IF-ACEE-CATTV    PIC X.
              10 IF-ACEE-NPRGIV   PIC 9(5).
      *--- flags
              10 IF-HS-TIPRG   PIC 9.
              10 IF-HS-VALUT   PIC 9.
              10 IF-HS-ATTRN   PIC 9.
              10 IF-HS-FLGEC   PIC 9.
              10 IF-HS-FLGSC   PIC 9.
              10 IF-HS-FLTIG   PIC 9.
              10 IF-HS-FLCOS   PIC 9.
              10 IF-HS-FL1SCAD PIC 9.
              10 IF-HS-CPART   PIC 9.
              10 IF-HS-SCA     PIC 9.
              10 IF-HS-SCAS    PIC 9.
              10 IF-HS-CONTDIF PIC 9.
              10 IF-HS-ACEE    PIC 9.
      **** rel 5.0
              10 IF-HS-ACEEV   PIC 9.
      ************
      **** rel 4.0
              10 IF-HS-EURO    PIC 9.
      ************
      *----- note dei flags ------------------------------------------
      * flags per hide-show
      * IF-HS-TIPRG   : tipo registrazione
      *                 1=generale  2=clienti  3=fornitori
      * IF-HS-VALUT   : mov. in valuta
      *                 0=no  1=si
      *                 nota: non valido per mov. acquisti CEE
      * IF-HS-ATTRN   : mov. IVA
      *                 0=no  1=si
      * IF-HS-FLGEC   : agg. estratto conto
      *                 0=no  1=si
      *                 (invertito rispetto a T02-FLGEC)
      * IF-HS-FLGSC   : agg. scadenzario
      *                 0=no  1=carico   2=scarico  3=carico/scarico
      *                 4=carico/scarico su causale, ma non permette
      *                   l'inserimento del carico (riemissione)
      *                   perche' sullo scarico non e' stato identificato
      *                   nessun insoluto
      *                   Lo stato 4 viene deciso da vcon112, ma viene
      *                   caricato in if-hs-flgs dall'interfaccia.
      * IF-HS-FLTIG   : gestione plafond
      *                 0=non gestito
      *                 1=rif. anno prec.
      *                 2=rif. 12 mesi prec.
      * IF-HS-FLCOS   : gestione centri di costo (da AZI-FLCOS)
      *                 0=no  1=si
      * IF-HS-FL1SCAD : flag data 1a scadenza da input su scadenzario
      *                 0=non richiesta  1=richiesta
      * IF-HS-CPART   : gestione contropartita in RG-C110-W
      *                 0=no  1=si
      * IF-HS-CONTDIF : flag contabilizzazione differenza cambio
      *                 0=no  1=si
      * IF-HS-ACEE    : flag movimento acquisto CEE
      *                 0=no
      *                 1=si  l'interfaccia abilitera' anche i campi 
      *                       if-valut, if-camgg, if-imval
      *                       sulla prima maschera
      * IF-HS-ACEEV   : flag movimento cessione CEE (cliente CEE)
      *                 0=no
      *                 1=si  l'interfaccia chiede se si vuole
      *                       aprire lo zoom elenchi iva CEE;
      *                       il cobol genera i movimenti su file EINTRA
      * IF-HS-EURO    : mov. in euro
      *                 0=no  1=si
      * flags per programma cobol
      * IF-HS-SCA     : esistenza file dati carico scadenzario
      *                 0=no  1=si
      * IF-HS-SCAS    : esistenza file dati scarico scadenzario
      *                 0=no  1=si
      *---------------------------------------------------------------
           05 IF-REC-GLOBALI.
              10 IF-AZI-D     PIC X(36).
      **** rel 4.0
      *       10 IF-SBILANCIO PIC S9(11).
      *       10 IF-DARE      PIC S9(11).
      *       10 IF-AVERE     PIC S9(11).
              10 IF-SBILANCIO PIC S9(11)V99.
              10 IF-DARE      PIC S9(11)V99.
              10 IF-AVERE     PIC S9(11)V99.
      ************
      *--- dati iva
      **** rel 4.0
      *       10 IF-DIFDOC    PIC S9(11).
      *       10 IF-TOTIMPON  PIC S9(11).
      *       10 IF-TOTIMPOS  PIC S9(11).
              10 IF-DIFDOC    PIC S9(11)V99.
              10 IF-TOTIMPON  PIC S9(11)V99.
              10 IF-TOTIMPOS  PIC S9(11)V99.
      ************
      *--- dati contropartite
      **** rel 4.0
      *       10 IF-DIFIMPON  PIC S9(11).
      *       10 IF-TOTIMPOR  PIC S9(11).
              10 IF-DIFIMPON  PIC S9(11)V99.
              10 IF-TOTIMPOR  PIC S9(11)V99.
      ************
      *--- dati relativi a movimento acquisto CEE
              10 IF-DIFDOCV   PIC S9(11)V99.
              10 IF-TOTIMPONV PIC S9(11)V99.
      *--- dati scadenzario carico
      **** rel 4.0
      *       10 IF-TOTSCA    PIC S9(11).
      *       10 IF-DIFSCA    PIC S9(11).
              10 IF-TOTSCA    PIC S9(11)V99.
              10 IF-DIFSCA    PIC S9(11)V99.
      ************
              10 IF-TOTSCAV   PIC S9(11)V99.
              10 IF-DIFSCAV   PIC S9(11)V99.
      **** rel 5.0
      *--- prg. scadenzario per scadenze di pagamenti anticipati
              10 IF-SCA-PRG   PIC 9(5).
      ************
      *--- anno per vritx70
              10 IF-AUV-ANNO  PIC 9(4).
      **** rel 2.0
      *--- dati per legami contabilita'
              10 IF-LEG-FLGPB1 PIC 9.
              10 IF-LEG-FLGPB2 PIC 9.
              10 IF-LEG-FLGDB  PIC 9.
              10 IF-LEG-CAUS   PIC 999.
              10 IF-LEG-CAUS-D PIC X(24).
              10 IF-LEG-TIPO   PIC 9.
              10 IF-LEG-POS    PIC 99.
              10 IF-LEG-RIGSEL PIC 99.
      **** rel 6.3
      *---------------------------------------------------------------
      * Chiave archivio INTRA per far s che aprendo lo zoom INTRA in
      * automatico nel caso di cliente/fornitore CEE ci si poasizioni
      * in automatico sul record inserito da vcon440.
      *---------------------------------------------------------------
              10 IF-AREA-KTRA.
                 15 IF-KTRA-AZI  PIC 999.
                 15 IF-KTRA-IVA  PIC 9(11).
                 15 IF-KTRA-ANNO PIC 9(4).
                 15 IF-KTRA-PERI PIC 9(2).
                 15 IF-KTRA-TRAN PIC X.
                 15 IF-KTRA-TIPO PIC 9.
                 15 IF-KTRA-TIPN PIC X.
                 15 IF-KTRA-PROT PIC 9(5).
                 15 IF-KTRA-PROG PIC 99.
      ************
      *---------------------------------------------------------------
      * IF-LEG-FLGPB1   : flag bottone legami su video 1
      *                   0=spento  1=acceso
      * IF-LEG-FLGPB2   : flag bottone legami su video dati IVA-C/P
      *                   0=spento  1=acceso
      * IF-LEG-FLGDB    : flag attivazione automatica finestra
      *                   di selezione legami
      *                   0=no  1=si
      * IF-LEG-CAUS     : cod. causale da cui derivano i legami
      *                   selezionabili
      * IF-LEG-CAUS-D   : descrizione causale
      * IF-LEG-TIPO     : tipo legami visualizzati 
      *                   0=alternativo  1=collegamento
      * IF-LEG-POS      : n. rigo del buffer legami di contabilita'
      *                   dove l'interfaccia si posizionera' (riga blu)
      * IF-LEG-RIGSEL   : n. riga selezionata da interfaccia
      *---------------------------------------------------------------
      ************
