      $SET LINKCOUNT"128"
       IDENTIFICATION DIVISION.
       PROGRAM-ID. VARC122.
      *
      *    Interfaccia TABELL per scheda parametri
      *    (T01, T14A, T14B, T14C, T14E, T14F, T14G, T14H, T14I, T14L)
      *
      * Nota: il nome del campo da validare e' composto
      *       dal solo suffisso.
      *
      **** rel 4.0
      * ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
       01  RELPRIMULA.
           05 FILLER PIC X(50) VALUE
              '@(#)Primula NT rel 6.0a     GR Informatica'.
           05 FILLER PIC X     VALUE LOW-VALUE.
           COPY 'gritabrk'.
           COPY 'grit14g'.
           COPY 'grit14h'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
       LINKAGE SECTION.
           COPY 'grit01rg'.
      *
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-T-CTRL
                                RG-T-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-T-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-T-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-T-FUN   TO FUN.
           MOVE RG-T-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'R' OR
                    'r' OR
                    'A' GO TO F-READ-AGGIOR.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'varc122: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-READ-AGGIOR.
           IF FUN = 'r' MOVE 1 TO FLCK.
           IF RG-T-NWIN = 1
              PERFORM LEG-AGG-T01  THRU EX-LEG-AGG-T01
              PERFORM LEG-AGG-T14A THRU EX-LEG-AGG-T14A
              PERFORM LEG-AGG-T14E THRU EX-LEG-AGG-T14E
              GO TO END-F-READ-AGGIOR.
           IF RG-T-NWIN = 2
              PERFORM LEG-AGG-T14A THRU EX-LEG-AGG-T14A
              PERFORM LEG-AGG-T14B THRU EX-LEG-AGG-T14B
              PERFORM LEG-AGG-T14E THRU EX-LEG-AGG-T14E
      **** rel 5.2
              PERFORM LEG-AGG-T14L THRU EX-LEG-AGG-T14L
      ************
              GO TO END-F-READ-AGGIOR.
           IF RG-T-NWIN = 3
              PERFORM LEG-AGG-T14F THRU EX-LEG-AGG-T14F
              GO TO END-F-READ-AGGIOR.
           IF RG-T-NWIN = 4
              PERFORM LEG-AGG-T14E THRU EX-LEG-AGG-T14E
              GO TO END-F-READ-AGGIOR.
           IF RG-T-NWIN = 5
              PERFORM LEG-AGG-T14C THRU EX-LEG-AGG-T14C
              GO TO END-F-READ-AGGIOR.
           IF RG-T-NWIN = 6
              PERFORM LEG-AGG-T14I THRU EX-LEG-AGG-T14I
              GO TO END-F-READ-AGGIOR.
           IF RG-T-NWIN = 7
              PERFORM LEG-AGG-T01  THRU EX-LEG-AGG-T01
              PERFORM LEG-AGG-T14B THRU EX-LEG-AGG-T14B
              PERFORM LEG-AGG-T14G THRU EX-LEG-AGG-T14G
              PERFORM LEG-AGG-T14H THRU EX-LEG-AGG-T14H
              GO TO END-F-READ-AGGIOR.
      **** rel 6.0a
      *    IF RG-T-NWIN = 8
      *       PERFORM LEG-AGG-T14A THRU EX-LEG-AGG-T14A
      *       PERFORM LEG-AGG-T14B THRU EX-LEG-AGG-T14B
      *       GO TO END-F-READ-AGGIOR.
      *************
      **** rel 5.2
           IF RG-T-NWIN = 10
              PERFORM LEG-AGG-T14L THRU EX-LEG-AGG-T14L
              GO TO END-F-READ-AGGIOR.
      ************
      *    
           MOVE 'Numero maschera inesistente' TO MESS.
           GO TO ERRIO.
      *
       END-F-READ-AGGIOR.
           IF FUN = 'A' UNLOCK TABELL.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           UNLOCK TABELL.
           GO TO F-READ-AGGIOR.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-T-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK TABELL.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-T-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABELL.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-T-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-T-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           IF RG-T-FL = ZERO MOVE 'tabell' TO ID-TAB
           ELSE              MOVE 'tabold' TO ID-TAB.
           OPEN I-O TABELL.
      *     
           MOVE 01001 TO KEYTB.
           READ TABELL INVALID PERFORM SCRIVI-T01 THRU EX-SCRIVI-T01.
      *     
           MOVE 14001 TO KEYTB.
           READ TABELL INVALID PERFORM SCRIVI-T14A THRU EX-SCRIVI-T14A.
      *     
           MOVE 14002 TO KEYTB.
           READ TABELL INVALID PERFORM SCRIVI-T14B THRU EX-SCRIVI-T14B.
      *     
           MOVE 14003 TO KEYTB.
           READ TABELL INVALID PERFORM SCRIVI-T14C THRU EX-SCRIVI-T14C.
      *     
           MOVE 14005 TO KEYTB.
           READ TABELL INVALID PERFORM SCRIVI-T14E THRU EX-SCRIVI-T14E.
      *     
           MOVE 14006 TO KEYTB.
           READ TABELL INVALID PERFORM SCRIVI-T14F THRU EX-SCRIVI-T14F.
      *     
           MOVE 14007 TO KEYTB.
           READ TABELL INVALID PERFORM SCRIVI-T14G THRU EX-SCRIVI-T14G.
      *     
           MOVE 14008 TO KEYTB.
           READ TABELL INVALID PERFORM SCRIVI-T14H THRU EX-SCRIVI-T14H.
      *     
           MOVE 14009 TO KEYTB.
           READ TABELL INVALID PERFORM SCRIVI-T14I THRU EX-SCRIVI-T14I.
      *     
      **** rel 5.2
           MOVE 14010 TO KEYTB.
           READ TABELL INVALID PERFORM SCRIVI-T14L THRU EX-SCRIVI-T14L.
      ************
      *     
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       READ-K.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ TABELL INVALID PERFORM INVK-TAB
                               GO TO ERRIO.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ TABELL KEPT LOCK INVALID PERFORM INVK-TAB
                                         GO TO ERRIO.
           IF SF-TAB > ZERO MOVE 7 TO RG-T-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       REWRITE-K.
           REWRITE RF-TAB INVALID PERFORM INVK-TAB
                                  GO TO ERRIO.
       EX-REWRITE-K.
           EXIT.
      *------------------
       CARICA-REC-T01.
           MOVE 01001            TO TAB-KEYID.
           MOVE RG-T01-CIVAV     TO T01-CIVAV.
           MOVE RG-T01-CIVAQ     TO T01-CIVAQ.
           MOVE RG-T01-CRPCL     TO T01-CRPCL.
           MOVE RG-T01-CRPC1     TO T01-CRPC1.
           MOVE RG-T01-CRPC2     TO T01-CRPC2.
           MOVE RG-T01-CRPFR     TO T01-CRPFR.
           MOVE RG-T01-CRPF1     TO T01-CRPF1.
           MOVE RG-T01-CRPF2     TO T01-CRPF2.
           MOVE RG-T01-MCLI      TO T01-MCLI.
           MOVE RG-T01-MFOR      TO T01-MFOR.
           MOVE RG-T01-CIVSO     TO T01-CIVSO.
           MOVE REKTAB TO RF-TAB.
       EX-CARICA-REC-T01.
           EXIT.
      *------------------
       CARICA-REC-T14A.
           MOVE 14001            TO TAB-KEYID.
           MOVE RG-T14A-RICAV    TO T14-RICAV.
           MOVE RG-T14A-SPBOL    TO T14-SPBOL.
           MOVE RG-T14A-SPBAN    TO T14-SPBAN.
           MOVE RG-T14A-RIBAN    TO T14-RIBAN.
           MOVE RG-T14A-TRATT    TO T14-TRATT.
           MOVE RG-T14A-FATT     TO T14-FATT.
           MOVE RG-T14A-RB       TO T14-RB.
           MOVE RG-T14A-TRT      TO T14-TRT.
           MOVE RG-T14A-IVABL    TO T14-IVABL.
           MOVE RG-T14A-IVABA    TO T14-IVABA.
      **** rel 6.0a
      *    MOVE RG-T14A-CMAG     TO T14-CMAG.
      *************
           MOVE RG-T14A-CDCOR    TO T14-CDCOR.
      **** rel 6.0a
      *    MOVE RG-T14A-FTRI     TO T14-FTRI.
      *************
           MOVE RG-T14A-COSTI    TO T14-COSTI.
      **** rel 5.0
           MOVE RG-T14A-FLGINC   TO T14-FLGINC.
      ************
           MOVE REKTAB TO RF-TAB.
       EX-CARICA-REC-T14A.
           EXIT.
      *------------------
       CARICA-REC-T14B.
           MOVE 14002            TO TAB-KEYID.
           MOVE RG-T14B-ACCR     TO T14-ACCR.
           MOVE RG-T14B-FTSO     TO T14-FTSO.
           MOVE RG-T14B-ACSO     TO T14-ACSO.
           MOVE RG-T14B-CSGR     TO T14-CSGR.
           MOVE RG-T14B-IVGR     TO T14-IVGR.
           MOVE RG-T14B-SCON     TO T14-SCON.
           MOVE RG-T14B-RIC1     TO T14-RIC1.
           MOVE RG-T14B-RIC2     TO T14-RIC2.
           MOVE RG-T14B-RIC3     TO T14-RIC3.
      **** rel 6.0a
      *    MOVE RG-T14B-IVRB     TO T14-IVRB.
      **** rel 5.2
      *    MOVE RG-T14B-NOTRIF   TO T14-NOTRIF.
      *    MOVE RG-T14B-NOTFFR   TO T14-NOTFFR.
      *    MOVE RG-T14B-NOTFCR   TO T14-NOTFCR.
      *    MOVE RG-T14B-NOTRIG   TO T14-NOTRIG.
      *    MOVE RG-T14B-NOTBCR   TO T14-NOTBCR.
      ************
      *************
           MOVE RG-T14B-ACCO     TO T14-ACCO.
           MOVE RG-T14B-CACC     TO T14-CACC.
           MOVE REKTAB TO RF-TAB.
       EX-CARICA-REC-T14B.
           EXIT.
      *------------------
       CARICA-REC-T14C.
           MOVE 14003            TO TAB-KEYID.
           MOVE RG-T14C-ALIQ     TO T14-ALIQ.
           MOVE RG-T14C-IMPS1    TO T14-IMPS(1).
           MOVE RG-T14C-IMPB1    TO T14-IMPB(1).
           MOVE RG-T14C-IMPS2    TO T14-IMPS(2).
           MOVE RG-T14C-IMPB2    TO T14-IMPB(2).
           MOVE RG-T14C-IMPS3    TO T14-IMPS(3).
           MOVE RG-T14C-IMPB3    TO T14-IMPB(3).
           MOVE RG-T14C-IMPS4    TO T14-IMPS(4).
           MOVE RG-T14C-IMPB4    TO T14-IMPB(4).
           MOVE RG-T14C-IMPS5    TO T14-IMPS(5).
           MOVE RG-T14C-IMPB5    TO T14-IMPB(5).
           MOVE RG-T14C-IMPS6    TO T14-IMPS(6).
           MOVE RG-T14C-IMPB6    TO T14-IMPB(6).
      **** rel 5.2
           MOVE RG-T14C-IMBOL    TO T14-IMBOL.
           MOVE RG-T14C-IMPSC    TO T14-IMPSC.
      ************
           MOVE REKTAB TO RF-TAB.
       EX-CARICA-REC-T14C.
           EXIT.
      *------------------
       CARICA-REC-T14E.
           MOVE 14005            TO TAB-KEYID.
           MOVE RG-T14E-IVER     TO T14-IVER.
           MOVE RG-T14E-RICO     TO T14-RICO.
           MOVE RG-T14E-GIIV     TO T14-GIIV.
      **** rel 7.2
           MOVE RG-T14E-GISO     TO T14-GISO.
      ************
           MOVE RG-T14E-GICO     TO T14-GICO.
           MOVE RG-T14E-IDIR     TO T14-IDIR.
           MOVE RG-T14E-ITRI     TO T14-ITRI.
           MOVE RG-T14E-IIND     TO T14-IIND.
           MOVE RG-T14E-ISCV     TO T14-ISCV.
           MOVE RG-T14E-IRSM     TO T14-IRSM.
           MOVE RG-T14E-IASS     TO T14-IASS.
           MOVE RG-T14E-ISIN     TO T14-ISIN.
           MOVE RG-T14E-1ACQ     TO T14-1ACQ.
           MOVE RG-T14E-1ACR     TO T14-1ACR.
           MOVE RG-T14E-1ACT     TO T14-1ACT.
           MOVE RG-T14E-2ACQ     TO T14-2ACQ.
           MOVE RG-T14E-3ACQ     TO T14-3ACQ.
           MOVE RG-T14E-IPOS     TO T14-IPOS.
           MOVE REKTAB TO RF-TAB.
       EX-CARICA-REC-T14E.
           EXIT.
      *------------------
       CARICA-REC-T14F.
           MOVE 14006            TO TAB-KEYID.
           MOVE RG-T14F-CAVC     TO T14-CAVC.
           MOVE RG-T14F-CARC     TO T14-CARC.
           MOVE RG-T14F-CAOC     TO T14-CAOC.
           MOVE RG-T14F-CASC     TO T14-CASC.
           MOVE RG-T14F-CAGC     TO T14-CAGC.
           MOVE RG-T14F-CAAF     TO T14-CAAF.
           MOVE RG-T14F-CARF     TO T14-CARF.
           MOVE REKTAB TO RF-TAB.
       EX-CARICA-REC-T14F.
           EXIT.
      *------------------
       CARICA-REC-T14G.
           MOVE 14007            TO KEYTB14G.
           MOVE RG-T14G-CRPC3    TO T14-CRPC3.
           MOVE RG-T14G-CRPC4    TO T14-CRPC4.
           MOVE RG-T14G-CRPC5    TO T14-CRPC5.
           MOVE RG-T14G-CRPC6    TO T14-CRPC6.
           MOVE RG-T14G-CRPC7    TO T14-CRPC7.
           MOVE RG-T14G-CRPC8    TO T14-CRPC8.
           MOVE RG-T14G-CRPF3    TO T14-CRPF3.
           MOVE RG-T14G-CRPF4    TO T14-CRPF4.
           MOVE RG-T14G-CRPF5    TO T14-CRPF5.
           MOVE RG-T14G-CRPF6    TO T14-CRPF6.
           MOVE RG-T14G-CRPF7    TO T14-CRPF7.
           MOVE RG-T14G-CRPF8    TO T14-CRPF8.
           MOVE RKTB14G TO RF-TAB.
       EX-CARICA-REC-T14G.
           EXIT.
      *------------------
       CARICA-REC-T14H.
           MOVE 14008            TO KEYTB14H.
           MOVE RG-T14H-RIC4     TO T14-RIC4.
           MOVE RG-T14H-RIC5     TO T14-RIC5.
           MOVE RG-T14H-RIC6     TO T14-RIC6.
           MOVE RG-T14H-RIC7     TO T14-RIC7.
           MOVE RG-T14H-RIC8     TO T14-RIC8.
           MOVE RG-T14H-RIC9     TO T14-RIC9.
           MOVE RKTB14H TO RF-TAB.
       EX-CARICA-REC-T14H.
           EXIT.
      *------------------
       CARICA-REC-T14I.
           MOVE 14009            TO TAB-KEYID.
           MOVE RG-T14I-CA1DC    TO T14-CA1DC.
           MOVE RG-T14I-CA2DC    TO T14-CA2DC.
           MOVE RG-T14I-CA3DC    TO T14-CA3DC.
           MOVE RG-T14I-UTCAM    TO T14-UTCAM.
           MOVE RG-T14I-PECAM    TO T14-PECAM.
           MOVE REKTAB TO RF-TAB.
       EX-CARICA-REC-T14I.
           EXIT.
      *------------------
      **** rel 5.2
       CARICA-REC-T14L.
           MOVE 14010            TO TAB-KEYID.
           MOVE RG-T14L-CRCGR    TO T14-CRCGR.
           MOVE RG-T14L-CRSCM    TO T14-CRSCM.
           MOVE RG-T14L-CFTEM1   TO T14-CFTEM1.
           MOVE RG-T14L-CFTEM2   TO T14-CFTEM2.
           MOVE RG-T14L-CFTEM3   TO T14-CFTEM3.
           MOVE RG-T14L-CNAEM1   TO T14-CNAEM1.
           MOVE RG-T14L-CNAEM2   TO T14-CNAEM2.
           MOVE RG-T14L-CNAEM3   TO T14-CNAEM3.
           MOVE RG-T14L-CFTRC1   TO T14-CFTRC1.
           MOVE RG-T14L-CFTRC2   TO T14-CFTRC2.
           MOVE RG-T14L-CFTRC3   TO T14-CFTRC3.
           MOVE RG-T14L-CNARC1   TO T14-CNARC1.
           MOVE RG-T14L-CNARC2   TO T14-CNARC2.
           MOVE RG-T14L-CNARC3   TO T14-CNARC3.
           MOVE RG-T14L-CAUFEM   TO T14-CAUFEM.
           MOVE RG-T14L-CAUFRC   TO T14-CAUFRC.
           MOVE REKTAB TO RF-TAB.
       EX-CARICA-REC-T14L.
           EXIT.
      *------------------
      ************
       CARICA-RG-T01.
           MOVE T01-CIVAV     TO RG-T01-CIVAV.
           MOVE T01-CIVAQ     TO RG-T01-CIVAQ.
           MOVE T01-CRPCL     TO RG-T01-CRPCL.
           MOVE T01-CRPC1     TO RG-T01-CRPC1.
           MOVE T01-CRPC2     TO RG-T01-CRPC2.
           MOVE T01-CRPFR     TO RG-T01-CRPFR.
           MOVE T01-CRPF1     TO RG-T01-CRPF1.
           MOVE T01-CRPF2     TO RG-T01-CRPF2.
           MOVE T01-MCLI      TO RG-T01-MCLI.
           MOVE T01-MFOR      TO RG-T01-MFOR.
           MOVE T01-CIVSO     TO RG-T01-CIVSO.
       EX-CARICA-RG-T01.
           EXIT.
      *------------------
       CARICA-RG-T14A.
           MOVE T14-RICAV     TO RG-T14A-RICAV.
           MOVE T14-SPBOL     TO RG-T14A-SPBOL.
           MOVE T14-SPBAN     TO RG-T14A-SPBAN.
           MOVE T14-RIBAN     TO RG-T14A-RIBAN.
           MOVE T14-TRATT     TO RG-T14A-TRATT.
           MOVE T14-FATT      TO RG-T14A-FATT.
           MOVE T14-RB        TO RG-T14A-RB.
           MOVE T14-TRT       TO RG-T14A-TRT.
           MOVE T14-IVABL     TO RG-T14A-IVABL.
           MOVE T14-IVABA     TO RG-T14A-IVABA.
      **** rel 6.0a
      *    MOVE T14-CMAG      TO RG-T14A-CMAG.
      *************
           MOVE T14-CDCOR     TO RG-T14A-CDCOR.
      **** rel 6.0a
      *    MOVE T14-FTRI      TO RG-T14A-FTRI.
      *************
           MOVE T14-COSTI     TO RG-T14A-COSTI.
      **** rel 5.0
           MOVE T14-FLGINC    TO RG-T14A-FLGINC.
      ************
       EX-CARICA-RG-T14A.
           EXIT.
      *------------------
       CARICA-RG-T14B.
           MOVE T14-ACCR      TO RG-T14B-ACCR.
           MOVE T14-FTSO      TO RG-T14B-FTSO.
           MOVE T14-ACSO      TO RG-T14B-ACSO.
           MOVE T14-CSGR      TO RG-T14B-CSGR.
           MOVE T14-IVGR      TO RG-T14B-IVGR.
           MOVE T14-SCON      TO RG-T14B-SCON.
           MOVE T14-RIC1      TO RG-T14B-RIC1.
           MOVE T14-RIC2      TO RG-T14B-RIC2.
           MOVE T14-RIC3      TO RG-T14B-RIC3.
      **** rel 6.0a
      *    MOVE T14-IVRB      TO RG-T14B-IVRB.
      **** rel 5.2
      *    MOVE T14-NOTRIF    TO RG-T14B-NOTRIF.
      *    MOVE T14-NOTFFR    TO RG-T14B-NOTFFR.
      *    MOVE T14-NOTFCR    TO RG-T14B-NOTFCR.
      *    MOVE T14-NOTRIG    TO RG-T14B-NOTRIG.
      *    MOVE T14-NOTBCR    TO RG-T14B-NOTBCR.
      ************
      *************
           MOVE T14-ACCO      TO RG-T14B-ACCO.
           MOVE T14-CACC      TO RG-T14B-CACC.
       EX-CARICA-RG-T14B.
           EXIT.
      *------------------
       CARICA-RG-T14C.
           MOVE T14-ALIQ      TO RG-T14C-ALIQ.
           MOVE T14-IMPS(1)   TO RG-T14C-IMPS1.
           MOVE T14-IMPB(1)   TO RG-T14C-IMPB1.
           MOVE T14-IMPS(2)   TO RG-T14C-IMPS2.
           MOVE T14-IMPB(2)   TO RG-T14C-IMPB2.
           MOVE T14-IMPS(3)   TO RG-T14C-IMPS3.
           MOVE T14-IMPB(3)   TO RG-T14C-IMPB3.
           MOVE T14-IMPS(4)   TO RG-T14C-IMPS4.
           MOVE T14-IMPB(4)   TO RG-T14C-IMPB4.
           MOVE T14-IMPS(5)   TO RG-T14C-IMPS5.
           MOVE T14-IMPB(5)   TO RG-T14C-IMPB5.
           MOVE T14-IMPS(6)   TO RG-T14C-IMPS6.
           MOVE T14-IMPB(6)   TO RG-T14C-IMPB6.
      **** rel 5.2
           MOVE T14-IMBOL     TO RG-T14C-IMBOL.
           MOVE T14-IMPSC     TO RG-T14C-IMPSC.
      ************
       EX-CARICA-RG-T14C.
           EXIT.
      *------------------
       CARICA-RG-T14E.
           MOVE T14-IVER      TO RG-T14E-IVER.
           MOVE T14-RICO      TO RG-T14E-RICO.
           MOVE T14-GIIV      TO RG-T14E-GIIV.
      **** rel 7.2
           MOVE T14-GISO      TO RG-T14E-GISO.
      ************
           MOVE T14-GICO      TO RG-T14E-GICO.
           MOVE T14-IDIR      TO RG-T14E-IDIR.
           MOVE T14-ITRI      TO RG-T14E-ITRI.
           MOVE T14-IIND      TO RG-T14E-IIND.
           MOVE T14-ISCV      TO RG-T14E-ISCV.
           MOVE T14-IRSM      TO RG-T14E-IRSM.
           MOVE T14-IASS      TO RG-T14E-IASS.
           MOVE T14-ISIN      TO RG-T14E-ISIN.
           MOVE T14-1ACQ      TO RG-T14E-1ACQ.
           MOVE T14-1ACR      TO RG-T14E-1ACR.
           MOVE T14-1ACT      TO RG-T14E-1ACT.
           MOVE T14-2ACQ      TO RG-T14E-2ACQ.
           MOVE T14-3ACQ      TO RG-T14E-3ACQ.
           MOVE T14-IPOS      TO RG-T14E-IPOS.
       EX-CARICA-RG-T14E.
           EXIT.
      *------------------
       CARICA-RG-T14F.
           MOVE T14-CAVC      TO RG-T14F-CAVC.
           MOVE T14-CARC      TO RG-T14F-CARC.
           MOVE T14-CAOC      TO RG-T14F-CAOC.
           MOVE T14-CASC      TO RG-T14F-CASC.
           MOVE T14-CAGC      TO RG-T14F-CAGC.
           MOVE T14-CAAF      TO RG-T14F-CAAF.
           MOVE T14-CARF      TO RG-T14F-CARF.
       EX-CARICA-RG-T14F.
           EXIT.
      *------------------
       CARICA-RG-T14G.
           MOVE T14-CRPC3     TO RG-T14G-CRPC3.
           MOVE T14-CRPC4     TO RG-T14G-CRPC4.
           MOVE T14-CRPC5     TO RG-T14G-CRPC5.
           MOVE T14-CRPC6     TO RG-T14G-CRPC6.
           MOVE T14-CRPC7     TO RG-T14G-CRPC7.
           MOVE T14-CRPC8     TO RG-T14G-CRPC8.
           MOVE T14-CRPF3     TO RG-T14G-CRPF3.
           MOVE T14-CRPF4     TO RG-T14G-CRPF4.
           MOVE T14-CRPF5     TO RG-T14G-CRPF5.
           MOVE T14-CRPF6     TO RG-T14G-CRPF6.
           MOVE T14-CRPF7     TO RG-T14G-CRPF7.
           MOVE T14-CRPF8     TO RG-T14G-CRPF8.
       EX-CARICA-RG-T14G.
           EXIT.
      *------------------
       CARICA-RG-T14H.
           MOVE T14-RIC4      TO RG-T14H-RIC4.
           MOVE T14-RIC5      TO RG-T14H-RIC5.
           MOVE T14-RIC6      TO RG-T14H-RIC6.
           MOVE T14-RIC7      TO RG-T14H-RIC7.
           MOVE T14-RIC8      TO RG-T14H-RIC8.
           MOVE T14-RIC9      TO RG-T14H-RIC9.
       EX-CARICA-RG-T14H.
           EXIT.
      *------------------
       CARICA-RG-T14I.
           MOVE T14-CA1DC     TO RG-T14I-CA1DC.
           MOVE T14-CA2DC     TO RG-T14I-CA2DC.
           MOVE T14-CA3DC     TO RG-T14I-CA3DC.
           MOVE T14-UTCAM     TO RG-T14I-UTCAM.
           MOVE T14-PECAM     TO RG-T14I-PECAM.
       EX-CARICA-RG-T14I.
           EXIT.
      *------------------
      **** rel 5.2
       CARICA-RG-T14L.
           MOVE T14-CRCGR     TO RG-T14L-CRCGR.
           MOVE T14-CRSCM     TO RG-T14L-CRSCM.
           MOVE T14-CFTEM1    TO RG-T14L-CFTEM1.
           MOVE T14-CFTEM2    TO RG-T14L-CFTEM2.
           MOVE T14-CFTEM3    TO RG-T14L-CFTEM3.
           MOVE T14-CNAEM1    TO RG-T14L-CNAEM1.
           MOVE T14-CNAEM2    TO RG-T14L-CNAEM2.
           MOVE T14-CNAEM3    TO RG-T14L-CNAEM3.
           MOVE T14-CFTRC1    TO RG-T14L-CFTRC1.
           MOVE T14-CFTRC2    TO RG-T14L-CFTRC2.
           MOVE T14-CFTRC3    TO RG-T14L-CFTRC3.
           MOVE T14-CNARC1    TO RG-T14L-CNARC1.
           MOVE T14-CNARC2    TO RG-T14L-CNARC2.
           MOVE T14-CNARC3    TO RG-T14L-CNARC3.
           MOVE T14-CAUFEM    TO RG-T14L-CAUFEM.
           MOVE T14-CAUFRC    TO RG-T14L-CAUFRC.
       EX-CARICA-RG-T14L.
           EXIT.
      *------------------
      ************
       CARICA-RA.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi non chiave
       V-DATI.
           MOVE ZERO TO VFLD.
      *
      **** rel 5.2
           IF RG-T-NWIN = 10 GO TO V-DATI-WINDOW10.
      ************
           GO TO V-DATI-WINDOW1 
                 V-DATI-WINDOW2 
                 V-DATI-WINDOW3 
                 V-DATI-WINDOW4 
                 V-DATI-WINDOW5 
                 V-DATI-WINDOW6 
                 V-DATI-WINDOW7 
      **** rel 6.0a
      *          V-DATI-WINDOW8 DEPENDING RG-T-NWIN.
                 DEPENDING RG-T-NWIN.
      *************
      *
       V-DATI-WINDOW1.
      *
           GO TO END-V-DATI.
      *
       V-DATI-WINDOW2.
      *
       V-FATT.
           MOVE 'FATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FATT.
           IF RG-T14A-FATT = ZERO GO TO E-FATT.
           MOVE 2            TO KTB-TIP.
           MOVE RG-T14A-FATT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 2 OR T02-ATTRN = ZERO
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-FATT.
      *
       V-ACCR.
           MOVE 'ACCR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACCR.
           IF RG-T14B-ACCR = ZERO GO TO E-ACCR.
           MOVE 2            TO KTB-TIP.
           MOVE RG-T14B-ACCR TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 2 OR T02-ATTRN = ZERO
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-ACCR.
      *
       V-FTSO.
           MOVE 'FTSO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FTSO.
           IF RG-T14B-FTSO = ZERO GO TO E-FTSO.
           MOVE 2            TO KTB-TIP.
           MOVE RG-T14B-FTSO TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 2 OR T02-ATTRN = ZERO
                                OR T02-FLGIS NOT = 1 
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-FTSO.
      *
       V-ACSO.
           MOVE 'ACSO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACSO.
           IF RG-T14B-ACSO = ZERO GO TO E-ACSO.
           MOVE 2            TO KTB-TIP.
           MOVE RG-T14B-ACSO TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 2 OR T02-ATTRN = ZERO
                                OR T02-FLGIS NOT = 1 
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-ACSO.
      *
       V-RB.
           MOVE 'RB' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-RB.
           IF RG-T14A-RB = ZERO GO TO E-RB.
           MOVE 2          TO KTB-TIP.
           MOVE RG-T14A-RB TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 2 OR T02-ATTRN > ZERO 
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-RB.
      *
       V-TRT.
           MOVE 'TRT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TRT.
           IF RG-T14A-TRT = ZERO GO TO E-TRT.
           MOVE 2           TO KTB-TIP.
           MOVE RG-T14A-TRT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 2 OR T02-ATTRN > ZERO 
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-TRT.
      *
       V-ACCO.
           MOVE 'ACCO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACCO.
           IF RG-T14B-ACCO = ZERO GO TO E-ACCO.
           MOVE 2            TO KTB-TIP.
           MOVE RG-T14B-ACCO TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 2 OR T02-ATTRN > ZERO 
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-ACCO.
      *
       V-GICO.
           MOVE 'GICO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-GICO.
           IF RG-T14E-GICO = ZERO GO TO E-GICO.
           MOVE 2            TO KTB-TIP.
           MOVE RG-T14E-GICO TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 1 OR T02-ATTRN > ZERO 
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-GICO.
      *
       V-GIIV.
           MOVE 'GIIV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-GIIV.
           IF RG-T14E-GIIV = ZERO GO TO E-GIIV.
           MOVE 2            TO KTB-TIP.
           MOVE RG-T14E-GIIV TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 1 OR T02-ATTRN > ZERO 
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-GIIV.
      *
      **** rel 7.2
       V-GISO.
           MOVE 'GISO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-GISO.
           IF RG-T14E-GISO = ZERO GO TO E-GISO.
           MOVE 2            TO KTB-TIP.
           MOVE RG-T14E-GISO TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 2
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-GISO.
      *
      ************
       V-IVABL.
           MOVE 'IVABL' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IVABL.
           IF RG-T14A-IVABL = ZERO GO TO E-IVABL.
           MOVE 3             TO KTB-TIP.
           MOVE RG-T14A-IVABL TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
       E-IVABL.
      *
       V-IVABA.
           MOVE 'IVABA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IVABA.
           IF RG-T14A-IVABA = ZERO GO TO E-IVABA.
           MOVE 3             TO KTB-TIP.
           MOVE RG-T14A-IVABA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
       E-IVABA.
      *
           GO TO END-V-DATI.
      *
       V-DATI-WINDOW3.
      *
       V-CAVC.
           MOVE 'CAVC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAVC.
           IF RG-T14F-CAVC = ZERO GO TO E-CAVC.
           MOVE 7            TO KTB-TIP.
           MOVE RG-T14F-CAVC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T07-AGGES NOT = '-' 
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-CAVC.
      *
       V-CARC.
           MOVE 'CARC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CARC.
           IF RG-T14F-CARC = ZERO GO TO E-CARC.
           MOVE 7            TO KTB-TIP.
           MOVE RG-T14F-CARC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T07-AGGES = '-' OR '+' )
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-CARC.
      *
       V-CAOC.
           MOVE 'CAOC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAOC.
           IF RG-T14F-CAOC = ZERO GO TO E-CAOC.
           MOVE 7            TO KTB-TIP.
           MOVE RG-T14F-CAOC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T07-AGGES NOT = '-'
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-CAOC.
      *
       V-CASC.
           MOVE 'CASC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CASC.
           IF RG-T14F-CASC = ZERO GO TO E-CASC.
           MOVE 7            TO KTB-TIP.
           MOVE RG-T14F-CASC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T07-AGGES NOT = '-'
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-CASC.
      *
       V-CAGC.
           MOVE 'CAGC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAGC.
           IF RG-T14F-CAGC = ZERO GO TO E-CAGC.
           MOVE 7            TO KTB-TIP.
           MOVE RG-T14F-CAGC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T07-AGGES NOT = '-'
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-CAGC.
      *
       V-CAAF.
           MOVE 'CAAF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAAF.
           IF RG-T14F-CAAF = ZERO GO TO E-CAAF.
           MOVE 7            TO KTB-TIP.
           MOVE RG-T14F-CAAF TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T07-AGGES NOT = '+'
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-CAAF.
      *
       V-CARF.
           MOVE 'CARF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CARF.
           IF RG-T14F-CARF = ZERO GO TO E-CARF.
           MOVE 7            TO KTB-TIP.
           MOVE RG-T14F-CARF TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T07-AGGES = '+' OR '-' )
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-CARF.
      *
           GO TO END-V-DATI.
      *
       V-DATI-WINDOW4.
      *
       V-1ACQ.
           MOVE '1ACQ' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-1ACQ.
           IF RG-T14E-1ACQ = ZERO GO TO E-1ACQ.
           MOVE 3            TO KTB-TIP.
           MOVE RG-T14E-1ACQ TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T03-ALIVA = ZERO AND T03-TPIVA = 6 )
              MOVE 'Codice IVA incongruente' TO MESS
              GO TO V-ERROR.
       E-1ACQ.
      *
       V-1ACR.
           MOVE '1ACR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-1ACR.
           IF RG-T14E-1ACR = ZERO GO TO E-1ACR.
           MOVE 3            TO KTB-TIP.
           MOVE RG-T14E-1ACR TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T03-ALIVA = ZERO AND T03-TPIVA = 6 )
              MOVE 'Codice IVA incongruente' TO MESS
              GO TO V-ERROR.
       E-1ACR.
      *
       V-1ACT.
           MOVE '1ACT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-1ACT.
           IF RG-T14E-1ACT = ZERO GO TO E-1ACT.
           MOVE 3            TO KTB-TIP.
           MOVE RG-T14E-1ACT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T03-ALIVA NOT = ZERO 
              MOVE 'Codice IVA incongruente' TO MESS
              GO TO V-ERROR.
       E-1ACT.
      *
       V-2ACQ.
           MOVE '2ACQ' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-2ACQ.
           IF RG-T14E-2ACQ = ZERO GO TO E-2ACQ.
           MOVE 3            TO KTB-TIP.
           MOVE RG-T14E-2ACQ TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T03-ALIVA = ZERO AND T03-TPIVA = 6 )
              MOVE 'Codice IVA incongruente' TO MESS
              GO TO V-ERROR.
       E-2ACQ.
      *
       V-3ACQ.
           MOVE '3ACQ' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-3ACQ.
           IF RG-T14E-3ACQ = ZERO GO TO E-3ACQ.
           MOVE 3            TO KTB-TIP.
           MOVE RG-T14E-3ACQ TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T03-ALIVA = ZERO AND T03-TPIVA = 6 )
              MOVE 'Codice IVA incongruente' TO MESS
              GO TO V-ERROR.
       E-3ACQ.
      *
       V-IDIR.
           MOVE 'IDIR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IDIR.
           IF RG-T14E-IDIR = ZERO GO TO E-IDIR.
           MOVE 3            TO KTB-TIP.
           MOVE RG-T14E-IDIR TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T03-ALIVA = ZERO AND T03-TPIVA = 3 )
              MOVE 'Codice IVA incongruente' TO MESS
              GO TO V-ERROR.
       E-IDIR.
      *
       V-ITRI.
           MOVE 'ITRI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ITRI.
           IF RG-T14E-ITRI = ZERO GO TO E-ITRI.
           MOVE 3            TO KTB-TIP.
           MOVE RG-T14E-ITRI TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T03-ALIVA = ZERO AND T03-TPIVA = 3 )
              MOVE 'Codice IVA incongruente' TO MESS
              GO TO V-ERROR.
       E-ITRI.
      *
       V-IIND.
           MOVE 'IIND' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IIND.
           IF RG-T14E-IIND = ZERO GO TO E-IIND.
           MOVE 3            TO KTB-TIP.
           MOVE RG-T14E-IIND TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T03-ALIVA = ZERO AND T03-TPIVA = 3 )
              MOVE 'Codice IVA incongruente' TO MESS
              GO TO V-ERROR.
       E-IIND.
      *
       V-ISCV.
           MOVE 'ISCV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ISCV.
           IF RG-T14E-ISCV = ZERO GO TO E-ISCV.
           MOVE 3            TO KTB-TIP.
           MOVE RG-T14E-ISCV TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T03-ALIVA = ZERO AND T03-TPIVA = 3 )
              MOVE 'Codice IVA incongruente' TO MESS
              GO TO V-ERROR.
       E-ISCV.
      *
       V-IRSM.
           MOVE 'IRSM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IRSM.
           IF RG-T14E-IRSM = ZERO GO TO E-IRSM.
           MOVE 3            TO KTB-TIP.
           MOVE RG-T14E-IRSM TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T03-ALIVA = ZERO AND T03-TPIVA = 3 )
              MOVE 'Codice IVA incongruente' TO MESS
              GO TO V-ERROR.
       E-IRSM.
      *
       V-IPOS.
           MOVE 'IPOS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IPOS.
           IF RG-T14E-IPOS = ZERO GO TO E-IPOS.
           MOVE 3            TO KTB-TIP.
           MOVE RG-T14E-IPOS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T03-ALIVA = ZERO AND T03-TPIVA = 3 )
              MOVE 'Codice IVA incongruente' TO MESS
              GO TO V-ERROR.
       E-IPOS.
      *
       V-IASS.
           MOVE 'IASS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IASS.
           IF RG-T14E-IASS = ZERO GO TO E-IASS.
           MOVE 3            TO KTB-TIP.
           MOVE RG-T14E-IASS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T03-ALIVA = ZERO AND T03-TPIVA = 3 )
              MOVE 'Codice IVA incongruente' TO MESS
              GO TO V-ERROR.
       E-IASS.
      *
       V-ISIN.
           MOVE 'ISIN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ISIN.
           IF RG-T14E-ISIN = ZERO GO TO E-ISIN.
           MOVE 3            TO KTB-TIP.
           MOVE RG-T14E-ISIN TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF NOT ( T03-ALIVA = ZERO AND T03-TPIVA = 3 )
              MOVE 'Codice IVA incongruente' TO MESS
              GO TO V-ERROR.
       E-ISIN.
      *
           GO TO END-V-DATI.
      *
       V-DATI-WINDOW5.
      *
       V-IMPB1.
           MOVE 'IMPB1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMPB1.
           IF RG-T14C-IMPB1 > ZERO AND RG-T14C-IMPS1 = ZERO
              MOVE 999999999 TO RG-T14C-IMPS1.
       E-IMPB1.
      *
       V-IMPB2.
           MOVE 'IMPB2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMPB2.
           IF RG-T14C-IMPB2 > ZERO AND RG-T14C-IMPS2 = ZERO
              MOVE 999999999 TO RG-T14C-IMPS2.
       E-IMPB2.
      *
       V-IMPB3.
           MOVE 'IMPB3' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMPB3.
           IF RG-T14C-IMPB3 > ZERO AND RG-T14C-IMPS3 = ZERO
              MOVE 999999999 TO RG-T14C-IMPS3.
       E-IMPB3.
      *
       V-IMPB4.
           MOVE 'IMPB4' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMPB4.
           IF RG-T14C-IMPB4 > ZERO AND RG-T14C-IMPS4 = ZERO
              MOVE 999999999 TO RG-T14C-IMPS4.
       E-IMPB4.
      *
       V-IMPB5.
           MOVE 'IMPB5' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMPB5.
           IF RG-T14C-IMPB5 > ZERO AND RG-T14C-IMPS5 = ZERO
              MOVE 999999999 TO RG-T14C-IMPS5.
       E-IMPB5.
      *
       V-IMPB6.
           MOVE 'IMPB6' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMPB6.
           IF RG-T14C-IMPB6 > ZERO AND RG-T14C-IMPS6 = ZERO
              MOVE 999999999 TO RG-T14C-IMPS6.
       E-IMPB6.
      *
           GO TO END-V-DATI.
      *
       V-DATI-WINDOW6.
      *
       V-CA1DC.
           MOVE 'CA1DC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CA1DC.
           IF RG-T14I-CA1DC = ZERO GO TO E-CA1DC.
           MOVE 2             TO KTB-TIP.
           MOVE RG-T14I-CA1DC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 1 
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-CA1DC.
      *
       V-CA2DC.
           MOVE 'CA2DC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CA2DC.
           IF RG-T14I-CA2DC = ZERO GO TO E-CA2DC.
           MOVE 2             TO KTB-TIP.
           MOVE RG-T14I-CA2DC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 2 OR T02-ATTRN > ZERO
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-CA2DC.
      *
       V-CA3DC.
           MOVE 'CA3DC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CA3DC.
           IF RG-T14I-CA3DC = ZERO GO TO E-CA3DC.
           MOVE 2             TO KTB-TIP.
           MOVE RG-T14I-CA3DC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 3 OR T02-ATTRN > ZERO
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-CA3DC.
      *
           GO TO END-V-DATI.
      *
       V-DATI-WINDOW7.
      *
           GO TO END-V-DATI.
      *
      **** rel 6.0a
      *V-DATI-WINDOW8.
      *
      *V-CMAG.
      *    MOVE 'CMAG' TO VCAMPO.
      *    IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CMAG.
      *    IF NOT ( RG-T14A-CMAG = ZERO OR RG-T14A-CMAG = 1 ) 
      *       PERFORM ERR-RADIO
      *       GO TO V-ERROR.
      *E-CMAG.
      *
      *V-FTRI.
      *    MOVE 'FTRI' TO VCAMPO.
      *    IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FTRI.
      *    IF  RG-T14A-FTRI > 1
      *       PERFORM ERR-DINV
      *       GO TO V-ERROR.
      *E-FTRI.
      *
      *V-IVRB.
      *    MOVE 'IVRB' TO VCAMPO.
      *    IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IVRB.
      *    IF  RG-T14B-IVRB > 1
      *       PERFORM ERR-DINV
      *       GO TO V-ERROR.
      *E-IVRB.
      *
      *    GO TO END-V-DATI.
      *************

      **** rel 5.2
       V-DATI-WINDOW10.
      *
       V-CAUFRC.
           MOVE 'CAUFRC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAUFRC.
           IF RG-T14L-CAUFRC = ZERO GO TO E-CAUFRC.
           MOVE 2             TO KTB-TIP.
           MOVE RG-T14L-CAUFRC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 1
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-CAUFRC.
      *
       V-CAUFEM.
           MOVE 'CAUFEM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAUFEM.
           IF RG-T14L-CAUFEM = ZERO GO TO E-CAUFEM.
           MOVE 2             TO KTB-TIP.
           MOVE RG-T14L-CAUFEM TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF T02-TIPRG NOT = 1
              MOVE 'Causale incongruente' TO MESS
              GO TO V-ERROR.
       E-CAUFEM.
      *
           GO TO END-V-DATI.
      ************
      *
       END-V-DATI.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *---------------------------------------------------------------
      * Creazione record vuoto di una tabella inesistente            *
      *---------------------------------------------------------------
       SCRIVI-T01.
           MOVE ZERO  TO REKTAB.
           MOVE 01001 TO TAB-KEYID.
           WRITE RF-TAB FROM REKTAB INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
       EX-SCRIVI-T01.
           EXIT.
      *------------------
       SCRIVI-T14A.
           MOVE ZERO  TO REKTAB.
           MOVE 14001 TO TAB-KEYID.
           WRITE RF-TAB FROM REKTAB INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
       EX-SCRIVI-T14A.
           EXIT.
      *------------------
       SCRIVI-T14B.
           MOVE ZERO  TO REKTAB.
           MOVE 14002 TO TAB-KEYID.
           WRITE RF-TAB FROM REKTAB INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
       EX-SCRIVI-T14B.
           EXIT.
      *------------------
       SCRIVI-T14C.
           MOVE ZERO TO REKTAB 
                        T14-ALIQ
      **** rel 5.2
                        T14-IMBOL
                        T14-IMPSC
      ************
                        T14-IMPS(1)
                        T14-IMPS(2)
                        T14-IMPS(3)
                        T14-IMPS(4)
                        T14-IMPS(5)
                        T14-IMPS(6)
                        T14-IMPB(1)
                        T14-IMPB(2)
                        T14-IMPB(3)
                        T14-IMPB(4)
                        T14-IMPB(5)
                        T14-IMPB(6).
           MOVE 14003 TO TAB-KEYID.
           WRITE RF-TAB FROM REKTAB INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
       EX-SCRIVI-T14C.
           EXIT.
      *------------------
       SCRIVI-T14E.
           MOVE ZERO  TO REKTAB.
           MOVE 14005 TO TAB-KEYID.
           WRITE RF-TAB FROM REKTAB INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
       EX-SCRIVI-T14E.
           EXIT.
      *------------------
       SCRIVI-T14F.
           MOVE ZERO  TO REKTAB.
           MOVE 14006 TO TAB-KEYID.
           WRITE RF-TAB FROM REKTAB INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
       EX-SCRIVI-T14F.
           EXIT.
      *------------------
       SCRIVI-T14G.
           MOVE ZERO TO RKTB14G
                        T14-CRPC3
                        T14-CRPC4
                        T14-CRPC5
                        T14-CRPC6
                        T14-CRPC7
                        T14-CRPC8
                        T14-CRPF3
                        T14-CRPF4
                        T14-CRPF5
                        T14-CRPF6
                        T14-CRPF7
                        T14-CRPF8.
           MOVE 14007 TO KEYTB14G.
           WRITE RF-TAB FROM RKTB14G INVALID PERFORM INVK-TAB
                                             GO TO ERRIO.
       EX-SCRIVI-T14G.
           EXIT.
      *------------------
       SCRIVI-T14H.
           MOVE ZERO  TO RKTB14H.
           MOVE 14008 TO KEYTB14H.
           WRITE RF-TAB FROM RKTB14H INVALID PERFORM INVK-TAB
                                             GO TO ERRIO.
       EX-SCRIVI-T14H.
           EXIT.
      *------------------
       SCRIVI-T14I.
           MOVE ZERO  TO REKTAB.
           MOVE 14009 TO TAB-KEYID.
           WRITE RF-TAB FROM REKTAB INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
       EX-SCRIVI-T14I.
           EXIT.
      *------------------
      **** rel 5.2
       SCRIVI-T14L.
           MOVE ZERO TO REKTAB 
                        T14-CRCGR T14-CRSCM
                        T14-CFTEM1 T14-CFTEM2 T14-CFTEM3
                        T14-CNAEM1 T14-CNAEM2 T14-CNAEM3
                        T14-CFTRC1 T14-CFTRC2 T14-CFTRC3
                        T14-CNARC1 T14-CNARC2 T14-CNARC3
                        T14-CAUFEM T14-CAUFRC.
           MOVE 14010   TO TAB-KEYID.
           WRITE RF-TAB FROM REKTAB INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
       EX-SCRIVI-T14L.
           EXIT.
      *------------------
      ************
      *----------------------------------------------------------------
      * Lettura - Caricamento RG 
      *       oppure
      * Lettura di riposizionamento - Caricamento REC - Rewrite Tabella
      *   dei dati relativi ad una tabella specifica
      *----------------------------------------------------------------
       LEG-AGG-T01.
           MOVE ZERO  TO VKEY.
           MOVE 01001 TO KEYTB.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
      **** rel 6.0a
                 MOVE RF-TAB TO REKTAB
      *************
                 PERFORM CARICA-REC-T01 THRU EX-CARICA-REC-T01
                 PERFORM REWRITE-K      THRU EX-REWRITE-K
              ELSE
                 MOVE RF-TAB TO REKTAB
                 PERFORM CARICA-RG-T01 THRU EX-CARICA-RG-T01.
       EX-LEG-AGG-T01.
           EXIT.
      *------------------
       LEG-AGG-T14A.
           MOVE ZERO  TO VKEY.
           MOVE 14001 TO KEYTB.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
      **** rel 6.0a
                 MOVE RF-TAB TO REKTAB
      *************
                 PERFORM CARICA-REC-T14A THRU EX-CARICA-REC-T14A
                 PERFORM REWRITE-K       THRU EX-REWRITE-K
              ELSE
                 MOVE RF-TAB TO REKTAB
                 PERFORM CARICA-RG-T14A THRU EX-CARICA-RG-T14A.
       EX-LEG-AGG-T14A.
           EXIT.
      *------------------
       LEG-AGG-T14B.
           MOVE ZERO  TO VKEY.
           MOVE 14002 TO KEYTB.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
      **** rel 6.0a
                 MOVE RF-TAB TO REKTAB
      *************
                 PERFORM CARICA-REC-T14B THRU EX-CARICA-REC-T14B
                 PERFORM REWRITE-K       THRU EX-REWRITE-K
              ELSE
                 MOVE RF-TAB TO REKTAB
                 PERFORM CARICA-RG-T14B THRU EX-CARICA-RG-T14B.
       EX-LEG-AGG-T14B.
           EXIT.
      *------------------
       LEG-AGG-T14C.
           MOVE ZERO  TO VKEY.
           MOVE 14003 TO KEYTB.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
      **** rel 6.0a
                 MOVE RF-TAB TO REKTAB
      *************
                 PERFORM CARICA-REC-T14C THRU EX-CARICA-REC-T14C
                 PERFORM REWRITE-K       THRU EX-REWRITE-K
              ELSE
                 MOVE RF-TAB TO REKTAB
                 PERFORM CARICA-RG-T14C THRU EX-CARICA-RG-T14C.
       EX-LEG-AGG-T14C.
           EXIT.
      *------------------
       LEG-AGG-T14E.
           MOVE ZERO  TO VKEY.
           MOVE 14005 TO KEYTB.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
      **** rel 6.0a
                 MOVE RF-TAB TO REKTAB
      *************
                 PERFORM CARICA-REC-T14E THRU EX-CARICA-REC-T14E
                 PERFORM REWRITE-K       THRU EX-REWRITE-K
              ELSE
                 MOVE RF-TAB TO REKTAB
                 PERFORM CARICA-RG-T14E THRU EX-CARICA-RG-T14E.
       EX-LEG-AGG-T14E.
           EXIT.
      *------------------
       LEG-AGG-T14F.
           MOVE ZERO  TO VKEY.
           MOVE 14006 TO KEYTB.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
      **** rel 6.0a
                 MOVE RF-TAB TO REKTAB
      *************
                 PERFORM CARICA-REC-T14F THRU EX-CARICA-REC-T14F
                 PERFORM REWRITE-K       THRU EX-REWRITE-K
              ELSE
                 MOVE RF-TAB TO REKTAB
                 PERFORM CARICA-RG-T14F THRU EX-CARICA-RG-T14F.
       EX-LEG-AGG-T14F.
           EXIT.
      *------------------
       LEG-AGG-T14G.
           MOVE ZERO  TO VKEY.
           MOVE 14007 TO KEYTB.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
      **** rel 6.0a
                 MOVE RF-TAB TO RKTB14G
      *************
                 PERFORM CARICA-REC-T14G THRU EX-CARICA-REC-T14G
                 PERFORM REWRITE-K       THRU EX-REWRITE-K
              ELSE
                 MOVE RF-TAB TO RKTB14G 
                 PERFORM CARICA-RG-T14G THRU EX-CARICA-RG-T14G.
       EX-LEG-AGG-T14G.
           EXIT.
      *------------------
       LEG-AGG-T14H.
           MOVE ZERO  TO VKEY.
           MOVE 14008 TO KEYTB.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
      **** rel 6.0a
                 MOVE RF-TAB TO RKTB14H
      *************
                 PERFORM CARICA-REC-T14H THRU EX-CARICA-REC-T14H
                 PERFORM REWRITE-K       THRU EX-REWRITE-K
              ELSE
                 MOVE RF-TAB TO RKTB14H 
                 PERFORM CARICA-RG-T14H THRU EX-CARICA-RG-T14H.
       EX-LEG-AGG-T14H.
           EXIT.
      *------------------
       LEG-AGG-T14I.
           MOVE ZERO  TO VKEY.
           MOVE 14009 TO KEYTB.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
      **** rel 6.0a
                 MOVE RF-TAB TO REKTAB
      *************
                 PERFORM CARICA-REC-T14I THRU EX-CARICA-REC-T14I
                 PERFORM REWRITE-K       THRU EX-REWRITE-K
              ELSE
                 MOVE RF-TAB TO REKTAB
                 PERFORM CARICA-RG-T14I THRU EX-CARICA-RG-T14I.
       EX-LEG-AGG-T14I.
           EXIT.
      *------------------
      **** rel 5.2
       LEG-AGG-T14L.
           MOVE ZERO  TO VKEY.
           MOVE 14010 TO KEYTB.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
      **** rel 6.0a
                 MOVE RF-TAB TO REKTAB
      *************
                 PERFORM CARICA-REC-T14L THRU EX-CARICA-REC-T14L
                 PERFORM REWRITE-K       THRU EX-REWRITE-K
              ELSE
                 MOVE RF-TAB TO REKTAB
                 PERFORM CARICA-RG-T14L THRU EX-CARICA-RG-T14L.
       EX-LEG-AGG-T14L.
           EXIT.
      *------------------
      ************
