       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON151.
      *
      * Stampa bilancio di verifica  alla data
      *
      **** rel 7.2
      * Ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           COPY 'grimszsl'.
           COPY 'grimvxsl'.
           COPY 'grimsxsl'.
           COPY 'gricolsl'.
           COPY 'gricfxsl'.
           COPY 'gritabsl'.
      **** rel 6.2
           COPY 'grimlisl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'griclf'.
           COPY 'grimov'.
           COPY 'grimsz'.
           COPY 'grimvx'.
           COPY 'grimsx'.
           COPY 'gricol'.
           COPY 'gricfx'.
           COPY 'gritab'.
      **** rel 6.2
           COPY 'grimli'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griconrk'.
           COPY 'gritabrk'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'grimovrk'.
           COPY 'grit20rk'.
           COPY 'parer'.
       01  REKCO2.
           05 CO2-KEYID.
              10 CO2-AZI  PIC 999   VALUE ZERO.
              10 CO2-COD  PIC 9(7)  VALUE ZERO.
           05 CO2-DESCR   PIC X(36) VALUE SPACE.
           05 CO2-DSABB   PIC X(20) VALUE SPACE.
           05 CO2-TIPO    PIC X     VALUE SPACE.
           05 CO2-SALDI.
              10 CO2-SP-D PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SP-A PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SPSP PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SE-D PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SE-A PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SESP PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 CO2-SALDR REDEFINES CO2-SALDI.
              10 CO2-SXYY PIC S9(11)V99 COMP-3 OCCURS 6.
           05 CO2-BIL1  PIC 9  VALUE ZERO.
           05 CO2-BIL2  PIC 99 VALUE ZERO.
           05 CO2-BIL3  PIC 99 VALUE ZERO.
           05 CO2-BIL4  PIC 9  VALUE ZERO.
           05 CO2-FLRIE PIC 9  VALUE ZERO.
           05 CO2-MOVIM PIC 9  VALUE ZERO.
           05 CO2-FLAUT PIC 9  VALUE ZERO.
           05 CO2-TPCOP PIC 9  VALUE ZERO.
           05 CO2-TPCON PIC 9  VALUE ZERO.
           05 CO2-PRO1  PIC 99 VALUE ZERO.
           05 CO2-PRO2  PIC 99 VALUE ZERO.
           05 CO2-BIL5  PIC 9  VALUE ZERO.
           05 CO2-CVAL  PIC 9  VALUE ZERO.
           05 FILLER    PIC X(4) VALUE ZERO.
       01  REKCL2.
           05 CL2-KEYID.
              10 CL2-AZI  PIC 999   VALUE ZERO.
              10 CL2-COD.
                 15 CL2-MS PIC 99   VALUE ZERO.
                 15 CL2-CD PIC 9(5) VALUE ZERO.
           05 CL2-XRGS.
              10 CL2-RGSOC  PIC X(36) VALUE SPACE.
              10 CL2-RGSOC2 PIC X(36) VALUE SPACE.
           05 CL2-XIND.
              10 CL2-INDIR  PIC X(24) VALUE SPACE.
              10 CL2-INDIR2 PIC X(24) VALUE SPACE.
           05 CL2-CAP     PIC 9(5)  VALUE ZERO.
           05 CL2-CITTA.
              10 CL2-CIT  PIC X(23) VALUE SPACE.
              10 CL2-FIL  PIC X     VALUE SPACE.
              10 CL2-PRV  PIC XX    VALUE SPACE.
           05 CL2-PIVA    PIC 9(11) COMP-3 VALUE ZERO.
           05 CL2-CFISC.
              10 CL2-CFP  PIC X(11) VALUE SPACE.
              10 CL2-BLK  PIC X(5)  VALUE SPACE.
           05 CL2-CFCEE REDEFINES CL2-CFISC.
              10 CL2-PAE  PIC XX.
              10 CL2-IVE  PIC X(12).
              10 CL2-ABB  PIC XX.
           05 CL2-SALDI.
              10 CL2-SP-D PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CL2-SP-A PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CL2-SPSP PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CL2-SE-D PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CL2-SE-A PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CL2-SESP PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 CL2-SALDR REDEFINES CL2-SALDI.
              10 CL2-SXYY PIC S9(11)V99 COMP-3 OCCURS 6.
           05 CL2-IMPON   PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 CL2-NIMPO   PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 CL2-ESENT   PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 CL2-IMIVA   PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 CL2-TACCR   PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 CL2-LINS    PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 CL2-NFATT   PIC 9(5)   COMP-3 VALUE ZERO.
           05 CL2-NOPNI   PIC 9(5)   COMP-3 VALUE ZERO.
           05 CL2-NACCR   PIC 9(5)   COMP-3 VALUE ZERO.
           05 CL2-NINS    PIC 9(5)   COMP-3 VALUE ZERO.
           05 CL2-FIDO    PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 CL2-ESPO    PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 CL2-VALORD  PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 CL2-SCBS    PIC 999V99 COMP-3 VALUE ZERO.
           05 CL2-BANC    PIC 9(5) VALUE ZERO.
           05 CL2-CPAG    PIC 999  VALUE ZERO.
           05 CL2-AGEN    PIC 999  VALUE ZERO.
           05 CL2-VETT    PIC 999  VALUE ZERO.
           05 CL2-MSPE    PIC 999  VALUE ZERO.
           05 CL2-PORT    PIC 999  VALUE ZERO.
           05 CL2-ESEN    PIC 999  VALUE ZERO.
           05 CL2-LIS     PIC 999  VALUE ZERO.
           05 CL2-ZONA    PIC XXX  VALUE ZERO.
           05 CL2-GRU     PIC XXX  VALUE SPACE.
           05 CL2-GRM     PIC 9    VALUE ZERO.
           05 CL2-CATCON  PIC 9    VALUE ZERO.
           05 CL2-TPRZ    PIC 9    VALUE ZERO.
           05 CL2-RBOL    PIC 9    VALUE ZERO.
           05 CL2-SBOL    PIC 9    VALUE ZERO.
           05 CL2-SBAN    PIC 9    VALUE ZERO.
           05 CL2-13IVA   PIC 9    VALUE ZERO.
           05 CL2-ANNUL   PIC 9    VALUE ZERO.
           05 CL2-IDTIVA  PIC 9(5)  COMP-3 VALUE ZERO.
           05 CL2-INUIVA  PIC 9(5)  COMP-3 VALUE ZERO.
           05 CL2-EDTIVA  PIC 9(5)  COMP-3 VALUE ZERO.
           05 CL2-ENUIVA  PIC 9(5)  COMP-3 VALUE ZERO.
           05 CL2-NOTE    PIC X(30) VALUE SPACE.
           05 CL2-FLING   PIC 9    VALUE ZERO.
           05 CL2-FLGIS   PIC 9    VALUE ZERO.
           05 CL2-FLAUT   PIC 9     VALUE ZERO.
           05 CL2-VAL     PIC 999   VALUE ZERO.
           05 CL2-BANCF   PIC 9(5)  VALUE ZERO.
           05 CL2-CCORF   PIC X(12) VALUE SPACE.
           05 CL2-TEL     PIC X(30) VALUE SPACE.
           05 CL2-FAX     PIC X(30) VALUE SPACE.
           05 CL2-NOMRIF  PIC X(30) VALUE SPACE.
           05 FILLER      PIC X(108) VALUE ZERO.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15).
       01  ID-CON PIC X(15).
       01  ID-CLF PIC X(15).
       01  ID-TAB PIC X(15).
       01  ID-MOV PIC X(15).
       01  ID-MSZ PIC X(15).
       01  ID-MVX PIC X(15).
       01  ID-MSX PIC X(15).
       01  ID-COL PIC X(15) VALUE 'anacol'.
       01  ID-CFX PIC X(15) VALUE 'anacfx'.
      **** rel 6.2
       01  ID-MLI PIC X(15) VALUE 'movlib'.
      ************
       01  COMODI.
           05 SF-AZI  PIC XX.
           05 SF-CON  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-MOV  PIC XX.
           05 SF-MSZ  PIC XX.
           05 SF-MSX  PIC XX.
           05 SF-MVX  PIC XX.
           05 SF-COL  PIC XX.
           05 SF-CFX  PIC XX.
      **** rel 6.2
           05 SF-MLI  PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 RGMS    PIC X(36).
           05 RGCN    PIC X(36).
           05 K       PIC 9 VALUE ZERO.
           05 PKDAT   PIC 9(5) COMP-3 VALUE ZERO.
           05 PKDT1   PIC 9(5) COMP-3 VALUE ZERO.
           05 PKDT2   PIC 9(5) COMP-3 VALUE ZERO.
           05 A1      PIC 99   VALUE ZERO.
           05 A2      PIC 99   VALUE ZERO.
           05 CODCLF.
              10 MAS PIC 99.
              10 COD PIC 9(5).
           05 MCLI PIC 99.
           05 MFOR PIC 99.
           05 CATEG PIC 99 VALUE ZERO.
           05 CAT99 PIC 99 VALUE ZERO.
      **** rel 6.2
           05 COMCOD   PIC 9(7) VALUE ZERO.
           05 COMCOD1  REDEFINES COMCOD.
              10 COMMS PIC 99.
              10 COMCP PIC 99.
              10 COMST PIC 999.
           05 COMCONK  PIC 9(10) VALUE ZERO.
      **********
      **** rel 6.3
           05 COMREKCON PIC X(130) VALUE SPACE.
      ************
       01  AREEK.
           05 CLX.
              10 TGPD PIC S9(13)V99 VALUE ZERO.
              10 TGPA PIC S9(13)V99 VALUE ZERO.
              10 TGPS PIC S9(13)V99 VALUE ZERO.
              10 TGAD PIC S9(13)V99 VALUE ZERO.
              10 TGAA PIC S9(13)V99 VALUE ZERO.
              10 TGAS PIC S9(13)V99 VALUE ZERO.
              10 TMPD PIC S9(13)V99 VALUE ZERO.
              10 TMPA PIC S9(13)V99 VALUE ZERO.
              10 TMPS PIC S9(13)V99 VALUE ZERO.
              10 TMAD PIC S9(13)V99 VALUE ZERO.
              10 TMAA PIC S9(13)V99 VALUE ZERO.
              10 TMAS PIC S9(13)V99 VALUE ZERO.
              10 TCPD PIC S9(13)V99 VALUE ZERO.
              10 TCPA PIC S9(13)V99 VALUE ZERO.
              10 TCPS PIC S9(13)V99 VALUE ZERO.
              10 TCAD PIC S9(13)V99 VALUE ZERO.
              10 TCAA PIC S9(13)V99 VALUE ZERO.
              10 TCAS PIC S9(13)V99 VALUE ZERO.
           05 CLY REDEFINES CLX.
              10 TGXX OCCURS 6 PIC S9(13)V99.
              10 TMXX OCCURS 6 PIC S9(13)V99.
              10 TCXX OCCURS 6 PIC S9(13)V99.
           05 TCYY   PIC S9(13)V99 VALUE ZERO.
           05 TMYY   PIC S9(13)V99 VALUE ZERO.
           05 TGYY   PIC S9(13)V99 VALUE ZERO.
           05 LTCAP  PIC S9(13)V99 VALUE ZERO.
           05 TOTANP PIC S9(13)V99 VALUE ZERO.
           05 CLAV  PIC S9(13)V99 VALUE ZERO.
           05 CLVS  PIC S9(13)V99 VALUE ZERO.
           05 CLVD  PIC S9(13)V99 VALUE ZERO.
           05 CLVA  PIC S9(13)V99 VALUE ZERO.
           05 LTCAD PIC S9(13)V99 VALUE ZERO.
           05 LTCAA PIC S9(13)V99 VALUE ZERO.
           05 LTCAS PIC S9(13)V99 VALUE ZERO.
           05 OLDMS PIC 99.
           05 OLDCN PIC 99.
           05 CONTO PIC 9(7).
           05 RCONT REDEFINES CONTO.
              10 MAST PIC 99.
              10 CAPC PIC 99.
              10 SOTT PIC 999.
      **** rel 6.2
           05 OLDCONTO PIC 9(7) VALUE ZERO.
           05 SAVCONTO PIC 9(7) VALUE ZERO.
           05 CDMLI PIC 9(7).
           05 RCDML REDEFINES CDMLI.
              10 MSMLI PIC 99.
              10 CPMLI PIC 99.
              10 STMLI PIC 999.
      *
           05 FLSTAMP PIC 9.
      ************
      **** rel 7.1
           05 DAT1 PIC 9(6).
           05 DAT2 PIC 9(6).
      **********

           COPY 'vcon151.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D      PIC X(36).
           05 IF-TPSTA      PIC 9.
           05 IF-COD-1      PIC 9(7).
           05 IF-COD-2      PIC 9(7).
           05 IF-CLF-1      PIC 9(5).
           05 IF-CLF-2      PIC 9(5).
           05 IF-TPLIV      PIC 9.
           05 IF-TPCON      PIC 9.
           05 IF-FLBIL      PIC 9.
           05 IF-DTSTA-1    PIC 9(6).
           05 IF-DTSTA-2    PIC 9(6).
           05 IF-TPBIL      PIC 9.
           05 IF-DTELA      PIC 9(6).
           05 IF-FLRIP      PIC 9.
           05 IF-HS-BIL-RIP PIC 9.
           05 IF-LIREUR     PIC 9.
      **** rel 6.2
           05 IF-FLMLI      PIC 9.
           05 IF-TPMLI      PIC 9.
      ************
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dclmsz'.
           COPY 'dclmvx'.
           COPY 'dclmsx'.
           COPY 'dclcol'.
           COPY 'dclcfx'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon151: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE ANACON.
           CLOSE ANACLF.
           CLOSE MOVMXX.
           CLOSE MOVIME.
           CLOSE MOVSXX.
           CLOSE MOVSEZ.
           IF IF-FL = ZERO CLOSE ANACOL
                           CLOSE ANACFX.
      **** rel 6.2
           CLOSE MOVLIB.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griconer'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'grimszer'.
           COPY 'grimvxer'.
           COPY 'grimsxer'.
           COPY 'gricoler'.
           COPY 'gricfxer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'anacon' TO ID-CON
                           MOVE 'anaclf' TO ID-CLF
                           MOVE 'movime' TO ID-MOV
                           MOVE 'movsez' TO ID-MSZ
                           MOVE 'movmxx' TO ID-MVX
                           MOVE 'movsxx' TO ID-MSX
                           MOVE 'tabell' TO ID-TAB
      **** rel 6.2
                           MOVE 'movlib' TO ID-MLI
      ************
           ELSE
                           MOVE 'anazol' TO ID-AZI
                           MOVE 'anacol' TO ID-CON
                           MOVE 'anacfx' TO ID-CLF
                           MOVE 'movmol' TO ID-MOV
                           MOVE 'movsol' TO ID-MSZ
                           MOVE 'movoxx' TO ID-MVX
                           MOVE 'mosoxx' TO ID-MSX
      **** rel 6.2
                           MOVE 'movlix' TO ID-MLI
      ************
                           MOVE 'tabold' TO ID-TAB.

           OPEN INPUT ANACON.
           OPEN INPUT ANACLF.
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT MOVMXX.
           OPEN INPUT MOVIME.
           OPEN INPUT MOVSXX.
           OPEN INPUT MOVSEZ.
           IF IF-FL = ZERO OPEN INPUT ANACOL
                           OPEN INPUT ANACFX.
      **** rel 6.2
           OPEN INPUT MOVLIB.
      ************
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                       PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
      *
           MOVE '20001' TO KEYTB.
           READ TABELL INTO RKTB20 INVALID
                PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DTELA.
      *
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO    TO IF-TPSTA.
           MOVE ZERO    TO IF-COD-1.
           MOVE 9999999 TO IF-COD-2.
           MOVE ZERO    TO IF-CLF-1.
           MOVE 99999   TO IF-CLF-2.
      *
           MOVE ZERO    TO IF-TPBIL
                           IF-FLRIP
                           IF-DTSTA-1
                           IF-DTSTA-2
                           IF-LIREUR
                           IF-HS-BIL-RIP.

           MOVE 1       TO IF-TPCON
           MOVE 3       TO IF-TPLIV.
           MOVE 1       TO IF-FLBIL.
      **** rel 6.2
           MOVE 1       TO IF-FLMLI.
           IF IF-FL = 2 MOVE ZERO TO IF-FLMLI.

           MOVE ZERO    TO IF-TPMLI.
      *
      * propone data apertura esercizio e chiusura
           MOVE AZI-DTAPE TO AAGGG.
           MOVE 2         TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 7.1
      *    MOVE GGMMAA    TO IF-DTSTA-1.
           MOVE GGMMAA    TO IF-DTSTA-1 DAT1.
      **********
           ADD  1         TO AA9.
           MOVE 1         TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           SUBTRACT 1 FROM AAGGG.
           MOVE 2         TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 7.1
      *    MOVE GGMMAA    TO IF-DTSTA-2.
           MOVE GGMMAA    TO IF-DTSTA-2 DAT2.
      ************
      *
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-TPSTA.
           MOVE 'IF-TPSTA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPSTA.
           IF NOT (IF-TPSTA = ZERO OR 1 OR 2)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF IF-TPSTA NOT = ZERO MOVE ZERO TO IF-TPLIV.
       E-TPSTA.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
       V-CLF-2.
           MOVE 'IF-CLF-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CLF-2.
           IF IF-CLF-2 < IF-CLF-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-CLF-2.
      *
       V-FLBIL.
           MOVE 'IF-FLBIL' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLBIL.
      **** rel 7.1
      *    IF IF-FLBIL NOT = ZERO MOVE ZERO TO IF-DTSTA-1
      *                                        IF-DTSTA-2
      *                                        PKDT1
           IF IF-FLBIL NOT = ZERO MOVE DAT1 TO IF-DTSTA-1
                                  MOVE DAT2 TO IF-DTSTA-2
                                  MOVE ZERO TO PKDT1
      **********
                                               PKDT2
                                               IF-TPBIL
                                               IF-HS-BIL-RIP.
       E-FLBIL.
      *
       V-TPBIL.
           MOVE 'IF-TPBIL' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPBIL.
           IF IF-TPBIL NOT = ZERO MOVE ZERO TO IF-FLRIP.
       E-TPBIL.
      *
       V-DTSTA-1.
           MOVE 'IF-DTSTA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTSTA-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTSTA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT1.
           IF (IF-FLBIL = ZERO)
              IF  (PKDT1 < AZI-DTAPE)
                    MOVE 1    TO IF-TPBIL
                    MOVE ZERO TO IF-FLRIP
                    MOVE 1    TO IF-HS-BIL-RIP
              ELSE  MOVE ZERO TO IF-HS-BIL-RIP.
       E-DTSTA-1.
      *
       V-DTSTA-2.
           MOVE 'IF-DTSTA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTSTA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTSTA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT2.
           IF PKDT1 > PKDT2
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DTSTA-2.
      *
       V-DTELA.
           MOVE 'IF-DTELA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTELA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTELA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTELA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           MOVE ZERO TO IEUR.
           IF IF-LIREUR = 1
              MOVE 'E' TO IEUR.
           MOVE AZRGSOC TO INTEAZ.

           MOVE 1 TO TIPOP1.
           MOVE IF-DTSTA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO PKDT1.
           MOVE AA9 TO A1.

           MOVE 1 TO TIPOP1.
           MOVE IF-DTSTA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO PKDT2.
           MOVE AA9 TO A2.

           MOVE 1 TO TIPOP1.
           MOVE IF-DTELA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO PKDAT.

           PERFORM RAZZ THRU EX-RAZZ.
           MOVE SPACE TO DETIB0 DEPEB0.
           MOVE 2 TO TIPOP1.
           MOVE AZI-RVDT TO AAGGG.
           CALL 'rdata' USING PARCDT.
           IF IF-FLBIL = 1 MOVE 'ALL''ULTIMO MOVIMENTO' TO DETIB0
                           GO TO SEL0.

           MOVE 'DAL' TO DETIBI.
           MOVE PKDT1 TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DETIB1.
           MOVE 'AL' TO DETIB2.
           MOVE PKDT2 TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DETIB3.
           IF IF-TPBIL = ZERO MOVE
                 SPACE TO DEPEB0
           ELSE MOVE
                'MOVIMENTI DEL PERIODO' TO DEPEB0.
           GO TO SEL1.
       SEL0.
           MOVE PKDAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DEPEB1.
       SEL1.
           MOVE SPACE TO RGMS RGCN.
      *
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 58      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 3       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
           MOVE C-TINT3 TO XTINT(3).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'BILANCIO ' DETIB0 DEPEB0
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *---------------------------------------------*
      *
           IF IF-TPSTA > ZERO GO TO LP10.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE IF-COD-1 TO KPC-COD.
           MOVE KEYPC TO KEYCF.
           START ANACON KEY NOT < KEYPC.
           START ANACLF KEY NOT < KEYCF.

           MOVE ZERO TO OLDMS.
           MOVE ZERO TO OLDCN.
           MOVE ZERO TO CONTO.

           PERFORM RAZZ1 THRU EX-RAZZ.
           IF IF-FLBIL = 1 MOVE ZERO TO IF-TPBIL.
       LEGG.
           READ ANACON NEXT INTO REKCON AT END GO TO FINES.
           IF SF-CON = '9D' OR '9A' OR '35' GO TO LEGG.
           IF KPC-AZI > KAZ-COD GO TO FINES.
           IF KPC-COD > IF-COD-2 GO TO FINES.
           IF IF-FL NOT = ZERO OR CON-TIPO = 'E' OR IF-FLRIP = ZERO
                         OR KPC-COD = T20-COBC
                         MOVE ZERO TO CO2-SESP GO TO LEGG-90.
           MOVE KPC-AZI TO KCL-AZI.
           MOVE KPC-COD TO KCL-COD.
           READ ANACOL INTO REKCO2 INVALID MOVE ZERO TO CO2-SESP
                                                   GO TO LEGG-90.
           IF SF-COL = '9D' OR '9A' OR '35' MOVE RF-COL TO REKCO2.
           COMPUTE CO2-SESP = CO2-SESP + CO2-SE-D - CO2-SE-A.
       LEGG-90.
           MOVE CO2-SESP TO LTCAP.
           ADD  CO2-SESP TO TOTANP.
           IF IF-FLBIL = 1 SUBTRACT CON-SESP FROM CON-SPSP
                           MOVE CON-SESP TO LTCAS
                           MOVE ZERO     TO LTCAD LTCAA
           ELSE
              PERFORM C00-BILCOM THRU C99.

           MOVE CON-COD TO CONTO.
           IF MAST NOT = OLDMS PERFORM RSTM THRU EX-RSTM.
           IF CAPC NOT = OLDCN PERFORM RSTC THRU EX-RSTC.
           PERFORM RADC THRU EX-RADC.
           IF IF-TPLIV = 3 PERFORM RSTS THRU EX-RSTS.
      **** rel 6.2
           IF IF-FLMLI = 1 PERFORM STAMPA-MLI THRU EX-STAMPA-MLI.
      ************
      *
           COPY 'grirpt-r'.
      *
      **** rel 6.2
           MOVE ZERO TO FLSTAMP.
      **********
           GO TO LEGG.
       FINES.
           PERFORM RGEN THRU EX-RGEN.
      *
           GO TO EX-RUN-ELABORA1.
       LP10.
           MOVE 1  TO CATEG.
           MOVE 99 TO CAT99.
       RCAT.
           MOVE 1 TO RP-JMP.
           MOVE ZERO TO TOTANP.
           MOVE KAZ-COD TO KCF-AZI.
           IF IF-TPSTA = 1 MOVE MCLI TO MAS.
           IF IF-TPSTA = 2 MOVE MFOR TO MAS.
           MOVE IF-CLF-1 TO COD.
           MOVE CODCLF TO KCF-COD.
           START ANACLF KEY NOT < KEYCF INVALID GO TO SCLF.
       RCLF.
           READ ANACLF NEXT INTO REKCLF AT END GO TO SCLF.
           IF SF-CLF = '9D' OR '9A' OR '35' GO TO RCLF.
           IF CLF-AZI > KAZ-COD GO TO SCLF.
           IF CLF-MS > MAS GO TO SCLF.
           IF CLF-CD > IF-CLF-2 GO TO SCLF.
           IF CLF-CATCON = ZERO MOVE 1 TO CLF-CATCON.
           IF CLF-CATCON = CATEG GO TO RCLF0.
           IF CLF-CATCON > CATEG AND
              CLF-CATCON < CAT99 MOVE CLF-CATCON TO CAT99.
           GO TO RCLF.
       RCLF0.
           IF IF-FL NOT = ZERO OR IF-FLRIP = ZERO
                         MOVE ZERO TO CL2-SESP GO TO RCLF0-90.
           MOVE KCF-AZI TO KCX-AZI.
           MOVE KCF-COD TO KCX-COD.
           READ ANACFX INTO REKCL2 INVALID MOVE ZERO TO CL2-SESP
                                                  GO TO RCLF0-90.
           IF SF-CFX = '9D' OR '9A' OR '35' MOVE RF-CFX TO REKCL2.
           COMPUTE CL2-SESP = CL2-SESP + CL2-SE-D - CL2-SE-A.
       RCLF0-90.
           MOVE CL2-SESP TO LTCAP.
           ADD  CL2-SESP TO TOTANP.
           IF IF-FLBIL = 1 SUBTRACT CLF-SESP FROM CLF-SPSP
                           MOVE CLF-SESP TO LTCAS
                           MOVE ZERO     TO LTCAD LTCAA
           ELSE PERFORM D00-BILCOM THRU D99.

           COMPUTE CLVD = CLF-SP-D + LTCAD.
           COMPUTE CLVA = CLF-SP-A + LTCAA.
           COMPUTE CLVS = CLF-SPSP + LTCAS.
           IF IF-TPCON = 1 AND CLVD = ZERO AND CLVA = ZERO
              AND CLVS = ZERO AND LTCAP = ZERO
              GO TO NO-CLF.

           MOVE CLF-RGSOC TO RG2.
      **** rel 6.2
           MOVE 1 TO FLSTAMP.
      **********
           MOVE CLF-MS TO RGM.
           MOVE CLF-CD TO RGC.
           IF IF-TPBIL = ZERO
              MOVE CLF-SPSP TO RG31
              IF IF-LIREUR = 1
                 MOVE CLF-SPSP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERG31.
           MOVE CLF-SP-D TO RG32.
           IF IF-LIREUR = 1
              MOVE CLF-SP-D TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG32.
           MOVE CLF-SP-A TO RG33.
           IF IF-LIREUR = 1
              MOVE CLF-SP-A TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG33.
           SUBTRACT CLVA FROM CLVD GIVING RG34.
           IF IF-LIREUR = 1
              SUBTRACT CLVA FROM CLVD GIVING ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG34.
           COMPUTE CLVS = CLVS + CLVD - CLVA.
           IF IF-TPBIL = ZERO
              MOVE CLVS TO RG35
              IF IF-LIREUR = 1
                 MOVE CLVS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERG35.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF LTCAS = ZERO AND LTCAD = ZERO AND LTCAA = ZERO
              AND LTCAP = ZERO
              GO TO SCL1.
           IF IF-TPBIL = 1 AND LTCAD = ZERO AND LTCAA = ZERO
              GO TO SCL1.
           IF LTCAS = ZERO AND LTCAD = ZERO AND LTCAA = ZERO
                                                 GO TO SCL01.
           MOVE 'APERTURA' TO RGA.
           IF IF-TPBIL = ZERO
              MOVE LTCAS TO R2G31
              IF IF-LIREUR = 1
                 MOVE LTCAS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ER2G31.
           MOVE LTCAD TO R2G32.
           IF IF-LIREUR = 1
              MOVE LTCAD TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G32.
           MOVE LTCAA TO R2G33.
           IF IF-LIREUR = 1
              MOVE LTCAA TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G33.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
       SCL01.
           IF LTCAP = ZERO GO TO SCL1.
           ADD LTCAP TO CLVS.
           MOVE 'ESER.PREC.' TO RGA.
           MOVE LTCAP TO R2G31.
           IF IF-LIREUR = 1
              MOVE LTCAP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G31.
           MOVE CLVS  TO R2G35.
           IF IF-LIREUR = 1
              MOVE CLVS TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G35.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
       SCL1.
           ADD CLF-SP-D TO TGPD.
           ADD CLF-SP-A TO TGPA.
           ADD CLF-SPSP TO TGPS.
           ADD LTCAD    TO TGAD.
           ADD LTCAA    TO TGAA.
           ADD LTCAS    TO TGAS.
           ADD LTCAP    TO TGYY.
       NO-CLF.
           GO TO RCLF.
       SCLF.
           IF TGAS = ZERO AND
              TGAD = ZERO AND
              TGAA = ZERO AND
              TGPS = ZERO AND
              TGPD = ZERO AND
              TGYY = ZERO AND
              TGPA = ZERO GO TO SCLF1.
      * riga vuota per carattere
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           PERFORM RGEN1 THRU EX-RGEN.
       SCLF1.
           IF CAT99 = 99 GO TO SCLF2.
           MOVE CAT99 TO CATEG.
           MOVE 99 TO CAT99.
           GO TO RCAT.
       SCLF2.
      *
       EX-RUN-ELABORA1.
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
      *
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       RAZZ.
           MOVE ZERO TO AREEK.
           MOVE ZERO TO CLAV CLVS CLVD CLVA.
       RAZZ1.
           MOVE ZERO TO TCYY TMYY TGYY LTCAP TOTANP.
           MOVE ZERO TO TGPD TGPA TGPS TGAD TGAA TGAS
                        TMPD TMPA TMPS TMAD TMAA TMAS
                        TCPD TCPA TCPS TCAD TCAA TCAS.
       EX-RAZZ.
           EXIT.
      *------------------
       C00-BILCOM.
           MOVE ZERO TO CON-SP-D CON-SP-A LTCAD LTCAA.
           IF PKDT1 > AZI-RVDT MOVE CON-SESP TO LTCAS
              SUBTRACT CON-SESP FROM CON-SPSP GO TO C40.
           MOVE ZERO TO CON-SPSP LTCAS.
           MOVE LOW-VALUE TO KEYMX.
           MOVE KPC-AZI TO KMX-AZI.
           MOVE KPC-COD TO KMX-CON.
           IF IF-TPBIL = ZERO MOVE AZI-DTAPE TO KMX-DAT
           ELSE           MOVE PKDT1     TO KMX-DAT.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO C40.
       C10.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO C40.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO C10.
           IF KMX-AZI > KPC-AZI GO TO C40.
           IF KMX-CON > KPC-COD GO TO C40.
           IF KMX-DAT NOT < PKDT1 GO TO C20.
           IF MOV-CAUS > 899 AND < 951 GO TO C15.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CON-SPSP
           ELSE SUBTRACT MOV-IMPO FROM CON-SPSP.
           GO TO C10.
       C15.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LTCAS
           ELSE SUBTRACT MOV-IMPO FROM LTCAS.
           GO TO C10.
       C20.
           IF KMX-DAT > PKDT2 GO TO C40.
           IF MOV-CAUS > 899 AND < 951 GO TO C25.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CON-SP-D
           ELSE ADD MOV-IMPO TO CON-SP-A.
           GO TO C10.
       C25.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LTCAD
           ELSE ADD MOV-IMPO TO LTCAA.
           GO TO C10.
       C40.
           MOVE LOW-VALUE TO KEYMV.
           MOVE KPC-AZI TO KMV-AZI.
           MOVE KPC-COD TO KMV-CON.
           IF IF-TPBIL = ZERO MOVE ZERO TO KMV-DAT
           ELSE MOVE PKDT1 TO KMV-DAT.
           START MOVIME KEY NOT < KEYMV INVALID GO TO C99.
       C50.
           READ MOVIME NEXT INTO REKMOV AT END GO TO C99.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO C50.
           IF KMV-AZI > KPC-AZI GO TO C99.
           IF KMV-CON > KPC-COD GO TO C99.
           IF KMV-DAT NOT < PKDT1 GO TO C60.
           IF MOV-CAUS > 899 AND < 951 GO TO C55.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CON-SPSP
           ELSE SUBTRACT MOV-IMPO FROM CON-SPSP.
           GO TO C50.
       C55.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LTCAS
           ELSE SUBTRACT MOV-IMPO FROM LTCAS.
           GO TO C50.
       C60.
           IF KMV-DAT > PKDT2 GO TO C99.
           IF MOV-CAUS > 899 AND < 951 GO TO C65.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CON-SP-D
           ELSE ADD MOV-IMPO TO CON-SP-A.
           GO TO C50.
       C65.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LTCAD
           ELSE ADD MOV-IMPO TO LTCAA.
           GO TO C50.
       C99.
           EXIT.
      *------------------
       D00-BILCOM.
           MOVE ZERO TO CLF-SP-D CLF-SP-A LTCAD LTCAA.
           IF PKDT1 > AZI-RVDT MOVE CLF-SESP TO LTCAS
              SUBTRACT CLF-SESP FROM CLF-SPSP GO TO D40.
           MOVE ZERO TO CLF-SPSP LTCAS.
           MOVE LOW-VALUE TO KEYSX.
           MOVE KCF-AZI TO KSX-AZI.
           MOVE KCF-COD TO KSX-CON.
           IF IF-TPBIL = ZERO MOVE AZI-DTAPE TO KSX-DAT
           ELSE           MOVE     PKDT1 TO KSX-DAT.
           START MOVSXX KEY NOT < KEYSX INVALID GO TO D40.
       D10.
           READ MOVSXX NEXT INTO REKMOV AT END GO TO D40.
           IF SF-MSX = '9D' OR '9A' OR '35' GO TO D10.
           IF KSX-AZI > KCF-AZI GO TO D40.
           IF KSX-CON > KCF-COD GO TO D40.
           IF KSX-DAT NOT < PKDT1 GO TO D20.
           IF MOV-CAUS > 899 AND < 951 GO TO D15.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CLF-SPSP
           ELSE SUBTRACT MOV-IMPO FROM CLF-SPSP.
           GO TO D10.
       D15.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LTCAS
           ELSE SUBTRACT MOV-IMPO FROM LTCAS.
           GO TO D10.
       D20.
           IF KSX-DAT > PKDT2 GO TO D40.
           IF MOV-CAUS > 899 AND < 951 GO TO D25.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CLF-SP-D
           ELSE ADD MOV-IMPO TO CLF-SP-A.
           GO TO D10.
       D25.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LTCAD
           ELSE ADD MOV-IMPO TO LTCAA.
           GO TO D10.
       D40.
           MOVE LOW-VALUE TO KEYMS.
           MOVE KCF-AZI TO KMS-AZI.
           MOVE KCF-COD TO KMS-CON.
           MOVE ZERO    TO KMS-DAT.
           IF IF-TPBIL = ZERO MOVE ZERO  TO KMS-DAT
           ELSE           MOVE PKDT1 TO KMS-DAT.
           START MOVSEZ KEY NOT < KEYMS INVALID GO TO D99.
       D50.
           READ MOVSEZ NEXT INTO REKMOV AT END GO TO D99.
           IF SF-MSZ = '9D' OR '9A' OR '35' GO TO D50.
           IF KMS-AZI > KCF-AZI GO TO D99.
           IF KMS-CON > KCF-COD GO TO D99.
           IF KMS-DAT NOT < PKDT1 GO TO D60.
           IF MOV-CAUS > 899 AND < 951 GO TO D55.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CLF-SPSP
           ELSE SUBTRACT MOV-IMPO FROM CLF-SPSP.
           GO TO D50.
       D55.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LTCAS
           ELSE SUBTRACT MOV-IMPO FROM LTCAS.
           GO TO D50.
       D60.
           IF KMS-DAT > PKDT2 GO TO D99.
           IF MOV-CAUS > 899 AND < 951 GO TO D65.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CLF-SP-D
           ELSE ADD MOV-IMPO TO CLF-SP-A.
           GO TO D50.
       D65.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LTCAD
           ELSE ADD MOV-IMPO TO LTCAA.
           GO TO D50.
       D99.
           EXIT.
      *------------------
       RGEN.
           PERFORM RSTM THRU EX-RSTM.
           IF IF-TPLIV = 1
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
       RGEN1.
           IF IF-TPSTA = ZERO
              MOVE 'T O T A L I   G E N E R A L I' TO R3TOT
           ELSE MOVE 'T O T A L I   C A T E G O R I A   ' TO R3TOT
                MOVE CATEG TO R3GA.
           IF IF-TPBIL = ZERO
              MOVE TGPS TO R3G31
              IF IF-LIREUR = 1
                 MOVE TGPS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ER3G31.
           MOVE TGPD TO R3G32.
           IF IF-LIREUR = 1
              MOVE TGPD TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3G32.
           MOVE TGPA TO R3G33.
           IF IF-LIREUR = 1
              MOVE TGPA TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3G33.
           COMPUTE CLVS = TGPS + TGAS.
           COMPUTE CLVS = CLVS + TGYY.
           COMPUTE CLVD = TGPD + TGAD.
           COMPUTE CLVA = TGPA + TGAA.
           SUBTRACT CLVA FROM CLVD GIVING R3G34.
           IF IF-LIREUR = 1
              SUBTRACT CLVA FROM CLVD GIVING ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3G34.
           COMPUTE CLVS = CLVS + CLVD - CLVA.
           IF IF-TPBIL = ZERO
              MOVE CLVS TO R3G35
              IF IF-LIREUR = 1
                 MOVE CLVS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ER3G35.
      *
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF TGAS = ZERO AND TGAD = ZERO AND TGAA = ZERO
           AND TGYY = ZERO
              GO TO RGEN2.
           IF TGAS = ZERO AND TGAD = ZERO AND TGAA = ZERO
                                            GO TO RGEN1-0.
           IF IF-TPBIL = ZERO
              MOVE TGAS TO R3G31
              IF IF-LIREUR = 1
                 MOVE TGAS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ER3G31.
           MOVE TGAD TO R3G32.
           IF IF-LIREUR = 1
              MOVE TGAD TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3G32.
           MOVE TGAA TO R3G33.
           IF IF-LIREUR = 1
              MOVE TGAA TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3G33.
      *
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
       RGEN1-0.
           IF TOTANP = ZERO GO TO RGEN2.
           MULTIPLY -1 BY TOTANP.
           MOVE 'DIFFERENZA ESERCIZIO PRECEDENTE ' TO R3TOT.
           MOVE TOTANP TO R3G35.
           IF IF-LIREUR = 1
              MOVE TOTANP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3G35.
      *
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'T O T A L I   E S E R C I Z I O' TO R3TOT.
           ADD TOTANP TO CLVS.
           MOVE CLVS TO R3G35.
           IF IF-LIREUR = 1
              MOVE CLVS TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3G35.
           MOVE TGPD TO R3G32.
           IF IF-LIREUR = 1
              MOVE TGPD TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3G32.
           MOVE TGPA TO R3G33.
           IF IF-LIREUR = 1
              MOVE TGPA TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3G33.
           COMPUTE CLVD = TGPD + TGAD.
           COMPUTE CLVA = TGPA + TGAA.
           SUBTRACT CLVA FROM CLVD GIVING R3G34.
           IF IF-LIREUR = 1
              SUBTRACT CLVA FROM CLVD GIVING ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3G34.
      *
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
       RGEN2.
           MOVE ZERO TO CLX.
           MOVE ZERO TO TGYY.
       EX-RGEN.
           EXIT.
      *--------------*
       RSTC.
           MOVE ZERO TO K.
       LOPC.
           ADD 1 TO K.
           IF K > 6 GO TO ENDC.
           ADD TCXX (K) TO TMXX (K).
           GO TO LOPC.
       ENDC.
           ADD TCYY TO TMYY.
      *    MOVE ZERO TO K.
           IF OLDCN = ZERO GO TO NO-CAP.
           IF IF-TPLIV = 1 GO TO NO-CAP.
           COMPUTE CLVS = TCPS + TCAS.
           COMPUTE CLVD = TCPD + TCAD.
           COMPUTE CLVA = TCPA + TCAA.
           IF IF-TPCON = 1 AND
              CLVD = ZERO AND CLVA = ZERO AND CLVS = ZERO
              AND TCYY = ZERO
              GO TO NO-CAP.
           MOVE OLDMS TO RGM.
           MOVE OLDCN TO RGC.
      **** rel 6.2
      *    MOVE RGCN TO RG2.
           MOVE KEYPC  TO COMCONK.
      **** rel 6.3
           MOVE REKCON TO COMREKCON.
      ************
           MOVE IF-AZI TO KPC-AZI.
           MOVE ZERO   TO COMCOD.
           MOVE OLDMS  TO COMMS.
           MOVE OLDCN  TO COMCP.
           MOVE ZERO   TO COMST.
           MOVE COMCOD TO KPC-COD.
           READ ANACON INTO REKCON INVALID 
                       MOVE ALL '*' TO CON-DESCR.
           MOVE CON-DESCR TO RG2.
           MOVE 1 TO FLSTAMP.
           MOVE COMCONK   TO KEYPC.
           READ ANACON INTO REKCON INVALID 
                       PERFORM INVK-CON
                       GO TO ERRIO.
      **********
      **** rel 6.3
           MOVE COMREKCON TO REKCON. *> poich fa conti direttamente su campi di record
      ************
      *
           IF IF-TPBIL = ZERO
              MOVE TCPS TO RG31
              IF IF-LIREUR = 1
                 MOVE TCPS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERG31.
           MOVE TCPD TO RG32.
           IF IF-LIREUR = 1
              MOVE TCPD TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG32.
           MOVE TCPA TO RG33.
           IF IF-LIREUR = 1
              MOVE TCPA TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG33.
           SUBTRACT CLVA FROM CLVD GIVING RG34.
           IF IF-LIREUR = 1
              SUBTRACT CLVA FROM CLVD GIVING ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG34.
           COMPUTE CLVS = CLVS + CLVD - CLVA.
           IF IF-TPBIL = ZERO
              MOVE CLVS TO RG35
              IF IF-LIREUR = 1
                 MOVE CLVS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERG35.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF TCAS = ZERO AND TCAD = ZERO AND TCAA = ZERO
              AND TCYY = ZERO
              GO TO RSTC0.
           IF IF-TPBIL = 1 AND TCAD = ZERO AND TCAA = ZERO
              GO TO RSTC0.
           IF TCAS = ZERO AND TCAD = ZERO AND TCAA = ZERO
                                             GO TO RST0C.
           MOVE 'APERTURA' TO RGA.
           IF IF-TPBIL = ZERO
              MOVE TCAS TO R2G31
              IF IF-LIREUR = 1
                 MOVE TCAS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ER2G31.
           MOVE TCAD TO R2G32.
           IF IF-LIREUR = 1
              MOVE TCAD TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G32.
           MOVE TCAA TO R2G33.
           IF IF-LIREUR = 1
              MOVE TCAA TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G33.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
       RST0C.
           IF TCYY = ZERO GO TO RSTC0.
           IF IF-TPBIL NOT = ZERO GO TO RSTC0.
           ADD TCYY TO CLVS.
           MOVE 'ESER.PREC.' TO RGA.
           MOVE TCYY TO R2G31.
           IF IF-LIREUR = 1
              MOVE TCYY TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G31.
           MOVE CLVS TO R2G35.
           IF IF-LIREUR = 1
              MOVE CLVS TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G35.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
       RSTC0.
           IF IF-TPLIV > 2
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
       NO-CAP.
      *
           MOVE ZERO TO K.
       RSTC1.
           ADD 1 TO K.
           IF K < 7 MOVE ZERO TO TCXX (K) GO TO RSTC1.
           MOVE ZERO TO TCYY.
           MOVE CAPC TO OLDCN.
           MOVE CON-DESCR TO RGCN.
       EX-RSTC.
           EXIT.
      *--------------*
       RSTM.
           PERFORM RSTC THRU EX-RSTC.
           MOVE ZERO TO K.
       LOPM.
           ADD 1 TO K.
           IF K > 6 GO TO ENDM.
           ADD TMXX (K) TO TGXX(K).
           GO TO LOPM.
       ENDM.
           ADD TMYY TO TGYY.
           IF OLDMS = ZERO GO TO NO-MAS.

           COMPUTE CLVS = TMPS + TMAS.
           COMPUTE CLVD = TMPD + TMAD.
           COMPUTE CLVA = TMPA + TMAA.
           IF IF-TPCON = 1 AND
              CLVD = ZERO AND CLVA = ZERO AND CLVS = ZERO
              AND TMYY = ZERO
              GO TO NO-MAS.
      *
           MOVE OLDMS TO RGM.
      **** rel 6.2
      *    MOVE RGMS TO RG2.
           MOVE KEYPC     TO COMCONK.
      **** rel 6.3
           MOVE REKCON    TO COMREKCON.
      ************
           MOVE IF-AZI    TO KPC-AZI.
           MOVE ZERO      TO COMCOD.
           MOVE OLDMS     TO COMMS.
           MOVE ZERO      TO COMCP.
           MOVE ZERO      TO COMST.
           MOVE COMCOD    TO KPC-COD.
           READ ANACON    INTO REKCON INVALID 
                          MOVE ALL '*' TO CON-DESCR.
           MOVE CON-DESCR TO RG2.
           MOVE 1 TO FLSTAMP.
           MOVE COMCONK   TO KEYPC.
           READ ANACON    INTO REKCON INVALID 
                          PERFORM INVK-CON
                          GO TO ERRIO.
      **********
      **** rel 6.3
           MOVE COMREKCON TO REKCON. *> poich fa conti direttamente su campi di record
      ************
      *
           IF IF-TPBIL = ZERO
              MOVE TMPS TO RG31
              IF IF-LIREUR = 1
                 MOVE TMPS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERG31.
           MOVE TMPD TO RG32.
           IF IF-LIREUR = 1
              MOVE TMPD TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG32.
           MOVE TMPA TO RG33.
           IF IF-LIREUR = 1
              MOVE TMPA TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG33.
           SUBTRACT CLVA FROM CLVD GIVING RG34.
           IF IF-LIREUR = 1
              SUBTRACT CLVA FROM CLVD GIVING ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG34.
           COMPUTE CLVS = CLVS + CLVD - CLVA.
           IF IF-TPBIL = ZERO
              MOVE CLVS TO RG35
              IF IF-LIREUR = 1
                 MOVE CLVS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERG35.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF TMAS = ZERO AND TMAD = ZERO AND TMAA = ZERO
              AND TMYY = ZERO
              GO TO SOTTO.
           IF IF-TPBIL = 1 AND TMAD = ZERO AND TMAA = ZERO
              GO TO SOTTO.
           IF IF-TPBIL = ZERO AND TMAD = ZERO AND TMAA = ZERO
                                               GO TO RS0M.
           MOVE 'APERTURA' TO RGA.
           IF IF-TPBIL = ZERO
              MOVE TMAS TO R2G31
              IF IF-LIREUR = 1
                 MOVE TMAS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ER2G31.
           MOVE TMAD TO R2G32.
           IF IF-LIREUR = 1
              MOVE TMAD TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G32.
           MOVE TMAA TO R2G33.
           IF IF-LIREUR = 1
              MOVE TMAA TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G33.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
       RS0M.
           IF TMYY = ZERO GO TO SOTTO.
           IF IF-TPBIL NOT = ZERO GO TO SOTTO.
           COMPUTE CLVS = CLVS + TMYY.
           MOVE 'ESER.PREC.' TO RGA.
           MOVE TMYY TO R2G31.
           IF IF-LIREUR = 1
              MOVE TMYY TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G31.
           MOVE CLVS TO R2G35.
           IF IF-LIREUR = 1
              MOVE CLVS TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G35.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
       SOTTO.
           IF IF-TPLIV > 1
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
       NO-MAS.
           MOVE MAST TO OLDMS.
           MOVE CAPC TO OLDCN.
           MOVE CON-DESCR TO RGMS.
           MOVE ZERO TO K.
       ALTRO.
           ADD 1 TO K.
           IF K > 6 MOVE ZERO TO TCYY TMYY GO TO EX-RSTM.
           MOVE ZERO TO TMXX (K) TCXX (K).
           GO TO ALTRO.
       EX-RSTM.
           EXIT.
      *--------------*
       RADC.
           MOVE ZERO TO K.
       LADC.
           ADD 1 TO K.
           IF K > 3 GO TO LAD1.
           MOVE CON-SXYY (K) TO CLAV.
           ADD CLAV TO TCXX (K).
           GO TO LADC.
       LAD1.
           ADD LTCAD TO TCXX (4).
           ADD LTCAA TO TCXX (5).
           ADD LTCAS TO TCXX (6).
           ADD LTCAP TO TCYY.
       EX-RADC.
           EXIT.
      *--------------*
       RSTS.
           IF SOTT = ZERO GO TO EX-RSTS.
       RST1.
           COMPUTE CLVD = CON-SP-D + LTCAD.
           COMPUTE CLVA = CON-SP-A + LTCAA.
           COMPUTE CLVS = CON-SPSP + LTCAS.
           IF IF-TPCON = 1 AND
              CLVD = ZERO AND CLVA = ZERO AND CLVS = ZERO
              AND LTCAP = ZERO
              GO TO EX-RSTS.
           IF IF-TPBIL = ZERO
              MOVE CON-SPSP TO RG31
              IF IF-LIREUR = 1
                 MOVE CON-SPSP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERG31.
           MOVE CON-SP-D TO RG32.
           IF IF-LIREUR = 1
              MOVE CON-SP-D TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG32.
           MOVE CON-SP-A TO RG33.
           IF IF-LIREUR = 1
              MOVE CON-SP-A TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG33.
           SUBTRACT CLVA FROM CLVD GIVING RG34.
           IF IF-LIREUR = 1
              SUBTRACT CLVA FROM CLVD GIVING ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG34.
           COMPUTE CLVS = CLVS + CLVD - CLVA.
           IF IF-TPBIL = ZERO
              MOVE CLVS TO RG35
              IF IF-LIREUR = 1
                 MOVE CLVS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERG35.
           MOVE MAST TO RGM.
           MOVE CAPC TO RGC.
           MOVE SOTT TO RGS.
           MOVE CON-DESCR TO RG2.
      **** rel 6.2
           MOVE 1 TO FLSTAMP.
      **********
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF LTCAS = ZERO AND LTCAD = ZERO AND LTCAA = ZERO
              AND LTCAP = ZERO
              GO TO RST2.
           IF IF-TPBIL = 1 AND LTCAD = ZERO AND LTCAA = ZERO
              GO TO RST2.
           IF LTCAS = ZERO AND LTCAD = ZERO AND LTCAA = ZERO
                                                  GO TO RST0.
           MOVE 'APERTURA' TO RGA.
           IF IF-TPBIL = ZERO
              MOVE LTCAS TO R2G31
              IF IF-LIREUR = 1
                 MOVE LTCAS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ER2G31.
           MOVE LTCAD    TO R2G32.
           IF IF-LIREUR = 1
              MOVE LTCAD TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G32.
           MOVE LTCAA    TO R2G33.
           IF IF-LIREUR = 1
              MOVE LTCAA TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G33.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
       RST0.
           IF LTCAP = ZERO GO TO RST2.
           IF IF-TPBIL NOT = ZERO GO TO RST2.
           ADD LTCAP TO CLVS.
           MOVE 'ESER.PREC.' TO RGA.
           MOVE LTCAP TO R2G31.
           IF IF-LIREUR = 1
              MOVE LTCAP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G31.
           MOVE CLVS  TO R2G35.
           IF IF-LIREUR = 1
              MOVE CLVS TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2G35.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
       RST2.
      **** rel 6.2
           MOVE CONTO TO OLDCONTO.
      ************
       EX-RSTS.
           EXIT.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Conto' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Saldo Prec.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Periodo Dare' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Periodo Avere' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Periodo Saldo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Saldo Attuale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
      *--------------*
      **** rel 6.2
       STAMPA-MLI.
           MOVE ZERO TO SAVCONTO CDMLI CLVD CLVA.
           MOVE LOW-VALUE TO KEYMLI.
           MOVE KPC-AZI   TO KMLI-AZI.
           MOVE KPC-COD   TO KMLI-CONTO.
           MOVE ZERO      TO KMLI-PRG.
           START MOVLIB KEY NOT < SKEYMLI1 INVALID GO TO END-MLI.
       RDNX-MLI.
           READ MOVLIB NEXT AT END GO TO END-MLI.
           IF SF-MLI = '9D' OR '9A' OR '35' GO TO RDNX-MLI.
           IF KMLI-AZI   > KPC-AZI GO TO END-MLI.
           IF KMLI-CONTO > KPC-COD GO TO END-MLI.
           IF MLI-DARE = ZERO AND  MLI-AVERE = ZERO GO TO RDNX-MLI.
           IF IF-FLBIL = ZERO
              IF MLI-DATA > PKDT2 GO TO RDNX-MLI.
      **** rel 6.3
           IF MLI-VALID = 1
              IF IF-FLBIL = ZERO
                 IF NOT (MLI-DTVALID < PKDT1 OR > PKDT2) GO TO RDNX-MLI
                 END-IF
              ELSE
                 IF NOT (MLI-DTVALID > PKDAT) GO TO RDNX-MLI.
      ************
           IF IF-TPBIL NOT = ZERO
              IF MLI-DATA < PKDT1 OR
                 MLI-DATA > PKDT2 GO TO RDNX-MLI.

      *> stampa sintetica
           IF IF-TPMLI = ZERO AND KMLI-CONTO NOT = SAVCONTO
              PERFORM STAMPA THRU EX-STAMPA
              MOVE ZERO TO CLVD CLVA
              GO TO SOMMA.

      *> stampa analitica
           IF IF-TPMLI = 1
              MOVE MLI-DARE   TO CLVD
              MOVE MLI-AVERE  TO CLVA
              MOVE KMLI-CONTO TO SAVCONTO
              PERFORM STAMPA THRU EX-STAMPA.
       SOMMA.
           IF IF-TPMLI = ZERO
              ADD MLI-DARE  TO CLVD
              ADD MLI-AVERE TO CLVA.

           IF IF-FLBIL = 1 OR
              (IF-FLBIL = ZERO AND MLI-DATA > PKDT1)
              MOVE MLI-DARE TO CLAV
              ADD CLAV TO TCXX (1)
              MOVE MLI-AVERE TO CLAV
              ADD CLAV TO TCXX (2).

           IF IF-FLBIL = ZERO AND MLI-DATA < PKDT1
                 SUBTRACT MLI-AVERE FROM MLI-DARE GIVING CLAV
                 ADD CLAV TO TCXX (3).
           GO TO RDNX-MLI.
       END-MLI.
           IF IF-TPMLI = ZERO PERFORM STAMPA THRU EX-STAMPA.
       EX-STAMPA-MLI.
           EXIT.
      *--------------*
       STAMPA.
           IF SAVCONTO = ZERO GO TO S90.
           IF CLVD = ZERO AND CLVA = ZERO GO TO EX-STAMPA.
           IF IF-TPLIV NOT = 3 GO TO EX-STAMPA.

           IF NOT (SAVCONTO = CDMLI OR OLDCONTO)
              MOVE SAVCONTO TO CDMLI
              MOVE MSMLI TO RGM
              MOVE CPMLI TO RGC
              MOVE STMLI TO RGS.
           IF FLSTAMP = ZERO
              MOVE SAVCONTO TO CON-COD
              READ ANACON INTO  REKCON INVALID MOVE ALL '*' TO RG2 
              END-READ
              MOVE CON-DESCR TO RG2
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
           MOVE 1 TO FLSTAMP.
           IF IF-TPMLI = ZERO MOVE '(Extra-Contabile)' TO RG2
           ELSE MOVE MLI-DESCR TO RG2.

           IF IF-FLBIL = ZERO
              IF MLI-DATA NOT < PKDT1
                 MOVE ZERO TO RG31.

           IF IF-FLBIL = ZERO
              IF MLI-DATA < PKDT1
                 SUBTRACT CLVA FROM CLVD GIVING RG31
                 IF IF-LIREUR = 1
                    SUBTRACT CLVA FROM CLVD GIVING ER-IMPORTO
                    CALL 'rlitimp' USING ER-IMPORTO
                    MOVE ER-IMPORTO TO ERG31
                 END-IF
                 COMPUTE CLVS = CLVS + CLVD - CLVA
                 MOVE ZERO TO CLVD CLVA.
      *********************************************
      *> dare
           MOVE CLVD TO RG32.
           IF IF-LIREUR = 1
              MOVE CLVD TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG32.
      *> avere
           MOVE CLVA TO RG33.
           IF IF-LIREUR = 1
              MOVE CLVA TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG33.
      *> saldo
           SUBTRACT CLVA FROM CLVD GIVING RG34.
           IF IF-LIREUR = 1
              SUBTRACT MLI-AVERE FROM MLI-DARE GIVING ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERG34.
      *> saldo  attuale
           IF (IF-FLBIL = 1) OR
              (IF-FLBIL = ZERO AND MLI-DATA > PKDT1)
                 COMPUTE CLVS = CLVS + CLVD - CLVA.
           IF IF-TPBIL = ZERO
              MOVE CLVS TO RG35
              IF IF-LIREUR = 1
                 MOVE CLVS TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERG35.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
       S90.
           MOVE KMLI-CONTO TO SAVCONTO.
       EX-STAMPA.
           EXIT.
      *--------------*
      ************
