       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON310.
      *
      * Chiusura/apertura clienti/fornitori
      *
      **** rel 7.2
      * Ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'griclfsl'.
           COPY 'gricolsl'.
           COPY 'griazlsl'.
           COPY 'grimolsl'.
           COPY 'grimszsl'.
           COPY 'grimslsl'.
           COPY 'grimovsl'.
           COPY 'gricfxsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'griclf'.
           COPY 'gricol'.
           COPY 'griazl'.
           COPY 'grimol'.                                         
           COPY 'grimsz'.                                         
           COPY 'grimsl'.                                         
           COPY 'grimov'.                                         
           COPY 'gricfx'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griconrk'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'grit20rk'.
           COPY 'grimovrk'.                                       
           COPY 'grit14g'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parmb'.
      **** rel 7.1
           COPY 'parppar'.
      ************
       01  REKCOM.
           05 COM-KEYID.
              10 COM-AZI PIC 999.
              10 COM-CON PIC 9(7) COMP-3.
              10 COM-DAT PIC 9(5) COMP-3.
              10 COM-NUM PIC 9(5) COMP-3.
           05 COM-CAUS   PIC 999  COMP-3.
           05 COM-D-A    PIC X.
           05 COM-TREG   PIC 9.
      **** rel 4.0
      *    05 COM-IMPO   PIC S9(11) COMP-3.
           05 COM-IMPO   PIC S9(11)V99 COMP-3.
      ************
           05 COM-NDOC   PIC 9(5) COMP-3.
           05 COM-DTDOC  PIC 9(5) COMP-3.
           05 COM-DTSCD  PIC 9(5) COMP-3.
           05 COM-NPRGI  PIC 9(5) COMP-3.
           05 COM-FLAG   PIC 9.
      **** rel 4.0
      *    05 COM-DSAGG.
      *       10 COM-IVA PIC 999.
      *       10 COM-ACF PIC 9(7) COMP-3.
      *       10 COM-TIP PIC 9.
      *       10 COM-IMP PIC S9(11).
      *       10 COM-IVN PIC S9(11).
      *    05 COM-DSCEE REDEFINES COM-DSAGG.
      *       10 FILLER  PIC X(8).
      *       10 COM-IMV PIC S9(11)V99 COMP-3.
      *       10 COM-IML PIC S9(11) COMP-3.
      *       10 COM-INL PIC S9(11) COMP-3.
      *       10 COM-VAL PIC 9(3)   COMP-3.
      *       10 FILLER  PIC X.
           05 COM-FILL1.
              10 COM-IVA PIC 999.
              10 COM-ACF PIC 9(7) COMP-3.
              10 COM-TIP PIC 9.
              10 COM-IMP PIC S9(11)V99.
              10 COM-IVN PIC S9(11)V99.
           05 COM-FILL2 REDEFINES COM-FILL1.
              10 COM-DSAGG PIC X(30).
              10 FILLER    PIC X(4).
           05 COM-DSCEE REDEFINES COM-FILL1.
              10 FILLER  PIC X(8).
              10 COM-IMV PIC S9(11)V99 COMP-3.
              10 COM-IML PIC S9(11)V99 COMP-3.
              10 COM-INL PIC S9(11)V99 COMP-3.
              10 COM-VAL PIC 9(3)      COMP-3.
              10 FILLER  PIC X(3).
      ************
           05 COM-PART   PIC 9(7) COMP-3.
           05 COM-NREG   PIC 9(5).
           05 COM-CATT   PIC X.
           05 COM-FEV    PIC 9.
           05 COM-PLAF.
              10 COM-MES PIC 99.
              10 COM-ANN PIC 9.
           05 COM-VALUT  PIC 9(3).
      **** rel 4.0
      *    05 COM-CAMGG  PIC 9999V999.
           05 COM-CAMGG  PIC 9(5)V9(6).
      ************
           05 COM-IMVAL  PIC S9(11)V99.
           05 COM-CCOST  PIC X(4).
      **** rel 4.0
      *    05 FILLER     PIC X(13).
           05 COM-FLGPC  PIC 9.
           05 COM-FLGE2  PIC 9.
           05 FILLER     PIC X(12).
      ************
      **** rel 4.0
      *01  REKCFX.
      *    05 CFX-KEYID.
      *       10 CFX-AZI  PIC 999   VALUE ZERO.
      *       10 CFX-COD.
      *          15 CFX-MS PIC 99   VALUE ZERO.
      *          15 CFX-CD PIC 9(5) VALUE ZERO.
      *    05 CFX-RGSOC   PIC X(36) VALUE SPACE.
      *    05 CFX-RGSOC2  PIC X(36) VALUE SPACE.
      *    05 CFX-INDIR   PIC X(24) VALUE SPACE.
      *    05 CFX-INDIR2  PIC X(24) VALUE SPACE.
      *    05 CFX-CAP     PIC 9(5)  VALUE ZERO.
      *    05 CFX-CITTA   PIC X(26) VALUE SPACE.
      *    05 CFX-PIVA    PIC 9(11) COMP-3 VALUE ZERO.
      *    05 CFX-CFISC.
      *       10 CFX-CFP  PIC X(11) VALUE SPACE.
      *       10 CFX-BLK  PIC X(5)  VALUE SPACE.
      *    05 CFX-SALDI.
      *       10 CFX-SP-D PIC S9(11) COMP-3 VALUE ZERO.
      *       10 CFX-SP-A PIC S9(11) COMP-3 VALUE ZERO.
      *       10 CFX-SPSP PIC S9(11) COMP-3 VALUE ZERO.
      *       10 CFX-SE-D PIC S9(11) COMP-3 VALUE ZERO.
      *       10 CFX-SE-A PIC S9(11) COMP-3 VALUE ZERO.
      *       10 CFX-SESP PIC S9(11) COMP-3 VALUE ZERO.
      *    05 CFX-SALDR REDEFINES CFX-SALDI.
      *       10 CFX-SXYY PIC S9(11) COMP-3 OCCURS 6.
      *    05 CFX-IMPON   PIC S9(11) COMP-3 VALUE ZERO.
      *    05 CFX-NIMPO   PIC S9(11) COMP-3 VALUE ZERO.
      *    05 CFX-ESENT   PIC S9(11) COMP-3 VALUE ZERO.
      *    05 CFX-IMIVA   PIC S9(11) COMP-3 VALUE ZERO.
      *    05 CFX-TACCR   PIC S9(11) COMP-3 VALUE ZERO.
      *    05 CFX-LINS    PIC S9(11) COMP-3 VALUE ZERO.
      *    05 CFX-NFATT   PIC 9(5)   COMP-3 VALUE ZERO.
      *    05 CFX-NOPNI   PIC 9(5)   COMP-3 VALUE ZERO.
      *    05 CFX-NACCR   PIC 9(5)   COMP-3 VALUE ZERO.
      *    05 CFX-NINS    PIC 9(5)   COMP-3 VALUE ZERO.
      *    05 CFX-FIDO    PIC S9(11) COMP-3 VALUE ZERO.
      *    05 CFX-ESPO    PIC S9(11) COMP-3 VALUE ZERO.
      *    05 CFX-VALORD  PIC S9(11) COMP-3 VALUE ZERO.
      *    05 CFX-SCBS    PIC 999V99 COMP-3 VALUE ZERO.
      *    05 CFX-BANC    PIC 9(5) VALUE ZERO.
      *    05 CFX-CPAG    PIC 999  VALUE ZERO.
      *    05 CFX-AGEN    PIC 999  VALUE ZERO.
      *    05 CFX-VETT    PIC 999  VALUE ZERO.
      *    05 CFX-MSPE    PIC 999  VALUE ZERO.
      *    05 CFX-PORT    PIC 999  VALUE ZERO.
      *    05 CFX-ESEN    PIC 999  VALUE ZERO.
      *    05 CFX-LIS     PIC 999  VALUE ZERO.
      *    05 CFX-ZONA    PIC XXX  VALUE ZERO.
      *    05 CFX-GRU     PIC XXX  VALUE SPACE.
      *    05 CFX-GRM     PIC 9    VALUE ZERO.
      *    05 CFX-CATCON  PIC 9    VALUE ZERO.
      *    05 CFX-TPRZ    PIC 9    VALUE ZERO.
      *    05 CFX-RBOL    PIC 9    VALUE ZERO.
      *    05 CFX-SBOL    PIC 9    VALUE ZERO.
      *    05 CFX-SBAN    PIC 9    VALUE ZERO.
      *    05 CFX-13IVA   PIC 9    VALUE ZERO.
      *    05 CFX-ANNUL   PIC 9    VALUE ZERO.
      *    05 CFX-IDTIVA  PIC 9(5)  COMP-3 VALUE ZERO.
      *    05 CFX-INUIVA  PIC 9(5)  COMP-3 VALUE ZERO.
      *    05 CFX-EDTIVA  PIC 9(5)  COMP-3 VALUE ZERO.
      *    05 CFX-ENUIVA  PIC 9(5)  COMP-3 VALUE ZERO.
      *    05 CFX-NOTE    PIC X(30) VALUE SPACE.
      *    05 FILLER      PIC X(230) VALUE ZERO.
      ************
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-COL PIC X(15) VALUE 'anacol'.
       01  ID-CFX PIC X(15) VALUE 'anacfx'.
       01  ID-AZL PIC X(15) VALUE 'anazol'.
       01  ID-MOL PIC X(15) VALUE 'movmol'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-MSZ PIC X(15) VALUE 'movsez'.
       01  ID-MSL PIC X(15) VALUE 'movsol'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  COMODI.
           05 SF-CON PIC XX.
           05 SF-CLF PIC XX.
           05 SF-AZI PIC XX.
           05 SF-COL PIC XX.
           05 SF-CFX PIC XX.
           05 SF-AZL PIC XX.
           05 SF-MOL PIC XX.
           05 SF-TAB PIC XX.
           05 SF-MSZ PIC XX.
           05 SF-MSL PIC XX.
           05 SF-MOV PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 MCLI   PIC 99.
           05 MFOR   PIC 99.
           05 CODICE.
              10 MS   PIC 99 VALUE ZERO.
              10 CDCF PIC 9(5) VALUE ZERO.
           05 CODCLF.
              10 MAS PIC 99 VALUE ZERO.
              10 CLF PIC 9(5) VALUE ZERO.
           05 PKDTAP PIC 9(5)  COMP-3.
           05 PKDTCH  PIC 9(5) COMP-3.
      **** rel 4.0
      *    05 SALDO  PIC S9(13).
      *    05 SALDON PIC S9(13).
           05 SALDO  PIC S9(13)V99.
           05 SALDON PIC S9(13)V99.
      ************
           05 CAUS   PIC 9(3).
           05 IND    PIC 9(3).
           05 K      PIC 9(3).
           05 J      PIC 9(3).
           05 X      PIC 99.
           05 Y      PIC 99.
           05 SWERR  PIC 9.
       01  MAT.
           05 RIG OCCURS 18.
              10 COD  PIC 9(7).
      **** rel 4.0
      *       10 DARE PIC S9(11).
      *       10 AVER PIC S9(11).
              10 DARE PIC S9(11)V99.
              10 AVER PIC S9(11)V99.
      ************

       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-TPCHI     PIC 9.
           05 IF-COD-1     PIC 9(5).
           05 IF-COD-2     PIC 9(5).
           05 IF-DTCHI     PIC 9(6).
           05 IF-DTAPE     PIC 9(6).

      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclcon'.
           COPY 'dclclf'.
           COPY 'dclazi'.
           COPY 'dclcol'.
           COPY 'dclazl'.
           COPY 'dclmol'.
           COPY 'dclmsz'.
           COPY 'dclmsl'.
           COPY 'dclmov'.
           COPY 'dclcfx'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon310: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE ANACON.
           CLOSE TABELL.
           CLOSE MOVSEZ.
           CLOSE MOVSOL.
           CLOSE ANACFX.
           CLOSE ANAZOL.
           CLOSE ANACOL.
           CLOSE ANACLF.
           CLOSE MOVMOL.
           CLOSE MOVIME.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griconer'.
           COPY 'griclfer'.
           COPY 'griazier'.
           COPY 'gricoler'.
           COPY 'griazler'.
           COPY 'grimoler'.
           COPY 'grimszer'.
           COPY 'grimsler'.
           COPY 'grimover'.
           COPY 'gricfxer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           OPEN INPUT TABELL.
           OPEN I-O ANAAZI.
           OPEN I-O ANACON.
           OPEN I-O ANACFX.
           OPEN I-O ANAZOL.
           OPEN I-O MOVSOL.
           OPEN I-O MOVSEZ.
           OPEN I-O ANACOL.
           OPEN I-O ANACLF.
           OPEN I-O MOVMOL.
           OPEN I-O MOVIME.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           MOVE 20 TO KTB-TIP.
           MOVE 1  TO KTB-COD
           READ TABELL INTO RKTB20 INVALID PERFORM INVK-TAB 
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.      
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE 14 TO KTB-TIP.
           MOVE 7  TO KTB-COD.
           READ TABELL INTO RKTB14G INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14G.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.

           MOVE T01-CRPCL TO COD(1).
           MOVE T01-CRPC1 TO COD(2).
           MOVE T01-CRPC2 TO COD(3).
           MOVE T14-CRPC3 TO COD(4).
           MOVE T14-CRPC4 TO COD(5).
           MOVE T14-CRPC5 TO COD(6).
           MOVE T14-CRPC6 TO COD(7).
           MOVE T14-CRPC7 TO COD(8).
           MOVE T14-CRPC8 TO COD(9).
           MOVE T01-CRPFR TO COD(10).
           MOVE T01-CRPF1 TO COD(11).
           MOVE T01-CRPF2 TO COD(12).
           MOVE T14-CRPF3 TO COD(13).
           MOVE T14-CRPF4 TO COD(14).
           MOVE T14-CRPF5 TO COD(15).
           MOVE T14-CRPF6 TO COD(16).
           MOVE T14-CRPF7 TO COD(17).
           MOVE T14-CRPF8 TO COD(18).
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO    TO IF-COD-1.
           MOVE 99999   TO IF-COD-2.
           MOVE ZERO    TO IF-TPCHI.
           MOVE ZERO    TO IF-DTCHI.
           MOVE ZERO    TO IF-DTAPE.

           MOVE 1 TO K.
           PERFORM UNTIL K NOT < 19
              MOVE ZERO TO DARE (K) AVER(K)
              ADD 1 TO K.

       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
       V-DTCHI.
           MOVE 'IF-DTCHI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCHI.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTCHI TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG = ZERO 
              MOVE "Non ammessa data a zero" TO MESS
              GO TO V-ERROR.
           MOVE AAGGG TO PKDTCH.
       E-DTCHI.
      *
       V-DTAPE.
           MOVE 'IF-DTAPE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTAPE.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTAPE TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDTAP.
           IF PKDTAP NOT > PKDTCH
              MOVE "Data apertura < data chiusura" TO MESS
              GO TO V-ERROR.
       E-DTAPE.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           PERFORM D00-CONTROLLO-PAR THRU D99.
           IF SWERR = 1 MOVE 'Sistemare codici' TO F-MES1
                        MOVE 1 TO F-NMES
                        CALL 'vrmbox' USING PARMB
                        GO TO EX-RUN-ELABORA.

           PERFORM E00-CONTR-BIL THRU E99.
           IF SWERR = 1 MOVE 'Sistemare anomalie' TO F-MES1
                        MOVE 1 TO F-NMES
                        CALL 'vrmbox' USING PARMB
                        GO TO EX-RUN-ELABORA.

           IF IF-TPCHI = ZERO MOVE MCLI TO MS
           ELSE               MOVE MFOR TO MS.

           PERFORM A00-CONTR THRU A99.
           IF SWERR NOT = ZERO  GO TO EX-RUN-ELABORA.


           MOVE KAZ-COD  TO KCX-AZI.
           MOVE IF-COD-1 TO CDCF.
           MOVE CODICE   TO KCX-COD.
           START ANACFX KEY NOT < KEYCX INVALID KEY GO TO FINEC.
       LPRCF.
           READ ANACFX NEXT INTO REKCLF AT END GO TO FINEC.
           IF SF-CFX = '9D' OR '9A' OR '35' GO TO LPRCF.
           IF KCX-AZI > KAZ-COD GO TO FINEC.
           MOVE KCX-COD TO CODCLF.
           IF MAS > MS OR
              CLF > IF-COD-2 GO TO FINEC.

           COMPUTE SALDO = CLF-SESP + CLF-SE-D - CLF-SE-A.
           IF SALDO < ZERO  COMPUTE SALDON = SALDO * -1
                            ADD SALDON TO CLF-SP-D
                            ADD SALDON TO CLF-SE-D
           ELSE ADD SALDO TO CLF-SP-A CLF-SE-A.

           REWRITE RF-CFX FROM REKCLF INVALID KEY
               PERFORM INVK-CFX 
               GO TO ERRIO.
           IF SALDO = ZERO GO TO LPRCF.
           PERFORM B00-APCH-BIL THRU B99 GO TO LPRCF.
       FINEC.
           PERFORM C00-AGGIORNA THRU C99.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       D00-CONTROLLO-PAR.
           MOVE ZERO TO SWERR.

           PERFORM CTRCAU THRU EX-CTRCAU.

           MOVE 2 TO KTB-TIP.
           MOVE T20-CDCLC TO KTB-COD.
           READ TABELL INVALID 
              MOVE 'Manca causale chiusura clienti dare' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           MOVE T20-CACLC TO KTB-COD.
           READ TABELL INVALID 
              MOVE 'Manca causale chiusura clienti avere' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           MOVE T20-CDFOC TO KTB-COD.
           READ TABELL INVALID 
              MOVE 'Manca causale chiusura fornitori dare' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           MOVE T20-CAFOC TO KTB-COD.
           READ TABELL INVALID
              MOVE 'Manca causale chiusura fornitori avere' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           MOVE T20-CDSOC TO KTB-COD.
           READ TABELL INVALID 
              MOVE 'Manca causale chiusura sottoconto dare' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           MOVE T20-CASOC TO KTB-COD.
           READ TABELL INVALID
              MOVE 'Manca causale chiusura sottoconto avere' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           MOVE T20-CDCLA TO KTB-COD.
           READ TABELL INVALID
              MOVE 'Manca causale apertura clienti dare' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           MOVE T20-CACLA TO KTB-COD.
           READ TABELL INVALID
              MOVE 'Manca causale apertura clienti avere' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           MOVE T20-CDFOA TO KTB-COD.
           READ TABELL INVALID
              MOVE 'Manca causale apertura fornitori dare' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           MOVE T20-CAFOA TO KTB-COD.
           READ TABELL INVALID
              MOVE 'Manca causale apertura fornitori avere' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           MOVE T20-CDSOA TO KTB-COD.
           READ TABELL INVALID
              MOVE 'Manca causale apertura sottoconto dare' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           MOVE T20-CASOA TO KTB-COD.
           READ TABELL INVALID
              MOVE 'Manca causale apertura sottoconto avere' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           MOVE T20-CUTIL TO KTB-COD.
           READ TABELL INVALID
              MOVE 'Manca causale utile/perdita esercizio' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
       D99.
           EXIT.
      *------------------
       CTRCAU.
           IF T20-CDCLA < 900 OR > 950
              MOVE 'Causale apertura clienti dare errata' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           IF T20-CACLA < 900 OR > 950
              MOVE 'Causale apertura clienti avere errata' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           IF T20-CDFOA < 900 OR > 950
              MOVE 'Causale apertura fornitori dare errata' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           IF T20-CAFOA < 900 OR > 950
              MOVE 'Causale apertura fornitori avere errata' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           IF T20-CDSOA < 900 OR > 950
              MOVE 'Causale apertura sottoconto dare errata' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           IF T20-CASOA < 900 OR > 950
              MOVE 'Causale apertura sottoconto avere errata' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           IF T20-CDCLC > 899
              MOVE 'Causale chiusura clienti dare errata' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           IF T20-CACLC > 899
              MOVE 'Causale chiusura clienti avere errata' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           IF T20-CDFOC > 899
              MOVE 'Causale chiusura fornitori dare errata' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           IF T20-CAFOC > 899
              MOVE 'Causale chiusura fornitori avere errata' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           IF T20-CDSOC > 899
              MOVE 'Causale chiusura sottoconto dare errata' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           IF T20-CASOC > 899 
              MOVE 'Causale chiusura sottoconto avere errata' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
       EX-CTRCAU.
           EXIT. 
      *------------------
       E00-CONTR-BIL.
           MOVE ZERO TO SWERR.
           MOVE KAZ-COD TO KPC-AZI KCL-AZI.
           MOVE T20-COBC TO KCL-COD.
           READ ANACOL INVALID
              MOVE 'Manca conto bilancio di chiusura' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
           MOVE T20-COBA TO KPC-COD.
           READ ANACON INVALID
              MOVE 'Manca conto bilancio di apertura' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO SWERR.
       E99.
           EXIT.
      *------------------
       A00-CONTR.
           MOVE ZERO TO SWERR.

           MOVE KAZ-COD  TO KCX-AZI.
           MOVE IF-COD-1 TO CDCF.
           MOVE CODICE   TO KCX-COD.
           START ANACFX KEY NOT < KEYCX INVALID KEY GO TO A99.
       A10.
           READ ANACFX NEXT INTO REKCLF AT END GO TO A99.
           IF SF-CFX = '9D' OR '9A' OR '35' GO TO A10.
           IF KCX-AZI > KAZ-COD GO TO A99.
           MOVE KCX-COD TO CODCLF.
           IF MAS > MS OR
              CLF > IF-COD-2 GO TO A99.

           COMPUTE SALDO = CLF-SESP + CLF-SE-D - CLF-SE-A.
           IF SALDO < ZERO  COMPUTE SALDON = SALDO * -1
                            ADD SALDON TO CLF-SP-D
                            ADD SALDON TO CLF-SE-D
           ELSE ADD SALDO TO CLF-SP-A CLF-SE-A.
           IF SALDO = ZERO GO TO A10.

           MOVE KEYCX TO KEYCF.
           READ ANACLF INVALID GO TO A20.
           GO TO A10.
       A20.
           MOVE 'Attenzione!' TO MB-TITOLO.
           MOVE 'Mancante su archivio esercizio corrente' TO F-MES1.
           STRING 'conto ' KCF-COD '. Continuare ?' DELIMITED SIZE 
                                               INTO F-MES2.
           MOVE  2 TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           CALL 'vrmbox' USING PARMB.
           MOVE 1 TO SWERR.
           IF MB-RISP = 'S' GO TO A10.
       A99.
           EXIT.
      *------------------
       B00-APCH-BIL.
           MOVE KEYCX TO KEYCF.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.      
           IF SALDO < ZERO  COMPUTE SALDON = SALDO * -1
                            ADD SALDON TO CLF-SP-A 
                            ADD SALDON TO CLF-SE-A 
           ELSE ADD SALDO TO CLF-SP-D CLF-SE-D.
           REWRITE RF-CLF FROM REKCLF INVALID PERFORM INVK-CLF
                                              GO TO ERRIO.
       B005.
           IF SALDO = ZERO GO TO B99.
           MOVE ZERO TO REKMOV.
           MOVE KAZ-COD TO MOV-AZI.
           MOVE KCF-COD TO MOV-CON.
           MOVE PKDTCH  TO MOV-DAT.
       B010.
           MOVE KAZ-COD TO KEYAL.
           READ ANAZOL INTO REKAZI KEPT LOCK INVALID
                               PERFORM INVK-AZL GO TO ERRIO.
           IF SF-AZL > ZERO GO TO B010.
           ADD 1 TO AZI-MOVPR.
           MOVE AZI-MOVPR TO MOV-NUM.
           REWRITE RF-AZL FROM REKAZI INVALID
                     PERFORM INVK-AZL GO TO ERRIO.
           UNLOCK ANAZOL.
           IF CLF-MS = MCLI MOVE 2 TO MOV-TREG
           ELSE MOVE 3 TO MOV-TREG.
           MOVE SALDO TO MOV-IMPO.
           IF MOV-TREG = 2 
              IF SALDO < ZERO MOVE T20-CDCLC TO CAUS
              ELSE MOVE T20-CACLC TO CAUS
           ELSE IF SALDO < ZERO MOVE T20-CDFOC TO CAUS
                ELSE MOVE T20-CAFOC TO CAUS.
           MOVE CAUS TO MOV-CAUS.
           MOVE 2 TO KTB-TIP.
           MOVE CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE T02-D-A TO MOV-D-A.
           IF T02-D-A = 'D' MULTIPLY -1 BY MOV-IMPO.
           MOVE 1 TO MOV-FLAG.
           MOVE ZERO TO MOV-NDOC
                        MOV-DTDOC
                        MOV-DTSCD
                        MOV-NPRGI
                        MOV-PART 
                        MOV-NREG.
           MOVE SPACE TO MOV-DSAGG.
           MOVE SPACE TO MOV-CCOST.
           WRITE RF-MSL FROM REKMOV INVALID PERFORM INVK-MSL
                                            GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MSL.
      ************
       B020.
           MOVE PKDTAP TO MOV-DAT.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID
                               PERFORM INVK-AZI GO TO ERRIO.
           IF SF-AZI > ZERO GO TO B020.
           ADD 1 TO AZI-MOVPR.
           MOVE AZI-MOVPR TO MOV-NUM.
           REWRITE RF-AZI FROM REKAZI INVALID
                     PERFORM INVK-AZI GO TO ERRIO.
           UNLOCK ANAAZI.
           IF MOV-TREG = 2
              IF SALDO < ZERO MOVE T20-CACLA TO CAUS
              ELSE MOVE T20-CDCLA TO CAUS
           ELSE IF SALDO < ZERO MOVE T20-CAFOA TO CAUS
                ELSE MOVE T20-CDFOA TO CAUS.
           MOVE SALDO TO MOV-IMPO.
           MOVE CAUS TO MOV-CAUS.
           MOVE 2 TO KTB-TIP.
           MOVE CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE T02-D-A TO MOV-D-A.
           IF T02-D-A = 'A' MULTIPLY -1 BY MOV-IMPO.
           MOVE SPACE TO MOV-CCOST.
           WRITE RF-MSZ FROM REKMOV INVALID PERFORM INVK-MSZ
                                            GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE
           PERFORM CALL-VSRV133-MSZ
      ************
           MOVE CLF-CATCON TO K.
           IF K = ZERO MOVE 1 TO K.
           IF MOV-TREG = 3 ADD 9 TO K.
           IF SALDO < ZERO ADD SALDO TO AVER(K)
           ELSE ADD SALDO TO DARE(K).
       B99.
           EXIT.
      *------------------------------------------------------------*
       C00-AGGIORNA.
      * 
      * RAGGRUPPAMENTO VALORI A PARITA' DI MASTRO RIEP.CLIENTI 
      * 
           MOVE ZERO TO X Y.
       C001.
           ADD 1 TO X.
           IF X > 8 GO TO C004.
           IF COD(X) = ZERO GO TO C001.
           MOVE X TO Y.
       C003.
           ADD 1 TO Y.
           IF COD(X) = COD(Y) ADD DARE(Y) TO DARE(X)
                              ADD AVER(Y) TO AVER(X)
                              MOVE ZERO TO COD(Y) DARE(Y) AVER(Y).
           IF Y < 9 GO TO C003.
           IF X < 8 GO TO C001.
       C004.
      ************
      * 
      * RAGGRUPPAMENTO VALORI A PARITA' DI MASTRO RIEP.FORNITORI
      * 
           MOVE 9 TO X Y.
       C005.
           ADD 1 TO X.
           IF X > 17 GO TO C007.
           IF COD(X) = ZERO GO TO C005.
           MOVE X TO Y.
       C006.
           ADD 1 TO Y.
           IF COD(X) = COD(Y) ADD DARE(Y) TO DARE(X)
                              ADD AVER(Y) TO AVER(X)
                              MOVE ZERO TO COD(Y) DARE(Y) AVER(Y).
           IF Y < 18 GO TO C006.
           IF X < 17 GO TO C005.
       C007.
           MOVE ZERO TO IND.
       C010.
           ADD 1 TO IND.
           IF IND > 18 GO TO C99.
           IF DARE(IND) = ZERO AND AVER(IND) = ZERO GO TO C010.
           IF DARE(IND) = ZERO GO TO C040.
      *
      * REGISTRAZIONE CHIUSURA MOVMOL PER SALDO POSITIVO
      *       (CONTO RIEPILOGATIVO)
      *
           MOVE KAZ-COD TO KML-AZI.
           MOVE COD(IND) TO KML-CON.
           MOVE PKDTCH TO KML-DAT.
           IF IND < 10 MOVE 99996 TO KML-NUM
           ELSE MOVE 99998 TO KML-NUM.
           READ MOVMOL INTO REKCOM INVALID
                MOVE ZERO TO COM-IMPO GO TO C013.
           IF SF-MOL = '9D' OR '9A' OR '35' MOVE RF-MOL TO REKCOM.      
           GO TO C015.
       C013.
           MOVE ZERO TO REKMOV.
           MOVE KAZ-COD TO MOV-AZI.
           MOVE COD(IND) TO MOV-CON.
           MOVE PKDTCH TO MOV-DAT.
           MOVE 1 TO MOV-TREG.
           IF IND < 10 MOVE 99996 TO MOV-NUM
           ELSE MOVE 99998 TO MOV-NUM.
           MOVE T20-CASOC TO MOV-CAUS.
       C015.
           MOVE DARE(IND) TO MOV-IMPO.
           MOVE 2 TO KTB-TIP.
           MOVE T20-CASOC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           IF T02-SEGNO > ZERO MULTIPLY -1 BY MOV-IMPO.
           ADD MOV-IMPO TO COM-IMPO.
           IF SF-MOL = ZERO GO TO C018.
           MOVE T02-D-A TO MOV-D-A.
           MOVE 1 TO MOV-FLAG.
           MOVE ZERO TO MOV-NDOC
                        MOV-DTDOC
                        MOV-DTSCD
                        MOV-NPRGI
                        MOV-PART 
                        MOV-NREG.
           MOVE SPACE TO MOV-DSAGG.
           MOVE SPACE TO MOV-CCOST.
           WRITE RF-MOL FROM REKMOV INVALID PERFORM INVK-MOL
                                            GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE
           PERFORM CALL-VSRV133-MOL
      ************
           GO TO C020.
       C018.
           REWRITE RF-MOL FROM REKCOM INVALID PERFORM INVK-MOL
                                              GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOL.
      ************
      *
      * REGISTRAZIONE CHIUSURA MOVMOL (CONTO BIL. CHIUSURA).
      *
       C020.
           READ ANAZOL INTO REKAZI KEPT LOCK INVALID 
                               PERFORM INVK-AZL GO TO ERRIO.
           IF SF-AZL > ZERO GO TO C020.
           ADD 1 TO AZI-MOVPR.
           MOVE AZI-MOVPR TO MOV-NUM.
           REWRITE RF-AZL FROM REKAZI INVALID
                     PERFORM INVK-AZL GO TO ERRIO.
           UNLOCK ANAZOL.
           MOVE PKDTCH TO MOV-DAT.
           MOVE DARE(IND) TO MOV-IMPO.
           MOVE T20-COBC TO MOV-CON.
           MOVE T20-CDSOC TO MOV-CAUS.
           MOVE 2 TO KTB-TIP.
           MOVE T20-CDSOC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE T02-D-A TO MOV-D-A.
           IF T02-SEGNO > ZERO MULTIPLY -1 BY MOV-IMPO.
           MOVE SPACE TO MOV-CCOST.
           WRITE RF-MOL FROM REKMOV INVALID PERFORM INVK-MOL
                                            GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOL.
      ************
      *
      * CHIUSURA MASTRO RIEPILOGATIVO CLIENTI
      *
           MOVE KAZ-COD TO KCL-AZI.
           MOVE COD(IND) TO KCL-COD.
           READ ANACOL INTO REKCON INVALID PERFORM INVK-COL
                                           GO TO ERRIO.
           IF SF-COL = '9D' OR '9A' OR '35' MOVE RF-COL TO REKCON.      
           MOVE DARE(IND) TO SALDO.
           ADD SALDO TO CON-SP-A.
           ADD SALDO TO CON-SE-A.
           REWRITE RF-COL FROM REKCON INVALID PERFORM INVK-COL
                                              GO TO ERRIO.
      *
      * AGGIORNAMENTO MASTRO BILANCIO CHIUSURA
      *
           MOVE T20-COBC TO KCL-COD.
           READ ANACOL INTO REKCON INVALID PERFORM INVK-COL
                                           GO TO ERRIO.
           IF SF-COL = '9D' OR '9A' OR '35' MOVE RF-COL TO REKCON.      
           MOVE DARE(IND) TO SALDO.
           ADD SALDO TO CON-SP-D.
           ADD SALDO TO CON-SE-D.
           REWRITE RF-COL FROM REKCON INVALID PERFORM INVK-COL
                                              GO TO ERRIO.
      *
      * REGISTRAZIONE APERTURA MOVIME (CONTO RIEPILOGATIVO)
      *
           MOVE KAZ-COD TO KMV-AZI.
           MOVE COD(IND) TO KMV-CON.
           MOVE PKDTAP TO KMV-DAT.
           IF IND < 10 MOVE 99995 TO KMV-NUM
           ELSE MOVE 99997 TO KMV-NUM.
           READ MOVIME INTO REKCOM INVALID 
                MOVE ZERO TO COM-IMPO GO TO C025.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCOM.      
           ADD MOV-IMPO TO COM-IMPO.
           REWRITE RF-MOV FROM REKCOM INVALID PERFORM INVK-MOV 
                                              GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      ************
           GO TO C030.
       C025.
           MOVE COD(IND) TO MOV-CON.
           MOVE PKDTAP TO MOV-DAT.
           IF IND < 10 MOVE 99995 TO MOV-NUM
           ELSE MOVE 99997 TO MOV-NUM.
           MOVE T20-CDSOA TO MOV-CAUS.
           MOVE 2 TO KTB-TIP.
           MOVE T20-CDSOA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE T02-D-A TO MOV-D-A.
           IF T02-SEGNO > ZERO MULTIPLY -1 BY MOV-IMPO.
           MOVE SPACE TO MOV-CCOST.
           WRITE RF-MOV FROM REKMOV INVALID PERFORM INVK-MOV
                                            GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      ************
      *
      * REGISTRAZIONE APERTURA MOVIME (CONTO BIL. APERTURA).
      *
       C030.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID
                               PERFORM INVK-AZI GO TO ERRIO.
           IF SF-AZI > ZERO GO TO C030.
           ADD 1 TO AZI-MOVPR.
           MOVE AZI-MOVPR TO MOV-NUM.
           REWRITE RF-AZI FROM REKAZI INVALID
                     PERFORM INVK-AZI GO TO ERRIO.
           UNLOCK ANAAZI.
           MOVE PKDTAP TO MOV-DAT.
           MOVE DARE(IND) TO MOV-IMPO.
           MOVE T20-COBA TO MOV-CON.
           MOVE T20-CASOA TO MOV-CAUS.
           MOVE 2 TO KTB-TIP.
           MOVE T20-CASOA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE T02-D-A TO MOV-D-A.
           IF T02-SEGNO > ZERO MULTIPLY -1 BY MOV-IMPO.
           MOVE SPACE TO MOV-CCOST.
           WRITE RF-MOV FROM REKMOV INVALID PERFORM INVK-MOV
                                            GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      ************
      *
      * APERTURA MASTRO RIEPILOGATIVO CLIENTI
      *
           MOVE KAZ-COD TO KPC-AZI.
           MOVE COD(IND) TO KPC-COD.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.      
           MOVE DARE(IND) TO SALDO.
           ADD SALDO TO CON-SE-D.
           ADD SALDO TO CON-SP-D.
           REWRITE RF-CON FROM REKCON INVALID PERFORM INVK-CON
                                              GO TO ERRIO.
      *
      * AGGIORNAMENTO MASTRO BILANCIO APERTURA
      *
           MOVE T20-COBA TO KPC-COD.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.      
           MOVE DARE(IND) TO SALDO.
           ADD SALDO TO CON-SP-A.
           ADD SALDO TO CON-SE-A.
           MULTIPLY -1 BY SALDO.
           REWRITE RF-CON FROM REKCON INVALID PERFORM INVK-CON
                                              GO TO ERRIO.
           IF AVER(IND) = ZERO GO TO C010.
      *
      * REGISTRAZIONE CHIUSURA MOVMOL PER SALDO NEGATIVO
      *       (CONTO RIEPILOGATIVO)
      *
       C040.
           MOVE KAZ-COD TO KML-AZI.
           MOVE COD(IND) TO KML-CON.
           MOVE PKDTCH TO KML-DAT.
           IF IND < 10 MOVE 99995 TO KML-NUM
           ELSE MOVE 99997 TO KML-NUM.
           READ MOVMOL INTO REKCOM INVALID 
                MOVE ZERO TO COM-IMPO GO TO C043.
           IF SF-MOL = '9D' OR '9A' OR '35' MOVE RF-MOL TO REKCOM.      
           GO TO C045.
       C043.
           MOVE ZERO TO REKMOV.
           MOVE KAZ-COD TO MOV-AZI.
           MOVE COD(IND) TO MOV-CON.
           MOVE PKDTCH TO MOV-DAT.
           MOVE 1 TO MOV-TREG.
           IF IND < 10 MOVE 99995 TO MOV-NUM
           ELSE MOVE 99997 TO MOV-NUM.
       C045.
           MOVE AVER(IND) TO MOV-IMPO.
           MULTIPLY -1 BY MOV-IMPO.
           MOVE 2 TO KTB-TIP.
           MOVE T20-CDSOC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           IF T02-SEGNO > ZERO MULTIPLY -1 BY MOV-IMPO.
           ADD MOV-IMPO TO COM-IMPO.
           IF SF-MOL = ZERO GO TO C048.
           MOVE T02-D-A TO MOV-D-A.
           MOVE T20-CDSOC TO MOV-CAUS.
           MOVE 1 TO MOV-FLAG.
           MOVE ZERO TO MOV-NDOC
                        MOV-DTDOC
                        MOV-DTSCD
                        MOV-NPRGI
                        MOV-PART 
                        MOV-NREG.
           MOVE SPACE TO MOV-DSAGG.
           MOVE SPACE TO MOV-CCOST.
           WRITE RF-MOL FROM REKMOV INVALID PERFORM INVK-MOL
                                            GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOL.
      ************
           GO TO C050.
       C048.
           REWRITE RF-MOL FROM REKCOM INVALID PERFORM INVK-MOL
                                              GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOL.
      ************
      *
      * REGISTRAZIONE CHIUSURA MOVMOL (CONTO BIL. CHIUSURA).
      *
       C050.
           READ ANAZOL INTO REKAZI KEPT LOCK INVALID
                               PERFORM INVK-AZL GO TO ERRIO.
           IF SF-AZL > ZERO GO TO C050.
           ADD 1 TO AZI-MOVPR.
           MOVE AZI-MOVPR TO MOV-NUM.
           REWRITE RF-AZL FROM REKAZI INVALID
                     PERFORM INVK-AZL GO TO ERRIO.
           UNLOCK ANAZOL.
           MOVE AVER(IND) TO MOV-IMPO.
           MULTIPLY -1 BY MOV-IMPO.
           MOVE T20-COBC TO MOV-CON.
           MOVE T20-CASOC TO MOV-CAUS.
           MOVE 2 TO KTB-TIP.
           MOVE T20-CASOC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE PKDTCH TO MOV-DAT.
           MOVE T02-D-A TO MOV-D-A.
           IF T02-SEGNO > ZERO MULTIPLY -1 BY MOV-IMPO.
           MOVE SPACE TO MOV-CCOST.
           WRITE RF-MOL FROM REKMOV INVALID PERFORM INVK-MOL
                                            GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOL.
      ************
      *
      * CHIUSURA MASTRO RIEPILOGATIVO CLIENTI,FORNITORI
      *
           MOVE KAZ-COD TO KCL-AZI.
           MOVE COD(IND) TO KCL-COD.
           READ ANACOL INTO REKCON INVALID PERFORM INVK-COL
                                           GO TO ERRIO.
           IF SF-COL = '9D' OR '9A' OR '35' MOVE RF-COL TO REKCON.      
           MOVE AVER(IND) TO SALDO.
           MULTIPLY -1 BY SALDO.
           ADD SALDO TO CON-SP-D.
           ADD SALDO TO CON-SE-D.
           REWRITE RF-COL FROM REKCON INVALID PERFORM INVK-COL
                                              GO TO ERRIO.
      *
      * AGGIORNAMENTO MASTRO BILANCIO CHIUSURA
      *
           MOVE T20-COBC TO KCL-COD.
           READ ANACOL INTO REKCON INVALID PERFORM INVK-COL
                                           GO TO ERRIO.
           IF SF-COL = '9D' OR '9A' OR '35' MOVE RF-COL TO REKCON.      
           MOVE AVER(IND) TO SALDO.
           MULTIPLY -1 BY SALDO.
           ADD SALDO TO CON-SP-A.
           ADD SALDO TO CON-SE-A.
           REWRITE RF-COL FROM REKCON INVALID PERFORM INVK-COL
                                              GO TO ERRIO.
      *
      * REGISTRAZIONE APERTURA MOVIME (CONTO RIEPILOGATIVO)
      *
           MOVE KAZ-COD TO KMV-AZI.
           MOVE COD(IND) TO KMV-CON.
           MOVE PKDTAP TO KMV-DAT.
           IF IND < 10 MOVE 99996 TO KMV-NUM
           ELSE MOVE 99998 TO KMV-NUM.
           READ MOVIME INTO REKCOM INVALID 
                MOVE ZERO TO COM-IMPO GO TO C055.
           IF SF-MOV = '9D' OR '9A' OR '35' MOVE RF-MOV TO REKCOM.      
           MOVE AVER(IND) TO MOV-IMPO.
           MULTIPLY -1 BY MOV-IMPO.
           ADD MOV-IMPO TO COM-IMPO.
           REWRITE RF-MOV FROM REKCOM INVALID PERFORM INVK-MOV
                                              GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      ************
           GO TO C060.
       C055.
           MOVE AVER(IND) TO MOV-IMPO.
           MULTIPLY -1 BY MOV-IMPO.
           MOVE COD(IND) TO MOV-CON.
           MOVE PKDTAP TO MOV-DAT.
           IF IND < 10 MOVE 99996 TO MOV-NUM
           ELSE MOVE 99998 TO MOV-NUM.
           MOVE T20-CASOA TO MOV-CAUS.
           MOVE 2 TO KTB-TIP.
           MOVE T20-CASOA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE T02-D-A TO MOV-D-A.
           IF T02-SEGNO > ZERO MULTIPLY -1 BY MOV-IMPO.
           MOVE SPACE TO MOV-CCOST.
           WRITE RF-MOV FROM REKMOV INVALID PERFORM INVK-MOV
                                            GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      ************
      *
      * REGISTRAZIONE APERTURA MOVIME (CONTO BIL. APERTURA).
      *
       C060.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID
                               PERFORM INVK-AZI GO TO ERRIO.
           IF SF-AZI > ZERO GO TO C060.
           ADD 1 TO AZI-MOVPR.
           MOVE AZI-MOVPR TO MOV-NUM.
           REWRITE RF-AZI FROM REKAZI INVALID
                     PERFORM INVK-AZI GO TO ERRIO.
           UNLOCK ANAAZI.
           MOVE T20-COBA TO MOV-CON.
           MOVE T20-CDSOA TO MOV-CAUS.
           MOVE 2 TO KTB-TIP.
           MOVE T20-CDSOA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE PKDTAP TO MOV-DAT.
           MOVE T02-D-A TO MOV-D-A.
           IF T02-SEGNO > ZERO MULTIPLY -1 BY MOV-IMPO.
           MOVE SPACE TO MOV-CCOST.
           WRITE RF-MOV FROM REKMOV INVALID PERFORM INVK-MOV
                                            GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      ************
      *
      * APERTURA MASTRO RIEPILOGATIVO CLIENTI
      *
           MOVE KAZ-COD TO KPC-AZI.
           MOVE COD(IND) TO KPC-COD.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.      
           MOVE AVER(IND) TO SALDO.
           MULTIPLY -1 BY SALDO.
           ADD SALDO TO CON-SE-A.
           ADD SALDO TO CON-SP-A.
           REWRITE RF-CON FROM REKCON INVALID PERFORM INVK-CON
                                              GO TO ERRIO.
      *
      * AGGIORNAMENTO MASTRO BILANCIO APERTURA
      *
           MOVE T20-COBA TO KPC-COD.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.      
           MOVE AVER(IND) TO SALDO.
           MULTIPLY -1 BY SALDO.
           ADD SALDO TO CON-SE-D.
           ADD SALDO TO CON-SP-D.
           REWRITE RF-CON FROM REKCON INVALID PERFORM INVK-CON
                                              GO TO ERRIO.
           GO TO C010.
       C99.
           EXIT.
      *------------------
      **** rel 7.1
       CALL-VSRV133-MOV.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'MOV'   TO PPAR-TARC.
           MOVE KEYMV   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE '0'     TO PPAR-OPZ(81:1)
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 MOV. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *
       CALL-VSRV133-MOL.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'MOV'   TO PPAR-TARC.
           MOVE KEYML   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE '1'     TO PPAR-OPZ(81:1)
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 MOV. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *
       CALL-VSRV133-MSZ.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'MSZ'   TO PPAR-TARC.
           MOVE KEYMS   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE '0'     TO PPAR-OPZ(81:1)
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 MSZ. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *
       CALL-VSRV133-MSL.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'MSZ'   TO PPAR-TARC.
           MOVE KEYSL   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE '1'     TO PPAR-OPZ(81:1)
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 MSZ. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      ************
