       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON440.
      *
      * Routine di generazione file EINTRA in automatico 
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'griartsl'.
           COPY 'gritrasl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'griart'.
           COPY 'gritra'.                                          
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'griartrk'.
           COPY 'gritabrk'.
           COPY 'grit25rk'.
           COPY 'parcdt'.
           COPY 'parmb'.
       01  ID-AZI  PIC X(15) VALUE 'anaazi'.
       01  ID-CLF  PIC X(15) VALUE 'anaclf'.
       01  ID-ART  PIC X(15) VALUE 'magart'.
       01  ID-TRA  PIC X(15) VALUE 'eintra'.
       01  ID-TAB  PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-AZI  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-ART  PIC XX.
           05 SF-TRA  PIC XX.
           05 SF-TAB  PIC XX.
           05 MESS    PIC X(40) VALUE SPACE.
           05 SWCON   PIC 9.
           05 FLAGT25 PIC 9    VALUE ZERO.
           05 MESE    PIC 99   VALUE ZERO.
           05 ANNO    PIC 9(4) VALUE ZERO.
           05 ANPRE   PIC 9(4) VALUE ZERO.
           05 NOMMEA  PIC 9(8) VALUE ZERO.
           05 NOMMEV  PIC 9(8) VALUE ZERO.
      **** rel 6.3
           05 CS-PAED PIC 9.
           05 CS-CNCO PIC X.
           05 CS-MOTR PIC 9.
           05 CS-PRPR PIC XX.
           05 SR-MOER PIC X.
           05 SR-MOIN PIC X.
           05 SR-PAPG PIC XX.
           05 AC-CNCO PIC X.
           05 AC-MDTR PIC 9.
           05 AC-PAPR PIC 9.
           05 AC-PAOR PIC 9.
           05 AC-PRDE PIC XX.
           05 SI-MOER PIC X.
           05 SI-MOIN PIC X.
           05 SI-CDPP PIC 9.
           05 CDSDOG  PIC 9(6).
      ************
           05 DTDOC   PIC X(8) VALUE SPACE.
      * CONTROLLO PARTITA IVA  *
       01  PARPIVA.
           05  CODPIVA PIC 9(11).
           05  CODNUM  REDEFINES CODPIVA.
               10 NUM1 PIC 9(7).
               10 NUM2 PIC 9(3).
               10 NUM3 PIC 9.
           05  RISPIVA PIC 9.
       LINKAGE SECTION.
           COPY 'partra'.
       PROCEDURE DIVISION USING PARTRA.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclart'.
           COPY 'dcltra'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       VIA.
           COPY 'strsub'.
           OPEN INPUT ANACLF.
           OPEN INPUT MAGART.
           OPEN INPUT ANAAZI.
           OPEN I-O EINTRA.

           MOVE ZERO TO PTRA-ST.
           IF PTRA-TIPOP = 8
                 MOVE 'Il programma non provvede          ' TO F-MES1
                 MOVE 'all''aggiornamento Elenchi IVA CEE ' TO F-MES2
                 MOVE '(Mod. INTRA) per note di accredito.' TO F-MES3
                 MOVE 'Effettuare le eventuali rettifiche ' TO F-MES4
                 MOVE 'con l''apposito programma.         ' TO F-MES5
                 MOVE 5 TO F-NMES
                 MOVE 8 TO ERRIO-ST
                 GO TO FINE.
      *
      *> controlli su azienda
      *
           MOVE PTRA-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID
                PERFORM INVK-AZI
                GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           MOVE AZI-DTAPE TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO ANPRE.
           IF AZI-DTAPE = ZERO
              MOVE 'Manca data apertura esercizio' TO MESS
              GO TO ERRIO.
           IF AZI-PIVA = ZERO
              MOVE 'Manca Partita IVA Azienda' TO MESS
              GO TO ERRIO.
           MOVE AZI-PIVA TO CODPIVA.
           CALL 'rpiva' USING PARPIVA.
           IF RISPIVA NOT = ZERO
              MOVE 'Partita IVA errata' TO MESS
              GO TO ERRIO.
      *
      *> controlli su tabella 25/0 e 25/6 
      *
           MOVE PTRA-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4  TO ANNO.
      *
           MOVE 'tabell' TO ID-TAB. 
           IF ANNO < ANPRE MOVE 'tabold' TO ID-TAB.
           OPEN INPUT TABELL.
      **** rel 6.3
           MOVE 25        TO T25-TIP.
           MOVE PTRA-AZI  TO T25-COD.
           MOVE '6'       TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID
                MOVE 'Tabella 25/6 mancante' TO F-MES1
                MOVE 1 TO F-NMES
                CALL 'vrmbox' USING PARMB
                CLOSE TABELL
                GO TO FINE.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-NOMMEA TO NOMMEA.
           MOVE T25-NOMMEV TO NOMMEV.
           MOVE T25-CS-PAED TO CS-PAED.
           MOVE T25-CS-CNCO TO CS-CNCO.
           MOVE T25-CS-MOTR TO CS-MOTR.
           MOVE T25-CS-PRPR TO CS-PRPR.
           MOVE T25-SR-MOER TO SR-MOER.
           MOVE T25-SR-MOIN TO SR-MOIN.
           MOVE T25-SR-PAPG TO SR-PAPG.
           MOVE T25-AC-CNCO TO AC-CNCO.
           MOVE T25-AC-MDTR TO AC-MDTR.
           MOVE T25-AC-PAPR TO AC-PAPR.
           MOVE T25-AC-PAOR TO AC-PAOR.
           MOVE T25-AC-PRDE TO AC-PRDE.
           MOVE T25-SI-MOER TO SI-MOER.
           MOVE T25-SI-MOIN TO SI-MOIN.
           MOVE T25-SI-CDPP TO SI-CDPP.
           MOVE T25-CDSDOG  TO CDSDOG.
      ************
           MOVE 25        TO T25-TIP.
           MOVE PTRA-AZI  TO T25-COD.
           MOVE ZERO      TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
      **** rel 5.1
      *         MOVE 'Tabella 25/0 mancante' TO MESS
      *         CLOSE TABELL
      *         GO TO ERRIO.
                MOVE 'Tabella 25/0 mancante' TO F-MES1
                MOVE 1 TO F-NMES
                CALL 'vrmbox' USING PARMB
                CLOSE TABELL
                GO TO FINE.
      ************
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           IF T25-INTRA = ZERO GO TO FINE.
           IF PTRA-TRAN = 'A'
              MOVE T25-CEA TO FLAGT25
           ELSE
              MOVE T25-CEE TO FLAGT25.
           IF FLAGT25 = ZERO
      **** rel 5.1
      *         MOVE 'Gestione elenchi CEE non abilitata' TO MESS
      *         CLOSE TABELL
      *         GO TO ERRIO.
                MOVE 'Gestione elenchi CEE non abilitata' TO F-MES1
                MOVE 1 TO F-NMES
                CALL 'vrmbox' USING PARMB
                CLOSE TABELL
                GO TO FINE.
      ************
      **** rel 6.3
      *    MOVE 25        TO T25-TIP.
      *    MOVE PTRA-AZI  TO T25-COD.
      *    MOVE '6'       TO T25-PRG.
      *    MOVE T25-KEYID TO KEYTB.
      *    READ TABELL INTO REKT25 INVALID
      **** rel 5.1
      *         MOVE 'Tabella 25/6 mancante' TO MESS
      *         CLOSE TABELL
      *         GO TO ERRIO.
      *         MOVE 'Tabella 25/6 mancante' TO F-MES1
      *         MOVE 1 TO F-NMES
      *         CALL 'vrmbox' USING PARMB
      *         CLOSE TABELL
      *         GO TO FINE.
      ************
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
      *    MOVE T25-NOMMEA TO NOMMEA.
      *    MOVE T25-NOMMEV TO NOMMEV.
      ************
           CLOSE TABELL.
      ***
           MOVE PTRA-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4  TO ANNO.
           MOVE ZERO TO MESE.
           IF FLAGT25 = 1 MOVE MM9 TO MESE. 
           IF FLAGT25 NOT = 2  GO TO NO-TRIM.
           IF MM9 > ZERO AND <= 3  MOVE 1 TO MESE.
           IF MM9 > 3    AND <= 6  MOVE 2 TO MESE.
           IF MM9 > 6    AND <= 9  MOVE 3 TO MESE.
           IF MM9 > 9    AND <= 12 MOVE 4 TO MESE.
       NO-TRIM.
           MOVE PTRA-AZI   TO KTA-AZI.
           MOVE AZI-PIVA   TO KTA-IVA.
           MOVE ANNO       TO KTA-ANNO.
           MOVE MESE       TO KTA-PERI.
           MOVE PTRA-TRAN  TO KTA-TRAN.
           MOVE 1          TO KTA-TIPO.
           MOVE PTRA-CATT  TO KTA-TIPN.
           MOVE PTRA-NPRGI TO KTA-PROT.
           MOVE PTRA-PROG  TO KTA-PROG.
      *    READ EINTRA NOT INVALID GO TO FINE.
           READ EINTRA NOT INVALID PERFORM ESISTE-MOV THRU E99
                                   GO TO FINE.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           MOVE PTRA-AZI   TO KTA-AZI.
           MOVE AZI-PIVA   TO KTA-IVA.
           MOVE ANNO       TO KTA-ANNO.
           MOVE MESE       TO KTA-PERI.
           MOVE PTRA-TRAN  TO KTA-TRAN.
           MOVE 1          TO KTA-TIPO.
           MOVE PTRA-CATT  TO KTA-TIPN.
           MOVE PTRA-NPRGI TO KTA-PROT.
           MOVE PTRA-PROG  TO KTA-PROG.
      *
           MOVE PTRA-AZI  TO KCF-AZI.
           MOVE PTRA-CLFO TO KCF-COD TRA-CDCLF.
           READ ANACLF INTO REKCLF INVALID KEY
                MOVE SPACE TO CLF-PAE CLF-IVE.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      **** rel 6.3
      *
      * Per soggetti tipo 4 e con paese CEE SPACE o Italia non eseguo
      * la scrittura dei movimenti INTRA.
      *
      **** rel 7.2
      *    IF (CLF-PAE = 'IT' OR SPACE) AND CLF-13IVA = 4
           IF CLF-13IVA = 4
              IF CLF-PAE = 'IT'  OR
                 CLF-PAE = SPACE OR
                 CLF-PAE IS NUMERIC
      **********
              GO TO FINE.
      *
      ************
           MOVE CLF-PAE TO TRA-CDSTA.
           MOVE CLF-IVE TO TRA-CDIVE.

           MOVE PTRA-NUDOC TO TRA-NUDOC.
           MOVE PTRA-DTDOC TO TRA-DTDOC.
           MOVE '1'        TO TRA-NATRA.
      **** rel 7.1
           IF PTRA-NATRA NOT = SPACE
              MOVE PTRA-NATRA TO TRA-NATRA.
      ************
           MOVE PTRA-IML   TO TRA-IMPLI.
           MOVE PTRA-IMV   TO TRA-IMPVA.
           MOVE PTRA-VAL   TO TRA-CODVA.
      **** rel 7.1
           MOVE PTRA-VASTA TO TRA-VASTA.
           MOVE PTRA-MNET  TO TRA-MASNE.
           IF PTRA-CDPRO NOT = SPACE MOVE PTRA-CDPRO TO TRA-CDPRO.
           IF PTRA-CDPAP NOT = SPACE MOVE PTRA-CDPAP TO TRA-CDPAP.
           IF PTRA-CDPAO NOT = SPACE MOVE PTRA-CDPAO TO TRA-CDPAO.
      ************
           IF PTRA-NOMME NOT = ZERO MOVE PTRA-NOMME TO TRA-NOMME
           ELSE
              IF CLF-NOMME NOT = ZERO MOVE CLF-NOMME TO TRA-NOMME
              ELSE
                 IF PTRA-TRAN = 'A' MOVE NOMMEA TO TRA-NOMME
                 ELSE MOVE NOMMEV TO TRA-NOMME.
      **** rel 6.3
      * servizi
           IF TRA-NOMME NOT = ZERO AND TRA-NOMME < 1000000
              MOVE TRA-NOMME TO TRA-SCOD
              MOVE ZERO      TO TRA-NOMME
              IF PTRA-TRAN = 'A'
                 MOVE 'I'       TO KTA-TRAN
              ELSE
                 MOVE 'R'       TO KTA-TRAN.
      **** rel 6.3
      * valorizzazione da tabella T25 PRG 6 configurazione INTRA
           IF KTA-TRAN = 'A'
              MOVE AC-CNCO TO TRA-CDREG
              MOVE AC-MDTR TO TRA-CDTRA
      **** rel 7.1
              IF PTRA-CDPAP NOT = SPACE
                 MOVE PTRA-CDPAP TO TRA-CDPAP
              ELSE
      ************
              IF AC-PAPR = ZERO
                 MOVE SPACE TO TRA-CDPAP
              ELSE
                 MOVE CLF-PAE TO TRA-CDPAP
              END-IF
      **** rel 7.1
              END-IF
      *
              IF PTRA-CDPAO NOT = SPACE
                 MOVE PTRA-CDPAO TO TRA-CDPAO
              ELSE
      ************
              IF AC-PAOR = ZERO
                 MOVE SPACE TO TRA-CDPAO
              ELSE
                 MOVE CLF-PAE TO TRA-CDPAO
              END-IF
      **** rel 7.1
              END-IF
              IF PTRA-CDPRO NOT = SPACE
                 MOVE PTRA-CDPRO TO TRA-CDPRO
              ELSE
      ************
              MOVE AC-PRDE TO TRA-CDPRO.
           IF KTA-TRAN = 'C'
              IF CS-PAED = ZERO
                 MOVE SPACE TO TRA-CDPAP
              ELSE
                 MOVE CLF-PAE TO TRA-CDPAP
              END-IF
      **** rel 7.1
              IF PTRA-CDPAP NOT = SPACE 
                 MOVE PTRA-CDPAP TO TRA-CDPAP
              END-IF
      ************
              MOVE CS-CNCO TO TRA-CDREG
              MOVE CS-MOTR TO TRA-CDTRA
      **** rel 7.1
      *       MOVE CS-PRPR TO TRA-CDPRO.
              MOVE CS-PRPR TO TRA-CDPRO
              IF PTRA-CDPRO NOT = SPACE 
                 MOVE PTRA-CDPRO TO TRA-CDPRO
              END-IF
           END-IF.
      ************
           IF KTA-TRAN = 'R'
              MOVE SR-MOER TO TRA-SMODER
              MOVE SR-MOIN TO TRA-SMODIN
      **** rel 7.1
              IF PTRA-MOER NOT = SPACE
                 MOVE PTRA-MOER TO TRA-SMODER
              END-IF
              IF PTRA-MOIN NOT = SPACE
                 MOVE PTRA-MOIN TO TRA-SMODIN
              END-IF
      ************
              MOVE SR-PAPG TO TRA-SPAEP.
           IF KTA-TRAN = 'I'
              MOVE SI-MOER TO TRA-SMODER
              MOVE SI-MOIN TO TRA-SMODIN
      **** rel 7.1
              IF PTRA-MOER NOT = SPACE
                 MOVE PTRA-MOER TO TRA-SMODER
              END-IF
              IF PTRA-MOIN NOT = SPACE
                 MOVE PTRA-MOIN TO TRA-SMODIN
              END-IF
      *
              IF PTRA-SPAEP NOT = SPACE
                 MOVE PTRA-SPAEP TO TRA-SPAEP
              ELSE
      ************
              IF SI-CDPP = ZERO
                 MOVE SPACE TO TRA-SPAEP
              ELSE
                 MOVE CLF-PAE TO TRA-SPAEP
              END-IF.
      * valorizzo parametri in output
           MOVE KEYTA TO PTRA-KEYTRA.
      ************
      **** rel 7.1
           IF PTRA-FLGFIS > ZERO
              MOVE ZERO  TO TRA-MASNE
              MOVE ZERO  TO TRA-VASTA
              MOVE ZERO  TO TRA-CDTRA
              MOVE SPACE TO TRA-CDPAP
              MOVE SPACE TO TRA-CDPRO
              MOVE SPACE TO TRA-CDREG
              MOVE SPACE TO TRA-NATRA
           END-IF.
      ************
      ***
           WRITE RF-TRA INVALID
              PERFORM INVK-TRA
              GO TO ERRIO.
      ***
           GO TO FINE.
      *-------------*
       ERRIO.
           COPY 'errsub'.
       FINE.
           CLOSE ANAAZI.
           CLOSE ANACLF.
           CLOSE MAGART.
           CLOSE EINTRA.
           EXIT PROGRAM.
           STOP RUN.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'griarter'.
           COPY 'gritraer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
       AZZ-REC.
           MOVE ZERO  TO RF-TRA.
           MOVE ZERO  TO TRA-IMPLI
                         TRA-IMPVA
                         TRA-MASNE
                         TRA-MISSU
                         TRA-VASTA.
           MOVE SPACE TO KTA-TRAN
                         KTA-TIPN
                         TRA-CDSTA
                         TRA-CDIVE
                         TRA-NATRA
                         TRA-CDPAP
                         TRA-CDPAO
      **** rel 6.2
                         TRA-CDREG
      ************
                         TRA-CDPRO.
       EX-AZZ-REC.
           EXIT.
      *------------------
       ESISTE-MOV.
           MOVE TRA-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DTDOC.

           MOVE 'Movimento INTRA gia'' esistente:' TO F-MES1.
           MOVE 'nessun aggiornamento effettuato!' TO F-MES2.
           STRING 'N. Documento ' TRA-NUDOC ' del ' DTDOC
                     DELIMITED SIZE INTO F-MES3.
           MOVE 3 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
       E99.
           EXIT.
      *------------------

