       IDENTIFICATION DIVISION.
       PROGRAM-ID. VINTPLA2.
      *
      * OGGETTO: aggiorna file connettore x pubblicazione
      *          dichiarazione di intento
      *
      *          Integra CONNETTORE GENERICO
      *
      **** rel 6.2
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griclfsl'.
           COPY 'gricdtsl'.
           COPY 'gricdrsl'.
           COPY 'gritabsl'.
      *
       DATA DIVISION.
       FILE SECTION.
           COPY 'griclf'.
           COPY 'gricdt'.
           COPY 'gricdr'.
           COPY 'gritab'.
      *
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parlpd'.
           COPY 'parppar'.
           COPY 'parpcgn'.
           COPY 'parwcd'.
      *
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-CDT PIC X(50) VALUE 'codate'.
       01  ID-CDR PIC X(50) VALUE 'codari'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-CLF   PIC XX.
           05 SF-CDT   PIC XX.
           05 SF-CDR   PIC XX.
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 COMAZI   PIC X(3).
           05 COMDAT   PIC 9(5).
           05 COMCLI   PIC 9(5).
           05 COMAA4   PIC 9(4)  VALUE ZERO.
           05 COMDT4   PIC X(10) VALUE SPACE.
           05 COMAMG   PIC X(6).
           05 TMPEST   PIC X(50) VALUE SPACE.
           05 I        PIC 999   VALUE ZERO.
           05 IZ       PIC 999   VALUE ZERO.
           05 NUMZ     PIC ZZZZZZZ9.
           05 ALLEGA   PIC X(32) VALUE SPACE.
           05 CODICE.
              10 MAS   PIC 99   VALUE ZERO.
              10 COD   PIC 9(5) VALUE ZERO.
           05 IND1     PIC 99.

      **** rel 7.2
      *    05 OPZIONI.
      *       10 COM-NPRT     PIC  9(4) COMP-3.       
      *       10 COM-ANNO     PIC  9(4) COMP-3.       
      *       10 COM-DTDOC    PIC  9(5) COMP-3.       
      *       10 COM-ART      PIC  X(4).       
      *       10 COM-DESCR-1  PIC  X(50).      
      *       10 COM-TPDIC    PIC  9(1).       
      *       10 COM-IMPOR    PIC  9(11)V99 COMP-3.      
      *       10 COM-PERG1    PIC  9(2).       
      *       10 COM-PERM1    PIC  9(2).       
      *       10 COM-PERG2    PIC  9(2).       
      *       10 COM-PERM2    PIC  9(2).       
           05 OPZIONI.
              10 COM-NPRT     PIC X(14).
              10 COM-FILE     PIC X(80).
              10 COM-NRIG     PIC 9(5) COMP-3.
              10 COM-DTDOC    PIC 9(5) COMP-3.
      ************
      *---------------------------------------------------------
       LINKAGE SECTION.
           COPY 'parxcd'.
           COPY 'parpint'.
       01  NOMEFILE PIC X(11).
      *
       PROCEDURE DIVISION USING PARXCD PARPINT NOMEFILE.
           COPY 'declxer1'.
      *    COPY 'dclcdr'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.
      *
           OPEN INPUT TABELL.
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY GO TO FINE.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 6.3
      *    MOVE T01-MCLI TO MAS.
           MOVE T01-MFOR TO MAS.
      ************
           CLOSE TABELL.
      *
           MOVE PXCD-IDCDT TO ID-CDT.
           MOVE PXCD-IDCDR TO ID-CDR.
      *
           MOVE 'I' TO PCGN-FUN.
           CALL 'vintgen2' USING PARXCD PARPINT NOMEFILE PARPCGN.
           IF PXCD-ERR NOT = ZERO GO TO ESCI.
      *
           OPEN INPUT ANACLF.
           OPEN INPUT CODATE CODARI.
      *
           MOVE PINT-AZI   TO COMAZI.
           IF PINT-I-AZI NOT = SPACE
              MOVE PINT-I-AZI TO COMAZI.
      *
           MOVE PXCD-SRV TO KCDT-SRV.
           MOVE PXCD-PRG TO KCDT-PRG.
           READ CODATE INVALID GO TO FINE.
      *
           MOVE PXCD-SRV TO KCDR-SRV.
           MOVE PXCD-PRG TO KCDR-PRG.
           MOVE ZERO     TO KCDR-PRR.
           START CODARI KEY NOT < KEYCDR INVALID GO TO FINE.
       LOOPCDR.
           READ CODARI NEXT AT END GO TO ENDCDR.
           IF SF-CDR = '9A' OR '9D' OR '35' GO TO LOOPCDR.
           IF KCDR-SRV > PXCD-SRV GO TO ENDCDR.
           IF KCDR-PRG > PXCD-PRG GO TO ENDCDR.

           PERFORM INVIA-AGGIO THRU EX-INVIA-AGGIO.

           IF PXCD-ERR NOT = ZERO GO TO FINE.
      *    GO TO LOOPCDR.     *> considerare solo primo record di codari
       ENDCDR.
           GO TO FINE.
      * 
       ERRIO.
           GO TO FINE.
      *
       FINE.
           CLOSE CODATE CODARI ANACLF.
      *
       ESCI.
           EXIT PROGRAM.
      *------------------
       INVIA-AGGIO.
           MOVE CDR-OPZ TO OPZIONI.
      *
           MOVE COM-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4     TO COMAA4.
           MOVE GBMMBA4 TO COMDT4.
           MOVE GGMMAA  TO COMAMG.

           MOVE CDR-KEY(4:7) TO CODICE.

      **** rel 7.1
      *    MOVE COMAZI   TO KCF-AZI.
           MOVE CDR-KEY(1:3) TO KCF-AZI.
      ************
           MOVE CODICE   TO KCF-COD.
           READ ANACLF INVALID MOVE SPACE TO CLF-RGS.

           PERFORM CHECK-LOG THRU EX-CHECK-LOG.
           IF PXCD-ERR NOT = ZERO GO TO EX-INVIA-AGGIO.

           MOVE 'W'          TO PCGN-FUN.
      *
           MOVE 'I'          TO PCGN-TIP.
           MOVE COMAZI       TO PCGN-AZI.
           MOVE 'F'          TO PCGN-TSOG.    *> new
           MOVE COD          TO PCGN-CSOG.
           MOVE 'pla'        TO PCGN-TDOC.    *> new
      **** rel 7.2
      *    MOVE COM-NPRT     TO PCGN-NDOC.
           MOVE COM-NPRT(1:4) TO PCGN-NDOC.
      ************
           MOVE SPACE        TO PCGN-SERIE.
           MOVE COMDT4       TO PCGN-DTDOC.

           PERFORM CREA-TIT.                  *> new
           PERFORM CREA-DES.                  *> new

      *--- Costruisce nome allegato -*

      * Ricerca estensione allegato
           MOVE 50 TO IND1.
           PERFORM UNTIL PXCD-PATH(IND1:1) = '.' OR IND1 = ZERO
                   SUBTRACT 1 FROM IND1.
           MOVE PXCD-PATH(IND1:) TO TMPEST.

           MOVE SPACE TO ALLEGA.
           STRING 'pla'
                  DELIMITED SIZE 
                  COMAZI
                  DELIMITED SPACE 
                  COD
      **** rel 7.2
                  COM-NPRT(1:4)
      ************
                  COMAMG
                  DELIMITED SIZE 
                  TMPEST 
                  DELIMITED SPACE INTO ALLEGA.

           MOVE ALLEGA TO PCGN-ALLEGA.
      *------------------------------*

           MOVE PXCD-LOGNAME TO PCGN-UTE.
      *
           CALL 'vintgen2' USING PARXCD PARPINT NOMEFILE PARPCGN.
           IF PXCD-ERR NOT = ZERO GO TO EX-INVIA-AGGIO.
      *
      * accoda evento di tipo SAV per documento non inviato
           IF PCGN-FLGS = 1
              MOVE ZERO       TO PWCD-FUN
              MOVE 'SAV'      TO PWCD-TIPO
              MOVE PXCD-TDOC  TO PWCD-TDOC
              MOVE PXCD-TDES  TO PWCD-TDES
              MOVE PXCD-CDES  TO PWCD-CDES
              MOVE CDR-KEY    TO PWCD-KEY
              MOVE PXCD-PARAM TO PWCD-PARAM
              MOVE CDR-OPZ    TO PWCD-OPZ
      **** rel 6.3
              MOVE PXCD-SRV   TO PWCD-SRV
      ************
              CALL 'vrwcoda' USING PARWCD
              IF PWCD-ERR NOT = ZERO
                 MOVE PWCD-ERR TO PXCD-ERR
                 MOVE 'Errore vrwcoda SAV' TO PXCD-LOG
                 GO TO EX-INVIA-AGGIO.
      *
           MOVE ZERO         TO PARLPD.
           MOVE 'W'          TO PLPD-FUN.
           MOVE SPACE        TO PLPD-TDOC.
           MOVE COMAZI       TO PLPD-AZI.
           MOVE 'INT'        TO PLPD-TIPO.
           MOVE COMAA4       TO PLPD-ANNO.
           MOVE CDR-KEY      TO PLPD-KEY.
           MOVE CDT-DATA     TO PLPD-EV-DATA.
           MOVE CDT-ORA      TO PLPD-EV-ORA.
           MOVE ZERO         TO PLPD-DTDOC.
           MOVE ALLEGA       TO PLPD-NOMEFILE.
           MOVE SPACE        TO PLPD-CATT.
           CALL 'vrc-lpd' USING PARXCD PARLPD.
           IF PXCD-ERR NOT = ZERO GO TO EX-INVIA-AGGIO.
      *
       EX-INVIA-AGGIO.
           EXIT.
      *------------------
       CHECK-LOG.
      * verifica se il soggetto e' stato precedentemente pubblicato
           MOVE ZERO        TO PARLPD.
           MOVE 'R'         TO PLPD-FUN.
      **** rel 6.3
      *    MOVE 'CLI'       TO PLPD-TDOC.
           MOVE 'FOR'       TO PLPD-TDOC.
      ************
           MOVE COMAZI      TO PLPD-AZI.
           MOVE 'INT'       TO PLPD-TIPO.
           MOVE ZERO        TO PLPD-ANNO.
           MOVE KEYCF       TO PLPD-KEY.
           MOVE ZERO        TO PLPD-CATT.
           CALL 'vrc-lpd' USING PARXCD PARLPD.
           IF PLPD-PROG > ZERO GO TO EX-CHECK-LOG.
      *
           MOVE ZERO   TO PPAR-FUN.
      **** rel 6.3
      *    MOVE 'CLI'  TO PPAR-TARC.
           MOVE 'FOR'  TO PPAR-TARC.
      ************
           MOVE 'I'    TO PPAR-TOPE.
           MOVE KEYCF  TO PPAR-KEY.
           MOVE ZERO   TO PPAR-CATT.
      **** rel 7.1
      *    CALL 'vsrv130' USING PARPPAR.
           CALL 'vsrv133' USING PARPPAR 'INT'.
      ************
           IF PPAR-ERR > 1 
              MOVE PPAR-ERR TO PXCD-ERR
      **** rel 6.3
      *       MOVE 'Errore vsrv130 CLI' TO PXCD-LOG.
      **** rel 7.1
      *       MOVE 'Errore vsrv130 FOR' TO PXCD-LOG.
              MOVE 'Errore vsrv133 FOR' TO PXCD-LOG.
      ************
      ************
       EX-CHECK-LOG.
           EXIT.
      *------------------
      *--- costruisce titolo --------*
       CREA-TIT.
           MOVE 1 TO I.

           STRING 'Dichiarazione Intento ' DELIMITED SIZE
                  INTO PCGN-DOCT POINTER I.

      **** rel 7.2
           STRING COM-NPRT(1:4) DELIMITED SIZE
                  INTO PCGN-DOCT POINTER I.
      ************
           MOVE 1 TO IZ.

      **** rel 7.2
      *    STRING ' del ' COMDT4 DELIMITED SIZE
      *           INTO PCGN-DOCT POINTER I.
           STRING ' del ' AA4 DELIMITED SIZE
                  INTO PCGN-DOCT POINTER I.
      ************
      *------------------
      *--- costruisce descrizione ---*
       CREA-DES.
           MOVE 1 TO I.

           STRING 'Dichiarazione Intento ' DELIMITED SIZE
                  INTO PCGN-DOCD POINTER I.

      **** rel 7.2
           STRING COM-NPRT(1:4) DELIMITED SIZE
                  INTO PCGN-DOCD POINTER I.
      ************
           STRING ' del ' COMDT4 DELIMITED SIZE
                  INTO PCGN-DOCD POINTER I.

           STRING ' - ' CLF-RGS DELIMITED SIZE
                  INTO PCGN-DOCD POINTER I.
      *------------------
