       IDENTIFICATION DIVISION.
       PROGRAM-ID. VLIN130.
      *
      * Stampa libro inventari
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gribilsl'.
           COPY 'griallsl'.
           COPY 'gricolsl'.
           COPY 'gricfxsl'.
           COPY 'grimvxsl'.
           COPY 'grimolsl'.
           COPY 'grimslsl'.
           COPY 'griartsl'.
           COPY 'grilifsl'.
           COPY 'grimsxsl'.
           SELECT WDSLAV ASSIGN TO DISK 
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           SELECT WDSLA2 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL2 STATUS SF-LA2.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gribil'.
           COPY 'griall'.
           COPY 'gricol'.
           COPY 'gricfx'.
           COPY 'grimvx'.                                         
           COPY 'grimol'.                                         
           COPY 'grimsl'.                                         
           COPY 'griart'.
           COPY 'grilif'.
           COPY 'grimsx'.                                         
           COPY 'gritab'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 23 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-TIP PIC 99.
              10 KLV-CAT PIC 9.
              10 KLV-COD.
                 15 KLV-MS PIC 9(2).
                 15 KLV-CD PIC 9(5).
           05 LAV-IMP PIC S9(11)V99.
      *
       FD  WDSLA2 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA2
      **** rel 7.2
      *    RECORD 62 DATA RECORD RF-LA2.
           RECORD 68 DATA RECORD RF-LA2.
      ************
       01  RF-LA2.
           05 KEYL2.
              10 KL2-CAT PIC 9.
      **** rel 7.2
      *       10 KL2-ART PIC X(12).
              10 KL2-ART PIC X(18).
      ************
              10 KL2-ANN PIC 9(4).
           05 LA2-QTA PIC S9(11)V999.
           05 LA2-PRZ PIC S9(11)V9(6).
           05 LA2-FSC PIC 9.
           05 LA2-IMP PIC S9(11)V99.
      *
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parpsb'.
           COPY 'griazirk'.
           COPY 'griconrk'.
           COPY 'griclfrk'.
           COPY 'grimovrk'.                                       
           COPY 'grimolrk'.                                       
           COPY 'gritabrk'.
           COPY 'grit20rk'.
           COPY 'griartrk'.
           COPY 'parcdt'.
           COPY 'parzf'.
           COPY 'parpv'.
           COPY 'parrd'.
           COPY 'parop'.
           COPY 'parmb'.
       01  COMODI.
           05 ID-AZI PIC X(15) VALUE 'anazol'.
           05 ID-BIL PIC X(15) VALUE 'anabil'.
           05 ID-ALL PIC X(15) VALUE 'analle'.
           05 ID-COL PIC X(15) VALUE 'anacol'.
           05 ID-CFX PIC X(15) VALUE 'anacfx'.
           05 ID-MVX PIC X(15) VALUE 'movoxx'.
           05 ID-MOL PIC X(15) VALUE 'movmol'.
           05 ID-MSX PIC X(15) VALUE 'mosoxx'.
           05 ID-MSL PIC X(15) VALUE 'movsol'.
           05 ID-TAB PIC X(15) VALUE 'tabell'.
           05 ID-ART PIC X(15) VALUE 'magart'.
           05 ID-LIF PIC X(15) VALUE 'maglif'.
           05 ID-LAV PIC X(15) VALUE 'wdslav'.
           05 ID-LA2 PIC X(15) VALUE 'wdsla2'.
           05 SF-AZI PIC XX.
           05 SF-BIL PIC XX.
           05 SF-ALL PIC XX.
           05 SF-COL PIC XX.
           05 SF-CFX PIC XX.
           05 SF-MVX PIC XX.
           05 SF-MOL PIC XX.
           05 SF-MSX PIC XX.
           05 SF-MSL PIC XX.
           05 SF-TAB PIC XX.
           05 SF-ART PIC XX.
           05 SF-LIF PIC XX.
           05 SF-LAV PIC XX.
           05 SF-LA2 PIC XX.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 TEST0  PIC 9 VALUE ZERO.                                 
           05 TESTA  PIC 9 VALUE ZERO.                                 
           05 MESS   PIC X(40) VALUE SPACE.
           05 PKDT1  PIC 9(5) COMP-3 VALUE ZERO.
           05 PKDT2  PIC 9(5) COMP-3 VALUE ZERO.
           05 DGRU   PIC X(28) VALUE SPACE.
           05 TOTVL  PIC S9(11)V99 VALUE ZERO.
           05 TOTQT  PIC S9(13)V999 VALUE ZERO.
           05 TCON   PIC 9 VALUE ZERO.
           05 MCLI   PIC 99 VALUE ZERO.
           05 MFOR   PIC 99 VALUE ZERO.
           05 K      PIC 999 VALUE ZERO.
           05 J      PIC 999 VALUE ZERO.
           05 PART   PIC 9(7) VALUE ZERO.
           05 PR REDEFINES PART.
              10 MPAR PIC 99.
              10 MCLF PIC 9(5).
           05 KONCA   PIC 999.
           05 POSIZ   PIC 999.
           05 CONCAIN PIC X(36).
           05 CONCOUT.
              10 WDSK31 PIC X(54).
              10 WDSK32 PIC X(54).
              10 WDSK33 PIC X(54).
           05 COMCOUT.
              10 FILLER PIC X(54).
              10 FILLER PIC X(54).
              10 FILLER PIC X(54).
      **** rel 7.2
      *    05 ART1   PIC X(12) VALUE SPACE.
           05 ART1   PIC X(18) VALUE SPACE.
      ************
           05 QTAL   PIC S9(13)V999 VALUE ZERO.
           05 TOT    PIC S9(13)V999 VALUE ZERO.
           05 CICLO  PIC 9   VALUE ZERO.
           05 CDCLC  PIC 999 VALUE ZERO.
           05 CACLC  PIC 999 VALUE ZERO.
           05 CDFOC  PIC 999 VALUE ZERO.
           05 CAFOC  PIC 999 VALUE ZERO.
           05 CDSOC  PIC 999 VALUE ZERO.
           05 CASOC  PIC 999 VALUE ZERO.
           05 CDSOA  PIC 999 VALUE ZERO.
           05 CASOA  PIC 999 VALUE ZERO.
           05 FLAPE  PIC 9   VALUE ZERO.
           05 COUTI  PIC 9(7) VALUE ZERO.
           05 COPER  PIC 9(7) VALUE ZERO.
           05 DFPAT  PIC S9(11)V99 VALUE ZERO.
           05 DFECO  PIC S9(11)V99 VALUE ZERO.
           05 SALDO  PIC S9(11)V99 VALUE ZERO.
           05 WSALDO PIC ZZZ.ZZZ.ZZ9,99-. 
           05 TTGRUP PIC S9(11)V99 VALUE ZERO.
           05 TOTGRU PIC S9(11)V99 OCCURS 6.
           05 COLONN PIC 9 VALUE ZERO.
           05 TOTCOL PIC S9(11)V99 VALUE ZERO.
           05 DATSTA PIC ZZ/ZZ/ZZ.
      *
           05 TINT1.
              10 FILLER PIC X(28) VALUE 
              'I N V E N T A R I O   A L  '.
              10 RDTIN  PIC ZZ/ZZ/ZZ.
           05 TINT2.
              10 FILLER PIC X(36) VALUE ALL '='.
           05 TINT3.
              10 FILLER PIC X(48) VALUE 
              'B I L A N C I O   D I   C H I U S U R A   A L'.
              10 RDCHI  PIC ZZ/ZZ/ZZ.
           05 TINT4.
              10 FILLER PIC X(56) VALUE ALL '='.
           05 TINT5.
              10 FILLER PIC X(35) VALUE 
              'P R O F I T T I   E   P E R D I T E'.
           05 TINT6.
              10 FILLER PIC X(35) VALUE ALL '='.
      *
           05 DESAX.
              10 FILLER PIC X(28) VALUE 'A T T I V I T A'' '.
              10 FILLER PIC X(28) VALUE 'CONTI D'' ORDINE'.
              10 FILLER PIC X(28) VALUE 'P A S S I V I T A'' '.
              10 FILLER PIC X(28) VALUE 'CONTI D'' ORDINE'.
              10 FILLER PIC X(28) VALUE 'PROFITTI E RENDITE'.
              10 FILLER PIC X(28) VALUE 'PERDITE E SPESE'.
           05 DESAT REDEFINES DESAX PIC X(28) OCCURS 6.
           05 SOTTX.
              10 FILLER PIC X(28) VALUE '----------------'.
              10 FILLER PIC X(28) VALUE '---------------'.
              10 FILLER PIC X(28) VALUE '------------------'.
              10 FILLER PIC X(28) VALUE '---------------'.
              10 FILLER PIC X(28) VALUE '------------------'.
              10 FILLER PIC X(28) VALUE '---------------'.
           05 SOTTY REDEFINES SOTTX PIC X(28) OCCURS 6.
           05 DESTX.
              10 FILLER PIC X(28) VALUE 'TOTALE ATTIVITA'' '.
              10 FILLER PIC X(28) VALUE 'TOTALE CONTI D''ORDINE'.
              10 FILLER PIC X(28) VALUE 'TOTALE PASSIVITA'' '.
              10 FILLER PIC X(28) VALUE 'TOTALE CONTI D''ORDINE'.
              10 FILLER PIC X(28) VALUE 'TOTALE PROFITTI E RENDITE'.
              10 FILLER PIC X(28) VALUE 'TOTALE PERDITE E SPESE'.
           05 DESTO REDEFINES DESTX PIC X(28) OCCURS 6.
           05 SOTOX.
              10 FILLER PIC X(28) VALUE '================'.
              10 FILLER PIC X(28) VALUE '====================='.
              10 FILLER PIC X(28) VALUE '================='.
              10 FILLER PIC X(28) VALUE '====================='.
              10 FILLER PIC X(28) VALUE '========================='.
              10 FILLER PIC X(28) VALUE '======================'.
           05 SOTOY REDEFINES SOTOX PIC X(28) OCCURS 6.

           COPY 'vlin130.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-DATA-1    PIC 9(6).
           05 IF-DATA-2    PIC 9(6).
           05 IF-DTELA     PIC 9(6).
           05 IF-TPSTA     PIC 9.
           05 IF-FLDE      PIC 9.
           05 IF-NBOL      PIC 9.
           05 IF-NUM-1     PIC 9(5).
           05 IF-ANNO      PIC 9(4).
           05 IF-PIEDE-1   PIC X(60).
           05 IF-PIEDE-2   PIC X(60).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclbil'.
           COPY 'dclall'.
           COPY 'dclcol'.
           COPY 'dclcfx'.
           COPY 'dclmvx'.
           COPY 'dclmol'.
           COPY 'dclmsl'.
           COPY 'dclart'.
           COPY 'dcllif'.
           COPY 'dclmsx'.
           COPY 'dcltab'.
           COPY 'dcllav'.
           COPY 'dclla2'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vlin130: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANABIL ANALLE TABELL.
           CLOSE ANAAZI.
           CLOSE WDSLAV WDSLA2.
           OPEN OUTPUT WDSLAV WDSLA2.
           CLOSE WDSLAV WDSLA2.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gribiler'.
           COPY 'grialler'.
           COPY 'gricoler'.
           COPY 'gricfxer'.
           COPY 'grimvxer'.
           COPY 'grimoler'.
           COPY 'grimsler'.
           COPY 'griarter'.
           COPY 'grilifer'.
           COPY 'grimsxer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV WDSLA2.
           CLOSE WDSLAV WDSLA2.
           OPEN I-O   WDSLAV WDSLA2.
      *
           OPEN I-O ANABIL
                    ANALLE.
      *
           OPEN INPUT ANAAZI
                      ANACOL
                      MOVMOL
                      MOVMXX
                      TABELL.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
           MOVE 20 TO KTB-TIP.
           MOVE 1  TO KTB-COD.
           READ TABELL INTO RKTB20 INVALID KEY 
                       PERFORM INVK-TAB
                       CLOSE TABELL
                       GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.
           MOVE T20-CDCLC TO CDCLC.
           MOVE T20-CACLC TO CACLC.
           MOVE T20-CDFOC TO CDFOC.
           MOVE T20-CAFOC TO CAFOC.
           MOVE T20-CDSOC TO CDSOC.
           MOVE T20-CASOC TO CASOC.
           MOVE T20-COUTI TO COUTI.
           MOVE T20-COPER TO COPER.
           MOVE T20-CDSOA TO CDSOA.
           MOVE T20-CASOA TO CASOA.
           CLOSE TABELL.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO TO IF-DATA-2.
           MOVE ZERO TO IF-DATA-1.
           MOVE ZERO TO IF-TPSTA  
                        IF-FLDE.
      *
           MOVE AZI-DTAPE TO AAGGG PKDT1.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DATA-1.
      *
           MOVE 1 TO TIPOP1.
           ADD 11 TO MM9.
           IF MM9 > 12 ADD 1 TO AA9
                       SUBTRACT 12 FROM MM9.
           MOVE 31 TO GG9.
       LDAT.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 NOT = ZERO SUBTRACT 1 FROM GG9
                                         GO TO LDAT.
           IF GG9 < 28 MOVE ZERO TO GGMMAA.
           MOVE GGMMAA TO IF-DATA-2.
           MOVE AAGGG  TO PKDT2.
      *
           MOVE ZERO TO IF-NBOL
                        IF-NUM-1
                        IF-ANNO.
           MOVE SPACE TO IF-PIEDE-1
                         IF-PIEDE-2.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           IF IF-DATA-1 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT1.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT2.
           IF PKDT2 < PKDT1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DATA-2.
      *
       V-DTELA.
           MOVE 'IF-DTELA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTELA.
           IF IF-DTELA = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTELA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG < PKDT2 
              PERFORM ERR-DINC 
              GO TO V-ERROR.
       E-DTELA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 2
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           IF RP-TRPT = ZERO 
              MOVE 'E'' possibile stampare il Report' TO F-MES1
              MOVE 'solo a carattere o visuale.'     TO F-MES2
              MOVE 'Forzato visuale.' TO F-MES3
              MOVE 3 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO RP-TRPT.
      *
           IF IF-NBOL = 1
              MOVE 'PBK_ADES' TO RP-BLK
              MOVE IF-PIEDE-1 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_ACIT' TO RP-BLK
              MOVE IF-PIEDE-2 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_DPAG' TO RP-BLK
              STRING 'Anno: ' IF-ANNO
                     DELIMITED SIZE INTO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_NPAG' TO RP-BLK
              MOVE IF-NUM-1 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE IF-ANNO  TO PANNO
              MOVE '/'      TO PBARR
              IF IF-ANNO = ZERO 
                 MOVE SPACE TO PANNO PBARR
              END-IF
              MOVE ZERO TO FNPG
           ELSE
              MOVE SPACE TO RTPAG
              MOVE 1 TO FNPG
              MOVE 'np' TO RP-VERM.    *> per non stampare il piede

           MOVE AZRGSOC TO TAZI.
      *
           MOVE IF-DATA-2 TO RDTIN RDCHI.
      *
           OPEN I-O WDSLAV.
       LDEL.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO LD20.
       LD10. 
           READ WDSLAV NEXT AT END GO TO LD20.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO LD10.
           DELETE WDSLAV.
           GO TO LD10.
       LD20.
           CLOSE WDSLAV.
           OPEN I-O WDSLA2.
           MOVE LOW-VALUE TO KEYL2.
           START WDSLA2 KEY NOT < KEYL2 INVALID GO TO LD40.
       LD30. 
           READ WDSLA2 NEXT AT END GO TO LD40.
           IF SF-LA2 = '9D' OR '9A' OR '35' GO TO LD30.
           DELETE WDSLA2.
           GO TO LD30.
       LD40. 
           CLOSE WDSLA2.
           MOVE ZERO TO DFPAT DFECO TCON.
           MOVE LOW-VALUE TO KEYBL.
           MOVE KAZ-COD TO KBL-AZI.
           START ANABIL KEY NOT < KEYBL INVALID GO TO ENDA.
       LPBIL.
           READ ANABIL NEXT AT END GO TO ENDA.
           IF SF-BIL = '9D' OR '9A' OR '35' GO TO LPBIL.
           IF KBL-AZI NOT = KAZ-COD GO TO ENDA.
           IF BIL-TRIGA = 'D' GO TO LPBIL.
           IF KBL-TCON NOT = TCON MOVE KBL-TCON TO TCON
                                  MOVE ZERO TO TOTGRU (TCON).
      *
           MOVE ZERO TO BIL-IMPOR.
           MOVE ZERO TO BIL-TEST TEST0.                                
      *
           MOVE LOW-VALUE TO KEYAL.
           MOVE KBL-AZI TO KAL-AZI.
           MOVE KBL-TCON TO KAL-TCON.
           MOVE KBL-NRIGA TO KAL-NRIGA.
           MOVE DESAT (KBL-TCON) TO DGRU.
           START ANALLE KEY NOT < KEYAL INVALID GO TO ENDALL.
       LPALL.
           READ ANALLE NEXT AT END GO TO ENDALL.
           IF SF-ALL = '9D' OR '9A' OR '35' GO TO LPALL.
           IF KAL-AZI NOT = KBL-AZI OR
              KAL-TCON NOT = KBL-TCON OR
              KAL-NRIGA NOT = KBL-NRIGA GO TO ENDALL.
           MOVE ZERO TO ALL-TOTIM.
           MOVE ZERO TO ALL-TEST TESTA.                                
           IF ALL-TALL = 'R' MOVE ALL-IMPOR TO ALL-TOTIM
                          IF ALL-IMPOR NOT = ZERO MOVE 1 TO TESTA.  
           IF ALL-TALL = 'S' PERFORM Z00-CONTI THRU Z99.
           IF ALL-TALL = 'C' OR 'F' PERFORM V00-CLIFO THRU V99.
           IF ALL-TALL = 'M' PERFORM U00-LIFO THRU U99.
           ADD  ALL-TOTIM TO BIL-IMPOR TOTGRU (TCON).
           REWRITE RF-BIL INVALID PERFORM INVK-BIL GO TO ERRIO.
           READ ANABIL INVALID PERFORM INVK-BIL GO TO ERRIO.
           IF KAL-TCON < 3 ADD ALL-TOTIM TO DFPAT.
           IF KAL-TCON = 6 ADD ALL-TOTIM TO DFECO.
           IF KAL-TCON = 5 SUBTRACT ALL-TOTIM FROM DFECO.
           IF KAL-TCON > 2 AND < 5 SUBTRACT ALL-TOTIM FROM DFPAT.
           MOVE TESTA TO ALL-TEST.                                     
           IF TESTA = 1 MOVE TESTA TO TEST0.                           
           MOVE ZERO TO TESTA.                                         
           REWRITE RF-ALL INVALID PERFORM INVK-ALL
                                  GO TO ERRIO.
           GO TO LPALL.
       ENDALL.
           MOVE TEST0 TO BIL-TEST.                                     
           MOVE ZERO TO TEST0.                                         
           REWRITE RF-BIL INVALID PERFORM INVK-BIL
                   GO TO ERRIO.
      *
           COPY 'grirpt-r' REPLACING 1 BY 2
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           GO TO LPBIL.
       ENDA.
           COMPUTE SALDO = DFPAT + DFECO.
           IF SALDO = ZERO GO TO STAMP.
           MOVE SPACE TO F-MES1.
           MOVE SALDO TO WSALDO
           STRING 'Differenza : ' WSALDO 
                  DELIMITED SIZE INTO F-MES1.
           MOVE 'Continuare ?' TO F-MES2.
           MOVE 'Q'            TO MB-TIPO.
           MOVE 2              TO MB-DEFAULT.
           MOVE 2              TO F-NMES.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP = 'N' GO TO NO-STAMPA.
      *
       STAMP.
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 59      TO NRGL.
           MOVE C-TTS0  TO RTTS.
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'L I B R O    I N V E N T A R I'
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
      *    MOVE IF-FL TO RP-FL.
           MOVE 1 TO RP-FL.
      ************
      *
      *    MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           MOVE ZERO TO XCRR CICLO.
           IF IF-TPSTA = 1 MOVE 1 TO CICLO.
       STAM.
           MOVE ZERO TO TCON.
           MOVE LOW-VALUE TO KEYBL.
           MOVE KAZ-COD TO KBL-AZI.
       S000.
           START ANABIL KEY NOT < KEYBL INVALID GO TO S050.
       S010.
           READ ANABIL NEXT AT END GO TO S050.
           IF SF-BIL = '9D' OR '9A' OR '35' GO TO S010.
           IF KBL-AZI NOT = KAZ-COD GO TO S050.
           IF ( KBL-TCON = 2 OR 4 ) AND TOTGRU ( KBL-TCON ) = ZERO
                                        ADD 1 TO KBL-TCON
                                        MOVE ZERO TO KBL-NRIGA
                                        GO TO S000.
           IF CICLO < 1 AND KBL-TCON > 4 GO TO S050.
           IF TCON > ZERO GO TO S011.
      *
           COPY 'grirpt-r'.
      *
           MOVE KBL-TCON TO TCON.
           IF CICLO = ZERO
      *               carattere
                      MOVE TINT1 TO P999
                      MOVE 2 TO RP-FLGR
                      MOVE 'RIG4' TO RP-BLK
                      PERFORM RST THRU EX-RST
                      MOVE TINT2 TO P999
                      MOVE 2 TO RP-FLGR
                      MOVE 'RIG4' TO RP-BLK
                      PERFORM RST THRU EX-RST
      *               visuale
                      MOVE SPACE TO RP-TIT2
                      STRING 'INVENTARIO AL ' RDTIN
                             DELIMITED SIZE INTO RP-TIT2.
           IF CICLO = 1
      *               carattere
                      MOVE TINT3 TO P999
                      MOVE 2 TO RP-FLGR
                      MOVE 'RIG4' TO RP-BLK
                      PERFORM RST THRU EX-RST
                      MOVE TINT4 TO P999
                      MOVE 2 TO RP-FLGR
                      MOVE 'RIG4' TO RP-BLK
                      PERFORM RST THRU EX-RST
      *               visuale
                      MOVE SPACE TO RP-TIT2
                      STRING 'BILANCIO DI CHIUSURA AL ' RDCHI
                            DELIMITED SIZE INTO RP-TIT2.
           IF RP-TRPT = 1
              MOVE 1 TO RP-JMP.
           PERFORM C00-STA-GRU THRU C99.
           MOVE ZERO TO TTGRUP.
       S011.
           IF KBL-TCON = TCON GO TO S012.
           PERFORM D00-STA-TOT THRU D99.
           IF CICLO = 1 AND KBL-TCON > 4
      * solo carattere
                      MOVE TINT5 TO P999
                      MOVE 2 TO RP-FLGR
                      MOVE 'RIG4' TO RP-BLK
                      PERFORM RST THRU EX-RST
                      MOVE TINT6 TO P999
                      MOVE 2 TO RP-FLGR
                      MOVE 'RIG4' TO RP-BLK
                      PERFORM RST THRU EX-RST
      * solo visuale
                      MOVE 'PROFITTI E PERDITE' TO RGRUPP
                      MOVE 1 TO RP-FLGR
                      MOVE 'RIG1' TO RP-BLK
                      PERFORM RST THRU EX-RST
                      MOVE 2 TO CICLO.
           MOVE KBL-TCON TO TCON.
           PERFORM C00-STA-GRU THRU C99.
       S012.
           IF BIL-TRIGA = 'D' AND TOTGRU (TCON) = ZERO 
                                            GO TO S010.
           IF BIL-TRIGA = 'D' MOVE BIL-DESCR TO RVOCE
                              MOVE 'RIG2' TO RP-BLK
                              PERFORM RST THRU EX-RST
                              GO TO S010.
           IF BIL-IMPOR = ZERO AND BIL-TEST = ZERO GO TO S010.         
           MOVE BIL-DESCR TO RVOCE.
           IF CICLO = ZERO AND (TCON = 2 OR 4)
                      MOVE BIL-IMPOR TO RVIMPO2
                      ADD BIL-IMPOR TO TTGRUP
                      GO TO S010.
           IF CICLO = 1 OR ( CICLO = 2 AND IF-FLDE = ZERO )
                        IF TCON = 2 OR 4
                                MOVE BIL-IMPOR TO RVIMPO2
                                ADD BIL-IMPOR TO TTGRUP
                        ELSE       
                                MOVE BIL-IMPOR TO RVIMPO3
                                ADD BIL-IMPOR  TO TTGRUP.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           IF CICLO = 1 OR ( CICLO = 2 AND IF-FLDE = ZERO ) GO TO S010.
           MOVE KBL-AZI TO KAL-AZI.
           MOVE KBL-TCON TO KAL-TCON.
           MOVE KBL-NRIGA TO KAL-NRIGA.
           MOVE ZERO TO KAL-PRG COLONN.
           START ANALLE KEY NOT < KEYAL INVALID GO TO S030.
       S020.
           READ ANALLE NEXT AT END GO TO S030.
           IF SF-ALL = '9D' OR '9A' OR '35' GO TO S020.
           IF KAL-AZI   > KBL-AZI   OR
              KAL-TCON  > KBL-TCON  OR
              KAL-NRIGA > KBL-NRIGA GO TO S030.
           IF ALL-TALL NOT = 'R' GO TO S025.
           IF ALL-CATEG = 1 MOVE ALL-DESCR TO RDECFM
                            MOVE ALL-TOTIM TO RIMPO1
                            MOVE 'RIG3' TO RP-BLK
                            PERFORM RST THRU EX-RST
                            IF COLONN = ZERO MOVE ALL-CATEG TO COLONN
                                             MOVE ALL-TOTIM TO TOTCOL
                                             GO TO S020
                                        ELSE 
                                             ADD ALL-TOTIM TO TOTCOL
                                             GO TO S020.
           IF COLONN NOT = ZERO MOVE ALL '=' TO RSOTT1
                                MOVE TOTCOL TO RIMPO2
                                MOVE 'RIG3' TO RP-BLK
                                PERFORM RST THRU EX-RST
                                MOVE ZERO TO COLONN TOTCOL.
           MOVE ALL-DESCR TO RDESCR1.
           MOVE ALL-TOTIM TO RIMPO2.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           GO TO S020.
       S025.
           IF COLONN NOT = ZERO MOVE ALL '=' TO RSOTT1
                                MOVE TOTCOL TO RIMPO2
                                MOVE 'RIG3' TO RP-BLK
                                PERFORM RST THRU EX-RST
                                MOVE ZERO TO COLONN TOTCOL.
           IF ALL-TOTIM = ZERO AND ALL-TEST = ZERO GO TO S020.         
           MOVE ALL-DESCR TO RDESCR1.
           IF ALL-TALL = 'S'
              IF ALL-FLAG = 'N'
                 MOVE ALL-TOTIM TO RIMPO2
                 MOVE 'RIG3' TO RP-BLK
                 PERFORM RST THRU EX-RST
                 GO TO S020
                 ELSE MOVE '- DOCUMENTO -' TO RSDOC
                 MOVE 'RIG3' TO RP-BLK
                 PERFORM RST THRU EX-RST
                 GO TO S026.
           IF ALL-DESCR NOT = SPACE
              MOVE 'RIG3' TO RP-BLK
              PERFORM RST THRU EX-RST.
       S026.
           IF ALL-TALL = 'C' OR 'F' PERFORM E00-STA-CLF THRU E99.
           IF ALL-TALL = 'M' PERFORM F00-STA-MAG THRU F99.
           IF ALL-TALL = 'S' PERFORM G00-STA-CON THRU G99.
           MOVE ALL '=' TO RSOTT1.
           MOVE ALL-TOTIM TO RIMPO2.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           GO TO S020.
       S030.
           IF COLONN NOT = ZERO MOVE ALL '=' TO RSOTT1
                                MOVE TOTCOL TO RIMPO2
                                MOVE 'RIG3' TO RP-BLK
                                PERFORM RST THRU EX-RST
                                MOVE ZERO TO COLONN TOTCOL.
           IF TCON = 2 OR 4 GO TO S040.
           MOVE ALL '=' TO RSOTT2.
           MOVE BIL-IMPOR TO RIMPO3.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
       S040.
           ADD BIL-IMPOR TO TTGRUP.
           GO TO S010.
       S050.
           PERFORM D00-STA-TOT THRU D99.
           IF CICLO = ZERO PERFORM I00-STA-BAR THRU CHSTA
                      IF IF-TPSTA = 2 
                         MOVE 1 TO CICLO 
                         GO TO STAM
                      ELSE GO TO S090.
           IF CICLO = 1 MOVE 'MANCA PROF. E PERD.' TO MESS
                                               GO TO ERRIO.
           IF (NRIG + 7) > NRGL
              PERFORM I00-STA-BAR THRU CHSTA.
      *
           MOVE 'IL PRESENTE BILANCIO RISPONDE A VERITA'' ' TO RTOT.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE IF-DTELA TO DATSTA.
           MOVE DATSTA   TO RTOT.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           IF NRIG NOT < NRGL GO TO S090.
           MOVE 5 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RST THRU EX-RST.
           MOVE 5 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RST THRU EX-RST.
           MOVE 1 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           PERFORM I00-STA-BAR THRU CHSTA.
       S090.
       NO-STAMPA.
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
           MOVE SPACE TO ID-LA2.
           STRING 'w2' PID DELIMITED SPACE INTO ID-LA2.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       C00-STA-GRU.
           MOVE DESAT (TCON) TO RGRUPP.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE SOTTY (TCON) TO RGRUPP.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RST THRU EX-RST.
       C99.
           EXIT.
      *-----------------------------*
       D00-STA-TOT.
      **** rel 6.3
           IF TCON = ZERO GO TO D99.
      ************
           IF TCON = 2 OR 4 MOVE ALL '=' TO RSOTT2
           ELSE
           MOVE ALL '-' TO RVSOTT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE DESTO (TCON) TO RTOT.
           MOVE TTGRUP TO RVIMPO3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           IF TCON > 1 GO TO D20.
           MOVE TTGRUP TO SALDO.
           IF DFPAT NOT < ZERO GO TO D10.
           MOVE 'PERDITA D'' ESERCIZIO' TO RTOT.
           MULTIPLY -1 BY DFPAT GIVING RVIMPO3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           COMPUTE SALDO = SALDO - DFPAT.
           MOVE ALL '-' TO RVSOTT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE SALDO TO RVIMPO3.
           IF KBL-TCON = 2 AND TOTGRU (KBL-TCON) > ZERO
                          MOVE 'RIG2' TO RP-BLK
                          PERFORM RST THRU EX-RST
                          GO TO D90
                      ELSE MOVE 'T O T A L E' TO RTOT
                          MOVE 'RIG2' TO RP-BLK
                          PERFORM RST THRU EX-RST
                          MOVE ALL '=' TO RVSOTT3
                          MOVE '===========' TO RTOT
                          MOVE 2 TO RP-FLGR
                          MOVE 'RIG2' TO RP-BLK
                          PERFORM RST THRU EX-RST
                          MOVE ZERO TO SALDO GO TO D90.
       D10.
           IF KBL-TCON = 2 AND TOTGRU (KBL-TCON) > ZERO GO TO D90
                                    ELSE MOVE ALL '=' TO RVSOTT3
                                         MOVE SOTOY (TCON) TO RTOT
                                    MOVE 2 TO RP-FLGR
                                    MOVE 'RIG2' TO RP-BLK
                                    PERFORM RST THRU EX-RST
                                    GO TO D90.
       D20.
           IF TCON > 2 GO TO D30.
           COMPUTE SALDO = SALDO + TTGRUP.
           MOVE ALL '-' TO RVSOTT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE SALDO TO RVIMPO3.
           MOVE 'T O T A L E ' TO RTOT.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE ALL '=' TO RVSOTT3.
           MOVE '===========' TO RTOT.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE ZERO TO SALDO.
           GO TO D90.
       D30.
           IF TCON > 3 GO TO D60.
           MOVE TTGRUP TO SALDO.
           IF DFPAT < ZERO GO TO D40.
           MOVE 'UTILE D'' ESERCIZIO' TO RTOT.
           MOVE DFPAT TO RVIMPO3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           COMPUTE SALDO = SALDO + DFPAT.
           MOVE ALL '-' TO RVSOTT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE SALDO TO RVIMPO3.
           IF KBL-TCON = 4 AND TOTGRU (KBL-TCON) > ZERO
                          MOVE 'RIG2' TO RP-BLK
                          PERFORM RST THRU EX-RST
                          GO TO D90
                      ELSE MOVE 'T O T A L E' TO RTOT
                          MOVE 'RIG2' TO RP-BLK
                          PERFORM RST THRU EX-RST
                          MOVE ALL '=' TO RVSOTT3
                          MOVE '===========' TO RTOT
                          MOVE 2 TO RP-FLGR
                          MOVE 'RIG2' TO RP-BLK
                          PERFORM RST THRU EX-RST
                          MOVE ZERO TO SALDO GO TO D90.
       D40.
           IF KBL-TCON = 4 AND TOTGRU (KBL-TCON) > ZERO GO TO D90
                                    ELSE MOVE ALL '=' TO RVSOTT3
                                         MOVE SOTOY (TCON) TO RTOT
                                    MOVE 2 TO RP-FLGR
                                    MOVE 'RIG2' TO RP-BLK
                                    PERFORM RST THRU EX-RST
                                    GO TO D90.
       D60.
           IF TCON > 4 GO TO D70.
           COMPUTE SALDO = SALDO + TTGRUP.
           MOVE ALL '-' TO RVSOTT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE SALDO TO RVIMPO3.
           MOVE 'T O T A L E ' TO RTOT.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE ALL '=' TO RVSOTT3.
           MOVE '===========' TO RTOT.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE ZERO TO SALDO.
           GO TO D90.
       D70.
           IF TCON > 5 GO TO D80.
           MOVE TTGRUP TO SALDO.
           IF DFECO NOT > ZERO MOVE SOTOY (TCON) TO RTOT
                                                 GO TO D75.
           MOVE 'PERDITA D'' ESERCIZIO' TO RTOT.
           MOVE DFECO TO RVIMPO3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           COMPUTE SALDO = SALDO + DFECO.
           MOVE ALL '-' TO RVSOTT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE SALDO TO RVIMPO3.
           MOVE 'T O T A L E ' TO RTOT.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE  '===========' TO RTOT.
       D75.
           MOVE ALL '=' TO RVSOTT3. 
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           GO TO D90.
       D80.
           MOVE TTGRUP TO SALDO.
           IF DFECO > ZERO MOVE SOTOY (TCON) TO RTOT GO TO D85.
           MOVE 'UTILE D'' ESERCIZIO' TO RTOT.
           MULTIPLY -1 BY DFECO GIVING RVIMPO3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           COMPUTE SALDO = SALDO - DFECO.
           MOVE ALL '-' TO RVSOTT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE SALDO TO RVIMPO3.
           MOVE 'T O T A L E ' TO RTOT.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE '===========' TO RTOT.
       D85.
           MOVE ALL '=' TO RVSOTT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
       D90.
           MOVE ZERO TO TTGRUP.
       D99.
           EXIT.
      *-----------------------------*
       E00-STA-CLF.
           CLOSE ANACOL MOVMOL MOVMXX.
           OPEN INPUT ANACFX WDSLAV.
           IF ALL-TALL = 'C' MOVE MCLI TO KLV-TIP
                        ELSE MOVE MFOR TO KLV-TIP.
           MOVE ALL-CATEG TO KLV-CAT.
           MOVE ZERO TO KLV-COD.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO E90.
       E10.
           READ WDSLAV NEXT AT END GO TO E90.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO E10.
           IF ALL-TALL = 'C' AND KLV-TIP NOT = MCLI GO TO E90.
           IF ALL-TALL = 'F' AND KLV-TIP NOT = MFOR GO TO E90.
           IF KLV-CAT NOT = ALL-CATEG GO TO E90.
           MOVE KAL-AZI TO KCX-AZI.
           MOVE KLV-COD TO KCX-COD.
           READ ANACFX INTO REKCLF INVALID
                       MOVE ALL '*' TO CLF-RGSOC CLF-CITTA.
           IF SF-CFX = '9D' OR '9A' OR '35' MOVE RF-CFX TO REKCLF.
           MOVE CLF-RGSOC TO RDECFM.
           IF CLF-RGSOC2 NOT = SPACE
              MOVE 'RIG3' TO RP-BLK
              PERFORM RST THRU EX-RST
              MOVE CLF-RGSOC2 TO RDECFM.
           MOVE CLF-CITTA TO RCITTA.
           MOVE LAV-IMP TO RIMPO1.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           GO TO E10.
       E90.
           CLOSE ANACFX WDSLAV.
           OPEN INPUT ANACOL MOVMOL MOVMXX.
       E99.
           EXIT.
      *-----------------------------*
       F00-STA-MAG.
           CLOSE ANACOL MOVMOL MOVMXX.
           OPEN INPUT MAGART WDSLA2.
           MOVE ALL-CATEG TO KL2-CAT.
           MOVE SPACE TO KL2-ART.
           MOVE ZERO TO KL2-ANN.
           MOVE SPACE TO ART1.
           START WDSLA2 KEY NOT < KEYL2 INVALID GO TO F90.
       F10.
           READ WDSLA2 NEXT AT END GO TO F90.
           IF SF-LA2 = '9D' OR '9A' OR '35' GO TO F10.
           IF KL2-CAT NOT = ALL-CATEG GO TO F90.
           IF KL2-ART = ART1 GO TO F20.
           MOVE KL2-ART TO ART1.
           MOVE KAZ-COD TO KMA-AZI.
           MOVE KL2-ART TO KMA-ART.
           READ MAGART INTO REKART INVALID
                            MOVE ALL '*' TO ART-DESCR ART-UNMIS
                            MOVE ZERO TO ART-FSC
                            MOVE ZERO TO ART-TQUAN.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           MOVE ART-DESCR TO RDECFM.
           MOVE ART-UNMIS TO RUNM.
       F20.
           MOVE LA2-QTA TO RQUA0.
           IF ART-TQUAN = 1 MOVE LA2-QTA TO RQUA1.
           IF ART-TQUAN = 2 MOVE LA2-QTA TO RQUA2.
           MOVE LA2-IMP TO RIMPO1.
           IF ALL-TIPS NOT = 'D' GO TO F30.
           MOVE KL2-ANN TO RANN.
           MOVE 'x' TO RSEGN.
           MOVE ART-AZI  TO OP-AZI.
           MOVE ZERO     TO OP-VALUT.
           MOVE LA2-PRZ  TO OP-PREZZO.
           MOVE LA2-FSC  TO OP-FSC.
           CALL 'routprz' USING PAROP OP-GUN.
           MOVE OP-PREZZO  TO RPREZ.
           IF OP-NDEC = 2 MOVE OP-PREZZO  TO RPRE2.
           IF OP-NDEC = 3 MOVE OP-PREZZO  TO RPRE3.
           IF OP-NDEC = 4 MOVE OP-PREZZO  TO RPRE4.
           IF OP-NDEC = 5 MOVE OP-PREZZO  TO RPRE5.
           IF OP-NDEC = 6 MOVE OP-PREZZO  TO RPRE6.
       F30.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           GO TO F10.
       F90.
           CLOSE MAGART WDSLA2.
           OPEN INPUT ANACOL MOVMOL MOVMXX.
       F99.
           EXIT.
      *----------------------------*
       G00-STA-CON.
           MOVE ZERO TO FLAPE.
       G05.
           OPEN INPUT TABELL.
           OPEN INPUT ANACFX.
           CLOSE MOVMOL.
           MOVE LOW-VALUE TO KEYMX KEYML.
           MOVE KAL-AZI TO KMX-AZI KML-AZI.
           MOVE ALL-CONTO TO KMX-CON KML-CON.
           MOVE PKDT1 TO KMX-DAT.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO G20.
       G10.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO G20.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO G10.
           IF KMX-AZI NOT = KAL-AZI OR
              KMX-CON NOT = ALL-CONTO GO TO G20.
           PERFORM H00-STA-MOV THRU H99.
           GO TO G10.
       G20.
           CLOSE MOVMXX.
           OPEN INPUT MOVMOL.
           START MOVMOL KEY NOT < KEYML INVALID GO TO G90.
       G30.
           READ MOVMOL NEXT INTO REKMOV AT END GO TO G90.
           IF SF-MOL = '9D' OR '9A' OR '35' GO TO G30.
           IF KML-AZI NOT = KAL-AZI OR
              KML-CON NOT = ALL-CONTO GO TO G90.
           PERFORM H00-STA-MOV THRU H99.
           GO TO G30.
       G90.
           CLOSE TABELL.
           CLOSE ANACFX.
           OPEN INPUT MOVMXX.
           IF FLAPE = ZERO MOVE 1 TO FLAPE GO TO G05.
       G99.
           EXIT.
      *--------------------------*
       H00-STA-MOV.
           IF MOV-CAUS = CDSOC OR
              MOV-CAUS = CASOC GO TO H99.
           IF FLAPE = 1 AND ( MOV-CAUS = CDSOA OR CASOA )
                                               GO TO H99.
           IF FLAPE = ZERO AND NOT ( MOV-CAUS = CDSOA OR CASOA )
                                                      GO TO H99.
           MOVE ZERO TO K.
           MOVE 2 TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ALL '*' TO TAB-DESCR. 
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF TAB-DESCR = SPACE GO TO EX0.
           MOVE TAB-DESCR TO CONCOUT.
           IF T02-TIPRG NOT > 1 GO TO EX1.
       EX0.
           IF MOV-PART = ZERO OR
              MOV-PART = MOV-CON OR
              MOV-PART = 9999999 GO TO EX1.
           MOVE KAL-AZI TO KCX-AZI.
           MOVE MOV-PART TO KCX-COD.
           READ ANACFX INTO REKCLF INVALID MOVE '*****' TO CLF-RGSOC.
           IF SF-CFX = '9D' OR '9A' OR '35' MOVE RF-CFX TO REKCLF.
           MOVE CLF-RGSOC TO CONCAIN.
           PERFORM CONCATENA.
           MOVE CLF-RGSOC2 TO CONCAIN.
           PERFORM CONCATENA.
       EX1.
           IF MOV-FLAG NOT = ZERO
              MOVE MOV-DSAGG TO CONCAIN
              PERFORM CONCATENA.
           PERFORM ALLINEA.
           MOVE WDSK31 TO ERG.
           IF WDSK32 = SPACE GO TO EX4.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE WDSK32 TO ERG.
           IF WDSK33 = SPACE GO TO EX4.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE WDSK33 TO ERG.
       EX4.
           IF MOV-DTDOC > ZERO
              MOVE MOV-DTDOC TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GMMMA TO RDATA.           
           IF MOV-NPRGI > ZERO
              MOVE MOV-NPRGI TO RNDOC
              ELSE
              IF MOV-NDOC > ZERO
                 MOVE MOV-NDOC TO RNDOC.
           IF KAL-TCON < 3 AND MOV-D-A = 'A'
                           MULTIPLY -1 BY MOV-IMPO.
           IF KAL-TCON > 2 AND MOV-D-A = 'D'
                           MULTIPLY -1 BY MOV-IMPO.
           MOVE MOV-IMPO TO RIMPO1.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
       H99.
           EXIT.
      *-------------------------*
       I00-STA-BAR.
      * solo stampa a carattere
           IF RP-TRPT = 1     GO TO CHSTA.
           IF NRIG NOT < NRGF GO TO CHSTA.
           MOVE ALL '=' TO P999.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           COMPUTE J = NRGL - NRIG.
           COMPUTE J = J + (132 - J) / 2.
           MOVE J TO K.
           ADD 1 TO J.
       LCHS.    
           IF NRIG NOT < (NRGL - 2) GO TO CHSTA. 
           ADD 1 TO NRIG.
           IF NRIG = (NRGL - 2)
              MOVE ALL '=' TO P999 
              MOVE 'RIG4' TO RP-BLK
           ELSE SUBTRACT 1 FROM J K
              MOVE '/' TO RX(J) RX(K)
              MOVE 'RIG5' TO RP-BLK.

           SUBTRACT 1 FROM NRIG.   
           PERFORM RPT-WR.
      *
           GO TO LCHS.
       CHSTA.
           PERFORM STA-PIE.
           EXIT.
      *-------------------------*
       U00-LIFO.
           MOVE SPACE TO KMA-ART.
           MOVE ZERO TO TOTQT TOTVL.
           MOVE ZERO TO ALL-TOTIM.
           CLOSE ANACOL MOVMOL MOVMXX.
           OPEN I-O WDSLA2.
           OPEN INPUT MAGLIF MAGART.
           MOVE LOW-VALUE TO KEYLF.
           MOVE KAL-AZI TO KLF-AZI.
           MOVE SPACE TO ART1.
           START MAGLIF KEY NOT < KEYLF INVALID GO TO U90.
       U10.
           READ MAGLIF NEXT AT END GO TO U90.
           IF SF-LIF = '9D' OR '9A' OR '35' GO TO U10.
           IF KLF-AZI NOT = KAZ-COD GO TO U90.
           IF KLF-ART = ART1 AND ALL-TIPS NOT = 'D'
                                         GO TO U30.
           MOVE KLF-AZI TO KMA-AZI.
           MOVE KLF-ART TO KMA-ART.
           READ MAGART INTO REKART INVALID GO TO U10.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           IF ALL-CATEG = ZERO GO TO U15.
           IF ALL-CATEG = 1 AND ART-TPART < 2 GO TO U15.
           IF ART-TPART NOT = ALL-CATEG GO TO U10.
       U15.
           IF ALL-TIPS = 'D' GO TO U20.
           IF ART1 = SPACE GO TO U20.
           MOVE TOTQT TO LA2-QTA.
           MOVE TOTVL TO LA2-IMP.
           WRITE RF-LA2 INVALID GO TO U20.
           ADD  TOTVL TO ALL-TOTIM.
       U20.
           MOVE ZERO TO TOTQT TOTVL.
           MOVE ALL-CATEG TO KL2-CAT.
           MOVE KLF-ART TO ART1 KL2-ART.
           MOVE ZERO TO KL2-ANN.
           IF ALL-TIPS = 'D' MOVE KLF-ANN TO KL2-ANN.
       U30.
           COMPUTE RD-NUM = LIF-VAL * LIF-QTA.
           CALL 'vrround' USING NNN-S PARRD DEC-2.
           MOVE RD-NUM TO TOT.
           MOVE LIF-QTA TO QTAL.
           MOVE LIF-VAL TO LA2-PRZ.
           MOVE LIF-FSC TO LA2-FSC.
           IF ALL-TIPS NOT = 'D' GO TO U40.
           MOVE QTAL  TO LA2-QTA.
           MOVE TOT   TO LA2-IMP.
           WRITE RF-LA2 INVALID MOVE 'WR LA2' TO MESS
                                          GO TO ERRIO.
           ADD  TOT TO ALL-TOTIM.
           GO TO U10.
       U40.
           COMPUTE TOTQT = TOTQT + QTAL.
           COMPUTE TOTVL = TOTVL + TOT.
           GO TO U10.
       U90.
           IF ALL-TIPS = 'D' GO TO U95.
           IF TOTQT = ZERO GO TO U95.
           MOVE TOTQT TO LA2-QTA.
           MOVE TOTVL TO LA2-IMP.
           WRITE RF-LA2 INVALID GO TO U95.
           ADD  TOTVL TO ALL-TOTIM.
       U95.
           CLOSE WDSLA2 MAGLIF MAGART.
           OPEN INPUT ANACOL MOVMOL MOVMXX.
       U99.
           EXIT. 
      *-------------------------*
       V00-CLIFO.
           MOVE ZERO TO CLF-COD.
           MOVE ZERO TO ALL-TOTIM.
           CLOSE ANACOL MOVMOL MOVMXX.
           OPEN I-O WDSLAV.
           OPEN INPUT ANACFX MOVSOL MOVSXX.
           MOVE KAZ-COD TO CLF-AZI.
           IF ALL-TALL = 'C' MOVE MCLI TO CLF-MS
                        ELSE MOVE MFOR TO CLF-MS.
           MOVE ZERO TO CLF-CD.
           MOVE CLF-KEYID TO KEYCX.
           START ANACFX KEY NOT < KEYCX INVALID GO TO V90.
       V10.
           READ ANACFX NEXT INTO REKCLF AT END GO TO V90.
           IF SF-CFX = '9D' OR '9A' OR '35' GO TO V10.
           IF KCX-AZI > KAL-AZI GO TO V90.
           IF ALL-TALL = 'C' AND
              CLF-MS > MCLI GO TO V90.
           IF ALL-TALL = 'F' AND
              CLF-MS > MFOR GO TO V90.
           IF ALL-CATEG = ZERO GO TO V15.
           IF ALL-CATEG = 1 AND CLF-CATCON < 2 GO TO V15.
           IF CLF-CATCON NOT = ALL-CATEG GO TO V10.
       V15.
           COMPUTE SALDO = CLF-SESP + CLF-SE-D - CLF-SE-A.
           MOVE LOW-VALUE TO KEYSL KEYSX.
           MOVE KAZ-COD TO KSL-AZI KSX-AZI.
           MOVE KCX-COD TO KSL-CON KSX-CON.
           MOVE PKDT1  TO KSL-DAT KSX-DAT.
           START MOVSXX KEY NOT < KEYSX INVALID GO TO V50.
       V20.
           READ MOVSXX NEXT INTO REKMOV AT END GO TO V50.
           IF SF-MSX = '9D' OR '9A' OR '35' GO TO V20.
           IF KSX-AZI > KAZ-COD OR
              KSX-CON > KCX-COD GO TO V50.
           IF NOT ( MOV-CAUS = CDCLC OR
                    MOV-CAUS = CACLC OR
                    MOV-CAUS = CDFOC OR
                    MOV-CAUS = CAFOC ) GO TO V20.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO SALDO
           ELSE IF MOV-D-A = 'D' SUBTRACT MOV-IMPO FROM SALDO.
           GO TO V20.
       V50.
           START MOVSOL KEY NOT < KEYSL INVALID GO TO V80.
       V60.
           READ MOVSOL NEXT INTO REKMOV AT END GO TO V80.
           IF SF-MSL = '9D' OR '9A' OR '35' GO TO V60.
           IF KSL-AZI > KAZ-COD OR
              KSL-CON > KCX-COD GO TO V80.
           IF NOT ( MOV-CAUS = CDCLC OR
                    MOV-CAUS = CACLC OR
                    MOV-CAUS = CDFOC OR
                    MOV-CAUS = CAFOC ) GO TO V60.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO SALDO
           ELSE IF MOV-D-A = 'D' SUBTRACT MOV-IMPO FROM SALDO.
           GO TO V60.
       V80.
           MOVE CLF-MS TO KLV-TIP.
           MOVE ALL-CATEG TO KLV-CAT.
           MOVE KCX-COD TO KLV-COD.
           IF CLF-MS = MFOR MULTIPLY -1 BY SALDO.
           MOVE SALDO TO LAV-IMP.
           IF LAV-IMP = ZERO GO TO V10.
           WRITE RF-LAV INVALID GO TO V10.
           ADD SALDO TO ALL-TOTIM.
           GO TO V10.
       V90.
           CLOSE ANACFX MOVSOL MOVSXX WDSLAV.
           OPEN INPUT ANACOL MOVMOL MOVMXX.
       V99.
           EXIT.
      *-------------------------*
       Z00-CONTI.
           IF ALL-CONTO = COUTI OR COPER GO TO Z99.
           MOVE KAZ-COD TO KCL-AZI.
           MOVE ALL-CONTO TO KCL-COD.
           READ ANACOL INTO REKCON INVALID
                       PERFORM INVK-COL GO TO ERRIO.
           IF SF-COL = '9D' OR '9A' OR '35' MOVE RF-COL TO REKCON.
           IF ALL-FLAG = 'S' GO TO Z10.
           COMPUTE ALL-TOTIM = CON-SESP + CON-SE-D - CON-SE-A.
       Z10.
           MOVE LOW-VALUE TO KEYML.
           MOVE KCL-AZI   TO KML-AZI.
           MOVE KCL-COD   TO KML-CON.
           MOVE PKDT1    TO KML-DAT.
           START MOVMOL KEY NOT < KEYML INVALID GO TO Z30.
       Z20.
           READ MOVMOL NEXT INTO REKMOV AT END GO TO Z30.
           IF SF-MOL = '9D' OR '9A' OR '35' GO TO Z20.
           IF KML-AZI > KCL-AZI GO TO Z30.
           IF KML-CON > KCL-COD GO TO Z30.
           IF ALL-FLAG = 'S'
              MOVE 1 TO TESTA                                          
              IF ( MOV-CAUS = T20-CDSOC OR 
                   MOV-CAUS = T20-CASOC ) GO TO Z20
              ELSE GO TO Z25.
           IF NOT ( MOV-CAUS = T20-CDSOC OR 
                    MOV-CAUS = T20-CASOC ) GO TO Z20.
       Z25.
           IF ALL-FLAG = 'N'
              IF MOV-D-A = 'A' ADD MOV-IMPO TO ALL-TOTIM 
                   ELSE SUBTRACT MOV-IMPO FROM ALL-TOTIM.
           IF ALL-FLAG = 'S'
              IF MOV-D-A = 'D' ADD MOV-IMPO TO ALL-TOTIM 
                   ELSE SUBTRACT MOV-IMPO FROM ALL-TOTIM.
           GO TO Z20.
       Z30.
           MOVE LOW-VALUE TO KEYMX.
           MOVE KCL-AZI   TO KMX-AZI.
           MOVE KCL-COD   TO KMX-CON.
           MOVE PKDT1    TO KMX-DAT.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO Z90.
       Z40.
           READ  MOVMXX NEXT INTO REKMOV AT END GO TO Z90.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO Z40.
           IF KMX-AZI > KCL-AZI GO TO Z90.
           IF KMX-CON > KCL-COD GO TO Z90.
           IF ALL-FLAG = 'S'
              MOVE 1 TO TESTA                                          
              IF ( MOV-CAUS = T20-CDSOC OR 
                   MOV-CAUS = T20-CASOC ) GO TO Z40
              ELSE GO TO Z45.
           IF NOT ( MOV-CAUS = T20-CDSOC OR 
                    MOV-CAUS = T20-CASOC ) GO TO Z40.
       Z45.
           IF ALL-FLAG = 'N'
              IF MOV-D-A = 'A' ADD MOV-IMPO TO ALL-TOTIM 
                   ELSE SUBTRACT MOV-IMPO FROM ALL-TOTIM.
           IF ALL-FLAG = 'S'
              IF MOV-D-A = 'D' ADD MOV-IMPO TO ALL-TOTIM 
                   ELSE SUBTRACT MOV-IMPO FROM ALL-TOTIM.
           GO TO Z40.
       Z90.
           IF KAL-TCON < 3 AND ALL-TOTIM < ZERO
                           MOVE ZERO TO ALL-TOTIM
                           MOVE ZERO TO TESTA                          
                           GO TO Z99.
           IF KAL-TCON < 3 AND > 5 GO TO Z99.
           IF KAL-TCON > 2 AND < 5 AND ALL-TOTIM > ZERO
                                 MOVE ZERO TO ALL-TOTIM
                           MOVE ZERO TO TESTA                          
                                 GO TO Z99.
           IF KAL-TCON > 2 AND < 6 MULTIPLY -1 BY ALL-TOTIM.
       Z99.      
            EXIT.
      * ---------------- *
       CONCATENA.
           PERFORM VARYING KONCA FROM 162 BY -1
                   UNTIL CONCOUT(KONCA:1) NOT = SPACE OR KONCA = ZERO
                   CONTINUE.
           IF KONCA > ZERO ADD 1 TO KONCA.
           ADD 1 TO KONCA.
           IF KONCA NOT > 162 MOVE CONCAIN TO CONCOUT(KONCA:).
      * ---------------- *
       ALLINEA.
           MOVE 54 TO POSIZ.
           PERFORM SPEZZA THRU EX-SPEZZA.

           MOVE 108 TO POSIZ.
           PERFORM SPEZZA THRU EX-SPEZZA.
      * ---------------- *
       SPEZZA.
           IF CONCOUT(POSIZ + 1:) = SPACE GO TO EX-SPEZZA.
           IF CONCOUT(POSIZ + 1:1) NOT = SPACE GO TO SPEZZA-10.
           ADD 1 TO POSIZ.
           PERFORM VARYING KONCA FROM POSIZ BY 1
                   UNTIL CONCOUT(KONCA:1) NOT = SPACE
                   CONTINUE.
           SUBTRACT 1 FROM POSIZ.
           MOVE CONCOUT(1:POSIZ) TO COMCOUT.
           MOVE CONCOUT(KONCA:) TO COMCOUT(POSIZ + 1:).
           MOVE COMCOUT TO CONCOUT.
           GO TO EX-SPEZZA.
       SPEZZA-10.
           IF CONCOUT(POSIZ:1) = SPACE GO TO EX-SPEZZA.
           PERFORM VARYING KONCA FROM POSIZ BY -1
                   UNTIL CONCOUT(KONCA:1) = SPACE OR KONCA = ZERO
                   CONTINUE.
           IF KONCA = ZERO GO TO EX-SPEZZA.
           MOVE CONCOUT(1:KONCA) TO COMCOUT.
           MOVE CONCOUT(KONCA + 1:) TO COMCOUT(POSIZ + 1:).
           MOVE COMCOUT TO CONCOUT.
       EX-SPEZZA.
           EXIT.
      * ---------------- *
       RST.
           PERFORM RPT-WR.
           IF RP-TRPT = 2 AND (NRIG NOT < (NRGL - 2))
               PERFORM STA-PIE.
       EX-RST.
           EXIT.
      *-------------*
       STA-PIE.
           IF IF-NBOL = 1
              MOVE IF-PIEDE-1 TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG4' TO RP-BLK
              PERFORM RPT-WR
              MOVE IF-PIEDE-2 TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG4' TO RP-BLK
              PERFORM RPT-WR.
      *------------------
