       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORDG15.
      *
      *    Interfaccia ORDRIG per scheda
      *
      **** rel 1.2
      *    Ricompilato per variazione tracciato LISVEN e PARVE
      ************
      **** rel 2.0
      * Valori particolari di FUN:
      *       e=evasione record selezionati da zoom multiplo
      *       f=flegga offerta come non piu' valida
      *       T=per tipo rigo 0, importa nelle note aggiuntive del
      *         rigo ordine, le note interne caricate sull'articolo.
      *         Restituisce un warning nel caso che non si possa
      *         importare i dati dell'articolo perche' ci sono gia'
      *         delle note caricate sul rigo ordine.
      ************
      **** rel 5.2
      * Ricompilato per copy griartrk variata 
      * per campi sconti con decimali
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'griartsl'.
           COPY 'griardsl'.
           COPY 'griordsl'.
           COPY 'griobcsl'.
           COPY 'gririgsl'.
           COPY 'griconsl'.
      **** rel 5.2
      *    COPY 'grilissl'.
      ************
           COPY 'gritabsl'.
      **** rel 5.2
      *    COPY 'grilvesl'.
      ************
      **** rel 5.0
           COPY 'griopcsl'.
           COPY 'griarnsl'.
      **** rel 5.2
      *    COPY 'grilpssl'.
      ************
      ************
      **** rel 2.0
      **** rel 6.1
      *    COPY 'griporsl'.
      ************
           COPY 'grinrisl'.
           COPY 'grinatsl'.
      **** rel 5.2
      *    COPY 'grisccsl'.
      ************
           COPY 'grifctsl'.
           COPY 'grifcrsl'.
           COPY 'grinfcsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'griart'.
           COPY 'griard'.
           COPY 'griord'.
           COPY 'griobc'.
           COPY 'gririg'.
           COPY 'gricon'.
           COPY 'gritab'.
      **** rel 5.2
      *    COPY 'grilis'.
      *    COPY 'grilve'.
      ************
      **** rel 5.0
           COPY 'griopc'.
           COPY 'griarn'.
      **** rel 5.2
      *    COPY 'grilps'.
      ************
      ************
      **** rel 2.0
      **** rel 6.1
      *    COPY 'gripor'.
      ************
           COPY 'grinri'.
           COPY 'grinat'.
      **** rel 5.2
      *    COPY 'griscc'.
      ************
           COPY 'grifct'.
           COPY 'grifcr'.
           COPY 'grinfc'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 8 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
             05 KLV-NOFF   PIC 9(5).
             05 KLV-PRG    PIC 999.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'griartrk'.
           COPY 'griardrk'.
           COPY 'griordrk'.
           COPY 'gririgrk'.
           COPY 'griconrk'.
           COPY 'gritabrk'.
      **** rel 2.0
           COPY 'grifctrk'.
           COPY 'grifcrrk'.
      ************
      **** rel 5.0
           COPY 'grit25rk'.
      ************
      **** rel 5.2
      *    COPY 'rekt52'.
      ************
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parrd'.
           COPY 'parve'.
      **** rel 1.2
           COPY 'parlk'.
      ************
      **** rel 2.0
           COPY 'parml'.
      ************
      **** rel 5.0
           COPY 'parmb'.
           COPY 'parbc'.
           COPY 'parim'.
      ************
      **** rel 4.0
           COPY 'pardp'.
           COPY 'parer'.
      **** rel 5.2
      *    COPY 'parbl'.
      ************
      ************
      **** rel 5.2
           COPY 'parrpz'.
           COPY 'parpcfa'.
      ************
      **** rel 6.0a
           COPY 'parrpv'.
      ************
      **** rel 6.2
           COPY 'parorc'.
           COPY 'partdc'.
      ************
      **** rel 7.1
           COPY 'parppar'.
      ************
       01 ID-AZI PIC X(15) VALUE 'anaazi'.
       01 ID-CLF PIC X(15) VALUE 'anaclf'.
       01 ID-ART PIC X(15) VALUE 'magart'.
       01 ID-ARD PIC X(15) VALUE 'magard'.
       01 ID-ORD PIC X(15) VALUE 'ordcli'.
       01 ID-OBC PIC X(15) VALUE 'bolord'.
       01 ID-RIG PIC X(15) VALUE 'ordrig'.
       01 ID-CON PIC X(15) VALUE 'anacon'.
      **** rel 5.2
      *01 ID-LIS PIC X(15) VALUE 'listin'.
      *01 ID-LVE PIC X(15) VALUE 'lisven'.
      ************
       01 ID-TAB PIC X(15) VALUE 'tabell'.
      **** rel 5.0
       01 ID-OPC PIC X(15) VALUE 'ordprc'.
       01 ID-ARN PIC X(15) VALUE 'arcnot'.
      **** rel 5.2
      *01 ID-LPS PIC X(15) VALUE 'lprosc'.
      ************
      ************
      **** rel 2.0
      **** rel 6.1
      *01 ID-POR PIC X(15) VALUE 'prorig'.
      ************
       01 ID-NRI PIC X(15) VALUE 'notrig'.
       01 ID-NAT PIC X(15) VALUE 'notart'.
      **** rel 5.2
      *01 ID-SCC PIC X(15) VALUE 'scocat'.
      ************
       01 ID-FCT PIC X(15) VALUE 'offcli'.
       01 ID-FCR PIC X(15) VALUE 'offrig'.
       01 ID-NFC PIC X(15) VALUE 'notofc'.
       01 ID-LAV PIC X(45).
      *--------------------------------------------------------
      * costanti
      *    NRIGMAX: n. righe max note aggiuntive rigo cliente
      **** rel 6.2
      *    NRIGMAX: n. righe fisiche max in pari con occurs
      *    NCOLMAX: n. colonne fisiche max
       78  NRIGMAX VALUE 100.
       78  NCOLMAX VALUE 60.
      *78  NRIGMAX VALUE 20.
      ************
      *--------------------------------------------------------
      ************
       01  COMODI.
           05 SF-AZI  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-ART  PIC XX.
           05 SF-ARD  PIC XX.
           05 SF-ORD  PIC XX.
           05 SF-OBC  PIC XX.
           05 SF-RIG  PIC XX.
           05 SF-CON  PIC XX.
      **** rel 5.2
      *    05 SF-LIS  PIC XX.
      *    05 SF-LVE  PIC XX.
      ************
           05 SF-TAB  PIC XX.
      **** rel 5.0
           05 SF-OPC  PIC XX.
           05 SF-ARN  PIC XX.
      **** rel 5.2
      *    05 SF-LPS  PIC XX.
      ************
      ************
      **** rel 2.0
      **** rel 6.1
      *    05 SF-POR  PIC XX.
      ************
           05 SF-NRI  PIC XX.
           05 SF-NAT  PIC XX.
      **** rel 5.2
      *    05 SF-SCC  PIC XX.
      ************
           05 SF-FCT  PIC XX.
           05 SF-FCR  PIC XX.
           05 SF-NFC  PIC XX.
           05 SF-LAV  PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(30).
           05 IF-AZI   PIC 9(3).
           05 IF-NUM   PIC 9(5).
      **** rel 5.0
           05 IF-FLGOPC PIC 9.
           05 IF-INTRA  PIC 9.
      **** rel 5.2
      *    05 J         PIC 99.
      *    05 SCAPP     PIC S99V99.
      ************
      ************
           05 CODCLI.
              10 MAS   PIC 99.
              10 COD   PIC 9(5).
           05 IVGR     PIC 9(7).
           05 IVRB     PIC 9.
           05 IMPCL    PIC S9(10)V999 VALUE ZERO.
           05 DISPO    PIC S9(10)V999 VALUE ZERO.
           05 RESID    PIC S9(10)V999 VALUE ZERO.
           05 WART     PIC X(18).
           05 SW-ESBOL PIC 9.
      **** rel 1.2
      **** rel 5.2
      *    05 FLGLVE   PIC 9.
      *    05 SCBLVE   PIC S99V99.
      ************
      ************
      **** rel 5.0
           05 COMDATPK PIC 9(5) COMP-3.
      ************
      **** rel 2.0
      **** rel 5.2
      *    05 FLGLIS   PIC 9.
      *    05 SCBLIS   PIC S99V99.
      ************
           05 KML      PIC 9(5).
           05 KVALID   PIC 9(5).
           05 KN       PIC 9(5).
           05 MAXRIGD  PIC ZZ9.
           05 SAVOFF   PIC 9(5).
           05 DESCRIZIONE.
              10 FILLER PIC X(12) VALUE '* NS.OFF.N.'.
              10 DES2   PIC ZZZZ9 VALUE ZERO.
              10 FILLER PIC XXX VALUE ' -'.
              10 DES4   PIC X(8) VALUE SPACE.
           05 DESCRIZIONE2.
              10 FILLER PIC X(12) VALUE '* VS.RIFER. '.
              10 DES6   PIC X(10) VALUE SPACE.
      ************
      **** rel 4.0
           05 COMEURO PIC 9(3) VALUE ZERO.
      ************
      **** rel 4.1
           05 COMAR   PIC 9.
      ************
      **** rel 5.2
           05 FSC     PIC 9 VALUE ZERO.
           05 FLGNRIG PIC 9 VALUE ZERO.
      ************
      **** rel 6.2
           05 FLGI    PIC 9 VALUE ZERO.
           05 SWINS   PIC 9.
           05 I       PIC 99  VALUE ZERO.
           05 NOPC    PIC 999 VALUE ZERO.
           05 FLGCONF PIC 9 VALUE ZERO.
      *    NRIGMAXL: n. righe  logiche max rigo cliente
      *    NCOLMAXL: n. colonne max note aggiuntive rigo cliente
           05 NRIGMAXL PIC 9(3).
           05 NCOLMAXL PIC 9(3).
      ************
      **** rel 6.3
           05 CDTCSC  PIC 9(5) VALUE ZERO.
      ************
      **** rel 6.2
       01  COM-IN.
           05 COM-RIN PIC X(60) OCCURS 100.
      ************
      **** rel 7.1
           05 DTINT   PIC 9(5) VALUE ZERO.
      ************
       LINKAGE SECTION.
           COPY 'gririgrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-RIG-CTRL
                                RG-RIG-REC
                                RA-RIG-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclart'.
           COPY 'dclard'.
           COPY 'dclobc'.
           COPY 'dclord'.
           COPY 'dclrig'.
           COPY 'dclcon'.
           COPY 'dcltab'.
      **** rel 5.2
      *    COPY 'dcllis'.
      *    COPY 'dcllve'.
      ************
      **** rel 5.0
           COPY 'dclopc'.
           COPY 'dclarn'.
      **** rel 5.2
      *    COPY 'dcllps'.
      ************
      ************
      **** rel 2.0
      **** rel 6.1
      *    COPY 'dclpor'.
      ************
           COPY 'dclnri'.
           COPY 'dclnat'.
      **** rel 5.2
      *    COPY 'dclscc'.
      ************
           COPY 'dclfct'.
           COPY 'dclfcr'.
           COPY 'dclnfc'.
           COPY 'dcllav'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-RIG-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-RIG-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-RIG-FUN   TO FUN.
           MOVE RG-RIG-IDX   TO IDX.
           MOVE RG-RIG-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.
      **** rel 4.0
           IF RG-RIG-FUN = 'r' AND FUN-PREC = 'r' GO TO ESCI.
      ************

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-RIG-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
      **** rel 2.0
           IF FUN = 'T' GO TO F-LEG-NAT.
           IF FUN = 'e' GO TO F-MZOOM.
           IF FUN = 'f' GO TO F-FLEGGA-FCT.
      ************
      **** rel 5.0
           IF FUN = 'J' PERFORM F-LEG-TESTO THRU END-F-LEG-TESTO
                        GO TO FINE.
      ************
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vordg15: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
      **** rel 2.0
       F-MZOOM.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           IF ID-LAV NOT = SPACE PERFORM R-RDF00 THRU R-RDF99.
           GO TO CHIUDI.
      * - - - - - *
       F-FLEGGA-FCT.
      * flegga offerta come non piu' valida
      * deve essere valido il valore di SAVOFF
           IF SAVOFF = ZERO GO TO F-FLEGGA-FCT-90.
           MOVE RG-RIG-AZI TO KFCT-AZI.
           MOVE SAVOFF     TO KFCT-NUM.
           READ OFFCLI INTO REKFCT INVALID GO TO F-FLEGGA-FCT-90.
           IF SF-FCT = '9D' OR '9A' OR '35' MOVE RF-FCT TO REKFCT.
           MOVE ZERO TO FCT-FLGVDT.
           REWRITE RF-FCT FROM REKFCT INVALID PERFORM INVK-FCT
                                              GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-FCT.
      ************
       F-FLEGGA-FCT-90.
           GO TO CHIUDI.
      * - - - - - *
      ************
       F-INIINS.
           MOVE ZERO TO RG-RIG-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
      **** rel 6.2
           MOVE 1 TO SWINS.
      ************
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-RIG-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-RIG-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK ORDRIG.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-RIG INVALID
              PERFORM INVK-RIG
              GO TO ERRIO.
           IF ORD-VALUT = CLF-VAL PERFORM G00-AGGLVE THRU G99.
      **** rel 2.0
       F-SCRIVI-NRI.
           PERFORM DL-WR-NOTE THRU EX-DL-WR-NOTE.
      ************
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-RIG INVALID
              PERFORM INVK-RIG
              GO TO ERRIO.
           UNLOCK ORDRIG.
           IF ORD-VALUT = CLF-VAL PERFORM G00-AGGLVE THRU G99.
      **** rel 2.0
       F-AGGIOR-NRI.
           PERFORM DL-WR-NOTE THRU EX-DL-WR-NOTE.
      ************
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-RIG
              GO TO WARNING.
           IF RG-RIG-ST = 7 GO TO FINE.
           PERFORM F00-GES-OBC THRU F99.
      **** rel 5.0
           IF SW-ESBOL > ZERO AND RA-RIG-FLGOPC = 1
              MOVE 'Esistono bolle di uscita' TO F-MES1
              MOVE 'Vuoi annullare'           TO F-MES2
              MOVE 2 TO F-NMES
              MOVE 'Q' TO MB-TIPO
              MOVE '1' TO MB-DEFAULT
              CALL 'vrmbox' USING PARMB
              IF MB-RISP = 'S'
                 GO TO F-DELETE-10.
      ************
           IF SW-ESBOL > ZERO
                 MOVE 'Rigo non Annullabile'     TO F-MES1
                 MOVE 'Esistono bolle di uscita' TO F-MES2
                 MOVE 2 TO F-NMES
                 GO TO WARNING.
      **** rel 5.0
       F-DELETE-10.
      ************
           PERFORM DB-STORNA THRU EX-DB-STORNA.
      **** rel 6.1
      *    PERFORM DEL-PRORIG THRU EX-DEL-PRORIG.
      *    IF RA-RIG-FLGOPC = 1
      *       PERFORM DEL-OBC THRU EX-DEL-OBC.
           CLOSE BOLORD NOTRIG.
      **** rel 7.1
      *    CALL 'vrdlrig' USING KEYRI.
           CALL 'vrdlrig' USING KEYRI 'DSV'.
      ************
           OPEN I-O BOLORD NOTRIG.
      ************
           DELETE ORDRIG INVALID
              PERFORM INVK-RIG
              GO TO ERRIO.
           UNLOCK ORDRIG.
      **** rel 6.1
      *    PERFORM DL-NOTE THRU EX-DL-NOTE.
      *    IF RA-RIG-FLGOPC = 1
      *       CALL 'vrdlopc' USING KEYRI.
      ************
      **** rel 7.1
           MOVE ORD-DAT TO DTINT.
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-RIG-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
      **** rel 2.0
      * importazione note aggiuntive interne dell'articolo
       F-LEG-NAT.
      *    IF RG-RIG-TPRIG NOT = ZERO
           IF RG-RIG-ARTIC = SPACE
              GO TO END-F-LEG-NAT.
           IF RA-RIG-NOTE NOT = SPACE
              MOVE 'Per importare le note aggiuntive' TO F-MES1
              MOVE ' dell''articolo e'' necessario'   TO F-MES2
              MOVE 'cancellare il contenuto corrente' TO F-MES3
              MOVE 3 TO F-NMES
              GO TO WARNING.
           MOVE RG-RIG-AZI   TO KNAT-AZI.
           MOVE RG-RIG-ARTIC TO KNAT-ART.
           MOVE 1            TO KNAT-TIP.
           MOVE ZERO         TO KNAT-PRG.
           MOVE ZERO TO KN.
           START NOTART KEY > KEYNAT INVALID GO TO F-LEG-NAT-90.
       F-LEG-NAT-10.
           READ NOTART NEXT AT END GO TO F-LEG-NAT-90.
           IF KNAT-AZI > RG-RIG-AZI   GO TO F-LEG-NAT-90.
           IF KNAT-ART > RG-RIG-ARTIC GO TO F-LEG-NAT-90.
           IF KNAT-TIP > 1            GO TO F-LEG-NAT-90.
           ADD 1 TO KN.
      **** rel 6.2
      *    IF KN > NRIGMAX GO TO F-LEG-NAT-90.
           IF KN > NRIGMAXL GO TO F-LEG-NAT-90.
      ************
           MOVE NAT-DESCR TO RA-RIG-RIGNOT(KN).
           GO TO F-LEG-NAT-10.
       F-LEG-NAT-90.
           IF KN = ZERO GO TO END-F-LEG-NAT.
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 2       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-RIG-NOTE.
       END-F-LEG-NAT.
      **** rel 6.0a
           EXIT.
       END-F-LEG-NAT2.
      *************
           GO TO FINE.
      * - - - - - *
      ************
       F-EXIT.
           UNLOCK ORDRIG.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-RIG-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABELL ANACLF MAGART MAGARD ORDCLI BOLORD ORDRIG.
      **** rel 2.0
      **** rel 6.1
      *    CLOSE PRORIG NOTART NOTRIG OFFCLI OFFRIG NOTOFC.
           CLOSE NOTART NOTRIG OFFCLI OFFRIG NOTOFC.
      ************
      ************
      **** rel 5.0
           CLOSE ORDPRC ARCNOT.
      ************
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-RIG-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-RIG-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'griarter'.
           COPY 'griarder'.
           COPY 'griorder'.
           COPY 'griobcer'.
           COPY 'gririger'.
           COPY 'griconer'.
      **** rel 5.2
      *    COPY 'griliser'.
      *    COPY 'grilveer'.
      ************
           COPY 'gritaber'.
      **** rel 5.0
           COPY 'griopcer'.
      **** rel 5.2
      *    COPY 'grilpser'.
      ************
      ************
      **** rel 2.0
      **** rel 6.1
      *    COPY 'griporer'.
      ************
           COPY 'grinrier'.
           COPY 'grinater'.
      **** rel 5.2
      *    COPY 'grisccer'.
      ************
           COPY 'grifcter'.
           COPY 'grifcrer'.
           COPY 'grinfcer'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN INPUT ANAAZI.
           MOVE RG-RIG-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID
                                   PERFORM INVK-AZI
                                   CLOSE ANAAZI
                                   GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           CLOSE ANAAZI.
      *
           OPEN INPUT TABELL ANACLF.
      **** rel 2.0
           OPEN INPUT NOTART
                      OFFRIG
                      NOTOFC.
      **** rel 6.1
      *    OPEN I-O PRORIG NOTRIG OFFCLI.
           OPEN I-O NOTRIG OFFCLI.
      ************
      ************
           OPEN I-O MAGART MAGARD ORDCLI BOLORD ORDRIG.
      **** rel 5.0
           OPEN I-O ORDPRC.
           OPEN INPUT ARCNOT.
      ************
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                                   PERFORM INVK-TAB
                                   GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 2  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
              PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-IVGR TO IVGR.
           MOVE T14-IVRB TO IVRB.
      **** rel 5.2
           MOVE T14-NOTRIG TO FLGNRIG.
      ************
      **** rel 5.0
           MOVE 25        TO T25-TIP.
           MOVE KAZ-COD   TO T25-COD.
           MOVE ZERO      TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-INTRA TO RA-RIG-INTRA.
      ************
      *
           MOVE RG-RIG-AZI TO KOR-AZI.
           MOVE RG-RIG-NUM TO KOR-NUM.
           READ ORDCLI INTO REKORD INVALID
                            PERFORM INVK-ORD
                            GO TO ERRIO.
           IF SF-ORD = '9D' OR '9A' OR '35' MOVE RF-ORD TO REKORD.
           MOVE ORD-CDCLI TO COD.
      *
           MOVE RG-RIG-AZI TO KCF-AZI.
           MOVE CODCLI     TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID
                       PERFORM INVK-CLF
                       GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      **** rel 2.0
      *
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
      ************
      **** rel 6.2
      *  verifico se c'e' ordine a richiamo, se si carico sort 
           MOVE ZERO        TO PARORC.
           MOVE RG-RIG-AZI  TO PORC-AZI.
           MOVE RG-RIG-NUM  TO PORC-NUM.
           CALL 'vrrdord' USING PARORC.
      ************
      **** rel 4.0
           CALL 'rveur' USING COMEURO.
      ************
      **** rel 5.0
      *
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO COMDATPK.
      ************
      *
      **** rel 5.2
           CANCEL 'vrdprz'.
      ************
      *
           MOVE 1 TO SWINI.
      **** rel 6.2
           MOVE ZERO TO SWINS.
      ************
           MOVE ZERO TO RG-RIG-EOF.
      **** rel 6.2
           MOVE RG-RIG-AZI TO PTDC-AZI.
           MOVE 'ORD'      TO PTDC-COD.
           CALL 'vrctdc' USING PARTDC. 
           MOVE PTDC-NRIG TO NRIGMAXL.
           MOVE PTDC-NCOL TO NCOLMAXL.
      ************
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-RIG REKRIG.
           MOVE ZERO TO RIG-QUANT RIG-DTCSR RIG-DTCSC RIG-PREZZ
                        RIG-1SCON RIG-2SCON RIG-PROVV RIG-QSPED
                        RIG-IPROV RIG-CDSPE RIG-CONTR RIG-FPNET.
      **** rel 5.0
           MOVE ZERO TO RIG-NOMME.
      ************
           MOVE SPACE TO RIG-ARTIC RIG-DESAR RIG-UNMIS.
      *
           MOVE REKRIG TO RF-RIG.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-RIG-AZI TO IF-AZI.
           MOVE RG-RIG-NUM TO IF-NUM.
      **** rel 5.0
           MOVE RA-RIG-FLGOPC TO IF-FLGOPC.
           MOVE RA-RIG-INTRA  TO IF-INTRA.
      ************

      * azzeramento aree interfaccia
           MOVE ZERO TO RG-RIG-REC.
           MOVE ZERO TO RG-RIG-QUANT
                        RG-RIG-PREZZ
                        RG-RIG-1SCON
                        RG-RIG-2SCON
                        RG-RIG-QSPED
                        RG-RIG-FPNET
      **** rel 5.0
                        RG-RIG-NOMME
      ************
                        RG-RIG-DTLIS.
           MOVE SPACE TO RG-RIG-ARTIC
                         RG-RIG-UNMIS
                         RG-RIG-DESAR.

           MOVE ZERO TO RA-RIG-AGG.
           MOVE ZERO TO RA-RIG-QDISP.
           MOVE SPACE TO RA-RIG-RIVGR-D
                         RA-RIG-CDIVA-D
                         RA-RIG-CONTR-D.
      **** rel 4.0
           MOVE SPACE TO RA-RIG-FSC-D.
      ************
           MOVE SPACE TO WART.
      **** rel 2.0
      *
           PERFORM AZZ-NOTE.
      ************

      * ripristino dei campi chiave fissi
           MOVE IF-AZI TO RG-RIG-AZI.
           MOVE IF-NUM TO RG-RIG-NUM.
      **** rel 5.0
           MOVE IF-FLGOPC TO RA-RIG-FLGOPC.
           MOVE IF-INTRA  TO RA-RIG-INTRA.
      ************
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
           MOVE RG-RIG-AZI TO KRI-AZI.
           MOVE RG-RIG-NUM TO KRI-NUM.
           MOVE ZERO TO KRI-PRG RG-RIG-PRG.
           START ORDRIG KEY NOT < KEYRI INVALID GO TO NORIG.
       RDBLR.
           READ ORDRIG NEXT INTO REKRIG AT END GO TO NORIG.
           IF SF-RIG = '9D' OR '9A' OR '35' GO TO RDBLR.
           IF KRI-AZI > RG-RIG-AZI GO TO NORIG.
           IF KRI-NUM > RG-RIG-NUM GO TO NORIG.
           MOVE KRI-PRG TO RG-RIG-PRG.
           GO TO RDBLR.
       NORIG.
           ADD 5 TO RG-RIG-PRG.
      *
           MOVE 2 TO TIPOP1.
           MOVE ORD-DTCSR TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RIG-DTCSR.
           MOVE ORD-DTCSC TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RIG-DTCSC.
      *
           MOVE IVRB TO RA-RIG-IVRB.
      **** rel 6.2
           MOVE ORD-GGS TO RA-RIG-GGS.
           MOVE RG-RIG-DTCSC TO RA-RIG-DTGGS.
      **** rel 6.3
           MOVE 1 TO TIPOP1.
           MOVE RG-RIG-DTCSC TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO CDTCSC.
      ************
           IF ORD-GGS > ZERO
              PERFORM SOMMA-GG THRU EX-SOMMA-GG.
      ************
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-RIG-AZI TO KRI-AZI.
           MOVE RG-RIG-NUM TO KRI-NUM.
           MOVE RG-RIG-PRG TO KRI-PRG.
           MOVE KEYRI TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYRI.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ ORDRIG INTO REKRIG INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-RIG = '9D' OR '9A' OR '35' MOVE RF-RIG TO REKRIG.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ ORDRIG INTO REKRIG KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-RIG > ZERO MOVE 7 TO RG-RIG-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
      * posizionamento su chiave secondaria per successive
      * read next/previous
      *
       SET-KEYSEC.
       EX-SET-KEYSEC.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
           IF IDX > 1 PERFORM SET-KEYSEC THRU EX-SET-KEYSEC.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ ORDRIG PREVIOUS INTO REKRIG AT END MOVE 1 TO EOF
           ELSE
              READ ORDRIG NEXT INTO REKRIG AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-ORD = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *


      * trovato record valido: reset EOF
           MOVE ZERO TO RG-RIG-EOF.
           MOVE KEYRI TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-RIG-EOF.
           IF RG-RIG-EOF = 4 MOVE 2 TO RG-RIG-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-RIG = LOW-VALUE GO TO EX-TEST-EOL.
           IF IDX > 1 GO TO TEST-EOL-IDX2.
           IF KRI-AZI = RG-RIG-AZI AND
              KRI-NUM = RG-RIG-NUM GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       TEST-EOL-IDX2.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
      **** rel 2.0
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 1       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 5       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-RIG-NOTE.
      *
      ************
           MOVE RG-RIG-AZI   TO RIG-AZI.
           MOVE RG-RIG-NUM   TO RIG-NUM.
           MOVE RG-RIG-PRG   TO RIG-PRG.
           MOVE RG-RIG-TPRIG TO RIG-TPRIG.
           MOVE RG-RIG-DESAR TO RIG-DESAR.
      *
           IF RG-RIG-TPRIG = 1
              MOVE 1 TO RIG-SALDO
      **** rel 2.0
              MOVE RA-RIG-RIGNOT(1) TO RIG-DESAR
      ************
              GO TO CARICA-REC-90.
      *
           MOVE RG-RIG-CDIVA TO RIG-CDIVA.
      **** rel 4.0
      *    MOVE RG-RIG-PREZZ TO RIG-PREZZ.
      *    MOVE RG-RIG-TPRZ  TO RIG-TPRZ.
           MOVE RG-RIG-FSC   TO RIG-FSC.
      ************
      *
           IF RG-RIG-TPRIG = 3
              MOVE RG-RIG-CDSPE TO RIG-CDSPE
              MOVE RG-RIG-PROVV TO RIG-PROVV
      **** rel 4.0
              MOVE RG-RIG-PREZZ TO RIG-PREZZ
      ************
              MOVE 1 TO RIG-SALDO
              GO TO CARICA-REC-90.
      *
      **** rel 4.0
           MOVE RG-RIG-FSC   TO DP-FSC.
           MOVE RG-RIG-PREZZ TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI.
           MOVE DP-PREZZO    TO RIG-PREZZ.
      ************
      *
           IF RG-RIG-TPRIG = 2
      **** rel 5.0
              MOVE RG-RIG-NOMME TO RIG-NOMME
      ************
              MOVE RG-RIG-CONTR TO RIG-CONTR.
      *
           IF RG-RIG-TPRIG = 4 OR = 5
              MOVE RG-RIG-RIVGR TO RIG-RIVGR.
      *--- standard interfaccia: 0=no 1=si
           IF RG-RIG-TPRIG = 4
              IF RG-RIG-RIVAL = 0 MOVE 1    TO RIG-RIVAL
              ELSE                MOVE ZERO TO RIG-RIVAL.
      *
           MOVE RG-RIG-ARTIC  TO RIG-ARTIC.
           MOVE RG-RIG-LOTTO  TO RIG-LOTTO.
           MOVE RG-RIG-QUANT  TO RIG-QUANT.
           MOVE 1 TO TIPOP1.
           MOVE RG-RIG-DTCSR TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO RIG-DTCSR.
           MOVE 1 TO TIPOP1.
           MOVE RG-RIG-DTCSC TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO RIG-DTCSC.
           MOVE RG-RIG-UNMIS  TO RIG-UNMIS.
           MOVE RG-RIG-FPNET  TO RIG-FPNET.
           MOVE RG-RIG-1SCON  TO RIG-1SCON.
           MOVE RG-RIG-2SCON  TO RIG-2SCON.
           MOVE RG-RIG-PROVV  TO RIG-PROVV.
           MOVE RG-RIG-TQUAN  TO RIG-TQUAN.
           MOVE RG-RIG-QSPED  TO RIG-QSPED.
           MOVE RG-RIG-SALDO  TO RIG-SALDO.
      **** rel 2.0
      **** rel 5.0
           IF RA-RIG-FLGOPC NOT = 1
      ************
           IF RIG-QSPED >= RIG-QUANT
              MOVE 1 TO RIG-SALDO.
      ************
      *
           PERFORM SETTA-TQP-RIG THRU EX-SETTA-TQP-RIG.
       CARICA-REC-90.
           MOVE REKRIG TO RF-RIG.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE RIG-AZI   TO RG-RIG-AZI.
           MOVE RIG-NUM   TO RG-RIG-NUM.
           MOVE RIG-PRG   TO RG-RIG-PRG.
           MOVE RIG-TPRIG TO RG-RIG-TPRIG.
           MOVE RIG-DESAR TO RG-RIG-DESAR.
      *
           IF RIG-TPRIG = 1
              GO TO EX-CARICA-RG.
      *
           MOVE RIG-CDIVA TO RG-RIG-CDIVA.
      **** rel 4.0
      *    MOVE RIG-PREZZ TO RG-RIG-PREZZ.
           MOVE RIG-FSC   TO RG-RIG-FSC.
      ************
      *
           MOVE RIG-FPNET TO RG-RIG-FPNET.
      *
           IF RIG-TPRIG = 3
              MOVE RIG-CDSPE TO RG-RIG-CDSPE
              MOVE RIG-PROVV TO RG-RIG-PROVV
      **** rel 4.0
              MOVE RIG-PREZZ TO RG-RIG-PREZZ
      ************
              GO TO EX-CARICA-RG.
      *
      **** rel 4.0
           MOVE RIG-FSC   TO DP-FSC.
           MOVE RIG-PREZZ TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC.
           MOVE DP-PREZZO TO RG-RIG-PREZZ.
      ************
      *
           IF RIG-TPRIG = 2
      **** rel 5.0
              MOVE RIG-NOMME TO RG-RIG-NOMME
      ************
              MOVE RIG-CONTR TO RG-RIG-CONTR.
      *
           IF RIG-TPRIG = 4 OR = 5
              MOVE RIG-RIVGR TO RG-RIG-RIVGR.

      *--- standard interfaccia: 0=no 1=si
           IF RIG-TPRIG = 4
              IF RIG-RIVAL = ZERO MOVE 1    TO RG-RIG-RIVAL
              ELSE                MOVE ZERO TO RG-RIG-RIVAL.
      *
           MOVE RIG-ARTIC TO RG-RIG-ARTIC
                             WART.
           MOVE RIG-LOTTO TO RG-RIG-LOTTO.
           MOVE RIG-QUANT TO RG-RIG-QUANT.
           MOVE 2 TO TIPOP1.
           MOVE RIG-DTCSR TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RIG-DTCSR.
           MOVE 2 TO TIPOP1.
           MOVE RIG-DTCSC TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RIG-DTCSC.
      **** rel 6.3
           MOVE AAGGG TO CDTCSC.
      ************
           MOVE RIG-UNMIS TO RG-RIG-UNMIS.
           MOVE RIG-1SCON TO RG-RIG-1SCON.
           MOVE RIG-2SCON TO RG-RIG-2SCON.
      **** rel 2.0
           MOVE RIG-PROVV TO RG-RIG-PROVV.
      ************
           MOVE RIG-TQUAN TO RG-RIG-TQUAN.
      **** rel 4.0
      *    MOVE RIG-TPRZ  TO RG-RIG-TPRZ.
      ************
           MOVE RIG-QSPED TO RG-RIG-QSPED.
           MOVE RIG-SALDO TO RG-RIG-SALDO.
      *
           IF (RIG-TPRIG = 2)  OR
              ((RIG-TPRIG = 4 OR 5) AND RIG-ARTIC = SPACE)
      **** rel 4.0
      *         MOVE 2 TO RG-RIG-TQUAN
      *         MOVE 1 TO RG-RIG-TPRZ.
                MOVE 2 TO RG-RIG-TQUAN.
      ************
      **** rel 4.1a
           MOVE ZERO TO RG-RIG-LISRF.
      ************
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           MOVE IVRB TO RA-RIG-IVRB.
      *
           MOVE 1 TO RA-RIG-SDEC.
      **** rel 2.0
      *    IF RIG-TPRIG = 1 GO TO EX-CARICA-RA.
           IF RIG-TPRIG = 1 GO TO RVID-90.
      ************
           MOVE 3 TO KTB-TIP.
           MOVE RIG-CDIVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                                 MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-RIG-CDIVA-D.
      **** rel 2.0
      *    IF RIG-TPRIG = 3 GO TO EX-CARICA-RA.
           IF RIG-TPRIG = 3 GO TO RVID-90.
      ************
           IF ( RIG-TPRIG = 2 )  OR
              (( RIG-TPRIG = 4 OR 5) AND RIG-ARTIC = SPACE)
                                                    GO TO RVID-20.
           MOVE RIG-ARTIC TO KMA-ART.
           MOVE RIG-AZI   TO KMA-AZI.
           READ MAGART INTO REKART INVALID KEY
                                   MOVE ZERO TO DISPO
                                   GO TO RVID-20.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           MOVE ART-ESDIN TO DISPO.
      **** rel 5.1
           ADD ART-IMPFO  TO DISPO.
      ************
           MOVE ART-IMPCL TO IMPCL.
           SUBTRACT IMPCL FROM DISPO.
       RVID-20.
           MOVE DISPO TO RA-RIG-QDISP.
           IF NOT (RIG-TPRIG = 2) GO TO RVID-30.
           IF RIG-CONTR = ZERO    GO TO RVID-30.
           MOVE KAZ-COD   TO KPC-AZI.
           MOVE RIG-CONTR TO KPC-COD.
           OPEN INPUT ANACON.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DSABB.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           CLOSE ANACON.
           IF CON-MOVIM NOT = ZERO
              MOVE 'Conto non moviment.' TO CON-DSABB.
           IF CON-DSABB = SPACE MOVE CON-DESCR TO CON-DSABB.
           MOVE CON-DSABB TO RA-RIG-CONTR-D.
       RVID-30.
      **** rel 2.0
      *    IF NOT (RIG-TPRIG = 4 OR 5) GO TO EX-CARICA-RA.
           IF NOT (RIG-TPRIG = 4 OR 5) GO TO RVID-90.
      ************
           MOVE 3 TO KTB-TIP.
           MOVE RIG-RIVGR TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ALL '*' TO T03-DSIVA.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RA-RIG-RIVGR-D.
      **** rel 2.0
       RVID-90.
      **** rel 4.0
           MOVE ZERO TO RA-RIG-CBFSC.
           IF (RG-RIG-TPRIG = 2 OR 4 OR 5) AND RG-RIG-ARTIC = SPACE
              IF RG-RIG-FSC > ZERO MOVE 1 TO RA-RIG-CBFSC.
      **** rel 5.2
           IF RG-RIG-TPRIG = 3
              IF RG-RIG-FSC > ZERO MOVE 1 TO RA-RIG-CBFSC.
      ************

           PERFORM AGGIORNA-FSC-D.
      ************
      *
           PERFORM RD-NRI THRU EX-RD-NRI.
      ************
      **** rel 5.0
           PERFORM C00-CAL-SCAPP.
           MOVE IM-NETRG TO RA-RIG-NETRG.
      ************
      **** rel 6.3
           MOVE ZERO TO RA-RIG-PRGOPC.
      ************
      **** rel 6.2
           IF PORC-NOPC NOT = ZERO *> verifico ordine a richiamo
              PERFORM VER-ART-OPC THRU EX-VER-ART-OPC.

           MOVE ORD-GGS TO RA-RIG-GGS.
           MOVE RG-RIG-DTCSC TO RA-RIG-DTGGS.
      **** rel 6.3
           MOVE 1 TO TIPOP1.
           MOVE RG-RIG-DTCSC TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO CDTCSC.
      ************
           IF ORD-GGS > ZERO
              PERFORM SOMMA-GG THRU EX-SOMMA-GG.
      ************
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-RIG-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-PRG.
           MOVE 'RIG-PRG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PRG.
           IF RG-RIG-PRG = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PRG.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-RIG-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-TPRIG.
           MOVE 'RIG-TPRIG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPRIG.
           IF NOT (RG-RIG-TPRIG = ZERO OR 1 OR 2 OR 3 OR 4 OR 5 OR 6)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF RG-RIG-TPRIG = 2 AND KRI-AZI = ZERO
      **** rel 4.0
      *       MOVE 2 TO RG-RIG-TQUAN
      *       MOVE 1 TO RG-RIG-TPRZ.
              MOVE 2 TO RG-RIG-TQUAN.
      ************
       E-TPRIG.
      *
       V-ARTIC.
      * Nota: non modificabile in variazione
           MOVE 'RIG-ARTIC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ARTIC.
           IF NOT (RG-RIG-TPRIG = 0 OR 4 OR 5 OR 6) GO TO E-ARTIC.
           IF (RG-RIG-TPRIG = 4 OR 5) AND RG-RIG-ARTIC = SPACE
              IF KRI-AZI = ZERO
                 MOVE 2 TO RG-RIG-TQUAN
      **** rel 4.0
      *          MOVE 1 TO RG-RIG-TPRZ
      ************
                 GO TO E-ARTIC
              ELSE
                 GO TO E-ARTIC.
      **** rel 2.0
           IF RG-RIG-ARTIC = SPACE
              MOVE SPACE TO RG-RIG-DESAR
              PERFORM ERR-ZERO
              MOVE SPACE TO WART
              GO TO V-ERROR.
      ************
           CALL 'vrcartb' USING RG-RIG-AZI RG-RIG-ARTIC.
           IF WART = RG-RIG-ARTIC GO TO E-ARTIC.
      **** rel 6.3
           MOVE ZERO TO RA-RIG-PRGOPC.
      ************
      **** rel 6.3
      **** rel 6.2
      *    IF RA-RIG-FLGOPC = 1 *> verifico ordine a programma
      *       IF PORC-FLGR = 1 
      *          PERFORM VER-ART-PRO THRU EX-VER-ART-PRO.
      *    IF PORC-NOPC NOT = ZERO *> verifico ordine a richiamo
      *       PERFORM VER-ART-OPC THRU EX-VER-ART-OPC.
      ************
      ************
      **** rel 5.2
           MOVE 9 TO PCFA-FUN.
       LP-PCFA.
      ************
           MOVE RG-RIG-ARTIC TO WART.
           MOVE RG-RIG-AZI TO KMA-AZI KAD-AZI.
           MOVE RG-RIG-ARTIC TO KMA-ART KAD-ART.
           READ MAGART INTO REKART INVALID
      **** rel 5.2
                IF PCFA-FUN = 9
                   MOVE RG-RIG-AZI TO PCFA-AZI
                   MOVE 'C' TO PCFA-TIP
                   MOVE ORD-CDCLI TO PCFA-CLF
                   MOVE RG-RIG-ARTIC TO PCFA-ART
                   CALL 'vrrcfa' USING PARPCFA
                   IF PCFA-ST = ZERO AND
                      PCFA-ART NOT = SPACE
                         MOVE PCFA-ART TO RG-RIG-ARTIC
                         MOVE ZERO TO PCFA-FUN
                         GO TO LP-PCFA
                   END-IF
                END-IF
      ************
                MOVE SPACE TO RG-RIG-DESAR
                PERFORM ERR-CINE
                MOVE SPACE TO WART
                GO TO V-ERROR.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
      **** rel 6.3
           IF RA-RIG-FLGOPC = 1 *> verifico ordine a programma
              IF PORC-FLGR = 1 
                 PERFORM VER-ART-PRO THRU EX-VER-ART-PRO.
           IF PORC-NOPC NOT = ZERO *> verifico ordine a richiamo
              PERFORM VER-ART-OPC THRU EX-VER-ART-OPC.
      ************
      **** rel 6.0a
           IF FUN = 'V' AND FLGNRIG = 1
              MOVE SPACE TO RA-RIG-NOTE
              MOVE ZERO  TO RA-RIG-FLGNOTE
              PERFORM F-LEG-NAT THRU END-F-LEG-NAT
              IF RA-RIG-NOTE NOT = SPACE
      **** rel 6.2
      *          MOVE NRIGMAX TO KVALID
                 MOVE NRIGMAXL TO KVALID
      ************
                 PERFORM UNTIL RA-RIG-RIGNOT(KVALID) NOT = SPACE
                    SUBTRACT 1 FROM KVALID
                 END-PERFORM
                 IF KVALID > ZERO
                    MOVE 1 TO RA-RIG-FLGNOTE.
      *************
      **** rel 4.0
           MOVE ART-FSC   TO DP-FSC.
           MOVE ORD-VALUT TO DP-VALUT.
           CALL 'rdetfsc' USING DP-VALUT DP-FSC.
           MOVE DP-FSC    TO RG-RIG-FSC.
           PERFORM AGGIORNA-FSC-D.
      ************
           MOVE ART-CDIVA TO RG-RIG-CDIVA.
           MOVE 3 TO KTB-TIP.
           MOVE RG-RIG-CDIVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                                 MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-RIG-CDIVA-D.
           MOVE ORD-CDEP TO KAD-DEP.
           READ MAGARD INVALID
                MOVE SPACE TO RG-RIG-DESAR
                MOVE 'Articolo non caricato su deposito' TO MESS
                MOVE SPACE TO WART
                GO TO V-ERROR.
           MOVE ART-DESCR TO RG-RIG-DESAR.
           MOVE ART-UNMIS TO RG-RIG-UNMIS.
           MOVE ART-ESDIN TO DISPO.
      **** rel 5.1
           ADD ART-IMPFO  TO DISPO.
      ************
           MOVE ART-IMPCL TO IMPCL.
           SUBTRACT IMPCL FROM DISPO.
      **** rel 5.2
           MOVE DISPO TO RA-RIG-QDISP.
      ************
           MOVE ART-TQUAN TO RG-RIG-TQUAN.
      **** rel 4.0
      *    MOVE ART-TPRZ TO RG-RIG-TPRZ.
      *    IF ORD-VALUT > 1 MOVE 1 TO RG-RIG-TPRZ.
      ************
      **** rel 5.2
      **** rel 6.0a
           MOVE ZERO         TO RPZ-FLGA.
      ************
           MOVE ZERO         TO RPZ-FLVE.
           MOVE ZERO         TO RPZ-FSCC.
           MOVE ZERO         TO RPZ-FPRV.
           MOVE ORD-AZI      TO RPZ-AZI.
           MOVE ZERO         TO RPZ-TIPO.
           MOVE ORD-CDCLI    TO RPZ-CLI.
           MOVE ORD-VALUT    TO RPZ-VALUT.
           MOVE ORD-DAT      TO RPZ-DATA.
           MOVE ORD-PERSC    TO RPZ-SCBAS.
           MOVE ORD-PROVV    TO RPZ-TPROV.
           MOVE ORD-CDAGE    TO RPZ-CDAGE.
           MOVE ZERO         TO RPZ-TDOC.
           MOVE RG-RIG-ARTIC TO RPZ-ART.
           MOVE RG-RIG-TPRIG TO RPZ-TPRIG.
           MOVE RG-RIG-FSC   TO RPZ-FSC.
           MOVE RG-RIG-QUANT TO RPZ-QTA.
           MOVE RG-RIG-TQUAN TO RPZ-TQUAN.
           MOVE ORD-LISRF    TO RPZ-CLIS.
      *
           CLOSE MAGART.
           CALL 'vrdprz' USING PARRPZ.
           OPEN I-O MAGART.
      *
           IF ERRIO-ST NOT = ZERO GO TO ERRIO.
           MOVE RPZ-CLIS    TO RG-RIG-LISRF.
           MOVE RPZ-F-PZLOR TO RG-RIG-PREZZ.
           MOVE RPZ-SC1     TO RG-RIG-1SCON.
           MOVE RPZ-SC2     TO RG-RIG-2SCON.
           MOVE RPZ-FPNET   TO RG-RIG-FPNET.
           MOVE RPZ-GMA-DT  TO RG-RIG-DTLIS.
           MOVE RPZ-PROVV   TO RG-RIG-PROVV.
      *    MOVE RPZ-IPROV   TO RG-RIG-IPROV.
           IF RPZ-FLIS > ZERO AND RPZ-SLIS NOT = ORD-PERSC
              MOVE 'Sconto testata diverso da listino' TO MESS
              GO TO V-ERROR.

      **** rel 6.0a
      *    IF FUN = 'V' AND FLGNRIG = 1
      *       MOVE SPACE TO RA-RIG-NOTE
      *       MOVE ZERO  TO RA-RIG-FLGNOTE
      *       PERFORM F-LEG-NAT THRU END-F-LEG-NAT
      *       IF RA-RIG-NOTE NOT = SPACE
      *          MOVE NRIGMAX TO KVALID
      *          PERFORM UNTIL RA-RIG-RIGNOT(KVALID) NOT = SPACE
      *             SUBTRACT 1 FROM KVALID
      *          END-PERFORM
      *          IF KVALID > ZERO
      *             MOVE 1 TO RA-RIG-FLGNOTE.
      *************
      ************
       E-ARTIC.
      *
       V-DESAR.
           MOVE 'RIG-DESAR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DESAR.
           IF NOT (RG-RIG-TPRIG = 2 OR 4 OR 5) GO TO E-DESAR.
           IF (RG-RIG-TPRIG = 4 OR 5) AND
              RG-RIG-ARTIC NOT = SPACE GO TO E-DESAR.
           IF (RG-RIG-TPRIG = 4 OR 5) AND RG-RIG-ARTIC = SPACE
              IF KRI-AZI = ZERO
      **** rel 4.0
      *          MOVE 2 TO RG-RIG-TQUAN
      *          MOVE 1 TO RG-RIG-TPRZ.
                 MOVE 2 TO RG-RIG-TQUAN.
      ************
           IF RG-RIG-DESAR = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-DESAR.
      **** rel 4.0
      *
       V-FSC.
           MOVE 'RIG-FSC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FSC.
      **** rel 5.2
           IF RG-RIG-TPRIG = 3           
              MOVE ZERO  TO RG-RIG-FSC
              IF RA-RIG-CBFSC = 1 MOVE 1 TO RG-RIG-FSC
              END-IF
              GO TO E-FSC.
      ************
           IF NOT (RG-RIG-TPRIG = 2 OR 4 OR 5) GO TO E-FSC.
           IF (RG-RIG-TPRIG = 4 OR 5) AND
              RG-RIG-ARTIC NOT = SPACE GO TO E-FSC.

           MOVE ZERO  TO RG-RIG-FSC.
           IF RA-RIG-CBFSC = 1 MOVE 3 TO RG-RIG-FSC.
           PERFORM AGGIORNA-FSC-D.
       E-FSC.
      ************
      *
       V-UNMIS.
           MOVE 'RIG-UNMIS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-UNMIS.
           IF NOT (RG-RIG-TPRIG = 2 OR 4 OR 5) GO TO E-UNMIS.
           IF (RG-RIG-TPRIG = 4 OR 5) AND
              RG-RIG-ARTIC NOT = SPACE GO TO E-UNMIS.
           IF RG-RIG-UNMIS = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-UNMIS.
      *
       V-QUANT.
           MOVE 'RIG-QUANT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-QUANT.
           IF NOT (RG-RIG-TPRIG = 0 OR 2 OR 4 OR 5 OR 6) GO TO E-QUANT.
      **** rel 5.0
           IF RA-RIG-FLGOPC = 1 GO TO E-QUANT.
      ************
           MOVE RG-RIG-QUANT TO RD-NUM.
           CALL 'vrround' USING QTA-S PARRD RG-RIG-TQUAN.
           MOVE RD-NUM TO RG-RIG-QUANT.
           IF RD-ST > ZERO
              PERFORM ERR-NDEC
              GO TO V-ERROR.
           IF RG-RIG-QUANT = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
      **** rel 5.0
      **** rel 6.0a
           PERFORM AGG-PRV THRU EX-AGG-PRV.
      ************
           PERFORM C00-CAL-SCAPP.
           MOVE IM-NETRG TO RA-RIG-NETRG.
      ************
       E-QUANT.
      *
       V-LISRF.
           MOVE 'RIG-LISRF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-LISRF.
           IF NOT (RG-RIG-TPRIG = 0 OR 4 OR 5 OR 6) GO TO E-LISRF.
           IF (RG-RIG-TPRIG = 4 OR 5) AND
              RG-RIG-ARTIC = SPACE GO TO E-LISRF.
           IF FUN NOT = 'V' GO TO E-LISRF.
           IF RG-RIG-LISRF = ZERO GO TO E-LISRF.
      **** rel 5.2
      **** rel 6.0a
           MOVE 1            TO RPZ-FLGA.
      ************
           MOVE 1            TO RPZ-FLVE.
      **** rel 6.2
      *    MOVE 1            TO RPZ-FSCC.
      *    MOVE 1            TO RPZ-FPRV.
           MOVE ZERO         TO RPZ-FSCC.
           MOVE ZERO         TO RPZ-FPRV.
      ************
           MOVE ORD-AZI      TO RPZ-AZI.
           MOVE ZERO         TO RPZ-TIPO.
           MOVE ORD-CDCLI    TO RPZ-CLI.
           MOVE ORD-VALUT    TO RPZ-VALUT.
           MOVE ORD-DAT      TO RPZ-DATA.
           MOVE ORD-PERSC    TO RPZ-SCBAS.
           MOVE ORD-PROVV    TO RPZ-TPROV.
           MOVE ORD-CDAGE    TO RPZ-CDAGE.
           MOVE ZERO         TO RPZ-TDOC.
           MOVE RG-RIG-ARTIC TO RPZ-ART.
           MOVE RG-RIG-TPRIG TO RPZ-TPRIG.
           MOVE RG-RIG-FSC   TO RPZ-FSC.
           MOVE RG-RIG-QUANT TO RPZ-QTA.
           MOVE RG-RIG-TQUAN TO RPZ-TQUAN.
           MOVE RG-RIG-LISRF TO RPZ-CLIS.
      *
           CLOSE MAGART.
           CALL 'vrdprz' USING PARRPZ.
           OPEN I-O MAGART.
      *
           IF ERRIO-ST NOT = ZERO GO TO ERRIO.
      *
           IF RG-RIG-LISRF > 3
              IF RPZ-CLIS NOT > 3
                 MOVE 'Listino inesistente' TO MESS
                 GO TO V-ERROR
              END-IF
              IF RPZ-VLIS NOT = ORD-VALUT
                 MOVE "Valuta diversa da quella dell'ordine" TO MESS
                 GO TO V-ERROR.
      *
           MOVE RPZ-F-PZLOR TO RG-RIG-PREZZ.
           MOVE RPZ-CLIS  TO RG-RIG-LISRF.
           MOVE RPZ-SC1   TO RG-RIG-1SCON.
           MOVE RPZ-SC2   TO RG-RIG-2SCON.
      **** rel 6.1
      *    MOVE RPZ-FPNET TO RG-RIG-FPNET.
           IF NOT (RPZ-CLIS = 1 OR 2 OR 3)
              MOVE RPZ-FPNET TO RG-RIG-FPNET
           ELSE 
              MOVE ZERO      TO RG-RIG-FPNET.
      ************
           MOVE RPZ-SDEC  TO RA-RIG-SDEC.
           IF RPZ-FLIS > ZERO AND RPZ-SLIS NOT = ORD-PERSC
              MOVE 'Sconto testata diverso da listino' TO MESS
              GO TO V-WARNING.
      ************
       E-LISRF.
      *
       V-CDSPE.
           MOVE 'RIG-CDSPE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDSPE.
           IF RG-RIG-TPRIG NOT = 3 GO TO E-CDSPE.
           IF RG-RIG-CDSPE = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 11 TO KTB-TIP.
           MOVE RG-RIG-CDSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO RG-RIG-DESAR
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 4.0
      *    IF ORD-VALUT > 1 MOVE 1 TO RG-RIG-TPRZ.
      ************
           IF T11-TIMP = ZERO
              MOVE ZERO TO RG-RIG-PROVV
           ELSE
              MOVE ZERO TO RG-RIG-PREZZ.
           MOVE TAB-DESCR TO RG-RIG-DESAR.
      **** rel 1.2
      *    MOVE T11-CIVA TO RG-RIG-CDIVA.
           IF FUN = 'V' AND RG-RIG-CDSPE NOT = RIG-CDSPE
              MOVE T11-CIVA TO RG-RIG-CDIVA.
      ************
           IF RG-RIG-CDIVA = ZERO
              MOVE 'da ventilare' TO RA-RIG-CDIVA-D
              GO TO E-CDSPE.
           MOVE 3 TO KTB-TIP.
           MOVE RG-RIG-CDIVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-RIG-CDIVA-D.
       E-CDSPE.
      *
       V-PROVV.
           MOVE 'RIG-PROVV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PROVV.
           IF RG-RIG-TPRIG NOT = 3 GO TO E-PROVV.
           MOVE 11 TO KTB-TIP.
           MOVE RG-RIG-CDSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO RG-RIG-DESAR
                MOVE 'Manca il codice spesa' TO MESS
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T11-TIMP = ZERO
              MOVE ZERO TO RG-RIG-PROVV
              GO TO E-PROVV.
           IF RG-RIG-PROVV = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PROVV.
      *
       V-PREZZ.
           MOVE 'RIG-PREZZ' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PREZZ.
           IF RG-RIG-TPRIG = 3 GO TO PRZSPE.
           IF NOT (RG-RIG-TPRIG = 0 OR 2 OR 4 OR 5 OR 6) GO TO E-PREZZ.
      **** rel 4.0
      *    MOVE RG-RIG-PREZZ TO RD-NUM.
      *    CALL 'vrround' USING PRZ-S PARRD RG-RIG-TPRZ.
      *    MOVE RD-NUM TO RG-RIG-PREZZ.
      *    IF RD-ST > ZERO
      *       PERFORM ERR-NDEC
      *       GO TO V-ERROR.
      ************
      **** rel 5.0
           PERFORM C00-CAL-SCAPP.
           MOVE IM-NETRG TO RA-RIG-NETRG.
      ************
           GO TO E-PREZZ.
       PRZSPE.
           MOVE 11 TO KTB-TIP.
           MOVE RG-RIG-CDSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO RG-RIG-DESAR
                MOVE 'Manca il codice spesa' TO MESS
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T11-TIMP = 1
              MOVE ZERO TO RG-RIG-PREZZ
              GO TO E-PREZZ.
      **** rel 4.0
      *    MOVE RG-RIG-PREZZ TO RD-NUM.
      *    CALL 'vrround' USING PRZ-S PARRD RG-RIG-TPRZ.
      *    MOVE RD-NUM TO RG-RIG-PREZZ.
      *    IF RD-ST > ZERO
      *       PERFORM ERR-NDEC
      *       GO TO V-ERROR.
      ************
           IF RG-RIG-PREZZ = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PREZZ.
      *
       V-FPNET.
           MOVE 'RIG-FPNET' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FPNET.
           IF RG-RIG-FPNET = 1
      **** rel 5.1
      *       MOVE ZERO TO RG-RIG-1SCON RG-RIG-2SCON.
              MOVE ZERO TO RG-RIG-1SCON RG-RIG-2SCON
      **** rel 5.2
      *       IF NOT (RG-RIG-TPRIG = 0 OR 2 OR 6) GO TO E-FPNET 
      *       ELSE
      *          IF FUN NOT = 'W'
      *             PERFORM CERCA-PROVVIGIONE THRU P99.
      **** rel 6.0a
      *       IF NOT (RG-RIG-TPRIG = 0 OR 2 OR 6) GO TO E-FPNET .
           PERFORM AGG-PRV THRU EX-AGG-PRV.
      ************
      ************
           PERFORM C00-CAL-SCAPP.
           MOVE IM-NETRG TO RA-RIG-NETRG.
      ************
       E-FPNET.
      *
       V-1SCON.
           MOVE 'RIG-1SCON' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-1SCON.
           IF NOT (RG-RIG-TPRIG = 0 OR 2 OR 6) GO TO E-1SCON.
           MOVE RG-RIG-1SCON TO RD-NUM.
      **** rel 4.0
      *    CALL 'vrround' USING PRZ-S PARRD AZI-FLSCC.
      **** rel 4.1
      *    CALL 'vrround' USING NNN-S PARRD AZI-FLSCC.
           IF AZI-FLSCC = ZERO
              MOVE ZERO TO COMAR
           ELSE
              MOVE 2 TO COMAR.
           CALL 'vrround' USING NNN-S PARRD COMAR.
      ************
      ************
           MOVE RD-NUM TO RG-RIG-1SCON.
           IF RD-ST > ZERO
              PERFORM ERR-NDEC
              GO TO V-ERROR.
      **** rel 5.0
      **** rel 5.2
      *    IF FUN NOT = 'W'
      *       PERFORM CERCA-PROVVIGIONE THRU P99.
      **** rel 6.0a
           PERFORM AGG-PRV THRU EX-AGG-PRV.
      ************
      ************
           PERFORM C00-CAL-SCAPP.
           MOVE IM-NETRG TO RA-RIG-NETRG.
      ************
       E-1SCON.
      *
       V-2SCON.
           MOVE 'RIG-2SCON' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-2SCON.
           IF NOT (RG-RIG-TPRIG = 0 OR 2 OR 6) GO TO E-2SCON.
           MOVE RG-RIG-2SCON TO RD-NUM.
      **** rel 4.0
      *    CALL 'vrround' USING PRZ-S PARRD AZI-FLSCC.
      **** rel 4.1
      *    CALL 'vrround' USING NNN-S PARRD AZI-FLSCC.
           IF AZI-FLSCC = ZERO
              MOVE ZERO TO COMAR
           ELSE
              MOVE 2 TO COMAR.
           CALL 'vrround' USING NNN-S PARRD COMAR.
      ************
      ************
           MOVE RD-NUM TO RG-RIG-2SCON.
           IF RD-ST > ZERO
              PERFORM ERR-NDEC
              GO TO V-ERROR.
      **** rel 5.0
      **** rel 5.2
      *    IF FUN NOT = 'W'
      *       PERFORM CERCA-PROVVIGIONE THRU P99.
      **** rel 6.0a
           PERFORM AGG-PRV THRU EX-AGG-PRV.
      ************
      ************
           PERFORM C00-CAL-SCAPP.
           MOVE IM-NETRG TO RA-RIG-NETRG.
      ************
       E-2SCON.
      *
       V-CDIVA.
           MOVE 'RIG-CDIVA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDIVA.
           IF NOT (RG-RIG-TPRIG = 0 OR 2 OR 3 OR 4 OR 5) GO TO E-CDIVA.
           IF RG-RIG-TPRIG = 3 AND RG-RIG-CDIVA = ZERO
              MOVE 'da ventilare' TO RA-RIG-CDIVA-D
              GO TO E-CDIVA.
           MOVE 3 TO KTB-TIP.
           MOVE RG-RIG-CDIVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO RA-RIG-CDIVA-D
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-RIG-CDIVA-D.
           IF T03-TPIVA = 1 OR 7
              MOVE 'Tipo di IVA non ammesso' TO MESS
              GO TO V-ERROR.
       E-CDIVA.
      *
       V-DTCSR.
           MOVE 'RIG-DTCSR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCSR.
           IF NOT (RG-RIG-TPRIG = 0 OR 2 OR 4 OR 5 OR 6) GO TO E-DTCSR.
           MOVE 1 TO TIPOP1.
           MOVE RG-RIG-DTCSR TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG NOT = ZERO
              IF AAGGG < ORD-DAT
                 MOVE 'Data consegna minore della data ordine' TO MESS
                 GO TO V-ERROR.
       E-DTCSR.
      *
       V-DTCSC.
           MOVE 'RIG-DTCSC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCSC.
           IF NOT (RG-RIG-TPRIG = 0 OR 2 OR 4 OR 5 OR 6) GO TO E-DTCSC.
           MOVE 1 TO TIPOP1.
           MOVE RG-RIG-DTCSC TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
      **** rel 6.2
      **** rel 6.3
      *    IF ORD-DTCSC NOT = AAGGG AND
      *       ORD-GGS > ZERO AND FUN = 'V' AND SWINS = 1
      *       PERFORM SOTTRAI-GG THRU EX-SOTTRAI-GG.
           IF ORD-GGS > ZERO AND FUN = 'V'
              IF CDTCSC NOT = AAGGG
                 PERFORM SOTTRAI-GG THRU EX-SOTTRAI-GG.
      ************

      **** rel 6.3
      *    IF ORD-GGS > ZERO AND FUN = 'V' AND SWINS = ZERO
      *       PERFORM SOMMA-GG THRU EX-SOMMA-GG.
      ************
      ************
           IF AAGGG NOT = ZERO
              IF AAGGG < ORD-DAT
                 MOVE 'Data consegna minore della data ordine' TO MESS
                 GO TO V-ERROR.
       E-DTCSC.
      *
       V-RIVGR.
           MOVE 'RIG-RIVGR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-RIVGR.
           IF NOT (RG-RIG-TPRIG = 4 OR 5) GO TO E-RIVGR.
           MOVE 3 TO KTB-TIP.
           MOVE RG-RIG-RIVGR TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO RA-RIG-RIVGR-D
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-RIG-RIVGR-D.
           IF T03-TPIVA = 1 OR 7
              MOVE 'Tipo di IVA non ammesso' TO MESS
              GO TO V-ERROR.
       E-RIVGR.
      *
       V-CONTR.
           MOVE 'RIG-CONTR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CONTR.
           IF NOT (RG-RIG-TPRIG = 2) GO TO E-CONTR.
           MOVE SPACE TO RA-RIG-CONTR-D.
           IF RG-RIG-CONTR = ZERO GO TO E-CONTR.
           MOVE KAZ-COD      TO KPC-AZI.
           MOVE RG-RIG-CONTR TO KPC-COD.
           OPEN INPUT ANACON.
           READ ANACON INTO REKCON INVALID
                PERFORM ERR-CINE
                CLOSE ANACON
                GO TO V-ERROR.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           CLOSE ANACON.
           IF CON-MOVIM NOT = ZERO
                MOVE 'Conto non movimentabile' TO MESS
                GO TO V-ERROR.
           IF CON-DSABB = SPACE MOVE CON-DESCR TO CON-DSABB.
           MOVE CON-DSABB TO RA-RIG-CONTR-D.
       E-CONTR.
      **** rel 2.0
      *
       V-NOTE.
           MOVE 'RIG-NOTE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NOTE.
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
      ************
           MOVE 0       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-RIG-NOTE.
           IF ML-ST = 1
              MOVE SPACE TO F-MES2
              MOVE 'E'' possibile caricare' TO F-MES1
      **** rel 6.2
      *       MOVE NRIGMAX  TO MAXRIGD
              MOVE NRIGMAXL TO MAXRIGD
      ************
              STRING 'al massimo ' MAXRIGD ' righe'
                     DELIMITED SIZE INTO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
      * accende/spegne bottone presenza note aggiuntive
           MOVE ZERO TO RA-RIG-FLGNOTE.
           IF RIG-TPRIG = 1
              MOVE 1 TO RA-RIG-FLGNOTE
              GO TO E-NOTE.
           IF RA-RIG-NOTE = SPACE GO TO E-NOTE.
      *
      **** rel 6.2
      *    MOVE NRIGMAX  TO KVALID.
           MOVE NRIGMAXL TO KVALID.
      ************
           PERFORM UNTIL RA-RIG-RIGNOT(KVALID) NOT = SPACE
              SUBTRACT 1 FROM KVALID
           END-PERFORM.
           IF KVALID > ZERO
              MOVE 1 TO RA-RIG-FLGNOTE.
       E-NOTE.
      ************
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
           PERFORM SUBMAG THRU EX-SUBMAG.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
           PERFORM ADDMAG THRU EX-ADDMAG.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       ADDMAG.
           IF (RIG-TPRIG > ZERO AND < 4) OR
               RIG-ARTIC = SPACE
               GO TO EX-ADDMAG.
           IF RIG-SALDO = 1 GO TO EX-ADDMAG.
           SUBTRACT RIG-QSPED FROM RIG-QUANT GIVING RESID.
           IF RESID NOT > ZERO GO TO EX-ADDMAG.
       ADDMAG-10.
           MOVE ORD-AZI   TO KMA-AZI.
           MOVE RIG-ARTIC TO KMA-ART.
           READ MAGART INTO REKART KEPT LOCK INVALID KEY
              PERFORM INVK-ART
              PERFORM VISK-RIG
              GO TO ERRIO.
           IF SF-ART > ZERO PERFORM REC-LOCK
                            GO TO ADDMAG-10.
       LRARD.
           MOVE KMA-AZI  TO KAD-AZI.
           MOVE ORD-CDEP TO KAD-DEP.
           MOVE KMA-ART  TO KAD-ART.
           READ MAGARD INTO REKARD KEPT LOCK INVALID KEY
              PERFORM INVK-ARD
              PERFORM VISK-RIG
              GO TO ERRIO.
           IF SF-ARD > ZERO PERFORM REC-LOCK
                            GO TO LRARD.
           ADD RESID TO ART-IMPCL ARD-CIMPE.
           REWRITE RF-ART FROM REKART INVALID
                   PERFORM INVK-ART
                   PERFORM VISK-RIG
                   GO TO ERRIO.
           UNLOCK MAGART.
           REWRITE RF-ARD FROM REKARD INVALID
                   PERFORM INVK-ARD
                   PERFORM VISK-RIG
                   GO TO ERRIO.
           UNLOCK MAGARD.
       EX-ADDMAG.
           EXIT.
      *------------------*
       SUBMAG.
           IF (RIG-TPRIG > ZERO AND < 4) OR
               RIG-ARTIC = SPACE
               GO TO EX-SUBMAG.
           IF RIG-SALDO = 1 GO TO EX-SUBMAG.
           SUBTRACT RIG-QSPED FROM RIG-QUANT GIVING RESID.
           IF RESID NOT > ZERO GO TO EX-SUBMAG.
           MOVE RIG-AZI   TO KMA-AZI.
           MOVE RIG-ARTIC TO KMA-ART.
       SMAG1.
           READ MAGART INTO REKART KEPT LOCK INVALID KEY
               PERFORM INVK-ART
               PERFORM VISK-RIG
               GO TO ERRIO.
           IF SF-ART > ZERO PERFORM REC-LOCK
                            GO TO SMAG1.
       SMAG2.
           MOVE KMA-AZI  TO KAD-AZI.
           MOVE ORD-CDEP TO KAD-DEP.
           MOVE KMA-ART  TO KAD-ART.
           READ MAGARD INTO REKARD KEPT LOCK INVALID KEY
               PERFORM INVK-ARD
               PERFORM VISK-RIG
               GO TO ERRIO.
           IF SF-ARD > ZERO PERFORM REC-LOCK
                            GO TO SMAG2.
           SUBTRACT RESID FROM ART-IMPCL ARD-CIMPE.
           REWRITE RF-ART FROM REKART INVALID KEY
               PERFORM INVK-ART
               PERFORM VISK-RIG
               GO TO ERRIO.
           UNLOCK MAGART.
           REWRITE RF-ARD FROM REKARD INVALID KEY
               PERFORM INVK-ARD
               PERFORM VISK-RIG
               GO TO ERRIO.
           UNLOCK MAGARD.
       EX-SUBMAG.
           EXIT.
      *------------------*
       F00-GES-OBC.
           MOVE ZERO TO SW-ESBOL.
           MOVE KRI-AZI TO OBC-AZI.
           MOVE KRI-NUM TO OBC-NORD.
           MOVE KRI-PRG TO OBC-RGOR.
           MOVE ZERO TO OBC-ANNO OBC-NUM OBC-BOL.
           START BOLORD KEY NOT < KEYBO2 INVALID GO TO F99.
       F10.
           READ BOLORD NEXT AT END GO TO F99.
           IF SF-OBC = '9D' OR '9A' OR '35' GO TO F10.
           IF KBO-AZI  NOT = KRI-AZI OR
              OBC-NORD NOT = KRI-NUM OR
              OBC-RGOR NOT = KRI-PRG
              GO TO F99.
           MOVE 1 TO SW-ESBOL.
       F99.
           EXIT.
      **** rel 2.0
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w9' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      ************
      *------------------*
       REC-LOCK.
      **** rel 1.2
           CALL 'rlock' USING PARLK.
      ************
           EXIT.
      *------------------*
      **** rel 5.2
      * procedura L00-LISTINO eliminata
      ************
      *------------------*
       G00-AGGLVE.
           IF RG-RIG-TPRIG NOT = ZERO GO TO G99.
           MOVE ORD-AZI    TO VE-AZI.
           MOVE RIG-ARTIC  TO VE-ART.
           MOVE ORD-CDCLI  TO VE-CLI.
           MOVE 'O'        TO VE-ORIG.
           MOVE ORD-NUM    TO VE-NDOC.
           MOVE ORD-DAT    TO VE-DTDOC.
           MOVE RIG-QUANT  TO VE-QTA.
           MOVE RIG-PREZZ  TO VE-PRZ.
           MOVE RIG-1SCON  TO VE-SC1.
           MOVE RIG-2SCON  TO VE-SC2.
      **** rel 1.2
           MOVE ORD-PERSC  TO VE-SCBAS.
           MOVE RIG-FPNET  TO VE-FPNET.
      ************
           MOVE ZERO       TO VE-ST.
           CALL 'vrlsven' USING PARVE.
           CANCEL 'vrlsven'.
       G99.
           EXIT.
      *------------------*
      * setta RIG-TQUAN e RIG-TPRZ per righi occasionali ORDINE
       SETTA-TQP-RIG.
           IF NOT ((RIG-TPRIG = 2)  OR
                  ((RIG-TPRIG = 4 OR 5) AND RIG-ARTIC = SPACE))
                    GO TO EX-SETTA-TQP-RIG.
      *
           MOVE RIG-QUANT TO RD-NUM.
           CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
           MOVE RD-TIPO TO RIG-TQUAN.
      *
           MOVE RIG-QSPED TO RD-NUM.
           CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
           IF RD-TIPO > RIG-TQUAN
              MOVE RD-TIPO TO RIG-TQUAN.
      *
      **** rel 4.0
      *    MOVE RIG-PREZZ TO RD-NUM.
      *    CALL 'vrround' USING PRZ-SET PARRD RD-TIPO.
      *    MOVE RD-TIPO TO RIG-TPRZ.
      *
      *    IF ORD-VALUT > 1 MOVE 1 TO RIG-TPRZ.
      ************
       EX-SETTA-TQP-RIG.
           EXIT.
      *------------------*
      **** rel 2.0
      * fase di scrittura note aggiuntive rigo ordine cliente
       DL-WR-NOTE.
      **** rel 6.3
           IF RA-RIG-NOTE = SPACE AND RG-RIG-TPRIG = 1
      **** rel 7.2
           AND RG-RIG-FUN NOT = 'A'
      ************
              MOVE KRI-AZI TO KNRI-AZI
              MOVE KRI-NUM TO KNRI-NUM
              MOVE KRI-PRG TO KNRI-PRG
              MOVE 1       TO KNRI-PRGN
              MOVE SPACE   TO NRI-DESCR
              WRITE RF-NRI INVALID PERFORM INVK-NRI
                                   GO TO ERRIO
              END-WRITE
              GO TO EX-DL-WR-NOTE.
      ************
           PERFORM DL-NOTE THRU EX-DL-NOTE.
      *
       WR-NOTE.
           IF RA-RIG-NOTE = SPACE GO TO EX-DL-WR-NOTE.
      *
      **** rel 6.2
      *    MOVE NRIGMAX TO KVALID.
           MOVE NRIGMAXL TO KVALID.
      ************
           PERFORM UNTIL RA-RIG-RIGNOT(KVALID) NOT = SPACE
              SUBTRACT 1 FROM KVALID
           END-PERFORM.
      *
      **** rel 6.2
      *    IF KVALID = 1 AND RIG-TPRIG = 1 GO TO EX-DL-WR-NOTE.
      ************
      *
           MOVE KRI-AZI TO KNRI-AZI.
           MOVE KRI-NUM TO KNRI-NUM.
           MOVE KRI-PRG TO KNRI-PRG.
           MOVE ZERO    TO KNRI-PRGN.
      *
           MOVE 1 TO KML.
      **** rel 6.2
      *    IF RIG-TPRIG = 1
      *       MOVE 2 TO KML.
      ************
           PERFORM UNTIL KML > KVALID
              ADD 1 TO KNRI-PRGN
              MOVE RA-RIG-RIGNOT(KML) TO NRI-DESCR
              WRITE RF-NRI INVALID PERFORM INVK-NRI
                                   GO TO ERRIO
              END-WRITE
              ADD 1 TO KML
           END-PERFORM.
      *
           PERFORM CONTA-NBYTE-RIG-NOTE.
      * conversione per visualizzazione automatica nel caso di conferma
      * dopo una variazione
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 2       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-RIG-NOTE.
       EX-DL-WR-NOTE.
           EXIT.
      *------------------
      * cancellazione note aggiuntive rigo ordine cliente
       DL-NOTE.
           MOVE KRI-AZI TO KNRI-AZI.
           MOVE KRI-NUM TO KNRI-NUM.
           MOVE KRI-PRG TO KNRI-PRG.
           MOVE ZERO    TO KNRI-PRGN.
      *
           START NOTRIG KEY >= KEYNRI INVALID GO TO EX-DL-NOTE.
       DL-NOTE-10.
           READ NOTRIG NEXT AT END GO TO EX-DL-NOTE.
           IF KNRI-AZI > KRI-AZI GO TO EX-DL-NOTE.
           IF KNRI-NUM > KRI-NUM GO TO EX-DL-NOTE.
           IF KNRI-PRG > KRI-PRG GO TO EX-DL-NOTE.
           DELETE NOTRIG INVALID PERFORM INVK-NRI
                                 GO TO V-ERROR.
           GO TO DL-NOTE-10.
       EX-DL-NOTE.
           EXIT.
      *------------------
      * fase di lettura note aggiuntive rigo ordine cliente e
      * caricamento aree interfaccia
       RD-NRI.
           PERFORM AZZ-NOTE.
      *
           MOVE ZERO TO RA-RIG-FLGNOTE.
           MOVE ZERO TO KN.
      *
      **** rel 6.2
      *    IF RIG-TPRIG = 1
      *       MOVE RIG-DESAR TO RA-RIG-RIGNOT(1)
      *       MOVE 1 TO RA-RIG-FLGNOTE
      *       ADD 1 TO KN.
      ************
      *
           MOVE KRI-AZI TO KNRI-AZI.
           MOVE KRI-NUM TO KNRI-NUM.
           MOVE KRI-PRG TO KNRI-PRG.
           MOVE ZERO    TO KNRI-PRGN.
           START NOTRIG KEY >= KEYNRI INVALID GO TO RD-NRI-20.
       RD-NRI-10.
           READ NOTRIG NEXT AT END GO TO RD-NRI-20.
           IF KNRI-AZI > KRI-AZI GO TO RD-NRI-20.
           IF KNRI-NUM > KRI-NUM GO TO RD-NRI-20.
           IF KNRI-PRG > KRI-PRG GO TO RD-NRI-20.
           ADD 1 TO KN.
      **** rel 6.2
      *    IF KN <= NRIGMAX
           IF KN <= NRIGMAXL
      ************
              MOVE NRI-DESCR TO RA-RIG-RIGNOT(KN)
              MOVE 1 TO RA-RIG-FLGNOTE
           GO TO RD-NRI-10.
       RD-NRI-20.
      *
           PERFORM CONTA-NBYTE-RIG-NOTE.
      *
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 2       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-RIG-NOTE.
      *
       EX-RD-NRI.
           EXIT.
      *------------------
       AZZ-NOTE.
           MOVE 1 TO KML.
           PERFORM UNTIL KML > NRIGMAX
              MOVE SPACE TO RA-RIG-RIGNOT(KML)
              ADD 1 TO KML
           END-PERFORM.
      *
           MOVE ZERO TO RA-RIG-NBYTE
                        RA-RIG-FLGNOTE.
      *------------------
      * conta nbyte note aggiuntive
       CONTA-NBYTE-RIG-NOTE.
           MOVE ZERO TO RA-RIG-NBYTE.
           IF RA-RIG-NOTE NOT = SPACE
      **** rel 6.2
      *       MOVE NRIGMAX TO KVALID
              MOVE NRIGMAXL TO KVALID
      ************
              PERFORM UNTIL RA-RIG-RIGNOT(KVALID) NOT = SPACE
                 SUBTRACT 1 FROM KVALID
              END-PERFORM
      **** rel 6.2
      *       COMPUTE RA-RIG-NBYTE = KVALID * 30.
              COMPUTE RA-RIG-NBYTE = KVALID * NCOLMAX.
      ************
      *------------------*
      **** rel 6.1
      * procedura DEL-PRORIG eliminata
      ************
      *------------------
      **** rel 5.2
      * procedura CERCA-SCONTI eliminata
      ************
      *------------------
      * evasione automatica righi offerta
       R-RDF00.
           MOVE ZERO TO SAVOFF.
           OPEN I-O WDSLAV.
           MOVE ZERO TO KEYLV.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO F-RDFCR.
       R-RDF10.
           READ WDSLAV NEXT AT END GO TO F-RDFCR.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO R-RDF10.
           IF SAVOFF = KLV-NOFF GO TO R-RDF15.
           IF SAVOFF NOT = ZERO
              ADD 5 TO RG-RIG-PRG.
           MOVE KLV-NOFF TO SAVOFF.
      * lettura testata offerta e caricamento righi ordine fissi
           MOVE RG-RIG-AZI TO KFCT-AZI.
           MOVE KLV-NOFF   TO KFCT-NUM.
           READ OFFCLI INTO REKFCT INVALID
                PERFORM INVK-FCT
                GO TO WARNING.
           IF SF-FCT = '9D' OR '9A' OR '35' MOVE RF-FCT TO REKFCT.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           MOVE KFCT-NUM TO DES2.
      *
           MOVE FCT-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DES4.
      *
      **** rel 6.2
      *    MOVE DESCRIZIONE TO RIG-DESAR.
           MOVE DESCRIZIONE TO RIG-DESAR NRI-DESCR.
      ************
           MOVE 1           TO RIG-TPRIG.
      **** rel 6.2
      *    MOVE KOR-AZI     TO RIG-AZI.
      *    MOVE KOR-NUM     TO RIG-NUM.
      *    MOVE RG-RIG-PRG  TO RIG-PRG.
           MOVE KOR-AZI     TO RIG-AZI KNRI-AZI.
           MOVE KOR-NUM     TO RIG-NUM KNRI-NUM.
           MOVE RG-RIG-PRG  TO RIG-PRG KNRI-PRG.
           MOVE 1 TO KNRI-PRGN.
      ************
           MOVE 1           TO RIG-SALDO.
           WRITE RF-RIG FROM REKRIG INVALID PERFORM INVK-RIG
                                            GO TO WARNING.
      **** rel 6.2
           WRITE RF-NRI INVALID PERFORM INVK-NRI
                                   GO TO WARNING.
      ************
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           IF FCT-VSORD = SPACE GO TO R-RDF15.
           MOVE FCT-VSORD TO DES6.
      **** rel 6.2
      *    MOVE DESCRIZIONE2 TO RIG-DESAR.
           MOVE DESCRIZIONE2 TO RIG-DESAR NRI-DESCR.
      ************
           MOVE 1 TO RIG-TPRIG.
           ADD 5 TO RG-RIG-PRG.
      **** rel 6.2
      *    MOVE RG-RIG-PRG TO RIG-PRG.
           MOVE RG-RIG-PRG TO RIG-PRG KNRI-PRG.
      ************
           MOVE 1 TO RIG-SALDO.
           WRITE RF-RIG FROM REKRIG INVALID PERFORM INVK-RIG
                                            GO TO WARNING.
      **** rel 6.2
           WRITE RF-NRI INVALID PERFORM INVK-NRI
                                   GO TO WARNING.
      ************
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
       R-RDF15.
           MOVE RIG-AZI  TO  KFCR-AZI.
           MOVE KLV-NOFF TO  KFCR-NUM.
           MOVE KLV-PRG  TO  KFCR-PRG.
           READ OFFRIG INTO REKFCR INVALID PERFORM INVK-FCR
                                           GO TO WARNING.
           IF SF-FCR = '9D' OR '9A' OR '35' MOVE RF-FCR TO REKFCR.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           MOVE KOR-AZI    TO RIG-AZI.
           MOVE KOR-NUM    TO RIG-NUM.
           ADD 5 TO RG-RIG-PRG.
           MOVE RG-RIG-PRG TO RIG-PRG.
           MOVE FCR-TPRIG  TO RIG-TPRIG.
           PERFORM B00-AUTOM THRU B99.
           GO TO R-RDF10.
       F-RDFCR.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
       R-RDF99.
           EXIT.
      *------------------
       B00-AUTOM.
           IF FCR-TPRIG = 3 GO TO B40.
           IF FCR-TPRIG = 1 GO TO B50.
           IF FCR-TPRIG = 2
              MOVE FCR-DESAR TO RIG-DESAR
              PERFORM L20-RD-ART THRU L99-RD-ART
              GO TO B20.
           MOVE FCR-ARTIC TO RIG-ARTIC.
           PERFORM L00-RD-ART THRU L99-RD-ART.
       B20.
      **** rel 5.0
           IF RA-RIG-FLGOPC = 1
              PERFORM CREA-RIG-PROGRAMMA THRU EX-CREA-RIG-PROGRAMMA
              MOVE ZERO TO RIG-QSPED
              MOVE ZERO TO RIG-QUANT
              MOVE ZERO TO RIG-SALDO
              GO TO B30.
      ************
      **** rel 5.2
           MOVE ORD-DTCSR TO RIG-DTCSR.
           IF FCR-DTCSR NOT = ZERO
              MOVE FCR-DTCSR TO RIG-DTCSR
           ELSE
              MOVE ORD-DTCSR TO RIG-DTCSR.
           MOVE ORD-DTCSC TO RIG-DTCSC.
      ************
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
       B30.
           MOVE KOR-AZI TO RIG-AZI.
           MOVE KOR-NUM TO RIG-NUM.
           WRITE RF-RIG FROM REKRIG INVALID KEY PERFORM INVK-RIG
                                                GO TO WARNING.
      *
           IF ORD-VALUT = CLF-VAL
              MOVE RIG-TPRIG TO RG-RIG-TPRIG
              PERFORM G00-AGGLVE THRU G99.
      *
           PERFORM TRAVAS-NOTE THRU EX-TRAVAS-NOTE.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           GO TO B99.
       B40.
           MOVE FCR-CDSPE TO RIG-CDSPE.
           MOVE RIG-CDSPE TO KTB-COD.
           MOVE 11        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-RIG
                                           GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RIG-DESAR.
           MOVE T11-CONTR TO RIG-CONTR.
           MOVE FCR-PREZZ TO RIG-PREZZ.
      **** rel 4.0
      *    MOVE FCR-TPRZ  TO RIG-TPRZ.
           MOVE FCR-FSC   TO RIG-FSC.
      ************
           MOVE FCR-CDIVA TO RIG-CDIVA.
           MOVE FCR-PROVV TO RIG-PROVV.
           MOVE ZERO      TO RIG-QUANT.
           MOVE 1         TO RIG-SALDO.
           GO TO B30.
       B50.
           MOVE FCR-DESAR TO RIG-DESAR.
      **** rel 4.0
      *    MOVE ZERO      TO RIG-TPRZ.
           MOVE ZERO      TO RIG-FSC.
      ************
           MOVE 1         TO RIG-SALDO.
           GO TO B30.
       B99.
           EXIT.
      *------------------
       L00-RD-ART.
           MOVE RIG-ARTIC TO KMA-ART.
           MOVE FCR-AZI   TO KMA-AZI.
           READ MAGART INTO REKART INVALID KEY PERFORM INVK-ART
                                               PERFORM VISK-RIG
                                               GO TO WARNING.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           MOVE ART-DESCR TO RIG-DESAR.
      **** rel 5.2
           IF ART-XCPRV > ZERO MOVE ART-XCPRV TO RIG-PROVV.
      ************
           MOVE KMA-ART TO KAD-ART.
           MOVE KMA-AZI TO KAD-AZI.
           MOVE ORD-CDEP TO KAD-DEP.
           READ MAGARD INTO REKARD INVALID KEY PERFORM INVK-ARD
                                               PERFORM VISK-RIG
                                               GO TO WARNING.
           IF SF-ARD = '9D' OR '9A' OR '35' MOVE RF-ARD TO REKARD.
       L20-RD-ART.
           MOVE FCR-TQUAN TO RIG-TQUAN.
      **** rel 4.0
      *    MOVE FCR-TPRZ  TO RIG-TPRZ.
           MOVE FCR-FSC   TO RIG-FSC.
      ************
           MOVE FCR-UNMIS TO RIG-UNMIS.
           MOVE FCR-CDIVA TO RIG-CDIVA.
           MOVE FCR-PREZZ TO RIG-PREZZ.
           MOVE FCR-QUANT TO RIG-QUANT.
           MOVE FCR-FPNET TO RIG-FPNET.
           MOVE FCR-1SCON TO RIG-1SCON.
           MOVE FCR-2SCON TO RIG-2SCON.
      **** rel 5.2
           IF RIG-PROVV = ZERO MOVE ORD-PROVV TO RIG-PROVV.
      ************
           IF RIG-CDIVA = ZERO GO TO L99-RD-ART.
           MOVE 3         TO KTB-TIP.
           MOVE RIG-CDIVA TO KTB-COD.
           READ TABELL INVALID PERFORM INVK-TAB
                               PERFORM VISK-RIG
                               GO TO WARNING.
       L99-RD-ART.
           EXIT.
      *------------------
      * fase di scrittura note aggiuntive rigo ordine cliente
      * da rigo offerta
       TRAVAS-NOTE.
           PERFORM DL-NOTE THRU EX-DL-NOTE.
      **** rel 6.2
           MOVE SPACE TO COM-IN.
      ************
      *
           MOVE KRI-AZI TO KNRI-AZI.
           MOVE KRI-NUM TO KNRI-NUM.
           MOVE KRI-PRG TO KNRI-PRG.
           MOVE ZERO    TO KNRI-PRGN.
      *
           MOVE KFCR-AZI TO KNFC-AZI.
           MOVE KFCR-NUM TO KNFC-NUM.
           MOVE KFCR-PRG TO KNFC-PRG.
           MOVE ZERO     TO KNFC-PRGN.
      *
      **** rel 6.2
      *    START NOTOFC KEY >= KEYNFC INVALID GO TO EX-TRAVAS-NOTE.
      *RD-NOTE-OFC.
      *    READ NOTOFC NEXT AT END GO TO EX-TRAVAS-NOTE.
      *    IF KNFC-AZI > KFCR-AZI GO TO EX-TRAVAS-NOTE.
      *    IF KNFC-NUM > KFCR-NUM GO TO EX-TRAVAS-NOTE.
      *    IF KNFC-PRG > KFCR-PRG GO TO EX-TRAVAS-NOTE.
           START NOTOFC KEY >= KEYNFC INVALID GO TO END-TRAVAS-NOTE.
       RD-NOTE-OFC.
           READ NOTOFC NEXT AT END GO TO END-TRAVAS-NOTE.
           IF KNFC-AZI > KFCR-AZI GO TO END-TRAVAS-NOTE.
           IF KNFC-NUM > KFCR-NUM GO TO END-TRAVAS-NOTE.
           IF KNFC-PRG > KFCR-PRG GO TO END-TRAVAS-NOTE.
      ************
      *
           ADD 1 TO KNRI-PRGN.
      **** rel 6.2
      *    MOVE NFC-DESCR TO NRI-DESCR.
      *    WRITE RF-NRI INVALID PERFORM INVK-NRI GO TO ERRIO.
           MOVE NFC-DESCR TO COM-RIN(KNRI-PRGN).
      ************
           GO TO RD-NOTE-OFC.
      *
      **** rel 6.2
       END-TRAVAS-NOTE.
      **** rel 7.2
      *    IF COM-IN = SPACE GO TO EX-TRAVAS-NOTE.
           IF COM-IN = SPACE
              IF RIG-TPRIG = 1
                 MOVE KRI-AZI TO KNRI-AZI
                 MOVE KRI-NUM TO KNRI-NUM
                 MOVE KRI-PRG TO KNRI-PRG
                 MOVE 1       TO KNRI-PRGN
                 MOVE SPACE   TO NRI-DESCR
                 WRITE RF-NRI INVALID PERFORM INVK-NRI
                                      GO TO ERRIO
                 END-WRITE
                 GO TO EX-TRAVAS-NOTE.
      **********
      *
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4 TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL COM-IN. 
      *    
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 5 TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL COM-IN. 
      *
           MOVE NRIGMAXL TO KVALID.
           PERFORM UNTIL COM-RIN(KVALID) NOT = SPACE
                   SUBTRACT 1 FROM KVALID.
           MOVE ZERO TO KNRI-PRGN.
           PERFORM UNTIL KNRI-PRGN >= KVALID
                ADD 1 TO KNRI-PRGN
                MOVE COM-RIN(KNRI-PRGN) TO NRI-DESCR
                WRITE RF-NRI INVALID PERFORM INVK-NRI GO TO ERRIO.
      ************
       EX-TRAVAS-NOTE.
           EXIT.
      *------------------
      ************
      **** rel 4.0
       AGGIORNA-FSC-D.
           MOVE SPACE TO RA-RIG-FSC-D.
           IF RG-RIG-FSC = 1 MOVE 'x10'   TO RA-RIG-FSC-D.
           IF RG-RIG-FSC = 2 MOVE 'x100'  TO RA-RIG-FSC-D.
           IF RG-RIG-FSC = 3 MOVE 'x1000' TO RA-RIG-FSC-D.
      *------------------
      **** rel 5.2
      * procedura LISTINO-BASE-LIRE eliminata
      ************
      ************
      **** rel 5.0
      * crea righi dell'ordine a programma
       CREA-RIG-PROGRAMMA.
           IF FCR-TPRIG = 3 OR 1 GO TO END-CREA-RIG.
           MOVE ZERO TO RF-OPC.
           MOVE KOR-AZI TO KOPC-AZI.
           MOVE KOR-NUM TO KOPC-NUM.
           MOVE RIG-PRG TO KOPC-PRG.
           MOVE 1       TO KOPC-PROG.
      *
           MOVE FCR-DTCSR TO OPC-DATA.
           IF OPC-DATA = ZERO
              MOVE COMDATPK TO OPC-DATA.
           MOVE ZERO      TO OPC-TIPO.
           MOVE RIG-QUANT TO OPC-QTAPR.
           MOVE ZERO      TO OPC-QTACF.
      *
           WRITE RF-OPC INVALID PERFORM INVK-OPC
                                PERFORM VISK-RIG
                                GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-O.
      ************
       END-CREA-RIG.

       EX-CREA-RIG-PROGRAMMA.
           EXIT.
      *------------------
      **** rel 6.1
      * procedura DEL-OBC eliminata
      ************
      *------------------*
      * importazione testi esterni *
       F-LEG-TESTO.
      **** rel 5.0-2
           IF RA-RIG-NTESTO = ZERO GO TO END-F-LEG-TESTO.
      **************
           MOVE RG-RIG-AZI    TO KARN-AZI.
           MOVE RA-RIG-NTESTO TO KARN-NUM.
           MOVE ZERO          TO KARN-PGR.
      *
           MOVE 1 TO KML.
      **** rel 6.2
      *    PERFORM UNTIL KML > NRIGMAX
           PERFORM UNTIL KML > NRIGMAXL
      ************
              MOVE SPACE TO RA-RIG-RIGNOT(KML)
              ADD 1 TO KML
           END-PERFORM.
      *
           MOVE ZERO TO KN.
           START ARCNOT KEY >=  KEYARN INVALID GO TO F-LEG-TESTO-90.
       F-LEG-TESTO-10.
           READ ARCNOT NEXT AT END GO TO F-LEG-TESTO-90.
           IF KARN-AZI NOT = RG-RIG-AZI GO TO F-LEG-TESTO-90.
           IF KARN-NUM NOT = RA-RIG-NTESTO GO TO F-LEG-TESTO-90.

           ADD 1 TO KN.
      **** rel 6.2
      *    IF KN > NRIGMAX GO TO F-LEG-TESTO-90.
           IF KN > NRIGMAXL GO TO F-LEG-TESTO-90.
      ************
           MOVE ARN-NOTE TO RA-RIG-RIGNOT(KN).
           GO TO F-LEG-TESTO-10.

           READ ARCNOT NEXT AT END GO TO F-LEG-TESTO-90.
           IF KARN-AZI NOT = RG-RIG-AZI GO TO F-LEG-TESTO-90.
           IF KARN-NUM NOT = RA-RIG-NTESTO GO TO F-LEG-TESTO-90.

           ADD 1 TO KN.
      **** rel 6.2
      *    IF KN > NRIGMAX GO TO F-LEG-TESTO-90.
           IF KN > NRIGMAXL GO TO F-LEG-TESTO-90.
      ************
           MOVE ARN-NOTE TO RA-RIG-RIGNOT(KN).
           GO TO F-LEG-TESTO-10.
       F-LEG-TESTO-90.
           IF KN = ZERO GO TO END-F-LEG-TESTO.
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 2       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-RIG-NOTE.
       END-F-LEG-TESTO.
           EXIT.
      *-------------*
      **** rel 5.2
      * procedura CERCA-PROVVIGIONE eliminata
      ************
      **** rel 6.0a
       AGG-PRV.
           IF FUN = 'W' GO TO EX-AGG-PRV.
           IF RG-RIG-TPRIG NOT = ZERO GO TO EX-AGG-PRV.
      *
           MOVE ORD-AZI      TO RPV-AZI.
           MOVE ORD-CDCLI    TO RPV-CLI.
           MOVE CLF-GRU      TO RPV-GRU.
           MOVE ORD-VALUT    TO RPV-VALUT.
           MOVE ORD-DAT      TO RPV-DATA.
           MOVE ORD-PERSC    TO RPV-SCBAS.
           MOVE ORD-CDAGE    TO RPV-CDAGE.
           MOVE RG-RIG-ARTIC TO RPV-ART.
           MOVE ART-GMERC    TO RPV-GMERC.
           MOVE RG-RIG-QUANT TO RPV-QTA.
           MOVE RG-RIG-TQUAN TO RPV-TQUAN.
      *
           MOVE RG-RIG-PREZZ TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI.
           MOVE DP-PREZZO    TO RPV-PZLOR.   
      * 
           MOVE RG-RIG-1SCON TO RPV-SC1.
           MOVE RG-RIG-2SCON TO RPV-SC2.
           MOVE RG-RIG-FPNET TO RPV-FPNET.
           CALL 'vrdprv' USING PARRPV.
           IF RPV-FLGP NOT = ZERO
              MOVE RPV-PROVV TO RG-RIG-PROVV.
      *       MOVE RPV-IPROV TO RG-RIG-IPROV.
       EX-AGG-PRV.
           EXIT.
      ************
      *------------------*
       C00-CAL-SCAPP.

           MOVE "V"       TO IM-TIPO.
      *
      **** rel 5.2
           MOVE RG-RIG-FSC   TO DP-FSC.
      ************
           MOVE RG-RIG-PREZZ TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI.
           MOVE DP-PREZZO    TO IM-PZLOR.   
      * 
           MOVE RG-RIG-QUANT TO IM-QTA.
           MOVE ORD-PERSC TO IM-SCBAS.
           MOVE RG-RIG-1SCON TO IM-SC1.
           MOVE RG-RIG-2SCON TO IM-SC2.
           MOVE ORD-VALUT TO IM-VALUT.
           MOVE RIG-TPRIG TO IM-TCOR.
           MOVE RG-RIG-TQUAN TO IM-TQUAN.
      **** rel 5.2
           MOVE RG-RIG-FSC  TO IM-FSC.
      ************
           MOVE RG-RIG-FPNET TO IM-FPNET.
           CALL 'vrimpor' USING PARIM.
      **** rel 5.2
      * procedura C00-10. C99. eliminata
      ************
      *------------------*
      **** rel 6.2
       VER-ART-PRO.
           MOVE ZERO TO NOPC.

           MOVE LOW-VALUE TO KEYRI.
           MOVE RG-RIG-ARTIC TO KRI-ART.
           MOVE RG-RIG-NUM   TO KRI-NUM.
           START ORDRIG KEY NOT < SKEYRI2 INVALID GO TO NOPRO.
       RDPRO.
           READ ORDRIG NEXT INTO REKRIG AT END GO TO NOPRO.
           IF SF-RIG = '9D' OR '9A' OR '35' GO TO RDPRO.
           IF KRI-ART NOT = RG-RIG-ARTIC GO TO NOPRO.
           IF KRI-NUM NOT = RG-RIG-NUM   GO TO NOPRO.

           IF KRI-AZI NOT = RG-RIG-AZI GO TO RDPRO.

           ADD 1 TO NOPC.
           GO TO RDPRO.
       NOPRO.
           IF NOPC > ZERO
              MOVE SPACE TO F-MES1
              STRING 'Articolo ' RG-RIG-ARTIC ' gi presente.' 
                                 DELIMITED SIZE INTO F-MES1
              MOVE 'Ordine a Programma gi utilizzato' TO F-MES2
              MOVE 'in almeno un Ordine a Richiamo.' TO F-MES3
              MOVE 3 TO F-NMES
              CALL 'vrmbox' USING PARMB.

      * rimette in linea RF-RIG + REKRIG recor in elaborazione
           PERFORM AZZ-REC THRU EX-AZZ-REC.
       EX-VER-ART-PRO.
           EXIT.
      *------------------*
       VER-ART-OPC.
           MOVE ZERO TO RA-RIG-PRGOPC.
           MOVE ZERO TO FLGI.
           MOVE ZERO TO NOPC FLGCONF.
           IF KRI-AZI = ZERO MOVE 1 TO FLGI.   *> inserimento

           MOVE LOW-VALUE TO KEYRI.
           MOVE RG-RIG-ARTIC TO KRI-ART.
           MOVE PORC-NOPC    TO KRI-NUM.
           START ORDRIG KEY NOT < SKEYRI2 INVALID GO TO NOOPC.
       RDOPC.
           READ ORDRIG NEXT INTO REKRIG AT END GO TO NOOPC.
           IF SF-RIG = '9D' OR '9A' OR '35' GO TO RDOPC.
           IF KRI-ART NOT = RG-RIG-ARTIC GO TO NOOPC.
           IF KRI-NUM NOT = PORC-NOPC  GO TO NOOPC.

           IF KRI-AZI NOT = RG-RIG-AZI GO TO RDOPC.

           ADD 1 TO NOPC.
           IF RA-RIG-PRGOPC = ZERO MOVE KRI-PRG TO RA-RIG-PRGOPC.
      *
           MOVE KRI-AZI TO SKOPC-AZI.
           MOVE KRI-NUM TO SKOPC-NUM.
           MOVE KRI-PRG TO SKOPC-PRG.
           MOVE ZERO    TO SKOPC-PROG.
           START ORDPRC KEY NOT < KEYOPC INVALID GO TO END-PROG.
       LP-PROG.
           READ ORDPRC NEXT AT END GO TO END-PROG.
           IF KRI-AZI NOT = SKOPC-AZI GO TO END-PROG.
           IF KRI-NUM NOT = SKOPC-NUM GO TO END-PROG.
           IF KRI-PRG NOT = SKOPC-PRG GO TO END-PROG.

           IF OPC-QTACF NOT = ZERO MOVE 1 TO FLGCONF
                                   GO TO END-PROG.
           GO TO LP-PROG.
       END-PROG.
      *
           GO TO RDOPC.
       NOOPC.
           IF NOPC NOT = 1 
              IF NOT (FUN = 'R' OR 'r')
                 MOVE SPACE TO F-MES1
                 IF NOPC = ZERO
                    STRING 'Articolo ' RG-RIG-ARTIC ' non presente' 
                                       DELIMITED SIZE INTO F-MES1
                    MOVE 'nell''Ordine a Programma' TO F-MES2
                 ELSE
                    STRING 'Articolo ' RG-RIG-ARTIC ' presente pi'
                                       DELIMITED SIZE INTO F-MES1
                    MOVE 'volte nell''Ordine a Programma' TO F-MES2
                 END-IF
                 MOVE 2 TO F-NMES
                 CALL 'vrmbox' USING PARMB.

           IF FLGCONF = 1 
              IF NOT (FUN = 'R' OR 'r')
                 MOVE SPACE TO F-MES1
                 STRING 'Articolo ' RG-RIG-ARTIC ' ha quantit' 
                                   DELIMITED SIZE INTO F-MES1
                 MOVE 'confermata nell''Ordine a Programma' TO F-MES2
                 MOVE 2 TO F-NMES
                 CALL 'vrmbox' USING PARMB.
           
       RDRIG.
      * rimette in linea RF-RIG + REKRIG recor in elaborazione
           IF FLGI = ZERO
              IF FUN = 'r'
                 MOVE 1 TO FLCK
              ELSE
                 MOVE ZERO TO FLCK
              END-IF
              PERFORM READ-K THRU EX-READ-K
              IF VKEY > ZERO
                 PERFORM INVK-RIG
                 GO TO ERRIO
              END-IF
           ELSE
              PERFORM AZZ-REC THRU EX-AZZ-REC.
       EX-VER-ART-OPC.
           EXIT.
      *------------------*
      ************
      **** rel 6.2
      *-------------------------------
       SOMMA-GG.
           MOVE 1 TO TIPOP1.
           MOVE RG-RIG-DTCSC TO GGMMAA.
           CALL 'rdata' USING PARCDT.

           IF ORD-GGS = ZERO OR AAGGG = ZERO GO TO EX-SOMMA-GG.
      * SOMMA giorni escludendo sabati e domeniche
           MOVE ORD-GGS TO I.
           PERFORM UNTIL I = ZERO
              ADD 1 TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF SWRET1 > ZERO
                 MOVE ZERO TO I
              ELSE
                 IF GGSET <= 5
                    SUBTRACT 1 FROM I.

           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RA-RIG-DTGGS.
       EX-SOMMA-GG.
           EXIT.
      *-------------------------------
       SOTTRAI-GG.
           MOVE RG-RIG-DTCSC TO RA-RIG-DTGGS.

           IF ORD-GGS = ZERO OR AAGGG = ZERO GO TO EX-SOTTRAI-GG.
      * SOTTRAE giorni escludendo sabati e domeniche
           MOVE ORD-GGS TO I.
           PERFORM UNTIL I = ZERO
              SUBTRACT 1 FROM AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF SWRET1 > ZERO
                 MOVE ZERO TO I
              ELSE
                 IF GGSET <= 5
                    SUBTRACT 1 FROM I.

           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RIG-DTCSC.
      **** rel 6.3
           MOVE AAGGG TO CDTCSC.
      ************
       EX-SOTTRAI-GG.
           EXIT.
      *-------------------------------
      ************
      **** rel 7.1
       CALL-VSRV133.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'RIG'   TO PPAR-TARC.
           MOVE KEYRI   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           IF PPAR-TOPE = 'C'
              MOVE DTINT TO PPAR-OPZ(1:5).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 RIG ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *-------------------------------
       CALL-VSRV133-O.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'OPC'   TO PPAR-TARC.
           MOVE KEYOPC  TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 OPC ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *-------------------------------
       CALL-VSRV133-FCT.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'FCT'   TO PPAR-TARC.
           MOVE KEYFCT  TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 FCT ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      ************
