       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORDX10-L.
      *
      *    Interfaccia ORDCLI per list box
      *
      **** rel 6.2
      * ricompilato
      ************
      **** rel 4.0
      * ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griordsl'.
           COPY 'griclfsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griord'.
           COPY 'griclf'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griordrk'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
      **** rel 5.0
           COPY 'paroc'.
      ************
      **** rel 6.2
           COPY 'parmc'.
      ************
      **** rel 6.1
           COPY 'parlpd'.
           COPY 'parxcd'.
           COPY 'parpint'.
      ************
      **** rel 6.2
           COPY 'parorc'.
      ************
       01  ID-ORD  PIC X(15) VALUE 'ordcli'.
       01  ID-CLF  PIC X(15) VALUE 'anaclf'.
       01  ID-TAB  PIC X(15) VALUE 'tabell'.
       01  SF-ORD  PIC XX.
       01  SF-CLF  PIC XX.
       01  SF-TAB  PIC XX.
       01  AREE.
           05 MESS    PIC X(40).
           05 FUN     PIC X.
           05 IDX     PIC 9.
           05 SEZ     PIC 9.
           05 NUM     PIC 999.
           05 NUMC    PIC 999.
           05 EOF     PIC 9.
           05 LETTI   PIC 999.
           05 RIGRIF  PIC 999.
           05 NR      PIC 999.
           05 K1      PIC 999.
           05 KMAX    PIC 999   VALUE ZERO.
           05 TABK    PIC 9(5)  OCCURS 100.
           05 KRIFER  PIC X(30).
           05 LNSEZ   PIC 999.
           05 INCR    PIC S9.
           05 LF      PIC X     VALUE X'0A'.
      **** rel 6.2
           05 SWTROVA PIC 9.
      ************
           05 SWINI   PIC 9     VALUE ZERO.
      **** rel 6.1
           05 ASCII PIC 999 COMP.
           05 FILLER REDEFINES ASCII.
              10 FILLER PIC X.
              10 STR    PIC X.
      ************
       01  CODICE.
           05 MCLI    PIC 99.
           05 CCLI    PIC 9(5).
       LINKAGE SECTION.
           COPY 'griordrx-l'.
       01  IF-BUFF.
           05 SEZ1.
              10 RIG1 OCCURS 100.
      **** rel 5.0
                 15 TIPORD  PIC X.
      **** rel 6.1
      *          15 FILLER  PIC XX.
                 15 FILLER  PIC X.
      ************
      *          15 FILLER  PIC X.
      ************
                 15 COD1    PIC Z(5).
      **** rel 6.1
                 15 FILLER  PIC X.
                 15 PUBINT  PIC X.
      ************
                 15 FILLER  PIC X.
                 15 DAT     PIC X(8).
                 15 FILLER  PIC X.
                 15 CDCLI   PIC Z(5).
                 15 FILLER  PIC X.
                 15 RGSOC   PIC X(36).
      **** rel 6.2
                 15 FILLER  PIC X.
                 15 VSORD   PIC X(10).
                 15 FILLER  PIC X.
                 15 CODP    PIC Z(5).
      ************
                 15 LF1     PIC X.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING GS-ORD-SHARED
                                RX-ORD-CTRL
                                IF-BUFF
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclord'.
           COPY 'dclclf'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RX-ORD-ST RX-ORD-LETTI RX-ORD-NBYTE.
           MOVE SPACE TO IF-MESS.
           IF SWINI = ZERO PERFORM PGM-INI THRU EX-PGM-INI.
           MOVE GS-ORD-FUN TO FUN.
      *
      * funzioni che trattano record
           IF FUN = 'X'
              PERFORM CONTROLLA-POS
              MOVE ZERO TO GS-ORD-SEL
              MOVE TABK(RX-ORD-POS) TO GS-ORD-COD-1
              MOVE ZERO             TO GS-ORD-COD-2
              GO TO ESCI.
      *
           IF FUN NOT = 'Z' MOVE ZERO TO RX-ORD-EOF.
      *
      * funzioni che restituiscono buffer
           MOVE ZERO  TO RX-ORD-POS.
           MOVE GS-ORD-IDX TO IDX.
           MOVE GS-ORD-SEZ TO SEZ.
           MOVE RX-ORD-NUM TO NUM.
      **** rel 6.2
           IF FUN = 'F' OR 'L' OR 'C'
              MOVE ZERO TO SWTROVA.
           IF FUN = 'K'
              MOVE 1   TO SWTROVA
              MOVE 'F' TO FUN.
           IF SWTROVA > ZERO
              MOVE 20  TO NUM.
      ************
           IF NOT (FUN = 'F' OR 'L' OR 'C' OR 'B' OR 'T' OR 'Z')
              MOVE 'F' TO FUN.
           IF (FUN = 'B' OR 'T' OR 'Z') PERFORM CONTROLLA-KMAX.
           IF NOT (IDX = 1 OR 2) MOVE 1 TO IDX.
           IF SEZ = ZERO MOVE 1    TO SEZ.
           IF NUM = ZERO MOVE 80   TO NUM.
           IF FUN = 'T'  MOVE 1    TO RIGRIF.
           IF FUN = 'B'  MOVE KMAX TO RIGRIF.
           IF FUN = 'T' OR 'L'
              MOVE NUM TO NR
           ELSE
              MOVE 1   TO NR.
           MOVE NUM TO NUMC.
           IF FUN = 'C' COMPUTE NUMC = NUM / 2 + 1.

           OPEN INPUT ORDCLI.
           OPEN INPUT ANACLF.
      **** rel 6.2
           CALL 'vrpint' USING PARPINT.
      ************
           IF FUN = 'Z' PERFORM CAMBIA-SEZ THRU EX-CAMBIA-SEZ
                        GO TO QUIT1.
       INI00.
           MOVE ZERO TO EOF LETTI.
           IF FUN = 'T' OR 'L'
              MOVE -1  TO INCR
           ELSE
              MOVE 1   TO INCR.
           PERFORM MOVE-KEY THRU EX-MOVE-KEY.
           IF IDX = 1 PERFORM START-IDX1.
           IF IDX = 2 PERFORM START-IDX2.
           IF EOF > ZERO GO TO ENDATI.

      * cerca primo record nel range richiesto
       CERCA.
           PERFORM READ-N-P.
           IF EOF > ZERO GO TO ENDATI.
           IF FUN = 'F' OR 'L' OR 'C' GO TO CARBUF.
           IF IDX = 1 GO TO CER90.
      *    ( controlla tramite chiave primaria se il record letto da
      *      secondario e' quello richiesto )
           IF KEYOR NOT = KRIFER GO TO CERCA.
       CER90.
           PERFORM READ-N-P.
           IF EOF > ZERO GO TO ENDATI.

      * carica buffer
       CARBUF.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO ENDATI.
       CARB10.
           PERFORM MOVE-REC THRU EX-MOVE-REC.
           IF LETTI >= NUMC GO TO ENDATI.
           PERFORM READ-N-P.
           IF EOF > ZERO GO TO ENDATI.
           GO TO CARBUF.

      * fine ciclo di letture / caricamento buffer
       ENDATI.
           SUBTRACT INCR FROM NR.
           IF FUN = 'F' MOVE 1 TO RX-ORD-EOF.
           IF FUN = 'L' MOVE 3 TO RX-ORD-EOF.
           ADD EOF   TO RX-ORD-EOF.
           ADD LETTI TO RX-ORD-LETTI.
           IF RX-ORD-LETTI = NUM  GO TO QUIT.
           IF RX-ORD-EOF = 4 GO TO ENDBUF.

      * incontrato BOF/EOF prima di aver letto NUM records o
      *    funzione C da completare: shift buffer indietro/avanti
      *    e tenta di inserire altri record in coda/testa
           IF RX-ORD-LETTI > ZERO GO TO SHIFT.
           IF FUN = 'T' OR 'L'
              MOVE 'F' TO FUN
              MOVE 1   TO NR
           ELSE
              MOVE 'L' TO FUN
              MOVE NUM TO NR.
           MOVE NUM TO NUMC.
           GO TO INI00.
       SHIFT.
           IF FUN = 'T' OR 'L'
              PERFORM SHIFT-BUF-INDIETRO
              MOVE RX-ORD-LETTI TO RIGRIF
              COMPUTE NR = RIGRIF + 1
              MOVE 'B' TO FUN
           ELSE
              PERFORM SHIFT-BUF-AVANTI
              COMPUTE NR = NUM - RX-ORD-LETTI
              COMPUTE RIGRIF = NR + 1
              MOVE 'T' TO FUN.
           COMPUTE NUMC = NUM - RX-ORD-LETTI.
           GO TO INI00.

      * buffer completato
       ENDBUF.
           IF FUN = 'T' OR 'L' PERFORM SHIFT-BUF-INDIETRO.
           PERFORM BLANK-BUF.

       QUIT.
           MOVE RX-ORD-LETTI TO KMAX.
           IF RX-ORD-EOF = 4 MOVE 2 TO RX-ORD-EOF.
           IF RX-ORD-POS = ZERO
              IF FUN = 'T' OR 'L'
                 MOVE RX-ORD-LETTI TO RX-ORD-POS
              ELSE
                 MOVE 1 TO RX-ORD-POS.
       QUIT1.
           PERFORM LENGTH-SEZ.
           COMPUTE RX-ORD-NBYTE = LNSEZ * RX-ORD-LETTI.
           GO TO FINE.
      *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RX-ORD-ST.
       FINE.
           CLOSE ORDCLI.
           CLOSE ANACLF.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RX-ORD-ST.
           EXIT PROGRAM.
           COPY 'griorder'.
           COPY 'griclfer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *--------
      *LCK.
      *    MOVE ZERO TO X-WIND.
      *    CALL 'rxcnf' USING PARX CNFLCK.
      *    MOVE X-COD TO RISP.
      *    MOVE ZERO TO X-COD.
      *    MOVE SPACE TO X-COX.
      *    MOVE 1 TO X-ST.
      *EX-LCK.
      *    EXIT.
      *------------------
       CONTROLLA-KMAX.
           IF KMAX = ZERO
              MOVE 'VORDX10-L: Funzione non ammessa' TO MESS
              GO TO ERRIO.
      *------------------
       CONTROLLA-POS.
           PERFORM CONTROLLA-KMAX.
           IF RX-ORD-POS = ZERO OR RX-ORD-POS > KMAX
              MOVE 'VORDX10-L: Parametro POS non corretto' TO MESS
              GO TO ERRIO.
      *------------------
       SHIFT-BUF-INDIETRO.
           IF RX-ORD-POS = ZERO MOVE NUM TO RX-ORD-POS.
           MOVE 1 TO K1.
           PERFORM UNTIL K1 > RX-ORD-LETTI
              MOVE RIG1(NR) TO RIG1(K1)
              MOVE TABK(NR) TO TABK(K1)
              ADD 1 TO K1 NR
           END-PERFORM.
           COMPUTE RX-ORD-POS = RX-ORD-POS - ( NUM - RX-ORD-LETTI ).
      *------------------
       SHIFT-BUF-AVANTI.
           IF RX-ORD-POS = ZERO MOVE 1 TO RX-ORD-POS.
           MOVE NUM TO K1.
           PERFORM UNTIL NR = ZERO
              MOVE RIG1(NR) TO RIG1(K1)
              MOVE TABK(NR) TO TABK(K1)
              SUBTRACT 1 FROM K1 NR
           END-PERFORM.
           COMPUTE RX-ORD-POS = RX-ORD-POS + ( NUM - RX-ORD-LETTI ).
      *------------------
      * pulisce righe buffer non caricate
       BLANK-BUF.
           COMPUTE NR = RX-ORD-LETTI + 1.
           PERFORM UNTIL NR > NUM
              MOVE SPACE TO RIG1(NR)
              ADD 1 TO NR
           END-PERFORM.
      *------------------
       LENGTH-SEZ.
           IF RX-ORD-LETTI = ZERO
              MOVE ZERO TO LNSEZ
           ELSE
              MOVE 1 TO LNSEZ
              PERFORM UNTIL IF-BUFF(LNSEZ:1) = LF ADD 1 TO LNSEZ.
      *------------------
       START-IDX1.
           IF FUN = 'T' OR 'L'
              START ORDCLI KEY <= KEYOR INVALID MOVE 1 TO EOF
           ELSE
              START ORDCLI KEY >= KEYOR INVALID MOVE 3 TO EOF.
      *------------------
       START-IDX2.
           IF FUN = 'T' OR 'L'
              START ORDCLI KEY <= SKEYOR1 INVALID MOVE 1 TO EOF
           ELSE
              START ORDCLI KEY >= SKEYOR1 INVALID MOVE 3 TO EOF.
      *------------------
       READ-N-P.
           IF FUN = 'T' OR 'L'
              READ ORDCLI PREVIOUS INTO REKORD AT END MOVE 1 TO EOF
           ELSE
              READ ORDCLI NEXT INTO REKORD AT END MOVE 3 TO EOF.
      *------------------
       MOVE-KEY.
           MOVE LOW-VALUE TO KEYOR SKOR-CLI SKOR-NUM.
           IF FUN = 'L' MOVE HIGH-VALUE TO KEYOR SKOR-CLI SKOR-NUM.
      * caricamento campi chiave fissi
           MOVE GS-ORD-AZI TO KOR-AZI.
      * ---
           IF FUN = 'C'        GO TO MOVE-KEY-C.
           IF FUN = 'B' OR 'T' GO TO MOVE-KEY-N-P.
           GO TO EX-MOVE-KEY.
       MOVE-KEY-C.
           IF IDX = 1 MOVE GS-ORD-VAL-1  TO KOR-NUM.
           IF IDX = 2 MOVE GS-ORD-VAL-2  TO KOR-CLI
      **** rel 4.0-2
      *               MOVE ZERO          TO KOR-NUM.
                      MOVE GS-ORD-VAL-1  TO KOR-NUM.
      ************
           GO TO EX-MOVE-KEY.
       MOVE-KEY-N-P.
           MOVE TABK(RIGRIF) TO KOR-NUM.
           MOVE KEYOR TO KRIFER.
           IF IDX = 1 GO TO EX-MOVE-KEY.
      * acquisizione chiavi secondarie tramite lettura da primario
           READ ORDCLI INVALID MOVE ZERO TO KOR-CLI KOR-NUM.
       EX-MOVE-KEY.
           EXIT.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-ORD = LOW-VALUE GO TO EX-TEST-EOL.
           IF IDX > 1 GO TO TEST-EOL-IDX2.
           IF KOR-AZI = GS-ORD-AZI GO TO EX-TEST-EOL.
           IF FUN = 'T' OR 'L'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       TEST-EOL-IDX2.
           IF GS-ORD-FLUG = ZERO GO TO EX-TEST-EOL.
           IF KOR-CLI = GS-ORD-VAL-2 GO TO EX-TEST-EOL.
           IF FUN = 'T' OR 'L'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
       EX-TEST-EOL.
           EXIT.
      *------------------
       MOVE-REC.
           IF RF-ORD = LOW-VALUE GO TO EX-MOVE-REC.
      *
      *    ( inserire qui controlli se ci sono records
      *      da escludere prima di incontrare BOF/EOF:
      *      per skip record GO TO EX-MOVE-REC )
      *
           IF KOR-AZI NOT = GS-ORD-AZI GO TO EX-MOVE-REC.
      **** rel 6.2
           IF SWTROVA > ZERO
              MOVE ORD-VSORD    TO MC-STR
              MOVE GS-ORD-VAL-3 TO MC-EXP
              CALL 'rmatch' USING PARMC
              IF MC-ST > ZERO GO TO EX-MOVE-REC.
      ************
      **** rel 5.0
           MOVE KOR-AZI TO OC-AZI.
           MOVE KOR-NUM TO OC-NUM.
           CALL 'vrvopc' USING PAROC.
      ************
      *
       MOVE-SEZ1.
           MOVE SPACE      TO RIG1(NR).
      **** rel 5.0
           IF OC-FLG = ZERO
              MOVE SPACE TO TIPORD(NR)
      **** rel 6.2
              MOVE ZERO     TO PARORC
              MOVE KOR-AZI  TO PORC-AZI
              MOVE KOR-NUM  TO PORC-NUM
              CALL 'vrrdord' USING PARORC
              IF PORC-NOPC > ZERO
                 MOVE 'R'   TO TIPORD(NR)
                 MOVE PORC-NOPC TO CODP(NR)
              END-IF
      ************
           ELSE
              MOVE 'P'   TO TIPORD(NR).
      ************
           MOVE ORD-NUM    TO COD1(NR).
      **** rel 6.1
           PERFORM VER-LPD THRU EX-VER-LPD.
           IF PLPD-PROG > ZERO MOVE STR TO PUBINT(NR).
      ************
           MOVE ORD-CDCLI  TO CDCLI(NR).
           MOVE ORD-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA     TO DAT(NR).
           MOVE KOR-AZI    TO KCF-AZI.
           MOVE ORD-CDCLI  TO CCLI.
           MOVE CODICE     TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID
                       MOVE ALL '*' TO CLF-RGSOC.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-RGSOC  TO RGSOC(NR).
      **** rel 6.2
           MOVE ORD-VSORD TO VSORD(NR).
      ************
       MOVE-END.

           MOVE LF TO LF1(NR).
           MOVE KOR-NUM TO TABK(NR).
           ADD 1 TO LETTI.
           ADD INCR TO NR.
       EX-MOVE-REC.
           EXIT.
      *------------------
       PGM-INI.
           OPEN INPUT TABELL.
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           CLOSE TABELL.
      **** rel 6.1
           MOVE '149' TO ASCII.
      **** rel 6.2
      *    CALL 'vrpint' USING PARPINT.
      ************
      ************.
      *
           MOVE 1 TO SWINI.
       EX-PGM-INI.
           EXIT.
      *------------------
       CAMBIA-SEZ.
       EX-CAMBIA-SEZ.
           EXIT.
      *------------------
      **** rel 6.1
       VER-LPD.
           MOVE ZERO        TO PARLPD.
           MOVE 'R'         TO PLPD-FUN.
           MOVE KOR-AZI    TO PLPD-AZI.
           IF PINT-I-AZI NOT = SPACE
              MOVE PINT-I-AZI TO PLPD-AZI.
           MOVE 'INT'       TO PLPD-TIPO.
      *
           MOVE ORD-DAT   TO AAGGG.
           MOVE 2 TO TIPOP1
           CALL 'rdata' USING PARCDT.
           MOVE AA4         TO PLPD-ANNO.
      *
           MOVE KEYOR       TO PLPD-KEY.
           MOVE SPACE       TO PLPD-CATT.
           MOVE 'ORD'       TO PLPD-TDOC.
           CALL 'vrc-lpd' USING PARXCD PARLPD.
       EX-VER-LPD.
           EXIT.
      *------------------
      ************
