       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORWG10.
      *
      *    Interfaccia ORWCLI per scheda 
      *
      **** rel 6.1
      * Nuovo
      ************
      **** rel 6.2
      * Ricompilato
      ************
      **** rel 6.3
      * Ricompilato
      ************
      **** rel 7.1
      * Ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griclfsl'.
           COPY 'griartsl'.
           COPY 'gribansl'.
           COPY 'griirisl'.
           COPY 'gritabsl'.
           COPY 'gritowsl'.
           COPY 'griorwsl'.
           COPY 'gririwsl'.
           COPY 'grinrwsl'.
           COPY 'grinowsl'.
      **** rel 6.2
           COPY 'gririgsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griclf'.
           COPY 'griart'.
           COPY 'griban'.
           COPY 'griiri'.
           COPY 'gritab'.
           COPY 'gritow'.
           COPY 'griorw'.
           COPY 'gririw'.
           COPY 'grinrw'.
           COPY 'grinow'.
      **** rel 6.2
           COPY 'gririg'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'gritow01'.
           COPY 'grit28rk'.
           COPY 'grit35rk'.
           COPY 'rekt52'.
           COPY 'griclfrk'.
           COPY 'griartrk'.
           COPY 'griorwrk'.
           COPY 'gririwrk'.
      **** rel 6.2
           COPY 'gririgrk'.
      ************
           COPY 'parcdt'.
           COPY 'parer'.
           COPY 'parlk'.
           COPY 'parmb'.
           COPY 'parml'.
           COPY 'parzf'.
           COPY 'pardp'.
           COPY 'gririwrg'.
      *
           COPY 'parppar'.
           COPY 'parwcd'.
      **** rel 6.2
           COPY 'parorc'.
           COPY 'paroc'.
      ************
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-ART PIC X(15) VALUE 'magart'.
       01  ID-BAN PIC X(15) VALUE 'anaban'.
       01  ID-LIS PIC X(15) VALUE 'listin'.
       01  ID-IRI PIC X(15) VALUE 'indiri'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-TOW PIC X(15) VALUE 'taborw'.
       01  ID-ORW PIC X(15) VALUE 'orwcli'.
       01  ID-RIW PIC X(15) VALUE 'orwrig'.
       01  ID-NRW PIC X(15) VALUE 'nowrig'.
       01  ID-NOW PIC X(15) VALUE 'nowtes'.
      **** rel 6.2
       01  ID-RIG PIC X(15) VALUE 'ordrig'.
      ************
      *--------------------------------------------------------
      * costanti
      *    NRIGMAX: n. righe max note aggiuntive rigo cliente
       78  NRIGMAX VALUE 20.
      *--------------------------------------------------------
       01  COMODI.
           05 SF-CLF   PIC XX.
           05 SF-ART   PIC XX.
           05 SF-BAN   PIC XX.
           05 SF-LIS   PIC XX.
           05 SF-IRI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-TOW   PIC XX.
           05 SF-NRW   PIC XX.
           05 SF-NOW   PIC XX.
           05 SF-ORW   PIC XX.
           05 SF-RIW   PIC XX.
      **** rel 6.2
           05 SF-RIG   PIC XX.
      ************
      *
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(30).
           05 IF-AZI   PIC 9(3).
           05 CODCLI.
              10 MAS   PIC 99.
              10 COD   PIC 9(5).
           05 VAAGGG   PIC 9(5) COMP-3.
           05 SAVNUM  PIC 9(5) VALUE ZERO.
           05 COMEURO PIC 9(3) VALUE ZERO.
           05 VALUT   PIC 9(3) VALUE ZERO.
           05 KML      PIC 9(5).
           05 KVALID   PIC 9(5).
           05 KN       PIC 9(5).
           05 MAXRIGD  PIC ZZ9.
           05 FLGNOT   PIC 9.
           05 FLGVAR   PIC 9.
           05 COMDTCSR PIC 9(5) COMP-3.
           05 COMDTCSC PIC 9(5) COMP-3.
           05 OLDLCONS PIC 99.
      **** rel 6.2
           05 NUMOPC   PIC ZZZZ9.
           05 I        PIC 999.
      ************
      *
           COPY 'griordrg'.
           COPY 'gririgrg'.
       LINKAGE SECTION.
           COPY 'griorwrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-ORW-CTRL
                                RG-ORW-REC
                                RA-ORW-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclclf'.
           COPY 'dclart'.
           COPY 'dclban'.
           COPY 'dcliri'.
           COPY 'dcltab'.
           COPY 'dclorw'.
           COPY 'dclriw'.
           COPY 'dclnrw'.
           COPY 'dclnow'.
      **** rel 6.2
           COPY 'dclrig'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-ORW-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-ORW-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-ORW-FUN   TO FUN.
           MOVE RG-ORW-IDX   TO IDX.
           MOVE RG-ORW-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-ORW-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'w' PERFORM CONFERMA THRU EX-CONFERMA 
                        GO TO FINE.
           IF FUN = 'o' PERFORM NO-WEB THRU EX-NO-WEB 
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vorwg10: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-ORW-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-ORW-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-ORW-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK ORWCLI.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-ORW INVALID
              PERFORM INVK-ORW
              GO TO ERRIO.
           PERFORM DL-WR-NOTE THRU EX-DL-WR-NOTE.
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-ORW INVALID
              PERFORM INVK-ORW
              GO TO ERRIO.
      *
           IF (COMDTCSC NOT = ORW-DTCSC)
              PERFORM MOD-DAT-RIG THRU EX-MOD-DAT-RIG.
      *
           IF TOW01-FLGN NOT = ZERO AND RA-ORW-NOTE1 = SPACE
              PERFORM VERIFICA-VARIAZIONI THRU EX-VERIFICA-VARIAZIONI.
      *
           PERFORM DL-WR-NOTE THRU EX-DL-WR-NOTE.
      *
           UNLOCK ORWCLI.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-ORW
              GO TO WARNING.
           IF RG-ORW-ST = 7 GO TO FINE.
      **** rel 6.2
           IF ORW-FLGTEL NOT = 2 
              MOVE 'Ordine non manuale' TO F-MES1
              MOVE 1 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB
              UNLOCK ORWCLI
              GO TO FINE.
      **********
      *
           PERFORM C00-DEL-RIG THRU C99.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM DL-NOTE-T0 THRU EX-DL-NOTE-T0.
           PERFORM DL-NOTE-T1 THRU EX-DL-NOTE-T1.
           DELETE ORWCLI INVALID
              PERFORM INVK-ORW
              GO TO ERRIO.
           UNLOCK ORWCLI.
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-ORW-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK ORWCLI.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-ORW-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANACLF ANABAN INDIRI TABORW.
           CLOSE TABELL MAGART ORWCLI ORWRIG.
           CLOSE NOWRIG NOWTES.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-ORW-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-ORW-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'erreur'.
           COPY 'griclfer'.
           COPY 'griarter'.
           COPY 'gribaner'.
           COPY 'griirier'.
           COPY 'gritaber'.
           COPY 'gritower'.
           COPY 'griorwer'.
           COPY 'gririwer'.
           COPY 'grinrwer'.
           COPY 'grinower'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN INPUT ANACLF ANABAN INDIRI.
           OPEN I-O TABELL MAGART ORWCLI ORWRIG NOWRIG TABORW NOWTES.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
      *
           MOVE RG-ORW-AZI TO KTOW-AZI.
           MOVE 1          TO KTOW-TIP.
           READ TABORW INTO REKTOW01 INVALID
                PERFORM INVK-TOW
                GO TO ERRIO.
           IF SF-TOW = '9D' OR '9A' OR '35' MOVE RF-TOW TO REKTOW01.
      *
           CALL 'rveur' USING COMEURO.
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-ORW-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-ORW REKORW.
           MOVE ZERO TO ORW-DAT ORW-DTCSR ORW-DTCSC ORW-CATT ORW-LISRF.
           MOVE SPACE TO ORW-ZONA ORW-VSORD ORW-COMME ORW-IDFILE.
      *
           MOVE REKORW TO RF-ORW.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-ORW-AZI TO IF-AZI.

      * azzeramento aree interfaccia
           MOVE ZERO  TO RG-ORW-REC.
           MOVE SPACE TO RG-ORW-ZONA RG-ORW-VSORD RG-ORW-COMME.
           MOVE SPACE TO RA-ORW-AGG.
           MOVE ZERO  TO RA-ORW-FLGNOTE.
           PERFORM AZZ-NOTE.
           PERFORM AZZ-NOTE1.

      * ripristino dei campi chiave fissi
           MOVE IF-AZI TO RG-ORW-AZI.
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
      **** rel 6.2
      *    MOVE 28         TO T28-TIP.
      *    MOVE RG-ORW-AZI TO T28-COD.
      *    MOVE 'W'        TO T28-PRG.
      *    MOVE T28-KEYID TO KEYTB.
      *RD1-TB28W.
      *    READ TABELL INTO REKT28 KEPT LOCK INVALID
      *                                      PERFORM INVK-TAB
      *                                      GO TO ERRIO.
      *    IF SF-TAB = '9D' OR '9A' OR '35'
      *                      PERFORM REC-LOCK
      *                      GO TO RD1-TB28W.
      *    COMPUTE RG-ORW-NUM = T28-NORDC + 1.
      *
           MOVE RG-ORW-AZI TO KTOW-AZI.
           MOVE 1          TO KTOW-TIP.
       RD-TOW.
           READ TABORW INTO REKTOW01 KEPT LOCK INVALID
                                             PERFORM INVK-TOW
                                             GO TO ERRIO.
           IF SF-TOW = '9D' OR '9A' OR '35'
                             PERFORM REC-LOCK
                             GO TO RD-TOW.
           COMPUTE RG-ORW-NUM = TOW01-NUMOW + 1.
           MOVE TOW01-DEP   TO RG-ORW-CDEP.
           MOVE 2   TO RG-ORW-FLGTEL.
      **********
      *
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO RG-ORW-DAT.
           MOVE AA9 TO GG9.
           MOVE RG-ORW-DAT TO AA9.
           MOVE GGMMAA TO RG-ORW-DAT.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
      **** rel 6.2
      *    IF RG-ORW-NUM NOT > T28-NORDC GO TO INS-OK-90.
      *    MOVE RG-ORW-NUM TO T28-NORDC.
      *    REWRITE RF-TAB FROM REKT28 INVALID
      *                   PERFORM INVK-TAB
      *                   GO TO ERRIO.
           IF RG-ORW-NUM NOT > TOW01-NUMOW GO TO INS-OK-90.
           MOVE RG-ORW-NUM TO TOW01-NUMOW.
           REWRITE RF-TOW FROM REKTOW01 INVALID
                          PERFORM INVK-TOW
                          GO TO ERRIO.
      **********
       INS-OK-90.
      **** rel 6.2
      *    UNLOCK TABELL.
           UNLOCK TABORW.
      **********
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
      **** rel 6.2
      *    MOVE 28         TO T28-TIP.
      *    MOVE RG-ORW-AZI TO T28-COD.
      *    MOVE 'W'        TO T28-PRG.
      *    MOVE T28-KEYID TO KEYTB.
      *RD2-TB28W.
      *    READ TABELL INTO REKT28 KEPT LOCK INVALID
      *                                      PERFORM INVK-TAB
      *                                      GO TO ERRIO.
      *    IF SF-TAB = '9D' OR '9A' OR '35'
      *                      PERFORM REC-LOCK
      *                      GO TO RD2-TB28W.
      *    IF RG-ORW-NUM NOT = T28-NORDC GO TO ULCKT.
      *    SUBTRACT 1 FROM T28-NORDC.
      *    REWRITE RF-TAB FROM REKT28 INVALID
      *                   PERFORM INVK-TAB
      *                   GO TO ERRIO.
           MOVE RG-ORW-AZI TO KTOW-AZI.
           MOVE 1          TO KTOW-TIP.
       RD-TOW01. 
           READ TABORW INTO REKTOW01 KEPT LOCK INVALID
                                             PERFORM INVK-TOW
                                             GO TO ERRIO.
           IF SF-TOW = '9D' OR '9A' OR '35'
                             PERFORM REC-LOCK
                             GO TO RD-TOW01.

           IF RG-ORW-NUM NOT = TOW01-NUMOW GO TO ULCKT.
           SUBTRACT 1 FROM TOW01-NUMOW.
           REWRITE RF-TOW FROM REKTOW01 INVALID
                          PERFORM INVK-TOW
                          GO TO ERRIO.
      **********
       ULCKT.
      **** rel 6.2
      *    UNLOCK TABELL.
           UNLOCK TABORW.
      **********
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-ORW-AZI TO KOW-AZI.
           MOVE RG-ORW-NUM TO KOW-NUM.
           MOVE KEYOW TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYOW.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ ORWCLI INTO REKORW INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-ORW = '9D' OR '9A' OR '35' MOVE RF-ORW TO REKORW.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ ORWCLI INTO REKORW KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-ORW > ZERO MOVE 7 TO RG-ORW-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
      * posizionamento su chiave secondaria per successive
      * read next/previous
      *
       SET-KEYSEC.
           MOVE KEYOW TO KRIFER.
           IF IDX = 2
              START ORWCLI KEY >= SKEYOW1 INVALID GO TO SET-90
           ELSE
              START ORWCLI KEY >= SKEYOW2 INVALID GO TO SET-90.
       SET-10.
           READ ORWCLI NEXT INTO REKORW AT END GO TO SET-90.
           IF KEYOW = KRIFER GO TO EX-SET-KEYSEC.
           GO TO SET-10.
       SET-90.
           MOVE 'vorwg10: errore di posizionamento su' TO F-MES1.
           MOVE 'chiave secondaria'                   TO F-MES2.
           MOVE 2 TO F-NMES.
           GO TO ERRIO.
       EX-SET-KEYSEC.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
           IF IDX > 1 PERFORM SET-KEYSEC THRU EX-SET-KEYSEC.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ ORWCLI PREVIOUS INTO REKORW AT END MOVE 1 TO EOF
           ELSE
              READ ORWCLI NEXT INTO REKORW AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-ORW = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *
           IF KOW-AZI NOT = RG-ORW-AZI GO TO RNP-10.

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-ORW-EOF.
           MOVE KEYOW TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-ORW-EOF.
           IF RG-ORW-EOF = 4 MOVE 2 TO RG-ORW-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-ORW = LOW-VALUE GO TO EX-TEST-EOL.
           IF IDX > 1 GO TO TEST-EOL-IDX2.
           IF KOW-AZI = RG-ORW-AZI GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       TEST-EOL-IDX2.
           IF IDX > 2 GO TO TEST-EOL-IDX3.
           GO TO EX-TEST-EOL.
       TEST-EOL-IDX3.
           IF KOW-AZI = RG-ORW-AZI GO TO EX-TEST-EOL.
           IF FUN = 'T' OR 'L'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-ORW-AZI     TO ORW-AZI.
           MOVE RG-ORW-NUM     TO ORW-NUM.
           MOVE RG-ORW-DAT TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ORW-DAT.
           MOVE RG-ORW-CDCLI   TO ORW-CDCLI.
           MOVE RG-ORW-ZONA    TO ORW-ZONA.
           MOVE RG-ORW-CDAGE   TO ORW-CDAGE.
           MOVE RG-ORW-PROVV   TO ORW-PROVV.
           MOVE RG-ORW-CDPAG   TO ORW-CDPAG.
           MOVE RG-ORW-CDBAN   TO ORW-CDBAN.
           MOVE RG-ORW-CDSPE   TO ORW-CDSPE.
           MOVE RG-ORW-VETT    TO ORW-VETT.
           MOVE RG-ORW-CDPOR   TO ORW-CDPOR.
           MOVE RG-ORW-PERSC   TO ORW-PERSC.
           MOVE RG-ORW-DTCSR TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ORW-DTCSR.
           MOVE RG-ORW-DTCSC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ORW-DTCSC.
           MOVE RG-ORW-CDESE   TO ORW-CDESE.
           MOVE RG-ORW-VSORD   TO ORW-VSORD.
           MOVE RG-ORW-COMME   TO ORW-COMME.
           MOVE RG-ORW-CDEP    TO ORW-CDEP.
           MOVE RG-ORW-VALUT   TO ORW-VALUT.
           MOVE RG-ORW-LCONS   TO ORW-LCONS.
           MOVE RG-ORW-CATT    TO ORW-CATT.
           MOVE RG-ORW-LISRF   TO ORW-LISRF.
           MOVE RG-ORW-NOFF    TO ORW-NOFF.
      *
           MOVE RG-ORW-NORPRI  TO ORW-NORPRI.
           MOVE 1 TO TIPOP1.
           MOVE RG-ORW-DTVSORD TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG         TO ORW-DTVSORD.
      *
      *> rif. n. ordine/data Web
           MOVE RG-ORW-NORWEB TO ORW-NORWEB.
           MOVE 1 TO TIPOP1.
           MOVE RG-ORW-DTWEB TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG         TO ORW-DTWEB.
      *
           MOVE RG-ORW-UTENTE TO ORW-UTENTE.
      **** rel 6.2  
           IF FUN = 'S'  MOVE 2 TO ORW-FLGTEL
                         MOVE ZERO TO ORW-ESTER.
      **********
      *
           MOVE REKORW TO RF-ORW.
      *
           MOVE NRIGMAX TO ML-MAXRIG.
           MOVE 30      TO ML-LUNRIG.
           MOVE 1       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-ORW-NOTE1.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE ORW-AZI     TO RG-ORW-AZI.
           MOVE ORW-NUM     TO RG-ORW-NUM.
           MOVE ORW-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-ORW-DAT.
           MOVE ORW-CDCLI   TO RG-ORW-CDCLI.
           MOVE ORW-ZONA    TO RG-ORW-ZONA.
           MOVE ORW-CDAGE   TO RG-ORW-CDAGE.
           MOVE ORW-PROVV   TO RG-ORW-PROVV.
           MOVE ORW-CDPAG   TO RG-ORW-CDPAG.
           MOVE ORW-CDBAN   TO RG-ORW-CDBAN.
           MOVE ORW-CDSPE   TO RG-ORW-CDSPE.
           MOVE ORW-VETT    TO RG-ORW-VETT.
           MOVE ORW-CDPOR   TO RG-ORW-CDPOR.
           MOVE ORW-PERSC   TO RG-ORW-PERSC.
      *
           MOVE ORW-DTCSR TO AAGGG COMDTCSR.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-ORW-DTCSR.
           MOVE ORW-DTCSC TO AAGGG COMDTCSC.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-ORW-DTCSC.
      *
           MOVE ORW-CDESE   TO RG-ORW-CDESE.
           MOVE ORW-VSORD   TO RG-ORW-VSORD.
           MOVE ORW-COMME   TO RG-ORW-COMME.
           MOVE ORW-CDEP    TO RG-ORW-CDEP.
           MOVE ORW-VALUT   TO RG-ORW-VALUT.
           MOVE ORW-LCONS   TO RG-ORW-LCONS.
           MOVE ORW-CATT    TO RG-ORW-CATT.
           MOVE ORW-LISRF   TO RG-ORW-LISRF.
           MOVE ORW-NOFF    TO RG-ORW-NOFF.
      *
           MOVE ORW-NORPRI  TO RG-ORW-NORPRI.
      *
           MOVE 2 TO TIPOP1.
           MOVE ORW-DTVSORD TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA      TO RG-ORW-DTVSORD.
      *
      * Rif. n. ord./data Web
           MOVE ORW-NORWEB  TO RG-ORW-NORWEB.
           MOVE 2 TO TIPOP1.
           MOVE ORW-DTWEB  TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA      TO RG-ORW-DTWEB.
      *
           MOVE ORW-UTENTE  TO RG-ORW-UTENTE.
      **** rel 6.2
           MOVE ORW-FLGTEL  TO RG-ORW-FLGTEL.
      ************
      *
           MOVE ORW-LCONS   TO OLDLCONS.
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           MOVE RG-ORW-AZI TO KCF-AZI.
           MOVE RG-ORW-CDCLI TO COD.
           MOVE CODCLI TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY
                               MOVE ALL '*' TO CLF-RGS
                               MOVE SPACE   TO CLF-RGS2
      **** rel 6.2
                               MOVE ZERO    TO CLF-GGS
      ************
                               MOVE ZERO TO CLF-VAL.
           MOVE CLF-VAL  TO VALUT.
           MOVE CLF-RGS  TO RA-ORW-CDCLI-D.
           MOVE CLF-RGS2 TO RA-ORW-CDCLI-D1.
       RVID.
           IF RG-ORW-CATT = ZERO
              MOVE 'ATTIVITA'' PRINCIPALE' TO RA-ORW-CATT-D
              GO TO RVID1.
           MOVE 35          TO T35-TIP.
           MOVE RG-ORW-AZI  TO T35-CDAZ.
           MOVE RG-ORW-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                MOVE 'ATTIVITA'' INESISTENTE' TO T35-DATT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE T35-DATT TO RA-ORW-CATT-D.
       RVID1.
           IF RG-ORW-ZONA = SPACE MOVE SPACE TO RA-ORW-ZONA-D
                         GO TO RVID-10.
           MOVE 17 TO T17-TIP.
           MOVE RG-ORW-ZONA TO T17-COD.
           MOVE T17-KEYID TO KEYTB.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-ZONA-D.
       RVID-10.
           MOVE RG-ORW-CDEP TO KTB-COD.
           MOVE 12 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-CDEP-D.
      *
           MOVE RG-ORW-CDAGE TO KTB-COD.
           MOVE 9 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-CDAGE-D.
      *
           IF KOW-AZI = ZERO MOVE T09-XCPR TO RG-ORW-PROVV.
      *
           MOVE RG-ORW-CDPAG TO KTB-COD.
           MOVE 4 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-CDPAG-D.
           IF RG-ORW-CDESE = ZERO
               MOVE 'SOGGETTO A IVA' TO RA-ORW-CDESE-D GO TO RVID-20.
      *
           MOVE RG-ORW-CDESE TO KTB-COD.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-CDESE-D.
       RVID-20.
           MOVE RG-ORW-CDSPE TO KTB-COD.
           MOVE 6 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-CDSPE-D.
      *
           MOVE SPACE TO RA-ORW-VETT-D.
           IF RG-ORW-VETT NOT = ZERO
              MOVE RG-ORW-VETT TO KTB-COD
              MOVE 8 TO KTB-TIP
              READ TABELL INTO REKTAB INVALID
                   MOVE ALL '*' TO TAB-DESCR
              END-READ
              IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB
              END-IF
              MOVE TAB-DESCR TO RA-ORW-VETT-D.
      *
           MOVE RG-ORW-CDPOR TO KTB-COD.
           MOVE 5 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-CDPOR-D.
      *
           IF RG-ORW-CDBAN = ZERO
              MOVE SPACE TO RA-ORW-CDBAN-D
              GO TO RVID-25.
           MOVE RG-ORW-CDBAN TO KBA-BAN.
           READ ANABAN INVALID
                MOVE ALL '*' TO BAN-RGSOC.
           MOVE BAN-RGSOC TO RA-ORW-CDBAN-D.
       RVID-25.
           IF RG-ORW-LCONS = ZERO
              MOVE SPACE TO RA-ORW-LCONS-D
              GO TO RVID-30.
           MOVE RG-ORW-AZI   TO KII-AZI.
           MOVE MAS          TO KII-MS.
           MOVE RG-ORW-CDCLI TO KII-CD.
           MOVE RG-ORW-LCONS TO KII-PRG.
           READ INDIRI INVALID KEY
                MOVE 'D' TO IRI-TIPO
      **** rel 6.2
                MOVE ZERO TO IRI-GGS
      ************
                MOVE ALL '*' TO IRI-RGSOC.
           IF IRI-TIPO = 'D' MOVE IRI-RGSOC TO RA-ORW-LCONS-D
              ELSE IF IRI-TIPO = 'L' MOVE IRI-DESDI TO RA-ORW-LCONS-D
                   ELSE MOVE ALL '*' TO RA-ORW-LCONS-D.
       RVID-30.
           IF RG-ORW-VALUT = ZERO MOVE SPACE TO RA-ORW-VALUT-D
                                  GO TO RVID-40.
           MOVE 10 TO KTB-TIP.
           MOVE RG-ORW-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO RA-ORW-VALUT-D.
       RVID-40.
           IF RG-ORW-LISRF NOT > 3
              MOVE SPACE TO RA-ORW-LISRF-D
                            RA-ORW-LISRF-D1
              GO TO RVID-50.
           MOVE RG-ORW-LISRF TO KTB-COD.
           MOVE 52           TO KTB-TIP.
           READ TABELL INTO REKT52 INVALID
                MOVE ALL '*' TO RA-ORW-LISRF-D
                                RA-ORW-LISRF-D1
                GO TO RVID-50.
           MOVE SPACE TO RA-ORW-LISRF-D1.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT52.
           IF (RG-ORW-VALUT = ZERO OR COMEURO) AND T52-VALUT = ZERO
              MOVE SPACE TO RA-ORW-LISRF-D
                            RA-ORW-LISRF-D1
              GO TO RVID-40-10.
           MOVE 10        TO KTB-TIP.
           MOVE T52-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO RA-ORW-LISRF-D.
       RVID-40-10.
           IF T52-DTDEC = ZERO AND T52-DTVAL = ZERO
              MOVE T52-DESCR TO RA-ORW-LISRF-D1
              GO TO RVID-50.
           MOVE RG-ORW-DAT TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AAGGG  < T52-DTDEC OR > T52-DTVAL
              MOVE '* NON IN VIGORE *' TO RA-ORW-LISRF-D1
           ELSE  MOVE T52-DESCR TO RA-ORW-LISRF-D1.
       RVID-50.
           PERFORM RD-NOTEW THRU EX-RD-NOTEW.
      *
           MOVE ZERO TO RA-ORW-FLGNOTE.
           IF RA-ORW-NOTE1 NOT= SPACE OR RA-ORW-NOTE NOT = SPACE
              MOVE 1 TO RA-ORW-FLGNOTE.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-ORW-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
       V-NUM.
           MOVE 'ORW-NUM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NUM.
           IF RG-ORW-NUM = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-NUM.
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-ORW-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-CATT.
           MOVE 'ORW-CATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CATT.
           IF RG-ORW-CATT = ZERO
              MOVE "ATTIVITA' PRINCIPALE" TO RA-ORW-CATT-D
              GO TO E-CATT.
           IF RG-ORW-CATT > 8
              PERFORM ERR-DINV
              GO TO V-ERROR.
           MOVE 35          TO T35-TIP.
           MOVE RG-ORW-AZI  TO T35-CDAZ.
           MOVE RG-ORW-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID
              MOVE SPACE TO RA-ORW-CATT-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE T35-DATT TO RA-ORW-CATT-D.
       E-CATT.
      *
       V-DAT.
           MOVE 'ORW-DAT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DAT.
           IF RG-ORW-DAT = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE RG-ORW-DAT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DAT.
      *
       V-CDEP.
           MOVE 'ORW-CDEP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDEP.
           IF RG-ORW-CDEP = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE RG-ORW-CDEP TO KTB-COD.
           MOVE 12 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE SPACE TO RA-ORW-CDEP-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-CDEP-D.
       E-CDEP.
      *
       V-CDCLI.
           MOVE 'ORW-CDCLI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDCLI.
           IF RG-ORW-CDCLI = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF RG-ORW-CDCLI = ORW-CDCLI GO TO E-CDCLI.
           MOVE RG-ORW-CDCLI TO COD.
           MOVE CODCLI TO KCF-COD.
           MOVE RG-ORW-AZI TO KCF-AZI.
           READ ANACLF INTO REKCLF INVALID KEY
              MOVE SPACE TO RA-ORW-CDCLI-D
              MOVE SPACE TO RA-ORW-CDCLI-D1
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-RGS  TO RA-ORW-CDCLI-D.
           MOVE CLF-RGS2 TO RA-ORW-CDCLI-D1.
      *
           IF FUN NOT = 'V' GO TO E-CDCLI.
           MOVE ZERO TO RG-ORW-LCONS RG-ORW-PROVV.
           MOVE CLF-ZONA TO RG-ORW-ZONA.
           MOVE CLF-AGEN TO RG-ORW-CDAGE.
           MOVE CLF-CPAG TO RG-ORW-CDPAG.
           MOVE CLF-PORT TO RG-ORW-CDPOR.
           MOVE CLF-VETT TO RG-ORW-VETT.
           MOVE CLF-MSPE TO RG-ORW-CDSPE.
           MOVE CLF-ESEN TO RG-ORW-CDESE.
           MOVE CLF-BANC TO RG-ORW-CDBAN.
           MOVE CLF-SCBS TO RG-ORW-PERSC.
           MOVE CLF-VAL  TO RG-ORW-VALUT.
           MOVE CLF-VAL  TO VALUT.
           IF CLF-LIS NOT = ZERO
              MOVE CLF-LIS TO RG-ORW-LISRF
           ELSE
              MOVE CLF-TPRZ TO RG-ORW-LISRF.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
       E-CDCLI.
      *
       V-ZONA.
           MOVE 'ORW-ZONA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ZONA.
           IF RG-ORW-ZONA = SPACE MOVE SPACE TO RA-ORW-ZONA-D
                         GO TO E-ZONA.
           MOVE 17          TO T17-TIP.
           MOVE RG-ORW-ZONA TO T17-COD.
           MOVE T17-KEYID   TO KEYTB.
           READ TABELL INTO REKTAB INVALID KEY
              MOVE SPACE TO RA-ORW-ZONA-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-ZONA-D.
       E-ZONA.
      *
       V-CDAGE.
           MOVE 'ORW-CDAGE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDAGE.
           MOVE RG-ORW-CDAGE TO KTB-COD.
           MOVE 9 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE SPACE TO RA-ORW-CDAGE-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-CDAGE-D.
           IF FUN NOT = 'V' GO TO E-CDAGE.
           IF RG-ORW-CDAGE NOT = ORW-CDAGE
               MOVE T09-XCPR TO RG-ORW-PROVV.
       E-CDAGE.
      *
       V-CDPAG.
           MOVE 'ORW-CDPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDPAG.
           MOVE RG-ORW-CDPAG TO KTB-COD.
           MOVE 4 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              MOVE SPACE TO RA-ORW-CDPAG-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-CDPAG-D.
       E-CDPAG.
      *
       V-CDESE.
           MOVE 'ORW-CDESE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDESE.
           IF RG-ORW-CDESE = ZERO
               MOVE 'SOGGETTO A IVA' TO RA-ORW-CDESE-D
               GO TO E-CDESE.
           MOVE RG-ORW-CDESE TO KTB-COD.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE SPACE TO RA-ORW-CDESE-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-ALIVA NOT = ZERO
              MOVE SPACE TO RA-ORW-CDESE-D
              PERFORM ERR-CODI
              GO TO V-ERROR.
           MOVE TAB-DESCR TO RA-ORW-CDESE-D.
       E-CDESE.
      *
       V-CDPOR.
           MOVE 'ORW-CDPOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDPOR.
           MOVE RG-ORW-CDPOR TO KTB-COD.
           MOVE 5 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              MOVE SPACE TO RA-ORW-CDPOR-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-CDPOR-D.
       E-CDPOR.
      *
       V-CDSPE.
           MOVE 'ORW-CDSPE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDSPE.
           MOVE RG-ORW-CDSPE TO KTB-COD.
           MOVE 6 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              MOVE SPACE TO RA-ORW-CDSPE-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-CDSPE-D.
       E-CDSPE.
      *
       V-VETT.
           MOVE 'ORW-VETT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-VETT.
           MOVE RG-ORW-VETT TO KTB-COD.
           MOVE 8 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              MOVE SPACE TO RA-ORW-VETT-D
              GO TO E-VETT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORW-VETT-D.
       E-VETT.
      *
       V-CDBAN.
           MOVE 'ORW-CDBAN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDBAN.
           MOVE RG-ORW-CDPAG TO KTB-COD.
           MOVE 4 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              MOVE ZERO TO T04-TIPAG.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T04-TIPAG = 1 OR 2 GO TO RDBAN.
           IF RG-ORW-CDBAN = ZERO
              MOVE SPACE TO RA-ORW-CDBAN-D
              GO TO E-CDBAN.
       RDBAN.
           MOVE RG-ORW-CDBAN TO KBA-BAN.
           READ ANABAN INVALID
              MOVE SPACE TO RA-ORW-CDBAN-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           MOVE BAN-RGSOC TO RA-ORW-CDBAN-D.
       E-CDBAN.
      *
       V-DTCSR.
           MOVE 'ORW-DTCSR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCSR.
           IF RG-ORW-DTCSR = ZERO GO TO E-DTCSR.
           MOVE 1 TO TIPOP1.
           MOVE RG-ORW-DTCSR TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO VAAGGG.
           MOVE 1 TO TIPOP1.
           MOVE RG-ORW-DAT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF VAAGGG < AAGGG
              MOVE 'Data consegna minore di data ordine' TO MESS
              GO TO V-ERROR.
       E-DTCSR.
      *
       V-DTCSC.
           MOVE 'ORW-DTCSC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCSC.
           IF RG-ORW-DTCSC = ZERO GO TO E-DTCSC.
           MOVE 1 TO TIPOP1.
           MOVE RG-ORW-DTCSC TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO VAAGGG.
           MOVE 1 TO TIPOP1.
           MOVE RG-ORW-DAT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF VAAGGG < AAGGG
              MOVE 'Data consegna minore di data ordine' TO MESS
              GO TO V-ERROR.
       E-DTCSC.
      *
       V-LCONS.
           MOVE 'ORW-LCONS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-LCONS.
           IF RG-ORW-LCONS = ZERO
              MOVE SPACE TO RA-ORW-LCONS-D
              GO TO E-LCONS.
           MOVE RG-ORW-AZI   TO KII-AZI.
           MOVE MAS          TO KII-MS.
           MOVE RG-ORW-CDCLI TO KII-CD.
           MOVE RG-ORW-LCONS TO KII-PRG.
           READ INDIRI INVALID
              MOVE SPACE TO RA-ORW-LCONS-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF IRI-TIPO = 'D' MOVE IRI-RGSOC TO RA-ORW-LCONS-D
              ELSE IF IRI-TIPO = 'L' MOVE IRI-DESDI TO RA-ORW-LCONS-D
                   ELSE MOVE SPACE TO RA-ORW-LCONS-D
                        MOVE 'Tipo indirizzo non valido' TO MESS
                        GO TO V-ERROR.
       E-LCONS.
      *
       V-VALUT.
           MOVE 'ORW-VALUT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-VALUT.
           IF RG-ORW-VALUT = ZERO
              MOVE SPACE TO RA-ORW-VALUT-D
              GO TO E-VALUT.
      *
           MOVE RG-ORW-VALUT TO ER-VALUT.
           MOVE RG-ORW-DAT  TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ER-DATA
           CALL 'rvalut' USING ER-VALUT ER-DATA CG-PAR.
           MOVE CG-DSINT TO RA-ORW-VALUT-D.
           IF CG-ST > ZERO PERFORM ERR-EURO
                           GO TO V-ERROR.
       E-VALUT.
      *
       V-LISRF.
           MOVE 'ORW-LISRF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-LISRF.
           MOVE SPACE TO RA-ORW-LISRF-D
                         RA-ORW-LISRF-D1.
           IF RG-ORW-LISRF NOT > 3 GO TO E-LISRF.
           MOVE RG-ORW-LISRF TO KTB-COD.
           MOVE 52           TO KTB-TIP.
           READ TABELL INTO REKT52 INVALID
                MOVE 'Listino inesistente' TO MESS
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT52.
           IF ( NOT (RG-ORW-VALUT = ZERO OR COMEURO) AND
                    (T52-VALUT NOT = RG-ORW-VALUT))   OR
              (RG-ORW-VALUT = ZERO OR COMEURO) AND T52-VALUT NOT = ZERO
                  MOVE 'Valuta diversa su listino' TO MESS
                  GO TO V-ERROR.
           IF (RG-ORW-VALUT = ZERO OR COMEURO) AND T52-VALUT = ZERO
              GO TO V-LISRF-10.
           MOVE 10        TO KTB-TIP.
           MOVE T52-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO RA-ORW-LISRF-D.
       V-LISRF-10.
           IF T52-DTDEC = ZERO AND T52-DTVAL = ZERO
              MOVE T52-DESCR TO RA-ORW-LISRF-D1
              GO TO E-LISRF.
           MOVE RG-ORW-DAT TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AAGGG  < T52-DTDEC OR > T52-DTVAL
              MOVE '* NON IN VIGORE *' TO RA-ORW-LISRF-D1
           ELSE  MOVE T52-DESCR TO RA-ORW-LISRF-D1.
       E-LISRF.
      *
       V-DTVSORD.
           MOVE 'ORW-DTVSORD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTVSORD.
           MOVE 1 TO TIPOP1.
           MOVE RG-ORW-DTVSORD TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTVSORD.
      *
       V-NOTE1.
           MOVE 'ORW-NOTE1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NOTE1.
           MOVE NRIGMAX TO ML-MAXRIG.
           MOVE 30      TO ML-LUNRIG.
           MOVE 0       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-ORW-NOTE1.
           IF ML-ST = 1
              MOVE SPACE TO F-MES2
              MOVE 'E'' possibile caricare' TO F-MES1
              MOVE NRIGMAX TO MAXRIGD
              STRING 'al massimo ' MAXRIGD ' righe'
                     DELIMITED SIZE INTO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
      * accende/spegne bottone presenza note aggiuntive
           MOVE ZERO TO RA-ORW-FLGNOTE.
           IF RA-ORW-NOTE1 NOT= SPACE OR RA-ORW-NOTE NOT = SPACE
              MOVE 1 TO RA-ORW-FLGNOTE.
      *
           IF RA-ORW-NOTE1 = SPACE GO TO E-NOTE1.
      *
           MOVE NRIGMAX TO KVALID.
           PERFORM UNTIL RA-ORW-RIGNOT1(KVALID) NOT = SPACE
              SUBTRACT 1 FROM KVALID
           END-PERFORM.
       E-NOTE1.
      ************
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       C00-DEL-RIG.
           MOVE KOW-AZI TO KRW-AZI KMA-AZI.
           MOVE KOW-NUM TO KRW-NUM.
           MOVE ZERO TO KRW-PRG.
           START ORWRIG KEY NOT < KEYRW INVALID GO TO C99.
       C10.
           READ ORWRIG NEXT INTO REKRIW AT END GO TO C99.
           IF SF-RIW = '9D' OR '9A' OR '35' GO TO C10.
           IF KRW-AZI NOT = KOW-AZI GO TO C99.
           IF KRW-NUM NOT = KOW-NUM GO TO C99.
      *
           PERFORM DL-NOTE    THRU EX-DL-NOTE.
      *
           DELETE ORWRIG INVALID KEY
               PERFORM INVK-RIW GO TO ERRIO.
           GO TO C10.
       C99.
           EXIT.
      *------------------
       REC-LOCK.
           CALL 'rlock' USING PARLK.
           EXIT.
      *------------------
      * cancellazione note aggiuntive rigo ordine cliente
       DL-NOTE.
           MOVE KRW-AZI TO KNRW-AZI.
           MOVE KRW-NUM TO KNRW-NUM.
           MOVE KRW-PRG TO KNRW-PRG.
           MOVE ZERO    TO KNRW-PRGN.
      *
           START NOWRIG KEY >= KEYNRW INVALID GO TO EX-DL-NOTE.
       DL-NOTE-10.
           READ NOWRIG NEXT AT END GO TO EX-DL-NOTE.
           IF KNRW-AZI > KRW-AZI GO TO EX-DL-NOTE.
           IF KNRW-NUM > KRW-NUM GO TO EX-DL-NOTE.
           IF KNRW-PRG > KRW-PRG GO TO EX-DL-NOTE.
           DELETE NOWRIG INVALID PERFORM INVK-NRW
                                 GO TO V-ERROR.
           GO TO DL-NOTE-10.
       EX-DL-NOTE.
           EXIT.
      *------------------
       MOD-DAT-RIG.
           MOVE 'Modificare la data di consegna' TO F-MES1.
           MOVE 'confermata sui righi ?        ' TO F-MES2.
           MOVE 2 TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP = 'N' GO TO EX-MOD-DAT-RIG.

           MOVE KOW-AZI TO KRW-AZI.
           MOVE KOW-NUM TO KRW-NUM.
           MOVE ZERO    TO KRW-PRG.
           START ORWRIG KEY NOT < KEYRW INVALID GO TO EX-MOD-DAT-RIG.
       DTR10.
           READ ORWRIG NEXT INTO REKRIW AT END GO TO EX-MOD-DAT-RIG.
           IF SF-RIW = '9D' OR '9A' OR '35' GO TO DTR10.
           IF KRW-AZI NOT = KOW-AZI GO TO EX-MOD-DAT-RIG.
           IF KRW-NUM NOT = KOW-NUM GO TO EX-MOD-DAT-RIG.
           IF (RIW-TPRIG = 1 OR 3 ) GO TO DTR10.

           IF (RIW-DTCSC NOT = COMDTCSC) GO TO DTR10.
      *
      *    IF (RIW-DTCSR NOT = COMDTCSR) AND (RIW-DTCSC NOT = COMDTCSC)
      *       GO TO DTR10.
      *
      *    IF RIW-DTCSR = COMDTCSR
      *       MOVE ORW-DTCSR TO RIW-DTCSR.
      *
           IF RIW-DTCSC = COMDTCSC
              MOVE ORW-DTCSC TO RIW-DTCSC.

           REWRITE RF-RIW FROM REKRIW INVALID KEY
              PERFORM INVK-RIW
              GO TO ERRIO.

           GO TO DTR10.
       EX-MOD-DAT-RIG.
           EXIT.
      *------------------
       RD-NOTEW.
           PERFORM AZZ-NOTE.
      *
           MOVE ZERO TO KN.
      *
           MOVE KOW-AZI TO KNOW-AZI.
           MOVE KOW-NUM TO KNOW-NUM.
           MOVE ZERO    TO KNOW-TIP
           MOVE ZERO    TO KNOW-PRGN.
           START NOWTES KEY >= KEYNOW INVALID GO TO RD-NOWW-20.
       RD-NOWW-10.
           READ NOWTES NEXT AT END GO TO RD-NOWW-20.
           IF KNOW-AZI > KOW-AZI  GO TO RD-NOWW-20.
           IF KNOW-NUM > KOW-NUM  GO TO RD-NOWW-20.
           IF KNOW-TIP NOT = ZERO GO TO RD-NOWW-20.
           ADD 1 TO KN.
           IF KN <= NRIGMAX
              MOVE NOW-DESCR TO RA-ORW-RIGNOT(KN)
           GO TO RD-NOWW-10.
       RD-NOWW-20.
      *
           PERFORM CONTA-NBYTE-ORW-NOTE.
      *
           MOVE NRIGMAX TO ML-MAXRIG.
           MOVE 30      TO ML-LUNRIG.
           MOVE 2       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-ORW-NOTE.
      *
           PERFORM AZZ-NOTE1.
      *
           MOVE ZERO TO KN.
      *
           MOVE KOW-AZI TO KNOW-AZI.
           MOVE KOW-NUM TO KNOW-NUM.
           MOVE 1       TO KNOW-TIP
           MOVE ZERO    TO KNOW-PRGN.
           START NOWTES KEY >= KEYNOW INVALID GO TO RD-NOWW-20-1.
       RD-NOWW-10-1.
           READ NOWTES NEXT AT END GO TO RD-NOWW-20-1.
           IF KNOW-AZI > KOW-AZI  GO TO RD-NOWW-20-1.
           IF KNOW-NUM > KOW-NUM  GO TO RD-NOWW-20-1.
           IF KNOW-TIP NOT = 1    GO TO RD-NOWW-20-1.
           ADD 1 TO KN.
           IF KN <= NRIGMAX
              MOVE NOW-DESCR TO RA-ORW-RIGNOT1(KN)
           GO TO RD-NOWW-10-1.
       RD-NOWW-20-1.
           PERFORM CONTA-NBYTE-ORW-NOTE1.
      *
           MOVE NRIGMAX TO ML-MAXRIG.
           MOVE 30      TO ML-LUNRIG.
           MOVE 2       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-ORW-NOTE1.
      *
       EX-RD-NOTEW.
           EXIT.
      *------------------
       AZZ-NOTE.
           MOVE 1 TO KML.
           PERFORM UNTIL KML > NRIGMAX
              MOVE SPACE TO RA-ORW-RIGNOT(KML)
              ADD 1 TO KML
           END-PERFORM.
      *
           MOVE ZERO TO RA-ORW-NBYTE.
      *------------------
      * conta nbyte note aggiuntive
       CONTA-NBYTE-ORW-NOTE.
           MOVE ZERO TO RA-ORW-NBYTE.
           IF RA-ORW-NOTE NOT = SPACE
              MOVE NRIGMAX TO KVALID
              PERFORM UNTIL RA-ORW-RIGNOT(KVALID) NOT = SPACE
                 SUBTRACT 1 FROM KVALID
              END-PERFORM
              COMPUTE RA-ORW-NBYTE = KVALID * 30.
      *------------------*
       AZZ-NOTE1.
           MOVE 1 TO KML.
           PERFORM UNTIL KML > NRIGMAX
              MOVE SPACE TO RA-ORW-RIGNOT1(KML)
              ADD 1 TO KML
           END-PERFORM.
      *
           MOVE ZERO TO RA-ORW-NBYTE1.
      *------------------
      * conta nbyte note aggiuntive
       CONTA-NBYTE-ORW-NOTE1.
           MOVE ZERO TO RA-ORW-NBYTE1.
           IF RA-ORW-NOTE1 NOT = SPACE
              MOVE NRIGMAX TO KVALID
              PERFORM UNTIL RA-ORW-RIGNOT1(KVALID) NOT = SPACE
                 SUBTRACT 1 FROM KVALID
              END-PERFORM
              COMPUTE RA-ORW-NBYTE1 = KVALID * 30.
      *------------------*
       CONFERMA.
           MOVE ZERO TO FLGVAR.
      *
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-ORW
              GO TO WARNING.
      *
           IF ORW-ESTER = 2 
      **** rel 6.2
      *       MOVE 'Ordine gi rifuitato !' TO F-MES1
              MOVE 'Ordine gi rifiutato !' TO F-MES1
      ************
              MOVE 1 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB
              UNLOCK ORWCLI
              GO TO EX-CONFERMA.
      *
      **** rel 6.2
           IF ORW-ESTER NOT = ZERO AND ORW-FLGTEL = 2 AND 
                                       ORW-NORPRI = ZERO 
              MOVE ZERO TO ORW-ESTER.
      ************

      **** rel 6.2
           IF ORW-ESTER NOT = ZERO AND ORW-FLGTEL = 2 
              MOVE 'Ordine gia'' generato' TO F-MES1
              MOVE 1 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB
              UNLOCK ORWCLI
              MOVE 4 TO RG-ORW-ST
              GO TO EX-CONFERMA.
      ************
           IF ORW-ESTER NOT = ZERO
              MOVE 'Ordine gia'' ritrasmesso' TO F-MES1
              MOVE 'Confermi nuovo reinvio?'  TO F-MES2
              MOVE 2 TO F-NMES
              MOVE 'Q' TO MB-TIPO
              MOVE '2' TO MB-DEFAULT
              CALL 'vrmbox' USING PARMB
              IF MB-RISP NOT = 'S'
                 UNLOCK ORWCLI
                 GO TO EX-CONFERMA.
      *
           IF ORW-ESTER NOT = ZERO GO TO CNF99-R.
      *
      *> scrittura della testata de''ordine
           PERFORM MOVE-DA-ORW-A-ORD THRU EX-MOVE-DA-ORW-A-ORD.
      *
           MOVE 'I'          TO RG-ORD-FUN.
           CALL 'vordg10' USING RG-ORD-CTRL RG-ORD-REC 
                                RA-ORD-AGG IF-MESS.
      *
           MOVE 'K' TO RG-ORD-FUN.
           CALL 'vordg10' USING RG-ORD-CTRL RG-ORD-REC 
                                RA-ORD-AGG IF-MESS.
           MOVE RG-ORD-NUM TO SAVNUM.
      *
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-ORW
              GO TO WARNING.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           PERFORM MOVE-DA-ORW-A-ORD THRU EX-MOVE-DA-ORW-A-ORD.
      **** rel 6.2
           PERFORM CERCA-ORDRIC THRU EX-CERCA-ORDRIC.
      ************
      *
           MOVE SAVNUM TO RG-ORD-NUM.
           MOVE 'S' TO RG-ORD-FUN.
           CALL 'vordg10' USING RG-ORD-CTRL RG-ORD-REC 
                                RA-ORD-AGG IF-MESS.
      *
           MOVE 'E' TO RG-ORD-FUN.
           CALL 'vordg10' USING RG-ORD-CTRL RG-ORD-REC 
                                RA-ORD-AGG IF-MESS.
      *> fine scrittura testata
      *
           IF ORW-DTCSR NOT = ZERO AND ORW-DTCSR NOT = ORW-DTCSC
              MOVE 1 TO FLGVAR.
      *
      *> scrittura dei righi dell'ordine
           MOVE KOW-AZI TO KRW-AZI.
           MOVE KOW-NUM TO KRW-NUM.
           MOVE ZERO    TO KRW-PRG FLGNOT.
           START ORWRIG KEY NOT < KEYRW INVALID GO TO CNF99.
       CNF10.
           READ ORWRIG NEXT INTO REKRIW AT END GO TO CNF99.
      **** rel 6.2
      *    IF SF-RIW = '9D' OR '9A' OR '35' GO TO C10.
           IF SF-RIW = '9D' OR '9A' OR '35' GO TO CNF10.
      ************
           IF KRW-AZI NOT = KOW-AZI GO TO CNF99.
           IF KRW-NUM NOT = KOW-NUM GO TO CNF99.
      **** rel 6.2
      *    IF FLGNOT = ZERO 
      *       IF RIW-TPRIG = 1 MOVE 1 TO FLGNOT GO TO CNF10.
           IF FLGNOT = 1 IF RIW-TPRIG = 1 GO TO CNF10.
      ************
      *
           IF RIW-TPRIG = 1 GO TO NO-RART.

           IF RIW-QUANT NOT = RIW-QUANTW MOVE 1 TO FLGVAR.
      **** rel 6.2
      *    IF RIW-QUANT = ZERO GO TO CNF10.
           IF RIW-QUANT = ZERO MOVE 1 TO FLGNOT GO TO CNF10.
           MOVE ZERO TO FLGNOT.
      ************
      *
           IF RIW-DTCSR NOT = ZERO 
              IF RIW-DTCSR NOT = RIW-DTCSC MOVE 1 TO FLGVAR.
      *
           IF RIW-PREZZW NOT = ZERO
              IF RIW-PREZZW NOT = RIW-PREZZ MOVE 1 TO FLGVAR
              END-IF
              IF RIW-1SCONW NOT = RIW-1SCON MOVE 1 TO FLGVAR
              END-IF
              IF RIW-2SCONW NOT = RIW-2SCON MOVE 1 TO FLGVAR.
       NO-RART.
      *
           MOVE KRW-AZI TO RG-RIG-AZI.
           MOVE SAVNUM  TO RG-RIG-NUM.
           PERFORM MOVE-DA-RIW-A-RIG THRU EX-MOVE-DA-RIW-A-RIG.
           MOVE 'I' TO RG-RIG-FUN.
           CALL 'vordg15' USING RG-RIG-CTRL RG-RIG-REC 
                                RA-RIG-AGG IF-MESS.
      *
           MOVE 'K' TO RG-RIG-FUN.
           CALL 'vordg15' USING RG-RIG-CTRL RG-RIG-REC 
                                RA-RIG-AGG IF-MESS.
      *
           PERFORM CARICA-RG-RIG THRU EX-CARICA-RG-RIG.
           PERFORM CARICA-RA-RIG THRU EX-CARICA-RA-RIG.
           PERFORM MOVE-DA-RIW-A-RIG THRU EX-MOVE-DA-RIW-A-RIG.
      *
      *> vcalidazione singola dell'articolo per il caricamento delle
      *> eventuali note se fleggato in tabella parametri
           MOVE 'V'         TO RG-RIG-FUN.
           MOVE 'RIG-ARTIC' TO RG-RIG-CAMPO.
           CALL 'vordg15' USING RG-RIG-CTRL RG-RIG-REC 
                                RA-RIG-AGG IF-MESS.
           IF RG-RIG-ST = 6 
              CALL 'vordg15' USING RG-RIG-CTRL RG-RIG-REC 
                                   RA-RIG-AGG IF-MESS.
      *>
           MOVE RA-RIG-NOTE TO RA-RIW-NOTE.
      *
           MOVE 'W' TO RG-RIG-FUN.
           CALL 'vordg15' USING RG-RIG-CTRL RG-RIG-REC 
                                RA-RIG-AGG IF-MESS.
           IF RG-RIG-ST = 6 
              CALL 'vordg15' USING RG-RIG-CTRL RG-RIG-REC 
                                   RA-RIG-AGG IF-MESS.
           IF RG-RIG-ST NOT = ZERO 
              MOVE 'Problemi nel travaso ordine' TO F-MES1
              MOVE 'Verificare righi ordine in esame' TO F-MES2
              MOVE 'e stato ordini nel gestionale' TO F-MES3
              MOVE 3 TO F-NMES
              UNLOCK ORWCLI
              GO TO ERRIO.
      *
           PERFORM CARICA-RG-RIG THRU EX-CARICA-RG-RIG.
           PERFORM MOVE-DA-RIW-A-RIG THRU EX-MOVE-DA-RIW-A-RIG.
      *
           MOVE SAVNUM TO RG-RIG-NUM.
           MOVE 'S' TO RG-RIG-FUN.
           CALL 'vordg15' USING RG-RIG-CTRL RG-RIG-REC 
                                RA-RIG-AGG IF-MESS.
      *
           MOVE 'E' TO RG-RIG-FUN.
           CALL 'vordg15' USING RG-RIG-CTRL RG-RIG-REC 
                                RA-RIG-AGG IF-MESS.

           GO TO CNF10.
      *
       CNF99.
      *> fine scrittura righi dell'ordine
      *
           IF ORW-ESTER = ZERO MOVE 9 TO ORW-ESTER.
      **** rel 6.2
      *    IF FLGVAR = 1 MOVE 1 TO ORW-ESTER.
           IF ORW-FLGTEL NOT = 2 
              IF FLGVAR = 1 MOVE 1 TO ORW-ESTER.
      ************
      *
           MOVE SAVNUM TO ORW-NORPRI.
      *
           MOVE REKORW TO RF-ORW.
           REWRITE RF-ORW INVALID PERFORM INVK-ORW GO TO ERRIO.
      *
           UNLOCK ORWCLI.
           MOVE ORW-NUM TO RG-ORW-NUM.
       CNF99-R.
      **** rel 6.2
           IF ORW-FLGTEL > 1 GO TO EX-CONFERMA.
      ************
           IF TOW01-FLGP NOT = ZERO
              MOVE ZERO       TO PWCD-FUN
              MOVE 'INT'      TO PWCD-TIPO
              MOVE 'ORD'      TO PWCD-TDOC
              MOVE 1          TO PWCD-TDES
              MOVE ORW-CDCLI  TO PWCD-CDES
              MOVE KOW-AZI    TO PWCD-KEY(1:3)
              MOVE ORW-NORPRI TO PWCD-KEY(4:5)
              MOVE SPACE      TO PWCD-OPZ
              CALL 'vrwcoda' USING PARWCD.
      *
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'ORE'   TO PPAR-TARC.
      *
      *> se l'ordine arriva da e-mail accodo un evento per inviare il 
      *> inerente l'esito al mittente EOM e non ORE
           IF ORW-IDFILE NOT = SPACE MOVE 'EOM' TO PPAR-TARC.
      *
           MOVE 'I'     TO PPAR-TOPE.
           MOVE KEYOW   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           CALL 'vsrv130' USING PARPPAR.
           IF PPAR-ERR > 1 
              MOVE SPACE TO MESS
              STRING 'Errore chiamata vsrv130. Errore ' PPAR-ERR
                      DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *
       EX-CONFERMA.
           EXIT.
      *------------------
       CARICA-RG-RIG.
           MOVE RIW-AZI   TO RG-RIW-AZI.
           MOVE RIW-NUM   TO RG-RIW-NUM.
           MOVE RIW-PRG   TO RG-RIW-PRG.
           MOVE RIW-TPRIG TO RG-RIW-TPRIG.
           MOVE RIW-DESAR TO RG-RIW-DESAR.
      *
           IF RIW-TPRIG = 1 GO TO EX-CARICA-RG-RIG.
      *
           MOVE RIW-CDIVA TO RG-RIW-CDIVA.
           MOVE RIW-FSC   TO RG-RIW-FSC.
      *
           MOVE RIW-FPNET TO RG-RIW-FPNET.
      *
           IF RIW-TPRIG = 3
              MOVE RIW-CDSPE TO RG-RIW-CDSPE
              MOVE RIW-PROVV TO RG-RIW-PROVV
              MOVE RIW-PREZZ TO RG-RIW-PREZZ
              GO TO EX-CARICA-RG-RIG.
      *
           MOVE RIW-FSC   TO DP-FSC.
           MOVE RIW-PREZZ TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC.
           MOVE DP-PREZZO TO RG-RIW-PREZZ.
      *
           IF RIW-TPRIG = 2
              MOVE RIW-NOMME TO RG-RIW-NOMME
              MOVE RIW-CONTR TO RG-RIW-CONTR.
      *
           IF RIW-TPRIG = 4 OR = 5
              MOVE RIW-RIVGR TO RG-RIW-RIVGR.

      *--- standard interfaccia: 0=no 1=si
           IF RIW-TPRIG = 4
              IF RIW-RIVAL = ZERO MOVE 1    TO RG-RIW-RIVAL
              ELSE                MOVE ZERO TO RG-RIW-RIVAL.
      *
           MOVE RIW-ARTIC TO RG-RIW-ARTIC.
           MOVE RIW-LOTTO TO RG-RIW-LOTTO.
           MOVE RIW-QUANT TO RG-RIW-QUANT.
           MOVE 2 TO TIPOP1.
           MOVE RIW-DTCSR TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RIW-DTCSR.
           MOVE 2 TO TIPOP1.
           MOVE RIW-DTCSC TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RIW-DTCSC.
           MOVE RIW-UNMIS TO RG-RIW-UNMIS.
           MOVE RIW-1SCON TO RG-RIW-1SCON.
           MOVE RIW-2SCON TO RG-RIW-2SCON.
           MOVE RIW-PROVV TO RG-RIW-PROVV.
           MOVE RIW-TQUAN TO RG-RIW-TQUAN.
           MOVE ZERO      TO RG-RIW-QUANTW.
      *
           IF (RIW-TPRIG = 2)  OR
              ((RIW-TPRIG = 4 OR 5) AND RIW-ARTIC = SPACE)
                MOVE 2 TO RG-RIW-TQUAN.
           MOVE ZERO TO RG-RIW-LISRF.
       EX-CARICA-RG-RIG.
           EXIT.
      *------------------
       CARICA-RA-RIG.
           PERFORM RD-NRW THRU EX-RD-NRW.
       EX-CARICA-RA-RIG.
           EXIT.
      *------------------
      * fase di lettura note aggiuntive rigo ordine cliente e
      * caricamento aree interfaccia
       RD-NRW.
           MOVE 1 TO KML.
           PERFORM UNTIL KML > NRIGMAX
              MOVE SPACE TO RA-RIW-RIGNOT(KML)
              ADD 1 TO KML
           END-PERFORM.
      *
           MOVE ZERO TO RA-RIW-NBYTE
                        RA-RIW-FLGNOTE.
           MOVE ZERO TO KN.
      *
           IF RIW-TPRIG = 1
              MOVE RIW-DESAR TO RA-RIW-RIGNOT(1)
              MOVE 1 TO RA-RIW-FLGNOTE
              ADD 1 TO KN.
      *
           MOVE KRW-AZI TO KNRW-AZI.
           MOVE KRW-NUM TO KNRW-NUM.
           MOVE KRW-PRG TO KNRW-PRG.
           MOVE ZERO    TO KNRW-PRGN.
           START NOWRIG KEY >= KEYNRW INVALID GO TO RD-NRW-20.
       RD-NRW-10.
           READ NOWRIG NEXT AT END GO TO RD-NRW-20.
           IF KNRW-AZI > KRW-AZI GO TO RD-NRW-20.
           IF KNRW-NUM > KRW-NUM GO TO RD-NRW-20.
           IF KNRW-PRG > KRW-PRG GO TO RD-NRW-20.
           ADD 1 TO KN.
           IF KN <= NRIGMAX
              MOVE NRW-DESCR TO RA-RIW-RIGNOT(KN)
              MOVE 1 TO RA-RIW-FLGNOTE
           GO TO RD-NRW-10.
       RD-NRW-20.
      *
           MOVE ZERO TO RA-RIW-NBYTE.
           IF RA-RIW-NOTE NOT = SPACE
              MOVE NRIGMAX TO KVALID
              PERFORM UNTIL RA-RIW-RIGNOT(KVALID) NOT = SPACE
                 SUBTRACT 1 FROM KVALID
              END-PERFORM
              COMPUTE RA-RIW-NBYTE = KVALID * 30.
      *
           MOVE NRIGMAX TO ML-MAXRIG.
           MOVE 30      TO ML-LUNRIG.
           MOVE 2       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-RIW-NOTE.
      *
       EX-RD-NRW.
           EXIT.
      *------------------
       NO-WEB.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-ORW
              GO TO WARNING.
      *
      **** rel 6.2
           IF ORW-FLGTEL = 2 
              MOVE 'Ordine manuale' TO F-MES1
              MOVE 1 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB
              UNLOCK ORWCLI
              GO TO EX-NO-WEB.
      ************
           IF ORW-ESTER = 1 OR 9
              MOVE 'Ordine gi accettato !' TO F-MES1
              MOVE 1 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB
              UNLOCK ORWCLI
              GO TO EX-NO-WEB.
      *
           IF ORW-ESTER NOT = ZERO
              MOVE 'Ordine gia'' ritrasmesso' TO F-MES1
              MOVE 'Confermi nuovo reinvio?'  TO F-MES2
              MOVE 2 TO F-NMES
              MOVE 'Q' TO MB-TIPO
              MOVE '2' TO MB-DEFAULT
              CALL 'vrmbox' USING PARMB
              IF MB-RISP NOT = 'S'
                 UNLOCK ORWCLI
                 GO TO EX-NO-WEB.
      *
           IF ORW-ESTER NOT = ZERO GO TO NO-W99.

           MOVE 2 TO ORW-ESTER.
           MOVE REKORW TO RF-ORW.
           REWRITE RF-ORW INVALID
              PERFORM INVK-ORW
              GO TO ERRIO.

       NO-W99.
           UNLOCK ORWCLI.
      *
      **** rel 6.2
           IF ORW-FLGTEL > 1 GO TO EX-NO-WEB.
      ************
           MOVE ZERO      TO PPAR-FUN.
           MOVE 'ORE'     TO PPAR-TARC.
      *
      *> se l'ordine arriva da e-mail accodo un evento per inviare il 
      *> inerente l'esito al mittente EOM e non ORE
           IF ORW-IDFILE NOT = SPACE MOVE 'EOM' TO PPAR-TARC.
      *
           MOVE 'I'       TO PPAR-TOPE.
           MOVE KEYOW     TO PPAR-KEY.
           MOVE ZERO      TO PPAR-CATT.
           CALL 'vsrv130' USING PARPPAR.
           IF PPAR-ERR > 1 
              MOVE SPACE TO MESS
              STRING 'Errore chiamata vsrv130. Errore ' PPAR-ERR
                      DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *
       EX-NO-WEB.
           EXIT.
      *------------------
       MOVE-DA-ORW-A-ORD.
           MOVE RG-ORW-IDX      TO RG-ORD-IDX.
           MOVE RG-ORW-CAMPO    TO RG-ORD-CAMPO.
           MOVE RG-ORW-ST       TO RG-ORD-ST.
           MOVE RG-ORW-EOF      TO RG-ORD-EOF.
      *
           MOVE RG-ORW-AZI      TO RG-ORD-AZI.
           MOVE RG-ORW-NUM      TO RG-ORD-NUM.
           MOVE RG-ORW-DAT      TO RG-ORD-DAT.
           MOVE RG-ORW-CDCLI    TO RG-ORD-CDCLI.
           MOVE RG-ORW-ZONA     TO RG-ORD-ZONA.
           MOVE RG-ORW-CDAGE    TO RG-ORD-CDAGE.
           MOVE RG-ORW-PROVV    TO RG-ORD-PROVV.
           MOVE RG-ORW-CDPAG    TO RG-ORD-CDPAG.
           MOVE RG-ORW-CDBAN    TO RG-ORD-CDBAN.
           MOVE RG-ORW-CDSPE    TO RG-ORD-CDSPE.
           MOVE RG-ORW-CDPOR    TO RG-ORD-CDPOR.
           MOVE RG-ORW-PERSC    TO RG-ORD-PERSC.
           MOVE RG-ORW-DTCSR    TO RG-ORD-DTCSR.
           MOVE RG-ORW-DTCSC    TO RG-ORD-DTCSC.
           MOVE RG-ORW-CDESE    TO RG-ORD-CDESE.
           MOVE RG-ORW-VSORD    TO RG-ORD-VSORD.
           MOVE RG-ORW-COMME    TO RG-ORD-COMME.
           MOVE RG-ORW-CDEP     TO RG-ORD-CDEP.
           MOVE RG-ORW-VALUT    TO RG-ORD-VALUT.
           MOVE RG-ORW-LCONS    TO RG-ORD-LCONS.
           MOVE RG-ORW-CATT     TO RG-ORD-CATT.
           MOVE RG-ORW-LISRF    TO RG-ORD-LISRF.
           MOVE RG-ORW-NOFF     TO RG-ORD-NOFF.
      **** rel 7.1
           MOVE RG-ORW-VETT     TO RG-ORD-VETT.
      ************

      **** rel 6.2
           MOVE CLF-GGS TO RG-ORD-GGS.
           IF RG-ORD-LCONS NOT = ZERO MOVE IRI-GGS TO RG-ORD-GGS.
           IF RG-ORD-GGS NOT = ZERO
              MOVE RG-ORD-GGS TO I
              MOVE RG-ORD-DTCSC TO GGMMAA
              PERFORM SOTTRAI-GG THRU EX-SOTTRAI-GG
              MOVE GGMMAA TO RG-ORD-DTCSC.
      ************
      *
           MOVE RA-ORW-CDCLI-D  TO RA-ORD-CDCLI-D.
           MOVE RA-ORW-CDCLI-D1 TO RA-ORD-CDCLI-D1.
           MOVE RA-ORW-ZONA-D   TO RA-ORD-ZONA-D.
           MOVE RA-ORW-CDAGE-D  TO RA-ORD-CDAGE-D.
           MOVE RA-ORW-CDPAG-D  TO RA-ORD-CDPAG-D.
           MOVE RA-ORW-CDBAN-D  TO RA-ORD-CDBAN-D.
           MOVE RA-ORW-CDSPE-D  TO RA-ORD-CDSPE-D.
           MOVE RA-ORW-CDPOR-D  TO RA-ORD-CDPOR-D.
           MOVE RA-ORW-CDESE-D  TO RA-ORD-CDESE-D.
           MOVE RA-ORW-CDEP-D   TO RA-ORD-CDEP-D.
           MOVE RA-ORW-VALUT-D  TO RA-ORD-VALUT-D.
           MOVE RA-ORW-LCONS-D  TO RA-ORD-LCONS-D.
           MOVE RA-ORW-CATT-D   TO RA-ORD-CATT-D.
           MOVE RA-ORW-LISRF-D  TO RA-ORD-LISRF-D
           MOVE RA-ORW-LISRF-D1 TO RA-ORD-LISRF-D1.
      *    MOVE RA-ORW-VETT-D   TO RA-ORD-VETT-D.
       EX-MOVE-DA-ORW-A-ORD.
           EXIT.
      *------------------
       MOVE-DA-RIW-A-RIG.
           MOVE RG-RIW-FUN      TO RG-RIG-FUN.
           MOVE RG-RIW-IDX      TO RG-RIG-IDX.
           MOVE RG-RIW-CAMPO    TO RG-RIG-CAMPO.
           MOVE RG-RIW-ST       TO RG-RIG-ST.
           MOVE RG-RIW-EOF      TO RG-RIG-EOF.
      *
      *    MOVE RG-RIW-AZI      TO RG-RIG-AZI.
      *    MOVE RG-RIW-NUM      TO RG-RIG-NUM.
           MOVE RG-RIW-PRG      TO RG-RIG-PRG.
           MOVE RG-RIW-TPRIG    TO RG-RIG-TPRIG.
           MOVE RG-RIW-ARTIC    TO RG-RIG-ARTIC.
           MOVE RG-RIW-LOTTO    TO RG-RIG-LOTTO.
           MOVE RG-RIW-QUANT    TO RG-RIG-QUANT.
           MOVE RG-RIW-LISRF    TO RG-RIG-LISRF.
           MOVE RG-RIW-DTCSR    TO RG-RIG-DTCSR.
           MOVE RG-RIW-DTCSC    TO RG-RIG-DTCSC.
      **** rel 6.2
           IF RG-ORD-GGS NOT = ZERO
              MOVE RG-ORD-GGS TO I
              MOVE RG-RIG-DTCSC TO GGMMAA
              PERFORM SOTTRAI-GG THRU EX-SOTTRAI-GG
              MOVE GGMMAA TO RG-RIG-DTCSC.
      ************
           MOVE RG-RIW-UNMIS    TO RG-RIG-UNMIS.
           MOVE RG-RIW-PREZZ    TO RG-RIG-PREZZ.
           MOVE RG-RIW-1SCON    TO RG-RIG-1SCON.
           MOVE RG-RIW-2SCON    TO RG-RIG-2SCON.
           MOVE RG-RIW-PROVV    TO RG-RIG-PROVV.
           MOVE RG-RIW-CDIVA    TO RG-RIG-CDIVA.
           MOVE RG-RIW-DESAR    TO RG-RIG-DESAR.
           MOVE RG-RIW-TQUAN    TO RG-RIG-TQUAN.
           MOVE RG-RIW-FSC      TO RG-RIG-FSC.
           MOVE ZERO            TO RG-RIG-QSPED.
           MOVE ZERO            TO RG-RIG-SALDO.
           MOVE RG-RIW-RIVAL    TO RG-RIG-RIVAL.
           MOVE RG-RIW-RIVGR    TO RG-RIG-RIVGR.
           MOVE RG-RIW-CDSPE    TO RG-RIG-CDSPE.
           MOVE RG-RIW-CONTR    TO RG-RIG-CONTR.
           MOVE RG-RIW-FPNET    TO RG-RIG-FPNET.
           MOVE RG-RIW-DTLIS    TO RG-RIG-DTLIS.
           MOVE RG-RIW-NOMME    TO RG-RIG-NOMME.
      *
           MOVE RA-RIW-IVRB     TO RA-RIG-IVRB.
           MOVE RA-RIW-RIVGR-D  TO RA-RIG-RIVGR-D.
           MOVE RA-RIW-CDIVA-D  TO RA-RIG-CDIVA-D.
           MOVE RA-RIW-QDISP    TO RA-RIG-QDISP.
           MOVE RA-RIW-SDEC     TO RA-RIG-SDEC.
           MOVE RA-RIW-CONTR-D  TO RA-RIG-CONTR-D.
           MOVE RA-RIW-NOTE     TO RA-RIG-NOTE.
           MOVE RA-RIW-NBYTE    TO RA-RIG-NBYTE.
           MOVE RA-RIW-FLGNOTE  TO RA-RIG-FLGNOTE.
           MOVE RA-RIW-CBFSC    TO RA-RIG-CBFSC.
           MOVE RA-RIW-FSC-D    TO RA-RIG-FSC-D.
           MOVE RA-RIW-INTRA    TO RA-RIG-INTRA.
           MOVE RA-RIW-NTESTO   TO RA-RIG-NTESTO.
           MOVE RA-RIW-NETRG    TO RA-RIG-NETRG.
       EX-MOVE-DA-RIW-A-RIG.
           EXIT.
      *------------------
      * cancellazione note aggiuntive rigo ordine cliente TESTATA 0
       DL-NOTE-T0.
           MOVE KOW-AZI TO KNOW-AZI.
           MOVE KOW-NUM TO KNOW-NUM.
           MOVE ZERO    TO KNOW-TIP
           MOVE ZERO    TO KNOW-PRGN.
           START NOWTES KEY >= KEYNOW INVALID GO TO EX-DL-NOTE-T0.
       DL-NOTE-10-T0.
           READ NOWTES NEXT AT END GO TO EX-DL-NOTE-T0.
           IF KNOW-AZI > KOW-AZI  GO TO EX-DL-NOTE-T0.
           IF KNOW-NUM > KOW-NUM  GO TO EX-DL-NOTE-T0.
           IF KNOW-TIP NOT = ZERO GO TO EX-DL-NOTE-T0.
           DELETE NOWTES INVALID PERFORM INVK-NOW
                                 GO TO V-ERROR.
           GO TO DL-NOTE-10-T0.
       EX-DL-NOTE-T0.
           EXIT.
      *------------------
      * cancellazione note aggiuntive rigo ordine cliente TESTATA 1
       DL-NOTE-T1.
           MOVE KOW-AZI TO KNOW-AZI.
           MOVE KOW-NUM TO KNOW-NUM.
           MOVE 1       TO KNOW-TIP
           MOVE ZERO    TO KNOW-PRGN.
           START NOWTES KEY >= KEYNOW INVALID GO TO EX-DL-NOTE-T1.
       DL-NOTE-10-T1.
           READ NOWTES NEXT AT END GO TO EX-DL-NOTE-T1.
           IF KNOW-AZI > KOW-AZI GO TO EX-DL-NOTE-T1.
           IF KNOW-NUM > KOW-NUM GO TO EX-DL-NOTE-T1.
           IF KNOW-TIP NOT = 1   GO TO EX-DL-NOTE-T1.
           DELETE NOWTES INVALID PERFORM INVK-NOW
                                 GO TO V-ERROR.
           GO TO DL-NOTE-10-T1.
       EX-DL-NOTE-T1.
           EXIT.
      *------------------
      * fase di scrittura note aggiuntive rigo ordine cliente
       DL-WR-NOTE.
           PERFORM DL-NOTE-T1 THRU EX-DL-NOTE-T1.
      *
       WR-NOTE.
           IF RA-ORW-NOTE1 = SPACE GO TO EX-DL-WR-NOTE.
      *
           MOVE NRIGMAX TO KVALID.
           PERFORM UNTIL RA-ORW-RIGNOT1(KVALID) NOT = SPACE
              SUBTRACT 1 FROM KVALID
           END-PERFORM.
      *
           MOVE KOW-AZI TO KNOW-AZI.
           MOVE KOW-NUM TO KNOW-NUM.
           MOVE 1       TO KNOW-TIP.
           MOVE ZERO    TO KNOW-PRGN.
      *
           MOVE 1 TO KML.
           PERFORM UNTIL KML > KVALID
              ADD 1 TO KNOW-PRGN
              MOVE RA-ORW-RIGNOT1(KML) TO NOW-DESCR
              WRITE RF-NOW INVALID PERFORM INVK-NOW
                                   GO TO ERRIO
              END-WRITE
              ADD 1 TO KML
           END-PERFORM.
      *
           PERFORM CONTA-NBYTE-ORW-NOTE1.
      * conversione per visualizzazione automatica nel caso di conferma
      * dopo una variazione
           MOVE NRIGMAX TO ML-MAXRIG.
           MOVE 30      TO ML-LUNRIG.
           MOVE 2       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-ORW-NOTE1.
       EX-DL-WR-NOTE.
           EXIT.
      *------------------
       VERIFICA-VARIAZIONI.
           IF ORW-LCONS = OLDLCONS  AND
              CLF-CPAG  = ORW-CDPAG AND
              CLF-BANC  = ORW-CDBAN AND
      *       CLF-VETT  = ORW-VETT  AND
              CLF-PORT  = ORW-CDPOR GO TO EX-VERIFICA-VARIAZIONI.
      *
           MOVE 'VERIFICARE CONFERMA D''ORDINE' TO RA-ORW-RIGNOT1(1).
           MOVE 1 TO RA-ORW-FLGNOTE.
       EX-VERIFICA-VARIAZIONI.
           EXIT.
      *------------------
      **** rel 6.2
       CERCA-ORDRIC.
           MOVE ZERO TO RA-ORD-NRORC.
           OPEN INPUT ORDRIG.
           MOVE KOW-AZI TO KRW-AZI.
           MOVE KOW-NUM TO KRW-NUM.
           MOVE ZERO    TO KRW-PRG.
           START ORWRIG KEY NOT < KEYRW INVALID GO TO FNRIW.
       RDRIW.
           READ ORWRIG NEXT INTO REKRIW AT END GO TO FNRIW.
           IF SF-RIW = '9D' OR '9A' OR '35' GO TO RDRIW.
           IF KRW-AZI NOT = KOW-AZI GO TO FNRIW.
           IF KRW-NUM NOT = KOW-NUM GO TO FNRIW.
           IF RIW-TPRIG NOT = ZERO GO TO RDRIW.
      *
           MOVE LOW-VALUE TO KEYRI.
           MOVE RIW-ARTIC TO KRI-ART.
           START ORDRIG KEY NOT < SKEYRI2 INVALID GO TO RDRIW.
       RDRIG.
           READ ORDRIG NEXT INTO REKRIG AT END GO TO RDRIW.
           IF SF-RIG = '9D' OR '9A' OR '35' GO TO RDRIG.
           IF KRI-ART NOT = RIW-ARTIC GO TO RDRIW.
           IF KRI-AZI NOT = KOW-AZI GO TO RDRIG.
           MOVE KRI-AZI TO OC-AZI.
           MOVE KRI-NUM TO OC-NUM.
           CALL 'vrvopc' USING PAROC.
           IF OC-FLG NOT = 1 GO TO RDRIG.
           MOVE ZERO         TO PARORC.
           MOVE KRI-AZI TO PORC-AZI.
           MOVE KRI-NUM TO PORC-NUM.
           CALL 'vrrdord' USING PARORC.
           IF NOT (PORC-CLI = ORW-CDCLI AND 
                   PORC-LCONS = ORW-LCONS) GO TO RDRIG.
      *
           IF RIG-QUANT = ZERO 
              MOVE SPACE TO F-MES1
              MOVE KRI-NUM TO NUMOPC 
              STRING 'Legare a Ordine a Progr. ' NUMOPC ' ?' 
                        DELIMITED SIZE INTO F-MES1
              MOVE 1 TO F-NMES
              MOVE 'Q' TO MB-TIPO
              MOVE '2' TO MB-DEFAULT
              CALL 'vrmbox' USING PARMB
              IF MB-RISP = 'N' GO TO RDRIG
              ELSE MOVE KRI-NUM TO RA-ORD-NRORC
                   GO TO FNRIW.
           GO TO RDRIG.
       FNRIW.
           CLOSE ORDRIG.
       EX-CERCA-ORDRIC.
           EXIT.
      *----------------------*
       SOTTRAI-GG.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.

           IF I = ZERO OR AAGGG = ZERO GO TO EX-SOTTRAI-GG.

      * SOTTRAE giorni escludendo sabati e domeniche
           PERFORM UNTIL I = ZERO
              SUBTRACT 1 FROM AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF SWRET1 > ZERO
                 MOVE ZERO TO I
              ELSE
                 IF GGSET <= 5
                    SUBTRACT 1 FROM I.

           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
       EX-SOTTRAI-GG.
           EXIT.
      *-------------------------------
      ************
