       IDENTIFICATION DIVISION.
       PROGRAM-ID. VPLA130.
      *
      * Lista movimenti
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'griplssl'.
           COPY 'grimovsl'.
           COPY 'grimvxsl'.
           COPY 'grimepsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'gripls'.
           COPY 'grimov'.                                         
           COPY 'grimvx'.                                         
           COPY 'grimep'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'grit25rk'.
           COPY 'grit35rk'.
           COPY 'grimovrk'.                                       
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MVX PIC X(15) VALUE 'movmxx'.
       01  ID-MEP PIC X(15) VALUE 'plamep'.
       01  ID-PLS PIC X(15) VALUE 'plapls'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-MOV   PIC XX.
           05 SF-MVX   PIC XX.
           05 SF-MEP   PIC XX.
           05 SF-PLS   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 T25DTM   PIC 9(5) COMP-3.
           05 MOVIMP   PIC S9(11)V99.
           05 TIG      PIC 9      VALUE ZERO.
           05 TPL      PIC 9      VALUE ZERO.
           05 TIPOP    PIC 9      VALUE ZERO.
           05 CATT     PIC 9      VALUE ZERO.
           05 FLGER    PIC 9      VALUE ZERO.
           05 CIVAQ    PIC 9(7)   COMP-3 VALUE ZERO.
           05 CIVAV    PIC 9(7)   COMP-3 VALUE ZERO.
           05 CIVA     PIC 9(7)   COMP-3 VALUE ZERO.
           05 DTMX     PIC 9(5)   COMP-3 VALUE ZERO.
           05 SAVNRGL  PIC 99.
           05 DTP      PIC 9(4)   VALUE ZERO.
           05 DTP6.
              10 MM6 PIC 99 VALUE ZERO.
              10 AA6.
                 15 AA61 PIC 99 VALUE ZERO.
                 15 AA62 PIC 99 VALUE ZERO.
           05 PERIO    PIC 9(6)   VALUE ZERO.
           05 PERIX    REDEFINES PERIO.
              10 PERM  PIC 99.
              10 PERA  PIC 9(4).
           05 DTCT1.
              10 PERAA PIC 9(4)   VALUE ZERO.
              10 PERMA PIC 99     VALUE ZERO.
           05 DTCT2.
              10 PLFAA PIC 9(4)   VALUE ZERO.
              10 PLFMM PIC 99     VALUE ZERO.
       01  REKTE14.
           05 FILLER   PIC X(5).
           05 T14IVER  PIC 9(7).
           05 T14RICO  PIC 9(7).
           05 T14GIIV  PIC 9(3).
           05 T14GICO  PIC 9(3).
           05 T14IDIR  PIC 9(3).
           05 T14ITRI  PIC 9(3).
           05 T14IIND  PIC 9(3).
           05 T14ISCV  PIC 9(3).
           05 T14IRSM  PIC 9(3).
           05 T14IASS  PIC 9(3).
           05 T14ISIN  PIC 9(3).
           05 T141ACQ  PIC 9(3).
           05 T141ACR  PIC 9(3).
           05 T141ACT  PIC 9(3).
           05 T142ACQ  PIC 9(3).
           05 T143ACQ  PIC 9(3).
           05 T14IPOS  PIC 9(3).
           05 FILLER    PIC X(8).
      *
           COPY 'vpla130.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'. 
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-DATA      PIC 9(6).
           05 IF-TPSTA     PIC 9.
           05 IF-TIPO      PIC 9.
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclpls'.
           COPY 'dclmov'.
           COPY 'dclmvx'.
           COPY 'dclmep'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vpla130: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI ANACLF TABELL MOVIME MOVMXX PLAMEP PLAPLS.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'griplser'.
           COPY 'grimover'.
           COPY 'grimvxer'.
           COPY 'grimeper'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           IF IF-FL = ZERO
              MOVE 'anaazi' TO ID-AZI
              MOVE 'anaclf' TO ID-CLF
              MOVE 'tabell' TO ID-TAB
              MOVE 'movime' TO ID-MOV
              MOVE 'movmxx' TO ID-MVX
           ELSE
              MOVE 'anazol' TO ID-AZI
              MOVE 'anacfx' TO ID-CLF
              MOVE 'tabold' TO ID-TAB
              MOVE 'movmol' TO ID-MOV
              MOVE 'movoxx' TO ID-MVX.
      *
           OPEN INPUT MOVIME MOVMXX PLAPLS TABELL PLAMEP ANACLF ANAAZI.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           IF T25-ESE = ZERO OR IF-FL NOT = 1 GO TO INI-ELABORA-10.
           CLOSE TABELL.
           MOVE 'tabell' TO ID-TAB.
           OPEN INPUT TABELL.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
       INI-ELABORA-10.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           IF T25-PLA = ZERO OR
             (T25-ATT = ZERO AND T25-TIG = ZERO)
              MOVE 'Plafond non gestito' TO MESS
              GO TO ERRIO.
           MOVE T25-DTM TO T25DTM.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 5  TO KTB-COD.
           READ TABELL INTO REKTE14 INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTE14.
           IF T14IDIR = ZERO AND T14ITRI = ZERO AND
              T14IIND = ZERO AND T14ISCV = ZERO AND
              T14IRSM = ZERO AND T14IASS = ZERO AND
              T14ISIN = ZERO AND T141ACQ = ZERO AND
              T141ACR = ZERO AND T141ACT = ZERO AND
              T142ACQ = ZERO AND T143ACQ = ZERO AND
              T14IPOS = ZERO
              MOVE 'Mancano parametri' TO MESS
              GO TO ERRIO.
      *
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-CIVAQ TO CIVAQ.
           MOVE T01-CIVAV TO CIVAV.
           IF CIVAQ = ZERO OR CIVAV = ZERO
              MOVE 'Mancano conti IVA' TO MESS
              GO TO ERRIO.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DATA.
           MOVE 1 TO IF-TPSTA.
           MOVE 1 TO IF-TIPO.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DATA.
           MOVE 'IF-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG NOT > T25DTM
              PERFORM ERR-DINV
              GO TO V-ERROR.
           MOVE AAGGG TO DTMX.
       E-DATA.
      *
       V-TPSTA.
           MOVE 'IF-TPSTA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPSTA.
           IF NOT (IF-TPSTA = 1 OR 2)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TPSTA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.

           COPY 'grirpt-sn' REPLACING 1 BY 2 
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
           COPY 'grirpt-sn' REPLACING 1 BY 3 
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-3.
      *
           MOVE AZRGSOC TO RAZI.
           MOVE IF-DATA TO DTINT.
           MOVE SPACE TO DSINT.
           IF IF-TPSTA = 2 MOVE 'IRREGOLARI' TO DSINT.
           MOVE 3 TO FLGER.
           MOVE ZERO TO CIVA.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 62      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).

           MOVE NRGL TO SAVNRGL.
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
      *           MOVE RINTEN TO RP-TIT1.
           STRING 'PLAFOND - LISTA MOVIMENTI AL ' DTINT
                 DELIMITED SIZE INTO RP-TIT1.

      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
           PERFORM RPT-RIG1-INTC.

           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
       TST10.
           IF CIVA = CIVAV GO TO TST99.
           IF CIVA = ZERO
              MOVE CIVAQ TO CIVA
           ELSE
              MOVE CIVAV TO CIVA.
           MOVE KAZ-COD TO KMX-AZI KMV-AZI KPS-AZI.
           MOVE CIVA    TO KMX-CON KMV-CON KPS-CON.
           MOVE T25DTM  TO KMX-DAT KMV-DAT.
           MOVE ZERO TO KPS-DAT.
           MOVE ZERO TO KMX-NUM KMV-NUM KPS-NUM.
           START PLAPLS KEY NOT < KEYPS INVALID GO TO TST18.
       TST15.
           READ PLAPLS NEXT INTO REKMOV AT END GO TO TST18.
           IF SF-PLS = '9D' OR '9A' OR '35' GO TO TST15.
           IF KPS-AZI > KAZ-COD  GO TO TST18.
           IF KPS-CON NOT = CIVA GO TO TST18.
           IF KPS-DAT > DTMX     GO TO TST18.
           IF PLA-FLAG > ZERO    GO TO TST15.
           IF IF-TIPO = 2
              IF MOV-TREG NOT = 2 GO TO TST15.
           IF IF-TIPO = 3
              IF MOV-TREG NOT = 3 GO TO TST15.
           IF MOV-TIP = 4
              IF CIVA = CIVAV
                 GO TO TST15
              ELSE
                 MOVE MOV-IML TO MOVIMP
              END-IF
           ELSE
              MOVE MOV-IMP TO MOVIMP.
           MOVE ZERO TO FLGER.
           PERFORM A00-CTR THRU A99.
      *
           COPY 'grirpt-r' REPLACING 1 BY 3
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-3.
           GO TO TST15.
       TST18.
           START MOVMXX KEY > KEYMX INVALID GO TO TST30.
       TST20.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO TST30.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO TST20.
           IF KMX-AZI > KAZ-COD     GO TO TST30.
           IF KMX-CON NOT = CIVA    GO TO TST30.
           IF KMX-DAT NOT > T25-DTM GO TO TST20.
           IF KMX-DAT > DTMX        GO TO TST30.
           IF MOV-FLAG = 1          GO TO TST20.
           IF IF-TIPO = 2
              IF MOV-TREG NOT = 2 GO TO TST20.
           IF IF-TIPO = 3
              IF MOV-TREG NOT = 3 GO TO TST20.
           IF MOV-TIP = 4
              IF CIVA = CIVAV
                 GO TO TST20
              ELSE 
                 MOVE MOV-IML TO MOVIMP
           ELSE
              MOVE MOV-IMP TO MOVIMP.
           MOVE ZERO TO FLGER.
      *
           PERFORM A00-CTR THRU A99.
      *      
           COPY 'grirpt-r' REPLACING 1 BY 2
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
           GO TO TST20.
       TST30.
           START MOVIME KEY > KEYMV INVALID GO TO TST10.
       TST40.
           READ MOVIME NEXT INTO REKMOV AT END GO TO TST10.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO TST40.
           IF KMV-AZI > KAZ-COD     GO TO TST10.
           IF KMV-CON NOT = CIVA    GO TO TST10.
           IF KMV-DAT NOT > T25-DTM GO TO TST40.
           IF KMV-DAT > DTMX        GO TO TST10.
           IF MOV-FLAG = 1          GO TO TST40.
           IF IF-TIPO = 2
              IF MOV-TREG NOT = 2 GO TO TST40.
           IF IF-TIPO = 3
              IF MOV-TREG NOT = 3 GO TO TST40.
           IF MOV-TIP = 4
              IF CIVA = CIVAV
                 GO TO TST40
              ELSE
                 MOVE MOV-IML TO MOVIMP
           ELSE
              MOVE MOV-IMP TO MOVIMP.
           MOVE ZERO TO FLGER.
           PERFORM A00-CTR THRU A99.
      *
           COPY 'grirpt-r'.
             
           GO TO TST40.
       TST99.
            
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
      *
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       A00-CTR.
           IF CIVA = CIVAV GO TO A90.
           IF CIVA NOT = CIVAQ GO TO A99.
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF (MOV-IVA = T141ACQ OR T141ACR OR T141ACT OR
                         T142ACQ OR T143ACQ)
              OR T03-TSPLA > ZERO
              GO TO A90.
           GO TO A99.
       A90.
           PERFORM B00-STA THRU B99.
       A99.
           EXIT.
      *------------------
       B00-STA.
           MOVE ZERO TO FLGER.
           MOVE ZERO TO CATT.
           MOVE T25-TIG TO TIG.
           MOVE T25-DTP TO DTP.
           PERFORM CONV-DTP-A6.
           MOVE T25-TPL TO TPL.
           IF T25-ATT = ZERO GO TO B10.
           IF MOV-CATT = '0'
              MOVE MOV-CATT TO CATT
              GO TO B10.
           MOVE 35       TO T35-TIP.
           MOVE KAZ-COD  TO T35-CDAZ.
           MOVE MOV-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           IF T35-GES = ZERO GO TO B10.
           MOVE T35-CATT TO CATT.
           MOVE T35-TIG  TO TIG.
           MOVE T35-DTP  TO DTP.
           PERFORM CONV-DTP-A6.
           MOVE T35-TPL  TO TPL.
       B10.
           IF TIG = ZERO GO TO B99.
           MOVE MOV-NUM TO RNUM.
           MOVE MOV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RDAT.
           MOVE MOV-AZI TO KCF-AZI.
           MOVE MOV-ACF TO KCF-COD.
           READ ANACLF INVALID MOVE ALL '*' TO CLF-RGS
                               MOVE SPACE   TO CLF-RGS2.
           MOVE CLF-RGS TO RDES.
           MOVE 2        TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR
                MOVE ZERO TO T02-TIPOP.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T02-TIPOP TO TIPOP.
           MOVE TAB-DESCR TO RDCA. 
           MOVE MOV-NDOC  TO RNDO.
      *
           MOVE MOV-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RDDO.
      *
           MOVE MOVIMP TO RIMP.
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO TO REKTAB                                  
                MOVE ALL '*' TO T03-DSIVA
                MOVE ZERO TO T03-TPIVA.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE MOV-IVA   TO RCDI.
           MOVE T03-DSIVA TO RDSI.
           MOVE MOV-CATT  TO RCAT.
           IF MOV-MES = ZERO GO TO B15.
           MOVE MOV-MES TO RMES.
           MOVE '/' TO RBAR.
           IF MOV-ANN > 1
              ADD MOV-ANN TO AA4
              SUBTRACT 1 FROM AA4.
           IF MOV-ANN = 1
              SUBTRACT 1 FROM AA4.
           MOVE AA4 TO RANN.
       B15.
           IF IF-TPSTA = 2 GO TO B20.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           IF CLF-RGS2 = SPACE GO TO LSTF1.
           MOVE CLF-RGS2 TO RDES.
           IF NRIG NOT < NRGL MOVE NRGF TO NRGL.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE SAVNRGL TO NRGL.
       LSTF1.
           GO TO B99.
       B20.
           IF NOT (TIPOP = 1 OR 8)
              MOVE 1 TO FLGER
              MOVE 'CAUSALE NON VALIDA' TO RDCA
              GO TO B80.
           IF CIVA = CIVAQ GO TO B20-20.
           IF TIG = 1 GO TO B20-10.
           MOVE MOV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RDAT.
           MOVE MM9  TO PERMA.
           MOVE AA4  TO PERAA.
           MOVE DTP6 TO PERIO.
           MOVE PERM TO PLFMM.
           MOVE PERA TO PLFAA.
           IF DTCT2 NOT < DTCT1
              MOVE 1 TO FLGER 
              MOVE 'DATA MOVIMENTO ERRATA' TO RDCA
              GO TO B80.
       B20-10.
           IF CIVA = CIVAV AND                                         
            ((MOV-IVA = T14IDIR OR T14ITRI OR                        
                        T14IIND OR T14ISCV OR                        
                        T14IRSM OR T14IASS OR                        
                        T14IPOS OR T14ISIN)                        
                        OR T03-TSPLA > ZERO) GO TO B20-20.          
           GO TO B99.
       B20-20.
           IF NOT (T03-TPIVA = 3 OR 6)
              MOVE 1 TO FLGER
              MOVE 'CODICE IVA NON VALIDO' TO RDCA
              GO TO B80.
           IF MOV-MES > 12
              MOVE 1 TO FLGER 
              MOVE 'PERIODO ERRATO' TO RDCA
              GO TO B80.
           IF MOV-MES = ZERO 
              MOVE 1 TO FLGER 
              MOVE 'PERIODO NON DEFINITO' TO RDCA
              GO TO B80.
           IF CIVA = CIVAQ                              AND
              (MOV-IVA = T141ACQ OR T141ACR OR T141ACT) AND
              T03-TSPLA > 1                             GO TO B20-25.
           IF CIVA = CIVAQ AND MOV-IVA = T142ACQ                       
              AND NOT (T03-TSPLA = ZERO OR 2) 
              GO TO B20-25.
           IF CIVA = CIVAQ AND MOV-IVA = T143ACQ                       
              AND NOT (T03-TSPLA = ZERO OR 3)           
              GO TO B20-25.                               
           IF CIVA = CIVAV AND
              (MOV-IVA = T14IDIR OR T14ITRI OR                        
                         T14IIND OR T14ISCV OR                        
                         T14IRSM OR T14IPOS)
              AND T03-TSPLA > 1 GO TO B20-25.              
           IF CIVA = CIVAV AND MOV-IVA = T14IASS                       
              AND NOT (T03-TSPLA = ZERO OR 2)           
              GO TO B20-25.                               
           IF CIVA = CIVAV AND MOV-IVA = T14ISIN                       
              AND NOT (T03-TSPLA = ZERO OR 3)           
              GO TO B20-25.                               
           IF TPL = 1 GO TO B20-30.
           IF TPL = 2 AND CIVA = CIVAV AND                             
              (MOV-IVA = T14IASS OR T03-TSPLA = TPL)                 
              GO TO B20-30.
           IF TPL = 2 AND CIVA = CIVAQ AND 
              (MOV-IVA = T142ACQ OR T03-TSPLA = TPL)
              GO TO B20-30.
           IF TPL = 3 AND CIVA = CIVAV AND                             
              (MOV-IVA = T14ISIN OR T03-TSPLA = TPL)         
              GO TO B20-30.
           IF TPL = 3 AND CIVA = CIVAQ AND 
              (MOV-IVA = T143ACQ OR T03-TSPLA = TPL)
              GO TO B20-30.
       B20-25.                                                         
           MOVE 'IVA E TIPO PLAF.INCONG.' TO RDCA.
           MOVE 1 TO FLGER.
           GO TO B80.
       B20-30.
           MOVE MOV-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE MM9 TO PERM.
           MOVE AA4 TO PERAA.
           MOVE MOV-MES TO PERMA.
           IF MOV-ANN = 1
              SUBTRACT 1 FROM PERAA. 
           IF MOV-ANN > 1
              ADD MOV-ANN TO PERAA
              SUBTRACT 1 FROM PERAA.
           MOVE DTP6 TO PERIO.
           MOVE PERM TO PLFMM.
           MOVE PERA TO PLFAA.
           IF DTCT2 NOT < DTCT1
              MOVE 1 TO FLGER 
              MOVE 'PERIODO ERRATO' TO RDCA
              GO TO B80.
           MOVE PERAA TO PERA.
           IF TIG = 2 GO TO B40.
           IF CIVA NOT = CIVAQ GO TO B80.
           MOVE KAZ-COD TO KMP-AZI.
           MOVE CATT    TO KMP-ATT.
           MOVE PERA    TO KMP-ANN.
           MOVE ZERO    TO KMP-MES.
           MOVE TPL     TO KMP-TIP.
           IF TPL = 1 AND (MOV-IVA = T142ACQ OR T03-TSPLA = 2)
              MOVE 2 TO KMP-TIP.
           IF TPL = 1 AND (MOV-IVA = T143ACQ OR T03-TSPLA = 3)
              MOVE 3 TO KMP-TIP.
           GO TO B36.
       B30.
           SUBTRACT 1 FROM PERAA.
       B35.
           MOVE PERAA TO KMP-ANN.
       B36.
           READ PLAMEP INVALID
                       MOVE 1 TO FLGER
                       MOVE 'MANCA FILE TOTALI' TO RDCA.
           GO TO B80.
       B40.
           MOVE KAZ-COD TO KMP-AZI.
           MOVE CATT    TO KMP-ATT.
           MOVE PERA    TO KMP-ANN.
           MOVE MOV-MES TO KMP-MES.
           MOVE TPL     TO KMP-TIP.
           IF TPL = 1 AND CIVA = CIVAV AND                           
              (MOV-IVA = T14IASS OR T03-TSPLA = 2)                 
              MOVE 2 TO KMP-TIP.
           IF TPL = 1 AND CIVA = CIVAQ AND 
              (MOV-IVA = T142ACQ OR T03-TSPLA = 2)
              MOVE 2 TO KMP-TIP.
           IF TPL = 1 AND CIVA = CIVAV AND                           
              (MOV-IVA = T14ISIN OR T03-TSPLA = 3)                 
              MOVE 3 TO KMP-TIP.
           IF TPL = 1 AND CIVA = CIVAQ AND
              (MOV-IVA = T143ACQ OR T03-TSPLA = 3)
              MOVE 3 TO KMP-TIP.
           READ PLAMEP INVALID GO TO B50.
           GO TO B60.
       B50.
           IF MOV-MES = 1
              MOVE 12 TO KMP-MES
              SUBTRACT 1 FROM PERAA
              GO TO B35
           ELSE
              SUBTRACT 1 FROM KMP-MES
              GO TO B36.
       B60.
           IF CIVA NOT = CIVAV GO TO B80.
           MOVE MOV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4     TO KMP-ANN.
           MOVE MM9     TO KMP-MES.
           READ PLAMEP INVALID GO TO B70.
           GO TO B80.
       B70.
           IF MM9 > 1
              SUBTRACT 1 FROM KMP-MES
              GO TO B36.
           MOVE 12 TO KMP-MES.
           SUBTRACT 1 FROM KMP-ANN.
           GO TO B36.
       B80.
           IF FLGER = ZERO
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-AZZ
              GO TO B99.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
       B99.
           EXIT.
      *------------------
       CONV-DTP-A6.
           IF DTP = ZERO
              MOVE ZERO TO DTP6
           ELSE
              MOVE DTP TO DTP6
              MOVE AA61 TO AA62
              MOVE ZERO TO AA61
              CALL 'ranno4' USING AA6.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      
           MOVE ' Att.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Num. Mov.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Data Mov.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione Conto' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione Causale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE '   I.V.A.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Num. Doc.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Data Doc.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Importo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Periodo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
