      $SET LINKCOUNT"128"
       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRIT534.
      *
      *    Interfaccia TABAUT per scheda gestione Elenchi Iva
      *
      **** rel 6.3
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritausl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritau'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'grie02rk'.
           COPY 'griazirk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'prfisc'.
           COPY 'prpiva'.
           COPY 'parpcfgr'.
           COPY 'parpcfgc'.
      **** rel 7.1
       01  ESTERNE1 EXTERNAL.
           02 EX1-DTAPE   PIC 9(5).
           02 EX1-DTCHI   PIC 9(5).
      ************
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAU PIC X(15) VALUE 'tabaut'.
       01  COMODI.
           05 SF-AZI PIC XX.
           05 SF-TAU PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KK       PIC 99.
           05 J        PIC 9.
      **** rel 7.1
           05 K        PIC 99.
           05 VETMES  PIC X(12) VALUE 'ABCDEHLMPRST'.
           05 NUMMES  REDEFINES VETMES PIC X OCCURS 12.
           05 CDFISC  PIC X(16).
           05 DTFISC  REDEFINES CDFISC.
              10 FILLER PIC X(6).
              10 AN     PIC XX.
              10 ANM REDEFINES AN PIC 99.
              10 MS     PIC X.
              10 GI     PIC XX.
              10 GIM REDEFINES GI PIC 99.
              10 FILLER PIC X(5).
           05 DTFIVA  REDEFINES CDFISC.
              10 NUM    PIC X(11).
              10 BLK    PIC X(5).
      ************
       LINKAGE SECTION.
           COPY 'grie02rg'.
      *
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-T-CTRL
                                RG-T-REC
                                RA-T-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcltau'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-T-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-T-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
      **** rel 7.1
           IF RG-T-FL = 1
              PERFORM STORICO THRU EX-STORICO
              IF AA4 = ZERO 
                 MOVE 'Selezionare uno storico' TO MESS
                 GO TO ERRIO
              END-IF 
           ELSE
      *       MOVE 'allcfx' TO ID-LCC
              MOVE 'tabaut' TO ID-TAU.
      *       MOVE 'allcfr' TO ID-LCR.
      ************
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-T-FUN   TO FUN.
           MOVE RG-T-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'R' OR
                    'r' OR
                    'A' GO TO F-READ-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vRIT534: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-READ-AGGIOR.
           IF FUN = 'r' MOVE 1 TO FLCK.
           IF RG-T-NWIN = 1
              PERFORM LEG-AGG-E02A THRU EX-LEG-AGG-E02A
              GO TO END-F-READ-AGGIOR.
      **** rel 7.1
           IF RG-T-NWIN = 2
              PERFORM LEG-AGG-E02B THRU EX-LEG-AGG-E02B
              PERFORM LEG-AGG-E02C THRU EX-LEG-AGG-E02C
              GO TO END-F-READ-AGGIOR.
           IF RG-T-NWIN = 3
              PERFORM LEG-AGG-E02D THRU EX-LEG-AGG-E02D
              PERFORM LEG-AGG-E02E THRU EX-LEG-AGG-E02E
              GO TO END-F-READ-AGGIOR.
      ************
           IF RG-T-NWIN = 4
              PERFORM LEG-AGG-E02I THRU EX-LEG-AGG-E02I
              GO TO END-F-READ-AGGIOR.
      *    
           MOVE 'Numero maschera inesistente' TO MESS.
           GO TO ERRIO.
      *
       END-F-READ-AGGIOR.
           IF FUN = 'A' UNLOCK TABAUT.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           UNLOCK TABAUT.
           GO TO F-READ-AGGIOR.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-T-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK TABAUT.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-T-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI TABAUT.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-T-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-T-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritauer'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN I-O   TABAUT.
           OPEN INPUT ANAAZI.
      *     
           MOVE RG-T-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *     
           MOVE 02        TO E02-TIP.
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'A'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           READ TABAUT INVALID PERFORM SCRIVI-E02A THRU EX-SCRIVI-E02A.
      *     
      **** rel 7.1
           MOVE 02        TO E02-TIP.
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'B'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           READ TABAUT INVALID PERFORM SCRIVI-E02B THRU EX-SCRIVI-E02B.
      *     
           MOVE 02        TO E02-TIP.
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'C'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           READ TABAUT INVALID PERFORM SCRIVI-E02C THRU EX-SCRIVI-E02C.
      *     
           MOVE 02        TO E02-TIP.
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'D'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           READ TABAUT INVALID PERFORM SCRIVI-E02D THRU EX-SCRIVI-E02D.
      *     
           MOVE 02        TO E02-TIP.
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'E'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           READ TABAUT INVALID PERFORM SCRIVI-E02E THRU EX-SCRIVI-E02E.
      *     
      ************
           MOVE 02        TO E02-TIP.
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'I'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           READ TABAUT INVALID PERFORM SCRIVI-E02I THRU EX-SCRIVI-E02I.
      *     
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       READ-K.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ TABAUT INTO REKE02 INVALID PERFORM INVK-TAU
                                           GO TO ERRIO.
           IF SF-TAU = '9D' OR '9A' OR '35' MOVE RF-TAU TO REKE02.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ TABAUT INTO REKE02 KEPT LOCK INVALID PERFORM INVK-TAU
                                                     GO TO ERRIO.
           IF SF-TAU > ZERO MOVE 7 TO RG-T-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       REWRITE-K.
           REWRITE RF-TAU FROM REKE02 INVALID PERFORM INVK-TAU
                                              GO TO ERRIO.
       EX-REWRITE-K.
           EXIT.
      *------------------
       WRITE-NUOVA-TAU.
           MOVE 02      TO E02-TIP.
           MOVE KAZ-COD TO E02-COD.
           WRITE RF-TAU FROM REKE02 INVALID PERFORM INVK-TAU
                                            GO TO ERRIO.
       EX-WRITE-NUOVA-TAU.
      *------------------
       CARICA-REC-E02A.
           MOVE 02              TO E02-TIP.
           MOVE KAZ-COD         TO E02-COD.
           MOVE 'A'             TO E02-PRG.
      *
           MOVE RG-E02-MIN      TO E02-MIN.
           MOVE RG-E02-MINS     TO E02-MINS.
           MOVE RG-E02-MINT     TO E02-MINT.
      **** rel 7.1
           MOVE RG-E02-AGGREG   TO E02-AGGREG.
      ************
      *
           MOVE RG-E02-PATHECF  TO E02-PATHECF.
       EX-CARICA-REC-E02A.
           EXIT.
      *------------------
       CARICA-RG-E02A.
           MOVE E02-MIN         TO RG-E02-MIN.
           MOVE E02-MINS        TO RG-E02-MINS.
           MOVE E02-MINT        TO RG-E02-MINT.
      **** rel 7.1
           MOVE E02-AGGREG      TO RG-E02-AGGREG.
      ************
      *
           MOVE E02-PATHECF     TO RG-E02-PATHECF.
       EX-CARICA-RG-E02A.
           EXIT.
      *------------------
      **** rel 7.1
       CARICA-REC-E02B.
           MOVE 02              TO E02-TIP.
           MOVE KAZ-COD         TO E02-COD.
           MOVE 'B'             TO E02-PRG.
      *
           MOVE RG-E02-CFRAP    TO E02-CFRAP.
           MOVE RG-E02-CARAP    TO E02-CARAP.
           MOVE RG-E02-CFDIC    TO E02-CFDIC.
           MOVE RG-E02-CORAP    TO E02-CORAP.
           MOVE RG-E02-NORAP    TO E02-NORAP.
           MOVE RG-E02-SERAP    TO E02-SERAP.
           MOVE RG-E02-CONRAP   TO E02-CONRAP.
           MOVE RG-E02-PRNRAP   TO E02-PRNRAP.
           MOVE RG-E02-CFSOC    TO E02-CFSOC.
      *
           MOVE RG-E02-DTRAP    TO GGMMAA4.
           MOVE 4 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG           TO E02-DTRAP.
       EX-CARICA-REC-E02B.
           EXIT.
      *------------------
       CARICA-RG-E02B.
           MOVE E02-CFRAP       TO RG-E02-CFRAP.
           MOVE E02-CARAP       TO RG-E02-CARAP.
           MOVE E02-CFDIC       TO RG-E02-CFDIC.
           MOVE E02-CORAP       TO RG-E02-CORAP.
           MOVE E02-NORAP       TO RG-E02-NORAP.
           MOVE E02-SERAP       TO RG-E02-SERAP.
           MOVE E02-CONRAP      TO RG-E02-CONRAP.
           MOVE E02-PRNRAP      TO RG-E02-PRNRAP.
           MOVE E02-CFSOC       TO RG-E02-CFSOC.
      *
           MOVE E02-DTRAP     TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4       TO RG-E02-DTRAP.
       EX-CARICA-RG-E02B.
           EXIT.
      *------------------
       CARICA-REC-E02C.
           MOVE 02              TO E02-TIP.
           MOVE KAZ-COD         TO E02-COD.
           MOVE 'C'             TO E02-PRG.
           MOVE RG-E02-CORRAP   TO E02-CORRAP.
           MOVE RG-E02-PRRRAP   TO E02-PRRRAP.
           MOVE RG-E02-CARRAP   TO E02-CARRAP.
           MOVE RG-E02-INRRAP   TO E02-INRRAP.
           MOVE RG-E02-TELRAP   TO E02-TELRAP.
      **** rel 7.1
           MOVE RG-E02-DTIP TO GGMMAA4.
           MOVE 4 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG           TO E02-DTIP.
      *
           MOVE RG-E02-DTFP TO GGMMAA4.
           MOVE 4 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG           TO E02-DTFP.
      *
           MOVE RG-E02-DENOM    TO E02-DENOM.
      ************
       EX-CARICA-REC-E02C.
           EXIT.
      *------------------
       CARICA-REC-E02D.
           MOVE 02              TO E02-TIP.
           MOVE KAZ-COD         TO E02-COD.
           MOVE 'D'             TO E02-PRG.
           MOVE RG-E02-STAEST   TO E02-STAEST.
           MOVE RG-E02-CDSTA    TO E02-CDSTA.
           MOVE RG-E02-NIVAE    TO E02-NIVAE.
       EX-CARICA-REC-E02D.
           EXIT.
      *------------------
       CARICA-REC-E02E.
           MOVE 02              TO E02-TIP.
           MOVE KAZ-COD         TO E02-COD.
           MOVE 'E'             TO E02-PRG.
           MOVE RG-E02-EMAIL    TO E02-EMAIL.
           MOVE RG-E02-TEL      TO E02-TEL.
           MOVE RG-E02-FAX      TO E02-FAX.
       EX-CARICA-REC-E02E.
           EXIT.
      *------------------
      ************
       CARICA-REC-E02I.
           MOVE 02              TO E02-TIP.
           MOVE KAZ-COD         TO E02-COD.
           MOVE 'I'             TO E02-PRG.
           MOVE RG-E02-CFINT    TO E02-CFINT.
           MOVE RG-E02-NRCAF    TO E02-NRCAF.
           MOVE RG-E02-FLGMOD   TO E02-FLGMOD.
      *
           MOVE RG-E02-DTIMP TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG           TO E02-DTIMP.
       EX-CARICA-REC-E02I.
           EXIT.
      *------------------
      **** rel 7.1
       CARICA-RG-E02D.
           MOVE E02-STAEST   TO RG-E02-STAEST.
           MOVE E02-CDSTA    TO RG-E02-CDSTA.
           MOVE E02-NIVAE    TO RG-E02-NIVAE.
       EX-CARICA-RG-E02D.
           EXIT.
      *------------------
       CARICA-RG-E02E.
           MOVE E02-EMAIL  TO RG-E02-EMAIL.
           MOVE E02-TEL    TO RG-E02-TEL.
           MOVE E02-FAX    TO RG-E02-FAX.
       EX-CARICA-RG-E02E.
           EXIT.
      *------------------
      ************
       CARICA-RG-E02I.
           MOVE E02-CFINT       TO RG-E02-CFINT.
           MOVE E02-NRCAF       TO RG-E02-NRCAF.
           MOVE E02-FLGMOD      TO RG-E02-FLGMOD.
      *
           MOVE E02-DTIMP TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA          TO RG-E02-DTIMP.
       EX-CARICA-RG-E02I.
           EXIT.
      *------------------
      **** rel 7.1
       CARICA-RG-E02C.
           MOVE E02-CORRAP   TO RG-E02-CORRAP.
           MOVE E02-PRRRAP   TO RG-E02-PRRRAP.
           MOVE E02-CARRAP   TO RG-E02-CARRAP.
           MOVE E02-INRRAP   TO RG-E02-INRRAP.
           MOVE E02-TELRAP   TO RG-E02-TELRAP.
      **** rel 7.1
           MOVE E02-DTIP TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4         TO RG-E02-DTIP.
      *
           MOVE E02-DTFP TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4         TO RG-E02-DTFP.
      *
           MOVE E02-DENOM    TO RG-E02-DENOM.
      ************
       EX-CARICA-RG-E02C.
           EXIT.
      *------------------
      ************
       CARICA-RA.
           MOVE AZRGSOC TO RA-TW0-AZI-D.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi non chiave
       V-DATI.
           MOVE ZERO TO VFLD.
      *
           IF RG-T-NWIN = 1
              GO TO V-DATI-WINDOW1.
      **** rel 7.1
           IF RG-T-NWIN = 2
              GO TO V-DATI-WINDOW2.
           IF RG-T-NWIN = 3
              GO TO V-DATI-WINDOW3.
      ************
           IF RG-T-NWIN = 4
              GO TO V-DATI-WINDOW4.
      *
       V-DATI-WINDOW1.
      *
       V-MIN.
           MOVE 'MIN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-MIN.
      **** rel 7.1
      *    IF RG-E02-MIN = ZERO
      *       PERFORM ERR-ZERO
      *       GO TO V-ERROR.
      ************
       E-MIN.
      *
       V-MINS.
           MOVE 'MINS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-MINS.
           IF RG-E02-MINS = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-MINS.
      *
       V-MINT.
           MOVE 'MINT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-MINT.
       E-MINT.
      *
       V-PATHECF.
           MOVE 'PATHECF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PATHECF.
           IF RG-E02-PATHECF = SPACE 
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PATHECF.
      *
           GO TO END-V-DATI.
      **** rel 7.1
      *
       V-DATI-WINDOW2.
      *
       V-CFRAP.
           MOVE 'CFRAP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CFRAP.
           IF RG-E02-CFRAP = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE ZERO TO RISPFISC RISPIVA.
           IF RG-E02-CFRAP(12:) = SPACE AND RG-E02-CFRAP(1:11) NUMERIC
              MOVE RG-E02-CFRAP(1:11) TO CODPIVA
              CALL 'rpiva' USING PARPIVA
           ELSE
              MOVE RG-E02-CFRAP TO COMFISC
              CALL 'rfisc' USING PARFISC.
           IF RISPFISC NOT = ZERO OR RISPIVA NOT = ZERO 
              MOVE "Codice fiscale errato" TO MESS
              GO TO V-ERROR.
      *
           IF FUN NOT = 'V' GO TO E-CFRAP.
      *
           MOVE RG-E02-CFRAP TO CDFISC.
      *
           IF CDFISC = SPACE GO TO E-CFRAP.
           IF BLK = SPACE    GO TO E-CFRAP.
           IF NOT (AN NUMERIC AND GI NUMERIC) GO TO E-CFRAP.
           MOVE ZERO TO K.
       L-CDFISC.
           ADD 1 TO K.
           IF K > 12 GO TO E-CFRAP.
           IF MS NOT = NUMMES (K) GO TO L-CDFISC.
           MOVE K      TO MM9.
           MOVE ANM    TO AA9.
           MOVE GIM    TO GG9.
           IF GG9 > 31
              SUBTRACT 40 FROM GG9
              MOVE 'F' TO RG-E02-SERAP
           ELSE
              MOVE 'M' TO RG-E02-SERAP.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 NOT = ZERO
              MOVE SPACE TO RG-E02-SERAP
              GO TO E-CFRAP.
           MOVE GGMMAA4 TO RG-E02-DTRAP.
      *
       E-CFRAP.
      *
       V-CFDIC.
           MOVE 'CFDIC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CFDIC.
           IF RG-E02-CFDIC = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE ZERO TO RISPFISC RISPIVA.
           IF RG-E02-CFDIC(12:) = SPACE AND RG-E02-CFDIC(1:11) NUMERIC
              MOVE RG-E02-CFDIC(1:11) TO CODPIVA
              CALL 'rpiva' USING PARPIVA
           ELSE
              MOVE RG-E02-CFDIC TO COMFISC
              CALL 'rfisc' USING PARFISC.
           IF RISPFISC NOT = ZERO OR RISPIVA NOT = ZERO 
              MOVE "Codice fiscale errato" TO MESS
              GO TO V-ERROR.
       E-CFDIC.
      *
       V-DTRAP.
           MOVE 'DTRAP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTRAP.
           MOVE 4 TO TIPOP1.
           MOVE RG-E02-DTRAP TO GGMMAA4.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTRAP.
      *
      **** rel 7.1
       V-NORAP.
           MOVE 'NORAP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NORAP.
           IF RG-E02-CORAP = SPACE GO TO E-NORAP.
           IF RG-E02-NORAP = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-NORAP.
      *
       V-CONRAP.
           MOVE 'CONRAP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CONRAP.
           IF RG-E02-CORAP = SPACE GO TO E-CONRAP.
           IF RG-E02-CONRAP = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-CONRAP.
      *
      ************
       V-DTIP.
           MOVE 'DTIP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTIP.
           IF RG-E02-DTIP = ZERO
              GO TO E-DTIP.
           MOVE 4 TO TIPOP1.
           MOVE RG-E02-DTIP TO GGMMAA4.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTIP.
      *
       V-DTFP.
           MOVE 'DTFP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTFP.
           IF RG-E02-DTFP = ZERO
              GO TO E-DTFP.
           MOVE 4 TO TIPOP1.
           MOVE RG-E02-DTFP TO GGMMAA4.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTFP.
      *
           GO TO END-V-DATI.
       V-DATI-WINDOW3.
           GO TO END-V-DATI.
      ************
       V-DATI-WINDOW4.
      *
       V-CFIMT.
           MOVE 'CFINT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CFIMT.
      *
           MOVE ZERO TO RISPFISC RISPIVA.
           IF RG-E02-CFINT(12:) = SPACE AND RG-E02-CFINT(1:11) NUMERIC
              MOVE RG-E02-CFINT(1:11) TO CODPIVA
              CALL 'rpiva' USING PARPIVA
           ELSE
              MOVE RG-E02-CFINT TO COMFISC
              CALL 'rfisc' USING PARFISC.
           IF RISPFISC NOT = ZERO OR RISPIVA NOT = ZERO 
              MOVE "Codice fiscale errato" TO MESS
              GO TO V-ERROR.
           IF RG-E02-CFINT = SPACE MOVE ZERO TO RG-E02-NRCAF 
                                                RG-E02-DTIMP.
       E-CFIMT.
      *
       V-DTIMP.
           MOVE 'DTIMP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTIMP.
           MOVE 1 TO TIPOP1.
           MOVE RG-E02-DTIMP TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF RG-E02-CFINT NOT = SPACE AND
              RG-E02-DTIMP = ZERO
                 PERFORM ERR-ZERO
                 GO TO V-ERROR.
       E-DTIMP.
      *
           GO TO END-V-DATI.
      *
       END-V-DATI.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *---------------------------------------------------------------
      * Creazione record vuoto di una tabella inesistente            *
      *---------------------------------------------------------------
       SCRIVI-E02A.
           MOVE ZERO    TO REKE02.
      *
           MOVE 25000   TO E02-MIN.
           MOVE 99999999999,99 TO E02-MINS.
           MOVE 0       TO E02-MINT.
      *
           MOVE ' '    TO E02-PATHECF.
           IF EX-DFL NOT = LOW-VALUE AND
              EX-FL NOT = LOW-VALUE
                STRING EX-DFL EX-FL '\' DELIMITED SPACE
                       INTO E02-PATHECF.
           IF EX-WS NOT = LOW-VALUE AND
              EX-UTI NOT = LOW-VALUE
      **** rel 6.3
      *          MOVE EX-UTI TO PCFG-PATH
                 DISPLAY 'PRF-DIR' UPON ENVIRONMENT-NAME
                 ACCEPT PCFG-PATH FROM ENVIRONMENT-VALUE ON EXCEPTION
                        MOVE EX-UTI TO PCFG-PATH
                 END-ACCEPT
      ************
                 MOVE ZERO TO PCFG-R-FUN
                 MOVE EX-WS TO PCFG-R-WS
                 MOVE 'PATH-ECF' TO PCFG-R-COD
                 CALL 'readcfg' USING PARPCFG-R PCFG-CTR
                                      ON EXCEPTION MOVE 9 TO PCFG-ST
                 END-CALL
                 IF PCFG-ST = ZERO AND PCFG-R-VAL NOT = SPACE
                    MOVE SPACE TO E02-PATHECF
                    STRING PCFG-R-VAL '\' DELIMITED SPACE
                           INTO E02-PATHECF.
      *
           MOVE 'A'     TO E02-PRG.
           PERFORM WRITE-NUOVA-TAU THRU EX-WRITE-NUOVA-TAU.
       EX-SCRIVI-E02A.
           EXIT.
      *------------------
      **** rel 7.1
       SCRIVI-E02B.
           MOVE ZERO    TO REKE02.
           MOVE SPACE   TO E02-CFRAP
                           E02-CFDIC
                           E02-CORAP
                           E02-NORAP
                           E02-CONRAP
                           E02-PRNRAP.
           MOVE 'M'     TO E02-SERAP.
           MOVE 'B'     TO E02-PRG.
           PERFORM WRITE-NUOVA-TAU THRU EX-WRITE-NUOVA-TAU.
       EX-SCRIVI-E02B.
           EXIT.
      *----------------------------------------------------------------
       SCRIVI-E02C.
           MOVE ZERO    TO REKE02.
           MOVE SPACE   TO E02-CORRAP
                           E02-PRRRAP
                           E02-INRRAP
      **** rel 7.1
                           E02-DENOM
      ************
                           E02-TELRAP.
           MOVE 'C'     TO E02-PRG.
           PERFORM WRITE-NUOVA-TAU THRU EX-WRITE-NUOVA-TAU.
       EX-SCRIVI-E02C.
           EXIT.
      *----------------------------------------------------------------
       SCRIVI-E02D.
           MOVE ZERO    TO REKE02.
           MOVE SPACE   TO E02-STAEST
                           E02-CDSTA
                           E02-NIVAE.
           MOVE 'D'     TO E02-PRG.
           PERFORM WRITE-NUOVA-TAU THRU EX-WRITE-NUOVA-TAU.
       EX-SCRIVI-E02D.
           EXIT.
      *----------------------------------------------------------------
       SCRIVI-E02E.
           MOVE ZERO    TO REKE02.
           MOVE SPACE   TO E02-EMAIL
                           E02-TEL
                           E02-FAX.
           MOVE 'E'     TO E02-PRG.
           PERFORM WRITE-NUOVA-TAU THRU EX-WRITE-NUOVA-TAU.
       EX-SCRIVI-E02E.
           EXIT.
      *----------------------------------------------------------------
      ************
       SCRIVI-E02I.
           MOVE ZERO    TO REKE02.
           MOVE SPACE   TO E02-CFINT.
           MOVE 1       TO E02-FLGMOD.
      *
           MOVE 'I'     TO E02-PRG.
           PERFORM WRITE-NUOVA-TAU THRU EX-WRITE-NUOVA-TAU.
       EX-SCRIVI-E02I.
           EXIT.
      *----------------------------------------------------------------
      * Lettura - Caricamento RG 
      *       oppure
      * Lettura di riposizionamento - Caricamento REC - Rewrite Tabella
      *   dei dati relativi ad una tabella specifica
      *----------------------------------------------------------------
       LEG-AGG-E02A.
           MOVE ZERO  TO VKEY.
           MOVE 02        TO E02-TIP.
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'A'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
                 PERFORM CARICA-REC-E02A THRU EX-CARICA-REC-E02A
                 PERFORM REWRITE-K      THRU EX-REWRITE-K
              ELSE
                 PERFORM CARICA-RG-E02A THRU EX-CARICA-RG-E02A
                 PERFORM CARICA-RA      THRU EX-CARICA-RA.
       EX-LEG-AGG-E02A.
           EXIT.
      *------------------
      **** rel 7.1
       LEG-AGG-E02B.
           MOVE ZERO  TO VKEY.
           MOVE 02        TO E02-TIP.
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'B'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
                 PERFORM CARICA-REC-E02B THRU EX-CARICA-REC-E02B
                 PERFORM REWRITE-K      THRU EX-REWRITE-K
              ELSE
                 PERFORM CARICA-RG-E02B THRU EX-CARICA-RG-E02B
                 PERFORM CARICA-RA      THRU EX-CARICA-RA.
       EX-LEG-AGG-E02B.
           EXIT.
      *------------------
       LEG-AGG-E02C.
           MOVE ZERO  TO VKEY.
           MOVE 02        TO E02-TIP.
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'C'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
                 PERFORM CARICA-REC-E02C THRU EX-CARICA-REC-E02C
                 PERFORM REWRITE-K      THRU EX-REWRITE-K
              ELSE
                 PERFORM CARICA-RG-E02C THRU EX-CARICA-RG-E02C
                 PERFORM CARICA-RA      THRU EX-CARICA-RA.
       EX-LEG-AGG-E02C.
           EXIT.
      *------------------
       LEG-AGG-E02D.
           MOVE ZERO  TO VKEY.
           MOVE 02        TO E02-TIP.
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'D'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
                 PERFORM CARICA-REC-E02D THRU EX-CARICA-REC-E02D
                 PERFORM REWRITE-K      THRU EX-REWRITE-K
              ELSE
                 PERFORM CARICA-RG-E02D THRU EX-CARICA-RG-E02D
                 PERFORM CARICA-RA      THRU EX-CARICA-RA.
       EX-LEG-AGG-E02D.
           EXIT.
      *------------------
       LEG-AGG-E02E.
           MOVE ZERO  TO VKEY.
           MOVE 02        TO E02-TIP.
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'E'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
                 PERFORM CARICA-REC-E02E THRU EX-CARICA-REC-E02E
                 PERFORM REWRITE-K      THRU EX-REWRITE-K
              ELSE
                 PERFORM CARICA-RG-E02E THRU EX-CARICA-RG-E02E
                 PERFORM CARICA-RA      THRU EX-CARICA-RA.
       EX-LEG-AGG-E02E.
           EXIT.
      *------------------
      ************
       LEG-AGG-E02I.
           MOVE ZERO  TO VKEY.
           MOVE 02        TO E02-TIP.
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'I'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
                 PERFORM CARICA-REC-E02I THRU EX-CARICA-REC-E02I
                 PERFORM REWRITE-K      THRU EX-REWRITE-K
              ELSE
                 PERFORM CARICA-RG-E02I THRU EX-CARICA-RG-E02I
                 PERFORM CARICA-RA      THRU EX-CARICA-RA.
       EX-LEG-AGG-E02I.
           EXIT.
      *------------------
      **** rel 7.1
       STORICO.
           MOVE EX1-DTAPE TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AA4 = ZERO 
              GO TO EX-STORICO.
      *    STRING 'allcfx' AA4 DELIMITED SPACE INTO ID-LCC.
      *    STRING 'allcfr' AA4 DELIMITED SPACE INTO ID-LCR.
           STRING 'tabaut' AA4 DELIMITED SPACE INTO ID-TAU.
       EX-STORICO.
           EXIT.
      *------------------
      ************
