       IDENTIFICATION DIVISION.
       PROGRAM-ID. DSV-P-BFR.
      *
      * DATA SERVICE: righi Bolle Fornitori
      *
      **** rel 7.1
      * nuovo
      ************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gribftsl'.
           COPY 'gribfrsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'gribft'.
           COPY 'gribfr'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parer'.
      *
           COPY 'dsv-idbft.cpy'.
           COPY 'dsv-idart.cpy'.
           COPY 'dsv-odbcl'.
      *
       01  ID-BFT PIC X(15) VALUE 'bolfte'.
       01  ID-BFR PIC X(15) VALUE 'bolfri'.
       01  COMODI.
           05 SF-BFT   PIC XX.
           05 SF-BFR   PIC XX.
           05 MESS    PIC X(40) VALUE SPACE.
           05 SWOPE   PIC 9     VALUE ZERO.
      *
           05 COMEURO  PIC 9(3).
      *
       LINKAGE SECTION.
           COPY 'dsv-bfr.cpy'.
       PROCEDURE DIVISION USING D-BFR-P-IN.
           COPY 'declxer1'.
           COPY 'dclbft'.
           COPY 'dclbfr'.
           COPY 'declxer2'.
       INIZIO.
           IF D-BFR-FUN = 'C'
              PERFORM CL-FILE
              GO TO FINE.
      *
           COPY 'strsub'.
      *
           IF D-BFR-FUN = 'O'
              PERFORM OP-FILE
              GO TO FINE.

           INITIALIZE D-BFR-CAMPI.
           INITIALIZE D-BFR-IN-FLD.

           MOVE D-BFR-AZI TO KBF-AZI.
           MOVE D-BFR-PRT TO KBF-PRT.
      **** rel 7.2
      *    READ BOLFTE INITIALIZE BFT.
           READ BOLFTE INVALID INITIALIZE BFT.
      ************
      *
           MOVE KBF-AZI TO D-BFT-AZI.
           MOVE KBF-PRT TO D-BFT-PRT.
      *
           IF D-BFR-SERIE = ZERO
              MOVE BFT-DTBO TO    AAGGG
              MOVE 2        TO    TIPOP1
              CALL 'rdata'  USING PARCDT
              MOVE AA4      TO    D-BFT-SERIE
           ELSE
              MOVE D-BFR-SERIE TO D-BFT-SERIE.
      *
           MOVE 'RD' TO D-BFT-FUN.  *> read
           PERFORM CALL-ODBC-BFT.
           IF D-BFT-ID = ZERO GO TO FINE.
      *
           MOVE D-BFT-ID TO D-BFR-IDBFT.
      *
           MOVE KBF-AZI   TO KFR-AZI.
           MOVE KBF-PRT   TO KFR-PRT.
           MOVE D-BFR-PRG TO KFR-PRG.
           READ BOLFRI INVALID GO TO FINE.
      *
           CALL 'rveur' USING COMEURO.

           IF NOT (BFT-VALUT = ZERO OR COMEURO)
              MOVE ZERO TO ER-DATA
              CALL 'rvalut' USING BFT-VALUT ER-DATA CG-PAR
              IF CG-ST > ZERO
                 MOVE ZERO TO CG-CAMBIO CG-VALUT.
      *
           MOVE KFR-AZI    TO D-ART-AZI.
           MOVE BFR-CODART TO D-ART-COD.
      *
           IF BFR-CODART NOT = SPACE
              MOVE 'RD' TO D-ART-FUN   *> read
              PERFORM CALL-ODBC-ART
              MOVE D-ART-ID TO D-BFR-IDART.
      *
           MOVE BFR-TPRIG  TO D-BFR-TPRIG
           MOVE BFR-CDSPE  TO D-BFR-CDSPE
           MOVE BFR-TQUAN  TO D-BFR-TQUAN
           MOVE BFR-FSC    TO D-BFR-FSC
           MOVE BFR-DESCR  TO D-BFR-DESCR
           MOVE BFR-UNMIS  TO D-BFR-UNMIS
           MOVE BFR-CDIVA  TO D-BFR-CDIVA
           MOVE BFR-QUANT  TO D-BFR-QUANT
           MOVE BFR-PZLOR  TO D-BFR-PZLOR
           MOVE BFR-SCON1  TO D-BFR-SCON1
           MOVE BFR-PZNET  TO D-BFR-PZNET
           MOVE BFR-NETRG  TO D-BFR-NETRG
           MOVE BFR-CPART  TO D-BFR-CPART
           MOVE BFR-QUAFA  TO D-BFR-QUAFA
           MOVE BFR-VALFA  TO D-BFR-VALFA
           MOVE BFR-FLGFT  TO D-BFR-FLGFT
           MOVE BFR-NUMOV  TO D-BFR-NUMOV
           MOVE BFR-FLGORD TO D-BFR-FLGORD
           MOVE BFR-QUADOC TO D-BFR-QUADOC
           MOVE BFR-CONLOT TO D-BFR-CONLOT
           MOVE BFR-MQTA   TO D-BFR-MQTA
           MOVE BFR-MGIOR  TO D-BFR-MGIOR
           MOVE BFR-SCON2  TO D-BFR-SCON2
           MOVE BFR-NOMC   TO D-BFR-NOMC
      *
           IF NOT (BFR-TPRIG = ZERO OR 2 OR 3) OR
              (BFR-TPRIG = 3 AND BFR-FSC = ZERO)
                 GO TO NO-VAL.
      *
           MOVE BFR-NETRG TO  ER-IMPORTO.
           PERFORM IMP-EURO THRU EX-IMP-EURO.
           MOVE ER-IMPORTO TO D-BFR-NETEU.
      *
       NO-VAL.
      *
           PERFORM IBISCO-MIMOSA.
      *
           GO TO FINE.

       ERRIO.
           COPY 'errsub'.
       CHIUDI.
           IF ERRIO-ST NOT = ZERO OR
              D-BFR-FUN NOT = 'R'
                 PERFORM CL-FILE.
       FINE.
           EXIT PROGRAM.
      *-------------*
       OP-FILE.
           IF SWOPE = ZERO
              OPEN INPUT BOLFTE
              OPEN INPUT BOLFRI
      *
              PERFORM IBISCO-MIMOSA
      *
              MOVE 1 TO SWOPE.
      *-------------*
       CL-FILE.
           IF SWOPE = 1
              CLOSE BOLFTE
              CLOSE BOLFRI
      *
              PERFORM IBISCO-MIMOSA
      *
              MOVE ZERO TO SWOPE.
      *-------------*
       IBISCO-MIMOSA.
      * dati di Ibisco
           CALL 'dsv-i-bfr' USING D-BFR-P-IN
                ON EXCEPTION NEXT SENTENCE.
           IF ERRIO-ST > ZERO GO TO ERRIO.

      * dati di Mimosa
           CALL 'dsv-m-bfr' USING D-BFR-P-IN
                ON EXCEPTION NEXT SENTENCE.
           IF ERRIO-ST > ZERO GO TO ERRIO.

      * dati PERSONALIZZATI
           CALL 'dsv-c-bfr' USING D-BFR-P-IN
                ON EXCEPTION NEXT SENTENCE.
           IF ERRIO-ST > ZERO GO TO ERRIO.
      *-------------*
       CALL-ODBC-BFT.
           MOVE 1 TO D-ODBC-FUN.
           MOVE 'dsv-idbft' TO D-ODBC-PROC.
           CALL 'dsv-odbc' USING D-ODBC-CTR D-BFT-PAR.
      *
           IF D-ODBC-ST > ZERO PERFORM ERRIO-ODBC.
      *-------------*
       CALL-ODBC-ART.
           MOVE 1 TO D-ODBC-FUN.
           MOVE 'dsv-idart' TO D-ODBC-PROC.
           CALL 'dsv-odbc' USING D-ODBC-CTR D-ART-PAR.
      *
           IF D-ODBC-ST > ZERO PERFORM ERRIO-ODBC.
      *-------------*
       ERRIO-ODBC.
           MOVE D-ODBC-MSG TO F-MES1.
           MOVE 1 TO F-NMES.
           IF D-ODBC-SQLERRMC NOT = SPACE
              MOVE D-ODBC-SQLERRMC TO F-MES2
              MOVE 2 TO F-NMES.
           GO TO ERRIO.
      *-------------*
       IMP-EURO.
           IF NOT (BFT-VALUT = ZERO OR COMEURO)
              MOVE CG-CAMBIO TO ER-CAMBIO
              MOVE CG-VALUT  TO ER-VALUT
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
       EX-IMP-EURO.
          EXIT.
      *-------------*
