       IDENTIFICATION DIVISION.
       PROGRAM-ID. DSV-P-MSZ.
      *
      * DATA SERVICE: Movimenti Contabili Sezionale
      *
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'grimszsl'.
           COPY 'gritabsl'.
           COPY 'griazisl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'grimsz'.
           COPY 'gritab'.
           COPY 'griazi'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'grimovrk'.
           COPY 'gritabrk'.
           COPY 'griazirk'.
      *
       01  ID-MSZ PIC X(15) VALUE 'movsez'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  COMODI.
           05 SF-MSZ  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-AZI  PIC XX.
           05 MESS    PIC X(40) VALUE SPACE.
           05 SWOPE   PIC 9     VALUE ZERO.
           05 MCLI    PIC 99    VALUE ZERO.
           05 MFOR    PIC 99    VALUE ZERO.
           05 W-ACF   PIC 9(7)  VALUE ZERO.
      *
       LINKAGE SECTION.
           COPY 'dsv-mov.cpy'.
       PROCEDURE DIVISION USING D-MOV-P-IN.
           COPY 'declxer1'.
           COPY 'dclmsz'.
           COPY 'dcltab'.
           COPY 'dclazi'.
           COPY 'declxer2'.
       INIZIO.
           IF D-MOV-FUN = 'C'
              PERFORM CL-FILE
              GO TO FINE.
      *
           COPY 'strsub'.
      *
           IF D-MOV-FUN = 'O'
              PERFORM OP-FILE
              GO TO FINE.
      *
           INITIALIZE D-MOV-CAMPI.
           INITIALIZE D-MOV-IN-FLD.
      **** rel 7.2
           MOVE 'S' TO D-MOV-GS.
      ************
      *
           MOVE D-MOV-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID GO TO FINE
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE AZI-DTAPE TO AAGGG.
           MOVE 2         TO TIPOP1.
           CALL 'rdata'  USING PARCDT.
           MOVE AA4       TO D-MOV-ANNO.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO FINE.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
      *
           MOVE D-MOV-AZI   TO KMS-AZI.
           MOVE D-MOV-CON   TO KMS-CON.
           MOVE D-MOV-DAT   TO KMS-DAT.
           MOVE D-MOV-NUM   TO KMS-NUM.
           READ MOVSEZ INTO REKMOV INVALID GO TO FINE.
           IF SF-MSZ = '9D' OR '9A' OR '35' MOVE RF-MSZ TO REKMOV.
      *
      **** rel 7.2
      *    MOVE 'S'         TO D-MOV-GS
      ************
           MOVE MOV-CAUS    TO D-MOV-CAUS
           MOVE MOV-D-A     TO D-MOV-D-A
           MOVE MOV-TREG    TO D-MOV-TREG
           MOVE MOV-IMPO    TO D-MOV-IMPO
           MOVE MOV-NDOC    TO D-MOV-NDOC
           MOVE MOV-DTDOC   TO D-MOV-DTDOC
           MOVE MOV-DTSCD   TO D-MOV-DTSCD
           MOVE MOV-NPRGI   TO D-MOV-NPRGI
           MOVE MOV-FLAG    TO D-MOV-FLAG
           MOVE MOV-PART    TO D-MOV-PART
           MOVE MOV-NREG    TO D-MOV-NREG
           MOVE MOV-CATT    TO D-MOV-CATT
           MOVE MOV-FEV     TO D-MOV-FEV
           MOVE MOV-MES     TO D-MOV-MES
           MOVE MOV-ANN     TO D-MOV-ANN
           MOVE MOV-VALUT   TO D-MOV-VALUT
           MOVE MOV-CAMGG   TO D-MOV-CAMGG
           MOVE MOV-IMVAL   TO D-MOV-IMVAL
           MOVE MOV-CCOST   TO D-MOV-CCOST
           MOVE MOV-FLGPC   TO D-MOV-FLGPC
           MOVE MOV-FLGE2   TO D-MOV-FLGE2
           MOVE MOV-FLGBKA  TO D-MOV-FLGBKA
           MOVE MOV-DSAGG   TO D-MOV-DSAGG
      *
           MOVE ZERO        TO D-MOV-IVA.
           MOVE SPACE       TO D-MOV-TICF.
           MOVE ZERO        TO D-MOV-CDCF.
           MOVE ZERO        TO D-MOV-TIP.
           MOVE ZERO        TO D-MOV-IMP.
           MOVE ZERO        TO D-MOV-IVN.
           MOVE ZERO        TO D-MOV-IMV.
           MOVE ZERO        TO D-MOV-IML.
           MOVE ZERO        TO D-MOV-INL.
           MOVE ZERO        TO D-MOV-VAL.
      *
           PERFORM IBISCO-MIMOSA.
      *
           GO TO FINE.

       ERRIO.
           COPY 'errsub'.
       CHIUDI.
           IF ERRIO-ST NOT = ZERO OR
              D-MOV-FUN NOT = 'R'
                 PERFORM CL-FILE.
       FINE.
           EXIT PROGRAM.
      *-------------*
       OP-FILE.
           IF SWOPE = ZERO
              MOVE 'movsez' TO ID-MSZ
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              IF D-MOV-FLGOLD = 1
                 MOVE 'movsol' TO ID-MSZ
                 MOVE 'anazol' TO ID-AZI
                 MOVE 'tabold' TO ID-TAB
              END-IF
              IF D-MOV-FLGOLD = 2
                 MOVE 'movsxx' TO ID-MSZ
                 MOVE 'anaazi' TO ID-AZI
                 MOVE 'tabell' TO ID-TAB
              END-IF
              IF D-MOV-FLGOLD = 3
                 MOVE 'mosoxx' TO ID-MSZ
                 MOVE 'anazol' TO ID-AZI
                 MOVE 'tabold' TO ID-TAB
              END-IF

              OPEN INPUT MOVSEZ
              OPEN INPUT TABELL
              OPEN INPUT ANAAZI
      *
              PERFORM IBISCO-MIMOSA
      *
              MOVE 1 TO SWOPE.
      *-------------*
       CL-FILE.
           IF SWOPE = 1
              CLOSE MOVSEZ
              CLOSE TABELL
              CLOSE ANAAZI
      *
              PERFORM IBISCO-MIMOSA
      *
              MOVE ZERO TO SWOPE.
      *-------------*
       IBISCO-MIMOSA.
      * dati di Ibisco
           CALL 'dsv-i-msz' USING D-MOV-P-IN
                ON EXCEPTION NEXT SENTENCE.
           IF ERRIO-ST > ZERO GO TO ERRIO.

      * dati di Mimosa
           CALL 'dsv-m-msz' USING D-MOV-P-IN
                ON EXCEPTION NEXT SENTENCE.
           IF ERRIO-ST > ZERO GO TO ERRIO.

      * dati PERSONALIZZATI
           CALL 'dsv-c-msz' USING D-MOV-P-IN
                ON EXCEPTION NEXT SENTENCE.
           IF ERRIO-ST > ZERO GO TO ERRIO.
      *-------------*
