      *
      * Parametri locali di controllo interfaccia
      *
       01  RG-BCT-CTRL.
           05 RG-BCT-FUN       PIC X.
           05 RG-BCT-IDX       PIC 9.
           05 RG-BCT-CAMPO     PIC X(20).
           05 RG-BCT-ST        PIC 9.
           05 RG-BCT-EOF       PIC 9.
      **** rel 5.0
           05 RG-BCT-IMU-SW    PIC 9.
           05 RG-BCT-IMU-TUTTI PIC 9.
      ************
      *-------------------------------------------------------------
      * Note:
      * - ST : oltre ai valori soliti, puo' assumere altri valori.
      *        Sono commentati in testa al programma che li utilizza
      *-------------------------------------------------------------

      *
      * Record di interfaccia
      *
       01  RG-BCT-REC.
           05 RG-BCT-AZI       PIC 9(3).
           05 RG-BCT-NUM       PIC 9.
           05 RG-BCT-BOL       PIC 9(5).
      * data
           05 RG-BCT-DATA      PIC 9(6).
           05 RG-BCT-CLI       PIC 9(5).
           05 RG-BCT-TDOC      PIC 9.
           05 RG-BCT-FLGFT     PIC 9.
           05 RG-BCT-FLGMG     PIC 9.
           05 RG-BCT-RAGGR     PIC 9.
           05 RG-BCT-CDEP      PIC 99.
           05 RG-BCT-CSPE      PIC 999.
           05 RG-BCT-CPOR      PIC 999.
           05 RG-BCT-CPAG      PIC 999.
           05 RG-BCT-SCBAS     PIC 99V99.
           05 RG-BCT-CBAN      PIC 9(5).
           05 RG-BCT-ESIVA     PIC 999.
           05 RG-BCT-VALUT     PIC 999.
      **** rel 4.0
      *    05 RG-BCT-CAMGG     PIC 9999V999.
           05 RG-BCT-CAMGG     PIC 9(5)V9(6).
      ************
           05 RG-BCT-NORD      PIC 9(5).
      * data
           05 RG-BCT-DTORD     PIC 9(6).
           05 RG-BCT-DSORD     PIC X(10).
           05 RG-BCT-DSFAT     PIC X(30).
           05 RG-BCT-ZONA      PIC XXX.
           05 RG-BCT-SCIMP     PIC 9(7).
           05 RG-BCT-CAGE      PIC 999.
           05 RG-BCT-PROVV     PIC 99V99.
           05 RG-BCT-CAUS      PIC 999.
           05 RG-BCT-CDEP2     PIC 99.
           05 RG-BCT-CAUC      PIC 999.
           05 RG-BCT-CATT      PIC X.
           05 RG-BCT-FLGIS     PIC 9.
      **** rel 4.0
      *    05 RG-BCT-ACCON     PIC 9(9).
           05 RG-BCT-ACCON     PIC 9(11)V99.
      ************
           05 RG-BCT-FLACC     PIC 9.
      * riferimento fattura
           05 RG-BCT-NUDOC     PIC 9.
           05 RG-BCT-NUFAT     PIC 9(5).
      * -------------------
           05 RG-BCT-TMODU     PIC 9.
           05 RG-BCT-LISRF     PIC 999.
           05 RG-BCT-GGESC     PIC 99.
           05 RG-BCT-LCONS     PIC 99.
      **** rel 2.0
      * -------------------
           05 RG-BCT-IMB       PIC 9.
           05 RG-BCT-ESCFAT    PIC 9.
           05 RG-BCT-STAMP     PIC 9.
      ************
      **** rel 5.2
           05 RG-BCT-PBASE     PIC 999V99.
           05 RG-BCT-PRACC     PIC 99V99.
      ************
      **** rel 6.3
           05 RG-BCT-IFAT      PIC 99.
      ************
      **** rel 7.1
           05 RG-BCT-IPA       PIC X(6).
           05 RG-BCT-CIG       PIC X(10).
           05 RG-BCT-CUP       PIC X(15).
           05 RG-BCT-TIPO      PIC 9.
           05 RG-BCT-XML       PIC 9.
      ************
      **** rel 7.2
           05 RG-BCT-FAORD     PIC X(20).
           05 RG-BCT-FADTORD   PIC 9(6).
           05 RG-BCT-MCIVA     PIC 9.
      ************
      *
      * Dati aggiuntivi
      *
       01  RA-BCT-AGG.
           05 RA-BCT-TDOC-D    PIC X(39).
           05 RA-BCT-CATT-D    PIC X(24).
           05 RA-BCT-CDCLI-D1  PIC X(36).
           05 RA-BCT-CDCLI-D2  PIC X(36).
           05 RA-BCT-VALUT-D   PIC X(24).
           05 RA-BCT-CDEP-D    PIC X(24).
           05 RA-BCT-CAUS-D    PIC X(24).
           05 RA-BCT-CDEP2-D   PIC X(24).
           05 RA-BCT-CAUC-D    PIC X(24).
           05 RA-BCT-ZONA-D    PIC X(24).
           05 RA-BCT-CAGE-D    PIC X(24).
           05 RA-BCT-CPAG-D    PIC X(24).
           05 RA-BCT-CBAN-D    PIC X(36).
           05 RA-BCT-CSPE-D    PIC X(24).
           05 RA-BCT-CPOR-D    PIC X(24).
           05 RA-BCT-CESE-D    PIC X(24).
           05 RA-BCT-LISRF-D   PIC X(4).
           05 RA-BCT-LISRF-D1  PIC X(17).
      * data
           05 RA-BCT-DTCGG     PIC 9(6).
      **** rel 6.1
           05 RA-BCT-DTFAT     PIC 9(6).
      ************
      **** rel 6.3
           05 RA-BCT-IFAT-D    PIC X(24).
      ************
      **** rel 7.1
           05 RA-BCT-FELE      PIC 9.
      ************
