       IDENTIFICATION DIVISION.
       PROGRAM-ID. UTI710.
      *
      * OGGETTO   :   GESTIONE ARCHIVIO FILE PARTIT (ex UTI920)
      *
      **** rel 7.2
      * recuperato programma a carattere
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'griparsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'gripar'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griparrk'.
           COPY 'gritabrk'.
           COPY 'parcdt'.
      **** rel 7.2
      *    COPY 'parx'.
      *    COPY 'parzf'.
      *    COPY 'wconf'.
           COPY '_parx'.
           COPY '_parzf'.
           COPY '_wconf'.
      ************
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-PAR PIC X(15) VALUE 'partit'.
       01  COMODI.
           05 SF-AZI  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-PAR  PIC XX.
           05 MESS    PIC X(20).
           05 IDE-DES PIC X(20) VALUE SPACE.
           05 RISP    PIC 9.
           05 INT1    PIC X(18).
           05 FUNZ    PIC 9.
           05 CAN.
              10 TIPO  PIC 9.
              10 CLF   PIC 9(5).
              10 ANNO  PIC 9(4).
              10 PART  PIC 9(5).
              10 NUME  PIC 99.
           05 CHIAVE REDEFINES CAN PIC 9(17).
           05 CLIENTE.
              10 MASCLI PIC 99.
              10 CODCLI PIC 9(5).
           05 FORNIT.
              10 MASFOR PIC 99.
              10 CODFOR PIC 9(5).
           05 TIP    PIC 9.
           05 DESCR  PIC X(20).
           05 SALDO  PIC S9(11)V99.
           05 NUMPA  PIC S9(9).
           05 DTCON  PIC 9(6).
           05 PKDTCON PIC 9(5) COMP-3.
           05 CAUS   PIC 9(3).
           05 TIPOP  PIC 99.
           05 DTSCA  PIC 9(6).
           05 PKDTSCA PIC 9(5) COMP-3.
           05 NDOC   PIC 9(5).
           05 DTDOC  PIC 9(6).
           05 PKDTDOC PIC 9(5) COMP-3.
           05 IMPOR  PIC S9(11)V99.
           05 VIMPO  PIC S9(11)V99.
           05 CAMGG  PIC 9(5)V9(6).
           05 VSALD  PIC S9(11)V99.
           05 CADOC  PIC 9(5)V9(6).
           05 VALUT  PIC 9(3).
           05 DSINT  PIC X(4).
           05 DA     PIC X.
           05 NPIVA  PIC 9(5).
           05 DT1    PIC 9(6).
           05 PKDT1  PIC 9(5) COMP-3.
           05 LT1    PIC S9(11)V99.
           05 DT2    PIC 9(6).
           05 PKDT2  PIC 9(5) COMP-3.
           05 LT2    PIC S9(11)V99.
           05 DT3    PIC 9(6).
           05 PKDT3  PIC 9(5) COMP-3.
           05 LT3    PIC S9(11)V99.
           05 DT4    PIC 9(6).
           05 PKDT4  PIC 9(5) COMP-3.
           05 LT4    PIC S9(11)V99.
           05 DT5    PIC 9(6).
           05 PKDT5  PIC 9(5) COMP-3.
           05 LT5    PIC S9(11)V99.
           05 DT6    PIC 9(6).
           05 PKDT6  PIC 9(5) COMP-3.
           05 LT6    PIC S9(11)V99.
           05 VT1    PIC S9(11)V99.
           05 VT2    PIC S9(11)V99.
           05 VT3    PIC S9(11)V99.
           05 VT4    PIC S9(11)V99.
           05 VT5    PIC S9(11)V99.
           05 VT6    PIC S9(11)V99.
       01  W-LINEE   PIC X(80) VALUE ALL '-'.
       01  MESSAGG1.
           05 FILLER PIC X(18) VALUE '       INSERIMENTO'.
           05 FILLER PIC X(18) VALUE 'VISUALIZ./MODIFICA'.
       01  MESS-RED2 REDEFINES MESSAGG1.
           05 MSSX PIC X(18) OCCURS 2.
       01  WANNUL.
           05 FILLER PIC X(28) VALUE SPACE.
           05 FILLER PIC 99    VALUE 2.
           05 FILLER PIC 99    VALUE 2.
           05 FILLER PIC X(30) VALUE '9 ANNULLA'.
           05 FILLER PIC X(30) VALUE '0 ABBANDONA'.
       01  WSCRCNT.
           05 FILLER PIC X(28) VALUE SPACE.
           05 FILLER PIC 99    VALUE 4.
           05 FILLER PIC 99    VALUE 1.
           05 FILLER PIC X(30) VALUE '0 CONTINUA'.
           05 FILLER PIC X(30) VALUE '1 MODIFICA'.
           05 FILLER PIC X(30) VALUE '2 ABBANDONA'.
           05 FILLER PIC X(30) VALUE '9 ANNULLA'.
       SCREEN SECTION.
      **** rel 7.2
      *    COPY 'scrlog'.
           COPY '_scrlog'.
      ************
       01  SCR000.
           05 LINE 1  COLUMN 1  PIC X(18) FROM INT1.
           05 LINE 1  COLUMN 20  VALUE 
             'ARCHIVIO ESTRATTO CONTO'.
           05 LINE 1  COLUMN 45 PIC X(36) FROM  AZRGSOC.
           05 LINE 2  COLUMN 1  PIC X(80) FROM W-LINEE.
       01  SCR110.
           05 LINE 8  COLUMN 30 VALUE
             '0 = FINE LAVORO'.
           05 LINE 10 COLUMN 30 VALUE 
             '1 = INSERIMENTO'.
           05 LINE 12 COLUMN 30 VALUE 
             '2 = VISUAL. O MODIFICA'.
           05 SRSPD  LINE 15 COLUMN 50 VALUE 
             'RISPOSTA :'.
           05 SRSPR LINE 15 COLUMN 61 PIC 9 USING FUNZ.
       01  SCRCOD.
           05 LINE 1  COLUMN 20  VALUE 
             '* GESTIONE ARCHIVIO ESTRATTO CONTO *'.
           05 LINE 2  COLUMN 1  PIC X(80) FROM W-LINEE.
           05 LINE 10 COLUMN 1 VALUE
           'Codice azienda (0=Fine) .....:'.
           05 SCAZI          COLUMN 32 PIC ZZ9   USING KAZ-COD.
           05 SDAZI          COLUMN 36 PIC X(36) FROM AZRGSOC.
       01  SCRDAT1.
           05 LINE 10 COLUMN 1 VALUE
           'Saldo partita (PAR-SALDO) ...:'.
           05 SSALDO         COLUMN 35 PIC ZZZ.ZZZ.ZZ9,99- USING SALDO.
           05 LINE 11 COLUMN 1 VALUE
           'Saldo valuta  (PAR-VSALD) ...:'.
           05 SVSALD         COLUMN 32 PIC ZZ.ZZZ.ZZZ.ZZ9,99-
                                                 USING VSALD.
           05 LINE 12 COLUMN 1 VALUE
           'Codice valuta (PAR-VALUT) ...:'.
           05 SVALUT         COLUMN 46 PIC ZZ9 USING VALUT.
           05 SDSINT         COLUMN 50 PIC X(4) FROM DSINT.
           05 LINE 13 COLUMN 1 VALUE
           'Cambio docum. (PAR-CADOC) ...:'.
           05 SCADOC         COLUMN 37 PIC ZZZZ9,999999 USING CADOC.
           05 LINE 14 COLUMN 1 VALUE
           'Records/partita (PAR-NUMPA) .:'.
           05 SNUMPA         COLUMN 38 PIC    ZZZ.ZZZ.ZZ9- USING NUMPA.
       01  SCRDAT2.
           05 LINE 10 COLUMN 1 VALUE
           'Data contabile (PAR-DTCON) ..:'.
           05 SDTCON         COLUMN 41 PIC 99/99/99 USING DTCON.
           05 LINE 11 COLUMN 1 VALUE
           'Causale (PAR-CAUS) ..........:'.
           05 SCAUS          COLUMN 46 PIC ZZ9   USING CAUS.
           05 SDCAU          COLUMN 51 PIC X(24) FROM TAB-RST.
           05 LINE 12 COLUMN 1 VALUE
           'Tipo operazione (PAR-TIPOP) .:'.
           05 STIPOP         COLUMN 47 PIC Z9    USING TIPOP.
           05 LINE 13 COLUMN 1 VALUE
           'Data scadenza (PAR-DTSCA) ...:'.
           05 SDTSCA         COLUMN 41 PIC 99/99/99 USING DTSCA.
           05 LINE 14 COLUMN 1 VALUE
           'Numero documento (PAR-NDOC) .:'.
           05 SNDOC          COLUMN 43 PIC ZZ.ZZ9 USING NDOC.
           05 LINE 15 COLUMN 1 VALUE
           'Data documento (PAR-DTDOC) ..:'.
           05 SDTDOC         COLUMN 41 PIC 99/99/99 USING DTDOC.
           05 LINE 16 COLUMN 1 VALUE
           'Importo (PAR-IMPOR) .........:'.
           05 SIMPOR         COLUMN 32 PIC ZZ.ZZZ.ZZZ.ZZ9,99- 
                                                           USING IMPOR.
           05 LINE 17 COLUMN 1 VALUE
           'Importo Valuta (PAR-VIMPO) ..:'.
           05 SVIMPO         COLUMN 32 PIC ZZ.ZZZ.ZZZ.ZZ9,99-
                                                  USING VIMPO.
           05 LINE 18 COLUMN 1 VALUE
           'Cambio         (PAR-CAMGG) ..:'.
           05 SCAMGG         COLUMN 37 PIC ZZZZ9,999999 USING CAMGG.
           05 LINE 19 COLUMN 1 VALUE
           'Dare/Avere (PAR-D-A) ........:'.
           05 SDA            COLUMN 48 PIC X USING DA.
           05 LINE 20 COLUMN 1 VALUE
           'N. protocollo IVA (PAR-NPIVA):'.
           05 SNPIVA         COLUMN 43 PIC ZZ.ZZ9 USING NPIVA.
       01  SCRDAT3.
           05 LINE 10 COLUMN 1 VALUE
           'Descr. aggiuntiva (PAR-DESCR):'.
           05 SDESCR         COLUMN 32 PIC X(20) USING DESCR.
       01  SCRDAT4.
           05 LINE 10 COLUMN 1 VALUE
           'Scadenza 1 (PAR-DT(1)) .:'.
           05 SDT1           COLUMN 33 PIC 99/99/99 USING DT1.
           05 LINE 11 COLUMN 1 VALUE
           'Importo 1 (PAR-LT(1)) ..:'.
           05 SLT1           COLUMN 27 PIC ZZ.ZZZ.ZZZ.ZZ9,99- USING LT1.
           05                COLUMN 46 VALUE 'Val.(PAR-VT) .:'.
           05 SVT1           COLUMN 62 PIC ZZ.ZZZ.ZZZ.ZZ9,99- 
                                                    USING VT1.
           05 LINE 12 COLUMN 1 VALUE
           'SCadenza 2 (PAR-DT(2)) .:'.
           05 SDT2           COLUMN 33 PIC 99/99/99 USING DT2.
           05 LINE 13 COLUMN 1 VALUE
           'Importo 2 (PAR-LT(2)) ..:'.
           05 SLT2           COLUMN 27 PIC ZZ.ZZZ.ZZZ.ZZ9,99- USING LT2.
           05                COLUMN 46 VALUE 'Val.(PAR-VT) .:'.
           05 SVT2           COLUMN 62 PIC ZZ.ZZZ.ZZZ.ZZ9,99- 
                                                    USING VT2.
           05 LINE 14 COLUMN 1 VALUE
           'Scadenza 3 (PAR-DT(3)) .:'.
           05 SDT3           COLUMN 33 PIC 99/99/99 USING DT3.
           05 LINE 15 COLUMN 1 VALUE
           'Importo 3 (PAR-LT(3)) ..:'.
           05 SLT3           COLUMN 27 PIC ZZ.ZZZ.ZZZ.ZZ9,99- USING LT3.
           05                COLUMN 46 VALUE 'Val.(PAR-VT) .:'.
           05 SVT3           COLUMN 62 PIC ZZ.ZZZ.ZZZ.ZZ9,99- 
                                                    USING VT3.
           05 LINE 16 COLUMN 1 VALUE
           'Scadenza 4 (PAR-DT(4)) .:'.
           05 SDT4           COLUMN 33 PIC 99/99/99 USING DT4.
           05 LINE 17 COLUMN 1 VALUE
           'Importo 4 (PAR-LT(4)) ..:'.
           05 SLT4           COLUMN 27 PIC ZZ.ZZZ.ZZZ.ZZ9,99- USING LT4.
           05                COLUMN 46 VALUE 'Val.(PAR-VT) .:'.
           05 SVT4           COLUMN 62 PIC ZZ.ZZZ.ZZZ.ZZ9,99- 
                                                    USING VT4.
           05 LINE 18 COLUMN 1 VALUE
           'Scadenza 5 (PAR-DT(5)) .:'.
           05 SDT5           COLUMN 33 PIC 99/99/99 USING DT5.
           05 LINE 19 COLUMN 1 VALUE
           'Importo 5 (PAR-LT(5)) ..:'.
           05 SLT5           COLUMN 27 PIC ZZ.ZZZ.ZZZ.ZZ9,99- USING LT5.
           05                COLUMN 46 VALUE 'Val.(PAR-VT) .:'.
           05 SVT5           COLUMN 62 PIC ZZ.ZZZ.ZZZ.ZZ9,99- 
                                                    USING VT5.
           05 LINE 20 COLUMN 1 VALUE
           'Scadenza 6 (PAR-DT(6)) .:'.
           05 SDT6           COLUMN 33 PIC 99/99/99 USING DT6.
           05 LINE 21 COLUMN 1 VALUE
           'Importo 6 (PAR-LT(6)) ..:'.
           05 SLT6           COLUMN 27 PIC ZZ.ZZZ.ZZZ.ZZ9,99- USING LT6.
           05                COLUMN 46 VALUE 'Val.(PAR-VT) .:'.
           05 SVT6           COLUMN 62 PIC ZZ.ZZZ.ZZZ.ZZ9,99- 
                                                    USING VT6.
       01  SCRKEY.
           05 LINE 3  COLUMN 1  VALUE
           'Tipo registrazione (0/2/3) ..:'.
           05 STIPO          COLUMN 36 PIC 9     USING TIPO.
           05 LINE 4  COLUMN 1 VALUE
           'Codice cliente/fornitore ....:'.
           05 SCLF           COLUMN 32 PIC ZZZZ9 USING CLF.
           05 SDCLF          COLUMN 40 PIC X(36) FROM  CLF-RGS.
           05 LINE 5  COLUMN 1 VALUE
           'Anno partita ................:'.
           05 SANNO          COLUMN 33 PIC ZZZ9  USING ANNO.
           05 LINE 6  COLUMN 1 VALUE
           'Numero partita ..............:'.
           05 SPART          COLUMN 32 PIC ZZZZ9 USING PART.
           05 LINE 7  COLUMN 1 VALUE
           'Progressivo rigo ............:'.
           05 SNUME          COLUMN 35 PIC Z9    USING NUME.
       01  SCRDAT0.
           05 LINE 8  COLUMN 1 VALUE
           'Tipo rigo (PAR-TIP) .........:'.
           05 STIP  LINE 8 COLUMN 36 PIC 9     USING TIP.
           05 LINE 8 COLUMN 38 VALUE
           '(1=Testata 2=Rigo 3=Descrittivo 4=Scadenze)'.
       01  SCRBLK.
           05 LINE 21 COLUMN 1 VALUE ' ' BLANK LINE.
           05 LINE 20 COLUMN 1 VALUE ' ' BLANK LINE.
           05 LINE 19 COLUMN 1 VALUE ' ' BLANK LINE.
           05 LINE 18 COLUMN 1 VALUE ' ' BLANK LINE.
           05 LINE 17 COLUMN 1 VALUE ' ' BLANK LINE.
           05 LINE 16 COLUMN 1 VALUE ' ' BLANK LINE.
           05 LINE 15 COLUMN 1 VALUE ' ' BLANK LINE.
           05 LINE 14 COLUMN 1 VALUE ' ' BLANK LINE.
           05 LINE 13 COLUMN 1 VALUE ' ' BLANK LINE.
           05 LINE 12 COLUMN 1 VALUE ' ' BLANK LINE.
           05 LINE 11 COLUMN 1 VALUE ' ' BLANK LINE.
           05 LINE 10 COLUMN 1 VALUE ' ' BLANK LINE.
       PROCEDURE DIVISION.
           COPY 'declxer1'.
      **** rel 7.2
      *    COPY 'dclazi'.
      *    COPY 'dclclf'.
      *    COPY 'dclpar'.
      *    COPY 'dcltab'.
      *    COPY 'declxer2'.
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==AZI==
                                   ==NFILE== BY ==ANAAZI==.
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==CLF==
                                   ==NFILE== BY ==ANACLF==.
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==PAR==
                                   ==NFILE== BY ==PARTIT==.
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==TAB==
                                   ==NFILE== BY ==TABELL==.
           COPY '_dclxer2'.
      ************
       INIZIO.
           OPEN INPUT TABELL ANACLF ANAAZI.
           OPEN I-O   PARTIT.
           MOVE 'uti710' TO X-NOT F-NOT.
           MOVE 'UTILITA''' TO STK-LAB.
      **** rel 7.2
      *    COPY 'readide'.
           COPY '_readide'.
      ************
           MOVE ZERO TO TIPOP1 GGMMAA.
           CALL 'rdata' USING PARCDT. 
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MASCLI.
           MOVE T01-MFOR TO MASFOR.
       LPAZI.
           MOVE ZERO TO KAZ-COD.
           MOVE SPACE TO AZRGSOC INT1.
           DISPLAY SCRLOG.
           DISPLAY SCRCOD.
       LB001.
           ACCEPT SCAZI.
           DISPLAY SCAZI.
           IF KAZ-COD = ZERO GO TO FINE.
           READ ANAAZI INVALID 
                MOVE SPACE TO AZRGSOC DISPLAY SDAZI 
                PERFORM ERR-CINE GO TO LB001.
           DISPLAY SDAZI.
           CALL 'rxcnf' USING PARX CNF1.
           MOVE X-COD TO RISP.
           IF RISP > ZERO GO TO LB001.
       TIPLV.
           MOVE ZERO TO FUNZ.
           MOVE SPACE TO INT1.
           DISPLAY SCRLOG.
           DISPLAY SCR000.
           DISPLAY SCR110.
           ACCEPT SRSPR.
           DISPLAY SRSPR.
           IF FUNZ = ZERO GO TO LPAZI.
           IF FUNZ > 2 GO TO TIPLV.
           MOVE MSSX (FUNZ) TO INT1.
           GO TO CARIC VARIA DEPENDING ON FUNZ.
      *----------*
       CARIC.
           MOVE ZERO TO TIPO CLF ANNO PART NUME TIP SALDO NUMPA
                        DTCON CAUS TIPOP DTSCA NDOC DTDOC IMPOR
                        VALUT VSALD CADOC VIMPO CAMGG DT5 DT6
                        LT5 LT6 VT1 VT2 VT3 VT4 VT5 VT6
                        NPIVA DT1 DT2 DT3 DT4 LT1 LT2 LT3 LT4.
           MOVE SPACE TO DESCR DA CLF-RGS TAB-RST.
           MOVE SPACE TO DSINT.
           DISPLAY SCRLOG.
           DISPLAY SCR000.
           DISPLAY SCRKEY.
           DISPLAY SCRDAT0.
       C001.
           ACCEPT STIPO.
           DISPLAY STIPO.
           IF TIPO = ZERO GO TO TIPLV.
           IF TIPO < 2 OR TIPO > 3 GO TO C001.
       C010.
           ACCEPT SCLF.
           DISPLAY SCLF.
           IF TIPO = 2 MOVE CLF TO CODCLI MOVE CLIENTE TO KCF-COD
           ELSE MOVE CLF TO CODFOR MOVE FORNIT TO KCF-COD.
           MOVE KAZ-COD TO KCF-AZI.
           READ ANACLF INVALID 
                MOVE SPACE TO CLF-RGS DISPLAY SDCLF 
                PERFORM ERR-CINE GO TO C010.
           DISPLAY SDCLF.
           ACCEPT SANNO.
           CALL 'ranno4' USING ANNO.
           DISPLAY SANNO.
           ACCEPT SPART.
           DISPLAY SPART.
           ACCEPT SNUME.
           DISPLAY SNUME.
       C020.
           ACCEPT STIP.
           DISPLAY STIP.
           IF TIP < 1 OR TIP > 4 GO TO C020.
           MOVE KAZ-COD TO KPA-AZI.
           MOVE CHIAVE  TO KPA-CAN.
           READ PARTIT INTO REKPAR INVALID GO TO C030.
           IF SF-PAR = '9D' OR '9A' OR '35' MOVE RF-PAR TO REKPAR.
           MOVE 'PARTITA ESISTENTE' TO F-MES1.
           MOVE 11 TO F-FUN.
           CALL 'rzfunz' USING PARF.
           GO TO C001.
       C030.
           MOVE KEYPA TO PAR-KEYID.
           MOVE TIP TO PAR-TIP.
           MOVE ZERO TO PAR-DESCR.
           GO TO C050 C100 C150 C200 DEPENDING ON TIP.
      * 
      * TESTATA
      *
       C050.
           DISPLAY SCRDAT1.
           ACCEPT SSALDO.
           DISPLAY SSALDO.
       C052.
           ACCEPT  SVSALD.
           DISPLAY SVSALD.
           ACCEPT  SVALUT.
           DISPLAY SVALUT.
           IF VALUT = ZERO AND VSALD NOT = ZERO GO TO C052.
           IF VALUT = ZERO MOVE SPACE TO DSINT  DISPLAY SDSINT
                           MOVE ZERO TO CADOC DISPLAY SCADOC
                                                  GO TO C054.
           MOVE 10 TO KTB-TIP.
           MOVE VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID 
                MOVE SPACE TO TAB-RST DSINT DISPLAY SDSINT 
                PERFORM ERR-CINE GO TO C052.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO DSINT.
           DISPLAY SDSINT.
       C053.
           ACCEPT  SCADOC.
           DISPLAY SCADOC.
           IF CADOC = ZERO GO TO C053.
       C054.
           ACCEPT SNUMPA.
           DISPLAY SNUMPA.
       C055.
           CALL 'rxcnf' USING PARX CNF2.
           MOVE X-COD TO RISP.
           IF RISP > 2 GO TO C055.
           IF RISP = 1 GO TO C050.
           IF RISP = 2 GO TO CARIC.
           MOVE SALDO TO PAR-SALDO.
           MOVE NUMPA TO PAR-NUMPA.
           MOVE VSALD TO PAR-VSALD.
           MOVE VALUT TO PAR-VALUT.
           MOVE CADOC TO PAR-CADOC.
           WRITE RF-PAR FROM REKPAR INVALID PERFORM INVK-PAR
                                            GO TO ERRIO.
           GO TO CARIC.
      *
      * RIGO CONTABILE
      *
       C100.
           DISPLAY SCRDAT2.
       C101.
           ACCEPT SDTCON.
           DISPLAY SDTCON.
           MOVE DTCON TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO C101.
           MOVE AAGGG TO PKDTCON.
       C102.
           ACCEPT SCAUS.
           DISPLAY SCAUS.
           MOVE 2 TO KTB-TIP.
           MOVE CAUS TO KTB-COD.
           READ TABELL INVALID 
                MOVE SPACE TO TAB-RST DISPLAY SDCAU 
                PERFORM ERR-CINE GO TO C102.
           DISPLAY SDCAU.
           ACCEPT STIPOP.
           DISPLAY STIPOP.
       C103.
           ACCEPT SDTSCA.
           DISPLAY SDTSCA.
           MOVE DTSCA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO C103.
           MOVE AAGGG TO PKDTSCA.
           ACCEPT SNDOC.
           DISPLAY SNDOC.
       C104.
           ACCEPT SDTDOC.
           DISPLAY SDTDOC.
           MOVE DTDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO C104.
           MOVE AAGGG TO PKDTDOC.
           ACCEPT SIMPOR.
           DISPLAY SIMPOR.
           ACCEPT  SVIMPO.
           DISPLAY SVIMPO.
           ACCEPT  SCAMGG.
           DISPLAY SCAMGG.
       C105.
           ACCEPT SDA.
           DISPLAY SDA.
           IF NOT ( DA = 'A' OR 'D' ) GO TO C105.
           ACCEPT SNPIVA.
           DISPLAY SNPIVA.
       C106.
           CALL 'rxcnf' USING PARX CNF2.
           MOVE X-COD TO RISP.
           IF RISP > 2 GO TO C106.
           IF RISP = 1 GO TO C100.
           IF RISP = 2 GO TO CARIC.
           MOVE PKDTCON TO PAR-DTCON.
           MOVE CAUS    TO PAR-CAUS.
           MOVE TIPOP   TO PAR-TIPOP.
           MOVE PKDTSCA TO PAR-DTSCA.
           MOVE NDOC    TO PAR-NDOC.
           MOVE PKDTDOC TO PAR-DTDOC.
           MOVE IMPOR   TO PAR-IMPOR.
           MOVE DA      TO PAR-D-A.
           MOVE NPIVA   TO PAR-NPIVA.
           MOVE VIMPO   TO PAR-VIMPO.
           MOVE CAMGG   TO PAR-CAMGG.
           WRITE RF-PAR FROM REKPAR INVALID PERFORM INVK-PAR
                                            GO TO ERRIO.
           GO TO CARIC.
      *
      * RIGO DESCRITTIVO
      *
       C150.
           DISPLAY SCRDAT3.
           ACCEPT SDESCR.
           DISPLAY SDESCR.
       C155.
           CALL 'rxcnf' USING PARX CNF2.
           MOVE X-COD TO RISP.
           IF RISP > 2 GO TO C155.
           IF RISP = 1 GO TO C150.
           IF RISP = 2 GO TO CARIC.
           MOVE DESCR TO PAR-DESCR.
           WRITE RF-PAR FROM REKPAR INVALID PERFORM INVK-PAR
                                            GO TO ERRIO.
           GO TO CARIC.
      *
      * RIGO SCADENZE
      *
       C200.
           DISPLAY SCRDAT4.
       C201.
           ACCEPT SDT1.
           DISPLAY SDT1.
           MOVE DT1 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO C201.
           MOVE AAGGG TO PKDT1.
           ACCEPT SLT1.
           DISPLAY SLT1.
           ACCEPT SVT1.
           DISPLAY SVT1.
       C202.
           ACCEPT SDT2.
           DISPLAY SDT2.
           MOVE DT2 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO C202.
           MOVE AAGGG TO PKDT2.
           ACCEPT SLT2.
           DISPLAY SLT2.
           ACCEPT SVT2.
           DISPLAY SVT2.
       C203.
           ACCEPT SDT3.
           DISPLAY SDT3.
           MOVE DT3 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO C203.
           MOVE AAGGG TO PKDT3.
           ACCEPT SLT3.
           DISPLAY SLT3.
           ACCEPT SVT3.
           DISPLAY SVT3.
       C204.
           ACCEPT SDT4.
           DISPLAY SDT4.
           MOVE DT4 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO C204.
           MOVE AAGGG TO PKDT4.
           ACCEPT SLT4.
           DISPLAY SLT4.
           ACCEPT SVT4.
           DISPLAY SVT4.
       C205.
           ACCEPT SDT5.
           DISPLAY SDT5.
           MOVE DT5 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO C205.
           MOVE AAGGG TO PKDT5.
           ACCEPT SLT5.
           DISPLAY SLT5.
           ACCEPT SVT5.
           DISPLAY SVT5.
       C206.
           ACCEPT SDT6.
           DISPLAY SDT6.
           MOVE DT6 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO C206.
           MOVE AAGGG TO PKDT6.
           ACCEPT SLT6.
           DISPLAY SLT6.
           ACCEPT SVT6.
           DISPLAY SVT6.
       C255.
           CALL 'rxcnf' USING PARX CNF2.
           MOVE X-COD TO RISP.
           IF RISP > 2 GO TO C255.
           IF RISP = 1 GO TO C200.
           IF RISP = 2 GO TO CARIC.
           MOVE PKDT1 TO PAR-DT(1).
           MOVE LT1   TO PAR-LT(1).
           MOVE PKDT2 TO PAR-DT(2).
           MOVE LT2   TO PAR-LT(2).
           MOVE PKDT3 TO PAR-DT(3).
           MOVE LT3   TO PAR-LT(3).
           MOVE PKDT4 TO PAR-DT(4).
           MOVE LT4   TO PAR-LT(4).
           MOVE PKDT5 TO PAR-DT(5).
           MOVE LT5   TO PAR-LT(5).
           MOVE PKDT6 TO PAR-DT(6).
           MOVE LT6   TO PAR-LT(6).
           MOVE VT1   TO PAR-VT(1).
           MOVE VT2   TO PAR-VT(2).
           MOVE VT3   TO PAR-VT(3).
           MOVE VT4   TO PAR-VT(4).
           MOVE VT5   TO PAR-VT(5).
           MOVE VT6   TO PAR-VT(6).
           WRITE RF-PAR FROM REKPAR INVALID PERFORM INVK-PAR
                                            GO TO ERRIO.
           GO TO CARIC.
      *------------------------------------------------------------*
       VARIA.
           MOVE ZERO TO TIPO CLF ANNO PART NUME.
           MOVE SPACE TO CLF-RGS.
           DISPLAY SCRLOG.
           DISPLAY SCR000.
           DISPLAY SCRKEY.
       V010.
           ACCEPT STIPO.
           DISPLAY STIPO.
           IF TIPO = ZERO GO TO TIPLV.
           IF TIPO < 2 OR TIPO > 3 GO TO V010.
           ACCEPT SCLF.
           DISPLAY SCLF.
           IF CLF = ZERO MOVE ZERO TO ANNO PART NUME GO TO V050.
           ACCEPT SANNO.
           CALL 'ranno4' USING ANNO.
           DISPLAY SANNO.
           ACCEPT SPART.
           DISPLAY SPART.
           IF PART = ZERO MOVE ZERO TO NUME GO TO V050.
           ACCEPT SNUME.
           DISPLAY SNUME.
       V050.
           DISPLAY SCRKEY.
           MOVE KAZ-COD TO KPA-AZI.
           MOVE CHIAVE TO KPA-CAN.
           START PARTIT KEY NOT < KEYPA INVALID GO TO CHIUDE.
       V100.
           READ PARTIT NEXT INTO REKPAR AT END GO TO CHIUDE.
           IF SF-PAR = '9D' OR '9A' OR '35' GO TO V100.
           IF KPA-AZI > KAZ-COD GO TO CHIUDE.
           MOVE KPA-CAN TO CHIAVE.
           IF TIPO = 2 MOVE CLF TO CODCLI MOVE CLIENTE TO KCF-COD
           ELSE MOVE CLF TO CODFOR MOVE FORNIT TO KCF-COD.
           MOVE KAZ-COD TO KCF-AZI.
           READ ANACLF INVALID MOVE ALL '*' TO CLF-RGS.
           DISPLAY SCRKEY.
           MOVE PAR-TIP TO TIP.
           DISPLAY SCRKEY.
           DISPLAY SCRDAT0.
           DISPLAY SCRBLK.
           GO TO V200 V300 V400 V500 DEPENDING ON TIP.
      *
      * TESTATA
      *
       V200.
           MOVE PAR-SALDO TO SALDO.
           MOVE PAR-NUMPA TO NUMPA. 
           MOVE PAR-VSALD TO VSALD.
           MOVE PAR-CADOC TO CADOC.
           MOVE PAR-VALUT TO VALUT.
           IF VALUT = ZERO MOVE SPACE TO DSINT
                                   GO TO V210.
           MOVE 10 TO KTB-TIP.
           MOVE VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID 
                            MOVE ALL '*' TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO DSINT.
       V210.
           DISPLAY SCRDAT1.
           GO TO V600.
      *
      * RIGO CONTABILE
      *
       V300.
           MOVE PAR-DTCON TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DTCON.
           MOVE PAR-CAUS TO CAUS KTB-COD.
           MOVE 2 TO KTB-TIP.
           READ TABELL INVALID MOVE ALL '*' TO TAB-RST.
           MOVE PAR-TIPOP TO TIPOP.
           MOVE PAR-DTSCA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DTSCA.
           MOVE PAR-NDOC TO NDOC.
           MOVE PAR-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DTDOC.
           MOVE PAR-IMPOR TO IMPOR.
           MOVE PAR-D-A TO DA.
           MOVE PAR-NPIVA TO NPIVA.
           MOVE PAR-VIMPO TO VIMPO.
           MOVE PAR-CAMGG TO CAMGG.
           DISPLAY SCRDAT2.
           GO TO V600.
      *
      * RIGO DESCRITTIVO
      *
       V400.
           MOVE PAR-DESCR TO DESCR.
           DISPLAY SCRDAT3.
           GO TO V600.
      *
      * RIGO SCADENZE
      *
       V500.
           MOVE PAR-DT(1) TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DT1.
           MOVE PAR-LT(1) TO LT1.
           MOVE PAR-DT(2) TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DT2.
           MOVE PAR-LT(2) TO LT2.
           MOVE PAR-DT(3) TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DT3.
           MOVE PAR-LT(3) TO LT3.
           MOVE PAR-DT(4) TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DT4.
           MOVE PAR-LT(4) TO LT4.
           MOVE PAR-DT(5) TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DT5.
           MOVE PAR-LT(5) TO LT5.
           MOVE PAR-DT(6) TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DT6.
           MOVE PAR-LT(6) TO LT6.
           MOVE PAR-VT(1) TO VT1.
           MOVE PAR-VT(2) TO VT2.
           MOVE PAR-VT(3) TO VT3.
           MOVE PAR-VT(4) TO VT4.
           MOVE PAR-VT(5) TO VT5.
           MOVE PAR-VT(6) TO VT6.
           DISPLAY SCRDAT4.
       V600.
           CALL 'rxcnf' USING PARX WSCRCNT.
           MOVE X-COD TO RISP.
           IF RISP = ZERO GO TO V100.
           IF RISP = 1    GO TO MODIF.
           IF RISP = 2    GO TO VARIA.
           IF RISP = 9    GO TO ANNULL.
           GO TO V600.
      *--------------------------------------------------------*
       MODIF.
           GO TO M100 M200 M300 M400 DEPENDING ON TIP.
      *
      * TESTATA
      *
       M100.
           ACCEPT SSALDO.
           DISPLAY SSALDO.
       M102.
           ACCEPT  SVSALD.
           DISPLAY SVSALD.
           ACCEPT  SVALUT.
           DISPLAY SVALUT.
           IF VALUT = ZERO AND VSALD NOT = ZERO GO TO M102.
           IF VALUT = ZERO MOVE SPACE TO DSINT  DISPLAY SDSINT
                           MOVE ZERO TO CADOC DISPLAY SCADOC
                                                  GO TO M104.
           MOVE 10 TO KTB-TIP.
           MOVE VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID 
                MOVE SPACE TO TAB-RST DSINT DISPLAY SDSINT 
                PERFORM ERR-CINE GO TO M102.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO DSINT.
           DISPLAY SDSINT.
       M103.
           ACCEPT  SCADOC.
           DISPLAY SCADOC.
           IF CADOC = ZERO GO TO M103.
       M104.
           ACCEPT SNUMPA.
           DISPLAY SNUMPA.
           CALL 'rxcnf' USING PARX CNF1.
           MOVE X-COD TO RISP.
           IF RISP > ZERO GO TO M100.
           MOVE SALDO TO PAR-SALDO.
           MOVE NUMPA TO PAR-NUMPA.
           MOVE VSALD TO PAR-VSALD.
           MOVE CADOC TO PAR-CADOC.
           MOVE VALUT TO PAR-VALUT.
           REWRITE RF-PAR FROM REKPAR INVALID PERFORM INVK-PAR
                                              GO TO ERRIO.
           GO TO V100.
      *
      * RIGO CONTABILE
      *
       M200.
           ACCEPT SDTCON.
           DISPLAY SDTCON.
           MOVE DTCON TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO M200.
           MOVE AAGGG TO PKDTCON.
       M201.
           ACCEPT SCAUS.
           DISPLAY SCAUS.
           MOVE 2 TO KTB-TIP.
           MOVE CAUS TO KTB-COD.
           READ TABELL INVALID 
                MOVE SPACE TO TAB-RST DISPLAY SDCAU 
                PERFORM ERR-CINE GO TO M201.
           DISPLAY SDCAU.
           ACCEPT STIPOP.
           DISPLAY STIPOP.
       M202.
           ACCEPT SDTSCA.
           DISPLAY SDTSCA.
           MOVE DTSCA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO M202.
           MOVE AAGGG TO PKDTSCA.
           ACCEPT SNDOC.
           DISPLAY SNDOC.
       M203.
           ACCEPT SDTDOC.
           DISPLAY SDTDOC.
           MOVE DTDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO M203.
           MOVE AAGGG TO PKDTDOC.
           ACCEPT SIMPOR.
           DISPLAY SIMPOR.
           ACCEPT SVIMPO.
           DISPLAY SVIMPO.
           ACCEPT  SCAMGG.
           DISPLAY SCAMGG.
       M204.
           ACCEPT SDA.
           DISPLAY SDA.
           IF NOT ( DA = 'A' OR 'D' ) GO TO M204.
           ACCEPT SNPIVA.
           DISPLAY SNPIVA.
           CALL 'rxcnf' USING PARX CNF1.
           MOVE X-COD TO RISP.
           IF RISP > ZERO GO TO M200.
           MOVE PKDTCON TO PAR-DTCON.
           MOVE CAUS    TO PAR-CAUS.
           MOVE TIPOP   TO PAR-TIPOP.
           MOVE PKDTSCA TO PAR-DTSCA.
           MOVE NDOC    TO PAR-NDOC.
           MOVE PKDTDOC TO PAR-DTDOC.
           MOVE IMPOR   TO PAR-IMPOR.
           MOVE DA      TO PAR-D-A.
           MOVE NPIVA   TO PAR-NPIVA.
           MOVE VIMPO   TO PAR-VIMPO.
           MOVE CAMGG   TO PAR-CAMGG.
           REWRITE RF-PAR FROM REKPAR INVALID PERFORM INVK-PAR
                                              GO TO ERRIO.
           GO TO V100.
      *
      * RIGO DESCRITTIVO
      *
       M300.
           ACCEPT SDESCR.
           DISPLAY SDESCR.
           CALL 'rxcnf' USING PARX CNF1.
           MOVE X-COD TO RISP.
           IF RISP > ZERO GO TO M300.
           MOVE DESCR TO PAR-DESCR.
           REWRITE RF-PAR FROM REKPAR INVALID PERFORM INVK-PAR
                                              GO TO ERRIO.
           GO TO V100.
      *
      * RIGO SCADENZE
      *
       M400.
           ACCEPT SDT1.
           DISPLAY SDT1.
           MOVE DT1 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO M400.
           MOVE AAGGG TO PKDT1.
           ACCEPT SLT1.
           DISPLAY SLT1.
           ACCEPT SVT1.
           DISPLAY SVT1.
       M401.
           ACCEPT SDT2.
           DISPLAY SDT2.
           MOVE DT2 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO M401.
           MOVE AAGGG TO PKDT2.
           ACCEPT SLT2.
           DISPLAY SLT2.
           ACCEPT SVT2.
           DISPLAY SVT2.
       M402.
           ACCEPT SDT3.
           DISPLAY SDT3.
           MOVE DT3 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO M402.
           MOVE AAGGG TO PKDT3.
           ACCEPT SLT3.
           DISPLAY SLT3.
           ACCEPT SVT3.
           DISPLAY SVT3.
       M403.
           ACCEPT SDT4.
           DISPLAY SDT4.
           MOVE DT4 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO M403.
           MOVE AAGGG TO PKDT4.
           ACCEPT SLT4.
           DISPLAY SLT4.
           ACCEPT SVT4.
           DISPLAY SVT4.
       M404.
           ACCEPT SDT5.
           DISPLAY SDT5.
           MOVE DT5 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO M404.
           MOVE AAGGG TO PKDT5.
           ACCEPT SLT5.
           DISPLAY SLT5.
           ACCEPT SVT5.
           DISPLAY SVT5.
       M405.
           ACCEPT SDT6.
           DISPLAY SDT6.
           MOVE DT6 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO M405.
           MOVE AAGGG TO PKDT6.
           ACCEPT SLT6.
           DISPLAY SLT6.
           ACCEPT SVT6.
           DISPLAY SVT6.
           CALL 'rxcnf' USING PARX CNF1.
           MOVE X-COD TO RISP.
           IF RISP > ZERO GO TO M400.
           MOVE PKDT1 TO PAR-DT(1).
           MOVE LT1   TO PAR-LT(1).
           MOVE PKDT2 TO PAR-DT(2).
           MOVE LT2   TO PAR-LT(2).
           MOVE PKDT3 TO PAR-DT(3).
           MOVE LT3   TO PAR-LT(3).
           MOVE PKDT4 TO PAR-DT(4).
           MOVE LT4   TO PAR-LT(4).
           MOVE PKDT5 TO PAR-DT(5).
           MOVE LT5   TO PAR-LT(5).
           MOVE PKDT6 TO PAR-DT(6).
           MOVE LT6   TO PAR-LT(6).
           MOVE VT1   TO PAR-VT(1).
           MOVE VT2   TO PAR-VT(2).
           MOVE VT3   TO PAR-VT(3).
           MOVE VT4   TO PAR-VT(4).
           MOVE VT5   TO PAR-VT(5).
           MOVE VT6   TO PAR-VT(6).
           REWRITE RF-PAR FROM REKPAR INVALID PERFORM INVK-PAR
                                              GO TO ERRIO.
           GO TO V100.
      *--------------------------------------------------*
       ANNULL.
           CALL 'rxcnf' USING PARX WANNUL.
           MOVE X-COD TO RISP.
           IF RISP NOT = 9 GO TO V100.
           DELETE PARTIT INVALID PERFORM INVK-PAR GO TO ERRIO.
           GO TO V100.
      *--------------------------------------------------*
       CHIUDE.
           MOVE 'FINE DATI' TO F-MES1.
           MOVE 11 TO F-FUN.
           CALL 'rzfunz' USING PARF.
           GO TO VARIA.
      *--------------------------------------------------*
       ERRIO.
      **** rel 7.2
      *    COPY 'errio'.
           COPY '_errio'.
      ************
       FINE.
           CLOSE ANAAZI ANACLF TABELL PARTIT.
      **** rel 7.2
      *    COPY 'rfstack'.
           COPY '_rfstack'.
      ************
           DISPLAY SCRLOG.
           EXIT PROGRAM.
           STOP RUN.
      **** rel 7.2
      *    COPY 'errmes'.
           COPY '_errmes'.
      ************
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'griparer'.
           COPY 'gritaber'.
      **** rel 7.2
      *    COPY 'grixxxer'.
           COPY '_grixxxer'.
      ************
