       IDENTIFICATION DIVISION.
       PROGRAM-ID. VBIC120.
      *
      * Stampa bilancio CEE
      *
      * Il campo IF-FUN puo' valere anche:
      *    s = restituisce se ci sono anomalie
      *    S = esegue la stampa della lista anomalia
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'grimovsl'.
           COPY 'grimvxsl'.
           COPY 'gritabsl'.
           COPY 'griceesl'.
           COPY 'gricecsl'.
           COPY 'gricepsl'.
      **** rel 6.2
           COPY 'grimlisl'.
           COPY 'gricolsl'.
      ************
           SELECT ERRORI  ASSIGN TO DISK
                  ORGANIZATION LINE SEQUENTIAL STATUS SF-ERR.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'grimov'.
           COPY 'grimvx'.
           COPY 'gritab'.
           COPY 'gricee'.
           COPY 'gricec'.
           COPY 'gricep'.
      **** rel 6.2
           COPY 'grimli'.
           COPY 'gricol'.
      ************
       FD  ERRORI LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-ERR
           RECORD 80 DATA RECORD RF-ERR.
       01  RF-ERR.
           05 ERRTES      PIC X(3).
           05 ERRMES.
              10 ERCODI   PIC X(7).
              10 ERMSAG   PIC X(70).
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griconrk'.
           COPY 'grimovrk'.
           COPY 'gritabrk'.
           COPY 'grit20rk'.
           COPY 'grit14g'.
           COPY 'grit14h'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'prpiva'.
           COPY 'parer'.
           COPY 'parrd'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MVX PIC X(15) VALUE 'movmxx'.
       01  ID-CEE PIC X(15) VALUE 'bilcee'.
       01  ID-CEC PIC X(15) VALUE 'bilcec'.
       01  ID-CEP PIC X(15) VALUE 'bilcep'.
      **** rel 6.2
       01  ID-MLI PIC X(15) VALUE 'movlib'.
       01  ID-COL PIC X(15) VALUE 'anacol'.
      ************
       01  ID-ERR PIC X(15) VALUE 'errori'.
       01  COMODI.
           05 SF-AZI PIC XX.
           05 SF-TAB PIC XX.
           05 SF-CON PIC XX.
           05 SF-MOV PIC XX.
           05 SF-MVX PIC XX.
           05 SF-CEE PIC XX.
           05 SF-CEC PIC XX.
           05 SF-CEP PIC XX.
      **** rel 6.2
           05 SF-MLI PIC XX.
           05 SF-COL PIC XX.
      ************
           05 SF-ERR PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 SW-SBIL  PIC 9 VALUE ZERO.

           05 J        PIC 9      VALUE ZERO.
           05 K1BAR    PIC 999.
           05 K2BAR    PIC 999.
           05 SWSTA    PIC 9      VALUE ZERO.
           05 K        PIC 99     VALUE ZERO.
           05 K1       PIC 99     VALUE ZERO.
           05 DIFFE    PIC S9(13)V99 VALUE ZERO.
           05 COMOD    PIC S9(13)V99 VALUE ZERO.
           05 COMOP    PIC S9(13)V99 VALUE ZERO.
           05 DTSTA    PIC 9(6)   VALUE ZERO.
           05 SALDO    PIC S9(13)V99 VALUE ZERO.
           05 TTPAT    PIC S9(13)V99 VALUE ZERO.
           05 TTECO    PIC S9(13)V99 VALUE ZERO.
           05 TTORD    PIC S9(13)V99 VALUE ZERO.
           05 TOTTIC   PIC S9(12)V99 VALUE ZERO.
           05 TOTVOC   PIC S9(12)V99 VALUE ZERO.
           05 TOTGRC   PIC S9(12)V99 VALUE ZERO.
           05 TOTTIP   PIC S9(12)V99 VALUE ZERO.
           05 TOTVOP   PIC S9(12)V99 VALUE ZERO.
           05 TOTGRP   PIC S9(12)V99 VALUE ZERO.
           05 CREIN    PIC S9(12)V99 VALUE ZERO.
           05 CREIP    PIC S9(12)V99 VALUE ZERO.
           05 CREOU    PIC S9(12)V99 VALUE ZERO.
           05 CREOP    PIC S9(12)V99 VALUE ZERO.
           05 EVIDE    PIC S9(12)V99 VALUE ZERO.
           05 EVIDP    PIC S9(12)V99 VALUE ZERO.
           05 COMTOTVO PIC S9(12)V99 VALUE ZERO.
           05 COMTOTVP PIC S9(12)V99 VALUE ZERO.
           05 COMEVIDE PIC S9(12)V99 VALUE ZERO.
           05 COMEVIDP PIC S9(12)V99 VALUE ZERO.
           05 COMCREIN PIC S9(12)V99 VALUE ZERO.
           05 COMCREIP PIC S9(12)V99 VALUE ZERO.
           05 COMCREOU PIC S9(12)V99 VALUE ZERO.
           05 COMCREOP PIC S9(12)V99 VALUE ZERO.
           05 COMODOC   PIC S9(12)V99 VALUE ZERO.
           05 COMODOP   PIC S9(12)V99 VALUE ZERO.
           05 TOTCEN13  PIC S9(12)V99 VALUE ZERO.
           05 TOTUNI13  PIC S9(12)V99 VALUE ZERO.
           05 TOTCEN2   PIC S9(12)V99 VALUE ZERO.
           05 TOTUNI2   PIC S9(12)V99 VALUE ZERO.
           05 TOTCEN4   PIC S9(12)V99 VALUE ZERO.
           05 TOTUNI4   PIC S9(12)V99 VALUE ZERO.
           05 TOTCEN5   PIC S9(12)V99 VALUE ZERO.
           05 TOTUNI5   PIC S9(12)V99 VALUE ZERO.
           05 TOTCEN13P PIC S9(12)V99 VALUE ZERO.
           05 TOTUNI13P PIC S9(12)V99 VALUE ZERO.
           05 TOTCEN2P  PIC S9(12)V99 VALUE ZERO.
           05 TOTUNI2P  PIC S9(12)V99 VALUE ZERO.
           05 TOTCEN4P  PIC S9(12)V99 VALUE ZERO.
           05 TOTUNI4P  PIC S9(12)V99 VALUE ZERO.
           05 TOTCEN5P  PIC S9(12)V99 VALUE ZERO.
           05 TOTUNI5P  PIC S9(12)V99 VALUE ZERO.
           05 COMFLSTAZ PIC 9.
           05 CODINI   PIC 9(7)   VALUE ZERO.
           05 SWERR    PIC 9      VALUE ZERO.
           05 SWDET    PIC 9      VALUE ZERO.
           05 FLGALL   PIC 9      VALUE ZERO.
           05 PKDAT    PIC 9(5)   COMP-3 VALUE ZERO.
           05 DSDAT    PIC X(28)  VALUE SPACE.
           05 CODULT.
              10 CODUM PIC 99.
              10 CODUX.
                 15 CODUS PIC 99.
                 15 CODUC PIC 9(3).
           05 TIPO     PIC 9      VALUE ZERO.
           05 VOCE     PIC X      VALUE SPACE.
           05 GRUP     PIC 9      VALUE ZERO.
           05 TRAI     PIC 99     VALUE ZERO.
           05 DETT     PIC X      VALUE SPACE.
           05 DESCR.
              10 DESC1 PIC X(30)  VALUE SPACE.
              10 DESC2 PIC X(30)  VALUE SPACE.
           05 CAPSOS PIC ZZZZ.ZZZ.ZZ9,99.
           05 CIFIS  PIC 9(11) VALUE ZERO.
           05 CIFIA  REDEFINES CIFIS PIC X(11).
      **** rel 6.2
      * switch per sapere se e' stata stampata la descrizione del conto
      * poiche' se il conto non e' movimentato altrimenti non veniva 
      * stampata
           05 SWDES    PIC 9      VALUE ZERO.
      *
           05 SAVCONTO PIC 9(7) VALUE ZERO.
           05 IMPMLI   PIC S9(13)V99 VALUE ZERO.
           05 IMLIDARE PIC S9(13)V99 VALUE ZERO.
           05 IMLIAVER PIC S9(13)V99 VALUE ZERO.
           05 SAVPC     PIC 9(10).
      *
           05 CPIVA  PIC 9(11) VALUE ZERO.
           05 CPIVX  REDEFINES CPIVA PIC X(11).
      ************
           05 RGRU.
              10 FILLER PIC X(5) VALUE '   I.'.
              10 FILLER PIC X(5) VALUE '  II.'.
              10 FILLER PIC X(5) VALUE ' III.'.
              10 FILLER PIC X(5) VALUE '  IV.'.
              10 FILLER PIC X(5) VALUE '   V.'.
              10 FILLER PIC X(5) VALUE '  VI.'.
              10 FILLER PIC X(5) VALUE ' VII.'.
              10 FILLER PIC X(5) VALUE 'VIII.'.
              10 FILLER PIC X(5) VALUE '  IX.'.
           05 RGRUX REDEFINES RGRU PIC X(5) OCCURS 9.
           05 DSTIP.
              10 FILLER PIC X(22) VALUE 'ATTIVO'.
              10 FILLER PIC X(22) VALUE 'CONTI D''ORDINE ATTIVO'.
              10 FILLER PIC X(22) VALUE 'PASSIVO'.
              10 FILLER PIC X(22) VALUE 'CONTI D''ORDINE PASSIVO'.
              10 FILLER PIC X(22) VALUE 'CONTO ECONOMICO'.
           05 DSTIPX REDEFINES DSTIP PIC X(22) OCCURS 5.
           05 ORDST  PIC X(5) VALUE '13245'.
           05 ORDSTA REDEFINES ORDST PIC 9 OCCURS 5.
           05 SAVKEY PIC X(16) VALUE SPACE.
           05 CRPCL    PIC 9(7).
           05 CRPC1    PIC 9(7).
           05 CRPC2    PIC 9(7).
           05 CRPFR    PIC 9(7).
           05 CRPF1    PIC 9(7).
           05 CRPF2    PIC 9(7).
           05 T14RIC.
              10 T14RIC1 PIC 9(7) VALUE ZERO.
              10 T14RIC2 PIC 9(7) VALUE ZERO.
              10 T14RIC3 PIC 9(7) VALUE ZERO.
              10 T14RIC4 PIC 9(7) VALUE ZERO.
              10 T14RIC5 PIC 9(7) VALUE ZERO.
              10 T14RIC6 PIC 9(7) VALUE ZERO.
              10 T14RIC7 PIC 9(7) VALUE ZERO.
              10 T14RIC8 PIC 9(7) VALUE ZERO.
              10 T14RIC9 PIC 9(7) VALUE ZERO.
           05 T14RIC0 REDEFINES T14RIC PIC 9(7) OCCURS 9.
           05 FLGOK PIC 9 VALUE ZERO.

           COPY 'vbic120.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
        01 IF-CTRL.
           05 IF-AZI                       PIC 9(3).
           05 IF-FUN                       PIC X.
           05 IF-CAMPO                     PIC X(20).
           05 IF-ST                        PIC 9.
           05 IF-FL                        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D                     PIC X(36).
           05 IF-DATA                      PIC 9(6).
           05 IF-TPBIL                     PIC 9.
           05 IF-TPSTA                     PIC 9.
           05 IF-TPAZ                      PIC 9.
           05 IF-FLSTAZ                    PIC 9.
           05 IF-RAGSOC                    PIC X(50).
           05 IF-CITTA                     PIC X(35).
           05 IF-INDIR                     PIC X(40).
           05 IF-CAPSO                     PIC 9(11)V99.
           05 IF-CDFIS                     PIC 9(11).
           05 IF-TRIBU                     PIC X(36).
      **** rel 6.2
      *    05 IF-IMPRN                     PIC X(7).
           05 IF-IMPRN                     PIC X(11).
      *    05 IF-VOLUN                     PIC X(5).
      ************
           05 IF-CAMCO                     PIC X(36).
           05 IF-ISCRN                     PIC X(9).
           05 IF-LIREUR                    PIC 9.
           05 IF-IMPCEN                    PIC 9.
      **** rel 6.2
           05 IF-PIVA                      PIC 9(11).
           05 IF-FLMLI                     PIC 9.
           05 IF-TPMLI                     PIC 9.
           05 IF-FLLIN                     PIC 9.
           05 IF-FLRIP                     PIC 9.
      ************

      *
       01  IF-MESS         PIC X(204).

       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclmov'.
           COPY 'dclmvx'.
           COPY 'dcltab'.
           COPY 'dclcee'.
           COPY 'dclcec'.
           COPY 'dclcep'.
      **** rel 6.2
           COPY 'dclmli'.
           COPY 'dclcol'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
      *                 GO TO FINE.
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO FINE.
           IF FUN = 's' PERFORM TEST-ERRORI THRU EX-TEST-ERRORI
                        GO TO FINE.
           IF FUN = 'S' PERFORM STA-ERRORI THRU EX-STA-ERRORI
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vbic120: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           UNLOCK BILCEE.
           CLOSE ANAAZI.
           CLOSE ANACON.
           CLOSE TABELL.
           CLOSE BILCEE.
           CLOSE BILCEC.
           CLOSE BILCEP.
           CLOSE MOVIME MOVMXX.
      **** rel 6.2
           CLOSE MOVLIB.
           CLOSE ANACOL.
      ************
           OPEN OUTPUT ERRORI.
           CLOSE ERRORI.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'grimover'.
           COPY 'grimvxer'.
           COPY 'gritaber'.
           COPY 'griceeer'.
           COPY 'gricecer'.
           COPY 'griceper'.
      **** rel 6.2
           COPY 'grimlier'.
           COPY 'gricoler'.
      ************
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDERR THRU EX-CREA-IDERR.
           IF IF-FL = 1 MOVE 'anazol' TO ID-AZI
                     MOVE 'tabold' TO ID-TAB
                     MOVE 'anacol' TO ID-CON
                     MOVE 'movmol' TO ID-MOV
                     MOVE 'movoxx' TO ID-MVX
                     MOVE 'bilolc' TO ID-CEC
                     MOVE 'bilolp' TO ID-CEP
                     MOVE 'bilold' TO ID-CEE
      **** rel 6.2
                     MOVE 'movlix' TO ID-MLI
      ************
              ELSE
                     MOVE 'anaazi' TO ID-AZI
                     MOVE 'tabell' TO ID-TAB
                     MOVE 'anacon' TO ID-CON
                     MOVE 'movime' TO ID-MOV
                     MOVE 'movmxx' TO ID-MVX
                     MOVE 'bilcec' TO ID-CEC
                     MOVE 'bilcep' TO ID-CEP
      **** rel 6.2
                     MOVE 'movlib' TO ID-MLI
      ************
                     MOVE 'bilcee' TO ID-CEE.
           IF IF-FL = 1 MOVE
              'Bilancio al ...............:' TO DSDAT
              ELSE MOVE
              'Movimenti al ..............:' TO DSDAT.

           OPEN INPUT  ANAAZI.
           OPEN INPUT  TABELL.
           OPEN INPUT  ANACON.
           OPEN INPUT  MOVIME.
           OPEN INPUT  MOVMXX.
           OPEN  I-O   BILCEE.
           OPEN  I-O   BILCEC.
           OPEN INPUT  BILCEP.
      **** rel 6.2
           OPEN INPUT  MOVLIB.
           OPEN INPUT  ANACOL.
      ************

           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.

           MOVE '20001' TO KEYTB.
           READ TABELL INTO RKTB20 INVALID
                PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.

           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-CRPCL TO CRPCL.
           MOVE T01-CRPC1 TO CRPC1.
           MOVE T01-CRPC2 TO CRPC2.
           MOVE T01-CRPFR TO CRPFR.
           MOVE T01-CRPF1 TO CRPF1.
           MOVE T01-CRPF2 TO CRPF2.

           MOVE 14 TO KTB-TIP.
           MOVE 2  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-RIC1 TO T14RIC1.
           MOVE T14-RIC2 TO T14RIC2.
           MOVE T14-RIC3 TO T14RIC3.

           MOVE 14 TO KTB-TIP.
           MOVE 8  TO KTB-COD.
           READ TABELL INTO RKTB14H INVALID KEY PERFORM INVK-TAB
                                                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14H.
           MOVE T14-RIC4 TO T14RIC4.
           MOVE T14-RIC5 TO T14RIC5.
           MOVE T14-RIC6 TO T14RIC6.
           MOVE T14-RIC7 TO T14RIC7.
           MOVE T14-RIC8 TO T14RIC8.
           MOVE T14-RIC9 TO T14RIC9.

           MOVE 14 TO KTB-TIP.
           MOVE 7  TO KTB-COD.
           READ TABELL INTO RKTB14G INVALID PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14G.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO TO IF-TPAZ.
           MOVE ZERO TO IF-DATA.
           MOVE ZERO TO IF-TPSTA IF-TPBIL.
           MOVE ZERO TO IF-FLSTAZ.
      **** rel 6.2
      *    MOVE SPACE TO IF-TRIBU IF-IMPRN IF-VOLUN 
      *                  IF-CAMCO IF-ISCRN.
           MOVE SPACE TO IF-TRIBU IF-IMPRN 
                         IF-CAMCO IF-ISCRN.
           MOVE ZERO TO IF-PIVA CPIVA.
           MOVE ZERO TO IF-FLMLI IF-TPMLI IF-FLLIN.
           MOVE ZERO TO IF-FLRIP.
      ************
           MOVE ZERO TO IF-CAPSO IF-CDFIS CIFIS.
      **** rel 6.2
           MOVE ZERO TO IF-PIVA CPIVA.
      ************
           MOVE ZERO TO IF-LIREUR.
           MOVE ZERO TO IF-IMPCEN.
           MOVE AZRGSOC TO IF-RAGSOC.
           MOVE AZI-CIT TO IF-CITTA.
           MOVE AZI-INDIR TO IF-INDIR.
           IF AZI-CFP NUMERIC MOVE AZI-CFP TO IF-CDFIS CIFIS.
      **** rel 6.2
           MOVE AZI-PIVA TO IF-PIVA CPIVA.
      ************

           MOVE KAZ-COD TO KCE-AZI.
           MOVE 1 TO KCE-TIPO.
           MOVE 'A'   TO KCE-VOCE.
           MOVE ZERO  TO KCE-GRUP KCE-TRAI.
           MOVE ZERO  TO KCE-PRG.
           MOVE SPACE TO KCE-DES.
           MOVE SPACE TO KCE-DETT.
           READ BILCEE KEPT LOCK INVALID PERFORM INVK-CEE
                                         GO TO ERRIO.
           IF SF-CEE = '9D' OR '9A' OR '35'
                        MOVE 'Bilancio gia'' in uso !!!' TO MESS
                        GO TO ERRIO.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DATA.
           MOVE 'IF-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA.
      *
       V-RAGSOC.
           MOVE 'IF-RAGSOC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-RAGSOC.
           IF IF-FLSTAZ = ZERO GO TO E-RAGSOC.
           IF IF-RAGSOC = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-RAGSOC.
      *
       V-CITTA.
           MOVE 'IF-CITTA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CITTA.
           IF IF-FLSTAZ = ZERO GO TO E-CITTA.
           IF IF-CITTA = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-CITTA.
      *
       V-INDIR.
           MOVE 'IF-INDIR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-INDIR.
           IF IF-FLSTAZ = ZERO GO TO E-INDIR.
           IF IF-INDIR = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-INDIR.
      *
       V-CAPSO.
           MOVE 'IF-CAPSO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAPSO.
           IF IF-FLSTAZ = ZERO GO TO E-CAPSO.
           IF IF-CAPSO = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-CAPSO.
      *
       V-CDFIS.
           MOVE 'IF-CDFIS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDFIS.
           IF IF-FLSTAZ = ZERO GO TO E-CDFIS.
           IF IF-CDFIS = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE IF-CDFIS TO CODPIVA.
           MOVE ZERO TO RISPIVA.
           CALL 'rpiva' USING PARPIVA.
           IF RISPIVA NOT = ZERO MOVE 'Cod.fisc.errato' TO MESS
                                 GO TO V-WARNING.
       E-CDFIS.
      *
      **** rel 6.2
       V-PIVA. 
           MOVE 'IF-PIVA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PIVA. 
           IF IF-FLSTAZ = ZERO GO TO E-PIVA.
           IF IF-PIVA = ZERO 
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE IF-PIVA TO CODPIVA.
           MOVE ZERO TO RISPIVA.
           CALL 'rpiva' USING PARPIVA.
           IF RISPIVA NOT = ZERO MOVE 'P.IVA errata' TO MESS 
                                 GO TO V-WARNING.
       E-PIVA. 
      ************
       V-TRIBU.
           MOVE 'IF-TRIBU' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TRIBU.
           IF IF-FLSTAZ = ZERO GO TO E-TRIBU.
           IF IF-TRIBU = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-TRIBU.
      *
       V-IMPRN.
           MOVE 'IF-IMPRN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMPRN.
           IF IF-FLSTAZ = ZERO GO TO E-IMPRN.
           IF IF-IMPRN = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-IMPRN.
      *
      **** rel 6.2
      *V-VOLUN. 
      *    MOVE 'IF-VOLUN' TO VCAMPO.
      *    IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-VOLUN. 
      *    IF IF-FLSTAZ = ZERO GO TO E-VOLUN.
      *    IF IF-VOLUN = SPACE 
      *       PERFORM ERR-ZERO
      *       GO TO V-ERROR.
      *E-VOLUN. 
      ************
      *
       V-CAMCO.
           MOVE 'IF-CAMCO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAMCO.
           IF IF-FLSTAZ = ZERO GO TO E-CAMCO.
           IF IF-CAMCO = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-CAMCO.
      *
       V-ISCRN.
           MOVE 'IF-ISCRN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ISCRN.
           IF IF-FLSTAZ = ZERO GO TO E-ISCRN.
           IF IF-ISCRN = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-ISCRN.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           MOVE IF-FLSTAZ TO COMFLSTAZ.
           MOVE ZERO TO IEUR.
           IF IF-LIREUR = 1
              MOVE 'E' TO IEUR.
           OPEN OUTPUT ERRORI.

           MOVE AZRGSOC TO TAZI.

           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE 1 TO TIPOP1.
           MOVE GBMMBA TO RDTBI.
           MOVE AAGGG TO PKDAT.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'BILANCIO AL ' RDTBI
                  DELIMITED SIZE INTO RP-TIT1.
      *
           PERFORM RPT-RIG2-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

       CALCOL.
           MOVE ZERO TO TTPAT TTECO TTORD DIFFE.
           MOVE ZERO TO TOTCEN13  TOTUNI13.
           MOVE ZERO TO TOTCEN2   TOTUNI2.
           MOVE ZERO TO TOTCEN4   TOTUNI4.
           MOVE ZERO TO TOTCEN5   TOTUNI5.
           MOVE ZERO TO TOTCEN13P TOTUNI13P.
           MOVE ZERO TO TOTCEN2P  TOTUNI2P.
           MOVE ZERO TO TOTCEN4P  TOTUNI4P.
           MOVE ZERO TO TOTCEN5P  TOTUNI5P.
           MOVE ZERO TO SWERR.
           MOVE KAZ-COD TO KCE-AZI.
           MOVE ZERO  TO KCE-DATI.
           MOVE SPACE TO KCE-DES.
           MOVE SPACE TO KCE-VOCE KCE-DETT.
           START BILCEE KEY NOT < KEYCE INVALID GO TO CAL-90.
       CAL-10.
           READ BILCEE NEXT AT END GO TO CAL-90.
           IF SF-CEE = '9D' OR '9A' OR '35' GO TO CAL-10.
           IF KCE-AZI NOT = KAZ-COD GO TO CAL-90.
           IF KCE-TIPO = 3 AND KCE-VOCE = 'A' AND KCE-GRUP = 9
                                                  GO TO CAL-10.
           IF KCE-TIPO = 5 AND KCE-TRAI = 23 GO TO CAL-10.
           MOVE ZERO TO CEE-TOTVO COMOD.
           IF IF-TPAZ NOT = ZERO
              MOVE ZERO TO CEE-CREIN CEE-CREOU CEE-EVIDE CEE-VARIA.
           MOVE KCE-AZI TO KEC-AZI.
           MOVE KCE-DATI TO KEC-DATI.
           MOVE ZERO TO KEC-CONTO.
           START BILCEC KEY NOT < KEYEC INVALID GO TO CAL-30.
       CAL-20.
           READ BILCEC NEXT AT END GO TO CAL-30.
           IF SF-CEC = '9D' OR '9A' OR '35' GO TO CAL-20.
           IF KEC-AZI NOT = KCE-AZI OR
              KEC-DATI NOT = KCE-DATI GO TO CAL-30.
           MOVE ZERO TO CEC-IMPO.
           PERFORM A00-CAL-BIL THRU A99.
           REWRITE RF-CEC INVALID PERFORM INVK-CEC
                                  GO TO ERRIO.
           GO TO CAL-20.
       CAL-30.
           MOVE COMOD TO CEE-TOTVO.
           MOVE ZERO TO COMOD.
           IF KCE-TIPO = 2 OR 4 ADD CEE-VARIA TO TTORD.
           IF KCE-TIPO = 1 OR 3 ADD CEE-VARIA TO TTPAT DIFFE.
           IF KCE-TIPO = 5 ADD CEE-VARIA TO TTECO DIFFE.
           REWRITE RF-CEE INVALID PERFORM INVK-CEE
                                  GO TO ERRIO.
           IF KCE-TIPO = 4 OR 5
                MULTIPLY -1 BY CEE-TOTVO CEE-TOTVP
                MULTIPLY -1 BY CEE-VARIA CEE-VARIP.

           ADD CEE-VARIA TO CEE-TOTVO.
           ADD CEE-VARIP TO CEE-TOTVP.

           MOVE CEE-TOTVO TO RD-NUM.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           IF KCE-TIPO = 1 OR 3
              ADD CEE-TOTVO  TO TOTCEN13
              ADD RD-NUM     TO TOTUNI13.
           IF KCE-TIPO = 2
              ADD CEE-TOTVO  TO TOTCEN2
              ADD RD-NUM     TO TOTUNI2.
           IF KCE-TIPO = 4
              ADD CEE-TOTVO  TO TOTCEN4
              ADD RD-NUM     TO TOTUNI4.
           IF KCE-TIPO = 5
              ADD CEE-TOTVO  TO TOTCEN5
              ADD RD-NUM     TO TOTUNI5.
      *
           MOVE CEE-TOTVP TO RD-NUM.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           IF KCE-TIPO = 1 OR 3
              ADD CEE-TOTVP  TO TOTCEN13P
              ADD RD-NUM     TO TOTUNI13P.
           IF KCE-TIPO = 2
              ADD CEE-TOTVP  TO TOTCEN2P
              ADD RD-NUM     TO TOTUNI2P.
           IF KCE-TIPO = 4
              ADD CEE-TOTVP  TO TOTCEN4P
              ADD RD-NUM     TO TOTUNI4P.
           IF KCE-TIPO = 5
              ADD CEE-TOTVP  TO TOTCEN5P
              ADD RD-NUM     TO TOTUNI5P.
           GO TO CAL-10.
       CAL-90.
           MULTIPLY -1 BY TTPAT TTECO.
           MOVE KAZ-COD TO KCE-AZI.
           MOVE 3       TO KCE-TIPO.
           MOVE 'A'     TO KCE-VOCE.
           MOVE 9       TO KCE-GRUP.
           MOVE ZERO    TO KCE-TRAI.
           MOVE ZERO    TO KCE-PRG.
           MOVE SPACE   TO KCE-DES.
           MOVE SPACE   TO KCE-DETT.
           READ BILCEE INVALID PERFORM INVK-CEE
                               GO TO ERRIO.
           MOVE TTPAT TO CEE-TOTVO.
           REWRITE RF-CEE INVALID PERFORM INVK-CEE
                                  GO TO ERRIO.
           MOVE 5     TO KCE-TIPO.
           MOVE 'E'   TO KCE-VOCE.
           MOVE ZERO  TO KCE-GRUP.
           MOVE SPACE TO KCE-DETT.
           MOVE 23    TO KCE-TRAI.
           MOVE ZERO  TO KCE-PRG.
           MOVE SPACE TO KCE-DES.
           READ BILCEE INVALID PERFORM INVK-CEE
                               GO TO ERRIO.
           MOVE TTECO TO CEE-TOTVO.
           REWRITE RF-CEE INVALID PERFORM INVK-CEE
                                  GO TO ERRIO.
           COMPUTE COMOD = TTPAT + TTECO.
           IF DIFFE NOT = ZERO
                    MOVE 'ER' TO ERRTES
                    MOVE SPACE TO ERCODI
                    MOVE 'SBILANCIO VARIAZIONI' TO ERMSAG
                    WRITE RF-ERR
                    MOVE 1 TO SWERR.
           IF TTORD NOT = ZERO
                    MOVE 'ER' TO ERRTES
                    MOVE SPACE TO ERCODI
                    MOVE 'SBILANCIO CONTI D'' ORDINE' TO ERMSAG
                    WRITE RF-ERR
                    MOVE 1 TO SWERR.
           MOVE ZERO TO SW-SBIL.
           IF COMOD = ZERO GO TO STAMPA.

           MOVE 1 TO SW-SBIL.

           MOVE 'ER' TO ERRTES.
           MOVE SPACE TO ERCODI.
           MOVE 'SBILANCIO PATRIMONIALE/ECONOMICO' TO ERMSAG.
           WRITE RF-ERR.
           MOVE 1 TO SWERR.
       STAMPA.
           MOVE KAZ-COD TO KCE-AZI.
           MOVE ZERO TO TIPO GRUP TRAI.
           MOVE SPACE TO VOCE DETT.
           MOVE ZERO TO XCRR NRIG NPAG TOTTIP TOTVOP TOTGRP
                                       TOTTIC TOTVOC TOTGRC.
           MOVE ZERO TO NINT.
           MOVE ZERO TO CREIN CREIP CREOU CREOP.
           MOVE ZERO TO EVIDE EVIDP.
           MOVE ZERO TO J.
       STA-05.
           ADD 1 TO J.
           IF J > 5 GO TO FNSTA.
           MOVE ZERO TO KCE-DATI.
           MOVE SPACE TO KCE-DES.
           MOVE SPACE TO KCE-VOCE KCE-DETT.
           MOVE ORDSTA (J) TO KCE-TIPO.
           START BILCEE KEY NOT < KEYCE INVALID GO TO STA-05.
       STA-10.
           READ BILCEE NEXT AT END GO TO STA-05.
           IF SF-CEE = '9D' OR '9A' OR '35' GO TO STA-10.
           IF KCE-AZI NOT = KAZ-COD GO TO STA-05.
           IF KCE-TIPO NOT = ORDSTA (J) GO TO STA-05.
           IF TIPO = ZERO MOVE KCE-TIPO TO TIPO GO TO STA-20.
           IF KCE-TIPO = TIPO GO TO STA-30.
           PERFORM C00-TOT-TIP THRU C99.
       STA-20.
           IF KCE-TIPO = 3 OR 2 OR 5
              MOVE ZERO TO XCRR
              MOVE 1  TO RP-JMP.

      *-- inizializza parametri per stampa report --*
           MOVE SPACE TO RP-TIT2.
           STRING DSTIPX (KCE-TIPO)
                  DELIMITED SIZE INTO RP-TIT2.
      *
           PERFORM RPT-RIG2-INTC.
      *---------------------------------------------*
           IF COMFLSTAZ = ZERO MOVE '2' TO NINT GO TO STA-20-99.
           MOVE '0' TO NINT.
           MOVE IF-RAGSOC TO R1AZI.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE SPACE TO R1AZI
           STRING 'Sede in '
                   IF-CITTA DELIMITED '  '
                   ', ' IF-INDIR DELIMITED SIZE INTO R1AZI.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE SPACE TO R1AZI.
           MOVE IF-CAPSO TO CAPSOS
           STRING 'Capitale Sociale Euro ' CAPSOS
                          DELIMITED SIZE INTO R1AZI.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      **** rel 6.2
      *    STRING 'Codice Fiscale ' CIFIA
      *                   DELIMITED SIZE  INTO R1AZI.
           STRING 'Codice Fiscale ' CIFIA ' P.Iva ' CPIVX
                          DELIMITED SIZE  INTO R1AZI.
      ************
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE SPACE TO R1AZI.
      **** rel 6.2
      *    STRING 'Iscritta al Registro delle Imprese di '
      *          IF-TRIBU DELIMITED '  '  ' ' 'al n. '
      *           IF-IMPRN DELIMITED '  ' ' '
      *           'Registro Societa'' , Volume ' IF-VOLUN
      *                    DELIMITED SIZE INTO R1AZI.
      *    MOVE 'RIG1' TO RP-BLK.
      *    PERFORM RPT-WR.
      *
           STRING 'Iscritta al Registro delle Imprese di '
                  IF-TRIBU DELIMITED '  '  ' ' 'al n. '
                  IF-IMPRN DELIMITED SIZE INTO R1AZI.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      ************
           MOVE SPACE TO R1AZI.
           STRING 'Camera di Commercio di '
                  IF-CAMCO delimited '  ' ' n. ' IF-ISCRN
                           DELIMITED SIZE INTO R1AZI.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE ALL '-' TO R1AZI
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE 2 TO NINT.
           MOVE ZERO TO COMFLSTAZ.
           MOVE TINT11 TO R1AZI.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE TINT22 TO R1AZI.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
       STA-20-99.
           MOVE KCE-TIPO TO TIPO.
           MOVE DSTIPX (KCE-TIPO) TO RDESX.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE ALL '=' TO RDESX.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE SPACE TO VOCE DETT.
           MOVE ZERO  TO GRUP TRAI.
       STA-30.
           MOVE CEE-TOTVO TO COMTOTVO.
           MOVE CEE-TOTVP TO COMTOTVP.
           MOVE CEE-EVIDE TO COMEVIDE.
           MOVE CEE-EVIDP TO COMEVIDP.
           MOVE CEE-CREIN TO COMCREIN.
           MOVE CEE-CREIP TO COMCREIP.
           MOVE CEE-CREOU TO COMCREOU.
           MOVE CEE-CREOP TO COMCREOP.
           IF IF-IMPCEN = ZERO
              MOVE CEE-TOTVO TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVO
              MOVE CEE-TOTVP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVP
              MOVE CEE-EVIDE TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMEVIDE
              MOVE CEE-EVIDP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMEVIDP
              MOVE CEE-CREIN TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREIN
              MOVE CEE-CREIP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREIP
              MOVE CEE-CREOU TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREOU
              MOVE CEE-CREOP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREOP.
           IF VOCE = SPACE MOVE KCE-VOCE TO VOCE GO TO STA-30-40.
           IF KCE-TIPO = 5
              IF VOCE = 'A' AND KCE-VOCE = 'B'
                 PERFORM STA-VALPRO THRU EX-STA-VALPRO.
           IF KCE-VOCE = VOCE GO TO STA-30-10.
           IF ( TIPO = 1 AND VOCE = 'A' ) OR
              ( TIPO = 3 AND VOCE = 'C' ) OR
                TIPO = 5
                MOVE KCE-VOCE TO VOCE GO TO STA-30-40.
           PERFORM D00-TOT-VOCE THRU D99.
           MOVE KCE-VOCE TO VOCE GO TO STA-30-40.
       STA-30-10.
           IF ( TIPO = 3 AND ( VOCE = 'B' OR 'D' ) ) OR TIPO = 5
                                                 GO TO STA-30-20.
           IF GRUP = ZERO MOVE KCE-GRUP TO GRUP GO TO STA-30-30.
           IF KCE-GRUP = GRUP GO TO STA-30-20.
      *    > arrotondamento sotto la voce PASSIVO-A-VII (*)
      *    (altre riserve)
           IF TIPO = 3 AND KCE-VOCE = 'A' AND GRUP = '7'
              PERFORM ARROT-PASS THRU EX-ARROT-PASS.
           IF TIPO = 3 AND KCE-VOCE = 'A' AND GRUP = 7
                 IF SWDET = ZERO MOVE ALL '=' TO RSOT1 RSOT3
                            MOVE 2 TO RP-FLGR
                            MOVE 'RIG2' TO RP-BLK
                            PERFORM RPT-WR
                            MOVE KCE-GRUP TO GRUP GO TO STA-30-30
                            ELSE MOVE ZERO TO SWDET
                                       GO TO STA-30-15.
           IF TIPO = 3 AND KCE-VOCE = 'A'
                           MOVE KCE-GRUP TO GRUP GO TO STA-30-30.
       STA-30-15.
           PERFORM E00-TOT-GRUP THRU E99.
           MOVE KCE-GRUP TO GRUP GO TO STA-30-30.
       STA-30-20.
           IF TIPO = 3 AND KCE-VOCE = 'A' AND KCE-GRUP = 7
                       AND KCE-DETT NOT = SPACE MOVE 1 TO SWDET.
           IF IF-TPBIL = ZERO GO TO STA-30-25.
           IF TIPO NOT = 5 AND KCE-DETT NOT = SPACE GO TO STA-60.
           IF TIPO NOT = 5 AND KCE-TRAI NOT = ZERO  GO TO STA-60.
       STA-30-25.
           IF KCE-DETT NOT = SPACE MOVE KCE-DETT TO RDETT
                                   MOVE ')' TO RDETTP GO TO STA-60.
           IF KCE-TRAI NOT = ZERO
              IF KCE-PRG = ZERO AND KCE-DES = SPACE
                 MOVE KCE-TRAI TO RTRAI
                 MOVE ')'      TO RTRAIP
              ELSE
                 MOVE KCE-TRAI TO RTRAI1
                 MOVE KCE-DES  TO RDES
                 MOVE ')'      TO RTRAIP1
              END-IF
              GO TO STA-60.
       STA-30-30.
           IF KCE-GRUP NOT = ZERO MOVE RGRUX ( KCE-GRUP ) TO RGRUP
                                        MOVE ZERO TO TOTGRC TOTGRP
                                                      GO TO STA-50.
       STA-30-40.
           MOVE KCE-VOCE TO RVOCE.
           MOVE ')' TO RVOCEP.
           IF KCE-VOCE = 'Z' MOVE SPACE TO RVOCE RVOCEP.
           MOVE ZERO TO GRUP TOTGRC TOTGRP
                             TOTVOC TOTVOP.
           MOVE ZERO TO CREIN CREIP CREOU CREOP.
           MOVE ZERO TO EVIDE EVIDP.
           MOVE CEE-DESCR TO DESCR.
           PERFORM F00-CTR-ALL THRU F99.
           IF FLGALL = 1 MOVE ZERO TO FLGALL GO TO STA-40.
           MOVE DESC1 TO RDESC.
      **** rel 6.3
      *    IF DESC2 = SPACE GO TO STA-30-42.
      ************
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE DESC2 TO RDESC.
       STA-30-42.
           IF IF-TPBIL NOT = ZERO
              IF FLGALL = 2 MOVE ZERO TO SWSTA
                            GO TO STA-10.
           ADD CEE-VARIA TO CEE-TOTVO.
           ADD CEE-VARIP TO CEE-TOTVP.
           IF ( KCE-TIPO = 3 OR 4 )
               MULTIPLY -1 BY CEE-TOTVO CEE-TOTVP
                              CEE-CREIP CEE-CREOP
                              CEE-CREIN CEE-CREOU.
           MOVE CEE-TOTVO TO COMTOTVO.
           MOVE CEE-TOTVP TO COMTOTVP.
           MOVE CEE-CREIN TO COMCREIN.
           MOVE CEE-CREIP TO COMCREIP.
           MOVE CEE-CREOU TO COMCREOU.
           MOVE CEE-CREOP TO COMCREOP.
           IF IF-IMPCEN = ZERO
              MOVE CEE-TOTVO TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVO
              MOVE CEE-TOTVP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVP
              MOVE CEE-CREIN TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREIN
              MOVE CEE-CREIP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREIP
              MOVE CEE-CREOU TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREOU
              MOVE CEE-CREOP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREOP.
           ADD COMTOTVO TO TOTTIC
           ADD COMTOTVP TO TOTTIP.
           IF KCE-TIPO = 2 OR 4 GO TO STA-30-44.
           IF NOT ( KCE-TIPO = 1 AND KCE-VOCE = 'A' )
                  GO TO STA-30-42-00.
           IF CEE-EVIDE = ZERO AND CEE-EVIDP = ZERO
                  GO TO STA-30-44.
           PERFORM I00-STA-CONTI THRU I99.
           IF IF-TPBIL = ZERO
           IF SWSTA = ZERO MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
           IF IF-TPBIL NOT = ZERO
           IF SWSTA = ZERO MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR
                      ELSE MOVE ALL '-' TO RSOT0 RSOT3
                           MOVE 2 TO RP-FLGR
                           MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
           MOVE ZERO TO SWSTA.
           IF IF-IMPCEN = ZERO
              MOVE COMTOTVO  TO ERIMP2
           ELSE
              MOVE CEE-TOTVO TO RIMP2.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP2.
           IF IF-IMPCEN = ZERO
              MOVE COMTOTVP TO ERIMP4
           ELSE
              MOVE CEE-TOTVP TO RIMP4.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP4.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 'Quote richiamate' TO RDES1.
           IF IF-IMPCEN = ZERO
              MOVE COMEVIDE  TO ERIMP1
           ELSE
              MOVE CEE-EVIDE TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CEE-EVIDE TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE COMEVIDP  TO ERIMP3
           ELSE
              MOVE CEE-EVIDP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CEE-EVIDP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE '(' TO RPAR1 RPAR3 .
           MOVE ')' TO RPAR11 RPAR33.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM H00-STA-RIG THRU H99.
           MOVE ALL '=' TO RSOT1 RSOT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM H00-STA-RIG THRU H99.
           GO TO STA-10.
       STA-30-42-00.
           IF KCE-TIPO = 3 AND KCE-VOCE = 'C' GO TO STA-30-44.
           IF NOT ( ( KCE-TIPO = 1 AND KCE-VOCE = 'D' ) OR
                    ( KCE-TIPO = 3 AND KCE-VOCE = 'E' ) )
                                          GO TO STA-30-44.
           IF CEE-CREIN = ZERO AND CEE-CREIP = ZERO
                                    GO TO STA-30-44.
           PERFORM I00-STA-CONTI THRU I99.
           IF IF-TPBIL = ZERO
           IF SWSTA = ZERO MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
           IF IF-TPBIL NOT = ZERO
           IF SWSTA = ZERO MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR
                      ELSE MOVE ALL '-' TO RSOT0 RSOT3
                           MOVE 2 TO RP-FLGR
                           MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
           MOVE ZERO TO SWSTA.
           MOVE 'Ratei e risconti' TO RDES1.
           IF IF-IMPCEN = ZERO
              COMPUTE RD-NUM =  CEE-TOTVO - CEE-CREIN
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO COMOD
              COMPUTE RD-NUM =  CEE-TOTVP - CEE-CREIP
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO COMOP.
           IF IF-IMPCEN = ZERO
              MOVE COMOD TO ERIMP1
           ELSE
              MOVE COMOD TO RIMP1.
           IF IF-LIREUR = 1
              MOVE COMOD TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE COMOP TO ERIMP3
           ELSE
              MOVE COMOP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE COMOP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           IF IF-IMPCEN = ZERO
              MOVE COMCREIN  TO ERIMP1
           ELSE
              MOVE CEE-CREIN TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CEE-CREIN TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE COMCREIP  TO ERIMP3
           ELSE
              MOVE CEE-CREIP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CEE-CREIP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           IF IF-IMPCEN = ZERO
              MOVE COMTOTVO  TO ERIMP2
           ELSE
              MOVE CEE-TOTVO TO RIMP2.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP2.
           IF IF-IMPCEN = ZERO
              MOVE COMTOTVP  TO ERIMP4
           ELSE
              MOVE CEE-TOTVP TO RIMP4.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP4.
           IF KCE-VOCE = 'D'
              MOVE 'Disaggio su prestiti' TO RDES1
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE ALL '=' TO RSOT1 RSOT3
              MOVE 2 TO RP-FLGR
              MOVE 'RIG2' TO RP-BLK
              PERFORM H00-STA-RIG THRU H99
              GO TO STA-10
              ELSE
              MOVE 'Aggio su prestiti' TO RDES1
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE ALL '=' TO RSOT1 RSOT3
              MOVE 2 TO RP-FLGR
              MOVE 'RIG2' TO RP-BLK
              PERFORM H00-STA-RIG THRU H99
              GO TO STA-10.
       STA-30-44.
           PERFORM I00-STA-CONTI THRU I99.
           IF IF-TPBIL NOT = ZERO
              IF SWSTA NOT = ZERO MOVE ALL '-' TO RSOT0 RSOT3
                              MOVE 2 TO RP-FLGR
                              MOVE 'RIG2' TO RP-BLK
                              PERFORM RPT-WR
                              MOVE 1 TO XCRR.
           IF IF-IMPCEN = ZERO
              MOVE COMTOTVO  TO ERIMP2
           ELSE
              MOVE CEE-TOTVO TO RIMP2.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP2.
           IF IF-IMPCEN = ZERO
              MOVE COMTOTVP  TO ERIMP4
           ELSE
              MOVE CEE-TOTVP TO RIMP4.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP4.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           IF KCE-TIPO = 3 AND KCE-VOCE = 'C' MOVE 2 TO XCRR
           ELSE
           MOVE 1 TO XCRR.
           GO TO STA-10.
       STA-40.
           MOVE DESC1 TO RDESC.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           IF DESC2 = SPACE GO TO STA-10.
           MOVE DESC2 TO RDESC.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           GO TO STA-10.
       STA-50.
           MOVE CEE-DESCR TO DESCR.
           PERFORM F00-CTR-ALL THRU F99.
           IF FLGALL = 1 MOVE ZERO TO FLGALL GO TO STA-40.
           MOVE DESC1 TO RDESC.
           IF DESC2 = SPACE GO TO STA-50-10.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE DESC2 TO RDESC.
       STA-50-10.
           IF IF-TPBIL NOT = ZERO
              IF FLGALL = 2 MOVE ZERO TO SWSTA
                            GO TO STA-10.
           ADD CEE-VARIA TO CEE-TOTVO.
           ADD CEE-VARIP TO CEE-TOTVP.
           IF KCE-TIPO = 3 MULTIPLY -1 BY CEE-TOTVO CEE-TOTVP
                                          CEE-CREIP CEE-CREOP
                                          CEE-CREIN CEE-CREOU.
           MOVE CEE-TOTVO TO COMTOTVO.
           MOVE CEE-TOTVP TO COMTOTVP.
           MOVE CEE-CREIN TO COMCREIN.
           MOVE CEE-CREIP TO COMCREIP.
           MOVE CEE-CREOU TO COMCREOU.
           MOVE CEE-CREOP TO COMCREOP.
           IF IF-IMPCEN = ZERO
              MOVE CEE-TOTVO TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVO
              MOVE CEE-TOTVP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVP
              MOVE CEE-CREIN TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREIN
              MOVE CEE-CREIP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREIP
              MOVE CEE-CREOU TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREOU
              MOVE CEE-CREOP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREOP.
           ADD COMTOTVO TO TOTVOC TOTTIC
           ADD COMTOTVP TO TOTVOP TOTTIP.
           PERFORM I00-STA-CONTI THRU I99.
           IF IF-TPBIL NOT = ZERO
              IF SWSTA = 1 MOVE ALL '-' TO RSOT0 RSOT3
                           MOVE 2 TO RP-FLGR
                           MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE ZERO TO SWSTA.
           IF IF-IMPCEN = ZERO
              MOVE COMTOTVO  TO ERIMP1
           ELSE
              MOVE CEE-TOTVO TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE COMTOTVP  TO ERIMP3
           ELSE
              MOVE CEE-TOTVP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO RSOT1 RSOT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM H00-STA-RIG THRU H99.
           GO TO STA-10.
       STA-60.
           IF KCE-TIPO = 5 GO TO STA-70.
           IF IF-TPBIL NOT = ZERO GO TO STA-60-10.
           MOVE CEE-DESCR TO DESCR.
           PERFORM F00-CTR-ALL THRU F99.
           IF FLGALL = 1 MOVE ZERO TO FLGALL GO TO STA-40.
           MOVE DESC1 TO RDESC.
           IF DESC2 = SPACE GO TO STA-60-10.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE DESC2 TO RDESC.
       STA-60-10.
           PERFORM I00-STA-CONTI THRU I99.
           ADD CEE-VARIA TO CEE-TOTVO.
           ADD CEE-VARIP TO CEE-TOTVP.
           IF KCE-TIPO = 3 MULTIPLY -1 BY CEE-TOTVO CEE-TOTVP
                                          CEE-CREIP CEE-CREOP
                                          CEE-CREIN CEE-CREOU.
           MOVE CEE-TOTVO TO COMTOTVO.
           MOVE CEE-TOTVP TO COMTOTVP.
           MOVE CEE-CREIN TO COMCREIN.
           MOVE CEE-CREIP TO COMCREIP.
           MOVE CEE-CREOU TO COMCREOU.
           MOVE CEE-CREOP TO COMCREOP.
           IF IF-IMPCEN = ZERO
              MOVE CEE-TOTVO TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVO
              MOVE CEE-TOTVP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVP
              MOVE CEE-CREIN TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREIN
              MOVE CEE-CREIP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREIP
              MOVE CEE-CREOU TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREOU
              MOVE CEE-CREOP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMCREOP.
           ADD COMTOTVO  TO TOTVOC TOTGRC TOTTIC
           ADD COMTOTVP  TO TOTVOP TOTGRP TOTTIP.
           IF IF-TPBIL = ZERO GO TO STA-60-15.
           IF ( KCE-TIPO = 1 AND KCE-VOCE = 'C' AND KCE-GRUP = 2 )
           OR ( KCE-TIPO = 1 AND KCE-VOCE = 'B' AND
              ( KCE-GRUP = 1 OR 2  ) )
           OR ( KCE-TIPO = 3 AND KCE-VOCE = 'D' )
                GO TO STA-60-20.
           GO TO STA-10.
       STA-60-15.
           IF ( KCE-TIPO = 1 AND KCE-VOCE = 'B' AND KCE-GRUP = 3
                AND KCE-TRAI = 2 )
           OR ( KCE-TIPO = 1 AND KCE-VOCE = 'C' AND KCE-GRUP = 2 )
           OR ( KCE-TIPO = 3 AND KCE-VOCE = 'D' )
                GO TO STA-60-20.
           IF KCE-TIPO = 1 AND ( KCE-VOCE = 'B' OR 'C' ) AND
              KCE-GRUP = 3 AND KCE-TRAI = 4 AND
              CEE-TOTVO NOT = ZERO
              IF CEE-EVIDE = ZERO
              MOVE 'ER' TO ERRTES
              MOVE KCE-DATI TO ERCODI
              MOVE 'MANCA VALORE NOMINALE COMPLESSIVO' TO ERMSAG
              MOVE 1 TO SWERR
              WRITE RF-ERR
              GO TO STA-60-30
                 ELSE IF IF-IMPCEN = ZERO
                         MOVE COMTOTVO  TO ERIMP1
                      ELSE
                         MOVE CEE-TOTVO TO RIMP1
                      END-IF
                      IF IF-LIREUR = 1
                         MOVE CEE-TOTVO TO ER-IMPORTO
                         CALL 'rlitimp' USING ER-IMPORTO
                         MOVE ER-IMPORTO TO ERIMP1
                      END-IF
                      IF IF-IMPCEN = ZERO
                         MOVE COMTOTVP  TO ERIMP3
                      ELSE
                         MOVE CEE-TOTVP TO RIMP3
                      END-IF
                      IF IF-LIREUR = 1
                         MOVE CEE-TOTVP TO ER-IMPORTO
                         CALL 'rlitimp' USING ER-IMPORTO
                         MOVE ER-IMPORTO TO ERIMP3
                      END-IF
                      MOVE 'RIG2' TO RP-BLK
                      PERFORM RPT-WR
                      MOVE 1 TO XCRR
                      MOVE 'Valore nomin.compl.' TO RDES1
                      MOVE '(' TO RPAR1 RPAR3
                      IF IF-IMPCEN = ZERO
                         MOVE COMEVIDE  TO ERIMP1
                      ELSE
                         MOVE CEE-EVIDE TO RIMP1
                      END-IF
                      IF IF-LIREUR = 1
                         MOVE CEE-EVIDE TO ER-IMPORTO
                         CALL 'rlitimp' USING ER-IMPORTO
                         MOVE ER-IMPORTO TO ERIMP1
                      END-IF
                      IF IF-IMPCEN = ZERO
                         MOVE COMEVIDP  TO ERIMP3
                      ELSE
                         MOVE CEE-EVIDP TO RIMP3
                      END-IF
                      IF IF-LIREUR = 1
                         MOVE CEE-EVIDP TO ER-IMPORTO
                         CALL 'rlitimp' USING ER-IMPORTO
                         MOVE ER-IMPORTO TO ERIMP3
                      END-IF
                      MOVE ')' TO RPAR11 RPAR33
                      MOVE 'RIG2' TO RP-BLK
                      PERFORM RPT-WR
                      GO TO STA-10.
           GO TO STA-60-30.
       STA-60-20.
           IF NOT ( KCE-TIPO = 1 AND KCE-VOCE = 'B' AND
                  ( KCE-GRUP = 1 OR 2  ) )
           IF CEE-CREIN = ZERO AND CEE-CREOU = ZERO
              MOVE CEE-TOTVO TO CEE-CREIN
              MOVE COMTOTVO  TO COMCREIN.
           IF CEE-CREIN = ZERO AND CEE-CREOU = ZERO AND
              CEE-CREIP = ZERO AND CEE-CREOP = ZERO AND
              CEE-TOTVO = ZERO
              IF IF-TPBIL = ZERO
              GO TO STA-60-30.
           COMPUTE COMOD = CEE-CREIN + CEE-CREOU.
           COMPUTE COMOP = CEE-CREIP + CEE-CREOP.
           IF ( KCE-TIPO = 1 AND KCE-VOCE = 'B' AND
              ( KCE-GRUP = 1 OR 2  ) )
              ADD CEE-EVIDE TO COMOD
              ADD CEE-EVIDP TO COMOP.
           IF IF-IMPCEN = ZERO
              MOVE COMOD  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO COMOD
              MOVE COMOP  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO COMOP.
           IF COMOD = ZERO AND CEE-TOTVO NOT = ZERO
                           MOVE 'ER' TO ERRTES
                           MOVE 'MANCA RIPARTO' TO ERMSAG
                           MOVE KCE-DATI TO ERCODI
                           MOVE 1 TO SWERR
                           WRITE RF-ERR
                          IF IF-TPBIL NOT = ZERO GO TO STA-60-25
                          ELSE
                           GO TO STA-60-30.
           IF COMOD NOT = COMTOTVO MOVE 'ER' TO ERRTES
                          MOVE 'RIPARTO ERRATO' TO ERMSAG
                          MOVE KCE-DATI TO ERCODI
                          MOVE 1 TO SWERR
                          WRITE RF-ERR
                          IF IF-TPBIL NOT = ZERO GO TO STA-60-25
                          ELSE
                          GO TO STA-60-30.
           IF IF-TPBIL NOT = ZERO GO TO STA-60-25.
           IF SWSTA = ZERO
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE ZERO TO SWSTA.
       STA-60-25.
           IF COMOP = ZERO MOVE CEE-TOTVP TO CEE-CREIP.
           IF COMOP = ZERO MOVE COMTOTVP  TO COMCREIP.
           IF IF-TPBIL NOT = ZERO ADD CEE-CREIN TO CREIN
                               ADD CEE-CREIP TO CREIP
                               ADD CEE-CREOU TO CREOU
                               ADD CEE-CREOP TO CREOP
                               ADD CEE-EVIDE TO EVIDE
                               ADD CEE-EVIDP TO EVIDP
                               GO TO STA-10.

           MOVE 'Entro esercizio suc.' TO RDES1.
           IF IF-IMPCEN = ZERO
              MOVE COMCREIN  TO ERIMP1
           ELSE
              MOVE CEE-CREIN TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CEE-CREIN TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE COMCREIP  TO ERIMP3
           ELSE
              MOVE CEE-CREIP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CEE-CREIP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE 'Oltre esercizio suc.' TO RDES1.
           IF IF-IMPCEN = ZERO
              MOVE COMCREOU  TO ERIMP1
           ELSE
              MOVE CEE-CREOU TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CEE-CREOU TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE COMCREOP  TO ERIMP3
           ELSE
              MOVE CEE-CREOP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CEE-CREOP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           GO TO STA-10.
       STA-60-30.
           IF IF-TPBIL NOT = ZERO GO TO STA-10.
           IF IF-IMPCEN = ZERO
              MOVE COMTOTVO TO ERIMP1
           ELSE
              MOVE CEE-TOTVO TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE COMTOTVP TO ERIMP3
           ELSE
              MOVE CEE-TOTVP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           GO TO STA-10.
       STA-70.
           IF IF-TPBIL NOT = ZERO MOVE ZERO TO SWSTA.
           MOVE CEE-DESCR TO DESCR.
           PERFORM F00-CTR-ALL THRU F99.
           IF FLGALL = 1 MOVE ZERO TO FLGALL GO TO STA-40.
           MOVE DESC1 TO RDESC.
           IF DESC2 = SPACE GO TO STA-70-10.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE DESC2 TO RDESC.
       STA-70-10.
           ADD CEE-VARIA TO CEE-TOTVO.
           ADD CEE-VARIP TO CEE-TOTVP.
           PERFORM I00-STA-CONTI THRU I99.
           IF KCE-TRAI NOT = 23
              MULTIPLY -1 BY CEE-TOTVO CEE-TOTVP.
           MOVE CEE-TOTVO TO COMTOTVO.
           MOVE CEE-TOTVP TO COMTOTVP.
           IF IF-IMPCEN = ZERO
              MOVE CEE-TOTVO TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVO

              MOVE CEE-TOTVP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVP.
           ADD COMTOTVO  TO TOTVOC TOTTIC
           ADD COMTOTVP  TO TOTVOP TOTTIP.
           IF KCE-TRAI = 5 GO TO STA-70-20.
           IF KCE-TRAI < 15 OR
            ( KCE-TRAI = 16 AND ( KCE-DETT = 'b' OR 'c' ) ) OR
            ( KCE-TRAI = 18 OR 19 ) OR KCE-TRAI > 21
                                     GO TO STA-70-30.
       STA-70-20.
           IF KCE-TRAI NOT = 5 GO TO STA-70-20-00.
           IF CEE-CREIN = ZERO AND CEE-CREIP = ZERO
                                       GO TO STA-70-30.
           IF SWSTA = ZERO MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
           MOVE ZERO TO SWSTA.
           MULTIPLY -1 BY CEE-CREIN CEE-CREIP.
           MULTIPLY -1 BY COMCREIN COMCREIP.
           SUBTRACT CEE-CREIN FROM CEE-TOTVO.
           SUBTRACT CEE-CREIP FROM CEE-TOTVP.
           MOVE CEE-TOTVO TO COMTOTVO.
           MOVE CEE-TOTVP TO COMTOTVP.
           IF IF-IMPCEN = ZERO
              MOVE CEE-TOTVO TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVO

              MOVE CEE-TOTVP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVP.
           MOVE 'Ricavi e Proventi' TO RDES1.
           IF IF-IMPCEN = ZERO
              MOVE COMTOTVO  TO ERIMP1
           ELSE
              MOVE CEE-TOTVO TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE COMTOTVP  TO ERIMP3
           ELSE
              MOVE CEE-TOTVP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 'Contrib.cto eserciz.' TO RDES1.
           IF IF-IMPCEN = ZERO
              MOVE COMCREIN  TO ERIMP1
           ELSE
              MOVE CEE-CREIN TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CEE-CREIN TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE COMCREIP  TO ERIMP3
           ELSE
              MOVE CEE-CREIP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CEE-CREIP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           GO TO STA-70-40.
       STA-70-20-00.
           IF KCE-TRAI NOT = 15 GO TO STA-70-21.
           IF CEE-CREIN = ZERO AND CEE-CREIP = ZERO AND
              CEE-CREOU = ZERO AND CEE-CREOP = ZERO
              GO TO STA-70-30.
           MULTIPLY -1 BY CEE-CREIN CEE-CREIP CEE-CREOU CEE-CREOP.
           MULTIPLY -1 BY COMCREIN COMCREIP COMCREOU COMCREOP.
           COMPUTE CEE-TOTVO = CEE-TOTVO - ( CEE-CREIN + CEE-CREOU ).
           COMPUTE CEE-TOTVP = CEE-TOTVO - ( CEE-CREIP + CEE-CREOP ).
           MOVE CEE-TOTVO TO COMTOTVO.
           MOVE CEE-TOTVP TO COMTOTVP.
           IF IF-IMPCEN = ZERO
              MOVE CEE-TOTVO TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVO

              MOVE CEE-TOTVP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVP.
           IF SWSTA = ZERO MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
           MOVE ZERO TO SWSTA.
           IF CEE-CREIN NOT = ZERO OR CEE-CREIP NOT = ZERO
              MOVE  'Da Impr.Controllate' TO RDES1
              IF IF-IMPCEN = ZERO
                 MOVE COMCREIN  TO ERIMP1
              ELSE
                 MOVE CEE-CREIN TO RIMP1
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-CREIN TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              IF IF-IMPCEN = ZERO
                 MOVE COMCREIP  TO ERIMP3
              ELSE
                 MOVE CEE-CREIP TO RIMP3
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-CREIP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP3
              END-IF
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR.
           IF CEE-CREOU NOT = ZERO OR CEE-CREOP NOT = ZERO
              MOVE  'Da Impr.Collegate' TO RDES1
              IF IF-IMPCEN = ZERO
                 MOVE COMCREOU  TO ERIMP1
              ELSE
                 MOVE CEE-CREOU TO RIMP1
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-CREOU TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              IF IF-IMPCEN = ZERO
                 MOVE COMCREOP  TO ERIMP3
              ELSE
                 MOVE CEE-CREOP TO RIMP3
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-CREOP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP3
              END-IF
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR.
           MOVE 'Altre Partecipazioni' TO RDES1.
           GO TO STA-70-30.
       STA-70-21.
           IF NOT ( KCE-TRAI = 16 OR 17 ) GO TO STA-70-23.
           IF CEE-CREIN = ZERO AND CEE-CREIP = ZERO AND
              CEE-EVIDE = ZERO AND CEE-CREOU = ZERO AND
              CEE-CREOP = ZERO AND CEE-EVIDP = ZERO
              GO TO STA-70-30.
           MULTIPLY -1 BY CEE-CREIN CEE-CREOU
                          CEE-EVIDE CEE-CREIP
                          CEE-CREOP CEE-EVIDP.
           MULTIPLY -1 BY COMCREIN COMCREOU
                          COMEVIDE COMCREIP
                          COMCREOP COMEVIDP.
           COMPUTE CEE-TOTVO = CEE-TOTVO -
                            ( CEE-CREIN + CEE-CREOU + CEE-EVIDE ).
           COMPUTE CEE-TOTVP = CEE-TOTVP -
                            ( CEE-CREIP + CEE-CREOP + CEE-EVIDP ).
           MOVE CEE-TOTVO TO COMTOTVO.
           MOVE CEE-TOTVP TO COMTOTVP.
           IF IF-IMPCEN = ZERO
              MOVE CEE-TOTVO TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVO

              MOVE CEE-TOTVP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVP.
           IF SWSTA = ZERO MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
           MOVE ZERO TO SWSTA.
           IF CEE-CREIN NOT = ZERO OR CEE-CREIP NOT = ZERO
              IF IF-IMPCEN = ZERO
                 MOVE COMCREIN  TO ERIMP1
              ELSE
                 MOVE CEE-CREIN TO RIMP1
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-CREIN TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              IF IF-IMPCEN = ZERO
                 MOVE COMCREIP  TO ERIMP3
              ELSE
                 MOVE CEE-CREIP TO RIMP3
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-CREIP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP3
              END-IF
              IF KCE-TRAI = 16 MOVE  'Da Impr.Controllate' TO RDES1
                               MOVE 'RIG2' TO RP-BLK
                               PERFORM RPT-WR
                          ELSE MOVE 'Verso Controllate' TO RDES1
                               MOVE 'RIG2' TO RP-BLK
                               PERFORM RPT-WR.
           IF CEE-CREOU NOT = ZERO OR CEE-CREOP NOT = ZERO
              IF IF-IMPCEN = ZERO
                 MOVE COMCREOU  TO ERIMP1
              ELSE
                 MOVE CEE-CREOU TO RIMP1
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-CREOU TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              IF IF-IMPCEN = ZERO
                 MOVE COMCREOP  TO ERIMP3
              ELSE
                 MOVE CEE-CREOP TO RIMP3
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-CREOP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP3
              END-IF
              IF KCE-TRAI = 16 MOVE  'Da Impr.Collegate' TO RDES1
                                      MOVE 'RIG2' TO RP-BLK
                                      PERFORM RPT-WR
                          ELSE MOVE  'Verso Collegate' TO RDES1
                                      MOVE 'RIG2' TO RP-BLK
                                      PERFORM RPT-WR.
           IF CEE-EVIDE NOT = ZERO OR CEE-EVIDP NOT = ZERO
              IF IF-IMPCEN = ZERO
                 MOVE COMEVIDE  TO ERIMP1
              ELSE
                 MOVE CEE-EVIDE TO RIMP1
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-EVIDE TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              IF IF-IMPCEN = ZERO
                 MOVE COMEVIDP  TO ERIMP3
              ELSE
                 MOVE CEE-EVIDP TO RIMP3
              IF IF-LIREUR = 1
                 MOVE CEE-EVIDP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP3
              END-IF
              IF KCE-TRAI = 16 MOVE  'Da Impr.Controllanti' TO RDES1
                                      MOVE 'RIG2' TO RP-BLK
                                      PERFORM RPT-WR
                          ELSE MOVE  'Verso Controllanti' TO RDES1
                                      MOVE 'RIG2' TO RP-BLK
                                      PERFORM RPT-WR.
           IF KCE-TRAI = 17 MOVE 'Verso Altri' TO RDES1
                      ELSE  MOVE 'Da Altri' TO RDES1.
           GO TO STA-70-30.
       STA-70-23.
           IF KCE-TRAI NOT = 20  GO TO STA-70-23-00.
           IF CEE-CREIN = ZERO AND CEE-CREIP = ZERO GO TO STA-70-30.
           MULTIPLY -1 BY CEE-CREIN CEE-CREIP.
           MULTIPLY -1 BY COMCREIN COMCREIP.
           IF SWSTA = ZERO MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
           MOVE ZERO TO SWSTA.
           SUBTRACT CEE-CREIN FROM CEE-TOTVO.
           SUBTRACT CEE-CREIP FROM CEE-TOTVP.
           MOVE CEE-TOTVO TO COMTOTVO.
           MOVE CEE-TOTVP TO COMTOTVP.
           IF IF-IMPCEN = ZERO
              MOVE CEE-TOTVO TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVO

              MOVE CEE-TOTVP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVP.
           MOVE 'Plusval.da alienaz.' TO RDES1.
           IF IF-IMPCEN = ZERO
              MOVE COMCREIN  TO ERIMP1
           ELSE
              MOVE CEE-CREIN TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CEE-CREIN TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE COMCREIP  TO ERIMP3
           ELSE
              MOVE CEE-CREIP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CEE-CREIP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 'Altri proventi' TO RDES1.
           GO TO STA-70-30.
       STA-70-23-00.
           IF KCE-TRAI NOT = 21 GO TO STA-70-30.
           IF CEE-CREIN = ZERO AND CEE-CREIP = ZERO AND
              CEE-CREOU = ZERO AND CEE-CREOP = ZERO
              GO TO STA-70-30.
           IF SWSTA = ZERO MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
           MOVE ZERO TO SWSTA.
           MULTIPLY -1 BY CEE-CREIN CEE-CREIP
                          CEE-CREOU CEE-CREOP.
           MULTIPLY -1 BY COMCREIN COMCREIP
                          COMCREOU COMCREOP.
           COMPUTE CEE-TOTVO = CEE-TOTVO - ( CEE-CREIN + CEE-CREOU ).
           COMPUTE CEE-TOTVP = CEE-TOTVP - ( CEE-CREIP + CEE-CREOP ).
           MOVE CEE-TOTVO TO COMTOTVO.
           MOVE CEE-TOTVP TO COMTOTVP.
           IF IF-IMPCEN = ZERO
              MOVE CEE-TOTVO TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVO

              MOVE CEE-TOTVP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVP.
           IF CEE-CREIN NOT = ZERO OR CEE-CREIP NOT = ZERO
              MOVE 'Minusv.da alienaz.' TO RDES1
              IF IF-IMPCEN = ZERO
                 MOVE COMCREIN  TO ERIMP1
              ELSE
                 MOVE CEE-CREIN TO RIMP1
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-CREIN TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              IF IF-IMPCEN = ZERO
                 MOVE COMCREIP  TO ERIMP3
              ELSE
                 MOVE CEE-CREIP TO RIMP3
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-CREIP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP3
              END-IF
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR.
           IF CEE-CREOU NOT = ZERO OR CEE-CREOP NOT = ZERO
              MOVE 'Imposte eserc.prec.' TO RDES1
              IF IF-IMPCEN = ZERO
                 MOVE COMCREOU  TO ERIMP1
              ELSE
                 MOVE CEE-CREOU TO RIMP1
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-CREOU TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              IF IF-IMPCEN = ZERO
                 MOVE COMCREOP  TO ERIMP3
              ELSE
                 MOVE CEE-CREOP TO RIMP3
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-CREOP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP3
              END-IF
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR.
           MOVE 'Altri oneri' TO RDES1.
       STA-70-30.
           MOVE CEE-TOTVO TO COMTOTVO.
           MOVE CEE-TOTVP TO COMTOTVP.
           IF IF-IMPCEN = ZERO
              MOVE CEE-TOTVO TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVO

              MOVE CEE-TOTVP TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM   TO COMTOTVP.
           IF KCE-TRAI > 21
              IF IF-IMPCEN = ZERO
                 MOVE COMTOTVO  TO ERIMP2
              ELSE
                 MOVE CEE-TOTVO TO RIMP2
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-TOTVO TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP2
              END-IF
              IF IF-IMPCEN = ZERO
                 MOVE COMTOTVP  TO ERIMP4
              ELSE
                 MOVE CEE-TOTVP TO RIMP4
              END-IF
              IF IF-LIREUR = 1
                 MOVE CEE-TOTVP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP4
              END-IF
              ELSE IF IF-IMPCEN = ZERO
                      MOVE COMTOTVO  TO ERIMP1
                   ELSE
                      MOVE CEE-TOTVO TO RIMP1
                   END-IF
                   IF IF-LIREUR = 1
                      MOVE CEE-TOTVO TO ER-IMPORTO
                      CALL 'rlitimp' USING ER-IMPORTO
                      MOVE ER-IMPORTO TO ERIMP1
                   END-IF
                   IF IF-IMPCEN = ZERO
                      MOVE COMTOTVP  TO ERIMP3
                   ELSE
                      MOVE CEE-TOTVP TO RIMP3
                   END-IF
                   IF IF-LIREUR = 1
                      MOVE CEE-TOTVP TO ER-IMPORTO
                      CALL 'rlitimp' USING ER-IMPORTO
                      MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
       STA-70-40.
           IF KCE-TRAI = 14 MOVE ALL '=' TO R3SOT1 R3SOT3
                  MOVE 2 TO RP-FLGR
                  MOVE 'RIG3' TO RP-BLK
                  PERFORM H00-STA-RIG THRU H99
                  MOVE 'TOTALE COSTI PRODUZIONE' TO R3DESZ
                  IF IF-IMPCEN = ZERO
                     MOVE TOTVOC TO ER3IMP2
                  ELSE
                     MOVE TOTVOC TO R3IMP2
                  END-IF
                  IF IF-LIREUR = 1
                     MOVE TOTVOC TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER3IMP2
                  END-IF
                  IF IF-IMPCEN = ZERO
                     MOVE TOTVOP TO ER3IMP4
                  ELSE
                     MOVE TOTVOP TO R3IMP4
                  END-IF
                  IF IF-LIREUR = 1
                     MOVE TOTVOP TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER3IMP4
                  END-IF
                  MOVE 'RIG3' TO RP-BLK
                  PERFORM H00-STA-RIG THRU H99
                  MOVE ZERO TO TOTVOC TOTVOP
                  MOVE ALL '-' TO R3SOT2 R3SOT4
                  MOVE 2 TO RP-FLGR
                  MOVE 'RIG3' TO RP-BLK
                  PERFORM H00-STA-RIG THRU H99
                  MOVE 'DIFFERENZA VALORE E COSTI PRODUZIONE' TO R3DESZ
                  IF IF-IMPCEN = ZERO
                     MOVE TOTTIC TO ER3IMP2
                  ELSE
                     MOVE TOTTIC TO R3IMP2
                  END-IF
                  IF IF-LIREUR = 1
                     MOVE TOTTIC TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER3IMP2
                  END-IF
                  IF IF-IMPCEN = ZERO
                     MOVE TOTTIP TO ER3IMP4
                  ELSE
                     MOVE TOTTIP TO R3IMP4
                  END-IF
                  IF IF-LIREUR = 1
                     MOVE TOTTIP TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER3IMP4
                  END-IF
                  MOVE 'RIG3' TO RP-BLK
                  PERFORM H00-STA-RIG THRU H99
                  MOVE 2 TO XCRR.
           IF KCE-TRAI = 17 AND KCE-PRG NOT = ZERO
                  MOVE ALL '=' TO R3SOT1 R3SOT3
                  MOVE 2 TO RP-FLGR
                  MOVE 'RIG3' TO RP-BLK
                  PERFORM H00-STA-RIG THRU H99
                  MOVE 'TOTALE PROVENTI E ONERI FINANZIARI' TO R3DESZ
                  IF IF-IMPCEN = ZERO
                     MOVE TOTVOC TO ER3IMP2
                  ELSE
                     MOVE TOTVOC TO R3IMP2
                  END-IF
                  IF IF-LIREUR = 1
                     MOVE TOTVOC TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER3IMP2
                  END-IF
                  IF IF-IMPCEN = ZERO
                     MOVE TOTVOP TO ER3IMP4
                  ELSE
                     MOVE TOTVOP TO R3IMP4
                  END-IF
                  IF IF-LIREUR = 1
                     MOVE TOTVOP TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER3IMP4
                  END-IF
                  MOVE 'RIG3' TO RP-BLK
                  PERFORM H00-STA-RIG THRU H99
                  MOVE 2 TO XCRR
                  MOVE ZERO TO TOTVOC TOTVOP.
           IF KCE-TRAI = 19 AND KCE-DETT = 'c'
                  MOVE ALL '=' TO R3SOT1 R3SOT3
                  MOVE 2 TO RP-FLGR
                  MOVE 'RIG3' TO RP-BLK
                  PERFORM H00-STA-RIG THRU H99
                  MOVE 'TOTALE RETTIFICHE VALORE ATTIV.FINANZ.'
                       TO R3DESZ
                  IF IF-IMPCEN = ZERO
                     MOVE TOTVOC TO ER3IMP2
                  ELSE
                     MOVE TOTVOC TO R3IMP2
                  END-IF
                  IF IF-LIREUR = 1
                     MOVE TOTVOC TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER3IMP2
                  END-IF
                  IF IF-IMPCEN = ZERO
                     MOVE TOTVOP TO ER3IMP4
                  ELSE
                     MOVE TOTVOP TO R3IMP4
                  END-IF
                  IF IF-LIREUR = 1
                     MOVE TOTVOP TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER3IMP4
                  END-IF
                  MOVE 'RIG3' TO RP-BLK
                  PERFORM H00-STA-RIG THRU H99
                  MOVE 2 TO XCRR
                  MOVE ZERO TO TOTVOC TOTVOP.
      *    > arrotondamento sotto la voce CONTO ECONOMICO-E (*)
      *    (proventi e oneri straordinari)
           IF KCE-TIPO = 5 AND KCE-VOCE = 'E' AND KCE-TRAI = 21
              MOVE KEYCE TO SAVKEY
              READ BILCEE NEXT AT END MOVE SAVKEY TO KEYCE
                                      READ BILCEE
                                      END-READ
                                      GO TO OK-STA
              END-READ
           IF KCE-TIPO = 5 AND KCE-VOCE = 'E' AND KCE-TRAI = 21 AND
              KCE-DETT NOT = SPACE
              MOVE SAVKEY TO KEYCE
              READ BILCEE
              END-READ
              GO TO STA-10
           ELSE
              MOVE SAVKEY TO KEYCE
              READ BILCEE.
       OK-STA.
           IF KCE-TIPO = 5 AND KCE-VOCE = 'E' AND KCE-TRAI = 21
              PERFORM ARROT-ECONOM THRU EX-ARROT-ECONOM.
           IF KCE-TRAI = 21 MOVE ALL '=' TO R3SOT1 R3SOT3
                  MOVE 2 TO RP-FLGR
                  MOVE 'RIG3' TO RP-BLK
                  PERFORM H00-STA-RIG THRU H99
                  MOVE 'TOTALE PARTITE STRAORDINARIE' TO R3DESZ
                  IF IF-IMPCEN = ZERO
                     MOVE TOTVOC TO ER3IMP2
                  ELSE
                     MOVE TOTVOC TO R3IMP2
                  END-IF
                  IF IF-LIREUR = 1
                     MOVE TOTVOC TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER3IMP2
                  END-IF
                  IF IF-IMPCEN = ZERO
                     MOVE TOTVOP TO ER3IMP4
                  ELSE
                     MOVE TOTVOP TO R3IMP4
                  END-IF
                  IF IF-LIREUR = 1
                     MOVE TOTVOP TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER3IMP4
                  END-IF
                  MOVE 'RIG3' TO RP-BLK
                  PERFORM H00-STA-RIG THRU H99
                  MOVE ZERO TO TOTVOC TOTVOP
                  MOVE ALL '-' TO R3SOT2 R3SOT4
                  MOVE 2 TO RP-FLGR
                  MOVE 'RIG3' TO RP-BLK
                  PERFORM H00-STA-RIG THRU H99
                  MOVE 'RISULTATO PRIMA DELLE IMPOSTE' TO R3DESZ
                  IF IF-IMPCEN = ZERO
                     MOVE TOTTIC TO ER3IMP2
                  ELSE
                     MOVE TOTTIC TO R3IMP2
                  END-IF
                  IF IF-LIREUR = 1
                     MOVE TOTTIC TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER3IMP2
                  END-IF
                  IF IF-IMPCEN = ZERO
                     MOVE TOTTIP TO ER3IMP4
                  ELSE
                     MOVE TOTTIP TO R3IMP4
                  END-IF
                  IF IF-LIREUR = 1
                     MOVE TOTTIP TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER3IMP4
                  END-IF
                  MOVE 'RIG3' TO RP-BLK
                  PERFORM H00-STA-RIG THRU H99
                  MOVE 2 TO XCRR.
      *
           COPY 'grirpt-r'.
      *
           GO TO STA-10.
       FNSTA.
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
      *
           IF SW-SBIL NOT = ZERO
              MOVE 'Attenzione sbilancio !!!' TO MESS
              MOVE 8 TO ERRIO-ST.
           CLOSE ERRORI.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDERR.
           MOVE SPACE TO ID-ERR.
           STRING 'w1' PID DELIMITED SPACE INTO ID-ERR.
       EX-CREA-IDERR.
           EXIT.
      *------------------
       A00-CAL-BIL.
           MOVE KEC-CONTO TO CODINI CODULT.
           IF CODUX = ZERO MOVE  99 TO CODUS
                           MOVE 999 TO CODUC.
           IF CODUC = ZERO MOVE 999 TO CODUC.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE CODINI TO KPC-COD.
           START ANACON KEY NOT < KEYPC INVALID GO TO A99.
       A10.
           READ ANACON NEXT INTO REKCON AT END GO TO A99.
           IF SF-CON = '9D' OR '9A' OR '35' GO TO A10.
           IF KPC-AZI NOT = KAZ-COD OR
              KPC-COD > CODULT GO TO A99.
           IF CON-MOVIM NOT = ZERO
              PERFORM VERIFICA-CONTO THRU EX-VERIFICA-CONTO
              IF FLGOK = ZERO GO TO A10.
      **** rel 6.2
      *    IF IF-FL = 1 GO TO A10-20.
      **********
      **** rel 6.2
           MOVE ZERO TO IMLIDARE IMLIAVER.
           IF IF-FLMLI = 1 PERFORM CALCOLA-MLI THRU EX-CALCOLA-MLI.
      ************
           PERFORM G00-LEGGE-CONTO THRU G99.
           ADD CON-SPSP TO CON-SESP.
           MOVE CON-SESP TO SALDO.
      **** rel 6.2
           IF IF-FL = 1 PERFORM B00-CALCSALDO THRU B99.
      *
           IF IF-FLRIP = ZERO OR IF-FL = 1 GO TO NORIP.
           IF CON-TIPO = 'E' GO TO NORIP.
           MOVE KEYPC TO SAVPC KEYCL.
           READ ANACOL INTO REKCON INVALID MOVE ZERO TO CON-SESP
                                                        CON-SE-D
                                                        CON-SE-A. 
           COMPUTE SALDO = SALDO + CON-SESP + CON-SE-D - CON-SE-A.
      *
           MOVE SAVPC TO KEYPC.
           READ ANACON INTO REKCON.
       NORIP.
      **********
           GO TO A10-40.
       A10-20.
           IF KPC-COD = T20-COUTI OR
              KPC-COD = T20-COPER GO TO A10.
           COMPUTE SALDO = CON-SESP + CON-SE-D - CON-SE-A.
           IF IF-FL = 1 PERFORM B00-CALCSALDO THRU B99.
       A10-40.
      **** rel 6.2
           ADD IMLIDARE TO SALDO.
           SUBTRACT IMLIAVER FROM SALDO.
      ************
           IF KCE-TIPO NOT = 2 GO TO A10-50.
           IF CEE-TEST1 = 1 AND SALDO < ZERO GO TO A10.
           ADD SALDO TO TTORD.
           GO TO A50.
       A10-50.
           IF KCE-TIPO NOT = 4 GO TO A10-60.
           IF CEE-TEST1 = 1 AND SALDO > ZERO GO TO A10.
           ADD SALDO TO TTORD.
           GO TO A50.
       A10-60.
           IF KCE-TIPO NOT = 1 GO TO A20.
           IF CEE-TEST1 = 1 AND SALDO < ZERO GO TO A10.
           ADD SALDO TO TTPAT.
           GO TO A50.
       A20.
           IF KCE-TIPO NOT = 3 GO TO A30.
           IF CEE-TEST1 = 1 AND SALDO > ZERO GO TO A10.
           ADD SALDO TO TTPAT.
           GO TO A50.
       A30.
           IF KCE-TIPO NOT = 5 GO TO A50.
           ADD SALDO TO TTECO.
       A50.
           ADD SALDO TO COMOD CEC-IMPO.
      **** rel 6.2
           SUBTRACT IMLIDARE FROM CEC-IMPO.
           ADD IMLIAVER TO CEC-IMPO.
      ************
           GO TO A10.
       A99.
           EXIT.
      *------------------------
       B00-CALCSALDO.
           MOVE LOW-VALUE TO KEYMV.
           MOVE KPC-AZI   TO KMV-AZI.
           MOVE KPC-COD   TO KMV-CON.
           START MOVIME KEY NOT < KEYMV INVALID GO TO B20.
       B10.
           READ MOVIME NEXT INTO REKMOV AT END GO TO B20.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO B10.
           IF KMV-AZI > KPC-AZI GO TO B20.
           IF KMV-CON > KPC-COD GO TO B20.
      **** rel 6.2
           IF KMV-DAT > PKDAT   GO TO B20.
      **********
           IF NOT ( MOV-CAUS = T20-CDSOC OR 
                    MOV-CAUS = T20-CASOC ) GO TO B10.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO SALDO
           ELSE SUBTRACT MOV-IMPO FROM SALDO.
           GO TO B10.
       B20.
           MOVE LOW-VALUE TO KEYMX.
           MOVE KPC-AZI   TO KMX-AZI.
           MOVE KPC-COD   TO KMX-CON.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO B99.
       B30.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO B99.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO B30.
           IF KMX-AZI > KPC-AZI GO TO B99.
           IF KMX-CON > KPC-COD GO TO B99.
      **** rel 6.2
           IF KMX-DAT > PKDAT   GO TO B99.
      **********
           IF NOT ( MOV-CAUS = T20-CDSOC OR 
                    MOV-CAUS = T20-CASOC ) GO TO B30.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO SALDO
                ELSE SUBTRACT MOV-IMPO FROM SALDO.
           GO TO B30.
       B99.
           EXIT.
      *----------------*
       C00-TOT-TIP.
      *    > arrotondamento sotto la voce CONTI D'ORDINE ATTIVO
           IF TIPO = 2
              PERFORM ARROT-CONTORDA THRU EX-ARROT-CONTORDA.

      *    > arrotondamento sotto la voce CONTI D'ORDINE PASSIVO
           IF TIPO = 4
              PERFORM ARROT-CONTORDP THRU EX-ARROT-CONTORDP.
           MOVE ALL '-' TO R3SOT2 R3SOT4.
           MOVE 2 TO RP-FLGR.
           IF NRIG NOT < NRGL MOVE 59 TO NRIG.
           MOVE 1 TO XCRR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
           IF TIPO = 1 MOVE 'TOTALE ATTIVO' TO R3DESZ.
           IF TIPO = 2 MOVE 'TOTALE CONTI D''ORDINE' TO R3DESZ.
           IF TIPO = 3 MOVE 'TOTALE PASSIVO' TO R3DESZ.
           IF TIPO = 4 MOVE 'TOTALE CONTI D''ORDINE' TO R3DESZ.
           IF IF-IMPCEN = ZERO
              MOVE TOTTIC TO ER3IMP2
           ELSE
              MOVE TOTTIC TO R3IMP2.
           IF IF-LIREUR = 1
              MOVE TOTTIC TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3IMP2.
           IF IF-IMPCEN = ZERO
              MOVE TOTTIP TO ER3IMP4
           ELSE
              MOVE TOTTIP TO R3IMP4.
           IF IF-LIREUR = 1
              MOVE TOTTIP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3IMP4.
           IF NRIG NOT < NRGL MOVE 59 TO NRIG.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE ALL '=' TO R3SOT2 R3SOT4.
           MOVE 2 TO RP-FLGR.
           IF NRIG NOT < NRGL MOVE 59 TO NRIG.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE ZERO TO TOTTIC TOTTIP.
       C99.
           EXIT.
      *----------------*
       D00-TOT-VOCE.
           PERFORM E00-TOT-GRUP THRU E99.
           IF NRIG NOT < NRGL MOVE 59 TO NRIG.
           IF TIPO = 1 AND VOCE = 'B'
              MOVE 'TOTALE IMMOBILIZZAZIONI' TO R3DESZ.
           IF TIPO = 1 AND VOCE = 'C'
              MOVE 'TOTALE ATTIVO CIRCOLANTE' TO R3DESZ.
           IF TIPO = 3 AND VOCE = 'A'
              MOVE 'TOTALE PATRIMONIO NETTO' TO R3DESZ.
           IF IF-TPBIL NOT = ZERO GO TO D05.
           IF TIPO = 3 AND VOCE = 'B'
              MOVE ALL '=' TO R3SOT1 R3SOT3
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3' TO RP-BLK
              PERFORM RPT-WR
              MOVE 'TOTALE FONDI RISCHI E ONERI' TO R3DESZ.
           IF TIPO = 3 AND VOCE = 'D'
              MOVE ALL '=' TO R3SOT1 R3SOT3
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3' TO RP-BLK
              PERFORM RPT-WR
              MOVE 'TOTALE DEBITI' TO R3DESZ.
           GO TO D20.
       D05.
           IF TIPO = 3 AND NOT ( VOCE = 'B' OR 'D' ) GO TO D10.
           IF SWSTA = ZERO GO TO D10.
           MOVE ALL '-' TO RSOT0 RSOT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE ZERO TO SWSTA.
       D10.
           MOVE ZERO TO FLGALL.
           IF NOT ( TIPO = 3 AND VOCE = 'D' ) GO TO D20.
           IF CREIN = ZERO AND CREOU = ZERO AND
              CREIP = ZERO AND CREOP = ZERO AND
              TOTGRC = ZERO GO TO D20.
           COMPUTE COMOD = CREIN + CREOU.
           COMPUTE COMOP = CREIP + CREOP.
           IF IF-IMPCEN = ZERO
              MOVE COMOD  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO COMOD
              MOVE COMOP  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO COMOP.
           IF COMOD NOT = TOTVOC GO TO D15.
           IF COMOP = ZERO MOVE TOTVOP TO CREIP.
           MOVE 'Entro esercizio suc.' TO RDES1.
           IF IF-IMPCEN = ZERO
              MOVE CREIN  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO ERIMP1
           ELSE
              MOVE CREIN TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CREIN TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE CREIP  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO ERIMP3
           ELSE
              MOVE CREIP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CREIP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE 'Oltre esercizio suc.' TO RDES1.
           IF IF-IMPCEN = ZERO
              MOVE CREOU  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO ERIMP1
           ELSE
              MOVE CREOU TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CREOU TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE CREOP  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO ERIMP3
           ELSE
              MOVE CREOP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CREOP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE ALL '-' TO RSOT1 RSOT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
       D15.
           MOVE ZERO TO CREIN CREIP CREOU CREOP.
       D20.
      *    IF IF-TPBIL = ZERO OR NOT (TIPO = 3 AND VOCE = 'B')



           IF IF-TPBIL NOT = ZERO AND (TIPO = 3 AND VOCE = 'B')
      * abbreviato
              IF IF-IMPCEN = ZERO
                 MOVE TOTVOC TO ERIMP2
              ELSE
                 MOVE TOTVOC TO RIMP2
              END-IF
              IF IF-LIREUR = 1
                 MOVE TOTVOC TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP2
              END-IF
              IF IF-IMPCEN = ZERO
                 MOVE TOTVOP TO ERIMP4
              ELSE
                 MOVE TOTVOP TO RIMP4
              END-IF
              IF IF-LIREUR = 1
                 MOVE TOTVOP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP4
              END-IF
              MOVE 'RIG2' TO RP-BLK
           ELSE
      * normale
              IF IF-IMPCEN = ZERO
                 MOVE TOTVOC TO ER3IMP2
              ELSE
                 MOVE TOTVOC TO R3IMP2
              END-IF
              IF IF-LIREUR = 1
                 MOVE TOTVOC TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ER3IMP2
              END-IF
              IF IF-IMPCEN = ZERO
                 MOVE TOTVOP TO ER3IMP4
              ELSE
                 MOVE TOTVOP TO R3IMP4
              END-IF
              IF IF-LIREUR = 1
                 MOVE TOTVOP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ER3IMP4
              END-IF
              MOVE 'RIG3' TO RP-BLK
           END-IF
           IF NRIG NOT < NRGL MOVE 59 TO NRIG.
           PERFORM RPT-WR.
           MOVE 2 TO XCRR.
           MOVE ZERO TO TOTVOC TOTVOP.
       D99.
           EXIT.
      *----------------*
       E00-TOT-GRUP.
           IF GRUP = ZERO GO TO E99.
           IF TIPO = 3 AND VOCE = 'A' AND GRUP = 9 GO TO E99.
           IF IF-TPBIL = ZERO GO TO E10.
           IF SWSTA = ZERO GO TO E05.
           MOVE ALL '-' TO RSOT0 RSOT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE ZERO TO SWSTA.
       E05.
           IF NOT ( TIPO = 1 AND VOCE = 'C' AND GRUP = 2 )
                                             GO TO E05-10.
           IF CREIN = ZERO AND CREOU = ZERO AND
              CREIP = ZERO AND CREOP = ZERO AND
              TOTGRC = ZERO GO TO E20.
           COMPUTE COMOD = CREIN + CREOU.
           COMPUTE COMOP = CREIP + CREOP.
           IF IF-IMPCEN = ZERO
              MOVE COMOD  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO COMOD
              MOVE COMOP  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO COMOP.
           IF COMOD NOT = TOTGRC GO TO E15.
           IF COMOP = ZERO MOVE TOTGRP TO CREIP.
           MOVE 'Entro esercizio suc.' TO RDES1.
           IF IF-IMPCEN = ZERO
              MOVE CREIN  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO ERIMP1
           ELSE
              MOVE CREIN TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CREIN TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE CREIP  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO ERIMP3
           ELSE
              MOVE CREIP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CREIP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE 'Oltre esercizio suc.' TO RDES1.
           IF IF-IMPCEN = ZERO
              MOVE CREOU  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO ERIMP1
           ELSE
              MOVE CREOU TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CREOU TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE CREOP  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO ERIMP3
           ELSE
              MOVE CREOP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CREOP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           GO TO E10.
       E05-10.
           IF NOT ( TIPO = 1 AND VOCE = 'B' AND ( GRUP = 1 OR 2 ))
                                                        GO TO E20.
           MOVE 'Immobilizzazioni' TO RDES1.
           IF IF-IMPCEN = ZERO
              MOVE CREIN  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO ERIMP1
           ELSE
              MOVE CREIN TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CREIN TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE CREIP  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO ERIMP3
           ELSE
              MOVE CREIP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CREIP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE 'Ammortamenti' TO RDES1.
           IF IF-IMPCEN = ZERO
              MOVE CREOU  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO ERIMP1
           ELSE
              MOVE CREOU TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CREOU TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE CREOP  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO ERIMP3
           ELSE
              MOVE CREOP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CREOP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 'Svalutazioni' TO RDES1.
           IF IF-IMPCEN = ZERO
              MOVE EVIDE  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO EVIDE

              MOVE EVIDP  TO RD-NUM
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO EVIDP.
           IF IF-IMPCEN = ZERO
              MOVE EVIDE TO ERIMP1
           ELSE
              MOVE EVIDE TO RIMP1.
           IF IF-LIREUR = 1
              MOVE EVIDE TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           IF IF-IMPCEN = ZERO
              MOVE EVIDP TO ERIMP3
           ELSE
              MOVE EVIDP TO RIMP3.
           IF IF-LIREUR = 1
              MOVE EVIDP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
       E10.
           MOVE ALL '-' TO R3SOT1 R3SOT3.
           MOVE 2 TO RP-FLGR.
           IF IF-TPBIL = ZERO
           IF NRIG NOT < NRGL MOVE 59 TO NRIG.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
           IF IF-TPBIL NOT = ZERO GO TO E15.
           IF TIPO = 1 AND VOCE = 'B' AND GRUP = 1
              MOVE '      TOTALE IMMOBILIZZAZIONI IMMATERIALI'
                          TO R3DESZ.
           IF TIPO = 1 AND VOCE = 'B' AND GRUP = 2
              MOVE '      TOTALE IMMOBILIZZAZIONI MATERIALI'
                          TO R3DESZ.
           IF TIPO = 1 AND VOCE = 'B' AND GRUP = 3
              MOVE '      TOTALE IMMOBILIZZAZIONI FINANZIARIE'
                          TO R3DESZ.
           IF TIPO = 1 AND VOCE = 'C' AND GRUP = 1
              MOVE '      TOTALE RIMANENZE'
                          TO R3DESZ.
           IF TIPO = 1 AND VOCE = 'C' AND GRUP = 2
              MOVE '      TOTALE CREDITI'
                          TO R3DESZ.
           IF TIPO = 1 AND VOCE = 'C' AND GRUP = 3
              MOVE '      TOTALE ATTIVITA'' FINANZIARIE'
                          TO R3DESZ.
           IF TIPO = 1 AND VOCE = 'C' AND GRUP = 4
              MOVE '      TOTALE DISPONIBILITA'' LIQUIDE'
                          TO R3DESZ.
           GO TO E20.
       E15.
           MOVE ZERO TO CREIN CREIP CREOU CREOP.
           MOVE ZERO TO EVIDE EVIDP.
       E20.
           IF IF-TPBIL NOT = ZERO
      * abbreviato
              IF IF-IMPCEN = ZERO
                 MOVE TOTGRC TO ERIMP1
              ELSE
                 MOVE TOTGRC TO RIMP1
              END-IF
              IF IF-LIREUR = 1
                 MOVE TOTGRC TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              IF IF-IMPCEN = ZERO
                 MOVE TOTGRP TO ERIMP3
              ELSE
                 MOVE TOTGRP TO RIMP3
              END-IF
              IF IF-LIREUR = 1
                 MOVE TOTGRP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP3
              END-IF
              MOVE 'RIG2' TO RP-BLK
           ELSE
      * normale
              IF IF-IMPCEN = ZERO
                 MOVE TOTGRC TO ER3IMP1
              ELSE
                 MOVE TOTGRC TO R3IMP1
              END-IF
              IF IF-LIREUR = 1
                 MOVE TOTGRC TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ER3IMP1
              END-IF
              IF IF-IMPCEN = ZERO
                 MOVE TOTGRP TO ER3IMP3
              ELSE
                 MOVE TOTGRP TO R3IMP3
              END-IF
              IF IF-LIREUR = 1
                 MOVE TOTGRP TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ER3IMP3
              END-IF
              MOVE 'RIG3' TO RP-BLK
           END-IF
           IF NRIG NOT < NRGL MOVE 59 TO NRIG.
           PERFORM RPT-WR.
           MOVE ZERO TO TOTGRC TOTGRP.
           IF NRIG NOT < NRGL MOVE 59 TO NRIG.
           MOVE ALL '=' TO R3SOT1 R3SOT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
           IF IF-TPBIL NOT = ZERO MOVE ZERO TO FLGALL.
       E99.
           EXIT.
      *----------------*
       F00-CTR-ALL.
           MOVE ZERO TO FLGALL.
           IF KCE-TIPO = 1 AND ( KCE-VOCE > 'A' AND < 'D' )
                           AND KCE-GRUP = ZERO
                           MOVE 1 TO FLGALL GO TO F99.
           IF KCE-TIPO = 1 AND ( KCE-VOCE > 'A' AND < 'D' )
                           AND KCE-TRAI = ZERO
              IF IF-TPBIL NOT = ZERO MOVE 2 TO FLGALL GO TO F99
                 ELSE
                 MOVE 1 TO FLGALL GO TO F99.
           IF IF-TPBIL = ZERO
           IF KCE-TIPO = 1 AND KCE-VOCE = 'B' AND KCE-GRUP = 3 AND
             (KCE-TRAI = 1 OR 2) AND KCE-DETT = SPACE
                            MOVE 1 TO FLGALL GO TO F99.
           IF KCE-TIPO = 3 AND KCE-VOCE = 'A' AND
                               KCE-GRUP = ZERO
                            MOVE 1 TO FLGALL GO TO F99.
           IF KCE-TIPO = 3 AND (KCE-VOCE = 'B' OR 'D') AND
                               KCE-TRAI = ZERO
              IF IF-TPBIL NOT = ZERO MOVE 2 TO FLGALL GO TO F99
                 ELSE
                 MOVE 1 TO FLGALL GO TO F99.
           IF KCE-TIPO = 3 AND KCE-VOCE = 'A' AND
              KCE-GRUP = 7 AND KCE-DETT = SPACE
              IF IF-TPBIL NOT = ZERO MOVE 2 TO FLGALL GO TO F99
                 ELSE
                 MOVE 1 TO FLGALL GO TO F99.
           IF KCE-TIPO = 5 AND KCE-TRAI = ZERO
                            MOVE 1 TO FLGALL GO TO F99.
           IF KCE-TIPO = 5 AND
              (KCE-TRAI = 9 OR 10 OR 16 OR 18 OR 19) AND
                              KCE-DETT = SPACE
                            MOVE 1 TO FLGALL GO TO F99.
       F99.
           EXIT.
      *----------------*
       G00-LEGGE-CONTO.
           MOVE ZERO TO CON-SP-D CON-SP-A CON-SE-D CON-SE-A.
           IF PKDAT > AZI-RVDT MOVE ZERO TO CON-SESP GO TO G40.
           MOVE ZERO TO CON-SPSP CON-SESP.
           MOVE LOW-VALUE TO KEYMX.
           MOVE KPC-AZI TO KMX-AZI.
           MOVE KPC-COD TO KMX-CON.
           MOVE AZI-DTAPE TO KMX-DAT.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO G40.
       G10.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO G40.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO G10.
           IF KMX-AZI > KPC-AZI GO TO G40.
           IF KMX-CON > KPC-COD GO TO G40.
           IF KMX-DAT > PKDAT   GO TO G40.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CON-SESP
           ELSE SUBTRACT MOV-IMPO FROM CON-SESP.
           GO TO G10.
       G40.
           MOVE LOW-VALUE TO KEYMV.
           MOVE KPC-AZI TO KMV-AZI.
           MOVE KPC-COD TO KMV-CON.
           MOVE ZERO    TO KMV-DAT.
           START MOVIME KEY NOT < KEYMV INVALID GO TO G99.
       G50.
           READ MOVIME NEXT INTO REKMOV AT END GO TO G99.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO G50.
           IF KMV-AZI > KPC-AZI GO TO G99.
           IF KMV-CON > KPC-COD GO TO G99.
           IF KMV-DAT > PKDAT   GO TO G99.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CON-SPSP
           ELSE SUBTRACT MOV-IMPO FROM CON-SPSP.
           GO TO G50.
       G99.
           EXIT.
      *----------------*
       H00-STA-RIG.
           IF NRIG NOT < NRGL MOVE 59 TO NRIG.
           PERFORM RPT-WR.
       H99.
           EXIT.
      *----------------*
       I00-STA-CONTI.
           IF IF-TPSTA > ZERO GO TO I05.
           IF CEE-TEST3 = ZERO GO TO I99.
       I05.
           IF IF-TPBIL = ZERO MOVE ZERO TO SWSTA.
           MOVE KCE-AZI  TO KEC-AZI.
           MOVE KCE-DATI TO KEC-DATI.
           MOVE ZERO TO KEC-CONTO.
           START BILCEC KEY NOT < KEYEC INVALID GO TO I20.
       I10.
           READ BILCEC NEXT AT END GO TO I20.
           IF KEC-AZI  NOT = KCE-AZI  GO TO I20.
           IF KEC-DATI NOT = KCE-DATI GO TO I20.
           MOVE KEYEC TO KEYEP.
           READ BILCEP INVALID MOVE ZERO TO CEP-IMPO.
      **** rel 6.2
      *    IF CEC-IMPO = ZERO AND CEP-IMPO = ZERO GO TO I10.
           MOVE ZERO TO SWDES.
           IF CEC-IMPO = ZERO AND CEP-IMPO = ZERO GO TO I15.
      ************
           IF SWSTA = ZERO MOVE 1 TO SWSTA
                           MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE KEC-CONTO TO KPC-COD.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO  CON-DESCR.
           MOVE CON-DESCR TO RDECO.
           IF KCE-TIPO = 3 OR 4 OR
                        ( KCE-TIPO = 5 AND KCE-TRAI NOT = 23 )
                        MULTIPLY -1 BY CEC-IMPO CEP-IMPO.
           MOVE CEC-IMPO TO RIMP0.
           IF IF-LIREUR = 1
              MOVE CEC-IMPO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP0.
           MOVE CEP-IMPO TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CEP-IMPO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 1 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      **** rel 6.2
           MOVE 1 TO SWDES.
       I15.
           IF IF-FLMLI = 1 AND IF-TPSTA > ZERO
              PERFORM STAMPA-MLI THRU EX-STAMPA-MLI.
      ************
           GO TO I10.
       I20.
           MOVE KCE-AZI  TO KEP-AZI.
           MOVE KCE-DATI TO KEP-DATI.
           MOVE ZERO TO KEP-CONTO.
           START BILCEP KEY NOT < KEYEP INVALID GO TO I90.
       I30.
           READ BILCEP NEXT AT END GO TO I90.
           IF KEP-AZI  NOT = KCE-AZI  GO TO I90.
           IF KEP-DATI NOT = KCE-DATI GO TO I90.
           MOVE KEYEP TO KEYEC.
           READ BILCEC INVALID MOVE ZERO TO CEC-IMPO GO TO I40.
           GO TO I30.
       I40.
           IF CEP-IMPO = ZERO GO TO I30.
           IF SWSTA = ZERO MOVE 1 TO SWSTA
                           MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE KEP-CONTO TO KPC-COD.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DESCR.
           MOVE CON-DESCR TO RDECO.
           IF KCE-TIPO = 3 OR 4 OR
                        ( KCE-TIPO = 5 AND KCE-TRAI NOT = 23 )
                        MULTIPLY -1 BY CEC-IMPO CEP-IMPO.
           MOVE CEC-IMPO TO RIMP0.
           IF IF-LIREUR = 1
              MOVE CEC-IMPO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP0.
           MOVE CEP-IMPO TO RIMP3.
           IF IF-LIREUR = 1
              MOVE CEP-IMPO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           GO TO I30.
       I90.
           IF SWSTA = ZERO GO TO I99.
           IF IF-TPBIL NOT = ZERO AND TIPO NOT = 5 GO TO I99.
           IF NRIG NOT < NRGL SUBTRACT 1 FROM NRIG.
           MOVE ALL '-' TO RSOT0 RSOT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
       I99.
           EXIT.
      *----------------*
       TEST-ERRORI.
           IF SWERR > ZERO
              MOVE 5 TO ERRIO-ST.
       EX-TEST-ERRORI.
           EXIT.
      *----------------*
       STA-ERRORI.
           PERFORM RPT-INI.
           MOVE AZRGSOC TO TAZI.
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 0       TO NINT.
      *--------------------------------------------------*
      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'LISTA ANOMALIE '
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *---------------------------------------------*
           OPEN INPUT ERRORI.
           MOVE ZERO TO XCRR NRIG NPAG.
           MOVE ' LISTA ANOMALIE ' TO P999B.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1B' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 2 TO XCRR.
       STERR.
           READ ERRORI AT END GO TO CHISTA.
           MOVE RF-ERR TO P999B.
           MOVE 'RIG1B' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           GO TO STERR.
       CHISTA.
           PERFORM RPT-CL.
           CLOSE ERRORI.
       EX-STA-ERRORI.
           EXIT.
      *----------------*
       ARROT-PASS.
           IF IF-IMPCEN NOT = ZERO GO TO EX-ARROT-PASS.

           MOVE TOTCEN13 TO RD-NUM.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           MOVE RD-NUM   TO TOTCEN13.

           MOVE TOTCEN13P TO RD-NUM.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           MOVE RD-NUM    TO TOTCEN13P.

           IF TOTCEN13  = TOTUNI13 AND
              TOTCEN13P = TOTUNI13P GO TO EX-ARROT-PASS.

           COMPUTE COMODOC = TOTUNI13 - TOTCEN13.
           ADD COMODOC TO TOTVOC TOTGRC TOTTIC.

           COMPUTE COMODOP = TOTUNI13P - TOTCEN13P.
           ADD COMODOP TO TOTVOP TOTGRP TOTTIP.

           IF IF-TPBIL NOT = ZERO GO TO EX-ARROT-PASS.
           MOVE '*' TO RDETT.
           MOVE ')' TO RDETTP.
           MOVE 'ARROTONDAMENTI UNITA'' DI EURO' TO RDESC.
           MOVE COMODOC TO ERIMP1.
           MOVE COMODOP TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM H00-STA-RIG THRU H99.
           MOVE 1 TO SWDET.
       EX-ARROT-PASS.
           EXIT.
      *----------------*
       ARROT-CONTORDA.
           IF IF-IMPCEN NOT = ZERO GO TO EX-ARROT-CONTORDA.

           MOVE TOTCEN2  TO RD-NUM.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           MOVE RD-NUM   TO TOTCEN2.

           MOVE TOTCEN2P  TO RD-NUM.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           MOVE RD-NUM    TO TOTCEN2P.

           IF TOTCEN2  = TOTUNI2 AND
              TOTCEN2P = TOTUNI2P GO TO EX-ARROT-CONTORDA.

           COMPUTE COMODOC = TOTCEN2 - TOTUNI2.
           ADD COMODOC TO TOTVOC TOTGRC TOTTIC.

           COMPUTE COMODOP = TOTCEN2P - TOTUNI2P.
           ADD COMODOP TO TOTVOP TOTGRP TOTTIP.

           IF IF-TPBIL NOT = ZERO GO TO EX-ARROT-CONTORDA.

           MOVE '*' TO RDETT.
           MOVE ')' TO RDETTP.
           MOVE 'ARROTONDAMENTI UNITA'' DI EURO' TO RDESC.
           MOVE COMODOC TO ERIMP2.
           MOVE COMODOP TO ERIMP4.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM H00-STA-RIG THRU H99.
       EX-ARROT-CONTORDA.
           EXIT.
      *----------------*
       ARROT-CONTORDP.
           IF IF-IMPCEN NOT = ZERO GO TO EX-ARROT-CONTORDP.

           MOVE TOTCEN4 TO RD-NUM.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           MOVE RD-NUM   TO TOTCEN4.

           MOVE TOTCEN4P TO RD-NUM.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           MOVE RD-NUM    TO TOTCEN4P.

           IF TOTCEN4  = TOTUNI4 AND
              TOTCEN4P = TOTUNI4P GO TO EX-ARROT-CONTORDP.

           COMPUTE COMODOC = TOTCEN4 - TOTUNI4.
           ADD COMODOC TO TOTVOC TOTGRC TOTTIC.

           COMPUTE COMODOP = TOTCEN4P - TOTUNI4P.
           ADD COMODOP TO TOTVOP TOTGRP TOTTIP.

           IF IF-TPBIL NOT = ZERO GO TO EX-ARROT-CONTORDP.

           MOVE '*' TO RDETT.
           MOVE ')' TO RDETTP.
           MOVE 'ARROTONDAMENTI UNITA'' DI EURO' TO RDESC.
           MOVE COMODOC TO ERIMP2.
           MOVE COMODOP TO ERIMP4.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM H00-STA-RIG THRU H99.
       EX-ARROT-CONTORDP.
           EXIT.
      *----------------*
       ARROT-ECONOM.
           IF IF-IMPCEN NOT = ZERO GO TO EX-ARROT-ECONOM.

           MOVE TOTCEN5 TO RD-NUM.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           MOVE RD-NUM   TO TOTCEN5.

           MOVE TOTCEN5P TO RD-NUM.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           MOVE RD-NUM   TO TOTCEN5P.

           IF TOTCEN5  = TOTUNI5  AND
              TOTCEN5P = TOTUNI5P GO TO EX-ARROT-ECONOM.

           COMPUTE COMODOC = TOTCEN5 - TOTUNI5.
           ADD COMODOC TO TOTVOC TOTGRC TOTTIC.

           COMPUTE COMODOP = TOTCEN5P - TOTUNI5P.
           ADD COMODOP TO TOTVOP TOTGRP TOTTIP.

           MOVE ' *' TO RTRAIX.
           MOVE ')'  TO RTRAIP.
           MOVE 'ARROTONDAMENTI UNITA'' DI EURO' TO RDESC.
           MOVE COMODOC TO ERIMP1.
           MOVE COMODOP TO ERIMP3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM H00-STA-RIG THRU H99.
       EX-ARROT-ECONOM.
           EXIT.
      *----------------*
       STA-VALPRO.
           MOVE ALL '=' TO R3SOT1 R3SOT3.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM H00-STA-RIG THRU H99.
           MOVE 'TOTALE VALORE PRODUZIONE' TO R3DESZ.
           IF IF-IMPCEN = ZERO
              MOVE TOTVOC TO ER3IMP2
           ELSE
              MOVE TOTVOC TO R3IMP2.
           IF IF-LIREUR = 1
              MOVE TOTVOC TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3IMP2.
           IF IF-IMPCEN = ZERO
              MOVE TOTVOP TO ER3IMP4
           ELSE
              MOVE TOTVOP TO R3IMP4.
           IF IF-LIREUR = 1
              MOVE TOTVOP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER3IMP4.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM H00-STA-RIG THRU H99.
           MOVE 2 TO XCRR.
           MOVE ZERO TO TOTVOC TOTVOP.
       EX-STA-VALPRO.
           EXIT.
      *----------------*
      *> verifica se il conto e' un riepilogativo
       VERIFICA-CONTO.
           MOVE ZERO TO FLGOK.

           IF (KPC-COD = CRPCL)     OR
              (KPC-COD = CRPC1)     OR
              (KPC-COD = CRPC2)     OR
              (KPC-COD = T14-CRPC3) OR
              (KPC-COD = T14-CRPC4) OR
              (KPC-COD = T14-CRPC5) OR
              (KPC-COD = T14-CRPC6) OR
              (KPC-COD = T14-CRPC7) OR
              (KPC-COD = T14-CRPC8) OR
              (KPC-COD = CRPFR)     OR
              (KPC-COD = CRPF1)     OR
              (KPC-COD = CRPF2)     OR
              (KPC-COD = T14-CRPF3) OR
              (KPC-COD = T14-CRPF4) OR
              (KPC-COD = T14-CRPF5) OR
              (KPC-COD = T14-CRPF6) OR
              (KPC-COD = T14-CRPF7) OR
              (KPC-COD = T14-CRPF8) GO TO V010.

           IF (KPC-COD = T14RIC1) OR
              (KPC-COD = T14RIC2) OR
              (KPC-COD = T14RIC3) OR
              (KPC-COD = T14RIC4) OR
              (KPC-COD = T14RIC5) OR
              (KPC-COD = T14RIC6) OR
              (KPC-COD = T14RIC7) OR
              (KPC-COD = T14RIC8) OR
              (KPC-COD = T14RIC9) GO TO V010.

           GO TO EX-VERIFICA-CONTO.
       V010.
           MOVE 1 TO FLGOK.
       EX-VERIFICA-CONTO.
           EXIT.
      *----------------*
       RPT-RIG2-INTC.
           MOVE 'RIG2' TO RP-BLK.
      *
           MOVE DSTIPX (KCE-TIPO) TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE '------ ESERCIZIO CORRENTE ------' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE '----- ESERCIZIO PRECEDENTE -----' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
      **** rel 6.2
       STAMPA-MLI.
           MOVE ZERO TO SAVCONTO IMPMLI.
           MOVE LOW-VALUE TO KEYMLI.
           MOVE KAZ-COD   TO KMLI-AZI.
           MOVE KEC-CONTO TO KMLI-CONTO.
           MOVE ZERO      TO KMLI-PRG.
           START MOVLIB KEY NOT < SKEYMLI1 INVALID GO TO END-MLI.
       RDNX-MLI.
           READ MOVLIB NEXT AT END GO TO END-MLI.
           IF SF-MLI = '9D' OR '9A' OR '35' GO TO RDNX-MLI.
           IF KMLI-AZI   > KAZ-COD   GO TO END-MLI.
           IF KMLI-CONTO > KEC-CONTO GO TO END-MLI.
           IF MLI-DARE = ZERO AND  MLI-AVERE = ZERO GO TO RDNX-MLI.
           IF MLI-DATA > PKDAT GO TO RDNX-MLI.
           IF SWSTA = ZERO MOVE 1 TO SWSTA
                           MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-WR.
      *
           IF SWDES = 1 GO TO NO-DES.
      *
           MOVE KAZ-COD TO KPC-AZI.
           MOVE KEC-CONTO TO KPC-COD.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO  CON-DESCR.
           MOVE CON-DESCR TO RDECO.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
      *
           MOVE 1 TO SWDES.
       NO-DES.
      *

      *> stampa sintetica
           IF IF-TPMLI = ZERO AND KMLI-CONTO NOT = SAVCONTO
              PERFORM STM-MLI THRU EX-STM-MLI
              MOVE ZERO TO IMPMLI
              GO TO SOMMA.

      *> stampa analitica
           IF IF-TPMLI = 1
              IF MLI-DARE NOT = ZERO MOVE MLI-DARE TO IMPMLI
              ELSE MOVE MLI-AVERE  TO IMPMLI
                   MULTIPLY -1 BY IMPMLI
              END-IF
              MOVE KMLI-CONTO TO SAVCONTO
              PERFORM STM-MLI THRU EX-STM-MLI.
       SOMMA.
           IF IF-TPMLI = ZERO
              IF MLI-DARE NOT = ZERO ADD MLI-DARE TO IMPMLI
              ELSE SUBTRACT MLI-AVERE FROM IMPMLI.

           GO TO RDNX-MLI.
       END-MLI.
           IF IF-TPMLI = ZERO PERFORM STM-MLI THRU EX-STM-MLI.
       EX-STAMPA-MLI.
           EXIT.
      *--------------*
       STM-MLI.
           IF SAVCONTO = ZERO GO TO S90.
           IF IMPMLI = ZERO   GO TO EX-STM-MLI.

           IF IF-TPMLI = ZERO MOVE '(Extra-Contabile)' TO RDECO
           ELSE MOVE MLI-DESCR TO RDECO.

           IF KCE-TIPO = 3 OR 4 OR
                        ( KCE-TIPO = 5 AND KCE-TRAI NOT = 26 )
                        MULTIPLY -1 BY IMPMLI.

      *> importo mov. extra-contabile
           MOVE IMPMLI TO RIMP0.
           IF IF-LIREUR = 1
              MOVE IMPMLI TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP0.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
       S90.
           MOVE KMLI-CONTO TO SAVCONTO.
       EX-STM-MLI.
           EXIT.
      *--------------*
       CALCOLA-MLI.
           MOVE LOW-VALUE TO KEYMLI.
           MOVE KPC-AZI   TO KMLI-AZI.
           MOVE KPC-COD   TO KMLI-CONTO.
           MOVE ZERO      TO KMLI-PRG.
           START MOVLIB KEY NOT < SKEYMLI1 INVALID GO TO EX-CALCOLA-MLI.
       RD-MLI.
           READ MOVLIB NEXT AT END GO TO EX-CALCOLA-MLI.
           IF SF-MLI = '9D' OR '9A' OR '35' GO TO RD-MLI.
           IF KMLI-AZI   > KPC-AZI GO TO EX-CALCOLA-MLI.
           IF KMLI-CONTO > KPC-COD GO TO EX-CALCOLA-MLI.
           IF MLI-DARE = ZERO AND  MLI-AVERE = ZERO GO TO RD-MLI.
           IF MLI-DATA > PKDAT GO TO RD-MLI.

           ADD MLI-DARE  TO IMLIDARE.
           ADD MLI-AVERE TO IMLIAVER.

           GO TO RD-MLI.
       EX-CALCOLA-MLI.
           EXIT.
      *--------------*
      ************
