       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON165.
      *
      * Stampa parametrica del bilancio alla data
      *        con raffronti alla data e totalizz.mensili
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'grimovsl'.
           COPY 'grimvxsl'.
      **** rel 6.2
           COPY 'gricolsl'.
      ************
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           COPY 'gritabsl'.
      **** rel 6.3
           COPY 'grimlisl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'grimov'.
           COPY 'grimvx'.
      **** rel 6.2
           COPY 'gricol'.
      ************
       FD  WDSLAV LABEL RECORD STANDARD 
           VALUE OF FILE-ID ID-LAV
           RECORD 91 DATA RECORD RF-LAV.
      *    FILE DI SORT - RCDLG=91 START=0 KEYLG=12
       01  RF-LAV.
           02 KEYLV.
              05 KLV-B1 PIC 9.
              05 KLV-B2 PIC 99.
              05 KLV-B3 PIC 99.
              05 KLV-CD PIC 9(7).
           02 LAV-TIPO  PIC X.
           02 LAV-DESCR PIC X(36).
           02 LAV-SALDO PIC S9(11)V99 COMP-3 OCCURS 6.
           COPY 'gritab'.
      **** rel 6.3
           COPY 'grimli'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griconrk'.
           COPY 'gritabrk'.
           COPY 'grimovrk'. 
      **** rel 6.2
       01  REKCO2.
           05 CO2-KEYID.
              10 CO2-AZI  PIC 999   VALUE ZERO.
              10 CO2-COD  PIC 9(7)  VALUE ZERO.
           05 CO2-DESCR   PIC X(36) VALUE SPACE.
           05 CO2-DSABB   PIC X(20) VALUE SPACE.
           05 CO2-TIPO    PIC X     VALUE SPACE.
           05 CO2-SALDI.
              10 CO2-SP-D PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SP-A PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SPSP PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SE-D PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SE-A PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SESP PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 CO2-SALDR REDEFINES CO2-SALDI.
              10 CO2-SXYY PIC S9(11)V99 COMP-3 OCCURS 6.
           05 CO2-BIL1  PIC 9  VALUE ZERO.
           05 CO2-BIL2  PIC 99 VALUE ZERO.
           05 CO2-BIL3  PIC 99 VALUE ZERO.
           05 CO2-BIL4  PIC 9  VALUE ZERO.
           05 CO2-FLRIE PIC 9  VALUE ZERO.
           05 CO2-MOVIM PIC 9  VALUE ZERO.
           05 CO2-FLAUT PIC 9  VALUE ZERO.
           05 CO2-TPCOP PIC 9  VALUE ZERO.
           05 CO2-TPCON PIC 9  VALUE ZERO.
           05 CO2-PRO1  PIC 99 VALUE ZERO.
           05 CO2-PRO2  PIC 99 VALUE ZERO.
           05 CO2-BIL5  PIC 9  VALUE ZERO.
           05 CO2-CVAL  PIC 9  VALUE ZERO.
           05 FILLER    PIC X(4) VALUE ZERO.
      ************
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parer'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MVX PIC X(15) VALUE 'movmxx'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
      **** rel 6.2
       01  ID-COL PIC X(15) VALUE 'anacol'.
      ************
      **** rel 6.3
       01  ID-MLI PIC X(15) VALUE 'movlib'.
      ************
       01  COMODI.
           05 SF-AZI    PIC XX.
           05 SF-TAB    PIC XX.
           05 SF-CON    PIC XX.
           05 SF-LAV    PIC XX.
           05 SF-MOV    PIC XX.
           05 SF-MVX    PIC XX.
      **** rel 6.2
           05 SF-COL   PIC XX.
      ************
      **** rel 6.3
           05 SF-MLI   PIC XX.
      ************
           05 MESS      PIC X(40) VALUE SPACE.
           05 SWINI     PIC 9     VALUE ZERO.
           05 FUN-PREC  PIC X     VALUE ZERO.
           05 VFLD      PIC 9.
           05 FUN       PIC X.
           05 CAMPO     PIC X(20).
           05 VCAMPO    PIC X(20).
           05 TOTG      PIC S9(13)V99 OCCURS 7.
           05 TOTP      PIC S9(13)V99 OCCURS 7.
           05 TOTR      PIC S9(13)V99 OCCURS 7.
           05 TOTRIGA   PIC S9(13)V99.
           05 COM-SALDO PIC S9(13)V99 OCCURS 6.
      **** rel 6.3
           05 CML-SALDO PIC S9(13)V99 OCCURS 6.
           05 TTCON     PIC S9(13)V99 OCCURS 7.
           05 COMLIB    PIC 9 VALUE ZERO.
           05 COMCD     PIC 9(7) VALUE ZERO.
           05 I         PIC 9.
           05 DESCCD    PIC X(30) VALUE ZERO.
           05 TEAVE     PIC S9(13)V99 VALUE ZERO.
           05 TEDAR     PIC S9(13)V99 VALUE ZERO.
           05 SALDO     PIC S9(11)V99 VALUE ZERO.
      ************
           05 BIL1      PIC 9.
           05 BIL2      PIC 99.
           05 DESB1     PIC X(24).
           05 DESB2     PIC X(24).
           05 K         PIC 9.
           05 ANNO      PIC 9(4).
           05 SEME      PIC 9.
           05 MESE      PIC 99.
      **** rel 6.3
           05 ANNOR     PIC 9999 VALUE ZERO.
      ************
           05 INTES1.
              10 FILLER PIC X     VALUE '2'.
              10 FILLER PIC X(9) VALUE 'CODICE'.
              10 FILLER PIC X(20) VALUE 'DESCRIZIONE'.
              10 FILLER PIC X(17) VALUE '          GENNAIO'.
              10 FILLER PIC X(17) VALUE '         FEBBRAIO'.
              10 FILLER PIC X(17) VALUE '            MARZO'.
              10 FILLER PIC X(17) VALUE '           APRILE'.
              10 FILLER PIC X(17) VALUE '           MAGGIO'.
              10 FILLER PIC X(17) VALUE '           GIUGNO'.
              10 FILLER PIC X     VALUE SPACE.
           05 INTES2.
              10 FILLER PIC X     VALUE '2'.
              10 FILLER PIC X(9) VALUE 'CODICE'.
              10 FILLER PIC X(20) VALUE 'DESCRIZIONE'.
              10 FILLER PIC X(17) VALUE '           LUGLIO'.
              10 FILLER PIC X(17) VALUE '           AGOSTO'.
              10 FILLER PIC X(17) VALUE '        SETTEMBRE'.
              10 FILLER PIC X(17) VALUE '          OTTOBRE'.
              10 FILLER PIC X(17) VALUE '         NOVEMBRE'.
              10 FILLER PIC X(17) VALUE '         DICEMBRE'.
              10 FILLER PIC X     VALUE SPACE.

           COPY 'vcon165.cpy'.
       LINKAGE SECTION.
      *
      * Record di interfaccia
      *

      *
      *******************************************
      *  IF-CTRL = parametri di controllo del
      *                callout VCON165
      *******************************************
      *
       01 IF-CTRL.
          05 IF-AZI        PIC 9(3).
          05 IF-FUN        PIC X.
          05 IF-CAMPO      PIC X(20).
          05 IF-ST         PIC 9.
          05 IF-FL         PIC 9.
          COPY 'grirpt-l'.
      *
      *******************************************
      *  IF-REC : Parametri di Stampa
      *******************************************
      *
       01 IF-REC.
          05 IF-AZI-D         PIC X(36).
          05 IF-GRU-1         PIC 9.
          05 IF-GRU-2         PIC 9.
          05 IF-DTRIF         PIC 9(6).
          05 IF-DTSTA         PIC 9(6).
          05 IF-TPSTA         PIC 9.
          05 IF-LIREUR        PIC 9.
      **** rel 6.0a
           05 IF-COMODO    PIC 999.
      *************
      **** rel 6.2
          05 IF-FLRIP     PIC 9.
      ************
      **** rel 6.3
           05 IF-FLEXT     PIC 9.
      ************
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclmov'.
           COPY 'dclmvx'.
           COPY 'dcllav'.
           COPY 'dcltab'.
      **** rel 6.2
           COPY 'dclcol'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon165: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE ANACON.
           CLOSE MOVIME.
           CLOSE MOVMXX.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
      **** rel 6.3
           CLOSE MOVLIB.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
      **** rel 6.2
           IF IF-FL = ZERO CLOSE ANACOL.
      ************
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'grimover'.
           COPY 'grimvxer'.
           COPY 'gritaber'.
      **** rel 6.3
           COPY 'grimlier'.
      ************
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'anacon' TO ID-CON
                           MOVE 'movime' TO ID-MOV
      **** rel 6.3
                           MOVE 'movlib' TO ID-MLI
      ************
                           MOVE 'movmxx' TO ID-MVX.
           IF IF-FL = 1    MOVE 'anazol' TO ID-AZI
                           MOVE 'tabold' TO ID-TAB
                           MOVE 'anacol' TO ID-CON
                           MOVE 'movmol' TO ID-MOV
      **** rel 6.3
                           MOVE 'movlix' TO ID-MLI
      ************
                           MOVE 'movoxx' TO ID-MVX.
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT ANACON.
           OPEN INPUT MOVIME.
           OPEN INPUT MOVMXX.
      **** rel 6.3
           OPEN INPUT MOVLIB.
      ************
      **** rel 6.2
           IF IF-FL = ZERO OPEN INPUT ANACOL.
      ************
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           PERFORM RPT-INI.
      * 
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DTRIF
                          IF-DTSTA.

           MOVE AZRGSOC TO IF-AZI-D.

           MOVE ZERO TO IF-GRU-1
      **** rel 6.3
      *                 IF-GRU-2
      ************
                        IF-LIREUR
                        IF-TPSTA.
      **** rel 6.0a
           MOVE ZERO TO IF-COMODO.
      *************
      **** rel 6.2
           MOVE ZERO    TO IF-FLRIP.
      ************
      **** rel 6.3
           MOVE 9 TO IF-GRU-2.
           MOVE ZERO TO IF-FLEXT.
           IF IF-FL = 2 MOVE ZERO TO IF-FLEXT.
      ************
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      **** rel 6.0a
       V-TB1.
           MOVE 'IF-TB1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TB1.
           IF FUN = 'V'
              MOVE IF-COMODO(1:1) TO IF-GRU-1.
       E-TB1.
      *
       V-TB2.
           MOVE 'IF-TB2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TB2.
           IF FUN = 'V'
              MOVE IF-COMODO(1:1) TO IF-GRU-2.
       E-TB2.
      *************
      *
      **** rel 6.3
      *V-GRU-1.
      *    MOVE 'IF-GRU-1' TO VCAMPO.
      *    IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-GRU-1.
      *    IF IF-GRU-1 < 1 
      *       PERFORM ERR-DINC
      *       GO TO V-ERROR.
      ************
       E-GRU-1.
      *
       V-GRU-2.
           MOVE 'IF-GRU-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-GRU-2.
           IF IF-GRU-2 < IF-GRU-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-GRU-2.
      *
       V-DTRIF.
           MOVE 'IF-DTRIF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTRIF.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTRIF TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG < AZI-DTAPE
              MOVE "Data inferiore alla data apertura" TO MESS
              GO TO V-ERROR.
       E-DTRIF.
      *
       V-DTSTA.
           MOVE 'IF-DTSTA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTSTA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTSTA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG < AZI-DTAPE
              MOVE "Data inferiore alla data apertura" TO MESS
              GO TO V-ERROR.
       E-DTSTA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
      *    COPY 'grirpt-sn' REPLACING 1 BY 2
      *                     RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           MOVE ZERO TO IEUR.
           IF IF-LIREUR = 1
              MOVE 'E' TO IEUR.
           
           MOVE AZRGSOC TO TAZI.

           MOVE 1 TO TIPOP1.
           MOVE IF-DTSTA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO ANNO.
           MOVE GBMMBA TO TDAT.

           MOVE 1 TO TIPOP1.
           MOVE IF-DTRIF TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE MM9 TO MESE.
      **** rel 6.3
           MOVE AA4 TO ANNOR.
      ************
           IF MESE > 6 COMPUTE MESE = MESE - 6
                       MOVE 2 TO SEME
           ELSE MOVE 1 TO SEME.


      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           IF SEME = 1 MOVE INTES1 TO C-TINT1 
                  ELSE MOVE INTES2 TO C-TINT1.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'BILANCIO IN DATA ' TDAT 
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           IF SEME = 1   PERFORM RPT-RIG2A-INTC
                  ELSE   PERFORM RPT-RIG2B-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO L110.
       L100.
           READ WDSLAV NEXT AT END GO TO L110.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO L100.
           DELETE WDSLAV.
           GO TO L100.
       L110.
           MOVE LOW-VALUE TO KEYPC.
           MOVE KAZ-COD TO KPC-AZI.
           START ANACON KEY NOT < KEYPC INVALID GO TO L200.
       L120.
           READ ANACON NEXT INTO REKCON AT END GO TO L200. 
           IF SF-CON = '9D' OR '9A' OR '35' GO TO L120.
           IF KPC-AZI > KAZ-COD GO TO L200.
           IF CON-BIL1 = ZERO GO TO L120.
           IF CON-BIL1 < IF-GRU-1 GO TO L120.
           IF CON-BIL1 > IF-GRU-2 GO TO L120.
      **** rel 6.2
           IF IF-FL NOT = ZERO OR CON-TIPO  = 'E' OR IF-FLRIP = ZERO
                             MOVE ZERO TO CO2-SESP GO TO L125.
           MOVE KAZ-COD TO KCL-AZI.
           MOVE KPC-COD TO KCL-COD.
           READ  ANACOL INTO REKCO2 INVALID MOVE ZERO TO CO2-SESP
                                                    GO TO L125.
           IF SF-COL = '9D' OR '9A' OR '35' MOVE RF-COL TO REKCO2.
           COMPUTE CO2-SESP = CO2-SESP + CO2-SE-D - CO2-SE-A.
       L125.
      ************
           MOVE ZERO TO K.
       L130.
           ADD 1 TO K.
           IF K > 6 GO TO L140.
           MOVE ZERO TO LAV-SALDO (K).
           GO TO L130.
       L140.
           PERFORM C00-LEGGE-CONTO THRU C99.
      **** rel 6.2
           ADD CO2-SESP TO LAV-SALDO (1).
      ************
           IF CON-BIL4 = ZERO
                              AND LAV-SALDO (1) = ZERO 
                              AND LAV-SALDO (2) = ZERO 
                              AND LAV-SALDO (3) = ZERO 
                              AND LAV-SALDO (4) = ZERO 
                              AND LAV-SALDO (5) = ZERO 
                              AND LAV-SALDO (6) = ZERO 
      **** rel 6.3
                              AND COMLIB = ZERO
      ************
                                                       GO TO L120.
           MOVE CON-BIL1 TO K.
           IF (( CON-BIL1 = 1 OR 2 ) AND LAV-SALDO (K) NOT < ZERO ) OR
              (( CON-BIL1 = 3 OR 4 ) AND LAV-SALDO (K) NOT > ZERO )
              GO TO L150.
           IF CON-BIL5 = ZERO GO TO L150.
           MOVE CON-BIL5 TO KLV-B1.
           MOVE CON-BIL3 TO KLV-B2.
           GO TO L160.
       L150.
           MOVE CON-BIL1 TO KLV-B1.
           MOVE CON-BIL2 TO KLV-B2.
       L160.
           MOVE ZERO TO KLV-B3.
           MOVE KPC-COD  TO KLV-CD.
      **** rel 6.3
      *    MOVE CON-DSABB TO LAV-DESCR.
           MOVE CON-DSABB TO LAV-DESCR.
           IF CON-DSABB = SPACE
              MOVE CON-DESCR TO LAV-DESCR.
      ************
           MOVE CON-TIPO TO LAV-TIPO.
           WRITE RF-LAV INVALID KEY MOVE 'WR LAV' TO MESS GO TO ERRIO.
      *
      *    COPY 'grirpt-r' REPLACING 1 BY 2
      *                    RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           GO TO L120.
       L200.
           MOVE ZERO TO K.
       L205.
           ADD 1 TO K.
           IF K > 6 GO TO L207.
           MOVE ZERO TO TOTP (K) TOTG (K) TOTR (K) COM-SALDO (K).
           GO TO L205.
       L207.
           MOVE ZERO TO BIL1 BIL2 XCRR.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO L290.
       L210.
           READ WDSLAV NEXT AT END GO TO L290. 
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO L210.
      **** rel 6.3
           IF KLV-CD NOT = COMCD PERFORM D00-TTCON THRU D99.
      ************
           IF KLV-B1 NOT = BIL1 PERFORM A00-BIL1 THRU A99.
           IF KLV-B2 NOT = BIL2 PERFORM B00-BIL2 THRU B99.
           MOVE KLV-CD TO PCOD.
           MOVE LAV-DESCR TO PDES.
           COMPUTE COM-SALDO (1) = COM-SALDO (1) + LAV-SALDO (1).
           MOVE COM-SALDO (1) TO PSAL1.
           IF IF-LIREUR = 1
              MOVE COM-SALDO(1) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL1.
           IF MESE < 2 GO TO L212.
           COMPUTE COM-SALDO (2) = COM-SALDO (1) + LAV-SALDO (2).
           MOVE COM-SALDO (2) TO PSAL2.
           IF IF-LIREUR = 1
              MOVE COM-SALDO(2) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL2.
           IF MESE < 3 GO TO L212.
           COMPUTE COM-SALDO (3) = COM-SALDO (2) + LAV-SALDO (3).
           MOVE COM-SALDO (3) TO PSAL3.
           IF IF-LIREUR = 1
              MOVE COM-SALDO(3) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL3.
           IF MESE < 4 GO TO L212.
           COMPUTE COM-SALDO (4) = COM-SALDO (3) + LAV-SALDO (4).
           MOVE COM-SALDO (4) TO PSAL4.
           IF IF-LIREUR = 1
              MOVE COM-SALDO(4) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL4.
           IF MESE < 5 GO TO L212.
           COMPUTE COM-SALDO (5) = COM-SALDO (4) + LAV-SALDO (5).
           MOVE COM-SALDO (5) TO PSAL5.
           IF IF-LIREUR = 1
              MOVE COM-SALDO(5) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL5.
           IF MESE < 6 GO TO L212.
           COMPUTE COM-SALDO (6) = COM-SALDO (5) + LAV-SALDO (6).
           MOVE COM-SALDO (6) TO PSAL6.
           IF IF-LIREUR = 1
              MOVE COM-SALDO(6) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL6.
       L212.
           IF IF-TPSTA = 2 MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-AZZ
                           GO TO L219.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
      **** rel 6.3
      *    MOVE 1 TO XCRR.
           IF IF-FLEXT = ZERO MOVE 1 TO XCRR. 
      ************
       L219.
      **** rel 6.3
      *    ADD COM-SALDO (1) TO TOTP (1) TOTG (1). 
      *    ADD COM-SALDO (2) TO TOTP (2) TOTG (2).
      *    ADD COM-SALDO (3) TO TOTP (3) TOTG (3).
      *    ADD COM-SALDO (4) TO TOTP (4) TOTG (4).
      *    ADD COM-SALDO (5) TO TOTP (5) TOTG (5).
      *    ADD COM-SALDO (6) TO TOTP (6) TOTG (6).
           IF IF-FLEXT = 1 
              PERFORM STAMPA-MLI THRU EX-STAMPA-MLI
              IF IF-TPSTA NOT = 2 MOVE 1 TO XCRR.
      *
           ADD COM-SALDO (1) TO TOTP (1) TOTG (1) TTCON (1).
           ADD COM-SALDO (2) TO TOTP (2) TOTG (2) TTCON (2).
           ADD COM-SALDO (3) TO TOTP (3) TOTG (3) TTCON (3).
           ADD COM-SALDO (4) TO TOTP (4) TOTG (4) TTCON (4).
           ADD COM-SALDO (5) TO TOTP (5) TOTG (5) TTCON (5).
           ADD COM-SALDO (6) TO TOTP (6) TOTG (6) TTCON (6).
      *
           IF IF-FLEXT = 1
              ADD CML-SALDO (1) TO TOTP (1) TOTG (1) TTCON (1)
              ADD CML-SALDO (2) TO TOTP (2) TOTG (2) TTCON (2)
              ADD CML-SALDO (3) TO TOTP (3) TOTG (3) TTCON (3)
              ADD CML-SALDO (4) TO TOTP (4) TOTG (4) TTCON (4)
              ADD CML-SALDO (5) TO TOTP (5) TOTG (5) TTCON (5)
              ADD CML-SALDO (6) TO TOTP (6) TOTG (6) TTCON (6).
      ************
           IF LAV-TIPO NOT = 'E' GO TO L220.
           ADD COM-SALDO (1) TO TOTR (1).
           ADD COM-SALDO (2) TO TOTR (2).
           ADD COM-SALDO (3) TO TOTR (3).
           ADD COM-SALDO (4) TO TOTR (4).
           ADD COM-SALDO (5) TO TOTR (5).
           ADD COM-SALDO (6) TO TOTR (6).
      **** rel 6.3
           IF IF-FLEXT = 1
              ADD CML-SALDO (1) TO TOTR (1)
              ADD CML-SALDO (2) TO TOTR (2)
              ADD CML-SALDO (3) TO TOTR (3)
              ADD CML-SALDO (4) TO TOTR (4)
              ADD CML-SALDO (5) TO TOTR (5)
              ADD CML-SALDO (6) TO TOTR (6).
      ************
       L220.
           DELETE WDSLAV.
           MOVE ZERO TO K.
       L225.
           ADD 1 TO K.
      *
      *    COPY 'grirpt-r'.
      *
           MOVE KLV-CD  TO COMCD.
      *
           IF K > 6 GO TO L210.
           MOVE ZERO TO COM-SALDO (K) GO TO L225.
       L290.
      **** rel 6.3
           PERFORM D00-TTCON THRU D99.
      ************
           PERFORM A00-BIL1 THRU A50.
           IF IF-GRU-1  NOT = 1 GO TO L300.
           IF IF-GRU-2  NOT = 9 GO TO L300.
           MOVE ALL '=' TO PSOTT1.
           MOVE ALL '=' TO PSOTT2.
           MOVE ALL '=' TO PSOTT3.
           MOVE ALL '=' TO PSOTT4.
           MOVE ALL '=' TO PSOTT5.
           MOVE ALL '=' TO PSOTT6.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.

      * riga vuota per visuale
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'UTILE(+)/PERDITE(-) ESERCIZIO' TO PDESTAR.
           MULTIPLY -1 BY TOTR (1).
           MOVE TOTR (1) TO PTG1.
           IF IF-LIREUR = 1
              MOVE TOTR(1) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTG1.
           MULTIPLY -1 BY TOTR (2).
           MOVE TOTR (2) TO PTG2.
           IF IF-LIREUR = 1
              MOVE TOTR(2) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTG2.
           MULTIPLY -1 BY TOTR (3).
           MOVE TOTR (3) TO PTG3.
           IF IF-LIREUR = 1
              MOVE TOTR(3) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTG3.
           MULTIPLY -1 BY TOTR (4).
           MOVE TOTR (4) TO PTG4.
           IF IF-LIREUR = 1
              MOVE TOTR(4) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTG4.
           MULTIPLY -1 BY TOTR (5).
           MOVE TOTR (5) TO PTG5.
           IF IF-LIREUR = 1
              MOVE TOTR(5) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTG5.
           MULTIPLY -1 BY TOTR (6).
           MOVE TOTR (6) TO PTG6.
           IF IF-LIREUR = 1
              MOVE TOTR(6) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTG6.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ALL '=' TO PSOTT1.
           MOVE ALL '=' TO PSOTT2.
           MOVE ALL '=' TO PSOTT3.
           MOVE ALL '=' TO PSOTT4.
           MOVE ALL '=' TO PSOTT5.
           MOVE ALL '=' TO PSOTT6.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
       L300.
           COPY 'grirpt-r'.
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       A00-BIL1.
           PERFORM B00-BIL2 THRU B50.
           IF BIL1 = ZERO GO TO A50.
           MOVE ALL '=' TO PSOTT1.
           MOVE ALL '=' TO PSOTT2.
           MOVE ALL '=' TO PSOTT3.
           MOVE ALL '=' TO PSOTT4.
           MOVE ALL '=' TO PSOTT5.
           MOVE ALL '=' TO PSOTT6.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE SPACE TO PDESTAR.
           STRING 'TOTALE ' DESB1
                  DELIMITED SIZE INTO PDESTAR.
           MOVE TOTG (1) TO PTG1.
           IF IF-LIREUR = 1
              MOVE TOTG(1) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTG1.
           MOVE TOTG (2) TO PTG2.
           IF IF-LIREUR = 1
              MOVE TOTG(2) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTG2.
           MOVE TOTG (3) TO PTG3.
           IF IF-LIREUR = 1
              MOVE TOTG(3) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTG3.
           MOVE TOTG (4) TO PTG4.
           IF IF-LIREUR = 1
              MOVE TOTG(4) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTG4.
           MOVE TOTG (5) TO PTG5.
           IF IF-LIREUR = 1
              MOVE TOTG(5) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTG5.
           MOVE TOTG (6) TO PTG6.
           IF IF-LIREUR = 1
              MOVE TOTG(6) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTG6.
           IF IF-TPSTA = 2 MOVE 1 TO XCRR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
      * riga vuota per visuale
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ALL '=' TO PSOTT1.
           MOVE ALL '=' TO PSOTT2.
           MOVE ALL '=' TO PSOTT3.
           MOVE ALL '=' TO PSOTT4.
           MOVE ALL '=' TO PSOTT5.
           MOVE ALL '=' TO PSOTT6.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
      **** rel 7.1
      *    IF IF-TPSTA = 2 MOVE 2 TO XCRR.
           MOVE 1 TO XCRR.
      ************
       A50. EXIT.
       A60.
           MOVE ZERO TO K.
       A70.
           ADD 1 TO K.
           IF K > 7 GO TO A80.
           MOVE ZERO TO TOTG (K).
           GO TO A70.
       A80.
           MOVE KLV-B1 TO BIL1.
           MOVE ZERO TO BIL2.
           MOVE 16 TO T16-TIP.
           MOVE KLV-B1 TO T16-COD.
           MOVE ZERO TO T16-GRU.
           MOVE T16-KEYID TO KEYTB.
           READ TABELL INTO REKTAB INVALID MOVE ALL '*'
                            TO T16-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T16-DESCR TO PDESTAR DESB1.
      **** rel 7.1
      *    IF XCRR > ZERO MOVE 3 TO XCRR.
           MOVE 1 TO XCRR.
      ************
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
      **** rel 7.1
      *    IF IF-TPSTA = 2 
      * riga vuota per visuale stampa sintetica
      *                    MOVE 1 TO RP-FLGR
      *                    MOVE 'RIG2' TO RP-BLK
      *                    PERFORM RPT-WR.
      *
      *    MOVE 2 TO XCRR.
           MOVE 1 TO XCRR.
      **********
       A99. EXIT.
      *----------------------------------
       B00-BIL2.
           IF BIL2 = ZERO GO TO B50.
           IF IF-TPSTA = 2 GO TO B10.
           MOVE ALL '-' TO PSOTT1.
           MOVE ALL '-' TO PSOTT2.
           MOVE ALL '-' TO PSOTT3.
           MOVE ALL '-' TO PSOTT4.
           MOVE ALL '-' TO PSOTT5.
           MOVE ALL '-' TO PSOTT6.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
       B10.
           MOVE 'TOTALE' TO PXTOT.
           MOVE DESB2 TO PDTOT.
           MOVE TOTP (1) TO PTSAL1.
           IF IF-LIREUR = 1
              MOVE TOTP(1) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSAL1.
           MOVE TOTP (2) TO PTSAL2.
           IF IF-LIREUR = 1
              MOVE TOTP(2) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSAL2.
           MOVE TOTP (3) TO PTSAL3.
           IF IF-LIREUR = 1
              MOVE TOTP(3) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSAL3.
           MOVE TOTP (4) TO PTSAL4.
           IF IF-LIREUR = 1
              MOVE TOTP(4) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSAL4.
           MOVE TOTP (5) TO PTSAL5.
           IF IF-LIREUR = 1
              MOVE TOTP(5) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSAL5.
           MOVE TOTP (6) TO PTSAL6.
           IF IF-LIREUR = 1
              MOVE TOTP(6) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSAL6.
      *
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF IF-TPSTA = 2 GO TO B50.
           MOVE ALL '-' TO PSOTT1.
           MOVE ALL '-' TO PSOTT2.
           MOVE ALL '-' TO PSOTT3.
           MOVE ALL '-' TO PSOTT4.
           MOVE ALL '-' TO PSOTT5.
           MOVE ALL '-' TO PSOTT6.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
       B50. EXIT.
       B60.
           MOVE ZERO TO K.
       B70.
           ADD 1 TO K.
           IF K > 7 GO TO B80.
           MOVE ZERO TO TOTP (K).
           GO TO B70.
       B80.
           MOVE KLV-B2 TO BIL2.
           MOVE 16 TO T16-TIP.
           MOVE KLV-B1 TO T16-COD.
           MOVE KLV-B2 TO T16-GRU.
           MOVE T16-KEYID TO KEYTB.
           READ TABELL INTO REKTAB INVALID MOVE ALL '*'
                           TO T16-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T16-DESCR TO PDES DESB2.
      *
           IF IF-TPSTA = 2 MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-AZZ
                           GO TO B99.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
       B99. EXIT.
      *-----------*
      **** rel 6.3
       D00-TTCON.
           IF COMCD = ZERO GO TO D50.
           MOVE SPACE TO PDES.
      *
           MOVE KAZ-COD TO KPC-AZI.
           MOVE COMCD   TO KPC-COD.
           READ ANACON INTO REKCON INVALID MOVE ALL '*'
                            TO CON-DESCR.
      *
           STRING 'TOTALE ' CON-DESCR
                  DELIMITED SIZE INTO PDES.
      *
           MOVE TTCON(1) TO PSAL1.
           IF IF-LIREUR = 1
              MOVE TTCON(1) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL1.
      *
           MOVE TTCON(2) TO PSAL2.
           IF IF-LIREUR = 1
              MOVE TTCON(2) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL2.
      *
           MOVE TTCON(3) TO PSAL3.
           IF IF-LIREUR = 1
              MOVE TTCON(3) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL3.
      *
           MOVE TTCON(4) TO PSAL4.
           IF IF-LIREUR = 1
              MOVE TTCON(4) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL4.
      *
           MOVE TTCON(5) TO PSAL5.
           IF IF-LIREUR = 1
              MOVE TTCON(5) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL5.
      *
           MOVE TTCON(6) TO PSAL6.
           IF IF-LIREUR = 1
              MOVE TTCON(6) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL6.
      *
           IF IF-TPSTA = 2 MOVE 1 TO XCRR.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
      **** rel 7.1
      *    IF IF-TPSTA = 2 MOVE 2 TO XCRR.
           MOVE 1 TO XCRR.
      ************
       D50. 
      *    IF COMCD = ZERO GO TO D99.
           EXIT.
       D60.
           MOVE ZERO TO K.
       D70.
           ADD 1 TO K.
           IF K > 7 GO TO D80.
           MOVE ZERO TO TTCON(K).
           GO TO D70.
       D80.
           IF COMCD = ZERO 
              MOVE KLV-CD  TO COMCD
              GO TO D99.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE KLV-CD  TO KPC-COD.
           READ ANACON INTO REKCON INVALID MOVE ALL '*'
                            TO CON-DESCR.
           MOVE CON-DESCR TO PDESTAR DESCCD.
      **** rel 7.1
      *    IF XCRR > ZERO MOVE 3 TO XCRR.
           MOVE 1 TO XCRR.
      ************
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
      * riga vuota per visuale stampa sintetica
      *
      **** rel 7.1
      *    IF IF-TPSTA = 2 
      *       MOVE 1 TO RP-FLGR
      *       MOVE 'RIG2' TO RP-BLK
      *       PERFORM RPT-WR.
      *
      *    MOVE 2 TO XCRR.
           MOVE 1 TO XCRR.
      ************
       D99.
           EXIT.
      *----------------------------------
      ************
       C00-LEGGE-CONTO.
           MOVE LOW-VALUE TO KEYMX.
           MOVE KPC-AZI TO KMX-AZI.
           MOVE KPC-COD TO KMX-CON.
           MOVE AZI-DTAPE TO KMX-DAT.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO C20.
       C10.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO C20.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO C10.
           IF KMX-AZI > KPC-AZI GO TO C20.
           IF KMX-CON > KPC-COD GO TO C20.
           MOVE MOV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SEME = 1 
                   IF MM9 > MESE GO TO C20 
                   ELSE GO TO C15.
           IF SEME = 2 
                   IF MM9 < 7 MOVE 1 TO MM9  
                   ELSE COMPUTE MM9 = MM9 - 6.
           IF MM9 > MESE GO TO C20.
       C15.
           IF AA4 > ANNO GO TO C20.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO LAV-SALDO (MM9) GO TO C10.
           SUBTRACT MOV-IMPO FROM LAV-SALDO (MM9).
           GO TO C10.
       C20.
           MOVE LOW-VALUE TO KEYMV.
           MOVE KPC-AZI TO KMV-AZI.
           MOVE KPC-COD TO KMV-CON.
           MOVE ZERO  TO KMV-DAT.
      **** rel 6.3
      *    START MOVIME KEY NOT < KEYMV INVALID GO TO C99.
           START MOVIME KEY NOT < KEYMV INVALID GO TO C90.
      ************
       C30.
      **** rel 6.3
      *    READ MOVIME NEXT INTO REKMOV AT END GO TO C99.
           READ MOVIME NEXT INTO REKMOV AT END GO TO C90.
      ************
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO C30.
      **** rel 6.3
      *    IF KMV-AZI > KPC-AZI GO TO C99.
      *    IF KMV-CON > KPC-COD GO TO C99.
           IF KMV-AZI > KPC-AZI GO TO C90.
           IF KMV-CON > KPC-COD GO TO C90.
      ************
           MOVE MOV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SEME = 1 
      **** rel 6.3
      *            IF MM9 > MESE GO TO C99 
                   IF MM9 > MESE GO TO C90 
      ************
                   ELSE GO TO C35.
           IF SEME = 2 
                   IF MM9 < 7 MOVE 1 TO MM9  
                   ELSE COMPUTE MM9 = MM9 - 6.
      **** rel 6.3
      *    IF MM9 > MESE GO TO C99.
      *    IF AA4 > ANNO GO TO C99.
           IF MM9 > MESE GO TO C90.
           IF AA4 > ANNO GO TO C90.
      ************
        C35.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO LAV-SALDO (MM9) GO TO C30.
           SUBTRACT MOV-IMPO FROM LAV-SALDO (MM9).
           GO TO C30.
      **** rel 6.3
        C90.
           MOVE ZERO TO COMLIB.
           MOVE LOW-VALUE TO KEYMLI.
           MOVE KPC-AZI   TO KMLI-AZI.
           MOVE KPC-COD   TO KMLI-CONTO.
           MOVE ZERO      TO KMLI-PRG.
           START MOVLIB KEY NOT < SKEYMLI1 INVALID GO TO C99.
       C95.
           READ MOVLIB NEXT AT END GO TO C99.
           IF SF-MLI = '9D' OR '9A' OR '35' GO TO C95.
           IF KMLI-AZI   > KPC-AZI GO TO C99.
           IF KMLI-CONTO > KPC-COD  GO TO C99.
           IF MLI-DARE = ZERO AND MLI-AVERE = ZERO GO TO C95.
           MOVE MLI-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SEME = 1 
                   IF MM9 > MESE GO TO C95 
                   ELSE GO TO C96.
           IF SEME = 2 
                   IF MM9 < 7 MOVE 1 TO MM9  
                   ELSE COMPUTE MM9 = MM9 - 6.
           IF MM9 > MESE GO TO C95.
           IF AA4 > ANNO GO TO C95.
      *
           IF MLI-VALID = 1
              MOVE MLI-DTVALID TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF AA4 NOT = ANNOR
                 GO TO C95
              ELSE 
                 IF SEME = 1 
                    IF MM9 < 7 
                       GO TO C95
                    END-IF
                    ELSE
                    IF MM9 > 6
                       GO TO C95
                    END-IF.
      *
        C96.
           MOVE 1 TO COMLIB.
           GO TO C95.
      ************
        C99.
           EXIT.
      *------------------
       RPT-RIG2A-INTC.
           MOVE 'RIG2' TO RP-BLK.
      *
           MOVE 'Codice' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Gennaio' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Febbraio' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Marzo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Aprile' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Maggio' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Giugno' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
       RPT-RIG2B-INTC.
           MOVE 'RIG2' TO RP-BLK.
      *
           MOVE 'Codice' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Luglio' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Agosto' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Settembre' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Ottobre' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Novembre' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Dicembre' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
      **** rel 6.3
       STAMPA-MLI.
      *
           PERFORM AZZ-SALDI THRU EX-AZZ-SALDI.
      *
           MOVE LOW-VALUE TO KEYMLI.
           MOVE KAZ-COD   TO KMLI-AZI.
           MOVE KLV-CD    TO KMLI-CONTO.
           MOVE ZERO      TO KMLI-PRG.
           START MOVLIB KEY NOT < SKEYMLI1 INVALID GO TO EX-STAMPA-MLI.
       RDNX-MLI.
           READ MOVLIB NEXT AT END GO TO M99.
           IF SF-MLI = '9D' OR '9A' OR '35' GO TO RDNX-MLI.
           IF KMLI-AZI   > KAZ-COD GO TO M99.
           IF KMLI-CONTO > KLV-CD  GO TO M99.
           IF MLI-DARE = ZERO AND MLI-AVERE = ZERO GO TO RDNX-MLI.
           IF MLI-VALID = 1
              MOVE MLI-DTVALID TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF AA4 NOT = ANNOR
                 GO TO RDNX-MLI
              ELSE 
              IF SEME = 1 
                 IF MM9 < 7 
                    GO TO RDNX-MLI
                 END-IF
              ELSE
                 IF MM9 > 6
                    GO TO RDNX-MLI
                 END-IF
              END-IF.
      *
           MOVE MLI-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      *
           IF SEME = 1 
              IF MM9 > MESE 
                 GO TO M99 
              ELSE 
                 GO TO M35.
      *
           IF SEME = 2 
              IF MM9 < 7 
                 MOVE 1 TO MM9  
              ELSE 
                 COMPUTE MM9 = MM9 - 6.
      *
           IF MM9 > MESE 
              GO TO M99.
      *
           IF AA4 > ANNO 
              GO TO M99.
        M35.
      *
           IF MM9 > 6 GO TO RDNX-MLI.
      **** rel 7.2
      *    ADD MLI-AVERE       TO CML-SALDO(MM9).
      *    SUBTRACT MLI-DARE FROM CML-SALDO(MM9).
           SUBTRACT MLI-AVERE FROM CML-SALDO(MM9).
           ADD MLI-DARE TO CML-SALDO(MM9).
      ************
           ADD 1 TO MM9.
           GO TO M35.
      *
      *    GO TO RDNX-MLI.
        M99.
      *
           IF CML-SALDO(1) = ZERO AND
              CML-SALDO(2) = ZERO AND
              CML-SALDO(3) = ZERO AND
              CML-SALDO(4) = ZERO AND
              CML-SALDO(5) = ZERO AND
              CML-SALDO(6) = ZERO
              GO TO EX-STAMPA-MLI.
      *
           MOVE KLV-CD TO PCOD.
           MOVE '(Extra Contabile)' TO PDES.
      *
      *    COMPUTE COM-SALDO (1) = COM-SALDO(1) + CML-SALDO(1).
           MOVE CML-SALDO (1) TO PSAL1.
           IF IF-LIREUR = 1
              MOVE CML-SALDO(1) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL1.
           IF MESE < 2 GO TO M101.
      *    COMPUTE COM-SALDO (2) = COM-SALDO (1) + CML-SALDO (2).
           MOVE CML-SALDO (2) TO PSAL2.
           IF IF-LIREUR = 1
              MOVE CML-SALDO(2) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL2.
           IF MESE < 3 GO TO M101.
      *    COMPUTE COM-SALDO (3) = COM-SALDO (2) + CML-SALDO (3).
           MOVE CML-SALDO (3) TO PSAL3.
           IF IF-LIREUR = 1
              MOVE CML-SALDO(3) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL3.
           IF MESE < 4 GO TO M101.
      *    COMPUTE COM-SALDO (4) = COM-SALDO (3) + CML-SALDO (4).
           MOVE CML-SALDO (4) TO PSAL4.
           IF IF-LIREUR = 1
              MOVE CML-SALDO(4) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL4.
           IF MESE < 5 GO TO M101.
      *    COMPUTE COM-SALDO (5) = COM-SALDO (4) + CML-SALDO (5).
           MOVE CML-SALDO (5) TO PSAL5.
           IF IF-LIREUR = 1
              MOVE CML-SALDO(5) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL5.
           IF MESE < 6 GO TO M101.
      *    COMPUTE COM-SALDO (6) = COM-SALDO (5) + CML-SALDO (6).
           MOVE CML-SALDO (6) TO PSAL6.
           IF IF-LIREUR = 1
              MOVE CML-SALDO(6) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL6.
      *
       M101.
      *
           IF IF-TPSTA = 2 MOVE 'RIG2' TO RP-BLK
                           PERFORM RPT-AZZ
                           GO TO EX-STAMPA-MLI.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
       EX-STAMPA-MLI.
           EXIT.
      *----------------------*
       AZZ-SALDI.
      *
           MOVE ZERO TO I.
       AZZ-1.
           ADD 1 TO I.
           IF I > 6 GO TO EX-AZZ-SALDI.
           MOVE ZERO TO CML-SALDO(I).
           GO TO AZZ-1.
      *
       EX-AZZ-SALDI.
           EXIT.
      *----------------------*
      ************
