       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON192.
      **** rel 7.1
      * Ricompilato
      ************
      *
      * Stampa prospetto simile registri per aliquota.
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           COPY 'grimvxsl'.
           COPY 'grimolsl'.
           COPY 'grimmosl'.
      **** rel 6.3
      *    COPY 'griivtsl'.
      ************
           COPY 'griivasl'.
           COPY 'gritabsl'.
           COPY 'griconsl'.
      **** rel 6.2
           COPY 'grimszsl'.
      ************
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           SELECT WDSLA1 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV1 STATUS SF-LA1.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'grimov'.
           COPY 'grimvx'.
           COPY 'grimol'.
           COPY 'grimmo'.
      **** rel 6.3
      *    COPY 'griivt'.
      ************
           COPY 'griiva'.
           COPY 'gritab'.
           COPY 'gricon'.
      **** rel 6.2
           COPY 'grimsz'.
      ************
      *
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 148 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-DAT   PIC 9(5).
              10 KLV-NPRGI PIC 9(5) COMP-3.
              10 KLV-CDCLI PIC 9(7) COMP-3.
              10 KLV-NREG  PIC 9(5) COMP-3.
              10 KLV-IVA   PIC 999.
              10 KLV-NUM   PIC 9(5) COMP-3.
           05 LAV-CIVA     PIC 9(7).
           05 LAV-RMOV     PIC X(120).
       FD  WDSLA1 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA1
           RECORD 10 DATA RECORD RF-LA1.
       01  RF-LA1.
           05 KEYLV1.
              10 KL1-AZI  PIC 999. 
              10 KL1-NREG PIC 9(5) COMP-3.
      **** rel 6.2
              10 KL1-DAT  PIC 9(5) COMP-3.
           05 FILLER   PIC X.
      *    05 FILLER   PIC X(4). 
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'pariv'.
           COPY 'parlk'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'grit35rk'.
           COPY 'grit25rk'.
           COPY 'grimovrk'.
           COPY 'griivark'.
           COPY 'griclfrk'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MVX PIC X(15) VALUE 'movmxx'.
       01  ID-MOL PIC X(15) VALUE 'movmol'.
       01  ID-MMO PIC X(15) VALUE 'movoxx'.
      **** rel 6.3
      *01  ID-IVT PIC X(15) VALUE 'movivt'.
      ************
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-LA1 PIC X(15) VALUE 'wdsla1'.
       01  ID-IVA PIC X(15) VALUE 'totiva'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
      **** rel 6.2
       01  ID-MSZ PIC X(15) VALUE 'movsez'.
      ************
      *
       01  COMODI.
           05 SF-AZI PIC XX.
           05 SF-CLF PIC XX.
           05 SF-TAB PIC XX.
           05 SF-MOV PIC XX.
           05 SF-MVX PIC XX.
           05 SF-MOL PIC XX.
           05 SF-MMO PIC XX.
      **** rel 6.3
      *    05 SF-IVT PIC XX.
      ************
           05 SF-LAV PIC XX.
           05 SF-LA1 PIC XX.
           05 SF-IVA PIC XX.
           05 SF-CON PIC XX.
      **** rel 6.2
           05 SF-MSZ PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
      *
           05 NUMMOV   PIC 9(5).
           05 NUMREG   PIC 9(5).
           05 COM-FLVEN PIC 9 VALUE ZERO.
           05 COM-FEV   PIC 9 VALUE ZERO.
           05 SEGNO     PIC 9 VALUE ZERO.
           05 TIPOP     PIC 9 VALUE ZERO.
           05 DTCOM  PIC 9(5) COMP-3 VALUE ZERO.
           05 FLGIS PIC 9 VALUE ZERO.
           05 CIVSO PIC 9(7) COMP-3 VALUE ZERO.
           05 COMCAU   PIC 9(3)   VALUE ZERO.
           05 K PIC 999 VALUE ZERO.
           05 CLAV PIC S9(11)V99.
           05 CLV1 PIC S9(11)V99.
           05 CLV2 PIC S9(11)V99.
           05 CIVA PIC 9(7) COMP-3.
           05 DT1 PIC 9(5) COMP-3.
           05 DT2 PIC 9(5) COMP-3.
           05 FLGPC     PIC 9    VALUE ZERO.
           05 DTMOV     PIC 9(5) VALUE ZERO.
           05 FLGIS-02  PIC 9    VALUE ZERO.
           05 T25PER   PIC 9        VALUE ZERO.
           05 T25ESE   PIC 9        VALUE ZERO.
           05 T25TSR   PIC 9        VALUE ZERO.
           05 T25ATT   PIC 9        VALUE ZERO.
           05 T25PRI   PIC 9(3)V99  VALUE ZERO.
           05 T25IND   PIC 9(7)     VALUE ZERO.
           05 T25PRO   PIC S9(11)V99 VALUE ZERO.
           05 DTK      PIC 9(5) COMP-3 VALUE ZERO.
           05 CIVAV    PIC 9(7) COMP-3 VALUE ZERO.
           05 K1       PIC 99       VALUE ZERO.
           05 K2       PIC 99       VALUE ZERO.
           05 CONTA PIC 9(7) VALUE ZERO.
           05 SW       PIC 9 VALUE ZERO.
           05 FTRI     PIC 9 VALUE ZERO.
           05 COMCOD   PIC 9(7) COMP-3 VALUE ZERO.
           05 COMNPRGI PIC 9(5) COMP-3 VALUE ZERO.
           05 COMIVA   PIC 999    VALUE ZERO.
           05 COMIMP   PIC S9(11)V99 VALUE ZERO.
           05 COMIMPO  PIC S9(11)V99 VALUE ZERO.
           05 COMIVN   PIC S9(11)V99 VALUE ZERO.
           05 COMCLF   PIC 9      VALUE ZERO.
           05 COMTIP   PIC 9      VALUE ZERO.
           05 COMCDV   PIC 999    VALUE ZERO.
           05 COMVAL   PIC S9(11)V99 VALUE ZERO.
           05 TOTIMP   PIC S9(11)V99 VALUE ZERO.
           05 TOTAIVA  PIC S9(11)V99 VALUE ZERO.
           05 TOTDOC   PIC S9(11)V99 VALUE ZERO.
           05 MATCON   OCCURS 50.
              10 CODIVA PIC 9(3).
              10 IMPCON PIC S9(11)V99.
              10 IVACON PIC S9(11)V99.
              10 INDCON PIC S9(11)V99.
           05 K5        PIC 99.
      **** rel 6.2
           05 SAV-NDOC   PIC 9(5) COMP-3.
           05 SAV-DTDOC  PIC 9(5) COMP-3.
           05 SAV-NPRGI  PIC 9(5) COMP-3.
           05 SAV-DAT    PIC 9(5) COMP-3.
           05 SAV-PART   PIC 9(7) COMP-3.
           05 SAV-CATT   PIC X.
           05 SAV-TIP    PIC 9.
           05 DTREG      PIC 9(5) VALUE ZERO.
           05 FLGPRI     PIC 9    VALUE ZERO.
      ************
       01  CAMPLAV.
           05 NREG     PIC 9(5)     VALUE ZERO.
           05 X        PIC 999 VALUE ZERO.
           05 CONTM    PIC 9        VALUE ZERO.
           05 CONTS    PIC 9        VALUE ZERO.
           05 CONTP    PIC 9        VALUE ZERO.
       01  VTLIQ.
           05 DTLIQ PIC   9(5) OCCURS 12.
           05 IMLIQ PIC S9(11)V99 OCCURS 12.
       01  VTRIM.
           05 IMRIB PIC S9(11)V99 OCCURS 3.

           COPY 'vcon192.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
      * data
           05 IF-DTLIQ     PIC 9(6).
           05 IF-CATT      PIC X.
           05 IF-CATT-D    PIC X(24).
           05 IF-TPREG     PIC 9.
      * data
           05 IF-DATA-1    PIC 9(6).
      * data
           05 IF-DATA-2    PIC 9(6).
           05 IF-IVAX.
              10 IF-IVA-1     PIC 9(3).
              10 IF-IVA-2     PIC 9(3).
              10 IF-IVA-3     PIC 9(3).
              10 IF-IVA-4     PIC 9(3).
              10 IF-IVA-5     PIC 9(3).
              10 IF-IVA-6     PIC 9(3).
              10 IF-IVA-7     PIC 9(3).
              10 IF-IVA-8     PIC 9(3).
              10 IF-IVA-9     PIC 9(3).
              10 IF-IVA-10    PIC 9(3).
           05 IF-IVAV REDEFINES IF-IVAX PIC 9(3) OCCURS 10.
           05 IF-TIPO      PIC 9.
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dclmvx'.
           COPY 'dclmmo'.
           COPY 'dclmol'.
      **** rel 6.3
      *    COPY 'dclivt'.
      ************
           COPY 'dcliva'.
           COPY 'dcltab'.
           COPY 'dclcon'.
      **** rel 6.2
           COPY 'dclmsz'.
      ************
           COPY 'dcllav'.
           COPY 'dclla1'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' OR
                    'w' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon192: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE MOVIME.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE MOVMXX.
           CLOSE MOVMOL.
           CLOSE MOVOXX.
           CLOSE TOTIVA.
           CLOSE ANACLF.
           CLOSE ANACON.
           CLOSE WDSLAV WDSLA1.
      *
           OPEN OUTPUT WDSLAV WDSLA1.
           CLOSE WDSLAV WDSLA1.
      *
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'grimoler'.
           COPY 'grimvxer'.
           COPY 'grimmoer'.
      **** rel 6.3
      *    COPY 'griivter'.
      ************
           COPY 'griivaer'.
           COPY 'gritaber'.
           COPY 'griconer'.
      **** rel 6.2
           COPY 'grimszer'.
      ************
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV WDSLA1.
           CLOSE WDSLAV WDSLA1.
           OPEN I-O WDSLAV WDSLA1.
      *
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'anaclf' TO ID-CLF
                           MOVE 'anacon' TO ID-CON
                           MOVE 'totiva' TO ID-IVA.
           IF IF-FL = 1 MOVE 'anazol' TO ID-AZI
                        MOVE 'tabold' TO ID-TAB
                        MOVE 'anacfx' TO ID-CLF
                        MOVE 'anacol' TO ID-CON
                        MOVE 'tivaol' TO ID-IVA.
      *
           OPEN INPUT ANACLF.
           OPEN INPUT ANACON.
           OPEN INPUT ANAAZI.
           OPEN INPUT MOVIME.
           OPEN INPUT MOVMXX.
           OPEN INPUT MOVMOL.
           OPEN INPUT MOVOXX.
      **** rel 6.3
      *    OPEN INPUT MOVIVT.
      ************
           OPEN INPUT TABELL.
           OPEN INPUT TOTIVA.
           OPEN INPUT ANACON.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE ZERO TO IF-REC.
           MOVE ZERO TO IF-IVA-1
                        IF-IVA-2
                        IF-IVA-3
                        IF-IVA-4
                        IF-IVA-5
                        IF-IVA-6
                        IF-IVA-7
                        IF-IVA-8
                        IF-IVA-9
                        IF-IVA-10.
           MOVE SPACE TO IF-AZI-D
                         IF-CATT-D.
      *
           MOVE '0' TO IF-CATT.
           MOVE 1   TO IF-TPREG.
           MOVE 1   TO IF-TIPO.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           MOVE AZI-RGSOC TO IF-AZI-D.
      *
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO INI-CAMPI-20.
       INI-CAMPI-10.
           READ WDSLAV NEXT AT END GO TO INI-CAMPI-20.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO INI-CAMPI-10.
           DELETE WDSLAV.
           GO TO INI-CAMPI-10.
       INI-CAMPI-20.
      *
           MOVE LOW-VALUE TO KEYLV1.
           START WDSLA1 KEY > KEYLV1 INVALID GO TO INI-CAMPI-40.
       INI-CAMPI-30.
           READ WDSLA1 NEXT AT END GO TO INI-CAMPI-40.
           IF SF-LA1 = '9D' OR '9A' OR '35' GO TO INI-CAMPI-30.
           DELETE WDSLA1.
           GO TO INI-CAMPI-30.
       INI-CAMPI-40.
           MOVE ZERO TO XCRR.
       ACCTB.
           IF IF-FL = 1 AND T25ESE = 1
              CLOSE TABELL TOTIVA ANAAZI
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'tivaol' TO ID-IVA
              OPEN INPUT ANAAZI
              OPEN INPUT TABELL
              OPEN INPUT TOTIVA.
       LPAZI.
           MOVE KAZ-COD TO IV-CDAZ.
           MOVE AZI-FLGIS TO FLGIS.
           MOVE 25        TO T25-TIP.
           MOVE KAZ-COD   TO T25-COD.
           MOVE '0'       TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-TSR TO T25TSR.
           MOVE T25-ESE TO T25ESE.
           IF NOT (IF-FL = 1 AND T25ESE = 1) GO TO LPAZ0.
           CLOSE ANAAZI TABELL TOTIVA.
           MOVE 'anaazi' TO ID-AZI.
           MOVE 'tabell' TO ID-TAB.
           MOVE 'totiva' TO ID-IVA.
           OPEN INPUT ANAAZI.
           OPEN INPUT TOTIVA.
           OPEN INPUT TABELL.
       LPAZ0.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '3'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE ZERO TO K1.
       LPAZ1.
           ADD 1 TO K1.
           MOVE T25-DT3(K1) TO DTLIQ(K1).
           MOVE T25-VE3(K1) TO IMLIQ(K1).
           IF K1 < 7 GO TO LPAZ1.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '4'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE ZERO TO K2.
       LPAZ2.
           ADD 1 TO K1 K2.
           MOVE T25-DT4(K2) TO DTLIQ(K1).
           MOVE T25-VE4(K2) TO IMLIQ(K1).
           IF K2 < 5 GO TO LPAZ2.
           MOVE '5' TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE ZERO TO K1.
       LPAZ3.
           ADD 1 TO K1.
           MOVE T25-RIB(K1) TO IMRIB(K1).
           IF K1 < 3 GO TO LPAZ3.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-ATT TO T25ATT.
           MOVE T25-PRI TO T25PRI.
           MOVE T25-IND TO T25IND.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-TSR TO T25TSR.
           MOVE T25-ESE TO T25ESE.
           MOVE T25-PER TO T25PER.
           IF IF-FL = ZERO GO TO EX-INI-CAMPI.
           CLOSE TABELL TOTIVA ANAAZI.
           MOVE 'anazol' TO ID-AZI.
           MOVE 'tabold' TO ID-TAB.
           MOVE 'tivaol' TO ID-IVA.
           OPEN INPUT ANAAZI TABELL TOTIVA.
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-CATT.
           MOVE 'IF-CATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CATT.
           IF IF-CATT NOT NUMERIC OR IF-CATT > '8'
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF IF-CATT = '0'
              MOVE AZI-DATT TO IF-CATT-D
              GO TO E-CATT.
      *
           MOVE 35      TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE IF-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID KEY PERFORM ERR-CINE
                                               GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE T35-DATT TO IF-CATT-D.
           MOVE T35-DTR  TO DTK.
       E-CATT.
      *
       V-TPREG.
           MOVE 'IF-TPREG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPREG.
           IF NOT (IF-TPREG = 1 OR 2)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TPREG.
      *
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG < AZI-DTAPE
              MOVE "Data inferiore alla data apertura" TO MESS
              GO TO V-ERROR.
           MOVE AAGGG TO DT1.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DT2.
           IF DT2 < DT1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DATA-2.
      *
       END-V-DATI.
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           CLOSE MOVIME.
           MOVE 'movime' TO ID-MOV.
           OPEN INPUT MOVIME.
           MOVE ZERO TO XCRR.
           MOVE ZERO TO X.
           MOVE ZERO TO TOTIMP TOTAIVA TOTDOC.
           MOVE 1  TO KTB-COD.
           MOVE 14 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-FTRI TO FTRI.

           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF IF-TPREG = 1
              MOVE T01-CIVAQ TO CIVA
              MOVE ZERO TO CIVSO
              MOVE 'A C Q U I S T I' TO TSX2
              MOVE IF-CATT-D TO TSX3
              GO TO LAZ4-1.
           IF IF-TPREG = 2
              MOVE T01-CIVAV TO CIVA CIVAV
              MOVE T01-CIVSO TO CIVSO
              MOVE 'V E N D I T E' TO TSX2
              MOVE IF-CATT-D TO TSX3.
       LAZ4-1.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 58      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      **** rel 7.1
           MOVE 1       TO LMOD.
      ************
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           IF IF-TPREG = 1
              STRING 'PROSPETTO IVA ACQUISTI ' TSX3
                     DELIMITED SIZE INTO RP-TIT1.
           IF IF-TPREG = 2
              STRING 'PROSPETTO IVA VENDITE '  TSX3
                     DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
      *    MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

      *------------------
       LAZ5.
      **** rel 6.2
           IF IF-FL = ZERO GO TO LAZ20.
      ************
           MOVE KAZ-COD TO KMO-AZI KL1-AZI.
           MOVE CIVA    TO KMO-CON.
           MOVE DT1     TO KMO-DAT.
           MOVE ZERO    TO KMO-NUM.
           START MOVOXX KEY NOT < KEYMO INVALID GO TO LAZ10.
       LOP5.
           READ MOVOXX NEXT INTO REKMOV AT END GO TO LAZ10.
           IF SF-MMO = '9D' OR '9A' OR '35' GO TO LOP5.
           IF KMO-AZI      > KAZ-COD GO TO LAZ10.
           IF KMO-CON      > CIVA    GO TO LAZ10.
           IF KMO-DAT      < DT1     GO TO LOP5.
           IF KMO-DAT      > DT2     GO TO LAZ10.
           IF MOV-CATT NOT = IF-CATT GO TO LOP5.
           IF MOV-FLAG     = 1       GO TO LOP5.
           PERFORM AGGLAV THRU EX-AGGLAV.
           GO TO LOP5.
       LAZ10.
           MOVE KAZ-COD TO KML-AZI KL1-AZI.
           MOVE CIVA    TO KML-CON.
           MOVE DT1     TO KML-DAT.
           MOVE ZERO    TO KML-NUM.
           START MOVMOL KEY NOT < KEYML INVALID GO TO LAZ20.
       LOP10.
           READ MOVMOL NEXT INTO REKMOV AT END GO TO LAZ20.
           IF SF-MOL = '9D' OR '9A' OR '35' GO TO LOP10.
           IF KML-AZI      > KAZ-COD GO TO LAZ20.
           IF KML-CON      > CIVA    GO TO LAZ20.
           IF KML-DAT      < DT1     GO TO LOP10.
           IF KML-DAT      > DT2     GO TO LAZ20.
           IF MOV-CATT NOT = IF-CATT GO TO LOP10.
           IF MOV-FLAG     = 1       GO TO LOP10.
           PERFORM AGGLAV THRU EX-AGGLAV.
           GO TO LOP10.
       LAZ20.
      **** rel 6.2
           IF IF-FL NOT = ZERO GO TO ENDA.
      ************
           MOVE KAZ-COD TO KMX-AZI KL1-AZI.
           MOVE CIVA    TO KMX-CON.
           MOVE DT1     TO KMX-DAT.
           MOVE ZERO    TO KMX-NUM.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO LAZ30.
       LOP20.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO LAZ30.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO LOP20.
           IF KMX-AZI      > KAZ-COD GO TO LAZ30.
           IF KMX-CON      > CIVA    GO TO LAZ30.
           IF KMX-DAT      < DT1     GO TO LOP20.
           IF KMX-DAT      > DT2     GO TO LAZ30.
           IF MOV-CATT NOT = IF-CATT GO TO LOP20.
           IF MOV-FLAG     = 1       GO TO LOP20.
           PERFORM AGGLAV THRU EX-AGGLAV.
           GO TO LOP20.
       LAZ30.
           MOVE KAZ-COD TO KMV-AZI KL1-AZI.
           MOVE CIVA    TO KMV-CON.
           MOVE DT1     TO KMV-DAT.
           MOVE ZERO    TO KMV-NUM.
           START MOVIME KEY NOT < KEYMV INVALID GO TO ENDA.
       LOPM.
           READ MOVIME NEXT INTO REKMOV AT END GO TO ENDA.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO LOPM.
           IF KMV-AZI      > KAZ-COD GO TO ENDA.
           IF KMV-CON      > CIVA    GO TO ENDA.
           IF KMV-DAT      < DT1     GO TO LOPM.
           IF KMV-DAT      > DT2     GO TO ENDA.
           IF MOV-CATT NOT = IF-CATT GO TO LOPM.
           IF MOV-FLAG     = 1       GO TO LOPM.
           PERFORM AGGLAV THRU EX-AGGLAV.
           GO TO LOPM.
       ENDA.
           EXIT.
      *------------------
       ENDA-00.
      **** rel 6.3
      * skippo sempre movint (MOV.IVA TRASPORT) poich i dati sono gi 
      * in movime (MOVIMENTI CONTABILE) tre mesi prima 
      *
      *    IF IF-TPREG NOT = 2     GO TO ENDA-10.
      *    IF CIVA     NOT = CIVAV GO TO ENDA-10.
      *    IF T25PER   NOT = 2     GO TO ENDA-10.
      *    MOVE KAZ-COD TO KVT-AZI KL1-AZI.
      *    MOVE CIVA    TO KVT-CON.
      *    MOVE DT1     TO KVT-DAT.
      *    MOVE ZERO    TO KVT-NUM.
      *    START MOVIVT KEY NOT < KEYVT INVALID GO TO ENDA-10.
      *LOPVT.
      *    READ MOVIVT NEXT INTO REKMOV AT END GO TO ENDA-10.
      *    IF SF-IVT = '9D' OR '9A' OR '35' GO TO LOPVT.
      *    IF KVT-AZI      > KAZ-COD GO TO ENDA-10.
      *    IF KVT-CON      > CIVA    GO TO ENDA-10.
      *    IF KVT-DAT      < DT1     GO TO LOPVT.
      *    IF KVT-DAT      > DT2     GO TO ENDA-10.
      *    IF MOV-CATT NOT = IF-CATT GO TO LOPVT.
      *    IF MOV-FLAG     = 1       GO TO LOPVT.
      *    PERFORM AGGLAV THRU EX-AGGLAV.
      *    GO TO LOPVT.
      *ENDA-10.
      ************
           IF CIVA NOT = CIVSO
              IF IF-TPREG = 2 AND FLGIS = 2
                 MOVE CIVSO TO CIVA
                 PERFORM LAZ5 THRU ENDA.
           MOVE ZERO TO COMCOD
                        COMNPRGI
                        SW
                        K5
                        DTCOM
                        COMCAU
                        COMIMP
                        COMIMPO
                        COMIVN
                        COMIVA
                        COMVAL
                        COMTIP
                        COMCDV
                        COMCLF.
       AZZ.
           ADD 1 TO K5.
           IF K5 > 50 GO TO AZZ1.
           MOVE ZERO TO CODIVA(K5) IVACON(K5)
                        IMPCON(K5) INDCON(K5).
           GO TO AZZ.
       AZZ1.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO ENDB.
       LOPL.
           READ WDSLAV NEXT AT END MOVE 1 TO SW
                                   GO TO RLIB2.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO LOPL.
           MOVE LAV-RMOV TO REKMOV.
           MOVE ZERO TO CONTS.
           MOVE KAZ-COD TO KL1-AZI.
           MOVE KLV-NREG TO KL1-NREG.
      **** rel 6.2
           MOVE KLV-DAT  TO KL1-DAT.
      ************
           READ WDSLA1 INVALID MOVE 1 TO CONTS.
           IF CONTS = 1 GO TO LOPL.
      **** rel 6.2
           MOVE ZERO TO FLGPRI.
           IF NREG = ZERO MOVE KLV-NREG TO NREG
                          MOVE KLV-DAT  TO DTREG
                          MOVE 1        TO FLGPRI.
      *    IF NREG = ZERO MOVE KLV-NREG TO NREG.
      ************
           MOVE KAZ-COD TO KMV-AZI.
           MOVE LAV-CIVA TO KMV-CON.
           MOVE KLV-DAT TO KMV-DAT.
           MOVE KLV-NUM TO KMV-NUM.
           CLOSE MOVIME.
           IF IF-FL = 1 MOVE 'movoxx' TO ID-MOV
           ELSE         MOVE 'movmxx' TO ID-MOV.
           OPEN INPUT MOVIME.
           READ MOVIME INTO REKMOV INVALID
                PERFORM LEG-MOV THRU EX-LEG-MOV.
           IF SF-MOV = '9D' OR '9A' OR '35' MOVE RF-MOV TO REKMOV.
      **** rel 6.2
           IF FLGPRI = 1
              MOVE MOV-CATT  TO SAV-CATT
              MOVE MOV-DTDOC TO SAV-DTDOC
              MOVE MOV-NDOC  TO SAV-NDOC
              MOVE MOV-NPRGI TO SAV-NPRGI
              MOVE MOV-DAT   TO SAV-DAT
              MOVE MOV-TIP   TO SAV-TIP
              MOVE MOV-PART  TO SAV-PART.
      ************
           IF IF-TPREG > 1 OR T25TSR = ZERO OR
              DTK NOT < DT2 GO TO LOP0.
       LOP0.
           IF DTCOM = ZERO MOVE KMV-DAT TO DTCOM.
           IF COMNPRGI = ZERO MOVE KLV-NPRGI TO COMNPRGI.
           IF DTCOM NOT = KMV-DAT MOVE ZERO TO COMNPRGI
                          MOVE KMV-DAT TO DTCOM.
           IF COMNPRGI = KLV-NPRGI
              IF (COMCOD = ZERO OR COMCOD = KLV-CDCLI)
                 AND (COMCAU = ZERO OR COMCAU = MOV-CAUS)
                                             GO TO LOPL0.
           MOVE 2 TO SW GO TO RLIB2.
       LOPL-0.
           IF FTRI = ZERO MOVE KLV-NPRGI TO COMNPRGI
                          MOVE ZERO TO COMCOD COMIVA TOTIMP TOTAIVA
                          COMCAU COMVAL COMTIP COMCDV COMCLF
                          GO TO LOPL0.
           MOVE 1 TO XCRR.
           MOVE KLV-NPRGI TO COMNPRGI.
           MOVE ZERO TO COMCOD COMIVA TOTIMP TOTAIVA.
           MOVE ZERO TO COMCAU.
           MOVE ZERO TO COMVAL COMTIP COMCDV COMCLF.
       LOPL0.
           PERFORM RLIB THRU EX-RLIB.
       LOPL1.
           DELETE WDSLAV.
      *
           COPY 'grirpt-r'.
      *
           GO TO LOPL.
       ENDB.
           MOVE ZERO TO CONTA CONTM CONTS CONTP NREG.
      **** rel 6.2
           MOVE ZERO TO DTREG.
      ************
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       RLIB.
           MOVE MOV-CAUS TO COMCAU.
           MOVE 2        TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO REKTAB.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T02-FLVEN TO COM-FLVEN.
           MOVE T02-TIPOP TO TIPOP.
           MOVE T02-SEGNO TO SEGNO.
           MOVE T02-FLGIS TO FLGIS-02.
           IF MOV-FLAG = 1 GO TO EX-RLIB.
       RLIB0.
           IF MOV-PART = COMCOD GO TO RLIB1.
           MOVE 1 TO XCRR.
           IF CONTP = ZERO GO TO NOST0.
           PERFORM ST-CONTR THRU EX-ST-CONTR.
           MOVE KLV-NREG TO NREG.
      **** rel 6.2
           MOVE KLV-DAT  TO DTREG.
      ************
           MOVE KAZ-COD TO KMV-AZI.
           MOVE LAV-CIVA TO KMV-CON.
           MOVE KLV-DAT TO KMV-DAT.
           MOVE KLV-NUM TO KMV-NUM.
           CLOSE MOVIME.
           IF IF-FL = 1 MOVE 'movoxx' TO ID-MOV
                  ELSE  MOVE 'movmxx' TO ID-MOV.
           OPEN INPUT MOVIME.
           READ MOVIME INTO REKMOV INVALID
                PERFORM LEG-MOV THRU EX-LEG-MOV.
           IF SF-MOV = '9D' OR '9A' OR '35' MOVE RF-MOV TO REKMOV.
      **** rel 6.2
           MOVE MOV-CATT  TO SAV-CATT.
           MOVE MOV-DTDOC TO SAV-DTDOC.
           MOVE MOV-NDOC  TO SAV-NDOC.
           MOVE MOV-NPRGI TO SAV-NPRGI.
           MOVE MOV-DAT   TO SAV-DAT.
           MOVE MOV-TIP   TO SAV-TIP.
           MOVE MOV-PART  TO SAV-PART.
      ************

       NOST0.
           MOVE 1 TO CONTP.
           MOVE MOV-PART TO KCF-COD COMCOD.
           MOVE MOV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RG1.
           MOVE KAZ-COD TO KCF-AZI.
           READ ANACLF INTO REKCLF INVALID KEY
               MOVE 'INES.' TO CLF-RGS
               MOVE SPACE   TO CLF-RGS2
               MOVE ZERO TO CLF-13IVA.
           MOVE CLF-13IVA TO COMCLF.
           MOVE MOV-NPRGI TO RV2.
      **** rel 6.2
           MOVE MOV-NREG  TO RV2A.
      ************
           IF T02-FLGIS > ZERO AND FLGIS = 2
                          MOVE MOV-NDOC TO RV2.
           MOVE CLF-RGS TO RV3.
           IF CLF-RGS2 NOT = SPACE
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR
              MOVE CLF-RGS2 TO RV3.
           MOVE MOV-NDOC TO RV4.
           MOVE MOV-DTDOC TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RV5.
       RLIB1.
           IF NOT (SEGNO = 1 OR TIPOP = 8)
              MOVE SPACE TO RV9.
           IF SEGNO = 1 MOVE 'STORNO CONT.'       TO RV91.
           IF TIPOP = 8 MOVE 'VAR. ART. 26'       TO RV91.
           IF IF-TPREG = 2 AND FLGIS-02 = 1
                        MOVE 'IMPOSTA SOSP'       TO RV92.
           IF IF-TPREG  = 2 AND FLGIS-02 = 2
              MOVE 010198 TO GGMMAA
              MOVE 1 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF MOV-DTDOC NOT < AAGGG
                 MOVE 'INCASSO FATTURA SOSPESA' TO RV9
              ELSE
                 MOVE 'INCASSO EX.REG.FATTURA SOSP.' TO RV9.
           IF MOV-FLGPC > ZERO
              IF MOV-DAT > DT2
                 MOVE 'MESE CORRENT' TO RV92
              ELSE
                 MOVE 'MESE PRECED.' TO RV92.
           MOVE MOV-DAT   TO DTMOV.
           MOVE MOV-FLGPC TO FLGPC.
           MOVE T02-FLGIS TO FLGIS-02.
           IF COMIVA NOT = ZERO GO TO RLIB1-00.
           IF TIPOP = 8
              MULTIPLY -1 BY MOV-IMPO
              IF MOV-TIP = 4
                 MULTIPLY -1 BY MOV-IML
                 MULTIPLY -1 BY MOV-INL
                 MULTIPLY -1 BY MOV-IMV
              ELSE
                 MULTIPLY -1 BY MOV-IMP
                 MULTIPLY -1 BY MOV-IVN.
            MOVE MOV-IVA  TO COMIVA.
            MOVE MOV-IMPO TO COMIMPO.
            MOVE MOV-TIP TO COMTIP.
            IF MOV-TIP = 4
               MOVE MOV-IML TO COMIMP
               MOVE MOV-INL TO COMIVN
               MOVE MOV-IMV TO COMVAL
               MOVE MOV-VAL TO COMCDV
            ELSE
               MOVE MOV-IMP  TO COMIMP
               MOVE MOV-IVN  TO COMIVN.
            MOVE MOV-FEV TO COM-FEV.
            GO TO EX-RLIB.
       RLIB1-00.
           IF NOT (COMIVA = MOV-IVA AND MOV-FEV = COM-FEV)
              GO TO RLIB2.
           IF TIPOP = 8
              MULTIPLY -1 BY MOV-IMPO
              IF COMTIP = 4
                 MULTIPLY -1 BY MOV-IML
                 MULTIPLY -1 BY MOV-INL
                 MULTIPLY -1 BY MOV-IMV
              ELSE
                 MULTIPLY -1 BY MOV-IMP
                 MULTIPLY -1 BY MOV-IVN.
           ADD MOV-IMPO TO COMIMPO.
           IF COMTIP = 4
              ADD MOV-IML TO COMIMP
              ADD MOV-INL TO COMIVN
              ADD MOV-IMV TO COMVAL
           ELSE
              ADD MOV-IMP TO COMIMP
              ADD MOV-IVN TO COMIVN.
           GO TO EX-RLIB.
       RLIB2.
           MOVE COMIMP TO RV6.
           ADD COMIMP TO TOTIMP.
           MOVE 3      TO KTB-TIP.
           MOVE COMIVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO  TO REKTAB
                MOVE ZERO  TO T03-ESCEE T03-DECEE
                MOVE SPACE TO T03-DSIVA.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF FLGPC > ZERO AND DTMOV NOT > DT2 GO TO CARV1.
           IF IF-TPREG = 2 AND FLGIS-02 = 1 GO TO CARV1.
           MOVE ZERO TO K5.
       CARV.
           ADD 1 TO K5.
           IF K5 > 50 GO TO CARV1.
           IF CODIVA(K5) = ZERO
              MOVE COMIVA TO CODIVA(K5).
           IF CODIVA(K5) NOT = COMIVA GO TO CARV.
           ADD COMIMP  TO IMPCON(K5).
           ADD COMIMPO TO IVACON(K5).
       CARV1.
           MOVE T03-DSIVA TO RV7.
           MOVE COMIMPO   TO RV8.
           ADD COMIMPO TO TOTAIVA.
           IF (COMTIP = 4 OR COMCLF = 4) AND T03-ESCEE = ZERO
              MOVE 'CEE' TO RV93.
           IF T03-TPIVA = ZERO GO TO STAMR.
           IF IF-TPREG = 1 AND T03-TPIVA = 1
              MOVE 'IVA INDEDUC.'     TO RV91
              GO TO STAMQ.
           IF T03-ALIVA = ZERO MOVE TAB-DESCR TO RV69.
           IF T03-TPIVA < 7 GO TO STAMR.
           IF IF-TPREG NOT = 1 GO TO STAMS.
           MOVE SPACE TO RV91.
           MOVE COMIMP TO CLAV.
      **** rel 6.2
      *    COMPUTE CLV1 = CLAV / 2.
           IF T03-PERIVA = ZERO MOVE 50 TO T03-PERIVA.
           COMPUTE CLV1 = CLAV * T03-PERIVA / 100.
      ************
           COMPUTE CLV2 = CLAV - CLV1.
           MOVE CLV2 TO RV6.
           MOVE COMIMPO TO RV8.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE CLV1 TO RV6.
       STAMQ.
           MOVE COMIVN TO RV8.
           ADD COMIVN TO TOTAIVA.
           IF FLGPC = ZERO OR DTMOV > DT2 OR
              IF-TPREG NOT = 2 OR FLGIS-02 NOT = 1
                 ADD COMIVN TO INDCON(K5).
           MOVE T03-DSIVA TO RV7.
           MOVE 'IVA INDEDUC.'     TO RV91.
       STAMR.
           IF COM-FLVEN     = ZERO OR
              COM-FEV       = 1    OR
              T03-TPIVA NOT = ZERO GO TO STAMS.
           IF IF-TPREG NOT = 1 GO TO STAMS.
           MOVE 'ACQ.RIVEND.-'              TO RV91.
           IF SEGNO = 1 MOVE 'ACQ.RIV.-ST.' TO RV91.
           IF TIPOP = 8 MOVE 'ACQ.RIV-A.26' TO RV91.
       STAMS.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ZERO TO COMIMP COMIMPO COMIVN COMIVA.
           IF COMTIP NOT = 4 GO TO STAMS-10.
           IF NOT COMCDV = 1 OR COMVAL = ZERO GO TO STAMS-10.
           MOVE 10      TO KTB-TIP.
           MOVE COMCDV  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO T10-DSINT.
           MOVE T10-DSINT TO RV51.
           MOVE COMVAL TO RV61.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ZERO TO COMVAL.
       STAMS-10.
           MOVE ZERO TO COMTIP COMCDV.
           IF SW = 1 PERFORM ST-CONTR THRU EX-ST-CONTR
                     GO TO ENDB.
           IF SW = 2 MOVE ZERO TO SW
                     GO TO LOPL-0
           ELSE      GO TO RLIB0.
       EX-RLIB.
           EXIT.
      *------------------
       AGGLAV.
           MOVE MOV-DAT TO KLV-DAT.
           MOVE MOV-NUM TO KLV-NUM.
           MOVE MOV-NPRGI TO KLV-NPRGI.
           MOVE CIVA TO LAV-CIVA.
           IF IF-TPREG = 1 GO TO AGL30.
           MOVE 2        TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                             MOVE ZERO TO REKTAB.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T02-FLGIS > ZERO AND FLGIS = 2
                          MOVE MOV-NDOC TO KLV-NPRGI.
       AGL30.
           IF IF-TIPO = 1
              MOVE 1 TO CONTS
              GO TO AGL35.
           MOVE ZERO TO X CONTS.
       LAZXX.
           ADD 1 TO X.
           IF MOV-IVA = IF-IVAV(X)
              MOVE 1 TO CONTS
              MOVE 10 TO X.
           IF X < 10 GO TO LAZXX.

       AGL35.
           MOVE MOV-IVA TO KLV-IVA.
           MOVE MOV-PART TO KLV-CDCLI.
           MOVE MOV-NREG TO KLV-NREG.
           IF MOV-PART NOT = ZERO GO TO AGL40.
           MOVE MOV-NUM  TO NUMMOV.
           MOVE MOV-NREG TO NUMREG.
           MOVE SPACE TO F-MES1.
           STRING 'Mov. n. ' NUMMOV ' Reg. n. ' NUMREG
                   DELIMITED BY SIZE INTO F-MES1.
           IF IF-TPREG = 1
              MOVE 'Manca codice fornitore' TO F-MES2
           ELSE
              MOVE 'Manca codice cliente  ' TO F-MES2.
           MOVE 2 TO F-NMES.
           GO TO ERRIO.
       AGL40.
           MOVE REKMOV TO LAV-RMOV.
           WRITE RF-LAV INVALID MOVE 'vcon192:errore WR LAV' TO MESS
                                GO TO ERRIO.
           ADD 1 TO CONTA.
           IF CONTS NOT = ZERO
              MOVE MOV-NREG TO KL1-NREG
      **** rel 6.2
              MOVE MOV-DAT  TO KL1-DAT
      ************
              WRITE RF-LA1.
       EX-AGGLAV.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV ID-LA1.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
           STRING 'w2' PID DELIMITED SPACE INTO ID-LA1.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       REC-LOCK.
           CALL 'rlock' USING PARLK.
           EXIT.
      *------------------
       LEG-MOV.
           CLOSE MOVIME.
           IF IF-FL = 1 MOVE 'movmol' TO ID-MOV
           ELSE         MOVE 'movime' TO ID-MOV.
           OPEN INPUT MOVIME.
      **** rel 6.3
           MOVE KAZ-COD TO KMV-AZI.
           MOVE LAV-CIVA TO KMV-CON.
           MOVE KLV-DAT TO KMV-DAT.
           MOVE KLV-NUM TO KMV-NUM.
      ************
           READ MOVIME INTO REKMOV INVALID
                       PERFORM INVK-MOV GO TO ERRIO.
       EX-LEG-MOV.
           EXIT.
      *---------------------*
       ST-CONTR.
      **** rel 6.2
           IF SAV-TIP = 4 PERFORM STAMPA-CEE THRU EX-STAMPA-CEE.
      ************
           MOVE 2 TO XCRR.
           MOVE ZERO TO CONTM.
           MOVE NREG TO KEYMV2.
           CLOSE MOVIME.
           IF IF-FL = 1 MOVE 'movoxx' TO ID-MOV
                  ELSE  MOVE 'movmxx' TO ID-MOV.
           OPEN INPUT MOVIME.
           START MOVIME KEY NOT < KEYMV2 INVALID GO TO NOMOV.
       LP10.
           READ MOVIME NEXT INTO REKMOV AT END GO TO NOMOV.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO LP10.
           IF MOV-NREG > NREG GO TO NOMOV.
      **** rel 6.2
           IF MOV-DAT NOT = DTREG GO TO LP10.
      ************
           IF MOV-AZI NOT = KAZ-COD GO TO LP10.
           IF MOV-FLAG = ZERO GO TO LP10.
      **** rel 7.1
      *    IF MOV-TREG = '1' GO TO LP10.
           IF SAV-TIP NOT = 4
              IF MOV-TREG = '1' GO TO LP10.
      ************
           IF IF-TPREG = 1
              IF MOV-D-A = 'A' MULTIPLY -1 BY MOV-IMPO.
           IF IF-TPREG = 2
              IF MOV-D-A = 'D' MULTIPLY -1 BY MOV-IMPO.
           MOVE MOV-CON TO RGC.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE MOV-CON TO KPC-COD.
           READ ANACON INVALID MOVE SPACE TO CON-DSC.
           MOVE CON-DSC  TO RGD.
           MOVE MOV-IMPO TO RG3.

           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           GO TO LP10.
       NOMOV.
           IF CONTM NOT = ZERO GO TO EX-ST-CONTR.
           MOVE 1 TO CONTM.
           CLOSE MOVIME.
           IF IF-FL = 1 MOVE 'movmol' TO ID-MOV
                  ELSE  MOVE 'movime' TO ID-MOV.
           OPEN INPUT MOVIME.
           MOVE NREG TO KEYMV2.
           START MOVIME KEY NOT < KEYMV2 INVALID GO TO EX-ST-CONTR.
           GO TO LP10.
       EX-ST-CONTR.
      * riga vuota carattere
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           EXIT.
      *-------------*
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Progr.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      **** rel 6.2
           MOVE 'N.Reg.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      ************
           MOVE 'Ragione Sociale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'N.Doc' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imponibile' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Aliq. - Imposta' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Note' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
      **** rel 6.2
       STAMPA-CEE.
           IF IF-FL = ZERO MOVE 'movsxx' TO ID-MSZ
           ELSE            MOVE 'mosoxx' TO ID-MSZ.
           PERFORM CERCA-NREG THRU EX-CERCA-NREG.
           IF NREG NOT = ZERO  GO EX-STAMPA-CEE.
      *
           IF IF-FL = ZERO MOVE 'movsez' TO ID-MSZ
           ELSE            MOVE 'movsol' TO ID-MSZ.
           PERFORM CERCA-NREG THRU EX-CERCA-NREG.
      *
       EX-STAMPA-CEE.
           EXIT.
      *-------------*
       CERCA-NREG.
           MOVE ZERO TO NREG DTREG.
           OPEN INPUT MOVSEZ.
           MOVE LOW-VALUE TO KEYMS.
           MOVE KAZ-COD   TO KMS-AZI.
           MOVE SAV-PART  TO KMS-CON.
           MOVE SAV-DAT   TO KMS-DAT.
           START MOVSEZ KEY NOT < KEYMS INVALID GO TO NO-CEE-E.
       RD-CEE.
           READ MOVSEZ NEXT INTO REKMOV AT END GO TO NO-CEE-E.
           IF SF-MSZ = '9D' OR '9A' OR '35' GO TO RD-CEE.
           IF MOV-AZI NOT = KAZ-COD  GO TO NO-CEE-E.
           IF KMS-CON NOT = SAV-PART GO TO NO-CEE-E.
           IF KMS-DAT NOT = SAV-DAT  GO TO NO-CEE-E.
      *
           IF NOT (MOV-CATT = SPACE AND SAV-CATT = ZERO)
              IF MOV-CATT  NOT = SAV-CATT   GO TO RD-CEE.
      *
           IF MOV-DTDOC NOT = SAV-DTDOC  GO TO RD-CEE.
           IF MOV-NDOC  NOT = SAV-NDOC   GO TO RD-CEE.
      *
           MOVE MOV-NREG TO NREG.
           MOVE MOV-DAT  TO DTREG.
      *
       NO-CEE-E.
           CLOSE MOVSEZ.
       EX-CERCA-NREG.
           EXIT.
      *------------------
      ************
