       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON210.
      *
      * Stampa mastrini
      *
      **** rel 7.2
      * Ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           COPY 'grimszsl'.
           COPY 'grimvxsl'.
           COPY 'grimsxsl'.
           COPY 'gricolsl'.
           COPY 'gricfxsl'.
           COPY 'gritabsl'.
      **** rel 6.2
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV 
                  ALTERNATE RECORD KEY 
                        SKEYLV1 = KLV-ESER KLV-NREG KLV-DAT KLV-NUM
                  WITH DUPLICATES
                  ALTERNATE RECORD KEY 
                        SKEYLV2 = KLV-DAT KLV-CATT KLV-NPRGI 
                                  KLV-NREG KLV-ESER 
                  WITH DUPLICATES
                  ALTERNATE RECORD KEY 
                        SKEYLV3 = KLV-CATT KLV-NPRGI KLV-DAT
                                  KLV-NREG KLV-ESER 
                  WITH DUPLICATES
                  STATUS SF-LAV.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'griclf'.
           COPY 'grimov'.
           COPY 'grimsz'.
           COPY 'grimvx'.
           COPY 'grimsx'.
           COPY 'gricol'.
           COPY 'gricfx'.
           COPY 'gritab'.
      **** rel 6.2
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 40 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
             10 KLV-ESER   PIC 9.
             10 KLV-DAT    PIC 9(5).
             10 KLV-NREG   PIC 9(5).
             10 KLV-NUM    PIC 9(5).
             10 KLV-CATT   PIC X.
             10 SKLV-NPRGI.
                15 KLV-NPRGI PIC 9(5) COMP-3.
           05 LAV-KEY      PIC X(20).
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griconrk'.
           COPY 'gritabrk'.
      **** rel 6.3
           COPY 'grit20rk'.
      ************
           COPY 'grimovrk'.
           COPY 'griclfrk'.
       01  REKCOL.
           05 COL-KEYID.
              10 COL-AZI  PIC 999   VALUE ZERO.
              10 COL-COD  PIC 9(7)  VALUE ZERO.
           05 COL-DESCR   PIC X(36) VALUE SPACE.
           05 COL-DSABB   PIC X(20) VALUE SPACE.
           05 COL-TIPO    PIC X     VALUE SPACE.
           05 COL-SALDI.
              10 COL-SP-D PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 COL-SP-A PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 COL-SPSP PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 COL-SE-D PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 COL-SE-A PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 COL-SESP PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 COL-SALDR REDEFINES COL-SALDI.
              10 COL-SXYY PIC S9(11) COMP-3 OCCURS 6.
           05 COL-BIL1  PIC 9  VALUE ZERO.
           05 COL-BIL2  PIC 99 VALUE ZERO.
           05 COL-BIL3  PIC 99 VALUE ZERO.
           05 COL-BIL4  PIC 9  VALUE ZERO.
           05 COL-FLRIE PIC 9  VALUE ZERO.
           05 COL-MOVIM PIC 9  VALUE ZERO.
           05 COL-FLAUT PIC 9  VALUE ZERO.
           05 COL-TPCOP PIC 9  VALUE ZERO.
           05 COL-TPCON PIC 9  VALUE ZERO.
           05 COL-PRO1  PIC 99 VALUE ZERO.
           05 COL-PRO2  PIC 99 VALUE ZERO.
           05 COL-BIL5  PIC 9  VALUE ZERO.
           05 COL-CVAL  PIC 9  VALUE ZERO.
           05 FILLER    PIC X(4) VALUE ZERO.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parer'.
       01  ID-AZI PIC X(15).
       01  ID-TAB PIC X(15).
       01  ID-CON PIC X(15).
       01  ID-MOV PIC X(15).
       01  ID-MSZ PIC X(15).
       01  ID-CLF PIC X(15).
       01  ID-MVX PIC X(15).
       01  ID-MSX PIC X(15).
       01  ID-COL PIC X(15) VALUE 'anacol'.
       01  ID-CFX PIC X(15) VALUE 'anacfx'.
      **** rel 6.2
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
      ************
       01  COMODI.
           05 SF-AZI PIC XX.
           05 SF-CON PIC XX.
           05 SF-TAB PIC XX.
           05 SF-MOV PIC XX.
           05 SF-MSZ PIC XX.
           05 SF-CLF PIC XX.
           05 SF-MVX PIC XX.
           05 SF-MSX PIC XX.
           05 SF-COL PIC XX.
           05 SF-CFX PIC XX.
      **** rel 6.2
           05 SF-LAV PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 K        PIC 999   VALUE ZERO.
           05 CLAV     PIC S9(12)V99.
           05 CLV1     PIC S9(12)V99.
           05 CLV2     PIC S9(12)V99.
           05 CLV3     PIC S9(12)V99.
           05 CLV4     PIC S9(12)V99.
           05 CLV1V    PIC S9(11)V99.
           05 CLV2V    PIC S9(11)V99.
           05 CONTO    PIC 9(7).
           05 CODICE   PIC 99.99.999.
           05 OLDCN    PIC 9(7).
           05 MCLI     PIC 99.
           05 MFOR     PIC 99.
           05 MOVAP1   PIC S9(12)V99.
           05 MOVAP2   PIC S9(12)V99.
           05 SALAP    PIC S9(12)V99.
           05 SALSP    PIC S9(12)V99.
           05 IVAVEN   PIC 9(7).
           05 IVASOS   PIC 9(7).
           05 IVAACQ   PIC 9(7).
           05 PRICO    PIC 9(7).
           05 ULTCO    PIC 9(7).
           05 CON1     PIC 9(7) VALUE ZERO.
           05 CON2     PIC 9(7) VALUE ZERO.
           05 CLF1     PIC 9(5) VALUE ZERO.
           05 CLF2     PIC 9(5) VALUE ZERO.
           05 PKDT1    PIC 9(5) COMP-3.
           05 PKDT2    PIC 9(5) COMP-3.
           05 PART     PIC 9(7).
           05 PR REDEFINES PART.
              10 MPAR PIC 99.
              10 MCLF PIC 9(5).
           05 KONCA   PIC 999.
           05 POSIZ   PIC 999.
           05 SDES1   PIC X(83).
           05 SDES2   PIC X(61).
           05 CONCAIN PIC X(36).
           05 CONCOUT PIC X(192).
           05 WDESK  REDEFINES CONCOUT PIC X(192).
           05 WDSK3  REDEFINES WDESK.
              10 WDSK31 PIC X(48).
              10 WDSK32 PIC X(48).
              10 WDSK33 PIC X(48).
              10 WDSK34 PIC X(48).
           05 COMCOUT PIC X(192).
           05 WKEYMX PIC X(13).
           05 WKEYMV PIC X(13).
           05 WKEYPC PIC X(10).
           05 SW     PIC 9      VALUE ZERO.
           05 SWTES  PIC 9      VALUE ZERO.
           05 DARAP  PIC S9(12)V99 VALUE ZERO.
           05 AVEAP  PIC S9(12)V99 VALUE ZERO.
           05 DARPR  PIC S9(12)V99 VALUE ZERO.
           05 AVEPR  PIC S9(12)V99 VALUE ZERO.
           05 PIVA   PIC 9(11)  VALUE ZERO.
           05 PIVX   REDEFINES PIVA PIC X(11).
           05 COMEURO PIC 9(3).
      **** rel 6.2
           05 TIPFIL   PIC 9.
      *       tipfile: 1=movime/movmol
      *                2=movmxx/movoxx
      *                3=movsez/movsol
      *                4=movsxx/mosoxx
      ************

           COPY 'vcon210.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-TPSCH     PIC 9.
           05 IF-CDCON-1   PIC 9(7).
           05 IF-CDCON-2   PIC 9(7).
           05 IF-CDCLF-1   PIC 9(5).
           05 IF-CDCLF-2   PIC 9(5).
           05 IF-DTMOV-1   PIC 9(6).
           05 IF-DTMOV-2   PIC 9(6).
           05 IF-FLPRO     PIC 9.
           05 IF-FLNREG    PIC 9.
           05 IF-FLVAL     PIC 9.
           05 IF-FLPRE     PIC 9.
           05 IF-LIREUR    PIC 9.
      **** rel 6.2
           05 IF-TPORD     PIC 9.
           05 IF-FLGATT    PIC 9.
      ************

      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dclmsz'.
           COPY 'dclmvx'.
           COPY 'dclmsx'.
           COPY 'dcltab'.
      **** rel 6.2
           COPY 'dcllav'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon210: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE ANACON.
           CLOSE ANACLF.
           CLOSE ANACOL.
           CLOSE ANACFX.
      **** rel 6.2
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'grimszer'.
           COPY 'grimvxer'.
           COPY 'grimsxer'.
           COPY 'gricoler'.
           COPY 'gricfxer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'anaclf' TO ID-CLF
                           MOVE 'anacon' TO ID-CON
                           MOVE 'movmxx' TO ID-MVX
                           MOVE 'movsxx' TO ID-MSX
                           MOVE 'movime' TO ID-MOV
                           MOVE 'movsez' TO ID-MSZ
           ELSE
                           MOVE 'anazol' TO ID-AZI
                           MOVE 'tabold' TO ID-TAB
                           MOVE 'anacfx' TO ID-CLF
                           MOVE 'anacol' TO ID-CON
                           MOVE 'movoxx' TO ID-MVX
                           MOVE 'mosoxx' TO ID-MSX
                           MOVE 'movmol' TO ID-MOV
                           MOVE 'movsol' TO ID-MSZ.
      *
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT ANACON.
           OPEN INPUT ANACLF.
           OPEN INPUT ANACOL.
           OPEN INPUT ANACFX.
      **** rel 6.2
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O   WDSLAV.
      ************
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-CIVAV TO IVAVEN.
           MOVE T01-CIVSO TO IVASOS.
           MOVE T01-CIVAQ TO IVAACQ.
           MOVE T01-MCLI  TO MCLI.
           MOVE T01-MFOR  TO MFOR.
      *
      **** rel 6.3
           MOVE 20 TO KTB-TIP.
           MOVE 1  TO KTB-COD.
           READ TABELL INTO RKTB20 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.
      ************
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           CALL 'rveur' USING COMEURO.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.

      **** rel 7.1
      *    ACCEPT GGMMAA FROM DATE.
      *    MOVE GG9 TO AAGGG.
      *    MOVE AA9 TO GG9.
      *    MOVE AAGGG TO AA9.
      *    MOVE GGMMAA TO IF-DTMOV-2.
      *    MOVE 1 TO GG9.
      *    MOVE GGMMAA TO IF-DTMOV-1.
           IF IF-FL = ZERO
              ACCEPT GGMMAA FROM DATE
              MOVE GG9 TO AAGGG
              MOVE AA9 TO GG9
              MOVE AAGGG TO AA9
              MOVE GGMMAA TO IF-DTMOV-2
              MOVE 1 TO GG9
              MOVE GGMMAA TO IF-DTMOV-1
           ELSE
              MOVE AZI-DTAPE TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GGMMAA TO IF-DTMOV-1
              MOVE 31 TO GG9
              MOVE 12 TO MM9
              MOVE GGMMAA TO IF-DTMOV-2.
      ************

           MOVE ZERO TO IF-TPSCH
                        IF-CDCON-1
                        IF-CDCLF-1
                        IF-FLPRO
                        IF-FLNREG
                        IF-FLVAL
                        IF-LIREUR
                        IF-FLPRE.
      **** rel 6.2
           MOVE ZERO TO IF-TPORD
                        IF-FLGATT.
      ************

           MOVE 9999999 TO IF-CDCON-2.
           MOVE 99999   TO IF-CDCLF-2.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-CDCON-2.
           MOVE 'IF-CDCON-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDCON-2.
           IF IF-CDCON-2 < IF-CDCON-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-CDCON-2.
      *
       V-CDCLF-2.
           MOVE 'IF-CDCLF-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDCLF-2.
           IF IF-CDCLF-2 < IF-CDCLF-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-CDCLF-2.
      *
       V-DTMOV-1.
           MOVE 'IF-DTMOV-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTMOV-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTMOV-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT1.
           IF AAGGG < AZI-DTAPE
              MOVE "Data inferiore alla data apertura" TO MESS
              GO TO V-ERROR.
       E-DTMOV-1.
      *
       V-DTMOV-2.
           MOVE 'IF-DTMOV-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTMOV-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTMOV-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT2.
           IF PKDT2 < PKDT1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DTMOV-2.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           IF IF-TPSCH = ZERO MOVE IF-CDCON-1 TO PRICO
                              MOVE IF-CDCON-2 TO ULTCO
                              GO TO L050.

           IF IF-TPSCH = 1 MOVE MCLI TO MPAR
           ELSE            MOVE MFOR TO MPAR.

           MOVE IF-CDCLF-1 TO MCLF.
           MOVE PART       TO PRICO.

           MOVE IF-CDCLF-2 TO MCLF.
           MOVE PART       TO ULTCO.
       L050.
           MOVE ZERO TO XCRR.
           MOVE PKDT1 TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DATAS1.

           MOVE PKDT2 TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DATAST.

           MOVE KAZ-COD TO KPC-AZI.
           MOVE AZI-RGSOC TO INTEAZ.
           MOVE AZI-CFISC TO CDFISC.

           MOVE 2 TO TIPOP1.
           MOVE ZERO TO OLDCN.
      *
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 56      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 1       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'SCHEDA CONTABILE DAL ' DATAS1(1:8) ' AL ' DATAST
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG3-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
      *
           OPEN INPUT MOVMXX.
           OPEN INPUT MOVSXX.
           OPEN INPUT MOVIME.
           OPEN INPUT MOVSEZ.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE PRICO   TO KPC-COD.
           IF IF-TPSCH = ZERO
                START ANACON KEY NOT < KEYPC INVALID GO TO A90
           ELSE MOVE KEYPC TO KEYCF
                START ANACLF KEY NOT < KEYCF INVALID GO TO A90.
       A00.
      *
           COPY 'grirpt-r'.
      *
           MOVE ZERO TO SWTES.
           IF IF-TPSCH = ZERO
                READ ANACON NEXT INTO REKCON AT END GO TO A90
           ELSE READ ANACLF NEXT INTO REKCLF AT END GO TO A90.
           IF IF-TPSCH > ZERO MOVE KEYCF TO KEYPC.
           IF KPC-AZI > KAZ-COD GO TO A90.
           MOVE KPC-COD TO CONTO.
           IF CONTO > ULTCO GO TO A90.
           IF PKDT1 NOT > AZI-RVDT GO TO A10.
           GO TO A50.
       A10.
           MOVE ZERO TO SW.
           MOVE KAZ-COD TO KMX-AZI.
           MOVE CONTO TO KMX-CON.
           MOVE PKDT1 TO KMX-DAT.
           MOVE ZERO TO KMX-NUM.
           IF IF-TPSCH = ZERO
                START MOVMXX KEY NOT < KEYMX INVALID GO TO A50
           ELSE MOVE KEYMX TO KEYSX
                START MOVSXX KEY NOT < KEYSX INVALID GO TO A50.
       A20.
           IF IF-TPSCH = ZERO
                READ MOVMXX NEXT INTO REKMOV AT END GO TO A50
           ELSE READ MOVSXX NEXT INTO REKMOV AT END GO TO A50.
           IF IF-TPSCH > ZERO MOVE KEYSX TO KEYMX.
           IF KMX-AZI > KAZ-COD GO TO A50.
           IF KMX-CON > CONTO   GO TO A50.
           IF KMX-DAT > PKDT2   GO TO A50.
           MOVE KEYMX TO WKEYMX.
           MOVE SPACE TO WKEYMV.
           IF CONTO NOT = IVAVEN AND CONTO NOT = IVAACQ
      **** rel 6.2
      *                          AND CONTO NOT = IVASOS GO TO SOTTO.
                                 AND CONTO NOT = IVASOS GO TO A21.
      ************
           IF MOV-IMPO = ZERO GO TO A20.
      **** rel 6.2
       A21.
           MOVE 2 TO TIPFIL.
           PERFORM WR-LAV THRU EX-WR-LAV.
           GO TO A20.
      *    GO TO SOTTO.
      ************
       A50.
           MOVE 1 TO SW.
           MOVE KAZ-COD TO KMV-AZI.
           MOVE CONTO TO KMV-CON.
           MOVE PKDT1 TO KMV-DAT.
           MOVE ZERO TO KMV-NUM.
           IF IF-TPSCH = ZERO
      **** rel 6.2
      *         START MOVIME KEY NOT < KEYMV INVALID GO TO A00
                START MOVIME KEY NOT < KEYMV INVALID GO TO A99
      ************
           ELSE MOVE KEYMV TO KEYMS
      **** rel 6.2
      *         START MOVSEZ KEY NOT < KEYMS INVALID GO TO A00.
                START MOVSEZ KEY NOT < KEYMS INVALID GO TO A99.
      ************
       A60.
           IF IF-TPSCH = ZERO
      **** rel 6.2
      *         READ MOVIME NEXT INTO REKMOV AT END GO TO A00
                READ MOVIME NEXT INTO REKMOV AT END GO TO A99
      ************
      **** rel 6.2
      *    ELSE READ MOVSEZ NEXT INTO REKMOV AT END GO TO A00.
           ELSE READ MOVSEZ NEXT INTO REKMOV AT END GO TO A99.
      ************
           IF IF-TPSCH > ZERO MOVE KEYMS TO KEYMV.
      **** rel 6.2
      *    IF KMV-AZI > KAZ-COD GO TO A00.
      *    IF KMV-CON > CONTO   GO TO A00.
      *    IF KMV-DAT > PKDT2   GO TO A00.
           IF KMV-AZI > KAZ-COD GO TO A99.
           IF KMV-CON > CONTO   GO TO A99.
           IF KMV-DAT > PKDT2   GO TO A99.
      ************
           MOVE KEYMV TO WKEYMV.
           MOVE SPACE TO WKEYMX.
           IF CONTO NOT = IVAVEN AND CONTO NOT = IVAACQ
      **** rel 6.2
      *                          AND CONTO NOT = IVASOS GO TO SOTTO.
                                 AND CONTO NOT = IVASOS GO TO A61.
      ************
           IF MOV-IMPO = ZERO GO TO A60.
      **** rel 6.2
       A61.
           MOVE 1 TO TIPFIL.
           PERFORM WR-LAV THRU EX-WR-LAV.
           GO TO A60.
      ************
      **** rel 6.2
       A99.
      **** rel 6.2
           MOVE LOW-VALUE TO KEYLV.
           IF IF-TPORD = ZERO
              START WDSLAV KEY NOT < KEYLV INVALID KEY GO TO A00.
           IF IF-TPORD = 1
              START WDSLAV KEY NOT < SKEYLV1 INVALID KEY GO TO A00.
           IF IF-TPORD = 2
              START WDSLAV KEY NOT < SKEYLV2 INVALID KEY GO TO A00.
           IF IF-TPORD = 3
              START WDSLAV KEY NOT < SKEYLV3 INVALID KEY GO TO A00.
      *
       RD-LAV.
           READ WDSLAV NEXT AT END GO TO A00.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO RD-LAV.
      *
           IF IF-TPSCH = ZERO
              IF KLV-ESER NOT = ZERO
                 MOVE LAV-KEY TO KEYMV WKEYMV
                 READ MOVIME INVALID PERFORM INVK-MOV
                                     GO TO ERRIO
                 END-READ
                 MOVE RF-MOV TO REKMOV
              ELSE
                 MOVE LAV-KEY TO KEYMX WKEYMX
                 READ MOVMXX INVALID PERFORM INVK-MVX
                                     GO TO ERRIO
                 END-READ
                 MOVE RF-MVX TO REKMOV.
      *
           IF IF-TPSCH NOT = ZERO
              IF KLV-ESER NOT = ZERO
                 MOVE LAV-KEY   TO KEYMS WKEYMV
                 READ MOVSEZ INVALID PERFORM INVK-MSZ
                                     GO TO ERRIO
                 END-READ
                 MOVE RF-MSZ TO REKMOV
              ELSE
                 MOVE LAV-KEY   TO KEYSX WKEYMX
                 READ MOVSXX INVALID PERFORM INVK-MSX
                                     GO TO ERRIO
                 END-READ
                 MOVE RF-MSX TO REKMOV.
      *
           DELETE WDSLAV.
      ************
       SOTTO.
           PERFORM RNWC THRU EX-RNWC.
           MOVE SPACE TO WDESK.
           MOVE SPACE TO SDES1.
           MOVE SPACE TO SDES2.
           MOVE MOV-DAT TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RG1.

           MOVE ZERO TO K.
           IF MOV-PART = ZERO GO TO EX0.
           IF MOV-PART = MOV-CON GO TO EX0.
           IF MOV-PART = 9999999 GO TO EX0.
           MOVE KEYPC TO WKEYPC.
           MOVE MOV-PART TO PART.

           MOVE 2 TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
              PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.

           IF IF-TPSCH > ZERO GO TO RCC.
           IF T02-TIPRG = 1 GO TO RCC.
           IF MPAR = MCLI OR MFOR GO TO RCF.
       RCC.
           MOVE PART TO KPC-COD CODICE.
           READ ANACON INVALID MOVE SPACE TO CON-DSC.
           MOVE CON-DSC TO WDESK.
           GO TO LK00.
       RCF.
           MOVE KAZ-COD TO KCF-AZI.
           MOVE PART TO KCF-COD CODICE.
           READ ANACLF INVALID MOVE SPACE TO CLF-RGS CLF-RGS2.
           MOVE CLF-RGS TO WDESK.
           MOVE CLF-RGS2 TO CONCAIN.
           PERFORM CONCATENA.
       LK00.
           STRING CODICE ' ' WDESK DELIMITED SIZE INTO SDES1.
           MOVE WKEYPC TO KEYPC KEYCF.
           IF IF-TPSCH = ZERO READ ANACON INTO REKCON INVALID
                       PERFORM INVK-CON GO TO ERRIO
           ELSE READ ANACLF INTO REKCLF INVALID
                       PERFORM INVK-CLF GO TO ERRIO.
       EX0.
           MOVE 2 TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
              PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO CONCAIN.
           STRING KTB-COD ' ' TAB-DESCR DELIMITED SIZE INTO SDES2.
           PERFORM CONCATENA.
           IF MOV-FLAG NOT = ZERO
              MOVE MOV-DSAGG TO CONCAIN
              PERFORM CONCATENA
              MOVE 1 TO KONCA
              PERFORM UNTIL SDES2(KONCA:) = SPACE
                 ADD 1 TO KONCA
              END-PERFORM
              IF MOV-DSAGG NOT = SPACE
                 STRING ' - ' MOV-DSAGG DELIMITED SIZE
                                        INTO SDES2(KONCA + 1:).

           PERFORM ALLINEA.
           MOVE WDSK31 TO ERGA.

           IF WDSK32 = SPACE GO TO EX31.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           MOVE WDSK32 TO ERGA.

           IF WDSK33 = SPACE GO TO EX31.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           MOVE WDSK33 TO ERGA.

           IF WDSK34 = SPACE GO TO EX31.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           MOVE WDSK34 TO ERGA.
       EX31.
           MOVE MOV-DAT TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RDMV.
           MOVE SDES1 TO RDES1V.
           MOVE SDES2 TO RDES2V.
           IF MOV-NPRGI NOT = ZERO
              IF MOV-TREG = 3
                 MOVE MOV-NPRGI TO RIG3A
              ELSE
                 IF MOV-NPRGI NOT = MOV-NDOC
                    MOVE MOV-NPRGI TO RIG3A.

           MOVE SPACE TO GBMMBA.
           IF MOV-DTDOC NOT = ZERO
                MOVE MOV-DTDOC TO AAGGG
                CALL 'rdata' USING PARCDT.
           MOVE MOV-NDOC TO RIG3B.
           MOVE GBMMBA TO RIG3C.
           MOVE ZERO TO CLV1 CLV2.
           IF MOV-D-A = 'D' MOVE MOV-IMPO TO CLV1.
           IF MOV-D-A = 'A' MOVE MOV-IMPO TO CLV2.
           MOVE CLV1 TO RIG3D.
      **** rel 6.1
      *    ADD CLV1  TO CLAV.
      ************
           MOVE CLV2 TO RIG3E.
           IF IF-FLPRO = 1
      **** rel 6.1
              ADD CLV1  TO CLAV
      ************
              SUBTRACT CLV2 FROM CLAV
              MOVE CLAV TO RIG3F.
           IF MOV-CAUS > 899 AND < 951 ADD CLV1 TO MOVAP1
                                       ADD CLV2 TO MOVAP2
            ELSE ADD CLV1 TO CLV3
                 ADD CLV2 TO CLV4.
           MOVE MOV-CCOST TO RICOST.
           IF IF-FLNREG NOT = ZERO AND MOV-NREG NOT = ZERO
               MOVE MOV-NREG TO RINREG.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
      *----------------
           MOVE ZERO TO CLV1 CLV2.
           MOVE ZERO TO CLV1V CLV2V.
           IF IF-FLVAL = ZERO GO TO NOVAL.
           IF (MOV-VALUT = ZERO OR COMEURO) GO TO NOVAL.
           MOVE 10 TO KTB-TIP.
           MOVE MOV-VALUT TO KTB-COD.
           READ TABELL INTO RKTB10 INVALID MOVE ALL '*' TO T10-DSINT.
           MOVE T10-DSINT TO RIG4B.
           IF IF-FLPRO = ZERO MOVE MOV-CAMGG TO EC-CAMBIO
                              CALL 're2cam' USING EC-PAR
                              MOVE EC-XCAMBIO TO RIG4C.
           IF IF-FLPRO = 1    MOVE MOV-CAMGG TO RIG4CV.
           IF MOV-D-A = 'D' MOVE MOV-IMVAL TO RIG4DV
           ELSE             MOVE MOV-IMVAL TO RIG4EV.
           IF MOV-VALUT = 1
             IF MOV-D-A = 'D' MOVE MOV-IMVAL TO ERIG4D
             ELSE             MOVE MOV-IMVAL TO ERIG4E.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
       NOVAL.
      *----------------
      **** rel 6.2
      *    IF SW = ZERO GO TO A20
      *    ELSE GO TO A60.
           GO TO RD-LAV.
      ************
       A90.
           IF OLDCN > ZERO PERFORM RSTO THRU EX-RSTO.
           CLOSE MOVIME.
           CLOSE MOVSEZ.
           CLOSE MOVMXX.
           CLOSE MOVSXX.
      **** rel 6.2
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
      ************
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       RNWC.
           IF SWTES = 1 GO TO EX-RNWC
           ELSE MOVE 1 TO SWTES.
           IF OLDCN > ZERO PERFORM RSTO THRU EX-RSTO.
           MOVE ZERO TO XCRR.
           MOVE 1 TO RP-JMP.
      **** rel 6.2
           MOVE 1       TO NINT.
           MOVE SPACE   TO XTINT(2).
           MOVE SPACE   TO XTINT(3).
      ************
           MOVE SPACE TO RT02 RT030 RT031 RT040 RT041.
           MOVE 'COD.CONTO' TO RD01.
           IF IF-TPSCH = 1 MOVE 'CLIENTE' TO RD01.
           IF IF-TPSCH = 2 MOVE 'FORNITORE' TO RD01.
      **** rel 6.2
           MOVE SPACE TO TRT02 TRT030 TRT031 TRT032.
           MOVE CONTO TO RT01 TRT01.
           IF IF-TPSCH > ZERO GO TO RCLF.
           MOVE CON-DESCR TO RT02 TRT02.
      *    MOVE CONTO TO RT01.
      *    IF IF-TPSCH > ZERO GO TO RCLF.
      *    MOVE CON-DESCR TO RT02.
      ************
           MOVE ZERO TO COL-SESP.
           IF IF-FLPRE = ZERO GO TO EX-RD.
           IF CON-TIPO = 'E' GO TO EX-RD.
           MOVE KEYPC TO KEYCL.
           READ ANACOL INTO REKCOL INVALID GO TO EX-RD.
           IF SF-COL = '9D' OR '9A' OR '35' MOVE RF-COL TO REKCOL.
           COMPUTE COL-SESP = COL-SESP + COL-SE-D - COL-SE-A.
           GO TO EX-RD.
       RCLF.
           MOVE CLF-SESP TO CON-SESP.
           MOVE CLF-SPSP TO CON-SPSP.
           MOVE CLF-SE-D TO CON-SE-D.
           MOVE CLF-SE-A TO CON-SE-A.
           MOVE CLF-SP-D TO CON-SP-D.
           MOVE CLF-SP-A TO CON-SP-A.
           MOVE CLF-RGSOC TO RT02.
           MOVE 'P.IVA'   TO RT030.
           MOVE 'C.FISC.' TO RT040.
      **** rel 6.2
           MOVE CLF-RGSOC TO TRT02.
           MOVE 'P.IVA'   TO TRT030.
      ************
           MOVE CLF-PIVA TO PIVA.
           MOVE PIVX TO RT031.
           IF CLF-CFP NOT = PIVX MOVE CLF-CFISC TO RT041.
           IF CLF-CFP = PIVX MOVE SPACE TO RT041.
      **** rel 6.2
           MOVE PIVX TO TRT031.
           IF CLF-CFP NOT = PIVX MOVE CLF-CFISC TO TRT032.
           IF CLF-CFP = PIVX MOVE SPACE TO TRT032.
      ************
      *-- inizializza parametri per stampa report --*
           MOVE SPACE TO RP-TIT2.
           STRING RD01 '  ' RT01 '  ' RT02
                  DELIMITED SIZE INTO RP-TIT2.
      *---------------------------------------------*
      **** rel 6.2
           MOVE C-TINT1 TO XTINT(1).
           MOVE 1       TO RP-FLGR.
      ************
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE CLF-RGSOC2 TO RT02.
           IF RT02 NOT = SPACE
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
      *
           MOVE CLF-INDIR TO RT02.
           IF RT02 NOT = SPACE
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
      *
           MOVE CLF-INDIR2 TO RT02.
           IF RT02 NOT = SPACE
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
      *
           STRING CLF-CAP ' ' CLF-CITTA DELIMITED SIZE INTO RT02.
           IF RT02 NOT = SPACE
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
      *
           MOVE ZERO TO COL-SESP.
           IF IF-FLPRE = ZERO GO TO EX-RD2.
           MOVE KEYCF TO KEYCX.
           READ ANACFX INTO REKCLF INVALID GO TO EX-RD2.
           COMPUTE COL-SESP = CLF-SESP + CLF-SE-D - CLF-SE-A.
           GO TO EX-RD2.
       EX-RD.
      *-- inizializza parametri per stampa report --*
           MOVE SPACE TO RP-TIT2.
           STRING RD01 '  ' RT01 '  ' RT02
                  DELIMITED SIZE INTO RP-TIT2.
      *---------------------------------------------*
      **** rel 6.2
           MOVE C-TINT1 TO XTINT(1).
           MOVE 1       TO RP-FLGR.
      ************

           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
       EX-RD2.
           MOVE CONTO TO OLDCN.
           MOVE ZERO TO CLAV SALSP SALAP.
           MOVE ZERO TO DARAP AVEAP DARPR AVEPR.
...
           MOVE CLAV TO RTA RTD.
           MOVE KAZ-COD TO KMX-AZI KMV-AZI.
           MOVE CONTO   TO KMX-CON KMV-CON.
           IF PKDT1 NOT > AZI-RVDT
                     MOVE AZI-DTAPE TO KMX-DAT GO TO R03.
           GO TO R20.
       R03.
           MOVE ZERO TO KMX-NUM.
           IF IF-TPSCH = ZERO
              START MOVMXX KEY NOT < KEYMX INVALID GO TO R30
           ELSE MOVE KEYMX TO KEYSX
              START MOVSXX KEY NOT < KEYSX INVALID GO TO R30.
       R05.
           IF IF-TPSCH = ZERO
              READ MOVMXX NEXT INTO REKMOV AT END GO TO R30
           ELSE READ MOVSXX NEXT INTO REKMOV AT END GO TO R30.
           IF IF-TPSCH > ZERO MOVE KEYSX TO KEYMX.
           IF KMX-AZI > KAZ-COD GO TO R30.
           IF KMX-CON > CONTO GO TO R30.
           IF KMX-DAT NOT < PKDT1 GO TO R30.
           IF MOV-CAUS > 899 AND < 951
               IF MOV-D-A = 'D' ADD MOV-IMPO TO SALAP
                                ADD MOV-IMPO TO DARAP
                                ADD MOV-IMPO TO CLAV GO TO R05
               ELSE             SUBTRACT MOV-IMPO FROM SALAP
                                ADD MOV-IMPO TO AVEAP
                                SUBTRACT MOV-IMPO FROM CLAV GO TO R05.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO SALSP
                            ADD MOV-IMPO TO DARPR
                            ADD MOV-IMPO TO CLAV
           ELSE        SUBTRACT MOV-IMPO FROM SALSP
                       ADD MOV-IMPO TO AVEPR
                       SUBTRACT MOV-IMPO FROM CLAV.
           GO TO R05.
       R20.
           SUBTRACT CON-SESP FROM CON-SPSP GIVING SALSP.
           MOVE CON-SESP TO SALAP.
           MOVE CON-SPSP TO CLAV.
           MOVE CON-SE-D TO DARPR.
           SUBTRACT CON-SP-D FROM DARPR.
           MOVE CON-SE-A TO AVEPR.
           SUBTRACT CON-SP-A FROM AVEPR.
           MOVE AZI-RVDT TO KMV-DAT.
           MOVE ZERO TO KMV-NUM.
           IF IF-TPSCH = ZERO
              START MOVIME KEY NOT < KEYMV INVALID GO TO R30
           ELSE MOVE KEYMV TO KEYMS
              START MOVSEZ KEY NOT < KEYMS INVALID GO TO R30.
       R25.
           IF IF-TPSCH = ZERO
                READ MOVIME NEXT INTO REKMOV AT END GO TO R30
           ELSE READ MOVSEZ NEXT INTO REKMOV AT END GO TO R30.
           IF IF-TPSCH > ZERO MOVE KEYMS TO KEYMV.
           IF KMV-AZI > KAZ-COD GO TO R30.
           IF KMV-CON > CONTO GO TO R30.
           IF KMV-DAT NOT < PKDT1 GO TO R30.
           IF MOV-CAUS > 899 AND < 951
               IF MOV-D-A = 'D' ADD MOV-IMPO TO SALAP
                                ADD MOV-IMPO TO DARAP
                                ADD MOV-IMPO TO CLAV GO TO R25
               ELSE             SUBTRACT MOV-IMPO FROM SALAP
                                ADD MOV-IMPO TO AVEAP
                                SUBTRACT MOV-IMPO FROM CLAV GO TO R25.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO SALSP
                            ADD MOV-IMPO TO DARPR
                            ADD MOV-IMPO TO CLAV
           ELSE        SUBTRACT MOV-IMPO FROM SALSP
                       ADD MOV-IMPO TO AVEPR
                       SUBTRACT MOV-IMPO FROM CLAV.
           GO TO R25.
       R30.
           IF IF-FLPRE = 1 ADD COL-SESP TO SALAP CLAV
              IF COL-SESP > ZERO ADD COL-SESP TO DARAP
                            ELSE SUBTRACT COL-SESP FROM AVEAP.
           IF WKEYMX = SPACE GO TO R40.
           IF IF-TPSCH = ZERO MOVE WKEYMX TO KEYMX
                              READ MOVMXX INTO REKMOV INVALID
                              PERFORM INVK-MVX GO TO ERRIO
           ELSE MOVE WKEYMX TO KEYSX
                READ MOVSXX INTO REKMOV INVALID
                     PERFORM INVK-MSX GO TO ERRIO.
           GO TO R50.
       R40.
           IF IF-TPSCH = ZERO MOVE WKEYMV TO KEYMV
                              READ MOVIME INTO REKMOV INVALID
                              PERFORM INVK-MOV GO TO ERRIO
           ELSE MOVE WKEYMV TO KEYMS
                READ MOVSEZ INTO REKMOV INVALID
                     PERFORM INVK-MSZ GO TO ERRIO.
       R50.
           MOVE 'C.C' TO RT12 TRT12.
           IF IF-FLPRO = ZERO
              MOVE 'DARE           AVERE' TO RTB1 TRTB1
           ELSE
              MOVE 'DARE           AVERE           SALDO' TO RTB1 TRTB1.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
      *
      **** rel 6.2
           MOVE 3       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
           MOVE C-TINT3 TO XTINT(3).
      ************
      *
           IF IF-FLPRO = 1 GO TO R60.
           MOVE 2 TO XCRR.
           MOVE 'SALDO PRECEDENTE' TO RDEST.
           IF SALSP > ZERO MOVE SALSP TO RTD
           ELSE MULTIPLY -1 BY SALSP GIVING RTA.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 2 TO XCRR.
           MOVE 'SALDO APERTURA  ' TO RDEST.
           IF SALAP > ZERO MOVE SALAP TO RTD
           ELSE MULTIPLY -1 BY SALAP GIVING RTA.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           GO TO BYSP.
       R60.
           MOVE 2 TO XCRR.
           MOVE 'MOVIMENTI PRECEDENTI' TO RDEST.
           MOVE DARPR TO RTD.
           MOVE AVEPR TO RTA
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           MOVE 'MOVIMENTO APERTURA  ' TO RDEST.
           MOVE DARAP TO RTD
           MOVE AVEAP TO RTA.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'SALDO PRECEDENTE' TO RDEST.
           MOVE CLAV TO RTS.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
       BYSP.
           MOVE 2 TO XCRR.
           MOVE ZERO TO CLV3 CLV4 MOVAP1 MOVAP2.
       EX-RNWC.
           EXIT.
      *-------------*
       RSTO.
           MOVE 2 TO XCRR.
           MOVE SPACE TO RIGA.
       LPGU.
           IF IF-FLPRO = ZERO
              ADD CLV3 TO CLAV
              SUBTRACT CLV4 FROM CLAV
              ADD MOVAP1 TO CLAV
              SUBTRACT MOVAP2 FROM CLAV.
           MOVE 'TOTALE MOVIMENTI' TO RDEST.
           MOVE CLV3 TO RTD.
           MOVE CLV4 TO RTA.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'TOTALE MOVIMENTI APERTURA' TO RDEST.
           MOVE MOVAP1 TO RTD.
           MOVE MOVAP2 TO RTA.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'SALDO CONTO' TO RDEST.
           IF IF-FLPRO = 1
              MOVE CLAV TO RTS.
           IF IF-FLPRO = ZERO
              IF CLAV > ZERO
                   MOVE CLAV TO RTD
              ELSE
                 MULTIPLY -1 BY CLAV
                 MOVE CLAV TO RTA
                 MULTIPLY -1 BY CLAV.
       BYSTO.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
       BYST1.
       EX-RSTO.
           EXIT.
      * ---------------- *
       CONCATENA.
           PERFORM VARYING KONCA FROM 192 BY -1
                   UNTIL CONCOUT(KONCA:1) NOT = SPACE OR KONCA = ZERO
                   CONTINUE.
           IF KONCA > ZERO ADD 1 TO KONCA.
           ADD 1 TO KONCA.
           IF KONCA NOT > 192 MOVE CONCAIN TO CONCOUT(KONCA:).
      * ---------------- *
       ALLINEA.
           MOVE 48 TO POSIZ.
           PERFORM SPEZZA THRU EX-SPEZZA.
           MOVE 96 TO POSIZ.
           PERFORM SPEZZA THRU EX-SPEZZA.
           MOVE 144 TO POSIZ.
           PERFORM SPEZZA THRU EX-SPEZZA.
      * ---------------- *
       SPEZZA.
           IF CONCOUT(POSIZ + 1:) = SPACE GO TO EX-SPEZZA.
           IF CONCOUT(POSIZ + 1:1) NOT = SPACE GO TO SPEZZA-10.
           ADD 1 TO POSIZ.
           PERFORM VARYING KONCA FROM POSIZ BY 1
                   UNTIL CONCOUT(KONCA:1) NOT = SPACE
                   CONTINUE.
           SUBTRACT 1 FROM POSIZ.
           MOVE CONCOUT(1:POSIZ) TO COMCOUT.
           MOVE CONCOUT(KONCA:) TO COMCOUT(POSIZ + 1:).
           MOVE COMCOUT TO CONCOUT.
           GO TO EX-SPEZZA.
       SPEZZA-10.
           IF CONCOUT(POSIZ:1) = SPACE GO TO EX-SPEZZA.
           PERFORM VARYING KONCA FROM POSIZ BY -1
                   UNTIL CONCOUT(KONCA:1) = SPACE OR KONCA = ZERO
                   CONTINUE.
           IF KONCA = ZERO GO TO EX-SPEZZA.
           MOVE CONCOUT(1:KONCA) TO COMCOUT.
           MOVE CONCOUT(KONCA + 1:) TO COMCOUT(POSIZ + 1:).
           MOVE COMCOUT TO CONCOUT.
       EX-SPEZZA.
           EXIT.
      * ---------------- *
       RPT-RIG3-INTC.
           MOVE 'RIG3' TO RP-BLK.
      *
           MOVE 'Data Reg.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Contropartita' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'C.C' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           IF IF-FLNREG NOT =  ZERO MOVE 'N.Reg' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Prg' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'N.Doc' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Data Doc.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Dare' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Avere' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           IF IF-FLPRO NOT =  ZERO MOVE 'Saldo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
      **** rel 6.2
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
      *    STRING 'w2' PID DELIMITED SPACE INTO ID-LAV.
      **** rel 6.3
      *    STRING 'w9' PID DELIMITED SPACE INTO ID-LAV.
           STRING 'wz' PID DELIMITED SPACE INTO ID-LAV.
      ************
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       WR-LAV.
           MOVE ZERO TO KEYLV.
           IF TIPFIL = 2 MOVE ZERO TO KLV-ESER
           ELSE          MOVE 1    TO KLV-ESER.
           MOVE MOV-DAT   TO KLV-DAT.
      *
           MOVE MOV-CATT  TO KLV-CATT.
           IF KLV-CATT = SPACE MOVE ZERO TO KLV-CATT.
      *
           IF IF-FLGATT = ZERO MOVE ZERO TO KLV-CATT.
      *
           MOVE MOV-NPRGI TO KLV-NPRGI.
           IF KLV-NPRGI = ZERO MOVE HIGH-VALUE TO SKLV-NPRGI.
      *
           MOVE MOV-NREG  TO KLV-NREG.
      **** rel 6.3
           IF MOV-CAUS = (T20-CDCLC OR T20-CACLC OR T20-CDFOC OR 
                         T20-CAFOC OR T20-CDSOC OR T20-CASOC) AND 
                          KLV-NREG= ZERO
              MOVE 99999 TO KLV-NREG.
      ************
           MOVE MOV-NUM   TO KLV-NUM.
           MOVE MOV-KEYID TO LAV-KEY.
           WRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS
                                GO TO ERRIO.
       EX-WR-LAV.
           EXIT.
      *------------------
      ************
