      $SET LINKCOUNT"128"
       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON350.
      *
      * Subroutine di variazione registrazione.
      * Richiamato da VCON110
      * Carica aree in memoria, carica file di lavoro WDSLAV
      *        da passare a vcon110.
      *
      * La copy dell'area di lavoro del tabell
      * e' stata inserita con l'editor ed in
      * formato ridotto           
      *
      * Nota: il chiamante dopo la call deve testare
      *       errio-st distinguendo: 9 per errore bloccante 
      *                              8 per warning
      *                              4 per movimento non gestibile
      *
      **** rel 5.1
      * Ricompilato per copy parcon1 variata
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           COPY 'grimszsl'.
           COPY 'gripavsl'.
           COPY 'gritabsl'.
           SELECT WDS35A ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEY35A STATUS SF-35A.
           SELECT WDS35B ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEY35B STATUS SF-35B.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'griclf'.
           COPY 'grimov'.                                         
           COPY 'grimsz'.                                         
           COPY 'gritab'.
           COPY 'gripav'.
      *
       FD  WDS35A LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-35A
      **** rel 4.0
      *    RECORD 493 DATA RECORD RF-35A.
           RECORD 519 DATA RECORD RF-35A.
      ************
       01  RF-35A.
           05 KEY35A.
              10 K35A-PROG PIC 9(3).
           05 REC35A.
              10 L35A-IVA   PIC 9.
              10 L35A-CAUSA PIC 9(3).
              10 L35A-TIPRG PIC 9.
              10 L35A-DAVE  PIC X.
              10 L35A-SEGNO PIC 9.
              10 L35A-FLGIS PIC 9.
              10 L35A-TIPOP PIC 99.
              10 L35A-FLGSC PIC 9.
              10 L35A-SWAGG PIC 9.
              10 L35A-FLGEC PIC 9.
              10 L35A-DESAG PIC X(30).
              10 L35A-PART  PIC 9(7).
      **** rel 4.0
      *       10 L35A-IMPOR PIC S9(11) COMP-3.
              10 L35A-IMPOR PIC S9(11)V99 COMP-3.
      ************
              10 L35A-DOCUM PIC 9(5).
              10 L35A-DTDOC PIC 9(5) COMP-3.
              10 L35A-DTSCD PIC 9(5) COMP-3.
              10 L35A-VALUT PIC 999  COMP-3.
      **** rel 4.0
      *       10 L35A-CAMGG PIC 9999V999  COMP-3. 
              10 L35A-CAMGG PIC 9(5)V9(6) COMP-3. 
      ************
              10 L35A-IMVAL PIC S9(11)V99 COMP-3.
              10 L35A-CCOST PIC X(4).
      **** rel 4.0
      *       10 L35A-DFCAM PIC S9(11) COMP-3.
              10 L35A-DFCAM PIC S9(11)V99 COMP-3.
      ************
              10 L35A-CAUDF PIC 9(3).
              10 L35A-DAVDF PIC X.
              10 L35A-GECDF PIC 9.
           05 REC35A2.
              10 L35A-CPART PIC 9(7).
      **** rel 4.0
      *       10 L35A-IMPCP PIC S9(11) COMP-3.
              10 L35A-IMPCP PIC S9(11)V99 COMP-3.
      ************
              10 L35A-CAUS2 PIC 9(3).
              10 L35A-TIPR2 PIC 9.
              10 L35A-TIPO2 PIC 9.
              10 L35A-DTSC2 PIC 9(5) COMP-3.
              10 L35A-FLGS2 PIC 9.
              10 L35A-SWAG2 PIC 9.
              10 L35A-FLGE2 PIC 9.
              10 L35A-DESA2 PIC X(30).
              10 L35A-CCOS2 PIC X(4).
              10 L35A-CATT  PIC X.
              10 L35A-NPRGI PIC 9(5).
              10 L35A-CDIVA PIC 9(3).
      **** rel 4.0
      *       10 L35A-IMPON PIC S9(11) COMP-3.
      *       10 L35A-IMPOS PIC S9(11) COMP-3.
      *       10 L35A-INDED PIC S9(11) COMP-3.
              10 L35A-IMPON PIC S9(11)V99 COMP-3.
              10 L35A-IMPOS PIC S9(11)V99 COMP-3.
              10 L35A-INDED PIC S9(11)V99 COMP-3.
      ************
              10 L35A-ESVEN PIC 9.
              10 L35A-PLAFO.
                 15 L35A-PLAM PIC 99.
                 15 L35A-PLAN PIC 9.
           05 L35A-RCSCA.
              10 L35A-FLAG  PIC 9.
              10 L35A-CDPAG PIC 999.
              10 L35A-NRATE PIC 99.
              10 L35A-SCAD  OCCURS 12.
                 20 L35A-TPAG  PIC 9.
                 20 L35A-DTSCA PIC 9(5) COMP-3.
      **** rel 4.0
      *          20 L35A-IMRATA PIC S9(11) COMP-3.
                 20 L35A-IMRATA PIC S9(11)V99 COMP-3.
      ************
                 20 L35A-VALRATA PIC S9(11)V99 COMP-3.
           05 L35A-RCWSC.
                 10 L35A-WSC OCCURS 6.
                    15 L35A-WBDSC PIC 9(5) COMP-3.
      **** rel 4.0
      *             15 L35A-WBISC PIC S9(11) COMP-3.
                    15 L35A-WBISC PIC S9(11)V99 COMP-3.
      ************
                    15 L35A-WBVSC PIC S9(11)V99 COMP-3.
      *
       FD  WDS35B LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-35B
      **** rel 4.0
      *    RECORD 120 DATA RECORD RF-35B.
           RECORD 130 DATA RECORD RF-35B.
      ************
       01  RF-35B.
           05 KEY35B.
              10 K35B-AZI PIC 999.
              10 K35B-NUM PIC 9(5) COMP-3.
              10 K35B-DAT PIC 9(5) COMP-3.
              10 K35B-CON PIC 9(7) COMP-3.
           05 L35B-CAUS   PIC 999  COMP-3.
           05 L35B-D-A    PIC X.
           05 L35B-TREG   PIC 9.
      **** rel 4.0
      *    05 L35B-IMPO   PIC S9(11) COMP-3.
           05 L35B-IMPO   PIC S9(11)V99 COMP-3.
      ************
           05 L35B-NDOC   PIC 9(5) COMP-3.
           05 L35B-DTDOC  PIC 9(5) COMP-3.
           05 L35B-DTSCD  PIC 9(5) COMP-3.
           05 L35B-NPRGI  PIC 9(5) COMP-3.
           05 L35B-FLAG   PIC 9.
           05 L35B-DSAGG.
              10 L35B-IVA PIC 999.
              10 L35B-ACF PIC 9(7) COMP-3.
              10 L35B-TIP PIC 9.
      **** rel 4.0
      *       10 L35B-IMP PIC S9(11).
      *       10 L35B-IVN PIC S9(11).
              10 L35B-IMP PIC S9(11)V99.
              10 L35B-IVN PIC S9(11)V99.
      ************
           05 L35B-PART   PIC 9(7) COMP-3.
           05 L35B-NREG   PIC 9(5).
           05 L35B-CATT   PIC X.
           05 L35B-FEV    PIC 9.
           05 L35B-PLAF. 
              10 L35B-MES PIC 99.
              10 L35B-ANN PIC 9.
           05 L35B-VALUT  PIC 999.
      **** rel 4.0
      *    05 L35B-CAMGG  PIC 9999V999.
           05 L35B-CAMGG  PIC 9(5)V9(6).
      ************
           05 L35B-IMVAL  PIC S9(11)V99.
           05 L35B-CCOST  PIC X(4).
           05 L35B-TST    PIC 9.
      **** rel 4.0
      *    05 FILLER     PIC X(12).
           05 FILLER     PIC X(13).
      ************
      *
      * file di lavoro righi registrazione
      * viene scritto per l'utilizzo da vcon110
      *
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 600 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-PROGR PIC 9(3).
           05 RECLAV PIC X(597).
      *
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parcon1'.
           COPY 'parcos'.
           COPY 'griazirk'.
           COPY 'griconrk'.                                       
           COPY 'grit14g'.
      * TRACCIATI TABELLE *
       01  REKTAB.
           05 TAB-KEYID.
              10 TAB-TIP PIC 99.
              10 TAB-COD PIC 999.
           05 TAB-DESCR  PIC X(24) VALUE SPACE.
           05 FILLER     PIC X(43) VALUE ZERO.
       01  RKTB01 REDEFINES REKTAB.
           05 FILLER    PIC X(5).
           05 T01-CIVAV PIC 9(7).
           05 T01-CIVAQ PIC 9(7).
           05 T01-CRPCL PIC 9(7).
           05 T01-CRPC1 PIC 9(7).
           05 T01-CRPC2 PIC 9(7).
           05 T01-CRPFR PIC 9(7).
           05 T01-CRPF1 PIC 9(7).
           05 T01-CRPF2 PIC 9(7).
           05 T01-MCLI  PIC 99.
           05 T01-MFOR  PIC 99.
           05 T01-CIVSO PIC 9(7).
       01  RKTB02 REDEFINES REKTAB.
           05 FILLER    PIC X(29).
           05 T02-DAIVA PIC X(15).
           05 T02-TIPRG PIC 9.
           05 T02-D-A   PIC X.
           05 T02-TIPOP PIC 99.
           05 T02-SEGNO PIC 9.
           05 T02-CTRFT PIC 9.
           05 T02-CTRAC PIC 9.
           05 T02-CTRIN PIC 9.
           05 T02-ATTRN PIC 9.
           05 T02-DTSCO PIC 9.
           05 T02-FLRAG PIC 9.
           05 T02-FLVEN PIC 9.
           05 T02-FLGEC PIC 9.
           05 T02-FLGSC PIC 9.
           05 T02-FLGIS PIC 9.
           05 T02-FLDOC PIC 9.
           05 FILLER    PIC X(12).
       01  RKTB03 REDEFINES REKTAB.
           05 FILLER    PIC X(29).
           05 T03-DSIVA PIC X(4).
           05 T03-ALIVA PIC 999V99.
           05 T03-TPIVA PIC 9.
           05 T03-ULDET PIC 999V99.
           05 T03-ALVEN PIC 9(3).
           05 T03-ULDE2 PIC 999V99.
           05 T03-TSNSO PIC 9.
           05 T03-TSESE PIC 9.
           05 T03-TSFCA PIC 9.
           05 T03-TSACE PIC 9.
           05 T03-TSAUE PIC 9.
           05 T03-TSOPE PIC 99.
           05 T03-TSPLA PIC 9.
           05 T03-ALIV2 PIC 999V99.
           05 FILLER    PIC X(7).
       01  RKTB10 REDEFINES REKTAB.
           05 FILLER    PIC X(29).
           05 T10-DSINT PIC X(4).
      **** rel 4.0
      *    05 T10-COEFF PIC 9(4)V999.
      ************
      **** rel 1.2
      *    05 T10-COEFA PIC 9(4)V999.
      *    05 FILLER    PIC X(25).
           05 T10-FEURO  PIC 9.
           05 T10-DTEUR  PIC 9(5) COMP-3.
           05 T10-DTSCA  PIC 9(5) COMP-3.
           05 T10-ETASSO PIC 9(5)V9(6).
           05 T10-FSC    PIC 9.
      **** rel 4.0
      *    05 FILLER     PIC X(13).
           05 T10-NDFSC  PIC 9.
           05 T10-NDUNI  PIC 9.
           05 FILLER     PIC X(18).
      ************
      ************
       01  RKTB14 REDEFINES REKTAB.
           05 FILLER    PIC X(5).
           05 T14-RICAV PIC 9(7).
           05 T14-SPBOL PIC 9(7).
           05 T14-SPBAN PIC 9(7).
           05 T14-RIBAN PIC 9(7).
           05 T14-TRATT PIC 9(7).
           05 T14-FATT  PIC 999.
           05 T14-RB    PIC 999.
           05 T14-TRT   PIC 999.
           05 T14-IVABL PIC 999.
           05 T14-IVABA PIC 999.
           05 T14-CMAG  PIC 9.
           05 T14-CDCOR PIC 9(7).
           05 T14-FTRI  PIC 9.
           05 T14-COSTI PIC 9(7).
           05 FILLER    PIC X(1).
           COPY 'grit20rk'.
           COPY 'grit25rk'.
           COPY 'grit35rk'.
           COPY 'rekt23'.
           COPY 'grimovrk'.                                       
       01  REKTE14.
           05 FILLER   PIC X(5).
           05 T14IVER  PIC 9(7).
           05 T14RICO  PIC 9(7).
           05 T14GIIV  PIC 9(3).
           05 T14GICO  PIC 9(3).
           05 T14IDIR  PIC 9(3).
           05 T14ITRI  PIC 9(3).
           05 T14IIND  PIC 9(3).
           05 T14ISCV  PIC 9(3).
           05 T14IRSM  PIC 9(3).
           05 T14IASS  PIC 9(3).
           05 T14ISIN  PIC 9(3).
           05 T141ACQ  PIC 9(3).
           05 T141ACR  PIC 9(3).
           05 T141ACT  PIC 9(3).
           05 T142ACQ  PIC 9(3).
           05 T143ACQ  PIC 9(3).
           05 T14IPOS  PIC 9(3).
           05 FILLER   PIC X(8).
       01 ID-AZI  PIC X(15) VALUE 'anaazi'.
       01 ID-CON  PIC X(15) VALUE 'anacon'.
       01 ID-CLF  PIC X(15) VALUE 'anaclf'.
       01 ID-TAB  PIC X(15) VALUE 'tabell'.
       01 ID-MOV  PIC X(15) VALUE 'movime'.
       01 ID-MSZ  PIC X(15) VALUE 'movsez'.
       01 ID-PAV  PIC X(15) VALUE 'parval'.
       01 ID-35A  PIC X(15) VALUE 'wds35a'. 
       01 ID-35B  PIC X(15) VALUE 'wds35b'. 
       01 ID-LAV  PIC X(15) VALUE 'wdslav'. 
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-CON   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-MOV   PIC XX.
           05 SF-MSZ   PIC XX.
           05 SF-PAV   PIC XX.
           05 SF-35A   PIC XX.
           05 SF-35B   PIC XX.
           05 SF-LAV   PIC XX.
           05 K        PIC 99.
           05 L        PIC 99.
           05 MCLI     PIC 99.
           05 MFOR     PIC 99.
           05 ATTRN    PIC 9.
           05 FLMOV    PIC 9.
           05 DATRG    PIC 9(6).
           05 SAVKEY   PIC X(13).
           05 OLDCAU   PIC 9(3).
           05 OLDCON   PIC 9(7).
           05 OLDPRG   PIC 9(5).
           05 OLDDOC   PIC 9(5).
           05 OLDDTD   PIC 9(5) COMP-3.
           05 OLDDAV   PIC X.
           05 OLDCAT   PIC X.
           05 MESS     PIC X(40)  VALUE SPACE.
      **** rel 4.0
      *    05 DFCNT    PIC S9(11) VALUE ZERO.
      *    05 DFIVA    PIC S9(11) VALUE ZERO.
           05 DFCNT    PIC S9(11)V99 VALUE ZERO.
           05 DFIVA    PIC S9(11)V99 VALUE ZERO.
      ************
      **** rel 5.2
           05 DTMOV    PIC 9(5) VALUE ZERO.
      ************
           05 DTAIVA   PIC 9(5) VALUE ZERO.
           05 NURIV    PIC 9(3) VALUE ZERO.
           05 DATIVB   PIC X(8) VALUE SPACE.
           05 AGIVA    PIC 9    VALUE ZERO.
           05 DTMB     PIC X(8) VALUE ZERO.
           05 TIG      PIC 9    VALUE ZERO.
           05 TPL      PIC 9    VALUE ZERO.
           05 FLGCO    PIC 9    VALUE ZERO.
           05 FLGPL    PIC 9    VALUE ZERO.
           05 FLGIVA   PIC 9    VALUE ZERO.
           05 FLGCPA   PIC 9    VALUE ZERO.
           05 FLGLET   PIC 9    VALUE ZERO.
           05 SAVCAU   PIC 9(3) VALUE ZERO.
           05 SAVCON   PIC 9(7) VALUE ZERO.
           05 SAVPRG   PIC 9(5) VALUE ZERO.
           05 SAVDOC   PIC 9(5) VALUE ZERO.
           05 SAVDAV   PIC X    VALUE ZERO.
           05 ORIDAV   PIC X    VALUE ZERO.
           05 ORICAU   PIC 9(3) VALUE ZERO.
           05 ORISEG   PIC 9(3) VALUE ZERO.
           05 SAVCPA   PIC 9(7) VALUE ZERO.
           05 SAVCAT   PIC X    VALUE ZERO.
           05 NURIG    PIC 9(3) VALUE ZERO.
           05 CIVSO    PIC 9(7) VALUE ZERO.
           05 CRPCL    PIC 9(7) VALUE ZERO.
           05 CRPC1    PIC 9(7) VALUE ZERO.
           05 CRPC2    PIC 9(7) VALUE ZERO.
           05 CRPFR    PIC 9(7) VALUE ZERO.
           05 CRPF1    PIC 9(7) VALUE ZERO.
           05 CRPF2    PIC 9(7) VALUE ZERO.
           05 CCOR     PIC 9(7) VALUE ZERO. 
           05 TSSALC   PIC 9    VALUE ZERO.
           05 TSSCAU   PIC 9    VALUE ZERO.
           05 CASALC   PIC 9(3) VALUE ZERO.
           05 SAVDTD   PIC 9(5) COMP-3 VALUE ZERO.
      **** rel 3.0a
      * sw-cp: 1=caricato su vettore c/p della pagina IVA-C/P
      *        0=vettore c/p della pagina IVA-C/P pieno, c/p caricata 
      *          su nuovo rigo di primanota.
           05 SW-CP    PIC 9.
      *************
      **** rel 4.0
           05 COMEURO  PIC 9(3) VALUE ZERO.
      ************
           05 CODICE.
              10 MAS   PIC 99.
              10 CODCF PIC 9(5).
           05 DTP      PIC 9(4) VALUE ZERO.
           05 DTP6.
              10 MM6 PIC 99 VALUE ZERO.
              10 AA6.
                 15 AA61 PIC 99 VALUE ZERO.
                 15 AA62 PIC 99 VALUE ZERO.

       01  WRKLAV.
           05 PROGR     PIC 9(3).
           05 WCLAV.
              10 SWIVA  PIC 9.
              10 WCAUSA PIC 9(3).
              10 WTIPRG PIC 9.
              10 WDAVE  PIC X.
              10 WSEGNO PIC 9.
              10 WFLGIS PIC 9.
              10 WTIPOP PIC 99.
              10 WFLGSC PIC 9.
              10 WSWAGG PIC 9.
              10 WFLGEC PIC 9.
              10 WDESAG PIC X(30).
              10 WPART  PIC 9(7).
      **** rel 4.0
      *       10 WIMPOR PIC S9(11) COMP-3.
              10 WIMPOR PIC S9(11)V99 COMP-3.
      ************
              10 WDOCUM PIC 9(5).
              10 WDTDOC PIC 9(5) COMP-3.
              10 WDTSCD PIC 9(5) COMP-3.
              10 WVALUT PIC 999  COMP-3.
      **** rel 4.0
      *       10 WCAMGG PIC 9999V999  COMP-3. 
              10 WCAMGG PIC 9(5)V9(6) COMP-3. 
      ************
              10 WIMVAL PIC S9(11)V99 COMP-3.
              10 WCCOST PIC X(4).
      **** rel 4.0
      *       10 WDFCAM PIC S9(11) COMP-3.
              10 WDFCAM PIC S9(11)V99 COMP-3.
      ************
              10 WCAUDF PIC 9(3).
              10 WDAVDF PIC X.
              10 WGECDF PIC 9.
           05 WCLA2.
              10 WCPART PIC 9(7).
      **** rel 4.0
      *       10 WIMPCP PIC S9(11) COMP-3.
              10 WIMPCP PIC S9(11)V99 COMP-3.
      ************
              10 WCAUS2 PIC 9(3).
              10 WTIPR2 PIC 9.
              10 WTIPO2 PIC 9.
              10 WDTSC2 PIC 9(5) COMP-3.
              10 WFLGS2 PIC 9.
              10 WSWAG2 PIC 9.
              10 WFLGE2 PIC 9.
              10 WDESA2 PIC X(30).
              10 WCCOS2 PIC X(4).
              10 WCATT  PIC X.
              10 WNPRGI PIC 9(5).
              10 WCDIVA PIC 9(3).
      **** rel 4.0
      *       10 WIMPON PIC S9(11) COMP-3.
      *       10 WIMPOS PIC S9(11) COMP-3.
      *       10 WINDED PIC S9(11) COMP-3.
              10 WIMPON PIC S9(11)V99 COMP-3.
              10 WIMPOS PIC S9(11)V99 COMP-3.
              10 WINDED PIC S9(11)V99 COMP-3.
      ************
              10 WESVEN PIC 9.
              10 WPLAFO.
                 15 WPLAM PIC 99.
                 15 WPLAN PIC 9.
          05  WRKSCA.
              10 WFLAG  PIC 9.
              10 WCDPAG PIC 999.
              10 WNRATE PIC 99.
              10 WSCAD  OCCURS 12.
                 15 WTPAG  PIC 9.
                 15 WDTSCA PIC 9(5) COMP-3.
      **** rel 4.0
      *          15 WIMRATA PIC S9(11) COMP-3.
                 15 WIMRATA PIC S9(11)V99 COMP-3.
      ************
                 15 WVALRATA PIC S9(11)V99 COMP-3.
      **** rel 6.2
                 15 WNOTE    PIC XX.
                 15 WNOTEA   PIC X(30).
      ************
          05  WSCDD.
              10 WSC OCCURS 6.
                 15 WBDSC  PIC 9(5) COMP-3.
      **** rel 4.0
      *          15 WBISC  PIC S9(11) COMP-3. 
                 15 WBISC  PIC S9(11)V99 COMP-3. 
      ************
                 15 WBVSC  PIC S9(11)V99 COMP-3. 
       LINKAGE SECTION.
       COPY 'parcon'.
      * aree salvataggio impostazioni di base registrazione (rigo 1)
      * significative solo per tipo registrazione = 1/2
      * viene poi passato a vcon110
       01  PARLINK-350-PRG1.
           05 TIPRG-350 PIC 9.
           05 CAUS-350  PIC 999.
           05 ATTRN-350 PIC 9.
           05 FLGIS-350 PIC 9.
      **** rel 5.0
           05 AGIVA-350 PIC 9.
      ************
       PROCEDURE DIVISION USING IF-CTRL IF-AREA-IVA IF-AREA-CPAR
                                PARLINK-350-PRG1.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dclmsz'.
           COPY 'dcltab'.
           COPY 'dclpav'.
      *
           COPY 'gridcl' REPLACING ==(SIGLA)== BY ==35A==
                                   ==NFILE== BY ==WDS35A==
                                   =='nfile'== BY =='wds35a'==.
      *
           COPY 'gridcl' REPLACING ==(SIGLA)== BY ==35B==
                                   ==NFILE== BY ==WDS35B==
                                   =='nfile'== BY =='wds35b'==.
      *
           COPY 'dcllav'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.
      **** rel 4.0
            CALL 'rveur' USING COMEURO.
      ************
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDS35A WDS35B WDSLAV.
           CLOSE WDS35A WDS35B WDSLAV.
           OPEN I-O WDS35A WDS35B WDSLAV.
           IF IF-FL = ZERO 
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              MOVE 'anacon' TO ID-CON
              MOVE 'anaclf' TO ID-CLF
              MOVE 'movime' TO ID-MOV
              MOVE 'movsez' TO ID-MSZ
           ELSE 
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'anacol' TO ID-CON
              MOVE 'anacfx' TO ID-CLF
              MOVE 'movmol' TO ID-MOV
              MOVE 'movsol' TO ID-MSZ.
      *
           OPEN INPUT ANAAZI
                      ANACON
                      ANACLF
                      MOVIME
                      MOVSEZ
                      PARVAL
                      TABELL.
      *
           IF IF-NREG = ZERO
              PERFORM ERR-ZERO
              MOVE 4 TO ERRIO-ST
              GO TO GEN-MESS.
      **** rel 5.2
           IF IF-DTMOV = ZERO
              PERFORM ERR-ZERO
              MOVE 'Data movimento contabile obbligatoria' TO MESS
              MOVE 4 TO ERRIO-ST
              GO TO GEN-MESS.

           MOVE 1 TO TIPOP1.
           MOVE IF-DTMOV TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              MOVE 'Data registrazione errata' TO MESS
              GO TO ERRIO.
           MOVE AAGGG TO DTMOV.
      ************
      *
           MOVE 20 TO KTB-TIP.
           MOVE 1  TO KTB-COD.
           READ TABELL INTO RKTB20 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI  TO MCLI.
           MOVE T01-MFOR  TO MFOR.
           MOVE T01-CIVSO TO CIVSO.
           MOVE T01-CRPCL TO CRPCL.
           MOVE T01-CRPC1 TO CRPC1.
           MOVE T01-CRPC2 TO CRPC2.
           MOVE T01-CRPFR TO CRPFR.
           MOVE T01-CRPF1 TO CRPF1.
           MOVE T01-CRPF2 TO CRPF2.
           MOVE 14 TO KTB-TIP.
           MOVE 7  TO KTB-COD.
           READ TABELL INTO RKTB14G INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14G.
           MOVE 14 TO KTB-TIP.
           MOVE 1  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-CDCOR TO CCOR. 
           MOVE 14 TO KTB-TIP.
           MOVE 5  TO KTB-COD.
           READ TABELL INTO REKTE14 INVALID MOVE ZERO TO REKTE14.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTE14.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO. 
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           IF AZI-FLCON NOT = ZERO
              MOVE 'Registrazione precedente errata' TO MESS
              GO TO ERRIO.
      *
           MOVE ZERO TO SAVCAU SAVCON.
           MOVE SPACE TO SAVDAV.
       FDL1.
           MOVE ZERO TO TSSALC TSSCAU CASALC.
           MOVE ZERO TO FLMOV FLGCO.
           MOVE IF-NREG TO KEYMS2.
           START MOVSEZ KEY NOT < KEYMS2 INVALID GO TO STMOV.
       RDMSZ.
           READ MOVSEZ NEXT INTO REKMOV AT END GO TO STMOV.
           IF SF-MSZ = '9D' OR '9A' OR '35' GO TO RDMSZ.
           IF MOV-NREG > IF-NREG GO TO STMOV.
      **** rel 5.2
           IF MOV-DAT NOT = DTMOV GO TO RDMSZ.
      ************
           IF MOV-AZI NOT = IF-AZI GO TO RDMSZ.
      **** rel 4.0
           IF MOV-FLGE2 > ZERO 
              MOVE 'Movimento pre Big-Bang' TO F-MES1
              MOVE '         Non variabile' TO F-MES2
              MOVE 2 TO F-NMES
              MOVE 4 TO ERRIO-ST
              GO TO GEN-MESS.
      ************
           MOVE REKMOV TO RF-35B.
           MOVE MOV-CON TO K35B-CON.
           MOVE MOV-DAT TO K35B-DAT.
           MOVE MOV-NUM TO K35B-NUM.
           MOVE ZERO TO L35B-TST.
           MOVE 2        TO KTB-TIP.
           MOVE L35B-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' MOVE RF-TAB TO REKTAB.
           IF T02-ATTRN > ZERO GO TO RDMS-00.
           IF CASALC = ZERO MOVE L35B-CAUS  TO CASALC
                            MOVE 1         TO TSSALC.
           IF L35B-CAUS NOT = CASALC MOVE ZERO TO TSSALC.
       RDMS-00.
           WRITE RF-35B INVALID MOVE 'Vcon350: Errore WR.L35B-1' TO MESS
                                GO TO ERRIO.
           MOVE 1 TO FLMOV.
           GO TO RDMSZ.
       STMOV.
           MOVE IF-NREG TO KEYMV2.
           START MOVIME KEY NOT < KEYMV2 INVALID GO TO LFIN.
       RDMOV.
           READ MOVIME NEXT INTO REKMOV AT END GO TO LFIN.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO RDMOV.
           IF MOV-CAUS = 999 GO TO RDMOV.
           IF MOV-CON = CRPCL OR CRPC1 OR CRPC2 OR
                        T14-CRPC3 OR T14-CRPC4 OR T14-CRPC5 OR
                        T14-CRPC6 OR T14-CRPC7 OR T14-CRPC8 OR
                        CRPFR OR CRPF1 OR CRPF2 OR
                        T14-CRPF3 OR T14-CRPF4 OR T14-CRPF5 OR
                        T14-CRPF6 OR T14-CRPF7 OR T14-CRPF8
                        GO TO RDMOV.
           IF MOV-NREG > IF-NREG GO TO LFIN.
      **** rel 5.2
           IF MOV-DAT NOT = DTMOV GO TO RDMOV.
      ************
           IF MOV-AZI NOT = IF-AZI GO TO RDMOV.
      **** rel 4.0
           IF MOV-FLGE2 > ZERO 
              MOVE 'Movimento pre Big-Bang' TO F-MES1
              MOVE '         Non variabile' TO F-MES2
              MOVE 2 TO F-NMES
              MOVE 4 TO ERRIO-ST
              GO TO GEN-MESS.
      ************
           MOVE KMV-AZI   TO KPV-AZI.
           MOVE KMV-CON   TO KPV-CON.
           MOVE MOV-VALUT TO KPV-VAL.
           MOVE KMV-DAT   TO KPV-DAT.
           MOVE KMV-NUM   TO KPV-NUM.
           READ PARVAL INVALID GO TO RDMO-00.
           IF KPV1-STATO = 'A' GO TO RDMO-00.
           MOVE 'Partita valutaria chiusa' TO F-MES1.
           MOVE 'Movimento  non variabile' TO F-MES2.
           MOVE 2 TO F-NMES.
           MOVE 4 TO ERRIO-ST.
           GO TO GEN-MESS.
       RDMO-00.
           MOVE REKMOV TO RF-35B.
           IF MOV-CON = CCOR AND MOV-FLAG = ZERO
              MOVE 1 TO FLGCO.
           IF MOV-FLAG = ZERO
              IF MOV-TIP = 4 
                 MOVE 'Movimento acquisto IVA CEE' TO F-MES1
                 MOVE '     Non variabile'         TO F-MES2
                 MOVE 2 TO F-NMES
                 MOVE 4 TO ERRIO-ST
                 GO TO GEN-MESS.
           MOVE MOV-CON TO K35B-CON.
           MOVE MOV-DAT TO K35B-DAT.
           MOVE MOV-NUM TO K35B-NUM.
           MOVE ZERO TO L35B-TST.
           IF TSSALC = ZERO GO TO RDMO-10.
           IF L35B-CAUS NOT = CASALC MOVE ZERO TO TSSALC
                                    GO TO RDMO-10.
           MOVE 1 TO L35B-TREG.
       RDMO-10.
           WRITE RF-35B INVALID MOVE 'Vcon350: Errore WR.L35B-2' TO MESS
                                GO TO ERRIO.
           MOVE 1 TO FLMOV.
           GO TO RDMOV.
       LFIN.
           IF FLMOV = ZERO
              MOVE 'Nessun movimento' TO MESS
              MOVE 4 TO ERRIO-ST
              GO TO GEN-MESS.
      *
           MOVE 25     TO T25-TIP.
           MOVE IF-AZI TO T25-COD.
           MOVE '0'    TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-DUP TO DTAIVA.
           MOVE 25   TO T25-TIP.
           MOVE IF-AZI  TO T25-COD.
           MOVE '1'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           IF T25-PLA = 1 MOVE T25-DTM TO AAGGG
                          MOVE 2 TO TIPOP1
                          CALL 'rdata' USING PARCDT
                          MOVE GBMMBA TO DTMB.
           MOVE 2 TO TIPOP1.
           MOVE DTAIVA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DATIVB.
       LPIN.
           MOVE ZERO TO PROGR NURIG DFCNT DFIVA
                        NURIV SWIVA.
           MOVE SPACE TO WDESAG WDESA2.
           PERFORM F00-AZZ-CAMPI THRU F99.
           PERFORM S00-AZZ-CAU   THRU S99.
           MOVE ZERO TO TSSCAU.
           MOVE ZERO TO SAVCPA.
           MOVE ZERO TO FLGCPA FLGLET.
           MOVE ZERO TO K35B-AZI K35B-NUM K35B-DAT K35B-CON.
       RDLA0.
           START WDS35B KEY NOT < KEY35B INVALID GO TO RDL-99.
       RDLA1.
           READ WDS35B NEXT AT END GO TO RDL-99.
           IF SF-35B = '9D' OR '9A' OR '35' GO TO RDLA1.
       RDL-00.
           MOVE 1 TO FLGCPA.
           ADD 1 TO PROGR.
           IF SWIVA = 3 AND L35B-CAUS NOT = SAVCAU
              IF L35B-CAUS = ORICAU MOVE SAVCAU TO L35B-CAUS.
           MOVE L35B-CAUS TO KTB-COD WCAUSA.
           MOVE 2 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                   PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T02-D-A   TO WDAVE.
           MOVE T02-TIPRG TO WTIPRG.
           MOVE T02-TIPOP TO WTIPOP.
           MOVE T02-SEGNO TO WSEGNO.
           MOVE T02-FLGIS TO WFLGIS.
           MOVE T02-ATTRN TO ATTRN.
           MOVE T02-FLGSC TO WFLGSC.
           MOVE T02-FLGEC TO WFLGEC.
           IF PROGR > 1 GO TO RDL-05.
           MOVE K35B-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DATRG.
           IF WTIPRG > 1 AND ATTRN = 1 MOVE 1 TO SWIVA.
           MOVE ZERO TO AGIVA.
           IF AAGGG NOT > DTAIVA AND SWIVA = 1 MOVE 1 TO AGIVA.
           MOVE ZERO TO FLGPL.
           IF T25-PLA = ZERO MOVE ZERO TO TIG DTP6 TPL
                             GO TO RDL-00-10.
           IF SWIVA NOT = 1 OR WFLGIS NOT = ZERO
              GO TO RDL-00-10.
           MOVE T25-TIG TO TIG.
           MOVE T25-TPL TO TPL.
           MOVE T25-DTP TO DTP.
           PERFORM CONV-DTP-A6.
           IF T25-ATT = ZERO GO TO RDL-00-05.
           IF L35B-CATT = '0' GO TO RDL-00-05.
           MOVE 35        TO T35-TIP.
           MOVE KAZ-COD   TO T35-CDAZ.
           MOVE L35B-CATT  TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           IF T35-GES = ZERO GO TO RDL-00-05.
           MOVE T35-TIG TO TIG.
           MOVE T35-TPL TO TPL.
           MOVE T35-DTP TO DTP.
           PERFORM CONV-DTP-A6.
       RDL-00-05.
           MOVE ZERO TO FLGPL.
           IF TIG = ZERO GO TO RDL-00-10.
           IF WTIPRG = 2 AND AAGGG NOT > T25-DTM MOVE 2 TO FLGPL.
       RDL-00-10.
       RDL-05.
           MOVE L35B-D-A TO WDAVE.
           MOVE L35B-TREG TO WTIPRG.
           IF SWIVA = ZERO      AND
              (WTIPRG = 2 OR 3) AND
              K35B-CON = SAVCPA  MOVE ZERO TO L35B-PART
                                MOVE 1 TO WTIPRG.
           IF SWIVA NOT = 3 GO TO RDL-051.
           IF WFLGIS = 2 AND K35B-CON = CIVSO GO TO RDLA1.              
           IF WCAUSA NOT = SAVCAU GO TO RDL-051.
           IF WCAUSA = ORICAU GO TO RDL-051.
           IF SAVDAV NOT = ORIDAV
           IF WDAVE = 'A'
              MOVE 'D' TO WDAVE
           ELSE
              MOVE 'A' TO WDAVE.
           MOVE T02-TIPRG TO WTIPRG.
           IF ORISEG = 1 MULTIPLY -1 BY L35B-IMPO
                         MULTIPLY -1 BY L35B-IMVAL.
           GO TO RDL-052.
       RDL-051.
           IF WSEGNO = 1 MULTIPLY -1 BY L35B-IMPO
                         MULTIPLY -1 BY L35B-IMVAL.
       RDL-052.
           MOVE L35B-IMPO TO WIMPOR.
           IF L35B-FLAG = 1 MOVE L35B-DSAGG TO WDESAG.
           MOVE K35B-CON   TO WPART.
           MOVE L35B-NDOC  TO WDOCUM.
           MOVE L35B-DTDOC TO WDTDOC.
           MOVE L35B-DTSCD TO WDTSCD.
           MOVE L35B-VALUT TO WVALUT.
           MOVE L35B-CCOST TO WCCOST.
           MOVE L35B-CAMGG TO WCAMGG.
           MOVE L35B-IMVAL TO WIMVAL.
           MOVE L35B-NPRGI TO WNPRGI.
           MOVE L35B-PART  TO WCPART.
           MOVE L35B-CATT  TO WCATT.
           MOVE L35B-FEV   TO WESVEN.
           MOVE L35B-PLAF  TO WPLAFO.
           IF SWIVA = 1
              MOVE WNPRGI TO SAVPRG
              MOVE WDOCUM TO SAVDOC
              MOVE WDTDOC TO SAVDTD
              MOVE WCATT  TO SAVCAT
              MOVE WCAUSA TO SAVCAU
              MOVE WDAVE  TO SAVDAV ORIDAV
              MOVE WCAUSA TO ORICAU
              MOVE WSEGNO TO ORISEG
              MOVE WPART  TO SAVCON.
           IF SWIVA = 1 AND WCPART = 9999999
              MOVE ZERO TO WCPART
              MOVE 1 TO FLGIVA
           ELSE
              MOVE ZERO TO FLGIVA.
           IF SWIVA = 3 AND WCAUSA = SAVCAU 
              IF WCPART NOT = SAVCON
                 MOVE SAVCON TO WCPART.
           IF SWIVA = 3 AND WCPART = SAVCON AND SAVCON NOT = ZERO
              MOVE ZERO TO WSWAGG.
           IF SWIVA = 3                                                
              MOVE SAVCAT TO WCATT                       
              MOVE SAVPRG TO WNPRGI
              MOVE SAVDOC TO WDOCUM
              MOVE SAVDTD TO WDTDOC.
       RDL-10.
           READ WDS35B NEXT AT END GO TO  RDL-99.
           IF SF-35B = '9D' OR '9A' OR '35' GO TO RDL-10.
           IF L35B-FLAG = 1    AND
              WFLGIS = 2      AND                          
              K35B-CON = CIVSO GO TO RDL-10.                            
           IF L35B-FLAG = 1 GO TO RDL-20.
       RDL-10-00.
           IF PROGR > 1 AND SWIVA = 1 MOVE 2 TO SWIVA.
           MOVE L35B-FEV   TO WESVEN.
           MOVE L35B-PLAF  TO WPLAFO.
           IF WPLAFO = ZERO GO TO RDL-10-01.
           MOVE WDTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
       RDL-10-01.
           MOVE L35B-IVA TO WCDIVA.
           IF TIG = ZERO OR AAGGG > T25-DTM GO TO RDL-10-10.
           MOVE 3      TO KTB-TIP.
           MOVE WCDIVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF WTIPRG NOT = 3 GO TO RDL-10-05.
           IF NOT ( T03-TPIVA = 3 OR 6 ) GO TO RDL-10-10.
           IF ( WCDIVA = T141ACQ OR T141ACR OR
                         T141ACT OR T142ACQ OR
                         T143ACQ )  OR
                         T03-TSPLA > ZERO GO TO RDL-10-02.
           GO TO RDL-10-10.
       RDL-10-02.
           IF TPL = 2 AND WCDIVA NOT = T142ACQ AND
                          T03-TSPLA NOT = 2  GO TO RDL-10-10.
           IF TPL = 3 AND WCDIVA NOT = T143ACQ AND
                          T03-TSPLA NOT = 3  GO TO RDL-10-10.
           MOVE 1 TO FLGPL.
           GO TO RDL-10-10.
       RDL-10-05.
           IF WTIPRG NOT = 2 GO TO RDL-10-10.
           IF NOT ( T03-TPIVA = 3 OR 6 ) GO TO RDL-10-10.
           IF WCDIVA = T14IDIR OR T14ITRI OR
                       T14IIND OR T14ISCV OR 
                       T14IRSM OR T14IASS OR 
                       T14ISIN  OR T14IPOS GO TO RDL-10-07.
           GO TO RDL-10-10.
       RDL-10-07.
           IF TPL = 2 AND WCDIVA NOT = T14IASS GO TO RDL-10-10.
           IF TPL = 3 AND WCDIVA NOT = T14ISIN GO TO RDL-10-10.
           MOVE 1 TO FLGPL.
       RDL-10-10.
           IF WSEGNO = 1 MULTIPLY -1 BY L35B-IMP L35B-IVN L35B-IMPO.
           MOVE L35B-IMP TO WIMPON.
           MOVE L35B-IVN TO WINDED.
           MOVE L35B-IMPO TO WIMPOS.
           ADD L35B-IVN TO WIMPOS.
       RDL-15.
           PERFORM B00-AZZ-SCA THRU B99.
           MOVE WRKLAV TO RF-35A.
           WRITE RF-35A INVALID GO TO RDL-150.
           GO TO RDL-152.
       RDL-150.
           REWRITE RF-35A INVALID
                   MOVE 'Vcon350: Errore RWR.L35A-3' TO MESS
                   GO TO ERRIO.
       RDL-152.
           IF WSEGNO = 1 MULTIPLY -1 BY WIMPOR WIMPCP WIMPOS WIMPON
                                                       WINDED WIMVAL.
           IF SWIVA = 1 ADD WIMPOR TO DFIVA.
           SUBTRACT WIMPON WIMPOS FROM DFIVA.
           IF SWIVA = 1 AND WDAVE = 'D' ADD WIMPOR TO DFCNT.
           IF SWIVA = 1 AND WDAVE = 'A' SUBTRACT WIMPOR FROM DFCNT.
           IF WDAVE = 'D'
              SUBTRACT WIMPCP WIMPOS FROM DFCNT
              ADD WINDED TO DFCNT
              IF WFLGIS = 2
                 ADD WIMPOS TO DFCNT.
           IF WDAVE = 'A'
              ADD WIMPCP WIMPOS TO DFCNT
              SUBTRACT WINDED FROM DFCNT
              IF WFLGIS = 2
                 SUBTRACT WIMPOS FROM DFCNT.
           MOVE ZERO TO FLGCPA.
           MOVE PROGR TO NURIG.
           ADD 1 TO PROGR.
           PERFORM F20 THRU F99.
           GO TO RDL-10.
       RDL-20.
           IF FLGIVA = 1  MOVE KEY35B TO SAVKEY
                          PERFORM F20 THRU F99
                          MOVE ZERO TO FLGCPA
                          GO TO RDL-993.
           IF NOT (SWIVA = 1 OR 2) GO TO RDL-20-20.
           MOVE K35B-CON TO WCPART.
           IF WSEGNO = 1 MULTIPLY -1 BY L35B-IMPO.
           MOVE L35B-IMPO  TO WIMPCP.
           MOVE L35B-DSAGG TO WDESA2.
           MOVE L35B-CCOST TO WCCOS2.
           MOVE KEY35B TO SAVKEY.
       RDL-20-10.
           READ WDS35B NEXT AT END GO TO RDL-99.
           IF SF-35B = '9D' OR '9A' OR '35' GO TO RDL-20-10.
           IF L35B-FLAG = 1
              MOVE SAVKEY TO KEY35B
              IF DFIVA = ZERO AND DFCNT = ZERO
                 MOVE 2 TO FLGIVA
                 GO TO RDL-30
              ELSE
                 GO TO RDL-30.
           GO TO RDL-10-00.
       RDL-20-20.
           IF K35B-CON = WCPART AND L35B-CAUS = WCAUSA AND
                                   L35B-IMPO = WIMPOR GO TO RDL-20-30.
           IF SWIVA > ZERO GO TO RDL-30.
           IF TSSALC = 1 MOVE 1 TO TSSCAU.
           MOVE WCPART TO SAVCPA.
           MOVE ZERO TO WCPART.
           GO TO RDL-30.
       RDL-20-30.
           MOVE K35B-CON TO WCPART.
           IF WSEGNO = 1 MULTIPLY -1 BY L35B-IMPO.
           MOVE L35B-IMPO TO WIMPCP.
           MOVE L35B-DSAGG TO WDESA2.
           MOVE L35B-CCOST TO WCCOS2.
           PERFORM B00-AZZ-SCA THRU B99.
           MOVE WRKLAV TO RF-35A.
           WRITE RF-35A INVALID GO TO RDL-200.
           GO TO RDL-202.
       RDL-200.
           REWRITE RF-35A INVALID
                   MOVE 'Vcon350: Errore RWR.L35A-1' TO MESS
                   GO TO ERRIO.
       RDL-202.
           IF WSEGNO = 1 MULTIPLY -1 BY WIMPOR WIMPCP.
           IF WDAVE = 'D' ADD WIMPOR TO DFCNT
                          SUBTRACT WIMPCP FROM DFCNT.
           IF WDAVE = 'A' SUBTRACT WIMPOR FROM DFCNT
                          ADD WIMPCP TO DFCNT.
           MOVE PROGR TO NURIG.
           PERFORM F00-AZZ-CAMPI THRU F99.
           MOVE ZERO TO FLGCPA.
           GO TO RDLA1.
       RDL-30.
           IF SWIVA = 1 OR 2 MOVE KEY35B TO SAVKEY
                          PERFORM F20 THRU F99
                          MOVE ZERO TO FLGCPA
                          GO TO RDL-993.
           PERFORM B00-AZZ-SCA THRU B99.
           MOVE WRKLAV TO RF-35A.
           WRITE RF-35A INVALID GO TO RDL-300.
           GO TO RDL-302.
       RDL-300.
           REWRITE RF-35A INVALID 
                   MOVE 'Vcon350: Errore RWR.L35A-2' TO MESS
                   GO TO ERRIO.
       RDL-302.
           IF WSEGNO = 1 MULTIPLY -1 BY WIMPOR WIMPCP.
           IF WDAVE = 'D' ADD WIMPOR TO DFCNT
                          SUBTRACT WIMPCP FROM DFCNT.
           IF WDAVE = 'A' SUBTRACT WIMPOR FROM DFCNT
                          ADD WIMPCP TO DFCNT.
           PERFORM F00-AZZ-CAMPI THRU F99.
           MOVE ZERO TO FLGCPA.
           MOVE PROGR TO NURIG.
           GO TO RDL-00.
       RDL-99.
           IF FLGCPA = ZERO GO TO RDL-993.
           IF TSSALC = 1 AND TSSCAU = 1 MOVE ZERO TO WCPART.
           PERFORM B00-AZZ-SCA THRU B99.
           MOVE WRKLAV TO RF-35A.
           WRITE RF-35A INVALID GO TO RDL-990.
           GO TO RDL-992.
       RDL-990.
           REWRITE RF-35A INVALID
                   MOVE 'Vcon350: Errore RWR.L35A-4' TO MESS
                   GO TO ERRIO.
       RDL-992.
           IF WSEGNO = 1 MULTIPLY -1 BY WIMPOR WIMPCP.
           IF WDAVE = 'D' ADD WIMPOR TO DFCNT
                          SUBTRACT WIMPCP FROM DFCNT.
           IF WDAVE = 'A' SUBTRACT WIMPOR FROM DFCNT
                          ADD WIMPCP TO DFCNT.
           MOVE PROGR TO NURIG.
           PERFORM F00-AZZ-CAMPI THRU F99.
           MOVE ZERO TO FLGCPA.
       RDL-993.
           MOVE NURIG TO PROGR.
           IF FLGIVA NOT = 2 MOVE ZERO TO FLGIVA.
           IF FLGLET = 1 GO TO RDL-999.
           IF FLGCO = 1 
              MOVE 2 TO F-NMES
              MOVE 'Movimento corrispettivi' TO F-MES1
              MOVE 'Movimento non variabile' TO F-MES2
              MOVE 2 TO F-NMES
              MOVE 4 TO ERRIO-ST
              GO TO GEN-MESS.
           MOVE SPACE TO F-MES1 F-MES2 F-MES3 F-MES4.
           IF AGIVA = 1
              MOVE 2 TO F-NMES
              MOVE 'Totali IVA aggiornati al' TO F-MES1
              MOVE DATIVB                     TO F-MES2
      **** rel 3.0
      *       MOVE 8 TO ERRIO-ST.
      **** rel 5.0
      *       MOVE 4 TO ERRIO-ST
      *       GO TO GEN-MESS.
              MOVE 7 TO ERRIO-ST.
      ************
      ************
           IF FLGPL > ZERO  
              MOVE 4  TO F-NMES 
              MOVE 'Movimenti plafond aggiornati al : ' TO F-MES3
              MOVE DTMB                                 TO F-MES4
              MOVE 8 TO ERRIO-ST.
           MOVE 1 TO FLGLET.
      *
       RDL-999.
           IF ( SWIVA > ZERO AND < 3 ) AND DFCNT NOT = ZERO
                                       MOVE 1 TO FLGIVA
                                       GO TO FNCR-20.
           IF FLGIVA = 2 GO TO FNCR-20.
           GO TO FNCR.
       FLCN.
       FNCR.
           IF SWIVA = 1 OR 2 GO TO FNCR-20.
           IF DFCNT NOT = ZERO GO TO FNCR-50.
       FNCR-10.
           IF FLGIVA > ZERO
              MOVE 3 TO SWIVA
              PERFORM S00-AZZ-CAU THRU S99
              MOVE NURIG TO NURIV PROGR
              PERFORM P40 THRU P99
              MOVE ZERO TO FLGIVA
              MOVE NURIG TO PROGR
              MOVE SAVKEY TO KEY35B
              GO TO RDLA0.
           GO TO GSSCA.
       FNCR-20.
           IF FLGIVA = 2 GO TO FNCR-30.
           IF DFIVA = ZERO AND DFCNT = ZERO GO TO FNCR-10.
           IF DFIVA NOT = ZERO GO TO FNCR-40.
       FNCR-30.
           MOVE 3 TO SWIVA.
           PERFORM S00-AZZ-CAU THRU S99.
           MOVE WDTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE NURIG TO NURIV PROGR.
           PERFORM P40 THRU P99.
           IF FLGIVA > ZERO
              MOVE ZERO TO FLGIVA
              MOVE NURIG TO PROGR
              MOVE SAVKEY TO KEY35B
              GO TO RDLA0
           ELSE
              GO TO FLCN.
       FNCR-40.
           GO TO FNCR-30.
       FNCR-50.
           PERFORM P40 THRU P99.
           MOVE '   Attenzione, SBILANCIO'      TO F-MES1.
           MOVE 'Registrazione  non  variabile' TO F-MES2.
           MOVE 'E'' possibile solo annullarla' TO F-MES3.
           MOVE 3 TO F-NMES.
           MOVE 4 TO ERRIO-ST.
           GO TO GEN-MESS.
       GSSCA.
           PERFORM CREA-AREE-110 THRU EX-CREA-AREE-110.
           GO TO FINE.
      *------------------
       ERRIO.
           COPY 'errsub'.
       FINE.
           CLOSE ANAAZI.
           CLOSE ANACON.
           CLOSE ANACLF.
           CLOSE MOVIME.
           CLOSE MOVSEZ.
           CLOSE PARVAL.
           CLOSE TABELL.
           CLOSE WDS35A WDS35B WDSLAV.
           EXIT PROGRAM.
           STOP RUN.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'grimszer'.
           COPY 'gripaver'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
       B00-AZZ-SCA.
           MOVE ZERO TO WFLAG WCDPAG WNRATE.
           MOVE ZERO TO L.
       B10.
           ADD 1 TO L.
           IF L < 7 MOVE ZERO TO WBDSC(L) WBISC(L) WBVSC(L).
           MOVE ZERO TO WTPAG(L) WIMRATA(L) WVALRATA(L) WDTSCA(L).
      **** rel 6.2
           MOVE SPACE TO WNOTE(L) WNOTEA(L).
      ************
           IF L < 12 GO TO B10.
       B99.
           EXIT.
      *------------------
       F00-AZZ-CAMPI.
           MOVE ZERO TO WDOCUM WDTDOC.
       F10.
           MOVE '0' TO WCATT.
           MOVE ZERO TO WNPRGI.
       F15.
           MOVE ZERO TO WPART WIMPOR.
           MOVE ZERO TO WVALUT WCAMGG WIMVAL.
           MOVE ZERO TO WDFCAM WCAUDF WGECDF.
           MOVE SPACE TO WCCOST WDAVDF.
       F20.
           MOVE ZERO TO WCPART WIMPCP WCDIVA  WTIPO2
                WFLGE2  WIMPON WIMPOS WINDED WESVEN 
                WTIPR2  WDTSC2 WCAUS2 WFLGS2 WSWAG2.
           MOVE ZERO TO WPLAN WPLAM.
           MOVE SPACE TO WCCOS2.
       F99.
           EXIT.
      *------------------
       P40.
           IF SWIVA = ZERO  GO TO P50.
           IF SWIVA = 3 PERFORM F15 THRU F99
                               GO TO P60.
           IF SWIVA = 1 MOVE 2 TO SWIVA.
           PERFORM F20 THRU F99.
           IF DFIVA NOT = ZERO GO TO P60.
           GO TO P99.
       P50.
           PERFORM S00-AZZ-CAU THRU S99.
           IF SWIVA = 3 PERFORM F15 THRU F99
                        GO TO P60.
           PERFORM F00-AZZ-CAMPI THRU F99.
       P60.
       P99.
           EXIT.
      *------------------
       S00-AZZ-CAU.
           MOVE ZERO TO WCAUSA.
           MOVE SPACE TO WDAVE.
           MOVE ZERO TO WTIPRG WFLGEC WDTSCD WFLGIS
                        WTIPOP WFLGSC WSWAGG.
       S99.
           EXIT.
      *------------------
       CONV-DTP-A6.
           IF DTP = ZERO MOVE ZERO TO DTP6
              ELSE MOVE DTP TO DTP6
                   MOVE AA61 TO AA62
                   MOVE ZERO TO AA61
                   CALL 'ranno4' USING AA6.
      *------------------
      * carica aree di lavoro x vcon110
       CREA-AREE-110.
           MOVE ZERO TO TIPRG-350
                        CAUS-350
                        ATTRN-350
      **** rel 5.0
                        AGIVA-350
      ************
                        FLGIS-350.
      * azzeramento vettore IVA
           PERFORM AZZ-IF-IVA.
      * azzeramento vettore C/P
           PERFORM AZZ-IF-CPAR.
      *
           MOVE ZERO TO K35A-PROG.
           START WDS35A KEY NOT < K35A-PROG INVALID
                 GO TO END-CREA-AREE-110.
       CREA-110-10.
           READ WDS35A NEXT AT END GO TO END-CREA-AREE-110.
           PERFORM AZZ-IF-REC THRU EX-AZZ-IF-REC.
      *
           MOVE K35A-PROG  TO IF-PROGR.
           MOVE L35A-CAUSA TO IF-CAUS.
      *
           MOVE L35A-DAVE  TO IF-D-A.
           IF L35A-SEGNO = 1
              MOVE '-' TO IF-SEGNI
           ELSE 
              MOVE SPACE TO IF-SEGNI.
           MOVE L35A-DESAG TO IF-DESAG.

           IF L35A-TIPRG = 1
              MOVE L35A-PART TO IF-PART
           ELSE
      **** rel 4.0
              IF IF-PROGR > 1 AND IF-CAUS = CAUS-350 AND ATTRN-350 = 1
                 MOVE L35A-PART TO IF-PART
              ELSE
      ************
              MOVE L35A-PART TO IF-CLIFOR.
           MOVE L35A-IMPOR TO IF-IMPOR.
           MOVE L35A-DOCUM TO IF-DOCUM.
      *
           MOVE L35A-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTDOC.
      *
           MOVE L35A-DTSCD TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTSCD.
      *
           MOVE L35A-VALUT TO IF-VALUT.
           MOVE L35A-CAMGG TO IF-CAMGG.
           MOVE L35A-IMVAL TO IF-IMVAL.
           MOVE L35A-CCOST TO IF-CCOST.
      *
           PERFORM SET-IF-FLCOSZ.
      *
           MOVE L35A-DFCAM TO IF-DIFCAM.
           MOVE L35A-CATT  TO IF-CATT.
           MOVE L35A-NPRGI TO IF-NPRGI.
           IF L35A-IVA = ZERO
              MOVE L35A-CPART TO IF-CPART
              MOVE L35A-CCOS2 TO IF-CCOST2
      **** rel 2.0
              MOVE L35A-DESA2 TO IF-DESAG2
      ************
              PERFORM SET-IF-FLCOS2Z
              PERFORM SCRIVI-RECLAV THRU EX-SCRIVI-RECLAV
              GO TO CREA-110-10.
           IF L35A-IVA = 1
              MOVE L35A-NPRGI TO OLDPRG
              MOVE L35A-DOCUM TO OLDDOC
              MOVE L35A-DTDOC TO OLDDTD
              MOVE L35A-CATT  TO OLDCAT
              MOVE L35A-CAUSA TO OLDCAU
              MOVE L35A-DAVE  TO OLDDAV
              MOVE L35A-PART  TO OLDCON.
           IF L35A-IVA = 1 OR 2
              PERFORM AGG-IF-AREA-IVA  THRU EX-AGG-IF-AREA-IVA
              PERFORM AGG-IF-AREA-CPAR THRU EX-AGG-IF-AREA-CPAR
              IF L35A-IVA = 1
                 IF L35A-FLGIS = 2
                    MOVE L35A-CPART TO IF-CPART
                    MOVE L35A-CCOS2 TO IF-CCOST2
                    PERFORM SET-IF-FLCOS2Z
                    MOVE L35A-DESA2 TO IF-DESAG2
                    MOVE ZERO  TO IF-CP-COD(1)
                                  IF-CP-IMPON(1)
                                  IF-CP-FLCOSZ(1)
                    MOVE SPACE TO IF-CP-DESCR(1)
                                  IF-CP-DESAG(1)
                                  IF-CP-CCOST(1)
                 END-IF
                 PERFORM SCRIVI-RECLAV THRU EX-SCRIVI-RECLAV
              END-IF
              GO TO CREA-110-10.
           IF L35A-IVA = 3
              IF L35A-NPRGI = OLDPRG AND
                 L35A-DOCUM = OLDDOC AND
                 L35A-DTDOC = OLDDTD AND
                 L35A-CATT  = OLDCAT AND
                 L35A-CAUSA = OLDCAU AND
      **** rel 2.0
                 L35A-DAVE NOT = OLDDAV AND
      ************
                 L35A-CPART = OLDCON
                 MOVE L35A-PART  TO L35A-CPART
                 MOVE L35A-IMPOR TO L35A-IMPCP
                 MOVE L35A-DESAG TO L35A-DESA2
      **** rel 3.0b
                 MOVE L35A-CCOST TO L35A-CCOS2
      ************
                 PERFORM AGG-IF-AREA-CPAR THRU EX-AGG-IF-AREA-CPAR
      **** rel 3.0a
                 IF SW-CP = ZERO
                    MOVE L35A-CPART TO IF-CPART
                    MOVE L35A-CCOS2 TO IF-CCOST2
                    MOVE L35A-DESA2 TO IF-DESAG2
                    PERFORM SET-IF-FLCOS2Z
                    PERFORM SCRIVI-RECLAV THRU EX-SCRIVI-RECLAV
                 END-IF
      *************
                 GO TO CREA-110-10
              ELSE
                 MOVE L35A-CPART TO IF-CPART
                 MOVE L35A-CCOS2 TO IF-CCOST2
      **** rel 2.0
                 MOVE L35A-DESA2 TO IF-DESAG2
      ************
                 PERFORM SET-IF-FLCOS2Z
                 PERFORM SCRIVI-RECLAV THRU EX-SCRIVI-RECLAV
                 GO TO CREA-110-10.
              GO TO CREA-110-10.
       END-CREA-AREE-110.
      *
       EX-CREA-AREE-110.
           EXIT.
      *------------------
      * scrittura record su file di lavoro wdslav
       SCRIVI-RECLAV.
      * 
           MOVE 2       TO KTB-TIP.
           MOVE IF-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' MOVE RF-TAB TO REKTAB.
           MOVE T02-TIPRG TO IF-T02-TIPRG.
           MOVE T02-TIPOP TO IF-T02-TIPOP.
           MOVE T02-SEGNO TO IF-T02-SEGNO.
           MOVE T02-FLGIS TO IF-T02-FLGIS.
           MOVE T02-ATTRN TO IF-T02-ATTRN.
           MOVE T02-FLVEN TO IF-T02-FLVEN.
           MOVE T02-FLGSC TO IF-T02-FLGSC.
           MOVE T02-DTSCO TO IF-T02-DTSCO.
           MOVE T02-FLGEC TO IF-T02-FLGEC.
      *
           IF IF-PROGR = 1
              MOVE IF-CAUS   TO CAUS-350
              MOVE T02-ATTRN TO ATTRN-350
              MOVE T02-TIPRG TO TIPRG-350
              MOVE T02-FLGIS TO FLGIS-350.
      **** rel 5.0
           MOVE AGIVA TO AGIVA-350.
      ************
      *
           MOVE AZI-FLCOS  TO IF-HS-FLCOS.
           MOVE L35A-TIPRG TO IF-HS-TIPRG.
           IF L35A-FLGEC = ZERO 
              MOVE 1 TO IF-HS-FLGEC.
           IF IF-DIFCAM NOT = ZERO MOVE 1 TO IF-HS-CONTDIF.
      **** rel 4.0
      *    IF IF-VALUT  > 1 MOVE 1 TO IF-HS-VALUT.
           IF NOT (IF-VALUT = ZERO OR COMEURO) MOVE 1 TO IF-HS-VALUT
                                               MOVE ZERO TO IF-HS-EURO
           ELSE
                                               MOVE 1 TO IF-HS-EURO.
      ************
           IF IF-PROGR = 1  MOVE IF-T02-ATTRN TO IF-HS-ATTRN.
           IF ATTRN-350 = ZERO
      **** rel 2.0
              MOVE 1 TO IF-HS-CPART
           ELSE
      **** rel 4.0-2
            IF IF-T02-FLGIS NOT = 2
      ************
              MOVE ZERO  TO IF-CPART
              MOVE SPACE TO IF-CCOST2 IF-DESAG2.
      *       MOVE 1 TO IF-HS-CPART.
      ************
           IF IF-T02-FLGIS = 2 MOVE 1 TO IF-HS-CPART.
           MOVE TIG TO IF-HS-FLTIG.
      **** rel 4.0
           IF IF-PROGR > 1 AND IF-CAUS = CAUS-350 AND ATTRN-350 = 1
              MOVE 1 TO IF-HS-TIPRG
              MOVE ZERO TO IF-HS-FLGEC.
      ************
      *
      * carica campi descrittivi aggiuntivi
      *
           MOVE 2       TO KTB-TIP.
           MOVE IF-CAUS TO KTB-COD.
           READ TABELL INVALID MOVE ALL '*' TO TAB-DESCR.
           MOVE TAB-DESCR TO IF-CAUS-D.
      *
           IF IF-PART = ZERO GO TO SCRIVI-RECLAV-10.
           MOVE IF-PART TO KPC-COD.
           MOVE KAZ-COD TO KPC-AZI.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DESCR.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-DESCR  TO IF-PART-D.
       SCRIVI-RECLAV-10.
           IF IF-CLIFOR = ZERO GO TO SCRIVI-RECLAV-20.
           IF IF-HS-TIPRG = 2
              MOVE MCLI TO MAS
           ELSE
              MOVE MFOR TO MAS.
           MOVE IF-CLIFOR TO CODCF.
           MOVE CODICE  TO KCF-COD.
           MOVE KAZ-COD TO KCF-AZI.
           READ ANACLF INVALID KEY MOVE ALL '*' TO CLF-RGS.
           MOVE CLF-RGS TO IF-CLIFOR-D.
       SCRIVI-RECLAV-20.
      **** rel 4.0
      *    IF IF-VALUT < 2 GO TO SCRIVI-RECLAV-30.
           IF (IF-VALUT = ZERO OR COMEURO) GO TO SCRIVI-RECLAV-30.
      ************
           MOVE 10       TO KTB-TIP.
           MOVE IF-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO IF-VALUT-D.
       SCRIVI-RECLAV-30.
           IF IF-CPART = ZERO GO TO SCRIVI-RECLAV-40.
           MOVE IF-CPART TO KPC-COD.
           MOVE KAZ-COD  TO KPC-AZI.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DESCR.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-DESCR  TO IF-CPART-D.
       SCRIVI-RECLAV-40.
      *
           MOVE DATRG TO IF-DATREG.
           MOVE IF-REC-WDS TO RECLAV.
           MOVE IF-PROGR TO KLV-PROGR.
           WRITE RF-LAV INVALID 
                 MOVE 'Vcon350:Errore scrittura wdslav' TO MESS
                 GO TO ERRIO.
       EX-SCRIVI-RECLAV.
           EXIT.
      *------------------
      * aggiorna rigo vettore IVA con dati rigo wrklav
       AGG-IF-AREA-IVA.
           IF L35A-CDIVA = ZERO GO TO EX-AGG-IF-AREA-IVA.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              IF IF-IV-COD(K) = ZERO
                 MOVE L35A-CDIVA TO IF-IV-COD(K)
                 MOVE L35A-IMPON TO IF-IV-IMPON(K)
                 MOVE L35A-IMPOS TO IF-IV-IMPOS(K)
                 IF TIG NOT = ZERO AND L35A-PLAM NOT = ZERO
                    MOVE L35A-PLAM  TO IF-IV-PMES(K)
                    MOVE L35A-DTDOC TO AAGGG
                    MOVE 2 TO TIPOP1
                    CALL 'rdata' USING PARCDT
                    MOVE AA4 TO IF-IV-PANN(K)
                    IF L35A-PLAN = 1
                       SUBTRACT 1 FROM IF-IV-PANN(K)
                    ELSE
                       IF L35A-PLAN > 1
                          ADD L35A-PLAN TO IF-IV-PANN(K)
                          SUBTRACT 1 FROM  IF-IV-PANN(K)
                       END-IF
                    END-IF
                 END-IF
                 MOVE IF-IV-COD(K) TO KTB-COD
                 MOVE 3            TO KTB-TIP
                 READ TABELL INTO REKTAB INVALID
                      MOVE ALL '*' TO TAB-DESCR
                 END-READ
                 IF SF-TAB = '9D' OR '9A' OR '35'
                    MOVE RF-TAB TO REKTAB
                 END-IF
                 MOVE TAB-DESCR TO IF-IV-DESCR(K)
                 MOVE 6 TO K
              END-IF
           ADD 1 TO K
           END-PERFORM.
       EX-AGG-IF-AREA-IVA.
           EXIT.
      *------------------
      * aggiorna rigo vettore C/P con dati rigo wrklav
       AGG-IF-AREA-CPAR.
           IF L35A-CPART = ZERO GO TO EX-AGG-IF-AREA-CPAR.
      **** rel 5.1
           IF L35A-IMPCP = ZERO GO TO EX-AGG-IF-AREA-CPAR.
      ************
      **** rel 3.0a
           MOVE ZERO TO SW-CP.
      *************
           MOVE 1 TO K.
      **** rel 6.2
      *    PERFORM UNTIL K > 7
           PERFORM UNTIL K > 15
      ************
              IF IF-CP-COD(K) = ZERO
      **** rel 3.0a
                 MOVE 1 TO SW-CP
      *************
                 MOVE L35A-CPART TO IF-CP-COD(K)
                 MOVE L35A-IMPCP TO IF-CP-IMPON(K)
                 MOVE L35A-DESA2 TO IF-CP-DESAG(K)
      **** rel 3.0b
      *          MOVE L35A-CCOST TO IF-CP-CCOST(K)
                 MOVE L35A-CCOS2 TO IF-CP-CCOST(K)
      ************
                 MOVE KAZ-COD      TO KPC-AZI
                 MOVE IF-CP-COD(K) TO KPC-COD
                 READ ANACON INTO REKCON INVALID
                      MOVE ALL '*' TO CON-DSABB
                      MOVE ZERO    TO CON-TIPO
                 END-READ
                 IF SF-CON = '9D' OR '9A' OR '35'
                    MOVE RF-CON TO REKCON
                 END-IF
                 IF CON-DSABB NOT = SPACE
                    MOVE CON-DSABB TO IF-CP-DESCR(K)
                 ELSE
                    MOVE CON-DESCR TO IF-CP-DESCR(K)
                 END-IF
                 IF CON-TIPO NOT = 'E'
                    MOVE ZERO  TO IF-CP-FLCOSZ(K)
                 ELSE
                    IF CON-TRIP = ZERO
                       MOVE 2 TO IF-CP-FLCOSZ(K)
                    ELSE
                       MOVE 3 TO IF-CP-FLCOSZ(K)
                    END-IF
                 END-IF
      **** rel 6.2
      *          MOVE 7 TO K
                 MOVE 15 TO K
      ************
              END-IF
           ADD 1 TO K
           END-PERFORM.
       EX-AGG-IF-AREA-CPAR.
           EXIT.
      *------------------
       AZZ-IF-REC.
           MOVE ZERO  TO IF-REC.
           MOVE ZERO  TO IF-SALD
                         IF-IMPOR
                         IF-IMVAL
                         IF-SALD2
                         IF-PAR-SALDO
                         IF-PAR-VSALD
                         IF-DIFCAM
                         IF-DIFVAL
                         IF-SBILANCIO
                         IF-DARE
                         IF-AVERE
                         IF-DIFDOC
                         IF-TOTIMPON
                         IF-TOTIMPOS
                         IF-DIFIMPON
                         IF-TOTIMPOR
                         IF-DIFDOCV
                         IF-TOTIMPONV
                         IF-TOTSCA
                         IF-DIFSCA
                         IF-TOTSCAV
                         IF-DIFSCAV
                         IF-AUV-ANNO.
           MOVE SPACE TO IF-CAUS-D
                         IF-DESAG
                         IF-PART-D
                         IF-CLIFOR-D
                         IF-CCOST
                         IF-CATT
                         IF-D-A
                         IF-SEGNI
                         IF-VALUT-D
                         IF-CPART-D
                         IF-DESAG2
                         IF-CCOST2
                         IF-AZI-D
                         IF-DESPAG
                         IF-DESBAN
                         IF-ACEE-T02-D-A
                         IF-ACEE-CAUS-D
                         IF-ACEE-CATTA
      **** rel 2.0
                         IF-LEG-CAUS-D
      ************
                         IF-ACEE-CATTV.
      *
           MOVE ZERO TO IF-HS-VALUT
                        IF-HS-ATTRN
                        IF-HS-FLGEC
                        IF-HS-FLGSC
                        IF-HS-FLTIG
                        IF-HS-FLCOS
                        IF-HS-FL1SCAD
                        IF-HS-CPART
                        IF-HS-SCA
                        IF-HS-SCAS 
                        IF-HS-CONTDIF
                        IF-HS-ACEE.
      **** rel 4.0
           MOVE 1    TO IF-HS-EURO.
      ************
       EX-AZZ-IF-REC.
           EXIT.
      *------------------
       AZZ-IF-IVA.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              MOVE ZERO  TO IF-IV-COD(K)
                            IF-ACEE-IV-IMPONV(K)
                            IF-IV-IMPON(K)
                            IF-IV-IMPOS(K)
                            IF-IV-PERPLA(K)
              MOVE SPACE TO IF-IV-DESCR(K)
              ADD 1 TO K
           END-PERFORM.
      *------------------
       AZZ-IF-CPAR.
           MOVE 1 TO K.
      **** rel 6.2
      *    PERFORM UNTIL K > 7
           PERFORM UNTIL K > 15
      ************
              MOVE ZERO  TO IF-CP-COD(K)
                            IF-CP-IMPON(K)
                            IF-CP-FLCOSZ(K)
              MOVE SPACE TO IF-CP-DESCR(K)
                            IF-CP-DESAG(K)
                            IF-CP-CCOST(K)
              ADD 1 TO K
           END-PERFORM.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-35A ID-35B ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-35A.
           STRING 'w2' PID DELIMITED SPACE INTO ID-35B.
      * ID-LAV deve avere lo stesso nome utilizzato da vcon110
           STRING 'w9' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       LEGG-TIPO-CONTO.
           MOVE KAZ-COD TO KPC-AZI.
           READ ANACON INTO REKCON INVALID
                MOVE ZERO TO CON-TIPO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
      *------------------
      * setta flag IF-FLCOSZ.
       SET-IF-FLCOSZ.
           IF L35A-TIPRG = 1
              MOVE IF-PART TO KPC-COD
              PERFORM LEGG-TIPO-CONTO
              IF CON-TIPO NOT = 'E'
                 MOVE ZERO  TO IF-FLCOSZ
              ELSE
                 IF CON-TRIP = ZERO
                    MOVE 2 TO IF-FLCOSZ
                 ELSE
                    MOVE 3 TO IF-FLCOSZ.
      *------------------
      * setta flag IF-FLCOS2Z.
       SET-IF-FLCOS2Z.
           MOVE IF-CPART TO KPC-COD.
           PERFORM LEGG-TIPO-CONTO
           IF CON-TIPO NOT = 'E'
              MOVE ZERO  TO IF-FLCOS2Z
           ELSE
              IF CON-TRIP = ZERO
                 MOVE 2 TO IF-FLCOS2Z
              ELSE
                 MOVE 3 TO IF-FLCOS2Z.
      *------------------
