       IDENTIFICATION DIVISION.
       PROGRAM-ID. VDSVART.
      *
      * OGGETTO: data service ARTICOLI
      *
      **** rel 7.1
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gricdtsl'.
           COPY 'gricdrsl'.
           COPY 'griartsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'gricdt'.
           COPY 'gricdr'.
           COPY 'griart'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'dsv-art.cpy'.
           COPY 'dsv-get.cpy'.
           COPY 'parppar'.
      *
       01  ID-CDT PIC X(50) VALUE 'codate'.
       01  ID-CDR PIC X(50) VALUE 'codari'.
       01  ID-ART PIC X(50) VALUE 'magart'.
       01  COMODI.
           05 SF-CDT   PIC XX.
           05 SF-CDR   PIC XX.
           05 SF-ART   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 FUN      PIC XX.
      *
           05 TIP      PIC X(3)  VALUE 'DSV'.
      *
       LINKAGE SECTION.
           COPY 'parxcd'.
           COPY 'dsv-odbcl'.
       PROCEDURE DIVISION USING PARXCD D-ODBC-CTR.
           COPY 'declxer1'.
           COPY 'dclcdt'.
           COPY 'dclcdr'.
           COPY 'dclart'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.
      *
           MOVE PXCD-IDCDT TO ID-CDT.
           MOVE PXCD-IDCDR TO ID-CDR.
      *
           OPEN INPUT CODATE CODARI.
      *
           MOVE 'O' TO D-ART-FUN.   *> open
           PERFORM CALL-P-ART.
           PERFORM CALL-ODBC-ART.
      *
           MOVE PXCD-SRV TO KCDT-SRV.
           MOVE PXCD-PRG TO KCDT-PRG.
           READ CODATE INVALID GO TO FINE.
      *
           MOVE PXCD-SRV TO KCDR-SRV.
           MOVE PXCD-PRG TO KCDR-PRG.
           MOVE ZERO     TO KCDR-PRR.
           START CODARI KEY NOT < KEYCDR INVALID GO TO FINE.
       LOOPCDR.
           READ CODARI NEXT AT END GO TO ENDCDR.
           IF SF-CDR = '9A' OR '9D' OR '35' GO TO LOOPCDR.
           IF KCDR-SRV > PXCD-SRV GO TO ENDCDR.
           IF KCDR-PRG > PXCD-PRG GO TO ENDCDR.

           INITIALIZE D-ART-P-IN.
      *
           IF CDR-OPZ(1:1) = 'V' AND
              CDR-KEY(4:) = SPACE
                 PERFORM VER-DELETE THRU EX-VER-DELETE
                 GO TO NO-CDR.

           IF CDR-OPZ(1:1) = 'c'

              MOVE CDR-OPZ(2:) TO D-GET-UUID
              MOVE CDR-KEY(1:9) TO D-GET-ID

              INITIALIZE D-ART-P-IN
              INITIALIZE D-ART-P-OUT
              MOVE SPACE TO D-ART-CAMPI D-ART-O-CAMPI
              MOVE D-GET-UUID TO D-ART-UUID
              MOVE D-GET-ID   TO D-ART-ID
              STRING 'Record_inesistente:_' CDR-KEY INTO D-ART-CAMPI
      *
              MOVE 'LV' TO D-ART-FUN   *> aggiorna log verifica
              PERFORM CALL-ODBC-ART 
              MOVE SPACE TO D-ART-CAMPI D-ART-O-CAMPI
      *
              MOVE 'BT' TO D-ART-FUN  *> begin transaction
              PERFORM CALL-ODBC-ART
      *
              MOVE 'dl' TO D-ART-FUN  *> delete
              PERFORM CALL-ODBC-ART
      *
              MOVE 'CM' TO D-ART-FUN   *> commit
              PERFORM CALL-ODBC-ART
              GO TO NO-CDR.
      *
           MOVE CDR-KEY(1:3)  TO D-ART-AZI.
           MOVE CDR-KEY(4:18) TO D-ART-COD.
      *
           MOVE CDR-OPZ(1:1) TO FUN.
      *
           IF NOT (FUN = 'C' OR 'R')
              MOVE 'R' TO D-ART-FUN
              PERFORM CALL-P-ART.
      *
           IF FUN = 'V'     *> verifica coerenza dati
              MOVE 'RD' TO D-ART-FUN   *> read
              PERFORM CALL-ODBC-ART
              IF D-ART-FOUT = ZERO AND
                 D-ART-CAMPI = D-ART-O-CAMPI  *> verifica dati OK
                    GO TO NO-CDR
              ELSE
                 IF D-ART-FOUT = 9
                    MOVE 'I' TO FUN
                 ELSE
                    MOVE 'LV' TO D-ART-FUN   *> aggiorna log verifica
                    PERFORM CALL-ODBC-ART
                    MOVE 'M' TO FUN.
      *
           MOVE 'BT' TO D-ART-FUN   *> begin transaction
           PERFORM CALL-ODBC-ART.
      *
           IF FUN = 'I' MOVE 'IN' TO D-ART-FUN.  *> insert
           IF FUN = 'M' MOVE 'UP' TO D-ART-FUN.  *> update
           IF FUN = 'C' MOVE 'DL' TO D-ART-FUN.  *> delete
           IF FUN = 'R'
              MOVE CDR-OPZ(2:18) TO D-ART-NEWCOD
              MOVE 'RC' TO D-ART-FUN.  *> ricodifica
           PERFORM CALL-ODBC-ART.
      *
           MOVE 'CM' TO D-ART-FUN   *> commit
           PERFORM CALL-ODBC-ART.

       NO-CDR.
           GO TO LOOPCDR.
       ENDCDR.
           GO TO FINE.
      * 
       ERRIO.
      *    COPY 'errsub'.
           MOVE 9 TO PXCD-ERR.
           MOVE F-MES1 TO PXCD-LOG.
           MOVE ZERO TO ERRIO-ST.
      *
       FINE.
           CLOSE CODATE CODARI.
      *
           IF PXCD-ERR NOT = 9
              MOVE 'C' TO D-ART-FUN    *> close
              PERFORM CALL-P-ART
              PERFORM CALL-ODBC-ART.
      *
           EXIT PROGRAM.
      *------------------
       CALL-ODBC-ART.
           MOVE 1 TO D-ODBC-FUN.
           MOVE 'dsv-art' TO D-ODBC-PROC.
      *
           CALL 'dsv-odbc' USING D-ODBC-CTR D-ART-P-IN D-ART-P-OUT.
           IF D-ODBC-ST > ZERO
              MOVE D-ODBC-MSG TO F-MES1
              MOVE 1 TO F-NMES
              IF D-ODBC-SQLERRMC NOT = SPACE
                 MOVE D-ODBC-SQLERRMC TO F-MES2
                 MOVE 2 TO F-NMES
              END-IF
              GO TO ERRIO.
      *------------------
       CALL-P-ART.
           CALL 'dsv-p-art' USING D-ART-P-IN.
           IF ERRIO-ST > ZERO GO TO ERRIO.
      *------------------
       VER-DELETE.

           OPEN INPUT MAGART.

           MOVE 'dsv-art-f' TO D-ODBC-PROC.

      * exec
           MOVE ZERO TO D-GET-LOOP.
           MOVE 1 TO D-ODBC-FUN.
       VER-10.
           CALL 'dsv-odbc' USING D-ODBC-CTR D-GET-P-IN D-GET-P-OUT.
           IF D-ODBC-ST > ZERO
              MOVE D-ODBC-MSG TO F-MES1
              MOVE 1 TO F-NMES
              IF D-ODBC-SQLERRMC NOT = SPACE
                 MOVE D-ODBC-SQLERRMC TO F-MES2
                 MOVE 2 TO F-NMES
              END-IF
              GO TO ERRIO.
           IF D-GET-LOOP NOT = 1 GO TO VER-99.
      *
           IF CDR-KEY(1:3) NOT NUMERIC OR
              D-GET-KEY(4:18) = SPACE
                 GO TO VER-90.
      *
           MOVE CDR-KEY(1:3)    TO KMA-AZI.
           MOVE D-GET-KEY(4:18) TO KMA-ART.
           READ MAGART INVALID GO TO VER-50.
      *
           GO TO VER-90.
      *
       VER-50.
      *
           MOVE ZERO TO PPAR-FUN.
           MOVE 'ART'    TO PPAR-TARC.
           MOVE 'c'      TO PPAR-TOPE.
      **** rel 7.2
      *    MOVE KEYMA    TO PPAR-KEY.
           MOVE D-GET-ID   TO PPAR-KEY.
      ************
           MOVE D-GET-UUID TO PPAR-OPZ.
           MOVE ZERO     TO PPAR-CATT.
           CALL 'vsrv133' USING PARPPAR TIP.
           IF PPAR-ERR > 1 
              MOVE 'Errore vsrv133 ART' TO F-MES1
              GO TO ERRIO.
      *
       VER-90.
           GO TO VER-10.
       VER-99.
           CLOSE MAGART.
      *
       EX-VER-DELETE.
           EXIT.
      *-------------*
