       IDENTIFICATION DIVISION.
       PROGRAM-ID. VEFF180.
      *
      * OGGETTO: Raggruppamento automatico effetti
      *
      **** rel 5.0
      * Ricompilato per variazione tracciato EFFETT
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'grieffsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'grieff'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-EFF PIC X(15) VALUE 'effett'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-EFF   PIC XX.
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 K        PIC 99.
           05 WDTSCA   PIC 9(5) COMP-3.
           05 WTDOCF   PIC 9.
           05 WCDCLI   PIC 9(5).
           05 WCDBAN   PIC 9(5).
           05 WSTATU   PIC 9.
           05 DTFAT    PIC 9(5) COMP-3 OCCURS 5.
           05 NFAT     PIC 9(5)        OCCURS 5.
           05 NEFF     PIC 9(5)        OCCURS 5.
      **** rel 4.0
      *    05 IMP      PIC S9(11)      OCCURS 5.
           05 IMP      PIC S9(11)V99   OCCURS 5.
      ************
           05 PKSCAD1  PIC 9(5) COMP-3.
           05 PKSCAD2  PIC 9(5) COMP-3.
           05 CONTA    PIC 9(6).
           05 SWCON    PIC 9.
      **** rel 4.0
      *    05 TOTIMP   PIC S9(11).
      *    05 TOTBOL   PIC S9(11).
           05 TOTIMP   PIC S9(11)V99.
           05 TOTBOL   PIC S9(11)V99.
      ************
           05 COMX     PIC S9(11).
           05 COMXR REDEFINES COMX.
              10 FILLER PIC 9(8).
              10 ULT3   PIC 999.
           05 COMBOL PIC 9(14).
           05 COMBLR REDEFINES COMBOL.
              10 FILLER PIC 9(12).
              10 ULT2   PIC 99.
           05 PERCB PIC 9(3)V99.
      **** rel 5.1-1
           05 FLGEND PIC 9 VALUE ZERO.
      **************
       01  RTABBL.
           05 TBL PIC S9(7) OCCURS 6.
       01  RTABRB.
           05 TRB PIC S9(11) OCCURS 6.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-TIPO      PIC 9.
           05 IF-COD-1     PIC 9(5).
           05 IF-COD-2     PIC 9(5).
           05 IF-DTSCA-1   PIC 9(6).
           05 IF-DTSCA-2   PIC 9(6).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcleff'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'veff180: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI EFFETT TABELL.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'grieffer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           OPEN INPUT ANAAZI TABELL.
           OPEN I-O EFFETT.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 3  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-ALIQ TO PERCB.
           MOVE ZERO TO K.
       CRBOL.
           ADD 1 TO K.
      **** rel 4.0
      *    MOVE T14-IMPS(K) TO TRB(K).
      *    MOVE T14-IMPB(K) TO TBL(K).
           COMPUTE TRB(K) = T14-IMPS(K) * 100.
           COMPUTE TBL(K) = T14-IMPB(K) * 100.
      ************
      **** rel 4.0
      *    IF T14-IMPS(K) = 999999999
           IF T14-IMPS(K) = 9999999,99
      ************
                    MOVE  99999999999 TO TRB(K).
           IF K < 6 GO TO CRBOL.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE 2       TO IF-TIPO.
           MOVE ZERO    TO IF-COD-1 
                           IF-COD-2
                           IF-DTSCA-1 
                           IF-DTSCA-2.
           MOVE ZERO TO PKSCAD1
                        PKSCAD2.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-TIPO.
           MOVE 'IF-TIPO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TIPO.
           IF NOT (IF-TIPO = 1 OR 2)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TIPO.
      *
       V-COD-1.
           MOVE 'IF-COD-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-1.
           IF IF-COD-1 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-COD-1.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
       V-DTSCA-1.
            MOVE 'IF-DTSCA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTSCA-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTSCA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKSCAD1.
       E-DTSCA-1.
      *
       V-DTSCA-2.
           MOVE 'IF-DTSCA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTSCA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTSCA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKSCAD2.
           IF PKSCAD2 < PKSCAD1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DTSCA-2.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
      *
       RAG23.
           MOVE ZERO TO CONTA SWCON.
           MOVE ZERO TO WDTSCA WTDOCF WCDCLI WCDBAN WSTATU.
      **** rel 5.1-1
           MOVE ZERO TO FLGEND.
      **************
           MOVE ZERO TO K.
       RAG24.
           ADD 1 TO K.
           IF K > 5 GO TO RAG24A.
           MOVE ZERO TO NEFF(K) IMP(K) NFAT(K) DTFAT(K).
           GO TO RAG24.
       RAG24A.
           MOVE KAZ-COD  TO KEF-AZI.
           MOVE IF-TIPO  TO KEF-TIPO.
           MOVE IF-COD-1 TO KEF-NUM.
      **** rel 5.1-1
      *    START EFFETT KEY NOT < KEYEF INVALID GO TO RAG100.
           START EFFETT KEY NOT < KEYEF INVALID MOVE 1 TO FLGEND
                                                GO TO RAG100.
      **************
       RAG25.
           READ EFFETT NEXT AT END GO TO RAG100.
           IF SF-EFF = '9D' OR '9A' OR '35' GO TO RAG25.
           IF KEF-AZI  > KAZ-COD  GO TO RAG100.
           IF KEF-TIPO > IF-TIPO  GO TO RAG100.
           IF KEF-NUM  > IF-COD-2 GO TO RAG100.
           IF CONTA > ZERO PERFORM D00-CONTROLLO-EFFETTO THRU D99
                           GO TO RAG27.
           IF EFF-NUFT2 NOT = ZERO GO TO RAG25.
           IF EFF-FLGDS NOT = ZERO GO TO RAG25.
           IF EFF-DTSCA < PKSCAD1  GO TO RAG25.
           IF EFF-DTSCA > PKSCAD2  GO TO RAG25.
      **** rel 6.3
           IF EFF-CIG NOT = SPACE OR
              EFF-CUP NOT = SPACE GO TO RAG25.
      ************
       RAG27.
           IF SWCON = 1 GO TO RAG25.
           ADD 1 TO CONTA.
           IF CONTA > 5 GO TO RAG100.
           IF CONTA = 1 MOVE EFF-DTSCA TO WDTSCA
                        MOVE EFF-TDOCF TO WTDOCF
                        MOVE EFF-CDCLI TO WCDCLI
                        MOVE EFF-CDBAN TO WCDBAN
                        MOVE EFF-STATU TO WSTATU.
           MOVE KEF-NUM   TO NEFF (CONTA).
           MOVE EFF-IMPOR TO IMP  (CONTA).
           MOVE EFF-NUFAT TO NFAT (CONTA).
           MOVE EFF-DTFAT TO DTFAT(CONTA).
           GO TO RAG25.
       RAG100.
      **** rel 5.1-1
      *    IF NEFF(1) = ZERO GO TO END-RUN-ELABORA.
           IF FLGEND = 1 GO TO END-RUN-ELABORA.
           IF NEFF(1) = ZERO 
      **** rel 5.2
      *       IF NOT (IF-COD-1 > IF-COD-2)
              IF IF-COD-1 < IF-COD-2
      ************
                 COMPUTE IF-COD-1 = IF-COD-1 + 1
                 GO TO RAG23
              ELSE GO TO END-RUN-ELABORA.
      **************
           IF NEFF(2) = ZERO COMPUTE IF-COD-1 = NEFF(1) + 1
                             GO TO RAG23.
           ADD IMP(1) IMP(2) IMP(3) IMP(4) IMP(5) GIVING TOTIMP.
      *
           MOVE KAZ-COD TO KEF-AZI.
           MOVE IF-TIPO TO KEF-TIPO.
           MOVE NEFF(1) TO KEF-NUM.
           READ EFFETT INVALID KEY PERFORM INVK-EFF GO TO ERRIO.
           MOVE TOTIMP   TO EFF-IMPOR.
      **** rel 5.0
           MOVE IMP(1)   TO EFF-IMEF1.
      ************
           MOVE NFAT (2) TO EFF-NUFT2.
           MOVE DTFAT(2) TO EFF-DTFT2.
      **** rel 5.0
           MOVE IMP(2)   TO EFF-IMEF2.
      ************
           MOVE NFAT (3) TO EFF-NUFT3.
           MOVE DTFAT(3) TO EFF-DTFT3.
      **** rel 5.0
           MOVE IMP(3)   TO EFF-IMEF3.
      ************
           MOVE NFAT (4) TO EFF-NUFT4.
           MOVE DTFAT(4) TO EFF-DTFT4.
      **** rel 5.0
           MOVE IMP(4)   TO EFF-IMEF4.
      ************
           MOVE NFAT (5) TO EFF-NUFT5.
           MOVE DTFAT(5) TO EFF-DTFT5.
      **** rel 5.0
           MOVE IMP(5)   TO EFF-IMEF5.
      ************
           PERFORM E00-BOLLI THRU E99.
           MOVE TOTBOL TO EFF-IMBOL.
           REWRITE RF-EFF INVALID KEY PERFORM INVK-EFF GO TO ERRIO.
           MOVE NEFF(2) TO KEF-NUM.
           READ EFFETT INVALID PERFORM INVK-EFF GO TO ERRIO.
           DELETE EFFETT INVALID PERFORM INVK-EFF GO TO ERRIO.
           IF NEFF(3) = ZERO GO TO RAG110.
           MOVE NEFF(3) TO KEF-NUM.
           READ EFFETT INVALID PERFORM INVK-EFF GO TO ERRIO.
           DELETE EFFETT INVALID PERFORM INVK-EFF GO TO ERRIO.
           IF NEFF(4) = ZERO GO TO RAG110.
           MOVE NEFF(4) TO KEF-NUM.
           READ EFFETT INVALID PERFORM INVK-EFF GO TO ERRIO.
           DELETE EFFETT INVALID PERFORM INVK-EFF GO TO ERRIO.
           IF NEFF(5) = ZERO GO TO RAG110.
           MOVE NEFF(5) TO KEF-NUM.
           READ EFFETT INVALID PERFORM INVK-EFF GO TO ERRIO.
           DELETE EFFETT INVALID PERFORM INVK-EFF GO TO ERRIO.
       RAG110.
      **** rel 7.2
           IF NEFF(1) = 99999 GO TO EX-RUN-ELABORA.
      ************
           COMPUTE IF-COD-1 = NEFF(1) + 1.
           GO TO RAG23.
      *
       END-RUN-ELABORA.
      *
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       D00-CONTROLLO-EFFETTO.
           MOVE ZERO TO SWCON.
           IF EFF-DTSCA NOT = WDTSCA MOVE 1 TO SWCON.
           IF EFF-TDOCF NOT = WTDOCF MOVE 1 TO SWCON.
           IF EFF-CDCLI NOT = WCDCLI MOVE 1 TO SWCON.
           IF EFF-CDBAN NOT = WCDBAN MOVE 1 TO SWCON.
           IF EFF-NUFT2 NOT = ZERO   MOVE 1 TO SWCON.
           IF EFF-STATU NOT = WSTATU MOVE 1 TO SWCON.
           IF EFF-FLGDS     = 1      MOVE 1 TO SWCON.
       D99.
           EXIT.
      *------------------
       E00-BOLLI.
           MOVE ZERO TO TOTBOL.
           IF IF-TIPO = 1 GO TO E50.
      **** rel 4.0
      *    MOVE EFF-IMPOR TO COMBOL.
           COMPUTE COMBOL = EFF-IMPOR * 100.
      ************
           MOVE ZERO TO K.
       E10.
           ADD 1 TO K.
           IF K > 6 MOVE 6 TO K GO TO E20.
           IF COMBOL NOT > TRB (K) GO TO E20.
           GO TO E10.
       E20.
      **** rel 4.0
      *    MOVE TBL (K) TO TOTBOL.
           COMPUTE TOTBOL = TBL (K) / 100.
      ************
           GO TO E99.
       E50.
      **** rel 4.0
      *    MOVE EFF-IMPOR TO COMX.
           COMPUTE COMX = EFF-IMPOR * 100.
      ************
           MOVE ZERO TO ULT3.
           COMPUTE COMBOL = COMX * PERCB.
           COMPUTE COMBOL = COMBOL / 1000.
           COMPUTE COMBOL = COMBOL + 49.
           MOVE ZERO TO ULT2.
      **** rel 4.0
      *    MOVE COMBOL TO TOTBOL.
           COMPUTE TOTBOL = COMBOL / 100.
      ************
       E99.
           EXIT.
      *------------------
