       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORDG10.
      *
      *    Interfaccia ORDCLI per scheda
      *
      **** rel 2.0
      * Valori particolari di FUN
      *    G = genera un nuovo cliente partendo dal contatto della
      *        offerta selezionata. Tutte le offerte del contatto
      *        in questione vengono riattribuite al nuovo cliente.
      ************
      **** rel 5.0
      * Ricompilato per variazione tracciato ANABAN
      ************
      **** rel 6.2
      *    c = Duplicazione
      *    w = Valida tutto solo nella duplicazione
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griclfsl'.
           COPY 'griartsl'.
           COPY 'griardsl'.
           COPY 'griordsl'.
           COPY 'gririgsl'.
           COPY 'griobcsl'.
           COPY 'gribansl'.
           COPY 'griirisl'.
      **** rel 2.0
      **** rel 6.1
      *    COPY 'griporsl'.
      *    COPY 'grinrisl'.
      ************
           COPY 'grifctsl'.
      ************
           COPY 'gritabsl'.
      **** rel 6.2
           COPY 'griorcsl'.
      ************
      **** rel 7.1
           COPY 'griaorsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griclf'.
           COPY 'griart'.
           COPY 'griard'.
           COPY 'griord'.
           COPY 'gririg'.
           COPY 'griobc'.
           COPY 'griban'.
           COPY 'griiri'.
      **** rel 2.0
      **** rel 6.1
      *    COPY 'gripor'.
      *    COPY 'grinri'.
      ************
           COPY 'grifct'.
      ************
           COPY 'gritab'.
      **** rel 6.2
           COPY 'griorc'.
      ************
      **** rel 7.1
           COPY 'griaor'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'grit28rk'.
           COPY 'grit35rk'.
      **** rel 5.2
           COPY 'grit30rk'.
      ************
           COPY 'rekt52'.
           COPY 'griclfrk'.
           COPY 'griartrk'.
           COPY 'griardrk'.
           COPY 'griordrk'.
           COPY 'gririgrk'.
      **** rel 2.0
           COPY 'grifctrk'.
      ************
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parfi'.
      **** rel 1.2
           COPY 'parer'.
           COPY 'parlk'.
      ************
      **** rel 5.0
           COPY 'parmb'.
      **** rel 6.1
      *    COPY 'parbc'.
      ************
           COPY 'paroc'.
      ************
      **** rel 5.1
           COPY 'parve'.
           COPY 'parppar'.
      ************
      **** rel 6.2
       01 PARDUO.
          05 DUO-KEYOR.
             10 DUO-AZI PIC 9(3).
             10 DUO-NUM PIC 9(5).
          05 DUO-CLI    PIC 9(5).
          05 DUO-FLAF   PIC 9.
          05 DUO-FLLAQ  PIC 9.
          05 DUO-DTORD  PIC 9(6).
          05 DUO-NEWORD PIC 9(5).
      ************
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-ART PIC X(15) VALUE 'magart'.
       01  ID-ARD PIC X(15) VALUE 'magard'.
       01  ID-ORD PIC X(15) VALUE 'ordcli'.
       01  ID-RIG PIC X(15) VALUE 'ordrig'.
       01  ID-OBC PIC X(15) VALUE 'bolord'.
       01  ID-BAN PIC X(15) VALUE 'anaban'.
       01  ID-LIS PIC X(15) VALUE 'listin'.
       01  ID-IRI PIC X(15) VALUE 'indiri'.
      **** rel 2.0
      **** rel 6.1
      *01  ID-POR PIC X(15) VALUE 'prorig'.
      *01  ID-NRI PIC X(15) VALUE 'notrig'.
      ************
       01  ID-FCT PIC X(15) VALUE 'offcli'.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
      **** rel 6.2
       01  ID-ORC PIC X(15) VALUE 'ordric'.
      ************
      **** rel 7.1
       01  ID-AOR PIC X(15) VALUE 'appord'.
      ************
       01  COMODI.
           05 SF-CLF   PIC XX.
           05 SF-ART   PIC XX.
           05 SF-ARD   PIC XX.
           05 SF-ORD   PIC XX.
           05 SF-RIG   PIC XX.
           05 SF-OBC   PIC XX.
           05 SF-BAN   PIC XX.
           05 SF-LIS   PIC XX.
           05 SF-IRI   PIC XX.
      **** rel 2.0
      **** rel 6.1
      *    05 SF-POR   PIC XX.
      *    05 SF-NRI   PIC XX.
      ************
           05 SF-FCT   PIC XX.
      ************
           05 SF-TAB   PIC XX.
      **** rel 6.2
           05 SF-ORC   PIC XX.
      ************
      **** rel 7.1
           05 SF-AOR   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(30).
           05 IF-AZI   PIC 9(3).
           05 CODCLI.
              10 MAS   PIC 99.
              10 COD   PIC 9(5).
           05 VAAGGG   PIC 9(5) COMP-3.
           05 SW-ESBOL PIC 9.
           05 RESID    PIC S9(9)V999.
      **** rel 4.0
           05 COMEURO PIC 9(3) VALUE ZERO.
      ************
      **** rel 5.1
           05 VALUT   PIC 9(3) VALUE ZERO.
      ************
      **** rel 5.1-1 
           05 DTINT   PIC 9(5) VALUE ZERO.
      ************** 
      **** rel 6.1
           05 COMDTCSR   PIC 9(5) COMP-3.
           05 COMDTCSC   PIC 9(5) COMP-3.
      ************
      **** rel 6.2
           05 SWINS     PIC 9.
           05 I         PIC 99    VALUE ZERO.
      ************
      * area parametri per call vordg11
       01  PARG11.
           05 G11-AZI  PIC 999  VALUE ZERO.
           05 G11-CTT  PIC 9(5) VALUE ZERO.
           05 G11-CLI  PIC 9(5) VALUE ZERO.
           05 G11-ST   PIC 9    VALUE ZERO.
      **** rel 5.0       
      **** rel 6.1
      *    05 COMDTCSR   PIC 9(5) COMP-3.
      *    05 COMDTCSC   PIC 9(5) COMP-3.
      ************
      **** rel 6.1
      *01  PAR-D-MDT.
      *    05 D-MDT-AZI  PIC 999.
      *    05 D-MDT-TDOC PIC 9.
      *    05 D-MDT-KEY  PIC X(15).
      ************
      ************
      **** rel 6.2
           COPY 'parorc'.
      ************
      **** rel 6.3
       01  PAR-D-MDT.
           05 D-MDT-AZI  PIC 999.
           05 D-MDT-TDOC PIC 9.
           05 D-MDT-KEY  PIC X(15).
      ************
       LINKAGE SECTION.
           COPY 'griordrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-ORD-CTRL
                                RG-ORD-REC
                                RA-ORD-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclclf'.
           COPY 'dclart'.
           COPY 'dclard'.
           COPY 'dclord'.
           COPY 'dclrig'.
           COPY 'dclobc'.
           COPY 'dclban'.
           COPY 'dcliri'.
      **** rel 2.0
      **** rel 6.1
      *    COPY 'dclpor'.
      *    COPY 'dclnri'.
      ************
           COPY 'dclfct'.
      ************
           COPY 'dcltab'.
      **** rel 6.2
           COPY 'dclorc'.
      ************
      **** rel 7.1
           COPY 'dclaor'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-ORD-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-ORD-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-ORD-FUN   TO FUN.
           MOVE RG-ORD-IDX   TO IDX.
           MOVE RG-ORD-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-ORD-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
      **** rel 6.2
                    'w' OR
      ************
                    'W' GO TO F-WALIDA.
      **** rel 2.0
           IF FUN = 'G' GO TO F-CONV-CTT-CLI.
      ************
      **** rel 6.2
           IF FUN = 'c' GO TO F-DUPLIC.
      ************
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vordg10: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-ORD-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
      **** rel 6.2
           MOVE 1 TO SWINS.
      ************
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-ORD-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-ORD-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK ORDCLI.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-ORD INVALID
              PERFORM INVK-ORD
              GO TO ERRIO.
      **** rel 6.2
           IF RA-ORD-NRORC = ZERO GO TO NO-W-ORC.
           MOVE ZERO TO RF-ORC.
           MOVE KOR-AZI TO KORC-AZI.
           MOVE KOR-NUM TO KORC-ORD.
           MOVE RA-ORD-NRORC TO ORC-ORD.
           WRITE RF-ORC INVALID PERFORM INVK-ORC
                                GO TO ERRIO.
       NO-W-ORC.
      ************
      **** rel 7.1
           MOVE KOR-AZI TO KAOR-AZI.
           MOVE KOR-NUM TO KAOR-NUM.
           WRITE RF-AOR INVALID
              PERFORM INVK-AOR
              GO TO ERRIO.
      *
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-ORD INVALID
              PERFORM INVK-ORD
              GO TO ERRIO.
      **** rel 5.0
           IF (COMDTCSC NOT = ORD-DTCSC) OR (COMDTCSR NOT = ORD-DTCSR)
              PERFORM MOD-DAT-RIG THRU EX-MOD-DAT-RIG.
      ************
      **** rel 5.1
           IF ORD-VALUT = VALUT 
              PERFORM MOD-LVE-RIG THRU EX-MOD-LVE-RIG.
      ************
      **** rel 6.2
           MOVE KOR-AZI TO KORC-AZI.
           MOVE KOR-NUM TO KORC-ORD.
           READ ORDRIC.

           IF SF-ORC = ZERO
              IF RA-ORD-NRORC = ZERO
                 DELETE ORDRIC INVALID PERFORM INVK-ORC
                                       GO TO ERRIO
              ELSE
                 MOVE RA-ORD-NRORC TO ORC-ORD
                 REWRITE RF-ORC INVALID PERFORM INVK-ORC
                                        GO TO ERRIO
           ELSE
              IF RA-ORD-NRORC NOT = ZERO
                 MOVE ZERO TO RF-ORC
                 MOVE KOR-AZI TO KORC-AZI
                 MOVE KOR-NUM TO KORC-ORD
                 MOVE RA-ORD-NRORC TO ORC-ORD
                 WRITE RF-ORC INVALID PERFORM INVK-ORC
                                      GO TO ERRIO.
      ************
      **** rel 7.1
           MOVE KOR-AZI TO KAOR-AZI.
           MOVE KOR-NUM TO KAOR-NUM.           
           REWRITE RF-AOR INVALID
              PERFORM CREA-APPORD THRU EX-CREA-APPORD.
      ************
           UNLOCK ORDCLI.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-ORD
              GO TO WARNING.
           IF RG-ORD-ST = 7 GO TO FINE.
      **** rel 6.3
      **** rel 5.0
      *    MOVE KOR-AZI TO OC-AZI.
      *    MOVE KOR-NUM TO OC-NUM.
      *    CALL 'vrvopc' USING PAROC.
      ************
      ************
           PERFORM F00-GES-OBC THRU F99.
      **** rel 5.0
           IF SW-ESBOL > ZERO AND OC-FLG = 1
              MOVE 'Esistono bolle di uscita' TO F-MES1
              MOVE 'Vuoi annullare'           TO F-MES2
              MOVE 2 TO F-NMES
              MOVE 'Q' TO MB-TIPO
              MOVE '1' TO MB-DEFAULT
              CALL 'vrmbox' USING PARMB
              IF MB-RISP = 'S'
                 GO TO F-DELETE-10.
      ************
           IF SW-ESBOL > ZERO
              MOVE 'Emesse bolle: ordine non annullabile' TO MESS
              GO TO WARNING.
      **** rel 5.0
       F-DELETE-10.
      ************
           PERFORM C00-DEL-RIG THRU C99.
      **** rel 6.2
           MOVE KOR-AZI TO KORC-AZI.
           MOVE KOR-NUM TO KORC-ORD.
           READ ORDRIC NOT INVALID
                DELETE ORDRIC INVALID PERFORM INVK-ORC
                                      GO TO ERRIO.
      ************
           PERFORM DB-STORNA THRU EX-DB-STORNA.
      **** rel 6.1
           CALL 'vrdlord' USING KEYOR.
      ************
           DELETE ORDCLI INVALID
              PERFORM INVK-ORD
              GO TO ERRIO.
      **** rel 7.1
           MOVE KOR-AZI TO KAOR-AZI.
           MOVE KOR-NUM TO KAOR-NUM.
           DELETE APPORD.
      ************
           UNLOCK ORDCLI.
      **** rel 6.1
      **** rel 5.0      
      *    MOVE KOR-AZI TO D-MDT-AZI
      *    MOVE 4       TO D-MDT-TDOC
      *    MOVE KEYOR   TO D-MDT-KEY
      *    CALL 'vrdlmdt' USING PAR-D-MDT.
      ************            
      ************
      **** rel 6.3
           MOVE KOR-AZI TO D-MDT-AZI
           MOVE 4       TO D-MDT-TDOC
           MOVE KEYOR   TO D-MDT-KEY
           CALL 'vrdlmdt' USING PAR-D-MDT.
      ************
      **** rel 5.1
           MOVE ZERO      TO PPAR-FUN.
           MOVE 'ORD'     TO PPAR-TARC.
           MOVE 'C'       TO PPAR-TOPE.
           MOVE KEYOR     TO PPAR-KEY.
           MOVE SPACE     TO PPAR-OPZ.
      **** rel 5.1-1 
      *    MOVE ORD-DAT   TO PPAR-OPZ(1:3).
      *    MOVE ORD-CDCLI TO PPAR-OPZ(4:5).
           MOVE ORD-DAT   TO DTINT.
           MOVE DTINT     TO PPAR-OPZ(1:5).
           MOVE ORD-CDCLI TO PPAR-OPZ(6:5).
           MOVE ZERO      TO PPAR-CATT.
      ************** 
           CALL 'vsrv130' USING PARPPAR.
           IF PPAR-ERR > 1 
              MOVE SPACE TO MESS
              STRING 'Errore chiamata vsrv130. Errore ' PPAR-ERR
                      DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      ************
           GO TO FINE.
      **** rel 2.0
      * - - - - - *
       F-CONV-CTT-CLI.
           IF FCT-TIPO = ZERO GO TO F-CONV-CTT-CLI-90.
      **** rel 7.1
           MOVE ZERO      TO PARG11.
      **********
           MOVE FCT-AZI   TO G11-AZI.
           MOVE FCT-CDCLI TO G11-CTT.
           CALL 'vordg11' USING PARG11.
           IF G11-ST = 9 GO TO ERRIO.
           MOVE SPACE TO F-MES1.
           STRING 'Caricato cliente ' G11-CLI
                  DELIMITED SIZE INTO F-MES1.
           MOVE 'Vuoi completare i suoi dati ?' TO F-MES2.
           MOVE 2 TO F-NMES.
           MOVE G11-CLI TO RG-ORD-CDCLI.
           GO TO QUESTION.
       F-CONV-CTT-CLI-90.
           GO TO FINE.
      ************
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-ORD-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK ORDCLI.
           GO TO CHIUDI.
      * - - - - - *
      **** rel 6.2
       F-DUPLIC.
           MOVE ZERO TO PARDUO.
           MOVE RG-ORD-AZI    TO DUO-AZI.
           MOVE RG-ORD-NUM    TO DUO-NUM.
           MOVE RA-ORD-CDCLI1 TO DUO-CLI.
           MOVE RA-ORD-FLAF   TO DUO-FLAF.
           MOVE RA-ORD-FLLAQ  TO DUO-FLLAQ.
           MOVE RA-ORD-DTORD  TO DUO-DTORD.
           CALL 'vdupord' USING PARDUO.
           IF ERRIO-ST > ZERO GO TO ERRIO.
      *
           MOVE SPACE TO F-MES1.
      **** rel 6.3
           MOVE DUO-NEWORD TO RG-ORD-NUM.
      ************
           STRING 'Generato ordine n. ' DUO-NEWORD
                  DELIMITED SIZE INTO F-MES1.
           MOVE 1 TO F-NMES.
           MOVE 8 TO ERRIO-ST.
           GO TO FINE.
      * - - - - - *
      ************
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-ORD-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANACLF ANABAN INDIRI.
           CLOSE TABELL MAGART MAGARD ORDCLI ORDRIG BOLORD.
      **** rel 6.1
      **** rel 2.0
      *    CLOSE PRORIG NOTRIG.
      ************
      ************
      **** rel 6.2
           CLOSE ORDRIC.
      ************
      **** rel 7.1
           CLOSE APPORD.
      ************
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-ORD-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-ORD-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
      **** rel 1.2
           COPY 'erreur'.
      ************
           COPY 'griclfer'.
           COPY 'griarter'.
           COPY 'griarder'.
           COPY 'griorder'.
           COPY 'gririger'.
           COPY 'griobcer'.
           COPY 'gribaner'.
           COPY 'griirier'.
      **** rel 2.0
      **** rel 6.1
      *    COPY 'griporer'.
      *    COPY 'grinrier'.
      ************
           COPY 'grifcter'.
      ************
           COPY 'gritaber'.
      **** rel 6.2
           COPY 'griorcer'.
      ************
      **** rel 7.1
           COPY 'griaorer'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN INPUT ANACLF ANABAN INDIRI.
           OPEN I-O TABELL MAGART MAGARD ORDCLI ORDRIG BOLORD.
      **** rel 6.1
      **** rel 2.0
      *    OPEN I-O PRORIG NOTRIG.
      ************
      ************
      **** rel 6.2
           OPEN I-O ORDRIC.
      ************
      **** rel 7.1
           OPEN I-O APPORD.
      ************
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
      *
      **** rel 4.0
           CALL 'rveur' USING COMEURO.
      ************
           MOVE 1 TO SWINI.
      **** rel 6.2
           MOVE ZERO TO SWINS.
      ************
           MOVE ZERO TO RG-ORD-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-ORD REKORD.
           MOVE ZERO TO ORD-DAT ORD-DTCSR ORD-DTCSC ORD-CATT ORD-LISRF.
           MOVE SPACE TO ORD-ZONA ORD-VSORD ORD-COMME.
      **** rel 7.1
           MOVE SPACE TO AOR-IPA AOR-CIG AOR-CUP.
      ************
      **** rel 7.2
           MOVE SPACE TO AOR-FAORD.
      ************
      *
           MOVE REKORD TO RF-ORD.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-ORD-AZI TO IF-AZI.

      * azzeramento aree interfaccia
           MOVE ZERO  TO RG-ORD-REC.
           MOVE SPACE TO RG-ORD-ZONA RG-ORD-VSORD RG-ORD-COMME.
      **** rel 7.1
           MOVE SPACE TO RG-ORD-IPA RG-ORD-CIG RG-ORD-CUP.
      ************
      **** rel 7.2
           MOVE SPACE TO RG-ORD-FAORD.
      ************
           MOVE SPACE TO RA-ORD-AGG.
      **** rel 6.2
           MOVE ZERO TO RA-ORD-NRORC.
      ************

      * ripristino dei campi chiave fissi
           MOVE IF-AZI TO RG-ORD-AZI.
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
           MOVE 28         TO T28-TIP.
           MOVE RG-ORD-AZI TO T28-COD.
           MOVE 'D'        TO T28-PRG.
           MOVE T28-KEYID TO KEYTB.
       RD1-TB28D.
           READ TABELL INTO REKT28 KEPT LOCK INVALID
                                             PERFORM INVK-TAB
                                             GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35'
                             PERFORM REC-LOCK
                             GO TO RD1-TB28D.
           COMPUTE RG-ORD-NUM = T28-NORDC + 1.

      **** rel 5.2
           MOVE 30         TO T30-TIP.
           MOVE RG-ORD-AZI TO T30-COD.
           MOVE '0'        TO T30-PRG.
           MOVE T30-KEYID TO KEYTB.
           READ TABELL INTO REKT30 INVALID MOVE ZERO TO T30-DEPCA
                                           MOVE ZERO TO T30-DEPSC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT30.
           MOVE T30-DEPSC TO RG-ORD-CDEP.
      ************
      *
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO RG-ORD-DAT.
           MOVE AA9 TO GG9.
           MOVE RG-ORD-DAT TO AA9.
           MOVE GGMMAA TO RG-ORD-DAT.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
      **** rel 2.0
           IF RG-ORD-NUM NOT > T28-NORDC GO TO INS-OK-90.
      ************
           MOVE RG-ORD-NUM TO T28-NORDC.
           REWRITE RF-TAB FROM REKT28 INVALID
                          PERFORM INVK-TAB
                          GO TO ERRIO.
      **** rel 2.0
       INS-OK-90.
      ************
           UNLOCK TABELL.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
           MOVE 28         TO T28-TIP.
           MOVE RG-ORD-AZI TO T28-COD.
           MOVE 'D'        TO T28-PRG.
           MOVE T28-KEYID TO KEYTB.
       RD2-TB28D.
           READ TABELL INTO REKT28 KEPT LOCK INVALID
                                             PERFORM INVK-TAB
                                             GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35'
                             PERFORM REC-LOCK
                             GO TO RD2-TB28D.
           IF RG-ORD-NUM NOT = T28-NORDC GO TO ULCKT.
           SUBTRACT 1 FROM T28-NORDC.
           REWRITE RF-TAB FROM REKT28 INVALID
                          PERFORM INVK-TAB
                          GO TO ERRIO.
       ULCKT.
           UNLOCK TABELL.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-ORD-AZI TO KOR-AZI.
           MOVE RG-ORD-NUM TO KOR-NUM.
           MOVE KEYOR TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYOR.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ ORDCLI INTO REKORD INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-ORD = '9D' OR '9A' OR '35' MOVE RF-ORD TO REKORD.
      **** rel 7.1
           MOVE KOR-AZI TO KAOR-AZI.
           MOVE KOR-NUM TO KAOR-NUM.
           READ APPORD INVALID 
                PERFORM CREA-APPORD THRU EX-CREA-APPORD.
      ************
           GO TO EX-READ-K.
      *
       RDK-10.
           READ ORDCLI INTO REKORD KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-ORD > ZERO MOVE 7 TO RG-ORD-ST.
      **** rel 7.1
           MOVE KOR-AZI TO KAOR-AZI.
           MOVE KOR-NUM TO KAOR-NUM.
           READ APPORD INVALID 
                PERFORM CREA-APPORD THRU EX-CREA-APPORD.
      ************
      *
       EX-READ-K.
           EXIT.
      *------------------
      * posizionamento su chiave secondaria per successive
      * read next/previous
      *
       SET-KEYSEC.
           MOVE KEYOR TO KRIFER.
           START ORDCLI KEY >= SKEYOR1 INVALID GO TO SET-90.
       SET-10.
           READ ORDCLI NEXT INTO REKORD AT END GO TO SET-90.
           IF KEYOR = KRIFER GO TO EX-SET-KEYSEC.
           GO TO SET-10.
       SET-90.
           MOVE 'vordg10: errore di posizionamento su' TO F-MES1.
           MOVE 'chiave secondaria'                   TO F-MES2.
           MOVE 2 TO F-NMES.
           GO TO ERRIO.
       EX-SET-KEYSEC.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
           IF IDX > 1 PERFORM SET-KEYSEC THRU EX-SET-KEYSEC.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ ORDCLI PREVIOUS INTO REKORD AT END MOVE 1 TO EOF
           ELSE
              READ ORDCLI NEXT INTO REKORD AT END MOVE 3 TO EOF.
      **** rel 7.1
           MOVE KOR-AZI TO KAOR-AZI.
           MOVE KOR-NUM TO KAOR-NUM.
           READ APPORD INVALID 
                PERFORM CREA-APPORD THRU EX-CREA-APPORD.
      ************
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-ORD = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *
           IF KOR-AZI NOT = RG-ORD-AZI GO TO RNP-10.

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-ORD-EOF.
           MOVE KEYOR TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-ORD-EOF.
           IF RG-ORD-EOF = 4 MOVE 2 TO RG-ORD-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-ORD = LOW-VALUE GO TO EX-TEST-EOL.
           IF IDX > 1 GO TO TEST-EOL-IDX2.
           IF KOR-AZI = RG-ORD-AZI GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       TEST-EOL-IDX2.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-ORD-AZI     TO ORD-AZI.
           MOVE RG-ORD-NUM     TO ORD-NUM.
           MOVE RG-ORD-DAT TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ORD-DAT.
           MOVE RG-ORD-CDCLI   TO ORD-CDCLI.
           MOVE RG-ORD-ZONA    TO ORD-ZONA.
           MOVE RG-ORD-CDAGE   TO ORD-CDAGE.
           MOVE RG-ORD-PROVV   TO ORD-PROVV.
           MOVE RG-ORD-CDPAG   TO ORD-CDPAG.
           MOVE RG-ORD-CDBAN   TO ORD-CDBAN.
           MOVE RG-ORD-CDSPE   TO ORD-CDSPE.
           MOVE RG-ORD-CDPOR   TO ORD-CDPOR.
           MOVE RG-ORD-PERSC   TO ORD-PERSC.
           MOVE RG-ORD-DTCSR TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ORD-DTCSR.
           MOVE RG-ORD-DTCSC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ORD-DTCSC.
           MOVE RG-ORD-CDESE   TO ORD-CDESE.
           MOVE RG-ORD-VSORD   TO ORD-VSORD.
           MOVE RG-ORD-COMME   TO ORD-COMME.
           MOVE RG-ORD-CDEP    TO ORD-CDEP.
           MOVE RG-ORD-VALUT   TO ORD-VALUT.
           MOVE RG-ORD-LCONS   TO ORD-LCONS.
           MOVE RG-ORD-CATT    TO ORD-CATT.
           MOVE RG-ORD-LISRF   TO ORD-LISRF.
      **** rel 2.0
           MOVE RG-ORD-NOFF    TO ORD-NOFF.
      ************
      **** rel 6.2
           MOVE RG-ORD-GGS     TO ORD-GGS.
      ************
      **** rel 6.3
           MOVE RG-ORD-IFAT    TO ORD-IFAT.
      ************
      **** rel 7.1
           MOVE RG-ORD-VETT    TO ORD-VETT.
           MOVE RG-ORD-IPA     TO AOR-IPA.
           MOVE RG-ORD-CIG     TO AOR-CIG.
           MOVE RG-ORD-CUP     TO AOR-CUP.
      ************
      **** rel 7.2
           MOVE RG-ORD-FAORD   TO AOR-FAORD.
           MOVE RG-ORD-FADTORD TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG          TO AOR-FADTORD.
      ************
           MOVE REKORD TO RF-ORD.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE ORD-AZI     TO RG-ORD-AZI.
           MOVE ORD-NUM     TO RG-ORD-NUM.
           MOVE ORD-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-ORD-DAT.
           MOVE ORD-CDCLI   TO RG-ORD-CDCLI.
           MOVE ORD-ZONA    TO RG-ORD-ZONA.
           MOVE ORD-CDAGE   TO RG-ORD-CDAGE.
           MOVE ORD-PROVV   TO RG-ORD-PROVV.
           MOVE ORD-CDPAG   TO RG-ORD-CDPAG.
           MOVE ORD-CDBAN   TO RG-ORD-CDBAN.
           MOVE ORD-CDSPE   TO RG-ORD-CDSPE.
           MOVE ORD-CDPOR   TO RG-ORD-CDPOR.
           MOVE ORD-PERSC   TO RG-ORD-PERSC.
      **** rel 5.0
      *    MOVE ORD-DTCSR TO AAGGG.
           MOVE ORD-DTCSR TO AAGGG COMDTCSR.
      ************
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-ORD-DTCSR.
      **** rel 5.0
      *    MOVE ORD-DTCSC TO AAGGG.
           MOVE ORD-DTCSC TO AAGGG COMDTCSC.
      ************
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-ORD-DTCSC.
           MOVE ORD-CDESE   TO RG-ORD-CDESE.
           MOVE ORD-VSORD   TO RG-ORD-VSORD.
           MOVE ORD-COMME   TO RG-ORD-COMME.
           MOVE ORD-CDEP    TO RG-ORD-CDEP.
           MOVE ORD-VALUT   TO RG-ORD-VALUT.
           MOVE ORD-LCONS   TO RG-ORD-LCONS.
           MOVE ORD-CATT    TO RG-ORD-CATT.
           MOVE ORD-LISRF   TO RG-ORD-LISRF.
      **** rel 2.0
           MOVE ORD-NOFF    TO RG-ORD-NOFF.
      ************
      **** rel 6.2
           MOVE ORD-GGS     TO RG-ORD-GGS.
      ************
      **** rel 6.3
           MOVE KOR-AZI TO OC-AZI.
           MOVE KOR-NUM TO OC-NUM.
           CALL 'vrvopc' USING PAROC.
           MOVE OC-FLG TO RG-ORD-TIPO.
      ************
      **** rel 6.3
           MOVE ORD-IFAT    TO RG-ORD-IFAT.
      ************
      **** rel 7.1
           MOVE ORD-VETT    TO RG-ORD-VETT.
           MOVE AOR-IPA     TO RG-ORD-IPA.
           MOVE AOR-CIG     TO RG-ORD-CIG.
           MOVE AOR-CUP     TO RG-ORD-CUP.
      ************
      **** rel 7.2
           MOVE AOR-FAORD   TO RG-ORD-FAORD.
           MOVE AOR-FADTORD TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA      TO RG-ORD-FADTORD.
      ************
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
      **** rel 6.2
           IF FUN = 'R' OR 'r' 
              MOVE ZERO TO RA-ORD-NRORC
              MOVE RG-ORD-AZI TO KORC-AZI
              MOVE RG-ORD-NUM TO KORC-ORD
              READ ORDRIC NOT INVALID MOVE ORC-ORD TO RA-ORD-NRORC.
      ************
           MOVE RG-ORD-AZI TO KCF-AZI.
           MOVE RG-ORD-CDCLI TO COD.
           MOVE CODCLI TO KCF-COD.
      **** rel 5.1
      *    READ ANACLF INVALID MOVE ALL '*' TO CLF-RGS
      *                        MOVE SPACE   TO CLF-RGS2.
           READ ANACLF INTO REKCLF INVALID KEY
                               MOVE ALL '*' TO CLF-RGS
                               MOVE SPACE   TO CLF-RGS2
                               MOVE ZERO TO CLF-VAL.
           MOVE CLF-VAL  TO VALUT.
      ************
           MOVE CLF-RGS  TO RA-ORD-CDCLI-D.
           MOVE CLF-RGS2 TO RA-ORD-CDCLI-D1.
       RVID.
      **** rel 7.1
           MOVE ZERO TO RA-ORD-FELE.
      ************
           IF RG-ORD-CATT = ZERO
              MOVE 'ATTIVITA'' PRINCIPALE' TO RA-ORD-CATT-D
              GO TO RVID1.
           MOVE 35          TO T35-TIP.
           MOVE RG-ORD-AZI  TO T35-CDAZ.
           MOVE RG-ORD-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                MOVE 'ATTIVITA'' INESISTENTE' TO T35-DATT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE T35-DATT TO RA-ORD-CATT-D.
      **** rel 7.1
           MOVE T35-FELE TO RA-ORD-FELE.
      ************
       RVID1.
           IF RG-ORD-ZONA = SPACE MOVE SPACE TO RA-ORD-ZONA-D
                         GO TO RVID-10.
           MOVE 17 TO T17-TIP.
           MOVE RG-ORD-ZONA TO T17-COD.
           MOVE T17-KEYID TO KEYTB.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-ZONA-D.
       RVID-10.
           MOVE RG-ORD-CDEP TO KTB-COD.
           MOVE 12 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-CDEP-D.
      *
           MOVE RG-ORD-CDAGE TO KTB-COD.
           MOVE 9 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-CDAGE-D.
      **** rel 5.1
           IF KOR-AZI = ZERO MOVE T09-XCPR TO RG-ORD-PROVV.
      ************
      *
           MOVE RG-ORD-CDPAG TO KTB-COD.
           MOVE 4 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-CDPAG-D.
           IF RG-ORD-CDESE = ZERO
               MOVE 'SOGGETTO A IVA' TO RA-ORD-CDESE-D GO TO RVID-20.
      *
           MOVE RG-ORD-CDESE TO KTB-COD.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-CDESE-D.
       RVID-20.
           MOVE RG-ORD-CDSPE TO KTB-COD.
           MOVE 6 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-CDSPE-D.
      *
      **** rel 7.1
           IF RG-ORD-VETT = ZERO MOVE SPACE TO RA-ORD-VETT-D
                         GO TO RVID-21.
           MOVE RG-ORD-VETT TO KTB-COD.
           MOVE 8 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-VETT-D.
       RVID-21.
      ************
      *
           MOVE RG-ORD-CDPOR TO KTB-COD.
           MOVE 5 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-CDPOR-D.
      *
           IF RG-ORD-CDBAN = ZERO
              MOVE SPACE TO RA-ORD-CDBAN-D
              GO TO RVID-25.
           MOVE RG-ORD-CDBAN TO KBA-BAN.
           READ ANABAN INVALID
                MOVE ALL '*' TO BAN-RGSOC.
           MOVE BAN-RGSOC TO RA-ORD-CDBAN-D.
       RVID-25.
      **** rel 6.3
           IF RG-ORD-IFAT = ZERO
              MOVE SPACE TO RA-ORD-IFAT-D
      **** rel 7.1
      *       GO TO RVID-30.
              GO TO RVID-35.
      ************
           MOVE RG-ORD-AZI   TO KII-AZI.
           MOVE MAS          TO KII-MS.
           MOVE RG-ORD-CDCLI TO KII-CD.
           MOVE RG-ORD-IFAT TO KII-PRG.
           READ INDIRI INVALID KEY
                MOVE 'D' TO IRI-TIPO
                MOVE ALL '*' TO IRI-RGSOC.
           IF IRI-TIPO = 'D' MOVE IRI-RGSOC TO RA-ORD-IFAT-D
              ELSE IF IRI-TIPO = 'L' MOVE IRI-DESDI TO RA-ORD-IFAT-D
                   ELSE MOVE ALL '*' TO RA-ORD-IFAT-D.
       RVID-35.
      ************
      **** rel 3.0b
      *    IF RG-ORD-LCONS = ZERO GO TO RVID-30.
           IF RG-ORD-LCONS = ZERO
              MOVE SPACE TO RA-ORD-LCONS-D
              GO TO RVID-30.
      ************
           MOVE RG-ORD-AZI   TO KII-AZI.
           MOVE MAS          TO KII-MS.
           MOVE RG-ORD-CDCLI TO KII-CD.
           MOVE RG-ORD-LCONS TO KII-PRG.
           READ INDIRI INVALID KEY
                MOVE 'D' TO IRI-TIPO
                MOVE ALL '*' TO IRI-RGSOC.
           IF IRI-TIPO = 'D' MOVE IRI-RGSOC TO RA-ORD-LCONS-D
              ELSE IF IRI-TIPO = 'L' MOVE IRI-DESDI TO RA-ORD-LCONS-D
                   ELSE MOVE ALL '*' TO RA-ORD-LCONS-D.
       RVID-30.
           IF RG-ORD-VALUT = ZERO MOVE SPACE TO RA-ORD-VALUT-D
                                  GO TO RVID-40.
           MOVE 10 TO KTB-TIP.
           MOVE RG-ORD-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO RA-ORD-VALUT-D.
       RVID-40.
           IF RG-ORD-LISRF NOT > 3
              MOVE SPACE TO RA-ORD-LISRF-D
                            RA-ORD-LISRF-D1
              GO TO RVID-50.
           MOVE RG-ORD-LISRF TO KTB-COD.
           MOVE 52           TO KTB-TIP.
           READ TABELL INTO REKT52 INVALID
                MOVE ALL '*' TO RA-ORD-LISRF-D
                                RA-ORD-LISRF-D1
                GO TO RVID-50.
           MOVE SPACE TO RA-ORD-LISRF-D1.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT52.
      **** rel 4.0
      *    IF RG-ORD-VALUT NOT > 1 AND T52-VALUT = ZERO
           IF (RG-ORD-VALUT = ZERO OR COMEURO) AND T52-VALUT = ZERO
      ************
              MOVE SPACE TO RA-ORD-LISRF-D
                            RA-ORD-LISRF-D1
              GO TO RVID-40-10.
           MOVE 10        TO KTB-TIP.
           MOVE T52-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO RA-ORD-LISRF-D.
       RVID-40-10.
           IF T52-DTDEC = ZERO AND T52-DTVAL = ZERO
      **** rel 4.1a
      *       MOVE SPACE TO RA-ORD-LISRF-D1
              MOVE T52-DESCR TO RA-ORD-LISRF-D1
      ************
              GO TO RVID-50.
           MOVE RG-ORD-DAT TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 6.2
      *    IF AAGGG  < T52-DTDEC OR > T52-DTVAL
           IF AAGGG < T52-DTDEC OR
              (T52-DTVAL NOT = ZERO AND AAGGG > T52-DTVAL)
      ************
              MOVE '* NON IN VIGORE *' TO RA-ORD-LISRF-D1
      **** rel 4.1a
      *    ELSE  MOVE SPACE TO RA-ORD-LISRF-D1.
           ELSE  MOVE T52-DESCR TO RA-ORD-LISRF-D1.
      ************
       RVID-50.
      **** rel 6.2
           MOVE RG-ORD-DTCSC TO RA-ORD-DTGGS.
           IF RG-ORD-GGS > ZERO
              PERFORM SOMMA-GG THRU EX-SOMMA-GG.
      ************
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-ORD-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
       V-NUM.
           MOVE 'ORD-NUM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NUM.
           IF RG-ORD-NUM = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-NUM.
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-ORD-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
      **** rel 6.2
           IF FUN = 'w' GO TO V-DATI-DUPL.
      ************
       V-CATT.
           MOVE 'ORD-CATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CATT.
      **** rel 7.1
           MOVE ZERO     TO RA-ORD-FELE.
      ************
           IF RG-ORD-CATT = ZERO
              MOVE "ATTIVITA' PRINCIPALE" TO RA-ORD-CATT-D
              GO TO E-CATT.
           IF RG-ORD-CATT > 8
              PERFORM ERR-DINV
              GO TO V-ERROR.
           MOVE 35          TO T35-TIP.
           MOVE RG-ORD-AZI  TO T35-CDAZ.
           MOVE RG-ORD-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID
              MOVE SPACE TO RA-ORD-CATT-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE T35-DATT TO RA-ORD-CATT-D.
      **** rel 7.1
           MOVE T35-FELE TO RA-ORD-FELE.
      ************
       E-CATT.
      *
       V-DAT.
           MOVE 'ORD-DAT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DAT.
           IF RG-ORD-DAT = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE RG-ORD-DAT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DAT.
      *
       V-CDEP.
           MOVE 'ORD-CDEP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDEP.
           IF RG-ORD-CDEP = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE RG-ORD-CDEP TO KTB-COD.
           MOVE 12 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE SPACE TO RA-ORD-CDEP-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-CDEP-D.
       E-CDEP.
      *
      **** rel 2.0
       V-NOFF.
           MOVE 'ORD-NOFF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NOFF.
           IF ORD-AZI NOT = ZERO GO TO E-NOFF.
           IF RG-ORD-NOFF = ZERO
              GO TO E-NOFF.
           MOVE ZERO        TO KEYFCT.
           MOVE RG-ORD-AZI  TO KFCT-AZI.
           MOVE RG-ORD-NOFF TO KFCT-NUM.
           OPEN INPUT OFFCLI.
           READ OFFCLI INTO REKFCT INVALID KEY
                CLOSE OFFCLI
                MOVE 'Offerta inesistente' TO MESS
                GO TO V-ERROR.
           IF SF-FCT = '9D' OR '9A' OR '35' MOVE RF-FCT TO REKFCT.
           CLOSE OFFCLI.
           IF FCT-TIPO = 1
              MOVE 'Offerta attribuita a un contatto' TO F-MES1
              MOVE 'Vuoi generare un cliente ? '         TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-QUESTION.
           IF FUN NOT = 'V' GO TO E-NOFF.
      **** rel 3.0b
      *    MOVE FCT-DAT TO AAGGG.
      *    MOVE 2 TO TIPOP1.
      *    CALL 'rdata' USING PARCDT.
      *    MOVE GGMMAA    TO RG-ORD-DAT.
      ************
           MOVE FCT-CDCLI TO RG-ORD-CDCLI.
           MOVE FCT-VALUT TO RG-ORD-VALUT.
           MOVE FCT-CDSPE TO RG-ORD-CDSPE.
           MOVE FCT-CDPOR TO RG-ORD-CDPOR.
           MOVE FCT-CDPAG TO RG-ORD-CDPAG.
           MOVE FCT-PERSC TO RG-ORD-PERSC.
           MOVE FCT-CDESE TO RG-ORD-CDESE.
           MOVE FCT-VSORD TO RG-ORD-VSORD.
           MOVE FCT-LISRF TO RG-ORD-LISRF.
      **** rel 5.0
           MOVE FCT-CDAGE TO RG-ORD-CDAGE.
      ************
      *
           MOVE 2 TO TIPOP1.
           MOVE FCT-DTCSR TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-ORD-DTCSR.
      *
           MOVE RG-ORD-CDCLI TO COD.
           MOVE RG-ORD-AZI   TO KCF-AZI.
           MOVE CODCLI        TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID
                MOVE 'Cliente inesistente'   TO MESS
                GO TO V-ERROR.
           MOVE CLF-ZONA TO RG-ORD-ZONA.
      **** rel 5.0
      *    MOVE CLF-AGEN TO RG-ORD-CDAGE.
      ************
           MOVE CLF-BANC TO RG-ORD-CDBAN.
      **** rel 6.2
           MOVE CLF-GGS  TO RG-ORD-GGS.
      ************
      **** rel 5.2
           PERFORM RD-CDPAG THRU EX-RD-CDPAG.
      ************
           PERFORM CARICA-RA THRU EX-CARICA-RA.
       E-NOFF.
      *
      ************
       V-CDCLI.
           MOVE 'ORD-CDCLI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDCLI.
           IF RG-ORD-CDCLI = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
      **** rel 6.2
           IF RA-ORD-NRORC NOT = ZERO
              MOVE ZERO         TO PARORC
              MOVE RG-ORD-AZI   TO PORC-AZI
              MOVE RA-ORD-NRORC TO PORC-NUM
              CALL 'vrrdord' USING PARORC
              IF PORC-ERR = ZERO AND PORC-CLI NOT = RG-ORD-CDCLI
                 MOVE 'Cliente diverso su ordine a richiamo' TO MESS
                 GO TO V-ERROR.
      ************
           IF RG-ORD-CDCLI = ORD-CDCLI GO TO E-CDCLI.
           MOVE RG-ORD-CDCLI TO COD.
           MOVE CODCLI TO KCF-COD.
           MOVE RG-ORD-AZI TO KCF-AZI.
           READ ANACLF INTO REKCLF INVALID KEY
              MOVE SPACE TO RA-ORD-CDCLI-D
              MOVE SPACE TO RA-ORD-CDCLI-D1
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-RGS  TO RA-ORD-CDCLI-D.
           MOVE CLF-RGS2 TO RA-ORD-CDCLI-D1.
      **** rel 2.0
           IF RG-ORD-NOFF NOT = ZERO GO TO E-CDCLI.
      ************
           IF FUN NOT = 'V' GO TO E-CDCLI.
      **** rel 6.2
      *    MOVE ZERO TO RG-ORD-LCONS RG-ORD-PROVV.
           IF RA-ORD-NRORC = ZERO
              MOVE ZERO TO RG-ORD-LCONS.
           MOVE ZERO TO RG-ORD-PROVV.
      ************
           MOVE CLF-ZONA TO RG-ORD-ZONA.
           MOVE CLF-AGEN TO RG-ORD-CDAGE.
           MOVE CLF-CPAG TO RG-ORD-CDPAG.
           MOVE CLF-PORT TO RG-ORD-CDPOR.
           MOVE CLF-MSPE TO RG-ORD-CDSPE.
           MOVE CLF-ESEN TO RG-ORD-CDESE.
           MOVE CLF-BANC TO RG-ORD-CDBAN.
      **** rel 7.1
           MOVE CLF-VETT TO RG-ORD-VETT.
      ************
      **** rel 5.2
           PERFORM RD-CDPAG THRU EX-RD-CDPAG.
      ************
           MOVE CLF-SCBS TO RG-ORD-PERSC.
           MOVE CLF-VAL  TO RG-ORD-VALUT.
      **** rel 5.1
           MOVE CLF-VAL  TO VALUT.
      ************
           IF CLF-LIS NOT = ZERO
              MOVE CLF-LIS TO RG-ORD-LISRF
           ELSE
              MOVE CLF-TPRZ TO RG-ORD-LISRF.
      **** rel 6.2
           MOVE CLF-GGS    TO RG-ORD-GGS.
      ************
      **** rel 6.3
           MOVE CLF-IFAT   TO RG-ORD-IFAT.
      ************
      **** rel 7.1
           MOVE CLF-VETT   TO RG-ORD-VETT.
      ************
           PERFORM CARICA-RA THRU EX-CARICA-RA.
       E-CDCLI.
      *
       V-ZONA.
           MOVE 'ORD-ZONA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ZONA.
           IF RG-ORD-ZONA = SPACE MOVE SPACE TO RA-ORD-ZONA-D
                         GO TO E-ZONA.
           MOVE 17          TO T17-TIP.
           MOVE RG-ORD-ZONA TO T17-COD.
           MOVE T17-KEYID   TO KEYTB.
           READ TABELL INTO REKTAB INVALID KEY
              MOVE SPACE TO RA-ORD-ZONA-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-ZONA-D.
       E-ZONA.
      *
       V-CDAGE.
           MOVE 'ORD-CDAGE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDAGE.
           MOVE RG-ORD-CDAGE TO KTB-COD.
           MOVE 9 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE SPACE TO RA-ORD-CDAGE-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-CDAGE-D.
      **** rel 4.1
           IF FUN NOT = 'V' GO TO E-CDAGE.
      ************
           IF RG-ORD-CDAGE NOT = ORD-CDAGE
               MOVE T09-XCPR TO RG-ORD-PROVV.
       E-CDAGE.
      *
       V-CDPAG.
           MOVE 'ORD-CDPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDPAG.
           MOVE RG-ORD-CDPAG TO KTB-COD.
           MOVE 4 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              MOVE SPACE TO RA-ORD-CDPAG-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-CDPAG-D.
      **** rel 5.2
           IF FUN NOT = 'V' GO TO E-CDPAG.
           IF T04-TIPAG = 1 OR 2 
              MOVE CLF-BANC TO RG-ORD-CDBAN
           ELSE 
              IF CLF-BANCF NOT = ZERO 
                 MOVE CLF-BANCF TO RG-ORD-CDBAN.
           IF RG-ORD-CDBAN = ZERO
              MOVE SPACE TO RA-ORD-CDBAN-D
              GO TO E-CDPAG.
           MOVE RG-ORD-CDBAN TO KBA-BAN.
           READ ANABAN INVALID
              MOVE SPACE TO RA-ORD-CDBAN-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           MOVE BAN-RGSOC TO RA-ORD-CDBAN-D.
      ************
       E-CDPAG.
      *
       V-CDESE.
           MOVE 'ORD-CDESE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDESE.
           IF RG-ORD-CDESE = ZERO
               MOVE 'SOGGETTO A IVA' TO RA-ORD-CDESE-D
               GO TO E-CDESE.
           MOVE RG-ORD-CDESE TO KTB-COD.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE SPACE TO RA-ORD-CDESE-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-ALIVA NOT = ZERO
              MOVE SPACE TO RA-ORD-CDESE-D
              PERFORM ERR-CODI
              GO TO V-ERROR.
           MOVE TAB-DESCR TO RA-ORD-CDESE-D.
       E-CDESE.
      *
       V-CDPOR.
           MOVE 'ORD-CDPOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDPOR.
           MOVE RG-ORD-CDPOR TO KTB-COD.
           MOVE 5 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              MOVE SPACE TO RA-ORD-CDPOR-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-CDPOR-D.
       E-CDPOR.
      *
       V-CDSPE.
           MOVE 'ORD-CDSPE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDSPE.
           MOVE RG-ORD-CDSPE TO KTB-COD.
           MOVE 6 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              MOVE SPACE TO RA-ORD-CDSPE-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-CDSPE-D.
       E-CDSPE.
      *
      **** rel 7.1
       V-VETT.
           MOVE 'ORD-VETT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-VETT.
           IF RG-ORD-VETT = ZERO
              MOVE SPACE TO RA-ORD-VETT-D
              GO TO E-VETT.
           MOVE RG-ORD-VETT TO KTB-COD.
           MOVE 8 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              MOVE SPACE TO RA-ORD-VETT-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-ORD-VETT-D.
       E-VETT.
      ************
      *
       V-CDBAN.
           MOVE 'ORD-CDBAN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDBAN.
           MOVE RG-ORD-CDPAG TO KTB-COD.
           MOVE 4 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              MOVE ZERO TO T04-TIPAG.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T04-TIPAG = 1 OR 2 GO TO RDBAN.
           IF RG-ORD-CDBAN = ZERO
              MOVE SPACE TO RA-ORD-CDBAN-D
              GO TO E-CDBAN.
       RDBAN.
           MOVE RG-ORD-CDBAN TO KBA-BAN.
           READ ANABAN INVALID
              MOVE SPACE TO RA-ORD-CDBAN-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           MOVE BAN-RGSOC TO RA-ORD-CDBAN-D.
       E-CDBAN.
      *
       V-DTCSR.
           MOVE 'ORD-DTCSR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCSR.
           IF RG-ORD-DTCSR = ZERO GO TO E-DTCSR.
           MOVE 1 TO TIPOP1.
           MOVE RG-ORD-DTCSR TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO VAAGGG.
           MOVE 1 TO TIPOP1.
           MOVE RG-ORD-DAT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF VAAGGG < AAGGG
              MOVE 'Data consegna minore di data ordine' TO MESS
              GO TO V-ERROR.
       E-DTCSR.
      *
      **** rel 6.2
       V-GGS.
           MOVE 'ORD-GGS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-GGS.
      *
           MOVE RG-ORD-DTCSC TO RA-ORD-DTGGS.
           IF RG-ORD-GGS > ZERO
              PERFORM SOMMA-GG THRU EX-SOMMA-GG.
       E-GGS.
      ************
      *
       V-DTCSC.
           MOVE 'ORD-DTCSC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCSC.
           IF RG-ORD-DTCSC = ZERO GO TO E-DTCSC.
           MOVE 1 TO TIPOP1.
           MOVE RG-ORD-DTCSC TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO VAAGGG.
      **** rel 6.2
           IF RG-ORD-GGS > ZERO AND FUN = 'V' AND SWINS = 1
              IF RA-ORD-DTGGS = ZERO
                 PERFORM SOTTRAI-GG THRU EX-SOTTRAI-GG
              ELSE
                 PERFORM SOMMA-GG THRU EX-SOMMA-GG.

           IF RG-ORD-GGS > ZERO AND FUN = 'V' AND SWINS = ZERO
              PERFORM SOMMA-GG THRU EX-SOMMA-GG.
      ************
           MOVE 1 TO TIPOP1.
           MOVE RG-ORD-DAT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF VAAGGG < AAGGG
              MOVE 'Data consegna minore di data ordine' TO MESS
              GO TO V-ERROR.
       E-DTCSC.
      *
       V-LCONS.
           MOVE 'ORD-LCONS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-LCONS.
           IF RG-ORD-LCONS = ZERO
              MOVE SPACE TO RA-ORD-LCONS-D
              GO TO E-LCONS.
           MOVE RG-ORD-AZI   TO KII-AZI.
           MOVE MAS          TO KII-MS.
           MOVE RG-ORD-CDCLI TO KII-CD.
           MOVE RG-ORD-LCONS TO KII-PRG.
           READ INDIRI INVALID
              MOVE SPACE TO RA-ORD-LCONS-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF IRI-TIPO = 'D' MOVE IRI-RGSOC TO RA-ORD-LCONS-D
              ELSE IF IRI-TIPO = 'L' MOVE IRI-DESDI TO RA-ORD-LCONS-D
                   ELSE MOVE SPACE TO RA-ORD-LCONS-D
                        MOVE 'Tipo indirizzo non valido' TO MESS
                        GO TO V-ERROR.
      **** rel 6.2
           MOVE IRI-GGS TO RG-ORD-GGS.
      ************
       E-LCONS.
      *
      **** rel 6.3
       V-IFAT.
           MOVE 'ORD-IFAT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IFAT.
           IF RG-ORD-IFAT = ZERO
              MOVE SPACE TO RA-ORD-IFAT-D
              GO TO E-IFAT.
           MOVE RG-ORD-AZI   TO KII-AZI.
           MOVE MAS          TO KII-MS.
           MOVE RG-ORD-CDCLI TO KII-CD.
           MOVE RG-ORD-IFAT TO KII-PRG.
           READ INDIRI INVALID
              MOVE SPACE TO RA-ORD-IFAT-D
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF IRI-TIPO = 'D' MOVE IRI-RGSOC TO RA-ORD-IFAT-D
              ELSE IF IRI-TIPO = 'L' MOVE IRI-DESDI TO RA-ORD-IFAT-D
                   ELSE MOVE SPACE TO RA-ORD-IFAT-D
                        MOVE 'Tipo indirizzo non valido' TO MESS
                        GO TO V-ERROR.
       E-IFAT.
      ************
      **** rel 7.2
       V-FAORD.
           MOVE 'ORD-FAORD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FAORD.
           IF RG-ORD-CIG = SPACE AND
              RG-ORD-CUP = SPACE
              GO TO E-FAORD.
      *
           IF RG-ORD-FAORD = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-FAORD.
      *
       V-FADTORD.
           MOVE 'ORD-FADTORD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FADTORD.
           IF RG-ORD-FADTORD = ZERO
              GO TO E-FADTORD.
      *
           MOVE 1 TO TIPOP1.
           MOVE RG-ORD-FADTORD TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-FADTORD.
      *
      ************
       V-VALUT.
           MOVE 'ORD-VALUT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-VALUT.
           IF RG-ORD-VALUT = ZERO
              MOVE SPACE TO RA-ORD-VALUT-D
              GO TO E-VALUT.
      **** rel 1.2
      *    MOVE 10 TO KTB-TIP.
      *    MOVE RG-ORD-VALUT TO KTB-COD.
      *    READ TABELL INTO REKTAB INVALID
      *       MOVE SPACE TO RA-ORD-VALUT-D
      *       PERFORM ERR-CINE
      *       GO TO V-ERROR.
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *    MOVE T10-DSINT TO RA-ORD-VALUT-D.

           MOVE RG-ORD-VALUT TO ER-VALUT.
           MOVE RG-ORD-DAT  TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ER-DATA
           CALL 'rvalut' USING ER-VALUT ER-DATA CG-PAR.
           MOVE CG-DSINT TO RA-ORD-VALUT-D.
           IF CG-ST > ZERO PERFORM ERR-EURO
                           GO TO V-ERROR.

           IF RG-ORD-VALUT = 1 GO TO E-VALUT.
           IF RG-ORD-CDESE NOT = ZERO GO TO E-VALUT.
      **** rel 4.0
      *    CALL 'rveur' USING ER-VALUT.
      *    IF RG-ORD-VALUT NOT = ER-VALUT
      **** rel 4.0-2
      *    IF RG-ORD-VALUT NOT = COMEURO
      ************
      ************
      **** rel 4.0-2
      *       MOVE 'Soggetto ad IVA, Divisa non valida' TO MESS
      *       GO TO V-ERROR.
      ************
      ************
       E-VALUT.
      *
      **** rel 6.2
           IF FUN = 'W' GO TO V-END-DATI-DUPL.
      *
       V-DATI-DUPL.
      *
       V-CDCLI1.
           MOVE 'ORD-CDCLI1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDCLI1.
           IF RA-ORD-CDCLI1 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE RG-ORD-AZI TO KCF-AZI.
           MOVE RA-ORD-CDCLI1 TO COD.
           MOVE CODCLI TO KCF-COD.
           READ ANACLF INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           MOVE CLF-RGS  TO RA-ORD-CDCLI1-D.
           MOVE CLF-RGS2 TO RA-ORD-CDCLI1-D1.
       E-CDCLI1.
      *
       V-DTORD.
           MOVE 'ORD-DTORD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTORD.
           IF RA-ORD-DTORD = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE RA-ORD-DTORD TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTORD.
      *
       V-END-DATI-DUPL.
      *
      ************
       V-LISRF.
           MOVE 'ORD-LISRF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-LISRF.
           MOVE SPACE TO RA-ORD-LISRF-D
                         RA-ORD-LISRF-D1.
           IF RG-ORD-LISRF NOT > 3 GO TO E-LISRF.
           MOVE RG-ORD-LISRF TO KTB-COD.
           MOVE 52           TO KTB-TIP.
           READ TABELL INTO REKT52 INVALID
                MOVE 'Listino inesistente' TO MESS
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT52.
      **** rel 4.0
      *    IF (RG-ORD-VALUT > 1 AND T52-VALUT NOT = RG-ORD-VALUT) OR
      *       (RG-ORD-VALUT < 2 AND T52-VALUT NOT = ZERO)
           IF ( NOT (RG-ORD-VALUT = ZERO OR COMEURO) AND
                    (T52-VALUT NOT = RG-ORD-VALUT))   OR
              (RG-ORD-VALUT = ZERO OR COMEURO) AND T52-VALUT NOT = ZERO
      ************
                  MOVE 'Valuta diversa su listino' TO MESS
                  GO TO V-ERROR.
      **** rel 4.0
      *    IF RG-ORD-VALUT NOT > 1 AND T52-VALUT = ZERO
           IF (RG-ORD-VALUT = ZERO OR COMEURO) AND T52-VALUT = ZERO
              GO TO V-LISRF-10.
      ************
           MOVE 10        TO KTB-TIP.
           MOVE T52-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO RA-ORD-LISRF-D.
       V-LISRF-10.
           IF T52-DTDEC = ZERO AND T52-DTVAL = ZERO
      **** rel 4.1a
      **** rel 6.2
      *       MOVE T52-DESCR TO RA-ORD-LISRF-D1.
              MOVE T52-DESCR TO RA-ORD-LISRF-D1
      ************
      ************
              GO TO E-LISRF.
           MOVE RG-ORD-DAT TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 6.2
      *    IF AAGGG  < T52-DTDEC OR > T52-DTVAL
           IF AAGGG < T52-DTDEC OR
              (T52-DTVAL NOT = ZERO AND AAGGG > T52-DTVAL)
      ************
              MOVE '* NON IN VIGORE *' TO RA-ORD-LISRF-D1
      **** rel 4.1a
      *    ELSE  MOVE SPACE TO RA-ORD-LISRF-D1.
           ELSE  MOVE T52-DESCR TO RA-ORD-LISRF-D1.
      ************
       E-LISRF.
      **** rel 6.2
       V-NRORC.
           MOVE 'ORD-NRORC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NRORC.
           IF RA-ORD-NRORC = RG-ORD-NUM
                PERFORM ERR-DINC
                GO TO V-ERROR.
           IF RA-ORD-NRORC NOT = ZERO
              MOVE ZERO         TO PARORC
              MOVE RG-ORD-AZI   TO PORC-AZI
              MOVE RA-ORD-NRORC TO PORC-NUM
              CALL 'vrrdord' USING PARORC
              IF PORC-ERR NOT = ZERO
                 MOVE ZERO TO ERRIO-ST
                 PERFORM ERR-CINE
                 GO TO V-ERROR
              ELSE
                 IF PORC-OPC = ZERO
                    MOVE 'Ordine Non A Programma' TO MESS
                    GO TO V-ERROR
                 ELSE
                    IF KOR-AZI = ZERO
                       MOVE PORC-CLI TO RG-ORD-CDCLI
                       MOVE PORC-DEP TO RG-ORD-CDEP
      *                MOVE PORC-LCONS TO RG-ORD-LCONS
                    ELSE
                       IF PORC-CLI NOT = RG-ORD-CDCLI
                          MOVE 'Cliente diverso' TO MESS
                          GO TO V-WARNING.
       E-NRORC.
      **********
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       C00-DEL-RIG.
           MOVE KOR-AZI TO KRI-AZI KMA-AZI KAD-AZI.
           MOVE KOR-NUM TO KRI-NUM.
           MOVE ZERO TO KRI-PRG.
           START ORDRIG KEY NOT < KEYRI INVALID GO TO C99.
       C10.
           READ ORDRIG NEXT INTO REKRIG AT END GO TO C99.
           IF SF-RIG = '9D' OR '9A' OR '35' GO TO C10.
           IF KRI-AZI NOT = KOR-AZI GO TO C99.
           IF KRI-NUM NOT = KOR-NUM GO TO C99.
           IF (RIG-TPRIG > ZERO AND < 4) OR
              RIG-ARTIC = SPACE GO TO C20.
           MOVE RIG-AZI   TO KMA-AZI.
           MOVE RIG-ARTIC TO KMA-ART.
           READ MAGART INTO REKART INVALID
                       PERFORM INVK-ART
                       PERFORM VISK-RIG
                       GO TO ERRIO.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           PERFORM SUBMAG THRU EX-SUBMAG.
       C20.
      **** rel 6.1
      *    PERFORM DEL-PRORIG THRU EX-DEL-PRORIG.
      *    PERFORM DL-NOTE    THRU EX-DL-NOTE.
      *    IF OC-FLG NOT = ZERO
      *       PERFORM DEL-OBC THRU EX-DEL-OBC.
           CLOSE BOLORD.
      **** rel 7.1
      *    CALL 'vrdlrig' USING KEYRI.
           CALL 'vrdlrig' USING KEYRI "DSV".
      ************
           OPEN I-O BOLORD.
      ************
           DELETE ORDRIG INVALID KEY
               PERFORM INVK-RIG GO TO ERRIO.
      **** rel 7.1
           MOVE ORD-DAT TO DTINT.
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-R.
      ************
      **** rel 6.1
      *    CALL 'vrdlopc' USING KEYRI.
      ************
           GO TO C10.
       C99.
           EXIT.
      *------------------
       F00-GES-OBC.
           MOVE ZERO TO SW-ESBOL.
           MOVE KOR-AZI TO OBC-AZI.
           MOVE KOR-NUM TO OBC-NORD.
           MOVE ZERO TO OBC-RGOR OBC-ANNO OBC-NUM OBC-BOL.
           START BOLORD KEY NOT < KEYBO2 INVALID GO TO F99.
       F10.
           READ BOLORD NEXT AT END GO TO F99.
           IF SF-OBC = '9D' OR '9A' OR '35' GO TO F10.
           IF OBC-ANNO = ZERO GO TO F10.
           IF KBO-AZI  NOT = KOR-AZI OR
              OBC-NORD NOT = KOR-NUM
              GO TO F99.
           MOVE 1 TO SW-ESBOL.
       F99.
           EXIT.
      *------------------
       SUBMAG.
           IF RIG-ARTIC = SPACE GO TO EX-SUBMAG.
           IF RIG-SALDO = 1 GO TO EX-SUBMAG.
           SUBTRACT RIG-QSPED FROM RIG-QUANT GIVING RESID.
           IF RESID NOT > ZERO GO TO EX-SUBMAG.
           MOVE RIG-AZI TO KMA-AZI.
           MOVE RIG-ARTIC TO KMA-ART.
       SMAG1.
           READ MAGART INTO REKART KEPT LOCK INVALID KEY
               PERFORM INVK-ART
               PERFORM VISK-RIG
               GO TO ERRIO.
           IF SF-ART > ZERO PERFORM REC-LOCK
                            GO TO SMAG1.
       SMAG2.
           MOVE KMA-AZI  TO KAD-AZI.
           MOVE ORD-CDEP TO KAD-DEP.
           MOVE KMA-ART  TO KAD-ART.
           READ MAGARD INTO REKARD KEPT LOCK INVALID KEY
               PERFORM INVK-ARD
               PERFORM VISK-RIG
               GO TO ERRIO.
           IF SF-ARD > ZERO PERFORM REC-LOCK
                            GO TO SMAG2.
           SUBTRACT RESID FROM ART-IMPCL ARD-CIMPE.
           REWRITE RF-ART FROM REKART INVALID KEY
               PERFORM INVK-ART
               PERFORM VISK-RIG
               GO TO ERRIO.
           UNLOCK MAGART.
           REWRITE RF-ARD FROM REKARD INVALID KEY
               PERFORM INVK-ARD
               PERFORM VISK-RIG
               GO TO ERRIO.
           UNLOCK MAGARD.
       EX-SUBMAG.
           EXIT.
      *------------------
       REC-LOCK.
      **** rel 1.2
           CALL 'rlock' USING PARLK.
      ************
           EXIT.
      *------------------
      **** rel 6.1
      * procedura DEL-PRORIG eliminata
      * procedura DL-NOTE eliminata
      * procedura DEL-OBC eliminata
      ************
      **** rel 5.0
      *------------------
       MOD-DAT-RIG.
           MOVE 'Modificare le date di consegna sui righi?' TO F-MES1.
           MOVE 1 TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP = 'N' GO TO EX-MOD-DAT-RIG.

           MOVE KOR-AZI TO KRI-AZI.
           MOVE KOR-NUM TO KRI-NUM.
           MOVE ZERO    TO KRI-PRG.
           START ORDRIG KEY NOT < KEYRI INVALID GO TO EX-MOD-DAT-RIG.
       DTR10.
           READ ORDRIG NEXT INTO REKRIG AT END GO TO EX-MOD-DAT-RIG.
           IF SF-RIG = '9D' OR '9A' OR '35' GO TO DTR10.
           IF KRI-AZI NOT = KOR-AZI GO TO EX-MOD-DAT-RIG.
           IF KRI-NUM NOT = KOR-NUM GO TO EX-MOD-DAT-RIG.
           IF (RIG-TPRIG = 1 OR 3 ) GO TO DTR10.
           IF (RIG-DTCSR NOT = COMDTCSR) AND (RIG-DTCSC NOT = COMDTCSC)
              GO TO DTR10.

           IF RIG-DTCSR = COMDTCSR
              MOVE ORD-DTCSR TO RIG-DTCSR.
           IF RIG-DTCSC = COMDTCSC
              MOVE ORD-DTCSC TO RIG-DTCSC.

           REWRITE RF-RIG FROM REKRIG INVALID KEY
              PERFORM INVK-RIG
              GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-R.
      ************

           GO TO DTR10.
       EX-MOD-DAT-RIG.
           EXIT.
      ************
      *------------------
      **** rel 5.1
       MOD-LVE-RIG.
           MOVE KOR-AZI TO KRI-AZI.
           MOVE KOR-NUM TO KRI-NUM.
           MOVE ZERO    TO KRI-PRG.
           START ORDRIG KEY NOT < KEYRI INVALID GO TO EX-MOD-LVE-RIG.
       LVE10.
           READ ORDRIG NEXT INTO REKRIG AT END GO TO EX-MOD-LVE-RIG.
           IF SF-RIG = '9D' OR '9A' OR '35' GO TO LVE10.
           IF KRI-AZI NOT = KOR-AZI GO TO EX-MOD-LVE-RIG.
           IF KRI-NUM NOT = KOR-NUM GO TO EX-MOD-LVE-RIG.
           IF RIG-TPRIG NOT = ZERO GO TO LVE10.
           PERFORM G00-AGGLVE THRU G99.
           GO TO LVE10.
       EX-MOD-LVE-RIG.
           EXIT.
      *------------------
       G00-AGGLVE.
           MOVE ORD-AZI    TO VE-AZI.
           MOVE RIG-ARTIC  TO VE-ART.
           MOVE ORD-CDCLI  TO VE-CLI.
           MOVE 'O'        TO VE-ORIG.
           MOVE ORD-NUM    TO VE-NDOC.
           MOVE ORD-DAT    TO VE-DTDOC.
           MOVE RIG-QUANT  TO VE-QTA.
           MOVE RIG-PREZZ  TO VE-PRZ.
           MOVE RIG-1SCON  TO VE-SC1.
           MOVE RIG-2SCON  TO VE-SC2.
      **** rel 1.2
           MOVE ORD-PERSC  TO VE-SCBAS.
           MOVE RIG-FPNET  TO VE-FPNET.
      ************
           MOVE ZERO       TO VE-ST.
           CALL 'vrlsven' USING PARVE.
           CANCEL 'vrlsven'.
       G99.
           EXIT.
      *------------------*
      ************
      **** rel 5.2
       RD-CDPAG.
           MOVE RG-ORD-CDPAG TO KTB-COD.
           MOVE 4 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID GO TO EX-RD-CDPAG.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T04-TIPAG = 1 OR 2
              MOVE CLF-BANC TO RG-ORD-CDBAN
              GO TO EX-RD-CDPAG.
           IF CLF-BANCF NOT = ZERO MOVE CLF-BANCF TO RG-ORD-CDBAN.
       EX-RD-CDPAG.
           EXIT.
      *------------------*
      ************
      **** rel 6.2
      *-------------------------------
       SOMMA-GG.
           MOVE 1 TO TIPOP1.
           MOVE RG-ORD-DTCSC TO GGMMAA.
           CALL 'rdata' USING PARCDT.

           IF RG-ORD-GGS = ZERO OR AAGGG = ZERO GO TO EX-SOMMA-GG.
      * SOMMA giorni escludendo sabati e domeniche
           MOVE RG-ORD-GGS TO I.
           PERFORM UNTIL I = ZERO
              ADD 1 TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF SWRET1 > ZERO
                 MOVE ZERO TO I
              ELSE
                 IF GGSET <= 5
                    SUBTRACT 1 FROM I.

           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RA-ORD-DTGGS.
       EX-SOMMA-GG.
           EXIT.
      *-------------------------------
       SOTTRAI-GG.
           MOVE RG-ORD-DTCSC TO RA-ORD-DTGGS.

           IF RG-ORD-GGS = ZERO OR AAGGG = ZERO GO TO EX-SOTTRAI-GG.
      * SOTTRAE giorni escludendo sabati e domeniche
           MOVE RG-ORD-GGS TO I.
           PERFORM UNTIL I = ZERO
              SUBTRACT 1 FROM AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF SWRET1 > ZERO
                 MOVE ZERO TO I
              ELSE
                 IF GGSET <= 5
                    SUBTRACT 1 FROM I.

           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-ORD-DTCSC.
       EX-SOTTRAI-GG.
           EXIT.
      *-------------------------------
      ************
      **** rel 7.1
       CREA-APPORD.
           MOVE ZERO TO RF-AOR.
           MOVE KOR-AZI TO KAOR-AZI.
           MOVE KOR-NUM TO KAOR-NUM.
           MOVE SPACE TO AOR-CIG AOR-CUP AOR-IPA.
      **** rel 7.2
           MOVE SPACE TO AOR-FAORD.
      ************
           WRITE RF-AOR INVALID PERFORM INVK-AOR
                                GO TO ERRIO. 
       EX-CREA-APPORD.
           EXIT.
      *-------------------------------
       CALL-VSRV133.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'ORD'   TO PPAR-TARC.
           MOVE KEYOR   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 ORD ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *-------------------------------
       CALL-VSRV133-R.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'RIG'   TO PPAR-TARC.
           MOVE KEYRI   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           IF PPAR-TOPE = 'C'
              MOVE DTINT TO PPAR-OPZ(1:5).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 RIG ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *-------------------------------
      ************
