      $SET LINKCOUNT"128"
       IDENTIFICATION DIVISION.
       PROGRAM-ID. VPLA534.
      *
      *    Interfaccia LEITAB per scheda gestione lettere d'intento
      *
      **** rel 7.2
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griditsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gridit'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'grid02rk'.
           COPY 'griazirk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'prfisc'.
           COPY 'prpiva'.
           COPY 'parpcfgr'.
           COPY 'parpcfgc'.
      **** rel 7.1
       01  ESTERNE1 EXTERNAL.
           02 EX1-DTAPE   PIC 9(5).
           02 EX1-DTCHI   PIC 9(5).
      ************
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-DIT PIC X(15) VALUE 'leitab'.
       01  COMODI.
           05 SF-AZI PIC XX.
           05 SF-DIT PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KK       PIC 99.
           05 J        PIC 9.
      **** rel 7.1
           05 K        PIC 99.
           05 VETMES  PIC X(12) VALUE 'ABCDEHLMPRST'.
           05 NUMMES  REDEFINES VETMES PIC X OCCURS 12.
           05 CDFISC  PIC X(16).
           05 DTFISC  REDEFINES CDFISC.
              10 FILLER PIC X(6).
              10 AN     PIC XX.
              10 ANM REDEFINES AN PIC 99.
              10 MS     PIC X.
              10 GI     PIC XX.
              10 GIM REDEFINES GI PIC 99.
              10 FILLER PIC X(5).
           05 DTFIVA  REDEFINES CDFISC.
              10 NUM    PIC X(11).
              10 BLK    PIC X(5).
      ************
       LINKAGE SECTION.
           COPY 'grid02rg'.
      *
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-T-CTRL
                                RG-T-REC
                                RA-T-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcldit'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-T-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-T-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
      **** rel 7.1
           IF RG-T-FL = 1
              PERFORM STORICO THRU EX-STORICO
              IF AA4 = ZERO 
                 MOVE 'Selezionare uno storico' TO MESS
                 GO TO ERRIO
              END-IF 
           ELSE
      *       MOVE 'allcfx' TO ID-LCC
              MOVE 'leitab' TO ID-DIT.
      *       MOVE 'allcfr' TO ID-LCR.
      ************
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-T-FUN   TO FUN.
           MOVE RG-T-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'R' OR
                    'r' OR
                    'A' GO TO F-READ-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vPLA534: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-READ-AGGIOR.
           IF FUN = 'r' MOVE 1 TO FLCK.
           IF RG-T-NWIN = 1
              PERFORM LEG-AGG-D02A THRU EX-LEG-AGG-D02A
              GO TO END-F-READ-AGGIOR.
      **** rel 7.1
           IF RG-T-NWIN = 2
              PERFORM LEG-AGG-D02B THRU EX-LEG-AGG-D02B
              PERFORM LEG-AGG-D02C THRU EX-LEG-AGG-D02C
              GO TO END-F-READ-AGGIOR.
           IF RG-T-NWIN = 3
              PERFORM LEG-AGG-D02D THRU EX-LEG-AGG-D02D
              PERFORM LEG-AGG-D02E THRU EX-LEG-AGG-D02E
              GO TO END-F-READ-AGGIOR.
      ************
           IF RG-T-NWIN = 4
              PERFORM LEG-AGG-D02I THRU EX-LEG-AGG-D02I
              GO TO END-F-READ-AGGIOR.
      *    
           MOVE 'Numero maschera inesistente' TO MESS.
           GO TO ERRIO.
      *
       END-F-READ-AGGIOR.
           IF FUN = 'A' UNLOCK LEITAB.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           UNLOCK LEITAB.
           GO TO F-READ-AGGIOR.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-T-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK LEITAB.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-T-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI LEITAB.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-T-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-T-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griditer'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN I-O   LEITAB.
           OPEN INPUT ANAAZI.
      *     
           MOVE RG-T-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *     
           MOVE 02        TO D02-TIP.
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'A'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INVALID PERFORM SCRIVI-D02A THRU EX-SCRIVI-D02A.
      *     
      **** rel 7.1
           MOVE 02        TO D02-TIP.
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'B'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INVALID PERFORM SCRIVI-D02B THRU EX-SCRIVI-D02B.
      *     
           MOVE 02        TO D02-TIP.
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'C'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INVALID PERFORM SCRIVI-D02C THRU EX-SCRIVI-D02C.
      *     
           MOVE 02        TO D02-TIP.
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'D'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INVALID PERFORM SCRIVI-D02D THRU EX-SCRIVI-D02D.
      *     
           MOVE 02        TO D02-TIP.
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'E'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INVALID PERFORM SCRIVI-D02E THRU EX-SCRIVI-D02E.
      *     
      ************
           MOVE 02        TO D02-TIP.
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'I'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INVALID PERFORM SCRIVI-D02I THRU EX-SCRIVI-D02I.
      *     
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       READ-K.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ LEITAB INTO REKD02 INVALID PERFORM INVK-DIT
                                           GO TO ERRIO.
           IF SF-DIT = '9D' OR '9A' OR '35' MOVE RF-DIT TO REKD02.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ LEITAB INTO REKD02 KEPT LOCK INVALID PERFORM INVK-DIT
                                                     GO TO ERRIO.
           IF SF-DIT > ZERO MOVE 7 TO RG-T-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       REWRITE-K.
           REWRITE RF-DIT FROM REKD02 INVALID PERFORM INVK-DIT
                                              GO TO ERRIO.
       EX-REWRITE-K.
           EXIT.
      *------------------
       WRITE-NUOVA-DIT.
           MOVE 02      TO D02-TIP.
           MOVE KAZ-COD TO D02-COD.
           WRITE RF-DIT FROM REKD02 INVALID PERFORM INVK-DIT
                                            GO TO ERRIO.
       EX-WRITE-NUOVA-DIT.
      *------------------
       CARICA-REC-D02A.
           MOVE 02              TO D02-TIP.
           MOVE KAZ-COD         TO D02-COD.
           MOVE 'A'             TO D02-PRG.
      *
           MOVE RG-D02-PATHECF  TO D02-PATHECF.
           MOVE RG-D02-TPLA     TO D02-TPLA.  
           MOVE RG-D02-CDIAP    TO D02-CDIAP. 
           MOVE RG-D02-EPSO     TO D02-EPSO.  
           MOVE RG-D02-CINTRA   TO D02-CINTRA.
           MOVE RG-D02-CSANM    TO D02-CSANM. 
           MOVE RG-D02-OPERAS   TO D02-OPERAS.
           MOVE RG-D02-OPERST   TO D02-OPERST.
       EX-CARICA-REC-D02A.
           EXIT.
      *------------------
       CARICA-RG-D02A.
           MOVE D02-PATHECF     TO RG-D02-PATHECF.
           MOVE D02-TPLA        TO RG-D02-TPLA.  
           MOVE D02-CDIAP       TO RG-D02-CDIAP. 
           MOVE D02-EPSO        TO RG-D02-EPSO.  
           MOVE D02-CINTRA      TO RG-D02-CINTRA.
           MOVE D02-CSANM       TO RG-D02-CSANM. 
           MOVE D02-OPERAS      TO RG-D02-OPERAS.
           MOVE D02-OPERST      TO RG-D02-OPERST.
       EX-CARICA-RG-D02A.
           EXIT.
      *------------------
      **** rel 7.1
       CARICA-REC-D02B.
           MOVE 02              TO D02-TIP.
           MOVE KAZ-COD         TO D02-COD.
           MOVE 'B'             TO D02-PRG.
      *
           MOVE RG-D02-CFRAP    TO D02-CFRAP.
           MOVE RG-D02-CARAP    TO D02-CARAP.
           MOVE RG-D02-CFDIC    TO D02-CFDIC.
           MOVE RG-D02-CORAP    TO D02-CORAP.
           MOVE RG-D02-NORAP    TO D02-NORAP.
           MOVE RG-D02-SERAP    TO D02-SERAP.
           MOVE RG-D02-CONRAP   TO D02-CONRAP.
           MOVE RG-D02-PRNRAP   TO D02-PRNRAP.
      *
           MOVE RG-D02-DTRAP    TO GGMMAA4.
           MOVE 4 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG           TO D02-DTRAP.
       EX-CARICA-REC-D02B.
           EXIT.
      *------------------
       CARICA-RG-D02B.
           MOVE D02-CFRAP       TO RG-D02-CFRAP.
           MOVE D02-CARAP       TO RG-D02-CARAP.
           MOVE D02-CFDIC       TO RG-D02-CFDIC.
           MOVE D02-CORAP       TO RG-D02-CORAP.
           MOVE D02-NORAP       TO RG-D02-NORAP.
           MOVE D02-SERAP       TO RG-D02-SERAP.
           MOVE D02-CONRAP      TO RG-D02-CONRAP.
           MOVE D02-PRNRAP      TO RG-D02-PRNRAP.
      *
           MOVE D02-DTRAP     TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4       TO RG-D02-DTRAP.
       EX-CARICA-RG-D02B.
           EXIT.
      *------------------
       CARICA-REC-D02C.
           MOVE 02              TO D02-TIP.
           MOVE KAZ-COD         TO D02-COD.
           MOVE 'C'             TO D02-PRG.
           MOVE RG-D02-CORRAP   TO D02-CORRAP.
           MOVE RG-D02-PRRRAP   TO D02-PRRRAP.
           MOVE RG-D02-CARRAP   TO D02-CARRAP.
           MOVE RG-D02-INRRAP   TO D02-INRRAP.
           MOVE RG-D02-TELRAP   TO D02-TELRAP.
           MOVE RG-D02-CFSOC    TO D02-CFSOC.
       EX-CARICA-REC-D02C.
           EXIT.
      *------------------
       CARICA-REC-D02D.
           MOVE 02              TO D02-TIP.
           MOVE KAZ-COD         TO D02-COD.
           MOVE 'D'             TO D02-PRG.
           MOVE RG-D02-STAEST   TO D02-STAEST.
           MOVE RG-D02-CDSTA    TO D02-CDSTA.
           MOVE RG-D02-NIVAE    TO D02-NIVAE.
       EX-CARICA-REC-D02D.
           EXIT.
      *------------------
       CARICA-REC-D02E.
           MOVE 02              TO D02-TIP.
           MOVE KAZ-COD         TO D02-COD.
           MOVE 'E'             TO D02-PRG.
           MOVE RG-D02-EMAIL    TO D02-EMAIL.
           MOVE RG-D02-TEL      TO D02-TEL.
           MOVE RG-D02-FAX      TO D02-FAX.
       EX-CARICA-REC-D02E.
           EXIT.
      *------------------
      ************
       CARICA-REC-D02I.
           MOVE 02              TO D02-TIP.
           MOVE KAZ-COD         TO D02-COD.
           MOVE 'I'             TO D02-PRG.
           MOVE RG-D02-CFINT    TO D02-CFINT.
           MOVE RG-D02-NRCAF    TO D02-NRCAF.
           MOVE RG-D02-FLGMOD   TO D02-FLGMOD.
      *
           MOVE RG-D02-DTIMP TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG           TO D02-DTIMP.
       EX-CARICA-REC-D02I.
           EXIT.
      *------------------
      **** rel 7.1
       CARICA-RG-D02D.
           MOVE D02-STAEST   TO RG-D02-STAEST.
           MOVE D02-CDSTA    TO RG-D02-CDSTA.
           MOVE D02-NIVAE    TO RG-D02-NIVAE.
       EX-CARICA-RG-D02D.
           EXIT.
      *------------------
       CARICA-RG-D02E.
           MOVE D02-EMAIL  TO RG-D02-EMAIL.
           MOVE D02-TEL    TO RG-D02-TEL.
           MOVE D02-FAX    TO RG-D02-FAX.
       EX-CARICA-RG-D02E.
           EXIT.
      *------------------
      ************
       CARICA-RG-D02I.
           MOVE D02-CFINT       TO RG-D02-CFINT.
           MOVE D02-NRCAF       TO RG-D02-NRCAF.
           MOVE D02-FLGMOD      TO RG-D02-FLGMOD.
      *
           MOVE D02-DTIMP TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA          TO RG-D02-DTIMP.
       EX-CARICA-RG-D02I.
           EXIT.
      *------------------
      **** rel 7.1
       CARICA-RG-D02C.
           MOVE D02-CORRAP   TO RG-D02-CORRAP.
           MOVE D02-PRRRAP   TO RG-D02-PRRRAP.
           MOVE D02-CARRAP   TO RG-D02-CARRAP.
           MOVE D02-INRRAP   TO RG-D02-INRRAP.
           MOVE D02-TELRAP   TO RG-D02-TELRAP.
           MOVE D02-CFSOC    TO RG-D02-CFSOC.
       EX-CARICA-RG-D02C.
           EXIT.
      *------------------
      ************
       CARICA-RA.
           MOVE AZRGSOC TO RA-TW0-AZI-D.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi non chiave
       V-DATI.
           MOVE ZERO TO VFLD.
      *
           IF RG-T-NWIN = 1
              GO TO V-DATI-WINDOW1.
      **** rel 7.1
           IF RG-T-NWIN = 2
              GO TO V-DATI-WINDOW2.
           IF RG-T-NWIN = 3
              GO TO V-DATI-WINDOW3.
      ************
           IF RG-T-NWIN = 4
              GO TO V-DATI-WINDOW4.
      *
       V-DATI-WINDOW1.
      *
       V-PATHECF.
           MOVE 'PATHECF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PATHECF.
           IF RG-D02-PATHECF = SPACE 
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PATHECF.
      *
       V-CHECK.
           MOVE 'CHECK' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CHECK.
           IF RG-D02-CDIAP  = ZERO AND
              RG-D02-EPSO   = ZERO AND 
              RG-D02-CINTRA = ZERO AND
              RG-D02-CSANM  = ZERO AND
              RG-D02-OPERAS = ZERO
              MOVE 'Selezionare almeno una delle scelte' TO F-MES1
              MOVE 'sottostanti.                       ' TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR. 
       E-CHECK.
      *
           GO TO END-V-DATI.
      *
       V-DATI-WINDOW2.
      *
       V-CFRAP.
           MOVE 'CFRAP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CFRAP.
           IF RG-D02-CFRAP = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE ZERO TO RISPFISC RISPIVA.
           IF RG-D02-CFRAP(12:) = SPACE AND RG-D02-CFRAP(1:11) NUMERIC
              MOVE RG-D02-CFRAP(1:11) TO CODPIVA
              CALL 'rpiva' USING PARPIVA
           ELSE
              MOVE RG-D02-CFRAP TO COMFISC
              CALL 'rfisc' USING PARFISC.
           IF RISPFISC NOT = ZERO OR RISPIVA NOT = ZERO 
              MOVE "Codice fiscale errato" TO MESS
              GO TO V-ERROR.
      *
           IF FUN NOT = 'V' GO TO E-CFRAP.
      *
           MOVE RG-D02-CFRAP TO CDFISC.
      *
           IF CDFISC = SPACE GO TO E-CFRAP.
           IF BLK = SPACE    GO TO E-CFRAP.
           IF NOT (AN NUMERIC AND GI NUMERIC) GO TO E-CFRAP.
           MOVE ZERO TO K.
       L-CDFISC.
           ADD 1 TO K.
           IF K > 12 GO TO E-CFRAP.
           IF MS NOT = NUMMES (K) GO TO L-CDFISC.
           MOVE K      TO MM9.
           MOVE ANM    TO AA9.
           MOVE GIM    TO GG9.
           IF GG9 > 31
              SUBTRACT 40 FROM GG9
              MOVE 'F' TO RG-D02-SERAP
           ELSE
              MOVE 'M' TO RG-D02-SERAP.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 NOT = ZERO
              MOVE SPACE TO RG-D02-SERAP
              GO TO E-CFRAP.
           MOVE GGMMAA4 TO RG-D02-DTRAP.
      *
       E-CFRAP.
      *
       V-CFDIC.
           MOVE 'CFDIC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CFDIC.
           IF RG-D02-CFDIC = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE ZERO TO RISPFISC RISPIVA.
           IF RG-D02-CFDIC(12:) = SPACE AND RG-D02-CFDIC(1:11) NUMERIC
              MOVE RG-D02-CFDIC(1:11) TO CODPIVA
              CALL 'rpiva' USING PARPIVA
           ELSE
              MOVE RG-D02-CFDIC TO COMFISC
              CALL 'rfisc' USING PARFISC.
           IF RISPFISC NOT = ZERO OR RISPIVA NOT = ZERO 
              MOVE "Codice fiscale errato" TO MESS
              GO TO V-ERROR.
       E-CFDIC.
      *
       V-DTRAP.
           MOVE 'DTRAP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTRAP.
           MOVE 4 TO TIPOP1.
           MOVE RG-D02-DTRAP TO GGMMAA4.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTRAP.
      *
       V-NORAP.
           MOVE 'NORAP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NORAP.
           IF RG-D02-CORAP = SPACE GO TO E-NORAP.
           IF RG-D02-NORAP = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-NORAP.
      *
       V-CONRAP.
           MOVE 'CONRAP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CONRAP.
           IF RG-D02-CORAP = SPACE GO TO E-CONRAP.
           IF RG-D02-CONRAP = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-CONRAP.
      *
       V-CFSOC.
           MOVE 'CFSOC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CFSOC.
      *
      *    MOVE ZERO TO RISPFISC RISPIVA.
      *    IF RG-D02-CFSOC(12:) = SPACE AND RG-D02-CFSOC(1:11) NUMERIC
      *       MOVE RG-D02-CFSOC(1:11) TO CODPIVA
      *       CALL 'rpiva' USING PARPIVA
      *    ELSE
      *       MOVE RG-D02-CFSOC TO COMFISC
      *       CALL 'rfisc' USING PARFISC.
      *    IF RISPFISC NOT = ZERO OR RISPIVA NOT = ZERO 
      *       MOVE "Codice fiscale errato" TO MESS
      *       GO TO V-ERROR.
       E-CFSOC.
      *
           GO TO END-V-DATI.
       V-DATI-WINDOW3.
           GO TO END-V-DATI.
       V-DATI-WINDOW4.
      *
       V-CFINT.
           MOVE 'CFINT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CFINT.
      *
           MOVE ZERO TO RISPFISC RISPIVA.
           IF RG-D02-CFINT(12:) = SPACE AND RG-D02-CFINT(1:11) NUMERIC
              MOVE RG-D02-CFINT(1:11) TO CODPIVA
              CALL 'rpiva' USING PARPIVA
           ELSE
              MOVE RG-D02-CFINT TO COMFISC
              CALL 'rfisc' USING PARFISC.
           IF RISPFISC NOT = ZERO OR RISPIVA NOT = ZERO 
              MOVE "Codice fiscale errato" TO MESS
              GO TO V-ERROR.
           IF RG-D02-CFINT = SPACE MOVE ZERO TO RG-D02-NRCAF 
                                                RG-D02-DTIMP.
       E-CFINT.
      *
       V-DTIMP.
           MOVE 'DTIMP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTIMP.
           MOVE 1 TO TIPOP1.
           MOVE RG-D02-DTIMP TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF RG-D02-CFINT NOT = SPACE AND
              RG-D02-DTIMP = ZERO
                 PERFORM ERR-ZERO
                 GO TO V-ERROR.
       E-DTIMP.
      *
           GO TO END-V-DATI.
      *
       END-V-DATI.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *---------------------------------------------------------------
      * Creazione record vuoto di una tabella inesistente            *
      *---------------------------------------------------------------
       SCRIVI-D02A.
           MOVE ZERO    TO REKD02.
      *
           MOVE ' '    TO D02-PATHECF.
           IF EX-DFL NOT = LOW-VALUE AND
              EX-FL NOT = LOW-VALUE
                STRING EX-DFL EX-FL '\' DELIMITED SPACE
                       INTO D02-PATHECF.
           IF EX-WS NOT = LOW-VALUE AND
              EX-UTI NOT = LOW-VALUE
      **** rel 6.3
      *          MOVE EX-UTI TO PCFG-PATH
                 DISPLAY 'PRF-DIR' UPON ENVIRONMENT-NAME
                 ACCEPT PCFG-PATH FROM ENVIRONMENT-VALUE ON EXCEPTION
                        MOVE EX-UTI TO PCFG-PATH
                 END-ACCEPT
      ************
                 MOVE ZERO TO PCFG-R-FUN
                 MOVE EX-WS TO PCFG-R-WS
                 MOVE 'PATH-ECF' TO PCFG-R-COD
                 CALL 'readcfg' USING PARPCFG-R PCFG-CTR
                                      ON EXCEPTION MOVE 9 TO PCFG-ST
                 END-CALL
                 IF PCFG-ST = ZERO AND PCFG-R-VAL NOT = SPACE
                    MOVE SPACE TO D02-PATHECF
                    STRING PCFG-R-VAL '\' DELIMITED SPACE
                           INTO D02-PATHECF.
      *
           MOVE 'A'     TO D02-PRG.
           PERFORM WRITE-NUOVA-DIT THRU EX-WRITE-NUOVA-DIT.
       EX-SCRIVI-D02A.
           EXIT.
      *------------------
      **** rel 7.1
       SCRIVI-D02B.
           MOVE ZERO    TO REKD02.
           MOVE SPACE   TO D02-CFRAP
                           D02-CFDIC
                           D02-CORAP
                           D02-NORAP
                           D02-CONRAP
                           D02-PRNRAP.
           MOVE 'M'     TO D02-SERAP.
           MOVE 'B'     TO D02-PRG.
           PERFORM WRITE-NUOVA-DIT THRU EX-WRITE-NUOVA-DIT.
       EX-SCRIVI-D02B.
           EXIT.
      *----------------------------------------------------------------
       SCRIVI-D02C.
           MOVE ZERO    TO REKD02.
           MOVE SPACE   TO D02-CORRAP
                           D02-PRRRAP
                           D02-INRRAP
                           D02-TELRAP.
           MOVE 'C'     TO D02-PRG.
           PERFORM WRITE-NUOVA-DIT THRU EX-WRITE-NUOVA-DIT.
       EX-SCRIVI-D02C.
           EXIT.
      *----------------------------------------------------------------
       SCRIVI-D02D.
           MOVE ZERO    TO REKD02.
           MOVE SPACE   TO D02-STAEST
                           D02-CDSTA
                           D02-NIVAE.
           MOVE 'D'     TO D02-PRG.
           PERFORM WRITE-NUOVA-DIT THRU EX-WRITE-NUOVA-DIT.
       EX-SCRIVI-D02D.
           EXIT.
      *----------------------------------------------------------------
       SCRIVI-D02E.
           MOVE ZERO    TO REKD02.
           MOVE SPACE   TO D02-EMAIL
                           D02-TEL
                           D02-FAX.
           MOVE 'E'     TO D02-PRG.
           PERFORM WRITE-NUOVA-DIT THRU EX-WRITE-NUOVA-DIT.
       EX-SCRIVI-D02E.
           EXIT.
      *----------------------------------------------------------------
      ************
       SCRIVI-D02I.
           MOVE ZERO    TO REKD02.
           MOVE SPACE   TO D02-CFINT.
           MOVE 1       TO D02-FLGMOD.
      *
           MOVE 'I'     TO D02-PRG.
           PERFORM WRITE-NUOVA-DIT THRU EX-WRITE-NUOVA-DIT.
       EX-SCRIVI-D02I.
           EXIT.
      *----------------------------------------------------------------
      * Lettura - Caricamento RG 
      *       oppure
      * Lettura di riposizionamento - Caricamento REC - Rewrite Tabella
      *   dei dati relativi ad una tabella specifica
      *----------------------------------------------------------------
       LEG-AGG-D02A.
           MOVE ZERO  TO VKEY.
           MOVE 02        TO D02-TIP.
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'A'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
                 PERFORM CARICA-REC-D02A THRU EX-CARICA-REC-D02A
                 PERFORM REWRITE-K      THRU EX-REWRITE-K
              ELSE
                 PERFORM CARICA-RG-D02A THRU EX-CARICA-RG-D02A
                 PERFORM CARICA-RA      THRU EX-CARICA-RA.
       EX-LEG-AGG-D02A.
           EXIT.
      *------------------
      **** rel 7.1
       LEG-AGG-D02B.
           MOVE ZERO  TO VKEY.
           MOVE 02        TO D02-TIP.
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'B'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
                 PERFORM CARICA-REC-D02B THRU EX-CARICA-REC-D02B
                 PERFORM REWRITE-K      THRU EX-REWRITE-K
              ELSE
                 PERFORM CARICA-RG-D02B THRU EX-CARICA-RG-D02B
                 PERFORM CARICA-RA      THRU EX-CARICA-RA.
       EX-LEG-AGG-D02B.
           EXIT.
      *------------------
       LEG-AGG-D02C.
           MOVE ZERO  TO VKEY.
           MOVE 02        TO D02-TIP.
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'C'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
                 PERFORM CARICA-REC-D02C THRU EX-CARICA-REC-D02C
                 PERFORM REWRITE-K      THRU EX-REWRITE-K
              ELSE
                 PERFORM CARICA-RG-D02C THRU EX-CARICA-RG-D02C
                 PERFORM CARICA-RA      THRU EX-CARICA-RA.
       EX-LEG-AGG-D02C.
           EXIT.
      *------------------
       LEG-AGG-D02D.
           MOVE ZERO  TO VKEY.
           MOVE 02        TO D02-TIP.
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'D'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
                 PERFORM CARICA-REC-D02D THRU EX-CARICA-REC-D02D
                 PERFORM REWRITE-K      THRU EX-REWRITE-K
              ELSE
                 PERFORM CARICA-RG-D02D THRU EX-CARICA-RG-D02D
                 PERFORM CARICA-RA      THRU EX-CARICA-RA.
       EX-LEG-AGG-D02D.
           EXIT.
      *------------------
       LEG-AGG-D02E.
           MOVE ZERO  TO VKEY.
           MOVE 02        TO D02-TIP.
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'E'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
                 PERFORM CARICA-REC-D02E THRU EX-CARICA-REC-D02E
                 PERFORM REWRITE-K      THRU EX-REWRITE-K
              ELSE
                 PERFORM CARICA-RG-D02E THRU EX-CARICA-RG-D02E
                 PERFORM CARICA-RA      THRU EX-CARICA-RA.
       EX-LEG-AGG-D02E.
           EXIT.
      *------------------
      ************
       LEG-AGG-D02I.
           MOVE ZERO  TO VKEY.
           MOVE 02        TO D02-TIP.
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'I'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           PERFORM READ-K THRU EX-READ-K.
           IF RG-T-ST = 7 
              MOVE 1 TO VKEY
           ELSE
              IF FUN = 'A'
                 PERFORM CARICA-REC-D02I THRU EX-CARICA-REC-D02I
                 PERFORM REWRITE-K      THRU EX-REWRITE-K
              ELSE
                 PERFORM CARICA-RG-D02I THRU EX-CARICA-RG-D02I
                 PERFORM CARICA-RA      THRU EX-CARICA-RA.
       EX-LEG-AGG-D02I.
           EXIT.
      *------------------
      **** rel 7.1
       STORICO.
           MOVE EX1-DTAPE TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AA4 = ZERO 
              GO TO EX-STORICO.
      *    STRING 'allcfx' AA4 DELIMITED SPACE INTO ID-LCC.
      *    STRING 'allcfr' AA4 DELIMITED SPACE INTO ID-LCR.
           STRING 'leitab' AA4 DELIMITED SPACE INTO ID-DIT.
       EX-STORICO.
           EXIT.
      *------------------
      ************
