       IDENTIFICATION DIVISION.
       PROGRAM-ID. VPLAWRD.
      **** rel 7.2
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           SELECT LETINT ASSIGN TO DISK
                  ORGANIZATION SEQUENTIAL
                  STATUS SF-LET.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'grilet'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parab'.
           COPY 'parwo'.
           COPY 'parrm'.
           COPY 'parop'.
           COPY 'parul'.
           COPY 'parrd'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-LET PIC X(80) VALUE 'letint'.
      *
       01  COMODI.
           05 SF-AZI     PIC XX.
           05 SF-LET     PIC XX.
           05 NPAG       PIC 999.
           05 MESS       PIC X(40) VALUE SPACE.
           05 CODCLI     PIC 9(7).
           05 TIPPER     PIC 9.
           05 K          PIC 99.
           05 VETTORE-VALORI.
              10 VET-A PIC S9(11)V99 COMP-3 OCCURS 34.
           05 DATI-INTERI PIC X(1800).
           05 DATI-DIVISI REDEFINES DATI-INTERI OCCURS 75.
              10 IDE PIC X(8).
              10 VAL PIC X(16).
           05 CONT PIC 9(5).
           05 TOTPAG PIC 9(5).
           05 COMNRIG PIC 9(5).
      *
           COPY 'vplawrd.cpy'.
       LINKAGE SECTION.
           COPY 'parwpla'.
       PROCEDURE DIVISION USING PARWPLA PARCCD.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
      *
           MOVE ZERO TO PCCD-ERR.

      * Inizializza
           IF PCCD-FUN = 'T' OR 'I'
              PERFORM PGM-INI THRU EX-PGM-INI.

      * Esegue
           IF PCCD-FUN = 'T' OR 'R'
              PERFORM PGM-RUN THRU EX-PGM-RUN.

      * Chiude
           IF PCCD-FUN = 'T' OR 'E'
              PERFORM PGM-END THRU EX-PGM-END
              GO TO CHIUDI.

           GO TO FINE.
       ERRIO.
           COPY 'errsub'.
           MOVE 9 TO PCCD-ERR.
           PERFORM WRD-CL.
       CHIUDI.
           CLOSE ANAAZI.
       FINE.
           EXIT PROGRAM.
      *-------------------*
           COPY 'griwrd'.
      *-------------------*
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'grixxxer'.
      *------------------------------------------*
       PGM-END.
           PERFORM WRD-END.
       EX-PGM-END.
           EXIT.
      *------------------------------------------*
       PGM-INI.
           OPEN INPUT ANAAZI.
      *
           MOVE PWPLA-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
      *
           MOVE 'intent'  TO WO-IDDOC.
           MOVE PWPLA-AZI TO WO-AZI.
           PERFORM WRD-INI.
      *
       EX-PGM-INI.
           EXIT.
      *------------------------------------------*
       PGM-RUN.
           STRING PWPLA-FILE DELIMITED SPACE INTO ID-LET.
           OPEN INPUT LETINT.
           IF SF-LET NOT = ZERO
              MOVE 'FILE INESISTENTE' TO MESS
              GO TO ERRIO.
           IF SAVPATH = SPACE AND PCCD-PATH NOT = SPACE
              STRING PCCD-PATH DELIMITED SPACE
                     '\pla'
                     PWPLA-AZI
                     PWPLA-NPRT
                     '.doc'
                     DELIMITED SIZE INTO SAVPATH
              MOVE SAVPATH TO PCCD-PATH.
      *
           MOVE ZERO TO NPAG CONT.
      *
           MOVE PWPLA-NRIG TO COMNRIG.
           MOVE 1 TO TOTPAG.
           OPEN INPUT LETINT.
       INIZIO-LETTURA.
           READ LETINT AT END GO TO FINE-LETTURA.
           ADD 1 TO CONT.
           IF RF-LET(1:1) = 'A'
              PERFORM STAMPA-RECA THRU EX-STAMPA-RECA.
           IF RF-LET(1:1) = 'B' AND CONT = COMNRIG 
              PERFORM STAMPA-RECB THRU EX-STAMPA-RECB.
           GO TO INIZIO-LETTURA.
       FINE-LETTURA.
              CLOSE LETINT.
       EX-PGM-RUN.
           EXIT.
      *------------------------------------------*
       SCR-REC.
           MOVE SPACE TO D-FLGS.
           IF PCCD-FLGS = 0
              MOVE 'S' TO D-FLGS.
           MOVE PCCD-PATH TO D-IDDOC.
      *
           PERFORM WRD-WR.
       EX-SCR-REC.
           EXIT.
      *-------------------------------
       STAMPA-RECA.
      *
           PERFORM WRD-AZZ.
      *
           ADD 1 TO NPAG.
      *
           MOVE 1       TO D-NCOP.
           MOVE SPACE   TO D-FAX.
           MOVE TOTPAG  TO D-TOTPAG.    
           MOVE WD-TIPS TO D-TIPS.
      *
           MOVE LETA-CDF  TO D-LETA-CDF.
           MOVE LETA-TFO  TO D-LETA-TFO.
           MOVE LETA-CFFO TO D-LETA-CFFO.
       EX-STAMPA-RECA.
           EXIT.
      *-------------------------------
       STAMPA-RECB.
      *
           MOVE LETB-CFDI    TO D-LETB-CFDI.
           MOVE LETB-PRMO    TO D-LETB-PRMO.
           MOVE LETB-NRPR    TO D-LETB-NRPR.
           MOVE LETB-IDDI    TO D-LETB-IDDI.
           MOVE LETB-PSWG    TO D-LETB-PSWG.
           IF LETB-DICO = ZERO
              MOVE SPACE TO D-LETB-DICO
           ELSE
              MOVE 'X'   TO D-LETB-DICO.
           MOVE LETB-PROT1  TO D-LETB-PROT1.
           IF LETB-PROT1 = ZERO
              MOVE SPACE TO D-LETB-PROT1.
           MOVE LETB-PROT2  TO D-LETB-PROT2.
           IF LETB-PROT2 = ZERO
              MOVE SPACE TO D-LETB-PROT2.
           MOVE LETB-COGN    TO D-LETB-DENO.
           IF LETB-COGN = SPACE
              MOVE LETB-DENO    TO D-LETB-DENO.
           MOVE LETB-NOME    TO D-LETB-NOME.
           MOVE LETB-PIVA    TO D-LETB-PIVA.
           MOVE LETB-CONA    TO D-LETB-CONA.
           MOVE LETB-PRNA    TO D-LETB-PRNA.
           MOVE LETB-DTNA(1:2) TO D-LETB-DTNAGG.
           MOVE LETB-DTNA(3:2) TO D-LETB-DTNAMM.
           MOVE LETB-DTNA(5:4) TO D-LETB-DTNAAA.
           MOVE LETB-SESS TO D-LETB-SESS.
           MOVE LETB-CFISC   TO D-LETB-CODF.
           IF LETB-CFISCS = ZERO
              MOVE SPACE  TO D-LETB-CFSOC
           ELSE
              MOVE LETB-CFISCS  TO D-LETB-CFSOC.
           MOVE LETB-CODC    TO D-LETB-CODC.
           MOVE LETB-CNF     TO D-LETB-COGNC.
           MOVE LETB-NOF     TO D-LETB-NOMEC.
           MOVE LETB-SEF TO D-LETB-SESSC.
           MOVE LETB-DTNAF(1:2) TO D-LETB-DTNACGG.
           MOVE LETB-DTNAF(3:2) TO D-LETB-DTNACMM.
           MOVE LETB-DTNAF(5:4) TO D-LETB-DTNACAA.
           MOVE LETB-COFN   TO D-LETB-CONAC.
           MOVE LETB-PRFN   TO D-LETB-PRNAC.
           MOVE LETB-NTEL    TO D-LETB-NTEL.
           MOVE LETB-EMAIL   TO D-LETB-EMAIL.
           IF LETB-CACQ = ZERO
              MOVE SPACE TO D-LETB-CACQ
           ELSE
              MOVE 'X'   TO D-LETB-CACQ.
           IF LETB-CIMP = ZERO
              MOVE SPACE TO D-LETB-CIMP
           ELSE
              MOVE 'X'   TO D-LETB-CIMP.
           MOVE LETB-ANNO    TO D-LETB-ANNO.
           MOVE LETB-IMPO TO D-LETB-IMPO.
           MOVE LETB-IMPC TO D-LETB-IMPC.
           MOVE LETB-DTDA(1:2) TO D-LETB-DTDAGG.
           MOVE LETB-DTDA(3:2) TO D-LETB-DTDAMM.
           MOVE LETB-DTDA(5:4) TO D-LETB-DTDAAA.
           MOVE LETB-DTA(1:2) TO D-LETB-DTAGG.
           MOVE LETB-DTA(3:2) TO D-LETB-DTAMM.
           MOVE LETB-DTA(5:4) TO D-LETB-DTAAA.
           MOVE LETB-DESCR    TO D-LETB-DESCR.
           MOVE LETB-NATTR    TO D-LETB-NATTR.
           MOVE LETB-ANNOD    TO D-LETB-ANNOD.
           IF LETB-DOGA = ZERO
              MOVE SPACE TO D-LETB-DOGA
           ELSE
              MOVE 'X'   TO D-LETB-DOGA.
           MOVE LETB-CFISCD  TO D-LETB-CFISCD.
           MOVE LETB-PIVAD   TO D-LETB-PIVAD.
           MOVE LETB-COND    TO D-LETB-DENOM.
           IF LETB-COND = SPACE
              MOVE LETB-DENOM    TO D-LETB-DENOM.
           MOVE LETB-NOMD    TO D-LETB-NOMD.
           MOVE LETB-SES     TO D-LETB-SES.
      *
           IF LETB-TPLA = 1
              MOVE 'X'   TO D-LETB-TPLA1
              MOVE SPACE TO D-LETB-TPLA2
           ELSE
              MOVE SPACE TO D-LETB-TPLA1
              MOVE 'X'   TO D-LETB-TPLA2.
      *
           IF LETB-CDIAP = ZERO
              MOVE SPACE TO D-LETB-CDIAP
           ELSE
              MOVE 'X'   TO D-LETB-CDIAP.
      *
           IF LETB-EPSO = ZERO
              MOVE SPACE TO D-LETB-EPSO
           ELSE
              MOVE 'X'   TO D-LETB-EPSO.
      *
           IF LETB-CINTRA = ZERO
              MOVE SPACE TO D-LETB-CINTRA
           ELSE
              MOVE 'X'   TO D-LETB-CINTRA.
      *
           IF LETB-CSANM = ZERO
              MOVE SPACE TO D-LETB-CSANM
           ELSE
              MOVE 'X'   TO D-LETB-CSANM.
      *
           IF LETB-OPERAS = ZERO
              MOVE SPACE TO D-LETB-OPERAS
           ELSE
              MOVE 'X'   TO D-LETB-OPERAS.
      *
           IF LETB-OPERST = ZERO
              MOVE SPACE TO D-LETB-OPERST
           ELSE
              MOVE 'X'   TO D-LETB-OPERST.
      *
           MOVE LETB-CFISI TO D-LETB-CFISI.
           MOVE LETB-DTIM(1:2) TO D-LETB-DTIMGG.
           MOVE LETB-DTIM(3:2) TO D-LETB-DTIMMM.
           MOVE LETB-DTIM(5:4) TO D-LETB-DTIMAA.
      *
           PERFORM SCR-REC THRU EX-SCR-REC.
           MOVE ZERO TO NPAG.
       EX-STAMPA-RECB.
           EXIT.
      *-------------------------------
