       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRCGISO.
      *
      *    Routine per la verifica se documento scissione pagamento
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritabsl'.
           COPY 'griconsl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           COPY 'grimszsl'.
           COPY 'grimvxsl'.
           COPY 'grimsxsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritab'.
           COPY 'gricon'.
           COPY 'griclf'.
           COPY 'grimov'.
           COPY 'grimsz'.
           COPY 'grimvx'.
           COPY 'grimsx'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.    
           COPY 'gritabrk'.
           COPY 'grimovrk'.                                       
           COPY 'grimolrk'.                                       
           COPY 'griconrk'.
           COPY 'grit20rk'.
           COPY 'grit14g'.
           COPY 'parzf'.
           COPY 'parag'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MSZ PIC X(15) VALUE 'movsez'.
       01  ID-MVX PIC X(15) VALUE 'movmxx'.
       01  ID-MSX PIC X(15) VALUE 'movsxx'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CON  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-MOV  PIC XX.
           05 SF-MSZ  PIC XX.
           05 SF-MVX  PIC XX.
           05 SF-MSX  PIC XX.
       01  AREE.
           05 CIVAV    PIC 9(7).
           05 CIVAQ    PIC 9(7).
           05 FIVAV    PIC 9.
           05 FIVAQ    PIC 9.
           05 COMCON   PIC 9(7).
           05 CLAV     PIC 9(7) VALUE ZERO.
           05 CRPCL    PIC 9(7).
           05 CRPC1    PIC 9(7).
           05 CRPC2    PIC 9(7).
           05 CRPFR    PIC 9(7).
           05 CRPF1    PIC 9(7).
           05 CRPF2    PIC 9(7).
           05 GISO     PIC 9(3).
           05 MESS    PIC X(40).
       LINKAGE SECTION.
           COPY 'pargiso'.
       PROCEDURE DIVISION USING PARGISO.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'dclcon'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dclmsz'.
           COPY 'dclmvx'.
           COPY 'dclmsx'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
      *
           MOVE ZERO TO PGISO-STATO.
           IF PGISO-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'anacon' TO ID-CON
                           MOVE 'anaclf' TO ID-CLF
                           MOVE 'movime' TO ID-MOV
                           MOVE 'movsez' TO ID-MSZ
                           MOVE 'movmxx' TO ID-MVX
                           MOVE 'movsxx' TO ID-MSX.
           IF PGISO-FL = 1 OR 2
                           MOVE 'anazol' TO ID-AZI
                           MOVE 'tabold' TO ID-TAB
                           MOVE 'anacol' TO ID-CON
                           MOVE 'anacfx' TO ID-CLF
                           MOVE 'movmol' TO ID-MOV
                           MOVE 'movsol' TO ID-MSZ
                           MOVE 'movoxx' TO ID-MVX
                           MOVE 'mosoxx' TO ID-MSX.
      *
           OPEN INPUT TABELL.
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID GO TO FINE.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-CRPCL TO CRPCL.
           MOVE T01-CRPC1 TO CRPC1.
           MOVE T01-CRPC2 TO CRPC2.
           MOVE T01-CRPFR TO CRPFR.
           MOVE T01-CRPF1 TO CRPF1.
           MOVE T01-CRPF2 TO CRPF2.
           MOVE T01-CIVAV TO CIVAV.
           MOVE T01-CIVAQ TO CIVAQ.
      *
           MOVE 14 TO KTB-TIP.
           MOVE  5 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO FINE.
           MOVE T14-GISO TO GISO.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 7  TO KTB-COD.
           READ TABELL INTO RKTB14G INVALID GO TO FINE.
      *
           OPEN INPUT MOVSEZ.
           MOVE PGISO-NREG TO KS2-NREG.
           START MOVSEZ KEY NOT < KEYMS2 INVALID GO TO MSZ5.
       LPES.
           READ MOVSEZ NEXT AT END GO TO MSZ5.
           IF SF-MSZ = '9D' OR '9A' OR '35' GO TO LPES.
           IF KS2-NREG > PGISO-NREG GO TO MSZ5.
           IF KMS-AZI NOT = PGISO-AZI GO TO LPES.
           IF PGISO-DTREG NOT = ZERO
              IF KMS-DAT NOT = PGISO-DTREG GO TO LPES.
           MOVE RF-MSZ TO REKMOV.
           IF KMS-CON NOT = CIVAV AND KMS-CON NOT = CIVAQ GO TO SOTTO.
           IF MOV-IMPO = ZERO GO TO LPES.
       SOTTO.
           MOVE RF-MSZ TO REKMOV.
           IF MOV-CAUS = GISO AND MOV-DTDOC >= 42005
              MOVE 1 TO PGISO-STATO
              GO TO FINE.
           GO TO LPES.
       MSZ5.
           CLOSE MOVSEZ.
       MSZ10.
           OPEN INPUT MOVSXX.
           IF PGISO-DTREG = ZERO GO TO LPGEN.
           MOVE PGISO-NREG TO KSX2-NREG.
           START MOVSXX KEY NOT < KEYSX2 INVALID GO TO LPGEN.
       LPESOL.
           READ MOVSXX NEXT AT END GO TO LPGEN.
           IF SF-MSX = '9D' OR '9A' OR '35' GO TO LPESOL.
           IF KSX2-NREG > PGISO-NREG GO TO LPGEN.
           IF KSX-AZI NOT = PGISO-AZI GO TO LPESOL.
           IF PGISO-DTREG NOT = ZERO
              IF KSX-DAT NOT = PGISO-DTREG GO TO LPESOL.
           MOVE RF-MSX TO REKMOV.
           IF MOV-CAUS = GISO AND MOV-DTDOC >= 42005
              MOVE 1 TO PGISO-STATO
              GO TO FINE.
           GO TO LPESOL.
       LPGEN.
           CLOSE MOVSXX.
           OPEN INPUT MOVIME.
       STMOV.
           MOVE PGISO-NREG TO KM2-NREG.
           START MOVIME KEY NOT < KEYMV2 INVALID GO TO EXES0.
       RDMOV.
           READ MOVIME NEXT AT END GO TO EXES0.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO RDMOV.
           IF KM2-NREG > PGISO-NREG GO TO EXES0.
           IF KMV-AZI NOT = PGISO-AZI GO TO RDMOV.
           IF PGISO-DTREG NOT = ZERO
              IF KMV-DAT NOT = PGISO-DTREG GO TO RDMOV.
           IF KMV-NUM < 99991     GO TO RDMOV1.
           IF KMV-CON = CRPCL     GO TO RDMOV.
           IF KMV-CON = CRPC1     GO TO RDMOV.
           IF KMV-CON = CRPC2     GO TO RDMOV.
           IF KMV-CON = T14-CRPC3 GO TO RDMOV.
           IF KMV-CON = T14-CRPC4 GO TO RDMOV.
           IF KMV-CON = T14-CRPC5 GO TO RDMOV.
           IF KMV-CON = T14-CRPC6 GO TO RDMOV.
           IF KMV-CON = T14-CRPC7 GO TO RDMOV.
           IF KMV-CON = T14-CRPC8 GO TO RDMOV.
           IF KMV-CON = CRPFR     GO TO RDMOV.
           IF KMV-CON = CRPF1     GO TO RDMOV.
           IF KMV-CON = CRPF2     GO TO RDMOV.
           IF KMV-CON = T14-CRPF3 GO TO RDMOV.
           IF KMV-CON = T14-CRPF4 GO TO RDMOV.
           IF KMV-CON = T14-CRPF5 GO TO RDMOV.
           IF KMV-CON = T14-CRPF6 GO TO RDMOV.
           IF KMV-CON = T14-CRPF7 GO TO RDMOV.
           IF KMV-CON = T14-CRPF8 GO TO RDMOV.
       RDMOV1.
           MOVE RF-MOV TO REKMOV.
           IF MOV-CAUS = GISO AND MOV-DTDOC >= 42005
              MOVE 1 TO PGISO-STATO
              GO TO FINE.
           GO TO RDMOV.
       EXES0.
           CLOSE MOVIME.
       EXES.
           OPEN INPUT MOVMXX.
           IF PGISO-DTREG = ZERO GO TO EXES1.
           MOVE PGISO-NREG TO KX2-NREG.
           START MOVMXX KEY NOT < KEYMX2 INVALID GO TO EXES1.
       LPMOL.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO EXES1.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO LPMOL.
           IF KX2-NREG > PGISO-NREG GO TO EXES1.
           IF KMX-AZI NOT = PGISO-AZI GO TO LPMOL.
           IF PGISO-DTREG NOT = ZERO
              IF KMX-DAT NOT = PGISO-DTREG GO TO LPMOL.
           IF KMX-NUM < 99991     GO TO RDMOL1.
           IF KMX-CON = CRPCL     GO TO LPMOL.
           IF KMX-CON = CRPC1     GO TO LPMOL.
           IF KMX-CON = CRPC2     GO TO LPMOL.
           IF KMX-CON = T14-CRPC3 GO TO LPMOL.
           IF KMX-CON = T14-CRPC4 GO TO LPMOL.
           IF KMX-CON = T14-CRPC5 GO TO LPMOL.
           IF KMX-CON = T14-CRPC6 GO TO LPMOL.
           IF KMX-CON = T14-CRPC7 GO TO LPMOL.
           IF KMX-CON = T14-CRPC8 GO TO LPMOL.
           IF KMX-CON = CRPFR     GO TO LPMOL.
           IF KMX-CON = CRPF1     GO TO LPMOL.
           IF KMX-CON = CRPF2     GO TO LPMOL.
           IF KMX-CON = T14-CRPF3 GO TO LPMOL.
           IF KMX-CON = T14-CRPF4 GO TO LPMOL.
           IF KMX-CON = T14-CRPF5 GO TO LPMOL.
           IF KMX-CON = T14-CRPF6 GO TO LPMOL.
           IF KMX-CON = T14-CRPF7 GO TO LPMOL.
           IF KMX-CON = T14-CRPF8 GO TO LPMOL.
       RDMOL1.
           IF MOV-CAUS = GISO AND MOV-DTDOC >= 42005
              MOVE 1 TO PGISO-STATO
              GO TO FINE.
           GO TO LPMOL.
       EXES1.
           CLOSE MOVMXX.
           GO TO FINE.
      *
       ERRIO.
      *    COPY 'errcal'.
       FINE.
           CLOSE TABELL MOVSEZ MOVMXX MOVIME MOVSXX.
       ESCI.
           EXIT PROGRAM.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
