       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRDATLCC2.
      *
      * Stampa - Esporta Movimenti  x allegati iva
      *
      **** rel 6.3
      * nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'grilccsl'.
           COPY 'grilcrsl'.
           COPY 'grialtsl'.
           COPY 'gritabsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS 
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'grilcc'.
           COPY 'grilcr'.
           COPY 'grialt'.
           COPY 'gritab'.
       FD  WDSLAV LABEL RECORD STANDARD 
           VALUE OF FILE-ID ID-LAV
           RECORD 56 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-KCF   PIC 9(7).
              10 KLV-NDOCR PIC 9(5).
           05 REKLAV.
              10 LAV-NVOLTE PIC 9(5).
      * importo totale 
              10 LAV-IMPON  PIC S9(11)V99.
              10 LAV-IMIVA  PIC S9(11)V99.
              10 LAV-CORR   PIC S9(11)V99.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'grilccrk'.
           COPY 'gritabrk'.
           COPY 'gric02rk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parlk'.
           COPY 'parmb'.
           COPY 'prpiva'.
           COPY 'prfisc'.
      **** rel 7.1
       01  ESTERNE1 EXTERNAL.
           02 EX1-DTAPE   PIC 9(5).
           02 EX1-DTCHI   PIC 9(5).
      ************
       01  ID-AZI PIC X(60) VALUE 'anaazi'.
       01  ID-CON PIC X(60) VALUE 'anacon'.
       01  ID-LCC PIC X(60) VALUE 'allcfx'.
       01  ID-LCR PIC X(60) VALUE 'allcfr'.
       01  ID-ALT PIC X(60) VALUE 'alltab'.
       01  ID-TAB PIC X(60) VALUE 'tabell'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  COMODI.
           05 SF-AZI  PIC XX.
           05 SF-CON  PIC XX.
           05 SF-LCC  PIC XX.
           05 SF-LCR  PIC XX.
           05 SF-ALT  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-LAV  PIC XX.
           05 MESS    PIC X(40) VALUE SPACE.
           05 MCLI    PIC 99.
           05 MFOR    PIC 99.
           05 PCLF    PIC 9(7).
      **** rel 7.1
      *    05 NDOCR   PIC 9(5).
           05 NVOLTE  PIC 9(5).
      ************
           05 CLIFOR  PIC 9(7).
           05 KATTESA PIC 9(5) VALUE ZERO.
           05 KRIFER   PIC X(50).
           05 FLGPRI  PIC 9 VALUE ZERO.
           05 FLGTROV PIC 9 VALUE ZERO.
           05 COMTP1  PIC 9.
           05 PIVA   PIC 9(11)  VALUE ZERO.
           05 PIVX   REDEFINES PIVA PIC X(11).
           05 COMCFISC.
              10 COMCFP  PIC X(11) VALUE SPACE.
              10 COMBLK  PIC X(5)  VALUE SPACE.
           05 CODICE   PIC 99.99.999.
      **** rel 7.1
           05 SAVCOD  PIC 9(7) VALUE ZERO.
           05 COM-IMPON  PIC S9(11)V99.
           05 COM-IMIVA  PIC S9(11)V99.
           05 COM-IMPONNC PIC S9(11)V99.
           05 COM-IMIVANC PIC S9(11)V99.
           05 COM-IMPONIN  PIC S9(11)V99.
           05 NOPE    PIC 9(7).
           05 NOPEC   PIC 9(7).
           05 NOPEIN  PIC 9(7).
      *
      ************
           05 CRIGA.
              10 FILLER PIC X(9)  VALUE 'DATA REG'.
      **** rel 7.1
      *       10 FILLER PIC X(24) VALUE 'CONTROPARTITA'.
              10 FILLER PIC X(24) VALUE 'CAUSALE'.
      ************
              10 FILLER PIC X(6)  VALUE ' N.REG'.
      **** rel 7.1
      *       10 FILLER PIC X(7)  VALUE ' N.RAGR'.
      *       10 FILLER PIC X(4)  VALUE ' M.P'.
      ************
              10 FILLER PIC X(6)  VALUE ' PROT.'.
              10 FILLER PIC X(6)  VALUE ' N.DOC'.
              10 FILLER PIC X(9)  VALUE ' DATA DOC'.
              10 FILLER PIC X(8)  VALUE ' VAR IMP'.
              10 FILLER PIC X(2)  VALUE SPACE.
              10 FILLER PIC X(13) VALUE '      IMPORTO'.
              10 FILLER PIC X(13) VALUE '      IMPOSTA'.
      **** rel 7.1
      *       10 FILLER PIC X(7)  VALUE ' TP OPE'.
      *       10 FILLER PIC X(3)  VALUE ' ES'.
              10 FILLER PIC X(7)  VALUE '   '.
              10 FILLER PIC X(7)  VALUE ' ES'.
      ************
              10 FILLER PIC X(7)  VALUE ' AT'.
      **** rel 7.1
              10 FILLER PIC X(7)  VALUE ' LE'.
              10 FILLER PIC X(7)  VALUE ' AF'.
              10 FILLER PIC X(7)  VALUE ' DC'.
              10 FILLER PIC X(7)  VALUE ' VI'.
              10 FILLER PIC X(7)  VALUE ' RC'.
              10 FILLER PIC X(7)  VALUE ' NE'.
      ************
              10 FILLER PIC X(34) VALUE SPACE.
      **** rel 7.1
           05 CRIGA2.
              10 FILLER PIC X(9)  VALUE SPACE.
              10 FILLER PIC X(24) VALUE 'TIPO TOTALE'.
              10 FILLER PIC X(6)  VALUE SPACE.
              10 FILLER PIC X(6)  VALUE SPACE.
              10 FILLER PIC X(6)  VALUE SPACE.
              10 FILLER PIC X(9)  VALUE SPACE.
              10 FILLER PIC X(8)  VALUE SPACE.
              10 FILLER PIC X(2)  VALUE SPACE.
              10 FILLER PIC X(13) VALUE '      IMPORTO'.
              10 FILLER PIC X(13) VALUE '      IMPOSTA'.
              10 FILLER PIC X(7)  VALUE SPACE.
              10 FILLER PIC X(7)  VALUE SPACE.
              10 FILLER PIC X(7)  VALUE SPACE.
              10 FILLER PIC X(7)  VALUE SPACE.
              10 FILLER PIC X(7)  VALUE SPACE.
              10 FILLER PIC X(7)  VALUE SPACE.
              10 FILLER PIC X(7)  VALUE SPACE.
              10 FILLER PIC X(7)  VALUE SPACE.
              10 FILLER PIC X(34) VALUE SPACE.
      ************
      *
           COPY 'vrdatlcc.cpy'.
      *
      * Area generata da file '../dsc/movecf.dsc'
      *
       01  RIGXP.
           05 D-ECF-AZI      PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-COD      PIC 9(7)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-RGS      PIC X(36)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-RGS2     PIC X(36)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-INDIR    PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-INDIR2   PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-CAP      PIC 9(5)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-CIT      PIC X(23)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-PRV      PIC X(2)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-PIVA     PIC 9(11)+       VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-FPIVA    PIC 9(1)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-CFISC    PIC X(16)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-FCFIS    PIC 9(1)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-PAE      PIC X(2)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-IVE      PIC X(12)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-ALLIVA   PIC 9(1)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      *
           05 D-ECF-DAT      PIC X(8)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 7.1
      *    05 D-ECF-NDOCR    PIC 9(5)+        VALUE ZERO.
      *    05 FILLER         PIC X            VALUE HIGH-VALUE.
      *    05 D-ECF-MODPAG   PIC 9(1)+        VALUE ZERO.
      *    05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ECF-NUM      PIC 9(5)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-NDOC     PIC 9(5)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-DTDOC    PIC X(8)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      *
           05 D-ECF-NREG     PIC 9(5)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-CON      PIC 9(7)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-DSCON    PIC X(30)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-CAUS     PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-VARIMP   PIC X(1)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-IMPON    PIC 9(11),9(2)+  VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-IMIVA    PIC 9(11),9(2)+  VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-CORR     PIC 9(11),9(2)+  VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 7.1
      *    05 D-ECF-TOPE     PIC 9(1)+        VALUE ZERO.
      *    05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ECF-FL       PIC X(2)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-CATT     PIC X            VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 7.1
           05 D-ECF-LE       PIC X            VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-AF       PIC X            VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-RI       PIC X            VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-IV       PIC X            VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ECF-RE       PIC X            VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ECF-TAPPO    PIC X(1)         VALUE SPACE.
           05 FILLER         PIC X            VALUE LOW-VALUE.

       01  RPT-LNK.
           COPY 'grirpt-l'.
       LINKAGE SECTION.
           COPY 'pardtcf2.cpy'.
      *
       01  IF-MESS         PIC X(204).
      *
           COPY 'parxpls'.
       PROCEDURE DIVISION USING PARDTCF2
                                IF-MESS
                                PARXP.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dcllcc'.
           COPY 'dcllcr'.
           COPY 'dclalt'.
           COPY 'dcltab'.
           COPY 'dcllav'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.
      *
           COPY 'dfdata'.
      *
      **** rel 7.1
           IF RDT2-FL = 1
              PERFORM STORICO THRU EX-STORICO
              IF AA4 = ZERO 
                 MOVE 'Selezionare uno storico' TO MESS
                 GO TO ERRIO
              END-IF 
           ELSE
              MOVE 'allcfx' TO ID-LCC
              MOVE 'alltab' TO ID-ALT
              MOVE 'allcfr' TO ID-LCR.
      ************
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV .
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
      *
           OPEN INPUT ANAAZI.
           OPEN INPUT ALLTAB.
           OPEN INPUT TABELL.
           OPEN INPUT ALLCFX.
           OPEN INPUT ALLCFR.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB 
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE T01-MCLI  TO MCLI.
           MOVE T01-MFOR  TO MFOR.
      *

           MOVE RDT2-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 02        TO C02-TIP.
           MOVE KAZ-COD   TO C02-COD.
           MOVE 'A'       TO C02-PRG.
           MOVE C02-KEYID TO KEYALT.
           READ ALLTAB INTO REKC02 INVALID PERFORM INVK-ALT
                                   GO TO ERRIO.
      *
           IF RDT2-TIPEL = 3
              MOVE RP-M-NOME TO RP-NOME
              PERFORM RPT-INI-START.
      *
           OPEN INPUT ANACON.
           PERFORM RD-MOVALL THRU EX-RD-MOVALL.
           CLOSE ANACON.
      *
           GO TO FINE.
      * -------------- *
       ERRIO.
           COPY 'errsub'.
       FINE.
           CLOSE ANAAZI.
           CLOSE ALLTAB.
           CLOSE TABELL.
           CLOSE ALLCFX.
           CLOSE ALLCFR.
      *
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
      *
           EXIT PROGRAM.
           STOP RUN.
      * --------------- *
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'grilccer'.
           COPY 'grilcrer'.
           COPY 'grialter'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *-----------------
           COPY 'grirpt'.
      *------------------
       RD-MOVALL.
      *
      * come in vcon335
      * sort movimenti esportabili
      *
      *
           MOVE LOW-VALUE TO KEYCC.
           MOVE KAZ-COD   TO KCC-AZI.
           START ALLCFX KEY NOT < KEYCC INVALID GO TO CLST.
       RDLCC.
           READ ALLCFX NEXT INTO REKLCC AT END GO TO CLST.
           IF SF-LCC = '9D' OR '9A' OR '35' GO TO RDLCC.
           IF KCC-AZI > KAZ-COD GO TO RDLCC.
      *
           IF RDT2-CLFO = ZERO AND LCC-MS NOT = MCLI GO TO RDLCC.
           IF RDT2-CLFO = 1    AND LCC-MS NOT = MFOR GO TO RDLCC.
      *
           IF LCC-CD < RDT2-COD-1 GO TO RDLCC.
           IF LCC-CD > RDT2-COD-2 GO TO RDLCC.
      *
           IF RDT2-ALLIVA NOT = 3
              IF NOT (LCC-ALLIVA = RDT2-ALLIVA)  GO TO RDLCC.
      *
           MOVE LOW-VALUE TO KEYLCR.
           MOVE KEYCC TO KEYLCR.
           MOVE ZERO TO KLCR-NDOCR.
           START ALLCFR KEY NOT < SKEYLCR1 INVALID GO TO END-LCR.
       RD-LCR.
           READ ALLCFR NEXT AT END GO TO END-LCR.
           IF KLCR-AZI > KCC-AZI GO TO END-LCR.
           IF KLCR-COD > KCC-COD GO TO END-LCR.
           IF RDT2-TPMOV NOT = LCR-TPMOV GO TO RD-LCR.
      *
           MOVE KCC-COD    TO KLV-KCF.
           MOVE KLCR-NDOCR TO KLV-NDOCR.
           READ WDSLAV.
           IF SF-LAV = '00'
              ADD 1          TO LAV-NVOLTE
              ADD LCR-IMPON  TO LAV-IMPON
              ADD LCR-IMIVA  TO LAV-IMIVA
              ADD LCR-CORR   TO LAV-CORR
              REWRITE RF-LAV INVALID 
                 MOVE 'Errore scrittura wdslav' TO MESS
                 CLOSE WDSLAV
                 GO TO ERRIO
              END-REWRITE
           ELSE
              MOVE 1          TO LAV-NVOLTE
              MOVE LCR-IMPON  TO LAV-IMPON
              MOVE LCR-IMIVA  TO LAV-IMIVA
              MOVE LCR-CORR   TO LAV-CORR
              WRITE RF-LAV INVALID 
                 MOVE 'Errore scrittura wdslav' TO MESS
                 CLOSE WDSLAV
                 GO TO ERRIO.
      *
           GO TO RD-LCR.
       END-LCR.
       
           GO TO RDLCC.
       CLST.
      *
      * stampo o esporto
      *
           IF RDT2-TIPEL = 2 GO TO NO-INT.
      *
           MOVE ZERO TO FLGPRI.
      **** rel 7.1
           MOVE ZERO TO COM-IMPON COM-IMIVA COM-IMPONNC COM-IMIVANC NOPE
                        NOPEC NOPEIN COM-IMPONIN.
      ************
      *                 
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DATAST.

           MOVE AZI-RGSOC TO INTEAZ.
           MOVE AZI-CFISC TO CDFISC.
      *
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 56      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 1       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE 1       TO LMOD.
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'MOVIMENTI PER SPESOMETRO CL/FR   AL ' DATAST
                  DELIMITED SIZE INTO RP-TIT1.
      *
      **** rel 7.1
      *    PERFORM RPT-RIG2-INTC.
           PERFORM RPT-RIG2-INTC THRU EX-RPT-RIG2-INTC.
      ************
      *
      *    MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
      *
       NO-INT.
           MOVE LOW-VALUE TO KEYCC.
           MOVE KAZ-COD   TO KCC-AZI.
           IF RDT2-TPSTA = 1
              START ALLCFX KEY NOT < KEYCC INVALID GO TO END-LAB.
           IF RDT2-TPSTA = 2
              MOVE LOW-VALUE TO KEYCC2
              START ALLCFX KEY NOT < KEYCC2 INVALID GO TO END-LAB.
       RD-LAB10.
           READ ALLCFX NEXT INTO REKLCC AT END GO TO END-LAB.
           IF SF-LCC = '9D' OR '9A' OR '35' GO TO RD-LAB10.
           IF KCC-AZI NOT = KAZ-COD GO TO RD-LAB10.
      *
           IF RDT2-CLFO = ZERO AND LCC-MS NOT = MCLI GO TO RD-LAB10.
           IF RDT2-CLFO = 1    AND LCC-MS NOT = MFOR GO TO RD-LAB10.
      *
           IF LCC-CD < RDT2-COD-1 GO TO RD-LAB10.
           IF LCC-CD > RDT2-COD-2 GO TO RD-LAB10.
      *
           IF RDT2-ALLIVA NOT = 3
              IF NOT (LCC-ALLIVA = RDT2-ALLIVA)  GO TO RD-LAB10.
      *
      **** rel 7.1
      *    MOVE ZERO TO PCLF NDOCR CLIFOR.
           MOVE ZERO TO PCLF NVOLTE CLIFOR.
      ************
           MOVE ZERO TO FLGTROV.
      *
           MOVE LOW-VALUE TO KEYLCR.
           MOVE KEYCC TO KEYLCR.
           MOVE ZERO TO KLCR-NDOCR.
           IF RDT2-TPSTA = 1
              START ALLCFR KEY NOT < KEYLCR INVALID GO TO END-LAB30.
           IF RDT2-TPSTA = 2
              START ALLCFR KEY NOT < SKEYLCR1 INVALID GO TO END-LAB30.
       RD-LAB30.
           READ ALLCFR NEXT AT END GO TO END-LAB30.
           IF KLCR-AZI > KCC-AZI GO TO END-LAB30.
           IF KLCR-COD > KCC-COD GO TO END-LAB30.
           IF RDT2-TPMOV NOT = LCR-TPMOV GO TO RD-LAB30.
      **** rel 7.1
           IF RDT2-TPSTA = 2
              IF LCR-IMPON < 1 AND
                 LCR-IMPON > -1 AND
                 LCR-IMPON NOT = ZERO 
                 GO TO RD-LAB30
              END-IF
              IF LCR-CORR < 1 AND
                 LCR-CORR > -1 AND
                 LCR-CORR NOT = ZERO 
                 GO TO RD-LAB30.
      ************

           MOVE 1 TO FLGTROV.

           MOVE RDT2-AZI TO KPC-AZI.
           MOVE LCR-CON TO KPC-COD.
           READ ANACON INVALID MOVE SPACE TO CON-DSC.
      *
      * come in vcon335
      *
           MOVE KLCR-COD TO KLV-KCF
           MOVE KLCR-NDOCR  TO KLV-NDOCR
           READ WDSLAV INVALID MOVE ZERO TO LAV-NVOLTE LAV-IMPON
                                            LAV-IMIVA LAV-CORR.
           IF RDT2-TPCAL = 2
              IF LCR-EXPFOR = 0
                 IF LAV-IMPON NOT = ZERO
                    IF (LAV-IMPON < C02-MIN)
                        GO TO RD-LAB30
                    END-IF
                 ELSE
                    IF (LAV-CORR < C02-MINS)
                        GO TO RD-LAB30.
      *
           IF RDT2-TIPEL = 2
              PERFORM SCRIVE-RIGXP  THRU EX-SCRIVE-RIGXP
              PERFORM SCRIVE-RIGXP2 THRU EX-SCRIVE-RIGXP2
              PERFORM SCRIVE-RIGXPE THRU EX-SCRIVE-RIGXPE
              GO TO RD-LAB30.

           IF KLCR-COD = PCLF GO TO NO-RIG1.

      **** rel 7.1
           IF FLGPRI = 1
              PERFORM STA-TOT THRU EX-STA-TOT.
      ************
      * riga vuota
           IF FLGPRI = 1
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
           MOVE 1 TO FLGPRI.

           IF KLCR-COD(1:2) = MCLI 
              MOVE 'CLIENTE' TO RD01
           ELSE 
              MOVE 'FORNITORE' TO RD01.
           MOVE KLCR-COD TO RT01 PCLF.
           MOVE LCC-RGSOC TO RT02.
           MOVE 'P.IVA'   TO RT030.
           MOVE 'C.FISC.' TO RT040.
           MOVE LCC-PIVA  TO PIVA.
           MOVE PIVX TO RT031.
           IF LCC-CFP NOT = PIVX MOVE LCC-CFISC TO RT041.
           IF LCC-CFP = PIVX MOVE SPACE TO RT041.

           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      **** rel 7.1
      *    MOVE CRIGA TO ST-TINT.
           IF RDT2-TPSTA = 2
              MOVE CRIGA2 TO ST-TINT
           ELSE
              MOVE CRIGA TO ST-TINT.
      ************
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *  
       NO-RIG1.
      *
           MOVE SPACE TO RASTE.
      **** rel 7.1
      *    IF LAV-NVOLTE > 1 MOVE '*' TO RASTE.
      *
      *    IF RDT2-TIPEL = 3 AND RDT2-TPSTA = 2 
      *       PERFORM STAMPA-DETT THRU EX-STAMPA-DETT.
      *
           IF LAV-NVOLTE > 1 MOVE '*' TO RASTE
                             ADD 1 TO NVOLTE.
      ************
      *
           MOVE KLCR-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RDMV.

           MOVE LCR-CON TO CODICE.
      **** rel 7.1
      *    STRING CODICE ' ' CON-DSC DELIMITED SIZE INTO RDES1V.
           MOVE 2 TO KTB-TIP.
           MOVE LCR-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
              MOVE SPACE TO TAB-DESCR.
           STRING LCR-CAUS ' ' TAB-DESCR DELIMITED SIZE INTO RDES1V.
      ************
           MOVE LCR-NREG TO RNREG.

      **** rel 7.1
      *    MOVE KLCR-NDOCR  TO RNDOCR.
      *    MOVE LCR-MODPAG  TO RMODPA.
      ************
           MOVE KLCR-NUM    TO RNUM.
           MOVE KLCR-NDOC TO RNDOC.
           MOVE LCR-DTDOC TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA      TO RDTDC.
      *
           MOVE LCR-VARIMP  TO RVARIMP.
           IF LCR-IVNE NOT = ZERO
              ADD LCR-IMPON TO COM-IMPONIN
           ELSE
              IF LCR-VARIMP NOT = 'C'
                 ADD LCR-IMPON TO COM-IMPON 
                 ADD LCR-CORR  TO COM-IMPON 
                 ADD LCR-IMIVA TO COM-IMIVA 
              ELSE
                 ADD LCR-IMPON TO COM-IMPONNC 
                 ADD LCR-CORR  TO COM-IMPONNC 
                 ADD LCR-IMIVA TO COM-IMIVANC. 

           MOVE LCR-IMIVA   TO RIVAV.
           MOVE LCR-IMPON   TO RIMP.
           IF LCR-CORR NOT = ZERO
              MOVE LCR-CORR TO RIMP.
      *
      **** rel 7.1
      *    MOVE LCR-TOPE TO RTOPE.
           MOVE LCR-LEAS TO RLE.
           IF LCR-AUTOF NOT = ZERO
              MOVE 'S' TO RAF
           ELSE  
              MOVE SPACE TO RAF.
           IF LCR-RIEP NOT = ZERO
              MOVE 'S' TO RRI
           ELSE  
              MOVE SPACE TO RRI.
           IF LCR-IVNE  NOT = ZERO
              MOVE 'S' TO RIV
           ELSE  
              MOVE SPACE TO RIV.
           IF LCR-REVERSE NOT = ZERO
              MOVE 'S' TO RRE
           ELSE  
              MOVE SPACE TO RRE.
           MOVE SPACE TO RNE.
           IF LCR-IMPON < 1 AND
              LCR-IMPON > -1 AND
              LCR-IMPON NOT = ZERO 
              MOVE 'X' TO RNE.
           IF LCR-CORR < 1 AND
              LCR-CORR > -1 AND
              LCR-CORR NOT = ZERO 
              MOVE 'X' TO RNE.
      ************
      *
           MOVE SPACE TO RFL.
           IF LCR-FL = 1 MOVE 'AP' TO RFL.
           IF LCR-FL = 2 MOVE 'S1' TO RFL.
           IF LCR-FL = 3 MOVE 'S2' TO RFL.

           MOVE LCR-CATT TO RCATT.

           IF RDT2-TPSTA = 1
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
           ELSE
              IF LCR-IVNE = ZERO
                 IF LCR-VARIMP = 'C'
                    ADD 1 TO NOPEC
                 ELSE
                    ADD 1 TO NOPE
                 END-IF
              ELSE
                 ADD 1 TO NOPEIN.
                 
              
      *
      **** rel 7.1
      *    MOVE KLCR-NDOCR TO NDOCR.
      ************
           MOVE KLCR-COD   TO CLIFOR.
      *
      **** rel 7.1
      *    IF RDT2-TIPEL = 3 AND RDT2-TPSTA = 2 
      *       PERFORM STAMPA-DETT THRU EX-STAMPA-DETT.
      ************
      *
           GO TO RD-LAB30.
       END-LAB30.
      *
      **** rel 7.1
      *    IF RDT2-TIPEL = 3 AND RDT2-TPSTA = 2 
      *       PERFORM STAMPA-DETT THRU EX-STAMPA-DETT.
      ************
      *
           GO TO RD-LAB10.
       END-LAB.
      *
      **** rel 7.1
           IF PCLF NOT = ZERO
              PERFORM STA-TOT THRU EX-STA-TOT.
      ************
           IF RDT2-TIPEL = 2 
              MOVE 9 TO XP-FUN
              CALL 'vrexpo' USING PARXP RIGXP
              GO TO EX-RD-MOVALL.
      *
           PERFORM RPT-CL.
           COPY 'grirpt-e'.
       EX-RD-MOVALL.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       RPT-RIG2-INTC.
           MOVE 'RIG2' TO RP-BLK.
      *
      **** rel 7.1
           IF RDT2-TPSTA = 2 GO TO TITSINT.
      ************
           MOVE 'Data Reg.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      **** rel 7.1
      *    MOVE 'Contropartita' TO RP-IFLD.
           MOVE 'Causale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      ************
      *
           MOVE 'N.Reg' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      **** rel 7.1
      *    MOVE 'N.Doc Ragg' TO RP-IFLD.
      *    PERFORM RPT-ADD-I.
      *    MOVE 'M.P' TO RP-IFLD.
      *    PERFORM RPT-ADD-I.
      ************
           MOVE 'Prot.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'N.Doc' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Data Doc.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *
           MOVE 'V.I.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Importo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imposta' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      **** rel 7.1
      *    MOVE 'Tipo Ope' TO RP-IFLD.
      *    PERFORM RPT-ADD-I.
      ************
           MOVE 'Es.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Att' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      **** rel 7.1
           MOVE 'Le' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Af' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Dr' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Ine' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Rc' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Ne' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           GO TO ENDTIT.
        TITSINT.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Tipo Totale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'N.Ope. ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Importo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imposta' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE ' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
        ENDTIT.
      ************
      *--*
           PERFORM RPT-CLOSE-I.
      **** rel 7.1
       EX-RPT-RIG2-INTC.
           EXIT.
      ************
      *------------------
       STAMPA-DETT.
      **** rel 7.1
      *    IF NDOCR = ZERO GO TO EX-STAMPA-DETT.
      *
      *    IF KLCR-NDOCR NOT = NDOCR 
      *       MOVE CLIFOR TO KLV-KCF
      *       MOVE NDOCR  TO KLV-NDOCR
      *       READ WDSLAV INVALID MOVE ZERO TO LAV-NVOLTE LAV-IMPON
      *                                        LAV-IMIVA LAV-CORR
      *       END-READ
           IF LAV-NVOLTE = NVOLTE 
              MOVE ZERO TO NVOLTE.
      ************
              IF LAV-NVOLTE > 1
                 ADD LAV-CORR TO LAV-IMPON
                 MOVE LAV-IMPON TO RTIMP
                 MOVE LAV-IMIVA TO RTIVAV
      *
                 MOVE 'RIG2B' TO RP-BLK
                 PERFORM RPT-WR.
      *
       EX-STAMPA-DETT.
           EXIT.
      *------------------
       SCRIVE-RIGXP.
           MOVE RDT2-AZI       TO D-ECF-AZI.

           MOVE KCC-COD        TO D-ECF-COD.

           MOVE LCC-RGSOC      TO D-ECF-RGS.
      *
           MOVE LCC-RGSOC2     TO D-ECF-RGS2.
           MOVE LCC-INDIR      TO D-ECF-INDIR.
           MOVE LCC-INDIR2     TO D-ECF-INDIR2.
           MOVE LCC-CAP        TO D-ECF-CAP.
           MOVE LCC-CIT        TO D-ECF-CIT.
           MOVE LCC-PRV        TO D-ECF-PRV.
           MOVE LCC-PIVA       TO D-ECF-PIVA.
           IF LCC-13IVA = 4
              MOVE LCC-PAE TO D-ECF-PAE
              MOVE LCC-IVE TO D-ECF-IVE
              MOVE SPACE   TO D-ECF-CFISC
           ELSE 
              MOVE LCC-CFISC TO D-ECF-CFISC
              MOVE SPACE TO   D-ECF-PAE
                              D-ECF-IVE.
           MOVE LCC-ALLIVA     TO D-ECF-ALLIVA.
           PERFORM VER-CFISC THRU EX-VER-CFISC.
           MOVE RISPFISC        TO D-ECF-FCFIS.
           MOVE RISPIVA         TO D-ECF-FPIVA.
       EX-SCRIVE-RIGXP.
           EXIT.
      *-----------------*
       SCRIVE-RIGXP2.
           MOVE KLCR-DAT        TO AAGGG.
           MOVE COMTP1 TO TIPOP1.
           CALL 'vramg' USING PARCDT.
           MOVE GGMMAA4        TO D-ECF-DAT.
      **** rel 7.1
      *    MOVE KLCR-NDOCR     TO D-ECF-NDOCR.
      *    MOVE LCR-MODPAG     TO D-ECF-MODPAG.
      ************
           MOVE KLCR-NUM       TO D-ECF-NUM.

           MOVE KLCR-NDOC      TO D-ECF-NDOC.
           MOVE LCR-DTDOC      TO AAGGG.
           MOVE COMTP1 TO TIPOP1.
           CALL 'vramg' USING PARCDT.
           MOVE GGMMAA4        TO D-ECF-DTDOC.
      *
           MOVE LCR-NREG       TO D-ECF-NREG.
           MOVE LCR-CON        TO D-ECF-CON.

           MOVE CON-DSC        TO D-ECF-DSCON.

           MOVE LCR-CAUS       TO D-ECF-CAUS.

           MOVE LCR-VARIMP      TO D-ECF-VARIMP.
           MOVE LCR-IMPON      TO D-ECF-IMPON.
           MOVE LCR-IMIVA      TO D-ECF-IMIVA.

           MOVE LCR-CORR       TO D-ECF-CORR.
      **** rel 7.1
      *    MOVE LCR-TOPE       TO D-ECF-TOPE.
           MOVE LCR-LEAS TO D-ECF-LE.
           IF LCR-AUTOF NOT = ZERO
              MOVE 'S' TO D-ECF-AF
           ELSE  
              MOVE SPACE TO D-ECF-AF.
           IF LCR-RIEP NOT = ZERO
              MOVE 'S' TO D-ECF-RI
           ELSE  
              MOVE SPACE TO D-ECF-RI.
           IF LCR-IVNE  NOT = ZERO
              MOVE 'S' TO D-ECF-IV
           ELSE  
              MOVE SPACE TO D-ECF-IV.
           IF LCR-REVERSE NOT = ZERO
              MOVE 'S' TO D-ECF-RE
           ELSE  
              MOVE SPACE TO D-ECF-RE.
      ************
      *
           MOVE SPACE              TO D-ECF-FL.
           IF LCR-FL = 1 MOVE 'AP' TO D-ECF-FL.
           IF LCR-FL = 2 MOVE 'S1' TO D-ECF-FL.
           IF LCR-FL = 3 MOVE 'S2' TO D-ECF-FL.
           MOVE LCR-CATT           TO D-ECF-CATT.
       EX-SCRIVE-RIGXP2.
           EXIT.
      *-----------------*
       SCRIVE-RIGXP3.
           MOVE 0              TO D-ECF-DAT.
      **** rel 7.1
      *    MOVE 0              TO D-ECF-NDOCR.
      *    MOVE 0              TO D-ECF-MODPAG.
      ************
           MOVE 0              TO D-ECF-NUM.
           MOVE 0              TO D-ECF-NDOC.
           MOVE 0              TO D-ECF-DTDOC.
           MOVE 0              TO D-ECF-NREG.
           MOVE 0              TO D-ECF-CON.
           MOVE SPACE          TO D-ECF-DSCON.
           MOVE 0              TO D-ECF-CAUS.
           MOVE ' '            TO D-ECF-VARIMP.
           MOVE 0              TO D-ECF-IMPON.
           MOVE 0              TO D-ECF-IMIVA.
           MOVE 0              TO D-ECF-CORR.
      **** rel 7.1
      *    MOVE 0              TO D-ECF-TOPE.
           MOVE SPACE TO D-ECF-LE.
           MOVE SPACE TO D-ECF-AF.
           MOVE SPACE TO D-ECF-RI.
           MOVE SPACE TO D-ECF-IV.
           MOVE SPACE TO D-ECF-RE.
      ************
           MOVE SPACE          TO D-ECF-FL.
           MOVE SPACE          TO D-ECF-CATT.
       EX-SCRIVE-RIGXP3.
           EXIT.
      *-----------------*
       SCRIVE-RIGXPE.
           MOVE 'X'            TO D-ECF-TAPPO.
           CALL 'vrexpo' USING PARXP RIGXP.
           IF XP-ST > ZERO
                 MOVE SPACE TO MESS
                 STRING 'vrexpo: status ' XP-ST DELIMITED SIZE INTO MESS
                 GO TO ERRIO.
       EX-SCRIVE-RIGXPE.
           EXIT.
      *-----------------*
       VER-CFISC.
           MOVE ZERO TO RISPFISC RISPIVA.
      *
           MOVE LCC-PIVA TO CODPIVA. *> num. partita iva 
           CALL 'rpiva' USING PARPIVA.
           IF LCC-13IVA = 4 
              IF LCC-PAE = 'IT' OR SPACE GO TO BYP0-1.
      *
           IF LCC-CFISC(12:) = SPACE AND LCC-CFISC(1:11) NUMERIC
              MOVE LCC-CFISC(1:11) TO CODPIVA
              CALL 'rpiva' USING PARPIVA  *> partiva iva cee
           ELSE
              MOVE LCC-CFISC TO COMFISC *> num. partita iva 
              CALL 'rfisc' USING PARFISC.
       BYP0-1.
      *
           IF LCC-PIVA = ZERO AND LCC-CFISC = SPACE 
              MOVE 1 TO RISPIVA RISPFISC. *> se non ci sono entrabi do errore
       EX-VER-CFISC.
           EXIT.
      *------------------
      **** rel 7.1
       STA-TOT.
           IF RDT2-TPSTA = 2 GO TO SINTENTICA.
           IF COM-IMPON NOT = ZERO
              MOVE 'TOTALE OPERAZIONI' TO RTDES1V
              MOVE COM-IMPON TO RTIMP
              MOVE COM-IMIVA TO RTIVAV
              MOVE 'RIG2B' TO RP-BLK
              PERFORM RPT-WR.
           IF COM-IMPONIN NOT = ZERO
              MOVE 'TOTALE OP. IVA NON ESPOSTA' TO RTDES1V
              MOVE COM-IMPONIN TO RTIMP
              MOVE ZERO      TO RTIVAV
              MOVE 'RIG2B' TO RP-BLK
              PERFORM RPT-WR.
           IF COM-IMPONNC NOT = ZERO
              MOVE 'TOTALE NOTE VARIAZIONE' TO RTDES1V
              MOVE COM-IMPONNC TO RTIMP
              MOVE COM-IMIVANC TO RTIVAV
              MOVE 'RIG2B' TO RP-BLK
              PERFORM RPT-WR.
           IF COM-IMPONNC NOT = ZERO AND
              COM-IMPON NOT = ZERO
              MOVE 'TOTALE SOGGETTO' TO RTDES1V
              COMPUTE RTIMP = COM-IMPON + COM-IMPONNC + COM-IMPONIN
              COMPUTE RTIVAV = COM-IMIVA + COM-IMIVANC
              MOVE 'RIG2B' TO RP-BLK
              PERFORM RPT-WR.
              GO TO FINETOT.
       SINTENTICA.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-AZZ.
           IF COM-IMPON NOT = ZERO
              MOVE 'TOTALE OPERAZIONI' TO RDES1V
              MOVE NOPE TO RNDOC
              MOVE COM-IMPON TO RIMP
              MOVE COM-IMIVA TO RIVAV
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR.
           IF COM-IMPONIN NOT = ZERO
              MOVE 'TOTALE OP. IVA NON ESPOSTA' TO RDES1V
              MOVE NOPEIN TO RNDOC
              MOVE COM-IMPONIN TO RIMP
              MOVE ZERO  TO RIVAV
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR.
           IF COM-IMPONNC NOT = ZERO
              MOVE 'TOTALE NOTE VARIAZIONE' TO RDES1V
              MOVE NOPEC TO RNDOC
              MOVE COM-IMPONNC TO RIMP
              MOVE COM-IMIVANC TO RIVAV
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR.
           IF COM-IMPONNC NOT = ZERO AND
              COM-IMPON NOT = ZERO
              MOVE 'TOTALE SOGGETTO' TO RDES1V
              COMPUTE RNDOC = NOPE + NOPEC + NOPEIN
              COMPUTE RIMP = COM-IMPON + COM-IMPONNC + COM-IMPONIN
              COMPUTE RIVAV = COM-IMIVA + COM-IMIVANC
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR.
       FINETOT.
           MOVE ZERO TO COM-IMPON COM-IMIVA 
                        COM-IMPONNC COM-IMIVANC NOPE NOPEC NOPEIN
                        COM-IMPONIN.
       EX-STA-TOT.
           EXIT.
      *------------------
      ************
      **** rel 7.1
       STORICO.
           MOVE EX1-DTAPE TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AA4 = ZERO 
              GO TO EX-STORICO.
           STRING 'allcfx' AA4 DELIMITED SPACE INTO ID-LCC.
           STRING 'allcfr' AA4 DELIMITED SPACE INTO ID-LCR.
           STRING 'alltab' AA4 DELIMITED SPACE INTO ID-ALT.
       EX-STORICO.
           EXIT.
      *------------------
      ************
