       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRRDCD.
      *
      * Legge DESTINATARIO e MITTENTE MESSAGGIO
      *
      **** rel 5.1
      * nuovo
      ************
      **** rel 6.1
      * ricompilato
      ************
      **** rel 7.1
      * Variato utilizzo PDCD-TDOC da solo INPUT a
      * INPUT/OUTPUT.Mi serve nei chiamanti per capire 
      * con che tipo documento leggo RUBPDC, potrebbe
      * diventare SPACE per via del fatto che non ho
      * una rubrica specifica per tipo documento.
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'griacfsl'.
           COPY 'gricttsl'.
           COPY 'griirisl'.
           COPY 'grirpdsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'griacf'.
           COPY 'grictt'.
           COPY 'griiri'.
           COPY 'grirpd'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griclfrk'.
           COPY 'gricttrk'.
           COPY 'gritabrk'.
           COPY 'parpsrv'.
      **** rel 5.2
           COPY 'parmit'.
      **************
       01  ID-AZI PIC X(50) VALUE 'anaazi'.
       01  ID-CLF PIC X(50) VALUE 'anaclf'.
       01  ID-ACF PIC X(50) VALUE 'appclf'.
       01  ID-CTT PIC X(50) VALUE 'anactt'.
       01  ID-IRI PIC X(50) VALUE 'indiri'.
       01  ID-RPD PIC X(50) VALUE 'rubpdc'.
       01  ID-TAB PIC X(50) VALUE 'tabell'.
       01  SF-AZI PIC XX.
       01  SF-CLF PIC XX.
       01  SF-ACF PIC XX.
       01  SF-CTT PIC XX.
       01  SF-IRI PIC XX.
       01  SF-RPD PIC XX.
       01  SF-TAB PIC XX.
       01  MESS PIC X(40)    VALUE SPACE.
           COPY 'parzf'.
       01  COMODI.
           05 CODCLI.
              10 MAS   PIC 99.
              10 COD   PIC 9(5).
           05 IND      PIC 999 VALUE ZERO.
           05 K        PIC 999 VALUE ZERO.
      **** rel 5.2
           05 COMFAX   PIC X(30) VALUE SPACE.
      ************
      **** rel 6.2
           05 FLGPRI   PIC 9 VALUE ZERO.
      ************
      **** rel 6.3
           05 SCDES    PIC X(20) VALUE SPACE.
      ************
       LINKAGE SECTION.
           COPY 'pardcd'.
       PROCEDURE DIVISION USING PARDCD.
           COPY 'declxer1'.
      *    COPY 'dclazi'.
      *    COPY 'dclclf'.
      *    COPY 'dclacf'.
      *    COPY 'dclctt'.
      *    COPY 'dcliri'.
      *    COPY 'dclrpd'.
      *    COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.

           MOVE SPACE TO PDCD-DEST.
           MOVE ZERO  TO PDCD-FLING.
           MOVE ZERO  TO PDCD-ERR.

           IF PDCD-FL NOT = SPACE
              MOVE SPACE TO ID-AZI
              MOVE SPACE TO ID-CLF
              MOVE SPACE TO ID-ACF
              MOVE SPACE TO ID-CTT
              MOVE SPACE TO ID-IRI
              MOVE SPACE TO ID-RPD
              MOVE SPACE TO ID-TAB
              STRING PDCD-DFL PDCD-FL
                     '\anaazi'
                     DELIMITED SPACE INTO ID-AZI
              STRING PDCD-DFL PDCD-FL
                     '\anaclf'
                     DELIMITED SPACE INTO ID-CLF
              STRING PDCD-DFL PDCD-FL
                     '\appclf'
                     DELIMITED SPACE INTO ID-ACF
              STRING PDCD-DFL PDCD-FL
                     '\anactt'
                     DELIMITED SPACE INTO ID-CTT
              STRING PDCD-DFL PDCD-FL
                     '\indiri'
                     DELIMITED SPACE INTO ID-IRI
              STRING PDCD-DFL PDCD-FL
                     '\rubpdc'
                     DELIMITED SPACE INTO ID-RPD
              STRING PDCD-DFL PDCD-FL
                     '\tabell'
                     DELIMITED SPACE INTO ID-TAB
           ELSE
              MOVE 'anaazi' TO ID-AZI
              MOVE 'anaclf' TO ID-CLF
              MOVE 'appclf' TO ID-ACF
              MOVE 'anactt' TO ID-CTT
              MOVE 'indiri' TO ID-IRI
              MOVE 'rubpdc' TO ID-RPD
              MOVE 'tabell' TO ID-TAB.

           PERFORM RD-MITT THRU EX-RD-MITT.

           IF PDCD-TDES = 1 OR 2 GO TO LPCLF.
           IF PDCD-TDES = 3 GO TO LPCTT.
      **** rel 6.2
           IF PDCD-TDES >= 51 AND <= 54 GO TO LPCTT.
      ************
           IF PDCD-TDES = 4 GO TO LPAGE.
      **** rel 5.2
           IF PDCD-TDES = 99 GO TO LPMIT.
      ************

           MOVE 1 TO PDCD-ERR.
           GO TO FINE.

      *** Cliente / Fornitore
       LPCLF.
           OPEN INPUT ANACLF.
           OPEN INPUT APPCLF.
           OPEN INPUT TABELL.

           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF PDCD-TDES = 1
              MOVE T01-MCLI TO MAS
           ELSE
              MOVE T01-MFOR TO MAS.

           IF PDCD-CDES(1:5) NOT NUMERIC GO TO ERRIO.

           MOVE PDCD-AZI TO KCF-AZI.
           MOVE PDCD-CDES(1:5) TO COD.
           MOVE CODCLI TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           IF PDCD-TDES = 1
              STRING 'Cli: ' CLF-RGSOC
                     DELIMITED SIZE INTO PDCD-DESCR
           ELSE
              STRING 'For: ' CLF-RGSOC
                     DELIMITED SIZE INTO PDCD-DESCR.

           MOVE CLF-RGSOC  TO PDCD-RGSOC.
           MOVE CLF-RGSOC2 TO PDCD-RGSOC2.
           MOVE CLF-INDIR  TO PDCD-INDIR.
           MOVE CLF-INDIR2 TO PDCD-INDIR2.
           IF CLF-CAP NOT = ZERO MOVE CLF-CAP TO PDCD-CAP.
           MOVE CLF-CITTA  TO PDCD-CITTA.
           MOVE CLF-TEL    TO PDCD-TEL.
           MOVE CLF-FAX    TO PDCD-FAX.
           MOVE CLF-NOMRIF TO PDCD-NOMRIF.
           MOVE CLF-FLING  TO PDCD-FLING.

           MOVE KEYCF TO KEYACF.
      **** rel 5.2
      *    READ APPCLF NOT INVALID MOVE ACF-EMAIL TO PDCD-EMAIL.
           READ APPCLF INVALID MOVE ZERO  TO REKACF
                               MOVE SPACE TO ACF-EMAIL.
           MOVE ACF-EMAIL TO PDCD-EMAIL.
           MOVE ACF-DEFTP TO PDCD-DEFTP.
      ************

           MOVE SPACE TO PDCD-DESDI.

           IF PDCD-CDES(6:2) NOT NUMERIC OR
              PDCD-CDES(6:2) = '00'
                 GO TO NOIRI.

           OPEN INPUT INDIRI.

           MOVE KCF-AZI        TO KII-AZI.
           MOVE MAS            TO KII-MS.
           MOVE COD            TO KII-CD.
           MOVE PDCD-CDES(6:2) TO KII-PRG.
      **** rel 6.3
      *    READ INDIRI INVALID GO TO CL-IRI.
           READ INDIRI INVALID MOVE '00' TO PDCD-CDES(6:2)
                               GO TO CL-IRI.
      ************

           IF IRI-TIPO = 'L'
              MOVE IRI-DESDI TO PDCD-DESDI
           ELSE
              IF IRI-TIPO = 'D'
                 MOVE IRI-RGSOC  TO PDCD-RGSOC
                 MOVE IRI-RGSOC2 TO PDCD-RGSOC2
                 MOVE IRI-INDIR  TO PDCD-INDIR
                 MOVE IRI-INDIR2 TO PDCD-INDIR2
                 MOVE SPACE      TO PDCD-CAP
                 IF IRI-CAP NOT = ZERO
                    MOVE IRI-CAP TO PDCD-CAP
                 END-IF
                 MOVE IRI-CITTA  TO PDCD-CITTA.
      *    MOVE IRI-???    TO PDCD-TEL.
      *    MOVE IRI-???    TO PDCD-FAX.
      *    MOVE IRI-???    TO PDCD-NOMRIF.
      *    MOVE ???????    TO PDCD-FLING.
      *    MOVE IRI-???    TO PDCD-EMAIL.

       CL-IRI.
           CLOSE INDIRI.
       NOIRI.
           CLOSE ANACLF.
           CLOSE APPCLF.
           CLOSE TABELL.
           GO TO LPRUB.

      *** Contatto
       LPCTT.
           OPEN INPUT ANACTT.

           MOVE PDCD-AZI TO KCTT-AZI.
           MOVE PDCD-CDES(1:5) TO KCTT-COD.
           READ ANACTT INTO REKCTT INVALID GO TO ERRIO.
           IF SF-CTT = '9D' OR '9A' OR '35' MOVE RF-CTT TO REKCTT.
           STRING 'Cnt: ' CTT-RGSOC
                  DELIMITED SIZE INTO PDCD-DESCR.

           MOVE CTT-RGSOC  TO PDCD-RGSOC.
           MOVE CTT-RGSOC2 TO PDCD-RGSOC2.
           MOVE CTT-INDIR  TO PDCD-INDIR.
           MOVE CTT-INDIR2 TO PDCD-INDIR2.
           IF CTT-CAP NOT = ZERO MOVE CTT-CAP TO PDCD-CAP.
           MOVE CTT-CITTA  TO PDCD-CITTA.
           MOVE CTT-TEL    TO PDCD-TEL.
           MOVE CTT-FAX    TO PDCD-FAX.
           MOVE CTT-NOMRIF TO PDCD-NOMRIF.
           MOVE CTT-FLING  TO PDCD-FLING.

           MOVE CTT-EMAIL TO PDCD-EMAIL.
      **** rel 5.2
           MOVE CTT-DEFTP TO PDCD-DEFTP.
      ************
      *    MOVE CTT-???   TO PDCD-DESDI.

           CLOSE ANACTT.
           GO TO LPRUB.

      *** Agente
       LPAGE.
           OPEN INPUT TABELL.

           MOVE 9 TO KTB-TIP.
           MOVE PDCD-CDES(1:3) TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           STRING 'Age: ' TAB-DESCR
                  DELIMITED SIZE INTO PDCD-DESCR.

           MOVE TAB-DESCR TO PDCD-RGSOC.

      *    MOVE T09-??? TO PDCD-RGSOC2.
      *    MOVE T09-??? TO PDCD-INDIR.
      *    MOVE T09-??? TO PDCD-INDIR2.
      *    IF T09-??? NOT = ZERO MOVE T09-??? TO PDCD-CAP.
      *    MOVE T09-??? TO PDCD-CITTA.
      *    MOVE T09-??? TO PDCD-TEL.
      *    MOVE T09-??? TO PDCD-FAX.
      *    MOVE T09-??? TO PDCD-NOMRIF.
      *    MOVE ??????? TO PDCD-FLING.
      *    MOVE T09-??? TO PDCD-EMAIL.
      *    MOVE T09-???   TO PDCD-DESDI.

           CLOSE TABELL.
           PERFORM DCONT THRU EX-DCONT.
           GO TO LPRUB.
      **** rel 5.2
      *** Mittente
       LPMIT.
           MOVE PDCD-MNOM TO PDCD-NOMRIF.
           MOVE PDCD-MTEL TO PDCD-TEL.
           MOVE PDCD-MFAX TO PDCD-FAX.
           MOVE PDCD-MEML TO PDCD-EMAIL.

           GO TO FINE.
      ************
       LPRUB.
           PERFORM CARICA-DA-RPD THRU EX-CARICA-DA-RPD.
           PERFORM DCONT THRU EX-DCONT.
           GO TO FINE.

       ERRIO.
      *    COPY 'errsub'.
           MOVE 9 TO PDCD-ERR.
       FINE.
       CHIUDI.
           EXIT PROGRAM.
      *--------------
      * Carica dati mittente
       RD-MITT.
           MOVE SPACE TO PDCD-MITT.

           OPEN INPUT ANAAZI.

           MOVE PDCD-AZI TO KAZ-COD.
           READ ANAAZI INVALID GO TO ERRIO.
           MOVE AZRGSOC TO PDCD-MDES.

           CLOSE ANAAZI.

      **** rel 5.2
      *    CALL 'vrpmit' USING PARDCD.
           MOVE SPACE        TO PMIT-MITT.
           MOVE PDCD-MDES    TO PMIT-MDES.

           MOVE PDCD-AZI     TO PMIT-AZI.
           MOVE PDCD-TDOC    TO PMIT-TDOC.
           MOVE PDCD-LOGNAME TO PMIT-LOGNAME.
           CALL 'vrpmit' USING PARMIT.
           MOVE PMIT-MITT TO PDCD-MITT.
      **************
       EX-RD-MITT.
           EXIT.
      *--------------
      * Carica descrizione in chiaro contatti
       DCONT.
      **** rel 5.2
           MOVE SPACE TO COMFAX.
           MOVE 1 TO IND.
           IF PDCD-FAX NOT = SPACE
              MOVE 1 TO K
              PERFORM UNTIL K > 30 
                 IF PDCD-FAX(K:1) NUMERIC OR 
                         (IND = 1 AND PDCD-FAX(K:1) = '+')
                    MOVE PDCD-FAX(K:1) TO COMFAX(IND:1)
                    ADD 1 TO IND
                 END-IF
                 ADD 1 TO K
              END-PERFORM
              MOVE COMFAX TO PDCD-FAX.
      ************
           MOVE 1 TO IND.

           IF PDCD-NOMRIF NOT = SPACE
              MOVE 30 TO K
              PERFORM UNTIL PDCD-NOMRIF(K:1) NOT = SPACE
                      SUBTRACT 1 FROM K
              END-PERFORM
              IF IND NOT = 1
                 STRING ' - ' DELIMITED SIZE INTO PDCD-DCONT POINTER IND
              END-IF
              STRING PDCD-NOMRIF(1:K) DELIMITED SIZE
                     INTO PDCD-DCONT POINTER IND.

           IF IND > 60 GO TO EX-DCONT.

           IF PDCD-TEL NOT = SPACE
              MOVE 30 TO K
              PERFORM UNTIL PDCD-TEL(K:1) NOT = SPACE
                      SUBTRACT 1 FROM K
              END-PERFORM
              IF IND NOT = 1
                 STRING ' - ' DELIMITED SIZE INTO PDCD-DCONT POINTER IND
              END-IF
              STRING 'Tel: ' PDCD-TEL(1:K) DELIMITED SIZE
                     INTO PDCD-DCONT POINTER IND.

           IF IND > 60 GO TO EX-DCONT.

           IF PDCD-FAX NOT = SPACE
              MOVE 30 TO K
              PERFORM UNTIL PDCD-FAX(K:1) NOT = SPACE
                      SUBTRACT 1 FROM K
              END-PERFORM
              IF IND NOT = 1
                 STRING ' - ' DELIMITED SIZE INTO PDCD-DCONT POINTER IND
              END-IF
              STRING 'Fax: ' PDCD-FAX(1:K) DELIMITED SIZE
                     INTO PDCD-DCONT POINTER IND.

           IF IND > 60 GO TO EX-DCONT.

           IF PDCD-EMAIL NOT = SPACE
      **** rel 5.2
      *       MOVE 30 TO K
              MOVE 50 TO K
      **************
              PERFORM UNTIL PDCD-EMAIL(K:1) NOT = SPACE
                      SUBTRACT 1 FROM K
              END-PERFORM
              IF IND NOT = 1
                 STRING ' - ' DELIMITED SIZE INTO PDCD-DCONT POINTER IND
              END-IF
              STRING 'E-mail: ' PDCD-EMAIL(1:K) DELIMITED SIZE
                     INTO PDCD-DCONT POINTER IND.
       EX-DCONT.
           EXIT.
      *--------------
      * Carica dati da Rubrica 
       CARICA-DA-RPD.
           OPEN INPUT RUBPDC.

      **** rel 6.2
           MOVE EX-WS      TO PSRV-WS.
           MOVE EX-LOGNAME TO PSRV-LOGNAME.
           CALL 'vrpsrv' USING PARPSRV.
      **** rel 6.3
           IF ERRIO-ST > ZERO GO TO ERRIO.
      ************

      **** rel 6.3
           MOVE PDCD-CDES TO SCDES.
      ************
           MOVE ZERO TO FLGPRI.
       LPLOOP.
      ************
           MOVE PDCD-AZI  TO KRPD-AZI.
           MOVE PDCD-TDES TO KRPD-TIPO.
      **** rel 6.3
      *    MOVE PDCD-CDES TO KRPD-COD.
           MOVE SCDES     TO KRPD-COD.
      ************
      **** rel 6.2
           IF (PDCD-TDES = 1 OR 2)
              IF FLGPRI = ZERO
      **** rel 6.3
      *          MOVE PDCD-CDES(1:5) TO KRPD-COD.
      * prima ricerca... con codice senza progressivo INDIRI
                 MOVE SPACE TO KRPD-COD(6:).
      ************
      ************
      **** rel 5.1-1
           MOVE SPACE     TO KRPD-TDOC.
      **************

      **** rel 6.2
      *    IF (PDCD-TDES = 1 OR 2) AND
      *       (PDCD-CDES(6:2) NOT NUMERIC OR
      *        PDCD-CDES(6:2) = '00')
      *           MOVE PDCD-CDES(1:5) TO KRPD-COD.
      *
      *    MOVE EX-WS      TO PSRV-WS.
      *    MOVE EX-LOGNAME TO PSRV-LOGNAME.
      *    CALL 'vrpsrv' USING PARPSRV.
      ************
           MOVE 1 TO K.
           PERFORM UNTIL K > PSRV-NTD 
              IF PSRV-TD(K) = PDCD-TDOC
                 IF PSRV-RB(K) = '-'
      **** rel 7.1
      *             MOVE PSRV-TD(K) TO KRPD-TDOC
                    MOVE PSRV-TD(K) TO KRPD-TDOC PDCD-TDOC
      ************
                 ELSE
      **** rel 7.1
      *             MOVE PSRV-RB(K) TO KRPD-TDOC
                    MOVE PSRV-RB(K) TO KRPD-TDOC PDCD-TDOC
      ************
                 END-IF
                 MOVE PSRV-NTD TO K
              END-IF
              ADD 1 TO K.
           READ RUBPDC NOT INVALID GO TO OK-RPD.
      *
      **** rel 7.1
      *    MOVE SPACE     TO KRPD-TDOC.
           MOVE SPACE     TO KRPD-TDOC PDCD-TDOC.
      ************
           READ RUBPDC INVALID GO TO NO-RPD.
      *
       OK-RPD.
      **** rel 5.2
      *    IF KRPD-TDOC = SPACE 
      *       IF RPD-TELEF  NOT = SPACE 
      *          MOVE RPD-TELEF  TO PDCD-TEL    END-IF
      *       IF RPD-EMAIL  NOT = SPACE 
      *          MOVE RPD-EMAIL  TO PDCD-EMAIL  END-IF
      *       IF RPD-FAX    NOT = SPACE 
      *          MOVE RPD-FAX    TO PDCD-FAX    END-IF
      *       IF RPD-NOMRIF NOT = SPACE 
      *          MOVE RPD-NOMRIF TO PDCD-NOMRIF END-IF
      *       IF RPD-FLING  NOT = ZERO  
      *          MOVE RPD-FLING  TO PDCD-FLING  END-IF
      *    ELSE
      *       MOVE RPD-TELEF  TO PDCD-TEL
      *       MOVE RPD-EMAIL  TO PDCD-EMAIL
      *       MOVE RPD-FAX    TO PDCD-FAX
      *       MOVE RPD-NOMRIF TO PDCD-NOMRIF
      *       MOVE RPD-FLING  TO PDCD-FLING.
           IF RPD-TELEF NOT = SPACE 
              MOVE SPACE TO PDCD-TEL
              IF RPD-TELEF NOT = '*'
                 MOVE RPD-TELEF TO PDCD-TEL.

           IF RPD-EMAIL NOT = SPACE 
              MOVE SPACE TO PDCD-EMAIL
              IF RPD-EMAIL NOT = '*'
                 MOVE RPD-EMAIL TO PDCD-EMAIL.

           IF RPD-FAX NOT = SPACE 
              MOVE SPACE TO PDCD-FAX
              IF RPD-FAX NOT = '*'
                 MOVE RPD-FAX TO PDCD-FAX.

      **** rel 7.1
      *    IF RPD-NOMRIF NOT = SPACE 
      ************
              MOVE SPACE TO PDCD-NOMRIF
              IF RPD-NOMRIF NOT = '*'
                 MOVE RPD-NOMRIF TO PDCD-NOMRIF.

      **** rel 7.2
      *    IF RPD-FLING NOT = ZERO  
      *       MOVE RPD-FLING TO PDCD-FLING.
           IF RPD-FLING NOT = ZERO
              IF RPD-FLING = 9
                 MOVE ZERO TO PDCD-FLING
              ELSE
                 MOVE RPD-FLING TO PDCD-FLING.
      ************
      **************
      **** rel 5.2
           IF RPD-DEFTP NOT = ZERO  
              MOVE RPD-DEFTP TO PDCD-DEFTP.
      ************
      *
      **** rel 6.3
      * attualizza codice da rubrica effettivamente utilizzata
           MOVE KRPD-COD TO PDCD-CDES.
      ************
       NO-RPD.
      **** rel 6.2
           IF FLGPRI = ZERO
              IF (PDCD-TDES = 1 OR 2) AND
      **** rel 6.3
      *          (PDCD-CDES(6:2) NUMERIC AND
      *           PDCD-CDES(6:2) NOT = '00')
                 (SCDES(6:2) NUMERIC AND
                  SCDES(6:2) NOT = '00')
      * seconda ricerca... con codice con progressivo INDIRI
      ************
                    ADD 1 TO FLGPRI
                    GO TO LPLOOP.
      ************
           CLOSE RUBPDC.
       EX-CARICA-DA-RPD.
           EXIT.
      *--------------
