       IDENTIFICATION DIVISION.
       PROGRAM-ID. VUTI930.
      *
      * Programma di controllo quadratura
      *
      **** rel 7.2
      * Ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'griclfsl'.
           COPY 'gricfxsl'.
           COPY 'grimovsl'.
           COPY 'grimvxsl'.
           COPY 'grimszsl'.
           COPY 'grimsxsl'.
           COPY 'gritabsl'.
           COPY 'griscasl'.
           COPY 'griparsl'.
      *
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           SELECT WDSLA1 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL1 STATUS SF-LA1.
           SELECT WDSLA2 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL2 STATUS SF-LA2.
      **** rel 7.1
           SELECT WDSLA3 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL3 STATUS SF-LA3.
      ************
           COPY 'grite2sl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'griclf'.
           COPY 'gricfx'.
           COPY 'grimov'.
           COPY 'grimvx'.
           COPY 'grimsz'.
           COPY 'grimsx'.
           COPY 'grisca'.
           COPY 'gripar'.
           COPY 'gritab'.
      *
      * Sort per controllo totali di giornata conti riepilogativi
      *
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 31 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-AZI PIC 9(3).
              10 KLV-CON PIC 9(7).
              10 KLV-DAT PIC 9(5).
           05 RECLAV.
              10 LAV-IMPMSZ PIC S9(13)V99 COMP-3.
              10 LAV-IMPMOV PIC S9(13)V99 COMP-3.
      *
      * Sort per controllo saldi clienti/fornitori
      *
       FD  WDSLA1 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA1
           RECORD 58 DATA RECORD RF-LA1.
       01  RF-LA1.
           05 KEYL1.
              10 KL1-AZI PIC 9(3).
              10 KL1-CLF PIC 9(7).
           05 RECLA1.
              10 LA1-SALDI.
                 15 LA1-SP-D PIC S9(13)V99 COMP-3.
                 15 LA1-SP-A PIC S9(13)V99 COMP-3.
                 15 LA1-SPSP PIC S9(13)V99 COMP-3.
                 15 LA1-SE-D PIC S9(13)V99 COMP-3.
                 15 LA1-SE-A PIC S9(13)V99 COMP-3.
                 15 LA1-SESP PIC S9(13)V99 COMP-3.
      *
      * Sort per controllo saldi conti
      *
       FD  WDSLA2 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA2
           RECORD 58 DATA RECORD RF-LA2.
       01  RF-LA2.
           05 KEYL2.
              10 KL2-AZI PIC 9(3).
              10 KL2-CON PIC 9(7).
           05 RECLA2.
              10 LA2-SALDI.
                 15 LA2-SP-D PIC S9(13)V99 COMP-3.
                 15 LA2-SP-A PIC S9(13)V99 COMP-3.
                 15 LA2-SPSP PIC S9(13)V99 COMP-3.
                 15 LA2-SE-D PIC S9(13)V99 COMP-3.
                 15 LA2-SE-A PIC S9(13)V99 COMP-3.
                 15 LA2-SESP PIC S9(13)V99 COMP-3.
      *
      **** rel 7.1
      *
      * Sort per controllo saldi conti
      *
       FD  WDSLA3 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA3
           RECORD 29 DATA RECORD RF-LA3.
       01  RF-LA3.
           05 KEYL3.
              10 KL3-AZI   PIC 9(3).
              10 KL3-DTREG PIC 9(5).
              10 KL3-NREG  PIC 9(5).
           05 RECLA3.
              10 LA3-DARE PIC S9(13)V99 COMP-3.
              10 LA3-AVER PIC S9(13)V99 COMP-3.
      ************
           COPY 'grite2'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parlo'.
           COPY 'griazirk'.
           COPY 'griconrk'.
           COPY 'griclfrk'.
           COPY 'grimovrk'.
           COPY 'gritabrk'.
           COPY 'griparrk'.
           COPY 'grit14g'.
           COPY 'grite2rk'.
      *
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-CFX PIC X(15) VALUE 'anacfx'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MVX PIC X(15) VALUE 'movmxx'.
       01  ID-MSZ PIC X(15) VALUE 'movsez'.
       01  ID-MSX PIC X(15) VALUE 'movsxx'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-SCA PIC X(15) VALUE 'anasca'.
       01  ID-PAR PIC X(15) VALUE 'partit'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-LA1 PIC X(15) VALUE 'wdsla1'.
       01  ID-LA2 PIC X(15) VALUE 'wdsla2'.
      **** rel 7.1
       01  ID-LA3 PIC X(15) VALUE 'wdsla3'.
      ************
       01  ID-TE2 PIC X(15) VALUE 'tabeu2'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-CON   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-CFX   PIC XX.
           05 SF-MOV   PIC XX.
           05 SF-MVX   PIC XX.
           05 SF-MSZ   PIC XX.
           05 SF-MSX   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-SCA   PIC XX.
           05 SF-PAR   PIC XX.
           05 SF-LAV   PIC XX.
           05 SF-LA1   PIC XX.
           05 SF-LA2   PIC XX.
      **** rel 7.1
           05 SF-LA3   PIC XX.
      ************
           05 SF-TE2   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
      *
           05 TOTSALDO PIC S9(15)V9(2).
           05 COMODO1  PIC S9(15)V9(2).
           05 COMODO2  PIC S9(15)V9(2).
           05 CRPCL    PIC 9(7) OCCURS 9.
           05 CRPFR    PIC 9(7) OCCURS 9.
           05 CATCON   PIC 9.
           05 SWPRI    PIC 9.
      *
      * progressivi mastri clienti
           05 MSC-SPSP PIC S9(15)V9(2) OCCURS 9.
           05 MSC-SP-D PIC S9(15)V9(2) OCCURS 9.
           05 MSC-SP-A PIC S9(15)V9(2) OCCURS 9.
           05 MSC-SESP PIC S9(15)V9(2) OCCURS 9.
           05 MSC-SE-D PIC S9(15)V9(2) OCCURS 9.
           05 MSC-SE-A PIC S9(15)V9(2) OCCURS 9.
      * progressivi mastri fornitori
           05 MSF-SPSP PIC S9(15)V9(2) OCCURS 9.
           05 MSF-SP-D PIC S9(15)V9(2) OCCURS 9.
           05 MSF-SP-A PIC S9(15)V9(2) OCCURS 9.
           05 MSF-SESP PIC S9(15)V9(2) OCCURS 9.
           05 MSF-SE-D PIC S9(15)V9(2) OCCURS 9.
           05 MSF-SE-A PIC S9(15)V9(2) OCCURS 9.
      *
           05 K        PIC 99.
           05 J        PIC 99.
           05 MCLI     PIC 99.
           05 MFOR     PIC 99.
           05 CODCLF.
              10 MAS   PIC 99.
              10 COD   PIC 9(5).
           05 COMMAS   PIC 99.
      *
           05 CAN    PIC 9(17) VALUE ZERO.
           05 CCC REDEFINES CAN.
              10 TIPO PIC 9.
              10 CLFO PIC 9(5).
              10 ANNO PIC 9(4).
              10 PARD PIC 9(5).
              10 NUME PIC 99.
      *
           05 CLAV     PIC S9(11)V99  VALUE ZERO.
           05 DTBIG    PIC 9(5).
      
           COPY 'vuti930.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 9(3).
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-CON       PIC 9.
           05 IF-CLF       PIC 9.
           05 IF-MAST      PIC 9.
           05 IF-SCAD      PIC 9.
           05 IF-PART      PIC 9.
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclclf'.
           COPY 'dclcfx'.
           COPY 'dclmov'.
           COPY 'dclmvx'.
           COPY 'dclmsz'.
           COPY 'dclmsx'.
           COPY 'dcltab'.
           COPY 'dclsca'.
           COPY 'dclpar'.
           COPY 'dcllav'.
           COPY 'dclla1'.
           COPY 'dclla2'.
      **** rel 7.1
           COPY 'dclla3'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vuti930: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE ANACON.
           CLOSE ANACLF.
           CLOSE ANACFX.
           CLOSE MOVIME.
           CLOSE MOVMXX.
           CLOSE MOVSEZ.
           CLOSE MOVSXX.
           CLOSE TABELL.
           CLOSE ANASCA.
           CLOSE PARTIT.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           CLOSE WDSLA1 WDSLA2.
      **** rel 7.1
           CLOSE WDSLA3.
           OPEN OUTPUT WDSLA3.
           CLOSE WDSLA3.
      ************
      *
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'griclfer'.
           COPY 'gricfxer'.
           COPY 'grimover'.
           COPY 'grimvxer'.
           COPY 'grimszer'.
           COPY 'grimsxer'.
           COPY 'griscaer'.
           COPY 'griparer'.
           COPY 'grite2er'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
      *
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
      *
           MOVE 'anaazi' TO ID-AZI.
           MOVE 'anacon' TO ID-CON.
           MOVE 'anaclf' TO ID-CLF.
           MOVE 'anacfx' TO ID-CFX.
           MOVE 'movime' TO ID-MOV.
           MOVE 'movmxx' TO ID-MVX.
           MOVE 'movsez' TO ID-MSZ.
           MOVE 'movsxx' TO ID-MSX.
           MOVE 'tabell' TO ID-TAB.
           IF IF-FL = 1
              MOVE 'anazol' TO ID-AZI
              MOVE 'anacol' TO ID-CON
              MOVE 'anacfx' TO ID-CLF
              MOVE 'movmol' TO ID-MOV
              MOVE 'movoxx' TO ID-MVX
              MOVE 'movsol' TO ID-MSZ
              MOVE 'mosoxx' TO ID-MSX
              MOVE 'tabold' TO ID-TAB.
      *
           OPEN OUTPUT WDSLAV WDSLA1 WDSLA2.
           CLOSE WDSLAV WDSLA1 WDSLA2.
           OPEN I-O WDSLAV WDSLA1 WDSLA2.
      **** rel 7.1
           OPEN OUTPUT WDSLA3.
           CLOSE WDSLA3.
           OPEN I-O WDSLA3.
      ************
      *
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT MOVIME.
           OPEN INPUT MOVMXX.
           OPEN INPUT ANACON.
           OPEN INPUT ANACLF.
           OPEN INPUT ANACFX.
           OPEN INPUT MOVSEZ.
           OPEN INPUT MOVSXX.
           OPEN INPUT ANASCA.
           OPEN INPUT PARTIT.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM ERR-CINE
                               GO TO ERRIO.
           MOVE AZRGSOC TO IF-AZI-D.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE 1       TO IF-CLF.
           MOVE 1       TO IF-CON.
           MOVE 1       TO IF-MAST.
           MOVE ZERO    TO IF-SCAD.
           MOVE ZERO    TO IF-PART.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           PERFORM ELABORA-AZIENDA THRU EX-ELABORA-AZIENDA.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       ELABORA-AZIENDA.
           COPY 'grirpt-s'.
      *
           MOVE ZERO TO XCRR.
      *
           MOVE AZRGSOC TO RT01.
      *
           MOVE SPACE   TO RVEC.
           IF IF-FL NOT = ZERO MOVE 'V.E.'TO RVEC.
      *
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 58      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 1       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'CONTROLLO QUADRATURA ' RVEC
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           MOVE 14 TO KTB-TIP.
           MOVE  7 TO KTB-COD.
           READ TABELL INTO RKTB14G INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14G.
      *
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
      *
           MOVE T01-CRPCL TO CRPCL(1).
           MOVE T01-CRPC1 TO CRPCL(2).
           MOVE T01-CRPC2 TO CRPCL(3).
           MOVE T14-CRPC3 TO CRPCL(4).
           MOVE T14-CRPC4 TO CRPCL(5).
           MOVE T14-CRPC5 TO CRPCL(6).
           MOVE T14-CRPC6 TO CRPCL(7).
           MOVE T14-CRPC7 TO CRPCL(8).
           MOVE T14-CRPC8 TO CRPCL(9).
      *
           MOVE T01-CRPFR TO CRPFR(1).
           MOVE T01-CRPF1 TO CRPFR(2).
           MOVE T01-CRPF2 TO CRPFR(3).
           MOVE T14-CRPF3 TO CRPFR(4).
           MOVE T14-CRPF4 TO CRPFR(5).
           MOVE T14-CRPF5 TO CRPFR(6).
           MOVE T14-CRPF6 TO CRPFR(7).
           MOVE T14-CRPF7 TO CRPFR(8).
           MOVE T14-CRPF8 TO CRPFR(9).
      *
           OPEN INPUT TABEU2.
           MOVE 4 TO KT2-TIP.
           MOVE 1 TO KT2-COD.
           READ TABEU2 INTO REKTE2 INVALID MOVE ZERO TO REKTE2.
           IF SF-TE2 = '9D' OR '9A' OR '35' MOVE RF-TE2 TO REKTE2.
           MOVE TE204-DTBIG TO DTBIG.
           CLOSE TABEU2.
      *
           PERFORM CREA-SORT        THRU EX-CREA-SORT.
      *
           IF IF-CON = 1
              PERFORM CONTROLLA-CONTI  THRU EX-CONTROLLA-CONTI.
      *
           IF IF-CLF = 1
              PERFORM CONTROLLA-CLIFOR THRU EX-CONTROLLA-CLIFOR.
      *
           IF IF-MAST = 1
              PERFORM CONTROLLA-MASTRI THRU EX-CONTROLLA-MASTRI.
      *
           IF IF-FL = ZERO
              IF IF-SCAD = 1
                 PERFORM CONTROLLA-ANASCA THRU EX-CONTROLLA-ANASCA
              END-IF
              IF IF-PART = 1
                 PERFORM CONTROLLA-PARTIT THRU EX-CONTROLLA-PARTIT.
      *
           COPY 'grirpt-r'.
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-ELABORA-AZIENDA.
           EXIT.
      *------------------
       CREA-SORT.
      *
      * calcolo totali di giornata da movimenti di generale
      * calcolo saldi conti
           MOVE LOW-VALUE TO KEYMX.
           MOVE IF-AZI    TO KMX-AZI.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO ST-MOV.
       RD-MVX.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO ST-MOV.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO RD-MVX.
           IF KMX-AZI > IF-AZI GO TO ST-MOV.
      *
           IF MOV-NUM > 99990 AND < 99999
              PERFORM AGG-LAV-MOV THRU EX-AGG-LAV-MOV.
      *
           MOVE KMX-AZI TO KL2-AZI.
           MOVE KMX-CON TO KL2-CON.
           READ WDSLA2 INVALID PERFORM AZZ-LA2.
      *
      * movimenti di apertura esercizio
           IF AZI-RVDT NOT < AZI-DTAPE
              IF MOV-CAUS > 899 AND MOV-CAUS < 951
                IF MOV-D-A = 'D' ADD MOV-IMPO TO LA2-SESP
                                 GO TO WR-LA1-MVX
                ELSE             SUBTRACT MOV-IMPO FROM LA2-SESP
                                 GO TO WR-LA1-MVX.
      *
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LA2-SE-D.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO LA2-SE-A.
      **** rel 7.1
      * Skip per i totali di giornata
           IF MOV-NUM > 99990 AND < 99999
              GO TO WR-LA1-MVX.
           MOVE KMV-AZI  TO KL3-AZI.
           MOVE MOV-DAT  TO KL3-DTREG.
           MOVE MOV-NREG TO KL3-NREG.
           READ WDSLA3 INVALID PERFORM AZZ-LA3.
      *
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LA3-DARE.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO LA3-AVER.
           PERFORM AGG-LA3 THRU EX-AGG-LA3.
      ************
      *
       WR-LA1-MVX.
           COMPUTE LA2-SPSP = LA2-SESP + LA2-SE-D - LA2-SE-A.
           PERFORM AGG-LA2 THRU EX-AGG-LA2.
      *
           GO TO RD-MVX.
       ST-MOV.
      *
           MOVE LOW-VALUE TO KEYMV.
           MOVE IF-AZI    TO KMV-AZI.
           START MOVIME KEY NOT < KEYMV INVALID GO TO END-MOV.
       RD-MOV.
           READ MOVIME NEXT INTO REKMOV AT END GO TO END-MOV.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO RD-MOV.
           IF KMV-AZI > IF-AZI GO TO END-MOV.
      *
           IF MOV-NUM > 99990 AND < 99999
              PERFORM AGG-LAV-MOV THRU EX-AGG-LAV-MOV.
      *
           MOVE KMV-AZI TO KL2-AZI.
           MOVE KMV-CON TO KL2-CON.
           READ WDSLA2 INVALID PERFORM AZZ-LA2.
      *
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LA2-SE-D
                            ADD MOV-IMPO TO LA2-SP-D.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO LA2-SE-A
                            ADD MOV-IMPO TO LA2-SP-A.
      **** rel 7.1
      * Skip per i totali di giornata
           IF MOV-NUM > 99990 AND < 99999
              GO TO WR-LA2-MOV.
           MOVE KMV-AZI  TO KL3-AZI.
           MOVE MOV-DAT  TO KL3-DTREG.
           MOVE MOV-NREG TO KL3-NREG.
           READ WDSLA3 INVALID PERFORM AZZ-LA3.
      *
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LA3-DARE.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO LA3-AVER.
           PERFORM AGG-LA3 THRU EX-AGG-LA3.
      ************
      *
       WR-LA2-MOV.
           PERFORM AGG-LA2 THRU EX-AGG-LA2.
      *
           GO TO RD-MOV.
       END-MOV.
      *
      * calcolo totali di giornata da movimenti clienti/fornitori
      * calcolo saldi clienti/fornitori
           MOVE LOW-VALUE TO KEYSX.
           MOVE IF-AZI    TO KSX-AZI.
           START MOVSXX KEY NOT < KEYSX INVALID GO TO ST-MSZ.
       RD-MSX.
           READ MOVSXX NEXT INTO REKMOV AT END GO TO ST-MSZ.
           IF SF-MSX = '9D' OR '9A' OR '35' GO TO RD-MSX.
           IF KSX-AZI > IF-AZI  GO TO ST-MSZ.
      *
           PERFORM AGG-LAV-MSZ THRU EX-AGG-LAV-MSZ.
      *
           MOVE KSX-AZI TO KL1-AZI.
           MOVE KSX-CON TO KL1-CLF.
           READ WDSLA1 INVALID PERFORM AZZ-LA1.
      *
      * movimenti di apertura esercizio
           IF AZI-RVDT NOT < AZI-DTAPE
              IF MOV-CAUS > 899 AND MOV-CAUS < 951
                IF MOV-D-A = 'D' ADD MOV-IMPO TO LA1-SESP
                                 GO TO WR-LA1-MSX
                ELSE             SUBTRACT MOV-IMPO FROM LA1-SESP
                                 GO TO WR-LA1-MSX.
      *
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LA1-SE-D.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO LA1-SE-A.
      *
       WR-LA1-MSX.
           COMPUTE LA1-SPSP = LA1-SESP + LA1-SE-D - LA1-SE-A.
           PERFORM AGG-LA1 THRU EX-AGG-LA1.
      *
           GO TO RD-MSX.
       ST-MSZ.
      *
           MOVE LOW-VALUE TO KEYMS.
           MOVE IF-AZI    TO KMS-AZI.
           START MOVSEZ KEY NOT < KEYMS INVALID GO TO END-MSZ.
       RD-MSZ.
           READ MOVSEZ NEXT INTO REKMOV AT END GO TO END-MSZ.
           IF SF-MSZ = '9D' OR '9A' OR '35' GO TO RD-MSZ.
           IF KMS-AZI > IF-AZI GO TO END-MSZ.
      *
           PERFORM AGG-LAV-MSZ THRU EX-AGG-LAV-MSZ.
      *
           MOVE KMS-AZI TO KL1-AZI.
           MOVE KMS-CON TO KL1-CLF.
           READ WDSLA1 INVALID PERFORM AZZ-LA1.
      *
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LA1-SE-D
                            ADD MOV-IMPO TO LA1-SP-D.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO LA1-SE-A
                            ADD MOV-IMPO TO LA1-SP-A.
      **** rel 7.1
      * Skip per i totali di giornata
           IF MOV-NUM > 99990 AND < 99999
              GO TO WR-LA1-MSZ.
           MOVE KMS-AZI  TO KL3-AZI.
           MOVE MOV-DAT  TO KL3-DTREG.
           MOVE MOV-NREG TO KL3-NREG.
           READ WDSLA3 INVALID PERFORM AZZ-LA3.
      *
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LA3-DARE.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO LA3-AVER.
           PERFORM AGG-LA3 THRU EX-AGG-LA3.
      ************
      *
       WR-LA1-MSZ.
           PERFORM AGG-LA1 THRU EX-AGG-LA1.
      *
           GO TO RD-MSZ.
       END-MSZ.

       EX-CREA-SORT.
           EXIT.
      *--------------------------------------*
      * aggiornamento sort con totali di giornata
      * (dai movimenti di generale dei conti riepilogativi)
       AGG-LAV-MOV.
           MOVE MOV-AZI TO KLV-AZI.
           MOVE MOV-CON TO KLV-CON.
           MOVE MOV-DAT TO KLV-DAT.
           READ WDSLAV INVALID MOVE ZERO TO RECLAV
                               MOVE ZERO TO LAV-IMPMSZ
                                            LAV-IMPMOV.
           
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LAV-IMPMOV
           ELSE             SUBTRACT MOV-IMPO FROM LAV-IMPMOV.
            
           IF SF-LAV = ZERO
              REWRITE RF-LAV INVALID MOVE 'RW-LAV MOV' TO MESS
                                     GO TO ERRIO
           ELSE
              WRITE RF-LAV INVALID MOVE 'WR-LAV MOV' TO MESS
                                   GO TO ERRIO.
       EX-AGG-LAV-MOV.
           EXIT.
      *--------------------------------------*
      * aggiornamento sort con totali di giornata
      * (dai movimenti clienti/fornitori)
       AGG-LAV-MSZ.
           MOVE MOV-AZI TO KCF-AZI.
           MOVE MOV-CON TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           GO TO EX-AGG-LAV-MSZ.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-CATCON TO CATCON.
           IF CATCON = ZERO MOVE 1 TO CATCON.
      *
           MOVE MOV-AZI TO KLV-AZI.
           MOVE ZERO TO KLV-CON.
           IF MOV-TREG = 2 MOVE CRPCL (CATCON) TO KLV-CON.
           IF MOV-TREG = 3 MOVE CRPFR (CATCON) TO KLV-CON.
           MOVE MOV-DAT TO KLV-DAT.
           READ WDSLAV INVALID MOVE ZERO TO RECLAV
                               MOVE ZERO TO LAV-IMPMSZ
                                            LAV-IMPMOV.
      *
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LAV-IMPMSZ
           ELSE             SUBTRACT MOV-IMPO FROM LAV-IMPMSZ.
      *
           IF SF-LAV = ZERO
              REWRITE RF-LAV INVALID MOVE 'RW-LAV MSZ' TO MESS
                                     GO TO ERRIO
           ELSE
              WRITE RF-LAV INVALID MOVE 'WR-LAV MSZ' TO MESS
                                   GO TO ERRIO.
       EX-AGG-LAV-MSZ.
           EXIT.
      *--------------------------------------*
       AZZ-LA1.
           MOVE ZERO TO LA1-SP-D
                        LA1-SP-A 
                        LA1-SPSP
                        LA1-SE-D
                        LA1-SE-A
                        LA1-SESP.
      *--------------------------------------*
       AGG-LA1.
           IF SF-LA1 = ZERO
              REWRITE RF-LA1 INVALID MOVE 'RW LA1' TO MESS
                                     GO TO ERRIO
           ELSE
              WRITE RF-LA1 INVALID MOVE 'WR LA1' TO MESS
                                   GO TO ERRIO.
       EX-AGG-LA1.
           EXIT.
      *--------------------------------------*
       AZZ-LA2.
           MOVE ZERO TO LA2-SP-D
                        LA2-SP-A 
                        LA2-SPSP
                        LA2-SE-D
                        LA2-SE-A
                        LA2-SESP.
      *--------------------------------------*
      **** rel 7.1
       AZZ-LA3.
           MOVE ZERO TO LA3-DARE
                        LA3-AVER.
      *--------------------------------------*
      ************
       AGG-LA2.
           IF SF-LA2 = ZERO
              REWRITE RF-LA2 INVALID MOVE 'RW LA2' TO MESS
                                     GO TO ERRIO
           ELSE
              WRITE RF-LA2 INVALID MOVE 'WR LA2' TO MESS
                                   GO TO ERRIO.
       EX-AGG-LA2.
           EXIT.
      *--------------------------------------*
      **** rel 7.1
       AGG-LA3.
           IF SF-LA3 = ZERO
              REWRITE RF-LA3 INVALID MOVE 'RW LA3' TO MESS
                                     GO TO ERRIO
           ELSE
              WRITE RF-LA3 INVALID MOVE 'WR LA3' TO MESS
                                   GO TO ERRIO.
       EX-AGG-LA3.
           EXIT.
      *--------------------------------------*
      ************
      *1- per ogni conto, il saldo di apertura + progressivi esercizio
      *   deve essere uguale al saldo ultima chiusura + progressivi di
      *   periodo
      *2- bilancio di verifica all'ultimo movimento uguale a bilancio
      *   alla data (ovvero progressivi di conto = alla sommatoria 
      *   mastrini
      *3- la sommatoria dei saldi di tutti i conti deve essere uguale 
      *   a zero
       CONTROLLA-CONTI.
           IF XCRR NOT = ZERO MOVE 2 TO XCRR.
      *
           MOVE '* PIANO DEI CONTI' TO RDES.
           MOVE 'ERRORI'            TO LOG-ES.
      *
           MOVE ZERO TO TOTSALDO SWPRI.

           MOVE LOW-VALUE TO KEYPC.
           MOVE IF-AZI    TO KPC-AZI.
           START ANACON KEY NOT < KEYPC INVALID GO TO END-CON.
       RD-CON.
           READ ANACON NEXT INTO REKCON AT END GO TO END-CON.
           IF SF-CON = '9D' OR '9A' OR '35' GO TO RD-CON.
           IF KPC-AZI > IF-AZI GO TO END-CON.
      *
      * controllo 1 
           COMPUTE COMODO1 = CON-SESP + CON-SE-D - CON-SE-A.
           COMPUTE COMODO2 = CON-SPSP + CON-SP-D - CON-SP-A.
           IF COMODO1 NOT = COMODO2 
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD TO LOG-CONTO
              MOVE COMODO1 TO LOG-IMP1
              MOVE COMODO2 TO LOG-IMP2
              MOVE 'E01'   TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.
      *
      * controllo 2
           MOVE KPC-AZI TO KL2-AZI.
           MOVE KPC-COD TO KL2-CON.
           READ WDSLA2 INVALID PERFORM AZZ-LA2.

           IF LA2-SP-D NOT = CON-SP-D
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD  TO LOG-CONTO
              MOVE 'S.P.D.' TO LOG-DATA
              MOVE CON-SP-D TO LOG-IMP1
              MOVE LA2-SP-D TO LOG-IMP2
              MOVE 'E02'    TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF LA2-SP-A NOT = CON-SP-A
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD  TO LOG-CONTO
              MOVE 'S.P.A.' TO LOG-DATA
              MOVE CON-SP-A TO LOG-IMP1
              MOVE LA2-SP-A TO LOG-IMP2
              MOVE 'E02'    TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF LA2-SPSP NOT = CON-SPSP 
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD  TO LOG-CONTO
              MOVE 'S.A.P.' TO LOG-DATA
              MOVE CON-SPSP TO LOG-IMP1
              MOVE LA2-SPSP TO LOG-IMP2
              MOVE 'E02'    TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF LA2-SE-D NOT = CON-SE-D
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD  TO LOG-CONTO
              MOVE 'S.E.D.' TO LOG-DATA
              MOVE CON-SE-D TO LOG-IMP1
              MOVE LA2-SE-D TO LOG-IMP2
              MOVE 'E02'    TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF LA2-SE-A NOT = CON-SE-A
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD  TO LOG-CONTO
              MOVE 'S.E.A.' TO LOG-DATA
              MOVE CON-SE-A TO LOG-IMP1
              MOVE LA2-SE-A TO LOG-IMP2
              MOVE 'E02'    TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF LA2-SESP NOT = CON-SESP 
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD  TO LOG-CONTO
              MOVE 'S.A.E.' TO LOG-DATA
              MOVE CON-SESP TO LOG-IMP1
              MOVE LA2-SESP TO LOG-IMP2
              MOVE 'E02'    TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.
      *
      * controllo 3
           COMPUTE TOTSALDO = TOTSALDO + CON-SESP + CON-SE-D - CON-SE-A.
      *
           GO TO RD-CON.
       END-CON.
           IF TOTSALDO NOT = ZERO 
              PERFORM SEGNALA-ERRORI
              MOVE '********' TO LOG-REC
              MOVE 'E03'      TO LOG-NERR
              MOVE TOTSALDO   TO LOG-IMP2
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.
      **** rel 7.1
           PERFORM STAMPA-REGSB THRU EX-STAMPA-REGSB.
           MOVE 1 TO XCRR.
      ************
      *
           IF SWPRI = ZERO MOVE 'OK' TO LOG-ES
                           MOVE 'RIG1' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
      *
       EX-CONTROLLA-CONTI.
           EXIT.
      *------------------
      *1- per ogni cliente/fornitore, il saldo di apertura + progressivi
      *   esercizio deve essere uguale al saldo ultima chiusura + 
      *   progressivi di periodo
      *2- progressivi uguali alla sommatoria dei movimenti
       CONTROLLA-CLIFOR.
           IF XCRR NOT = ZERO MOVE 2 TO XCRR.
      *
           MOVE '* CLIENTI/FORNITORI' TO RDES.
           MOVE 'ERRORI'              TO LOG-ES.
      *
      * azzeramento totali saldi per categorie contabili
           MOVE 1 TO K.
           PERFORM UNTIL K > 9
                MOVE ZERO TO MSC-SPSP(K)
                             MSC-SP-D(K)
                             MSC-SP-A(K)
                             MSC-SESP(K)
                             MSC-SE-D(K)
                             MSC-SE-A(K)
                             MSF-SPSP(K)
                             MSF-SP-D(K)
                             MSF-SP-A(K)
                             MSF-SESP(K)
                             MSF-SE-D(K)
                             MSF-SE-A(K)
                ADD 1 TO K.
      *
           MOVE ZERO TO SWPRI.
      *
           MOVE LOW-VALUE TO KEYCF.
           MOVE IF-AZI    TO KCF-AZI.
           START ANACLF KEY NOT < KEYCF INVALID GO TO END-CLF.
       RD-CLF.
           READ ANACLF NEXT INTO REKCLF AT END GO TO END-CLF.
           IF SF-CLF = '9D' OR '9A' OR '35' GO TO RD-CLF.
           IF KCF-AZI > IF-AZI GO TO END-CLF.

      * controllo 1 
           COMPUTE COMODO1 = CLF-SESP + CLF-SE-D - CLF-SE-A.
           COMPUTE COMODO2 = CLF-SPSP + CLF-SP-D - CLF-SP-A.
           IF COMODO1 NOT = COMODO2 
              PERFORM SEGNALA-ERRORI
              IF CLF-MS = MCLI MOVE 'C' TO LOG-TIPO
              ELSE             MOVE 'F' TO LOG-TIPO
              END-IF
              MOVE KCF-COD TO LOG-CONTO
              MOVE COMODO1 TO LOG-IMP1
              MOVE COMODO2 TO LOG-IMP2
              MOVE 'E04'   TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.
      *
      * controllo 2
           MOVE KCF-AZI TO KL1-AZI.
           MOVE KCF-COD TO KL1-CLF.
           READ WDSLA1 INVALID PERFORM AZZ-LA1.

           IF LA1-SP-D NOT = CLF-SP-D 
              PERFORM SEGNALA-ERRORI
              IF CLF-MS = MCLI MOVE 'C' TO LOG-TIPO
              ELSE             MOVE 'F' TO LOG-TIPO
              END-IF
              MOVE KCF-COD TO LOG-CONTO
              MOVE 'S.P.D.' TO LOG-DATA
              MOVE CLF-SP-D TO LOG-IMP1
              MOVE LA1-SP-D TO LOG-IMP2
              MOVE 'E05'    TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF LA1-SP-A NOT = CLF-SP-A 
              PERFORM SEGNALA-ERRORI
              IF CLF-MS = MCLI MOVE 'C' TO LOG-TIPO
              ELSE             MOVE 'F' TO LOG-TIPO
              END-IF
              MOVE KCF-COD TO LOG-CONTO
              MOVE 'S.P.A.' TO LOG-DATA
              MOVE CLF-SP-A TO LOG-IMP1
              MOVE LA1-SP-A TO LOG-IMP2
              MOVE 'E05'    TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF LA1-SPSP NOT = CLF-SPSP 
              PERFORM SEGNALA-ERRORI
              IF CLF-MS = MCLI MOVE 'C' TO LOG-TIPO
              ELSE             MOVE 'F' TO LOG-TIPO
              END-IF
              MOVE KCF-COD TO LOG-CONTO
              MOVE 'S.A.P.' TO LOG-DATA
              MOVE CLF-SPSP TO LOG-IMP1
              MOVE LA1-SPSP TO LOG-IMP2
              MOVE 'E05'    TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF LA1-SE-D NOT = CLF-SE-D 
              PERFORM SEGNALA-ERRORI
              IF CLF-MS = MCLI MOVE 'C' TO LOG-TIPO
              ELSE             MOVE 'F' TO LOG-TIPO
              END-IF
              MOVE KCF-COD TO LOG-CONTO
              MOVE 'S.E.D.' TO LOG-DATA
              MOVE CLF-SE-D TO LOG-IMP1
              MOVE LA1-SE-D TO LOG-IMP2
              MOVE 'E05'    TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.
   
           IF LA1-SE-A NOT = CLF-SE-A 
              PERFORM SEGNALA-ERRORI
              IF CLF-MS = MCLI MOVE 'C' TO LOG-TIPO
              ELSE             MOVE 'F' TO LOG-TIPO
              END-IF
              MOVE KCF-COD TO LOG-CONTO
              MOVE 'S.E.A.' TO LOG-DATA
              MOVE CLF-SE-A TO LOG-IMP1
              MOVE LA1-SE-A TO LOG-IMP2
              MOVE 'E05'    TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF LA1-SESP NOT = CLF-SESP 
              PERFORM SEGNALA-ERRORI
              IF CLF-MS = MCLI MOVE 'C' TO LOG-TIPO
              ELSE             MOVE 'F' TO LOG-TIPO
              END-IF
              MOVE KCF-COD TO LOG-CONTO
              MOVE 'S.A.E.' TO LOG-DATA
              MOVE CLF-SESP TO LOG-IMP1
              MOVE LA1-SESP TO LOG-IMP2
              MOVE 'E05'    TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

      *
      * vengono totalizzati i totali dei saldi per categorie
           MOVE CLF-CATCON TO CATCON.
           IF CATCON = ZERO MOVE 1 TO CATCON.
           IF CLF-MS = MCLI 
              ADD CLF-SESP TO MSC-SESP(CATCON)
              ADD CLF-SE-D TO MSC-SE-D(CATCON)
              ADD CLF-SE-A TO MSC-SE-A(CATCON)
              ADD CLF-SPSP TO MSC-SPSP(CATCON)
              ADD CLF-SP-D TO MSC-SP-D(CATCON)
              ADD CLF-SP-A TO MSC-SP-A(CATCON).
           IF CLF-MS = MFOR
              ADD CLF-SESP TO MSF-SESP(CATCON)
              ADD CLF-SE-D TO MSF-SE-D(CATCON)
              ADD CLF-SE-A TO MSF-SE-A(CATCON)
              ADD CLF-SPSP TO MSF-SPSP(CATCON)
              ADD CLF-SP-D TO MSF-SP-D(CATCON)
              ADD CLF-SP-A TO MSF-SP-A(CATCON).
      *
           GO TO RD-CLF.
       END-CLF.
      *
           IF SWPRI = ZERO MOVE 'OK' TO LOG-ES
                           MOVE 'RIG1' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
      *
       EX-CONTROLLA-CLIFOR.
           EXIT.
      *--------------------------------------*
      *1- progressivi dei mastri clienti/fornitori uguali alla sommatoria
      *   per categoria dei progressivi all'ultimo movimento dei singoli 
      *   clienti/fornitori
      *2- Totali di giornata sui mastri clienti/fornitori uguali , giorno
      *   per giorno, alla sommatoria dei movimenti
       CONTROLLA-MASTRI.
           IF XCRR NOT = ZERO MOVE 2 TO XCRR.
      *
           MOVE '* CONTI RIEPILOGATIVI CLIENTI' TO RDES.
           MOVE 'ERRORI'                        TO LOG-ES.
      *
           PERFORM RAGGRUPPA-MASTRI THRU EX-RAGGRUPPA-MASTRI.
      *
           MOVE ZERO TO SWPRI.
      *
           MOVE ZERO TO K.
       LOOP-MASTRIC.
           ADD 1 TO K.
           IF K > 9 GO TO END-LOOP-MASTRIC.

           IF CRPCL(K) = ZERO GO TO LOOP-MASTRIC.
           MOVE IF-AZI   TO KPC-AZI.
           MOVE CRPCL(K) TO KPC-COD.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO LOOP-MASTRIC.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.

      * controllo 1 per clienti
           IF MSC-SP-D(K) NOT = CON-SP-D 
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD     TO LOG-CONTO
              MOVE 'S.P.D.'    TO LOG-DATA
              MOVE CON-SP-D    TO LOG-IMP1
              MOVE MSC-SP-D(K) TO LOG-IMP2
              MOVE 'E06'       TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF MSC-SP-A(K) NOT = CON-SP-A
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD     TO LOG-CONTO
              MOVE 'S.P.A.'    TO LOG-DATA
              MOVE CON-SP-A    TO LOG-IMP1
              MOVE MSC-SP-A(K) TO LOG-IMP2
              MOVE 'E06'       TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF MSC-SPSP(K) NOT = CON-SPSP
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD     TO LOG-CONTO
              MOVE 'S.A.P.'    TO LOG-DATA
              MOVE CON-SPSP    TO LOG-IMP1
              MOVE MSC-SPSP(K) TO LOG-IMP2
              MOVE 'E06'       TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF MSC-SE-D(K) NOT = CON-SE-D
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD     TO LOG-CONTO
              MOVE 'S.E.D.'    TO LOG-DATA
              MOVE CON-SE-D    TO LOG-IMP1
              MOVE MSC-SE-D(K) TO LOG-IMP2
              MOVE 'E06'       TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF MSC-SE-A(K) NOT = CON-SE-A
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD     TO LOG-CONTO
              MOVE 'S.E.A.'    TO LOG-DATA
              MOVE CON-SE-A    TO LOG-IMP1
              MOVE MSC-SE-A(K) TO LOG-IMP2
              MOVE 'E06'       TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF MSC-SESP(K) NOT = CON-SESP
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD     TO LOG-CONTO
              MOVE 'S.A.E.'    TO LOG-DATA
              MOVE CON-SESP    TO LOG-IMP1
              MOVE MSC-SESP(K) TO LOG-IMP2
              MOVE 'E06'       TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.
      *
      * controllo 2 per fornitori
           PERFORM TOTALI-GIORNATA THRU EX-TOTALI-GIORNATA.
      *
           GO TO LOOP-MASTRIC.
       END-LOOP-MASTRIC.
           IF SWPRI = ZERO MOVE 'OK' TO LOG-ES
                           MOVE 'RIG1' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
      *
           MOVE 2 TO XCRR.
      *
           MOVE '* CONTI RIEPILOGATIVI FORNITORI' TO RDES.
           MOVE 'ERRORI'                          TO LOG-ES.
      *
           MOVE ZERO TO SWPRI.
      *
           MOVE ZERO TO K.
       LOOP-MASTRIF.
           ADD 1 TO K.
           IF K > 9 GO TO END-LOOP-MASTRIF.
      *
           IF CRPFR(K) = ZERO GO TO LOOP-MASTRIF.
           MOVE IF-AZI   TO KPC-AZI.
           MOVE CRPFR(K) TO KPC-COD.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO LOOP-MASTRIF.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.

      * controllo 1 per fornitori
           IF MSF-SP-D(K) NOT = CON-SP-D 
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD     TO LOG-CONTO
              MOVE 'S.P.D.'    TO LOG-DATA
              MOVE CON-SP-D    TO LOG-IMP1
              MOVE MSF-SP-D(K) TO LOG-IMP2
              MOVE 'E06'       TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF MSF-SP-A(K) NOT = CON-SP-A
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD     TO LOG-CONTO
              MOVE 'S.P.A.'    TO LOG-DATA
              MOVE CON-SP-A    TO LOG-IMP1
              MOVE MSF-SP-A(K) TO LOG-IMP2
              MOVE 'E06'       TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF MSF-SPSP(K) NOT = CON-SPSP
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD     TO LOG-CONTO
              MOVE 'S.A.P.'    TO LOG-DATA
              MOVE CON-SPSP    TO LOG-IMP1
              MOVE MSF-SPSP(K) TO LOG-IMP2
              MOVE 'E06'       TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF MSF-SE-D(K) NOT = CON-SE-D
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD     TO LOG-CONTO
              MOVE 'S.E.D.'    TO LOG-DATA
              MOVE CON-SE-D    TO LOG-IMP1
              MOVE MSF-SE-D(K) TO LOG-IMP2
              MOVE 'E06'       TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF MSF-SE-A(K) NOT = CON-SE-A
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD     TO LOG-CONTO
              MOVE 'S.E.A.'    TO LOG-DATA
              MOVE CON-SE-A    TO LOG-IMP1
              MOVE MSF-SE-A(K) TO LOG-IMP2
              MOVE 'E06'       TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           IF MSF-SESP(K) NOT = CON-SESP
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD     TO LOG-CONTO
              MOVE 'S.A.E.'    TO LOG-DATA
              MOVE CON-SESP    TO LOG-IMP1
              MOVE MSF-SESP(K) TO LOG-IMP2
              MOVE 'E06'       TO LOG-NERR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.
      *
      * controllo 2 per fornitori
           PERFORM TOTALI-GIORNATA THRU EX-TOTALI-GIORNATA.
      *
           GO TO LOOP-MASTRIF.
      *
       END-LOOP-MASTRIF.
      *
           IF SWPRI = ZERO MOVE 'OK' TO LOG-ES
                           MOVE 'RIG1' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
      *
       EX-CONTROLLA-MASTRI.
           EXIT.
      *--------------------------------------*
       RAGGRUPPA-MASTRI.
           MOVE ZERO TO K.
       RAGGR-MASTRIC.
           ADD 1 TO K.
           IF K > 9 GO TO END-RAGGR-MASTRIC.
           IF CRPCL(K) = ZERO GO TO RAGGR-MASTRIC.
         
           MOVE ZERO TO J.
       RAGGR-MASTRIC-1.
           ADD 1 TO J.
           IF J > 9 GO TO RAGGR-MASTRIC.
           IF J = K GO TO RAGGR-MASTRIC-1.

           IF CRPCL(J) = CRPCL(K)
              ADD MSC-SPSP(J) TO MSC-SPSP(K)
              ADD MSC-SP-D(J) TO MSC-SP-D(K)
              ADD MSC-SP-A(J) TO MSC-SP-A(K)
              ADD MSC-SESP(J) TO MSC-SESP(K)
              ADD MSC-SE-D(J) TO MSC-SE-D(K)
              ADD MSC-SE-A(J) TO MSC-SE-A(K)
              MOVE ZERO TO CRPCL(J)
                           MSC-SPSP(J)
                           MSC-SP-D(J)
                           MSC-SP-A(J)
                           MSC-SESP(J)
                           MSC-SE-D(J)
                           MSC-SE-A(J).
           GO TO RAGGR-MASTRIC-1.
       END-RAGGR-MASTRIC.

           MOVE ZERO TO K.
       RAGGR-MASTRIF.
           ADD 1 TO K.
           IF K > 9 GO TO END-RAGGR-MASTRIF.
           IF CRPFR(K) = ZERO GO TO RAGGR-MASTRIF.
         
           MOVE ZERO TO J.
       RAGGR-MASTRIF-1.
           ADD 1 TO J.
           IF J > 9 GO TO RAGGR-MASTRIF.
           IF J = K GO TO RAGGR-MASTRIF-1.

           IF CRPFR(J) = CRPFR(K)
              ADD MSF-SPSP(J) TO MSF-SPSP(K)
              ADD MSF-SP-D(J) TO MSF-SP-D(K)
              ADD MSF-SP-A(J) TO MSF-SP-A(K)
              ADD MSF-SESP(J) TO MSF-SESP(K)
              ADD MSF-SE-D(J) TO MSF-SE-D(K)
              ADD MSF-SE-A(J) TO MSF-SE-A(K)
              MOVE ZERO TO CRPFR(J)
                           MSF-SPSP(J)
                           MSF-SP-D(J)
                           MSF-SP-A(J)
                           MSF-SESP(J)
                           MSF-SE-D(J)
                           MSF-SE-A(J).
           GO TO RAGGR-MASTRIF-1.
       END-RAGGR-MASTRIF.

       EX-RAGGRUPPA-MASTRI.
           EXIT.
      *--------------------------------------*
      * controlla che i totali di giornata calcolati dai movimenti di
      * generale dei conti riepilogativi siano uguali a quelli calcolati
      * dai movimenti clienti/fornitori
       TOTALI-GIORNATA.
           MOVE KPC-AZI TO KLV-AZI.
           MOVE KPC-COD TO KLV-CON.
           MOVE ZERO    TO KLV-DAT.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO END-LAV.
       RD-LAV.
           READ WDSLAV NEXT AT END GO TO END-LAV.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO RD-LAV.
           IF KLV-AZI > KPC-AZI GO TO END-LAV.
           IF KLV-CON > KPC-COD GO TO END-LAV.
      *
           IF LAV-IMPMOV NOT = LAV-IMPMSZ  
              PERFORM SEGNALA-ERRORI
              MOVE KPC-COD TO LOG-CONTO
              MOVE KLV-DAT TO AAGGG
              MOVE 2       TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GBMMBA  TO LOG-DATA
              MOVE 'S01'   TO LOG-NERR
              MOVE LAV-IMPMOV TO LOG-IMP1
              MOVE LAV-IMPMSZ TO LOG-IMP2
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.
      *
           GO TO RD-LAV.
       END-LAV.

       EX-TOTALI-GIORNATA.
           EXIT.
      *--------------------------------------*
       CONTROLLA-ANASCA.
           IF XCRR NOT = ZERO MOVE 2 TO XCRR.
      *
           MOVE '* SCADENZARIO' TO RDES.
           MOVE 'SEGNALAZIONI'  TO LOG-ES.
      *
           MOVE ZERO TO SWPRI.
      *
           MOVE LOW-VALUE TO KEYSC.
           MOVE IF-AZI    TO KSC-AZI.
           MOVE 1         TO KSC-TIPO.
           START ANASCA KEY NOT < KEYSC INVALID GO TO NO-SCA-CLI.
       RD-SCA-CLI.
           READ ANASCA NEXT AT END GO TO NO-SCA-CLI.
           IF SF-SCA = '9D' OR '9A' OR '35' GO TO RD-SCA-CLI.
           IF KSC-AZI  NOT = IF-AZI GO TO NO-SCA-CLI.
           IF KSC-TIPO NOT = 1      GO TO NO-SCA-CLI.

           MOVE MCLI TO COMMAS.
           PERFORM SCADEN THRU EX-SCADEN.

       NO-SCA-CLI.
           MOVE LOW-VALUE TO KEYSC.
           MOVE IF-AZI    TO KSC-AZI.
           MOVE 2         TO KSC-TIPO.
           START ANASCA KEY NOT < KEYSC INVALID GO TO NO-SCA-FOR.
       RD-SCA-FOR.
           READ ANASCA NEXT AT END GO TO NO-SCA-FOR.
           IF SF-SCA = '9D' OR '9A' OR '35' GO TO RD-SCA-FOR.
           IF KSC-AZI  NOT = IF-AZI GO TO NO-SCA-FOR.
           IF KSC-TIPO NOT = 2      GO TO NO-SCA-FOR.

           MOVE MFOR TO COMMAS.
           PERFORM SCADEN THRU EX-SCADEN.
       NO-SCA-FOR.
      *
           IF SWPRI = ZERO MOVE 'OK' TO LOG-ES
                           MOVE 'RIG1' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
      *
       EX-CONTROLLA-ANASCA.
           EXIT.
      *------------------------*
       SCADEN.
           MOVE LOW-VALUE TO KEYCF.
           MOVE IF-AZI    TO KCF-AZI.
           MOVE ZERO      TO CODCLF.
           MOVE COMMAS    TO MAS.
           MOVE CODCLF    TO KCF-COD.
           START ANACLF KEY NOT < KEYCF INVALID GO TO END-CLF-SCA.
       RD-CLF-SCA.
           READ ANACLF NEXT INTO REKCLF AT END GO TO END-CLF-SCA.
           IF SF-CLF = '9D' OR '9A' OR '35' GO TO RD-CLF-SCA.
           IF KCF-AZI > IF-AZI    GO TO END-CLF-SCA.
           IF CLF-MS NOT = COMMAS GO TO END-CLF-SCA.
      *
           MOVE ZERO TO TOTSALDO.
           MOVE LOW-VALUE TO KEYS2.
           MOVE KCF-COD   TO KS2-CODCF.
           START ANASCA KEY NOT < KEYS2 INVALID GO TO END-SCA.
       RD-SCA.
           READ ANASCA NEXT AT END GO TO END-SCA.
           IF SF-SCA = '9D' OR '9A' OR '35' GO TO RD-SCA.
           IF KS2-CODCF NOT = KCF-COD GO TO END-SCA.

           IF KSC-AZI   NOT = IF-AZI  GO TO RD-SCA.
           IF SCA-STATO = 'P' OR 'I'  GO TO RD-SCA.
           MOVE KS2-CODCF TO CODCLF.
           IF MAS = MCLI AND SCA-TPAG < 3 GO TO RD-SCA.

           COMPUTE TOTSALDO = TOTSALDO + (SCA-IMRATA - SCA-PAGATO)

           GO TO RD-SCA.
       END-SCA.
           PERFORM VER-CLISCA THRU EX-VER-CLISCA.
      *
           GO TO RD-CLF-SCA.
      *
       END-CLF-SCA.
      *
       EX-SCADEN.
           EXIT.
      *--------------------------------------*
       VER-CLISCA.
           COMPUTE COMODO1 = CLF-SESP + CLF-SE-D - CLF-SE-A.
           MOVE KEYCF TO KEYCX.
           READ ANACFX INTO REKCLF INVALID 
                MOVE ZERO TO CLF-SESP CLF-SE-D CLF-SE-A.
           IF SF-CFX = '9D' OR '9A' OR '35' MOVE RF-CFX TO REKCLF.
           COMPUTE COMODO1 = COMODO1 + CLF-SESP + CLF-SE-D - CLF-SE-A.
           MOVE RF-CLF TO REKCLF.

           IF CLF-MS = MFOR COMPUTE TOTSALDO = TOTSALDO * -1.
           IF COMODO1 NOT = TOTSALDO 
              PERFORM SEGNALA-ERRORI
              IF CLF-MS = MCLI MOVE 'C' TO LOG-TIPO
              ELSE             MOVE 'F' TO LOG-TIPO
              END-IF
              MOVE KCF-COD  TO LOG-CONTO
              MOVE 'S02'    TO LOG-NERR
              MOVE COMODO1  TO LOG-IMP1
              MOVE TOTSALDO TO LOG-IMP2
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           MOVE ZERO TO TOTSALDO.
       EX-VER-CLISCA.
           EXIT.
      *--------------------------------------*
       CONTROLLA-PARTIT.
           IF XCRR NOT = ZERO MOVE 2 TO XCRR.
      *
           MOVE '* ESTRATTO CONTO' TO RDES.
           MOVE 'SEGNALAZIONI'     TO LOG-ES.
      *
           MOVE ZERO TO SWPRI.
      *
           MOVE LOW-VALUE TO KEYPA.
           MOVE IF-AZI    TO KPA-AZI.
           MOVE ZERO      TO CAN.
           MOVE 2         TO TIPO.
           MOVE CAN       TO KPA-CAN.
           START PARTIT KEY NOT < KEYPA INVALID GO TO NO-PAR-CLI.
       RD-PAR-CLI.
           READ PARTIT NEXT AT END GO TO NO-PAR-CLI.
           IF SF-PAR = '9D' OR '9A' OR '35' GO TO RD-PAR-CLI.
           IF KPA-AZI  NOT = IF-AZI GO TO NO-PAR-CLI.
           MOVE KPA-CAN TO CAN.
           IF TIPO NOT = 2 GO TO NO-PAR-CLI.

           MOVE MCLI TO COMMAS.
           PERFORM PARTITAR THRU EX-PARTITAR.

       NO-PAR-CLI.
      *
           MOVE LOW-VALUE TO KEYPA.
           MOVE IF-AZI    TO KPA-AZI.
           MOVE ZERO      TO CAN.
           MOVE 3         TO TIPO.
           MOVE CAN       TO KPA-CAN.
           START PARTIT KEY NOT < KEYPA INVALID GO TO NO-PAR-FOR.
       RD-PAR-FOR.
           READ PARTIT NEXT AT END GO TO NO-PAR-FOR.
           IF SF-PAR = '9D' OR '9A' OR '35' GO TO RD-PAR-FOR.
           IF KPA-AZI  NOT = IF-AZI GO TO NO-PAR-FOR.
           MOVE KPA-CAN TO CAN.
           IF TIPO NOT = 3 GO TO NO-PAR-FOR.

           MOVE MFOR TO COMMAS.
           PERFORM PARTITAR THRU EX-PARTITAR.

       NO-PAR-FOR.
      *
           IF SWPRI = ZERO MOVE 'OK' TO LOG-ES
                           MOVE 'RIG1' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
      *
       EX-CONTROLLA-PARTIT.
           EXIT.
      *--------------------------------------*
       PARTITAR.
           MOVE LOW-VALUE TO KEYCF.
           MOVE IF-AZI    TO KCF-AZI.
           MOVE ZERO      TO CODCLF.
           MOVE COMMAS    TO MAS.
           MOVE CODCLF    TO KCF-COD.
           START ANACLF KEY NOT < KEYCF INVALID GO TO END-CLF-PAR.
       RD-CLF-PAR.
           READ ANACLF NEXT INTO REKCLF AT END GO TO END-CLF-PAR.
           IF SF-CLF = '9D' OR '9A' OR '35' GO TO RD-CLF-PAR.
           IF KCF-AZI > IF-AZI    GO TO END-CLF-PAR.
           IF CLF-MS NOT = COMMAS GO TO END-CLF-PAR.
      *
           MOVE ZERO TO TOTSALDO.
           MOVE LOW-VALUE TO KEYPA.
           MOVE IF-AZI    TO KPA-AZI.
           MOVE ZERO      TO CAN.
           IF COMMAS = MCLI MOVE 2 TO TIPO
           ELSE             MOVE 3 TO TIPO.
           MOVE CLF-CD    TO CLFO.
           MOVE CAN       TO KPA-CAN.
           START PARTIT KEY NOT < KEYPA INVALID GO TO END-PAR.
       RD-PAR.
           READ PARTIT NEXT INTO REKPAR AT END GO TO END-PAR.
           IF SF-PAR = '9D' OR '9A' OR '35' GO TO RD-PAR.
           IF KPA-AZI > IF-AZI GO TO END-PAR.
           MOVE KPA-CAN TO CAN.
           IF COMMAS = MCLI AND TIPO NOT = 2 GO TO END-PAR.
           IF COMMAS = MFOR AND TIPO NOT = 3 GO TO END-PAR.
           IF CLFO NOT = CLF-CD GO TO END-PAR.

           IF PAR-TIP NOT = 2 GO TO RD-PAR.

           MOVE PAR-IMPOR TO CLAV.
           IF PAR-D-A = 'D' ADD CLAV      TO   TOTSALDO
           ELSE             SUBTRACT CLAV FROM TOTSALDO.
           GO TO RD-PAR.
       END-PAR.
           PERFORM VER-CLIPAR THRU EX-VER-CLIPAR.
           GO TO RD-CLF-PAR.
      *
       END-CLF-PAR.
      *
       EX-PARTITAR.
           EXIT.
      *--------------------------------------*
       VER-CLIPAR.
           COMPUTE COMODO1 = CLF-SESP + CLF-SE-D - CLF-SE-A.
           MOVE KEYCF TO KEYCX.
           READ ANACFX INTO REKCLF INVALID 
                MOVE ZERO TO CLF-SESP CLF-SE-D CLF-SE-A.
           IF SF-CFX = '9D' OR '9A' OR '35' MOVE RF-CFX TO REKCLF.
           COMPUTE COMODO1 = COMODO1 + CLF-SESP + CLF-SE-D - CLF-SE-A.
           MOVE RF-CLF TO REKCLF.

           IF COMODO1 NOT = TOTSALDO 
              PERFORM SEGNALA-ERRORI
              IF CLF-MS = MCLI MOVE 'C' TO LOG-TIPO
              ELSE             MOVE 'F' TO LOG-TIPO
              END-IF
              MOVE KCF-COD  TO LOG-CONTO
              MOVE 'S03'    TO LOG-NERR
              MOVE COMODO1  TO LOG-IMP1
              MOVE TOTSALDO TO LOG-IMP2
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.

           MOVE ZERO TO TOTSALDO.
       EX-VER-CLIPAR.
           EXIT.
      *--------------------------------------*
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
           MOVE SPACE TO ID-LA1.
           STRING 'w2' PID DELIMITED SPACE INTO ID-LA1.
           MOVE SPACE TO ID-LA2.
           STRING 'w3' PID DELIMITED SPACE INTO ID-LA2.
      **** rel 7.1
           MOVE SPACE TO ID-LA3.
           STRING 'w4' PID DELIMITED SPACE INTO ID-LA3.
      ************
       EX-CREA-IDLAV.
           EXIT.
      *--------------------------------------*
       SEGNALA-ERRORI.
           IF SWPRI = ZERO MOVE 1 TO SWPRI
                           MOVE 'RIG1' TO RP-BLK
                           PERFORM RPT-WR
                           MOVE 1 TO XCRR.
      *------------------
      **** rel 7.1
       STAMPA-REGSB.
      *
           MOVE LOW-VALUE TO KEYL3.
           MOVE IF-AZI    TO KL3-AZI.
           START WDSLA3 KEY NOT < KEYL3 INVALID GO TO END-LA3-1.
       LOOP-LA3-1.
           READ WDSLA3 NEXT AT END GO TO END-LA3-1.
           IF SF-LA3 = '9D' OR '9A' OR '35' GO TO LOOP-LA3-1.
           IF KL3-AZI > IF-AZI GO TO END-LA3-1.
      *
           IF LA3-DARE = LA3-AVER GO TO LOOP-LA3-1.
      *
           MOVE '********' TO LOG-REC.
           MOVE 'NREG'     TO LOG-NERR.
           MOVE KL3-NREG   TO LOG-NREG.
           MOVE KL3-DTREG TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA  TO LOG-DATA.
           MOVE LA3-DARE TO LOG-IMP1.
           MOVE LA3-AVER TO LOG-IMP2.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           GO TO LOOP-LA3-1.
       END-LA3-1.
      *
      *
       EX-STAMPA-REGSB.
           EXIT.
      *------------------
      ************
